/* SPDX-License-Identifier: LGPL-2.1-only OR BSD-3-Clause */
/******************************************************************************
 *
 * This file is provided under a dual license.  When you use or
 * distribute this software, you may choose to be licensed under
 * version 2.1 of the GNU Lesser General Public License
 * ("LGPLv2.1 License") or BSD License.
 *
 * LGPLv2.1 License
 *
 * Copyright(C) 2019 MediaTek Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2.1 of the GNU Lesser General Public
 * License as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See https://www.gnu.org/licenses/old-licenses/lgpl-2.1.html for more
 * details.
 *
 * BSD LICENSE
 *
 * Copyright(C) 2019 MediaTek Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *  * Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *****************************************************************************/

/*-----------------------------------------------------------------------------
 *
 * $Author: sakamoto $
 * $Date: 2017/10/16 $
 * $RCSfile: aud_cust_amp_if.h,v $
 * $Revision: #2 $
 *
 *---------------------------------------------------------------------------*/


#ifndef AUD_CUST_AMP_IF_H
#define AUD_CUST_AMP_IF_H

//---------------------------------------------------------------------------
// Include files
//---------------------------------------------------------------------------

#include "x_typedef.h"
#include "aud_if.h"

//---------------------------------------------------------------------------
// Global variables
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
// Constant definitions
//---------------------------------------------------------------------------
#define SIF_CLK_DIV 0x100

typedef enum {
    AUD_CUST_AMP_TYPE_INVALID,
    AUD_CUST_AMP_TYPE_5538,
    AUD_CUST_AMP_TYPE_5760,
    AUD_CUST_AMP_TYPE_5782,
    AUD_CUST_AMP_TYPE_RT9119,
} eAudCustAmpType;

typedef enum {
    AUD_CUST_AMP_I2C_BUS_A=2,         // SIF_BUS_SECOND_I2C
    AUD_CUST_AMP_I2C_BUS_B=1,         // SIF_BUS_TUNER_I2C
    AUD_CUST_AMP_I2C_BUS_C=0,         // SIF_BUS_SYSTEM_I2C
    AUD_CUST_AMP_I2C_BUS_D=3,         // SIF_BUS_PDWNC_I2C
    AUD_CUST_AMP_I2C_BUS_PDWNC_1=4,   // SIF_BUS_PDWNC_I2C_1
} eAudCustAmpI2CBus;



//---------------------------------------------------------------------------
// Public functions
//---------------------------------------------------------------------------

void AUD_CUST_AMP_RegistAmp(eAudCustAmpType type, eAudCustAmpI2CBus bus, UINT8 addr, UINT8 table);

extern AMP_T* AUD_AMP_GetAQCustFunTbl1(void);
extern AMP_T* AUD_AMP_GetAQCustFunTbl2(void);

extern AMP_T* AUD_AMP_GetDrvCustFunTbl(void);

void AUD_CUST_AMP_Init(void);
void AUD_CUST_AMP_Mute(AUD_CUST_AMP_MUTE_T mute);
void AUD_CUST_AMP_Suspend(void);
void AUD_CUST_AMP_Resume(void);
void AUD_CUST_AMP_Update(void);
void AUD_CUST_AMP_StartRefresh(void);
void AUD_CUST_AMP_StopRefresh(void);
void AUD_CUST_AMP_ShowStatus(void);

#endif /* AUD_CUST_AMP_IF_H */


