

#ifndef __OSD_EXP_H__
#define __OSD_EXP_H__

#include "osd_drvif.h"

typedef enum {
    OSD_BYPASS_SHARPNESS,
    OSD_BYPASS_CBE_CTL,
    OSD_BYPASS_BITPLUS_Y,
    OSD_BYPASS_BITPLUS_S,
    OSD_BYPASS_3DCOLORMAP,
    OSD_BYPASS_SRS,
    OSD_BYPASS_TTD,
    #if defined(CC_MT5891)
    OSD_BYPASS_VERTICALSHARP,
    OSD_BYPASS_XVYCC,
    OSD_BYPASS_GAMMAPOS,
    #endif
    OSD_BYPASS_MAX
} OSD_BYPASS_MODULE;

typedef enum
{
    OSD_EXP_RET_OK = 0,
    OSD_EXP_RET_INVALID_ARGV = -1,
    OSD_EXP_RET_OUTOF_RESOURCE = -2,
    OSD_EXP_RET_CALLBACK_REGISTED = -3,
} OSD_EXP_RET_T;

typedef struct
{
    INT32 i4Identity;
    VOID (*pfnVsyncIsr)(VOID);
    VOID (*pfnUpdateVsyncTime)(UINT64 *pu8VsyncTime);
    VOID (*pfnResumeSuspend)(BOOL fgSuspend);
    VOID (*pfnTimingChanged)(VOID);
}
OSD_EXP_CALLBACK_T;

OSD_EXP_RET_T OSD_EXP_GenCallback(INT32 *pi4Identity);
OSD_EXP_RET_T OSD_EXP_RegisterCallback(OSD_EXP_CALLBACK_T *pfnCb);
OSD_EXP_RET_T OSD_EXP_RemoveCallback(INT32 i4Identity);
OSD_EXP_RET_T OSD_EXP_HandleVSync(VOID);
OSD_EXP_RET_T OSD_EXP_UpdateVsyncTime(UINT64 *pu8VsyncTime);
OSD_EXP_RET_T OSD_EXP_HandleResumeSuspend(BOOL fgSuspend);

VOID OSD_EXP_BypPQPath(VOID);
VOID OSD_EXP_EnablePQPath(VOID);
VOID OSD_EXP_BypGFXPath(VOID);
VOID OSD_EXP_EnableGFXPath(VOID);
VOID OSD_EXP_UHD_EnableGFXPathOnly(VOID);
VOID OSD_EXP_UHD_EnableMergePathOnly(VOID);
VOID OSD_EXP_BypUHDPath(VOID);
VOID OSD_EXP_InitOsdPath(VOID);
BOOL OSD_EXP_GetOSDMixPreMJCEn(VOID);
VOID OSD_EXP_SetOSDMixPreMJCEn(BOOL u4Enable);

BOOL OSD_EXP_IS_GFX_4K2K(VOID);
BOOL OSD_EXP_IS_GFX_FHD(VOID);
BOOL OSD_EXP_IS_GFX(VOID);
BOOL OSD_EXP_IS_vertical_sharpness_bypass(VOID);
BOOL OSD_EXP_IS_BYPASSTTD(VOID);
VOID OSD_EXP_BakUpMIX(VOID);
VOID OSD_EXP_ReSumeMix(VOID);
VOID OSD_EXP_BypassApply(void);
INT32 OSD_EXP_TimGenVal(VOID);

#ifdef CC_MT5891
BOOL OSD_EXP_IS_TTDPosBeforeSRS(VOID);
#endif

#endif
