/* SPDX-License-Identifier: LGPL-2.1-only OR BSD-3-Clause */
/******************************************************************************
 *
 * This file is provided under a dual license.  When you use or
 * distribute this software, you may choose to be licensed under
 * version 2.1 of the GNU Lesser General Public License
 * ("LGPLv2.1 License") or BSD License.
 *
 * LGPLv2.1 License
 *
 * Copyright(C) 2019 MediaTek Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2.1 of the GNU Lesser General Public
 * License as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See https://www.gnu.org/licenses/old-licenses/lgpl-2.1.html for more
 * details.
 *
 * BSD LICENSE
 *
 * Copyright(C) 2019 MediaTek Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *  * Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *****************************************************************************/
/*-----------------------------------------------------------------------------
 *
 * $Author$
 * $Date$
 * $RCSfile: alp_hal_api.h,v $
 * $Revision$
 *
 *---------------------------------------------------------------------------*/

/** @file alp_hal_if.h
 *  Interface of demux ALP HAL driver
 */

#ifndef ATSC30_ALP_HAL_IF_H
#define ATSC30_ALP_HAL_IF_H

//-----------------------------------------------------------------------------
// Include files
//-----------------------------------------------------------------------------
#include "alp_hal_hw.h"
#include "alp_hal_fw.h"
#include "dmx_mm_if.h"
#include "dmx.h"
#include "x_typedef.h"

EXTERN BOOL alp_hal_if_init(UINT8 framer_idx,
                            const alp_hal_frontend_input_packet_type fe_input_pkt_type,
                            const alp_hal_framer_mode_t hw_mode,
                            const alp_hal_fw_config_t fw_cfg,
                            const UINT32 hw_cfg_flags);

EXTERN BOOL alp_hal_if_de_init(UINT8 framer_idx);

EXTERN BOOL alp_hal_if_set_framer(UINT8 framer_idx, DMX_FRONTEND_T fe_type);

EXTERN UINT8 alp_hal_if_set_stream_filter(UINT8 framer_idx, const alp_stream_t *const strm);

EXTERN BOOL alp_hal_if_free_stream_filter(UINT8 frm_idx, UINT8 strm_id);

EXTERN BOOL alp_hal_if_set_plp_id_filter(UINT8 framer_idx, const UINT8 *const plp_id_arr, UINT8 plp_cnt);

EXTERN BOOL alp_hal_if_clear_plp_id_filter(UINT8 framer_idx);

EXTERN BOOL alp_hal_if_check_buffer_full(UINT8 framer_idx);

EXTERN VOID alp_hal_if_reset_stream_filters(UINT8 framer_idx);

EXTERN BOOL alp_hal_if_DDI_move_data(DMX_MM_DATA_T *prData, const UINT8 ddi_intvl);

EXTERN UINT8 alp_hal_if_get_dmx_inst_id(UINT8 framer_idx);

EXTERN VOID alp_hal_if_collect_statistics(UINT8 framer_idx);

#endif  // ATSC30_ALP_HAL_IF_H
