/* SPDX-License-Identifier: LGPL-2.1-only OR BSD-3-Clause */
/******************************************************************************
 *
 * This file is provided under a dual license.  When you use or
 * distribute this software, you may choose to be licensed under
 * version 2.1 of the GNU Lesser General Public License
 * ("LGPLv2.1 License") or BSD License.
 *
 * LGPLv2.1 License
 *
 * Copyright(C) 2019 MediaTek Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2.1 of the GNU Lesser General Public
 * License as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See https://www.gnu.org/licenses/old-licenses/lgpl-2.1.html for more
 * details.
 *
 * BSD LICENSE
 *
 * Copyright(C) 2019 MediaTek Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *  * Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *****************************************************************************/

/*-----------------------------------------------------------------------------
 *
 * $Author$
 * $Date$
 * $RCSfile: cbus_if.h,v $
 * $Revision$
 *
 *---------------------------------------------------------------------------*/
#ifndef _CBUS_IF_H_
#define _CBUS_IF_H_

#include "x_typedef.h"
#include "cec_if.h"

// *********************************************************************
// Type definitions
// *********************************************************************
#if defined(SYS_MHL_SUPPORT)
#define SetCBUSStatus(arg) { \
    CRIT_STATE_T rCritState; \
    rCritState = x_crit_start(); \
    (_Cbus_Status |= ((UINT16)arg)); \
    x_crit_end(rCritState); }

#define ClrCBUSStatus(arg) { \
    CRIT_STATE_T rCritState; \
    rCritState = x_crit_start(); \
    (_Cbus_Status &= (~((UINT16)arg))); \
    x_crit_end(rCritState); }

#define IsCBUSStatus(arg)     ((_Cbus_Status & ((UINT16)arg)) > 0)
#endif
#ifdef SYS_MHL_SUPPORT
extern UINT8  _bIsMhlDeviceConnect;
#endif

#if defined(SYS_MHL_SUPPORT)
void Cbus_Init(void);
void _Cbus_HandleTxTask(void);
void _Cbus_HandleRxTask(void);
void _Cbus_NotifyTxResult(UINT8 result, CEC_FRAME_DESCRIPTION *frame,void *tag);
void _Cbus_NotifyRxResult(CEC_FRAME_DESCRIPTION *frame);
CEC_FRAME_DESCRIPTION *_Cbus_GetTxReadFrame(void);
CEC_FRAME_DESCRIPTION *_Cbus_GetRxReadFrame(void);

UINT8 u1IsTX_Q_Empty(void);
UINT8 u1IsTX_Q_Full(void);
UINT8 u1IsRX_Q_Empty(void);
UINT8 u1IsRX_Q_Full(void);
void _Cbus_DequeueTx(void);
void _Cbus_DequeueRx(void);
void _Cbus_EnqueueRx(CEC_FRAME_DESCRIPTION *prFrame);

#endif

#endif /* _CEC_IF_H_ */

