#ifndef _DRV_DOLBY_DRVIF_H_
#define _DRV_DOLBY_DRVIF_H_

#include "x_typedef.h"

#include <linux/version.h>
#include "x_timer.h"


//#define CC_DOLBY_IDK_SUPPORT

#define  MAX_DOLBY_IDK_DUMP_FRAME 120

#define  DOLBY_REG_NUM    120

#define MAX_GD_DEBUG_INFO_FRAME_CNT 3000


#ifdef DOLBY_VISION_IDK1611
#define MAX_DOLBY_PIC_MODE      10
#else
#define MAX_DOLBY_PIC_MODE      6
#endif

#define  DOLBY_VIDEO_INFO       1
#define  DOLBY_METADATA_INFO    2



#define  DOLBY_RUN_MODE_MASK         3
    #define OTT_MODE                 (0)
    #define HDMI_HD_MODE             (1<<1)
    #define BYPASS_MODE              (1)
    #define HDMI_UHD_MODE            (3)
#define  DOLBY_Opt_MODE_MASK         (3<<2)
    #define BL_EL_RATIO11            (1<<2)
    #define BL_EL_RATIO41            (3<<2)
#define  DOLBY_GRAPHIC_MASK          (1<<5)
    #define GRAPHIC_DISABLE          (0<<5)
    #define GRAPHIC_ENABLE           (1<<5)
#define  DOLBY_PIXEL_RATE_MASK       (0xf<<6)
    #define PIXEL_RATE_23_98         (0<<6)
    #define PIXEL_RATE_24            (1<<6)
    #define PIXEL_RATE_25            (2<<6)
    #define PIXEL_RATE_29_97         (3<<6)
    #define PIXEL_RATE_30            (4<<6)
    #define PIXEL_RATE_50            (5<<6)
    #define PIXEL_RATE_59_94         (6<<6)
    #define PIXEL_RATE_60            (7<<6)
    #define PIXEL_RATE_120           (8<<6)


#define DOLBY_METADATA_DEBUG_OTT             0x1  //dump ott rpu/cp/dm bin
#define DOLBY_METADATA_DEBUG_RPU             0x2  //used for read rpu
#define DOLBY_DEBUG_CONFIG_BIN               0x4  //read config bin from file
#define DOLBY_VERIFICATION                   0x8  //used for ott dump
#define DOLBY_DEBUG_REG_LUT                  0x10 //used for dump reg and lut
#define DOLBY_DEBUG_CRC                      0x20 //used for printf crc to check video/md shift issues
#define DOLBY_DEBUG_DM_STATUS                0x40 //used for get some dm md info
#define DOLBY_DEBUG_GD_STATUS                0x80 //gd delay trol debug
#define DOLBY_DEBUG_VSIF_STATUS              0x100   //used for rd static vsif
#define DOLBY_DEBUG_DYN_VSIF_STATUS          0x200   //used for rd dyn vsif
#define DOLBY_DEBUG_DEBUG_RD_REGLUT          0x400   //used for rd reg and lut
#define DOLBY_DEBUG_AUTO_DUMP_HDMI           0x800   //used for hdmi auto dump
#define DOLBY_DEBUG_HDMI21_VSEM              0x1000  //used for rd static vsif
#define DOLBY_DEBUG_STOP_UPDATE_REG          0x2000  //used for stop aply new md


//-----------------------------------------------------------------------------
// Type definitions
//-----------------------------------------------------------------------------

typedef void (*PFN_DOVI_HDR_NFY_FCT) (
    UINT32              u4CurHDR,
    UINT32              u4LastHDR
);

typedef enum _ENUM_DOVI_HDR_TYPE_T_
{
    DOVI_HDR_TYPE_SDR = 0,
    DOVI_HDR_TYPE_DV = 13,
    DOVI_HDR_TYPE_HDR10 = 16,
    DOVI_HDR_TYPE_HLG = 18,
} ENUM_DOVI_HDR_TYPE_T;
typedef struct  {
    int frame_num;
    int width ;
    int height;
    int  idk_view_mode;
    UINT32 idk_first_frame_crc;
    UINT32 idk_bl_scaler;
    char cFileNm[128];
    char cFilePath[128];
    BOOL ambient_en;
} DOLBY_CLI_PRM_T;

/** Brief of DOLBY_MSG_T
 */



typedef struct
{
    UINT32 u4Arg1;
    UPTR   u4Arg2;
    UINT32 u4Arg3;
    UINT32 u4Arg4;
    UINT32 u4Arg5;
} DOLBY_MSG_T;

typedef struct
{
    UINT8 u1VdpId;
    UINT8 u1Dolby_Mode;
    UINT8 u1Omux_Source;
} DOLBY_SRC_T;

typedef struct
{
    UINT32 Dolby_Out_Y_Crc;
    UINT32 Dolby_Out_U_Crc;
    UINT32 Dolby_Out_V_Crc;
    UINT32 Dolby_IN_Y_Crc;
    UINT32 Dolby_IN_U_Crc;
    UINT32 Dolby_IN_V_Crc;

    UINT32 LUT_3D_Crc;
    UINT32 TC_Crc;
    UINT32 DM_Crc;
    UINT32 BL_Crc;
    UINT32 EL_Crc;
    UINT32 COMP_Crc;
    UINT32 COMP_420_Crc;

    UINT32 MIB_SRCW_CRC_OUT_V;
    UINT32 MIB_OUT_CRC_OUT_V;

    UINT32 frame_nr;
    //Pre-proc CRC

}DOLBY_CRC_T;

typedef struct
{
    UINT32 DV_INPUT_CRC[MAX_DOLBY_IDK_DUMP_FRAME];
    UINT32 frame_dump_status[MAX_DOLBY_IDK_DUMP_FRAME];
    UINT32 tatol_frame_nr;
    UINT32 idk_first_frame_crc;
    UINT32 cur_play_frame_nr;
    UINT32 cur_wait_dump_frame_nr;
    UINT32 start_save_crc_flag;
    UINT32 crc_save_ready_flag;
    UINT32 cur_frame_crc;
    UINT32 dump_direct_flag;
    UINT32 u4DvSourceCnt;
}DOLBY_AUTO_DUMP_T;


typedef struct
{
    //about source
    UINT32 u4Runmode;
    UINT32 u4Optmode;
    UINT32 u4Graphicmode;
    UINT32 u4PixelRate;
    UINT32 u4MetadataProgramErrorEnable;

    UINT32 u4DolbyMode;
    UINT32 u4Dolby_Dma_Vysnc_Mode;
    UINT32 u4Dolby_Dma_Hsync_mode;
    UINT32 u4Dolby_ClkEn;

    UINT32 u4Dolby_3D_Num;
    UINT32 u4Dolby_Tc_Num;
    UINT32 u4Dolby_3D_Addr;
    UINT32 u4Dolby_Tc_Addr;

    UINT32 u4Dolby_Sel444;
    UINT32 u4Dolby_Yc2Yuc_En;

    UINT32 u4BLWidth;
    UINT32 u4BLHeight;
    UINT32 u4InputFormat;
    UINT32 u4InputColorFmt;
    UINT32 u4InputYuvRange;


    //about  frame status
    UINT32 rpu_ret;
    UINT32 dm_ret;
    UINT32 pre_frame_nr;
    UINT32 frame_nr;
    BOOL   src_change_flag;
    UINT32 u4ATSCFormat;
}DOLBY_PRM_T;

typedef struct
{
    UINT8  u1IsDoviHDR[2]; //Main or sub
    UINT32 u4GolbalDimmingEn;
    UINT32 u4DoviFmt;
    UINT32 u4IsDtrFelMode;
    UINT32 u4IsDtrFelModeCheckDone;
    UINT32 u4IsSourceStaticInfoUpdateDone;
    UINT32 u4IsDoviCtrolPathConnectDone;
    PFN_DOVI_HDR_NFY_FCT pfDOVIHDRInfoCb;
    UCHAR  ucVdpIdDolbyUse;
}DOLBY_CUSTOM_SOURCE_INFO_T;


typedef struct
{
    UINT32 u4MetadataDbgFlag;
    UINT32 u4DolbyBypassEn;
    UINT32 u4DolbyHdmiDumpDoneFlag;
    UINT32 u4dolbyScnChgEn;
    UINT32 u4ForceGDOnOff;
    UINT32 u4viewmodeTestEn;
}DOLBY_DBG_INFO_T;

typedef struct
{
    UINT8 u1IsDoviHDR;
}DOLBY_SOURCE_INFO_T;//used for mtal


typedef enum
{
    DOLBY_PIC_MODE_BRIGHT=0,
    DOLBY_PIC_MODE_DARK,
    DOLBY_PIC_MODE_INDX2,
    DOLBY_PIC_MODE_INDX3,
    DOLBY_PIC_MODE_INDX4,
    DOLBY_PIC_MODE_INDX5,
    DOLBY_PIC_MODE_INDX6,
    DOLBY_PIC_MODE_MAX
}DOLBY_PIC_MODE_T;

typedef enum
{
  DOLBY_FORMAT_INVALID = -1,
  DOLBY_FORMAT_DOVI = 0,
  DOLBY_FORMAT_HDR10 = 1,
  DOLBY_FORMAT_SDR = 2,
  DOLBY_FORMAT_HLG = 3,
  DOLBY_FORMAT_DOVI_LL = 4,  //mtk13439
} DOLBY_SRC_FMT_T; //same as cotnrol_path_api.h



typedef enum
{
    DOLBY_INPUT_MODE_OTT = 0,
    DOLBY_INPUT_MODE_HDMI= 1
} DOLBY_RUN_MODE_T;

typedef enum
{
    DOVI_SUCCEED = 0,
    DOVI_ERROR_0 = 1,
    DOVI_ERROR_1 = 2,
    DOVI_ERROR_2 = 3,
    DOVI_ERROR_3 = 4,  //init failed
} DOLBY_ERROR_T;

typedef struct
{
    BOOL pic_mode_ready_flag;
    DOLBY_PIC_MODE_T dolby_pic_mode;//used for get dolby mode indx
    UINT32 u4PreGdBacklightVal;
    UINT32 u4GdBacklightVal;
    UINT32 u4IsDropCurFrame;
    UINT32 u4TargetBinPartId;
}DOLBY_DM_CUST_SET_INFO_T;

typedef struct
{
    HAL_TIME_T tGetGdFromDvTimeStap;
    UINT32  u4DvGdDuty;
    UINT32  u4NextDvGdDuty;
    UINT32  u4SourceFrameNr;
    UINT32  u4SourceVideoInCrc;
    UINT32  u4DvLoopCnt;
    UINT32  reserved1[1];//make struct size 2 pow
    //exten  info
}DOLBY_GD_INFO_AFTER_GET_FROM_DV_T;//gd info get from dv moudle

typedef struct
{
    UINT32  u4DvGdDuty;
    UINT32  u4PreDvGdDuty; //output domain
    UINT32  u4NextDvGdDuty;//output domain
    UINT32  u4SourceFrameNr;//
    UINT32  u4SourceVideoInCrc;//
    UINT32  u4VdpOutputDomainFrameNr;
    BOOL    u4DvGdValid;
    HAL_TIME_T tGetGdFromDvTimeStap;
    HAL_TIME_T tGetGdFromVdpAfterVideoPmwSyncTimeStap;
    //exten  info
}DOLBY_GD_INFO_AFTER_VIDEO_PWM_SYNC_T;//gd info get from vdp after sync


typedef struct
{
    //also add dolby parser gd time and frame number push to mib isr but this need a fifo in dv moudle
    UINT32 u4VdpOutputDomainFrameNr;//input domain frame number
    UINT32 u4VideoAndDutyDelayCnt;
    UINT32 u4CurInOutGdDelayCnt;
    UINT32 u4InkOstgGValue;
    HAL_TIME_T tVdpGetDvInfoStap;
    DOLBY_GD_INFO_AFTER_GET_FROM_DV_T strVdpGetDvGdInfo;//FIFO IN
    HAL_TIME_T tVdpSetDvInfoStap;
    DOLBY_GD_INFO_AFTER_GET_FROM_DV_T strVdpSetDvGdInfo;//FIFO OUT
    HAL_TIME_T tSonyGetDvInfoStap;
    UINT32 u4SonyGetDvEn;
    UINT32 u4SonyGetDvGdEn;
    UINT32 u4SonyGetDvGdDuty;
    //exten other info
}DOLBY_GD_DBUG_INFO_T;


typedef struct
{
    UINT32 u4RegDbgEn;
    UINT32 u4RegMode;
    UINT32 u4RegNum;
    UINT32 u4RegAddNum;
    UINT32 u4RegRmainNum;
    UINT32 u4ArgRegAddr[DOLBY_REG_NUM];
    UINT32 u4ArgRegVal[DOLBY_REG_NUM];
    UINT32 u4RegReplaceFlag;
    //add lut update flag
}DOLBY_DBG_REG_T;

EXTERN DOLBY_CLI_PRM_T              dolby_cli_param;
EXTERN DOLBY_DBG_INFO_T             dolby_dbg_param;
EXTERN DOLBY_PRM_T                  dolbyprminfo;
EXTERN DOLBY_CRC_T                  dolbyCrcInfo;
EXTERN DOLBY_DM_CUST_SET_INFO_T     doviDMCustInfo_t;
EXTERN DOLBY_CUSTOM_SOURCE_INFO_T  doviCustSrcInfo_t;

EXTERN DOLBY_DBG_REG_T tDolbyDbgReg;
EXTERN DOLBY_AUTO_DUMP_T tDolbyAutoDumpInfo;

EXTERN DOLBY_GD_INFO_AFTER_VIDEO_PWM_SYNC_T doviGdInfoAfterVideoPmwSnc;
EXTERN DOLBY_GD_INFO_AFTER_GET_FROM_DV_T    doviGdInfoAfterGetFromDv;
EXTERN DOLBY_GD_DBUG_INFO_T* ptr_gd_debug_info;



//used for dtv driver
EXTERN void vDolby_SendEvent(DOLBY_MSG_T tMsg);
EXTERN int  vDrvDolbySetSource(DOLBY_SRC_T tSrc);
EXTERN void vDolbyMLInit(void);
EXTERN void vDolbyUninit(void);
EXTERN void vDolbyResume(void);
EXTERN void vDolbySuspend(void);


EXTERN UINT32 u4DolbyGetCustSourceInfo(UINT8 u1VdpId);
EXTERN UINT32 u4DolbyGetGlobalDimmingInfo(void);
EXTERN UINT32 u4DolbyGetGdPwmValue(void);
EXTERN INT32  i4DolbyGetGdPwmDelay(INT32 *ptr_gdDelayMilliSec_ott,INT32 *ptr_gdDelayMilliSec_hdmi);
EXTERN UINT32 u4DolbyGetSourceFmtInfo(void);
EXTERN UINT32 u4DolbyGetDtrFelInfo(void);
EXTERN BOOL   vDolbyRegHDRInfoCb(PFN_DOVI_HDR_NFY_FCT pfnHDRInfoCb);
EXTERN UINT32 u4DolbyGetEfuseInfo(void);
EXTERN UINT32 u4DolbyGetIdkVersion(void);
EXTERN UINT32 u4DolbyGetSourceType(void);
EXTERN UINT32 u4DolbyGetDoviType(void);

EXTERN DOLBY_PIC_MODE_T u4DolbyGetPicMode(void);
EXTERN void vDolbySetPicMode(DOLBY_PIC_MODE_T pic_mode);
EXTERN BOOL u1DolbyGetPicModeReadyFlag(void);
EXTERN int  u4DolbyCheckPicModeValid(UINT32 u4PicMode);
EXTERN void vDolbySetConfiFile(UINT8 u1PicMode,UPTR u4addr, UINT32 u4size);
EXTERN void vDolbyUpdateVsvdb(unsigned char *pdata);
EXTERN void vDolbyUpdateVsif(unsigned char *pdata,int size);
EXTERN void vDolbyUpdateLowLatencyModeCfg(void);
EXTERN void vDolbyLowLatencyModeProc(void);
EXTERN int  u4DolbyIdkCertModeIsNeedOttPause(void);
EXTERN int  u4DolbyDiscardMdTruncated(unsigned char*  in_out_md_buf,  unsigned int  in_md_buf_size,   int* out_md_buf_size);
EXTERN INT32 u4DolbyGetGdPwmInfo(DOLBY_GD_INFO_AFTER_GET_FROM_DV_T* ptrGDInfoFromDv);


//used for mtal
EXTERN INT32 u4DolbyGetDoviHDRInfo(UCHAR ucVdpId,  void* pkvPqGetInfo, UINT32 u4Size);


//used for cli
EXTERN void vDolbySetLoop(BOOL bRunLoop);
EXTERN void vDolbySetDbgFlag(UINT32 bDebugFlag);
EXTERN void vDolbyInfoQuery(void);
EXTERN void vDolbySetBypassFlag(UINT32 bDebugFlag);
EXTERN void vDolbyEnableScenceFlag(UINT8 u1ScnChgEn);
EXTERN void vDolbyForceGDOnOff(UINT32 bOn);
EXTERN void vDolbySetCmdLogLvl(UINT32 msk);
EXTERN void vDolbyCatDvGDInfo(UINT8 u1CatEn);
EXTERN void vDolbyHdmiSrcDumpCtrl(void);
EXTERN void vDrvDolbyHdmiSourceCrcQuery(void);
EXTERN void vDrvDolbySetHdmiDumpStartFrameIndx(int indx);
EXTERN void vDrvDolbyHdmiIDKAutoDumpCatchInfo(void);


extern int u4Dolby4K5060HdmiSinkledDvSourceOperationTnrUpdate(UINT32 u4TnrChnl, UINT32 u4TnrFunc);
extern int u4Dolby4K5060HdmiSinkledDvSourceOperation(void);


#endif

