/* SPDX-License-Identifier: LGPL-2.1-only OR BSD-3-Clause */
/******************************************************************************
 *
 * This file is provided under a dual license.  When you use or
 * distribute this software, you may choose to be licensed under
 * version 2.1 of the GNU Lesser General Public License
 * ("LGPLv2.1 License") or BSD License.
 *
 * LGPLv2.1 License
 *
 * Copyright(C) 2019 MediaTek Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2.1 of the GNU Lesser General Public
 * License as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See https://www.gnu.org/licenses/old-licenses/lgpl-2.1.html for more
 * details.
 *
 * BSD LICENSE
 *
 * Copyright(C) 2019 MediaTek Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *  * Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *****************************************************************************/

/*-----------------------------------------------------------------------------
 *
 * $Author: brianpc.huang $
 * $Date: 2015/05/29 $
 * $RCSfile: fe_tuner_common_if.h,v $
 * $Revision: #1 $
 *
 *---------------------------------------------------------------------------*/

/** @file fe_tuner_common_if.h
 *  Add your description here.
 */

#ifndef FE_TUNER_COMMON_IF_H
#define FE_TUNER_COMMON_IF_H

typedef enum //liuqu,20091224
{
    MOD_TYPE_BEGIN = 0,
    MOD_ATSC_8VSB = MOD_TYPE_BEGIN,
    MOD_J83B_64QAM,
    MOD_J83B_256QAM,
    MOD_J83B_AUTO_QAM,
#ifdef CC_S_PLATFORM
	MOD_J83B_256QAM_SONY,  //yican,adjust its position in code:sakura JP_QAM256=5.6(symbol rate)
#endif
    MOD_DVBT,
    MOD_DVBT2,   //add by liuqu    
    MOD_ISDBT,
    MOD_DVBC,
    MOD_DVBC2,
	MOD_DTMB,
    MOD_TYPE_END,
    MOD_ANA_TYPE_BEGIN,
    MOD_PAL_BG = MOD_ANA_TYPE_BEGIN,
    MOD_PAL_DK,
    MOD_PAL_I,
    MOD_SECAM_L,
    MOD_SECAM_L1,
    MOD_NTSC_M,
    MOD_TYPE_UNKNOWN,
    MOD_ANA_TERR,
    MOD_ANA_CABLE,
    MOD_ANA_TYPE_END
}MOD_TYPE_T;


#endif /* FE_TUNER_COMMON_IF_H */

