/* SPDX-License-Identifier: LGPL-2.1-only OR BSD-3-Clause */
/******************************************************************************
 *
 * This file is provided under a dual license.  When you use or
 * distribute this software, you may choose to be licensed under
 * version 2.1 of the GNU Lesser General Public License
 * ("LGPLv2.1 License") or BSD License.
 *
 * LGPLv2.1 License
 *
 * Copyright(C) 2019 MediaTek Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2.1 of the GNU Lesser General Public
 * License as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See https://www.gnu.org/licenses/old-licenses/lgpl-2.1.html for more
 * details.
 *
 * BSD LICENSE
 *
 * Copyright(C) 2019 MediaTek Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *  * Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *****************************************************************************/

/*-----------------------------------------------------------------------------
 * $Author: brianpc.huang $
 * $Date: 2015/05/29 $
 * $RCSfile: spi_if.h,v $
 * $Revision: #1 $
 *---------------------------------------------------------------------------*/

#ifndef SPI_IF_H
#define SPI_IF_H

//-----------------------------------------------------------------------------
// Include files
//-----------------------------------------------------------------------------
#include "x_lint.h"

LINT_EXT_HEADER_BEGIN
#include "x_typedef.h"
LINT_EXT_HEADER_END

//-----------------------------------------------------------------------------
// Constant definitions
//-----------------------------------------------------------------------------
#define SPI_DEMOD_REG_PROXY_WDATA       (0x104b0>>2)
#define SPI_DEMOD_REG_PROXY_CTRL        (0x104b4>>2)
#define SPI_DEMOD_REG_PROXY_RDATA       (0x104b8>>2)
#define SPI_DEMOD_REG_PROXY_STATUS      (0x104bc>>2)
#define SPI_DEMOD_REG_PROXY_STATUS_READ_OK      0x0
#define SPI_DEMOD_REG_PROXY_STATUS_READ_BUSY    0x1
#define SPI_DEMOD_REG_PROXY_STATUS_READ_READY   0x2
#define SPI_DEMOD_REG_PROXY_STATUS_READ_ERROR   0x3
#define SPI_DEMOD_REG_PROXY_STATUS_WRITE_OK     0x0
#define SPI_DEMOD_REG_PROXY_STATUS_WRITE_BUSY   0x1
#define SPI_DEMOD_REG_PROXY_STATUS_WRITE_ERROR  0x2
#define SPI_DEMOD_REG_PROXY_WRITE_ENABLE    (0x40<<24)
#define SPI_DEMOD_REG_PROXY_READ_ENABLE     (0x20<<24)

//-----------------------------------------------------------------------------
// Type definitions
//-----------------------------------------------------------------------------


//-----------------------------------------------------------------------------
// Inter-file functions
//-----------------------------------------------------------------------------
#ifdef CC_FAST_INIT
EXTERN void SPI_pm_suspend(void);
EXTERN void SPI_pm_resume(void);
#endif
EXTERN void SPI_Init(void);
EXTERN void SPI_Reset(void);
EXTERN void SPI_SetPll(void);
EXTERN INT32 SPI_SDAWrite(const UINT32* pu4Data, UINT32 u4Addr);
EXTERN INT32 SPI_SDARead(UINT32* pu4Data, UINT32 u4Addr);
EXTERN INT32 SPI_DMAWrite(const UINT32* pu4Data, UINT32 u4Addr, UINT32 u4DataLen);
EXTERN INT32 SPI_DMARead(UINT32* pu4Data, UINT32 u4Addr, UINT32 u4DataLen);

EXTERN INT32 SPI_DemodSingleRead(UINT8* pu4Data, UINT32 u4Addr);
EXTERN INT32 SPI_DemodSingleWrite(const UINT8* pu4Data, UINT32 u4Addr);

#endif //SPI_IF_H
