/* SPDX-License-Identifier: LGPL-2.1-only OR BSD-3-Clause */
/******************************************************************************
 *
 * This file is provided under a dual license.  When you use or
 * distribute this software, you may choose to be licensed under
 * version 2.1 of the GNU Lesser General Public License
 * ("LGPLv2.1 License") or BSD License.
 *
 * LGPLv2.1 License
 *
 * Copyright(C) 2019 MediaTek Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2.1 of the GNU Lesser General Public
 * License as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See https://www.gnu.org/licenses/old-licenses/lgpl-2.1.html for more
 * details.
 *
 * BSD LICENSE
 *
 * Copyright(C) 2019 MediaTek Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *  * Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *****************************************************************************/

/*-----------------------------------------------------------------------------
 *
 * $Author$
 * $Date$
 * $RCSfile: swdmx_mpg_psipsr_if.h,v $
 * $Revision$
 *
 *---------------------------------------------------------------------------*/

/** @file psipsr_if.h
 *  This header file declares public function prototypes of widget.
 */

#ifndef PSIPSR_IF_H
#define PSIPSR_IF_H

// definition remove to swdmx_drvif.h
#if 0
#define SWDMX_MAX_PMT_NUM                       (96)
#endif 

// remove these structs to swdmx_drvif.h

#if 0
typedef enum _E_PSIPSR_TBL_TYPE
{
	E_PSIPSR_TBL_TVCT,
	E_PSIPSR_TBL_CVCT,	
	E_PSIPSR_TBL_MGT,	
	E_PSIPSR_TBL_PAT,
	E_PSIPSR_TBL_PMT	,
	E_PSIPSR_TBL_STT	,
	E_PSIPSR_TBL_PSI
} E_PSIPSR_TBL_TYPE;

typedef enum _E_PSIPSR_MSG
{
	E_PSIPSR_OK,
	E_PSIPSR_TIMEOUT,
	E_PSIPSR_SLD_NOT_MATCH,
	E_PSIPSR_TABLE_ERROR,
	E_PSIPSR_OUT_OF_BOUNDRY,
	E_PSIPSR_OUT_OF_RESOURCE,
	E_PSIPSR_ERROR
} E_PSIPSR_MSG;

typedef struct _PSIPSR_TBL_TS2FREQ_T
{
	UINT16 u2TsId;
	UINT8 u1PhyCh; // physical channel, to acquire frequency
	UINT8 u1Version;
} PSIPSR_TBL_TS2FREQ_T;

typedef struct _PSIPSR_TBL_PMT_T
{
	UINT32 u4PID;
	UINT32 u4PCR;
	UINT32 u4VPID;
	UINT32 u4VPIDType; // add for h264
	UINT32 u4APID1;
	UINT32 u4APID2;
	UINT32 u4APID3;
	UINT32 u4APID1Type;
	UINT32 u4APID2Type;
	UINT32 u4APID3Type;
	UINT32 u4ProgNum;
} PSIPSR_TBL_PMT_T;


// 16 bytes (*128=2048bytes!)
typedef struct _PSIPSR_TBL_VCT_T
{
	UINT16 u2MajorChNum;
	UINT16 u2MinorChNum;
	UINT8 u1NextCh; //max 256 ch
	UCHAR szShortName[8];
	UINT16 u2ChTsId;
	UINT16 u2ProgNum;
	// volatile parts
	UINT16 u2PCR;
	UINT16 u2VPID;
	UINT16 u2VPIDType;
	UINT16 u2APID1;
	UINT16 u2APID1Type;
	UINT16 u2APID2;
	UINT16 u2APID2Type;
	UINT16 u2APID3;
	UINT16 u2APID3Type;
	
	UINT16 u2PhyFreq;
} PSIPSR_TBL_VCT_T;

typedef struct _PSIPSR_TBL_MGT_T
{
	UINT32 u4Type;
	UINT32 u4Pid;
	UINT32 u4Version;
	UINT32 u4Length;
} PSIPSR_TBL_MGT_T;

typedef struct _PSIPSR_TBL_STT_T
{
	UINT32 u4SysTime;
	UINT8 u1GPSUTCOffset;
	UINT16 u2DayLightSavings;

} PSIPSR_TBL_STT_T;

typedef struct _PSIPSR_SECTION
{
	UINT32 u4BufID;
	UINT32 u4Len;
	UINT32 u4Pidx;
} PSIPSR_SECTION;



typedef struct _PSIPSR_PARAM_T {
	UINT32 u4MaxEleNum;
	UINT32 u4RetEleNum;
	UINT32 u4TblType;
	UINT32 u4PMTTblIdx;
	UINT32 u4Timeout;
	//UINT32 u4Pidx;
	//UINT32 u4Filter;
	PSIPSR_TBL_VCT_T* prVctTbl;
	PSIPSR_TBL_TS2FREQ_T* prTsTbl;
	PSIPSR_TBL_MGT_T* prMgtTbl;
	PSIPSR_TBL_PMT_T* prPMTTbl;
	PSIPSR_TBL_STT_T* prSttTbl;

	UINT32 u4TsIndex;
	
} PSIPSR_PARAM_T;

typedef struct _PSIPSR_RTC_T
{
    UINT8   u1Year;
    UINT8   u1Month;
    UINT8   u1Day;
    UINT8   u1Hour;
    UINT8   u1Minute;
    UINT8   u1Second;
} PSIPSR_RTC_T;

#endif 

EXTERN INT32 SWDMX_PsiPsrParsePsi(UINT8 u1SrcId, PSIPSR_TBL_PMT_T* prPMTTbl, UINT32* pu4NumTblEle, UINT32 u4Timeout, UINT32 u4TsIndex);
EXTERN INT32 SWDMX_PsiPsrParseMgt(UINT8 u1SrcId, PSIPSR_TBL_MGT_T* prMgtTbl, UINT32* pu4NumTblEle, UINT32 u4Timeout, UINT32 u4TsIndex);
EXTERN INT32 SWDMX_PsiPsrParseTvct(UINT8 u1SrcId, PSIPSR_TBL_VCT_T* prVctTbl, UINT32* pu4NumTblEle, PSIPSR_TBL_TS2FREQ_T* prTsTbl, UINT32 u4Timeout, UINT32 u4TsIndex);
EXTERN INT32 SWDMX_PsiPsrParseCvct(UINT8 u1SrcId, PSIPSR_TBL_VCT_T* prVctTbl, UINT32* pu4NumTblEle, PSIPSR_TBL_TS2FREQ_T* prTsTbl, UINT32 u4Timeout, UINT32 u4TsIndex);
EXTERN INT32 SWDMX_PsiPsrParseStt(UINT8 u1SrcId, PSIPSR_TBL_STT_T* prSttTbl, UINT32* pu4NumTblEle, UINT32 u4Timeout, UINT32 u4TsIndex);
EXTERN VOID SWDMX_PsiPsrDataNofify(UINT8 u1SrcId, UINT32 u4Tag);

#endif
