/* SPDX-License-Identifier: LGPL-2.1-only OR BSD-3-Clause */
/******************************************************************************
 *
 * This file is provided under a dual license.  When you use or
 * distribute this software, you may choose to be licensed under
 * version 2.1 of the GNU Lesser General Public License
 * ("LGPLv2.1 License") or BSD License.
 *
 * LGPLv2.1 License
 *
 * Copyright(C) 2019 MediaTek Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2.1 of the GNU Lesser General Public
 * License as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See https://www.gnu.org/licenses/old-licenses/lgpl-2.1.html for more
 * details.
 *
 * BSD LICENSE
 *
 * Copyright(C) 2019 MediaTek Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *  * Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *****************************************************************************/


#ifndef MAPLE_BUTTON_H
#define MAPLE_BUTTON_H

static MULTI_KEY_T _arMTKMultiKeyList[] = {
    { BTN_FACTORY_MODE_1,   (DKBIT_VOL_DOWN | DKBIT_INPUT_SRC) },
    { BTN_FUNCTION_1,       (DKBIT_VOL_DOWN | DKBIT_POWER) },
    { BTN_NONE,             (DKBIT_NONE) },
};
#ifdef CC_3FP_SUPPORT
static SGL_SERVO_T _arMTKSingleServoKey[] = {
    {   SERVO(1),   1068,   413,    DKBIT_LEFT},   //  8    // 39
    {   SERVO(1),   412,    0,     DKBIT_RIGHT},      //  101  // 102
    {   0,          0,      0,      BTN_NONE	  },
};

static SGL_GPIO_T _arMTKSingleGpioKey[] = {
    // GPIO,       Btm,    Key
    {   OPCTRL15,   0,    DKBIT_POWER },
    {   0,         0,    DKBIT_NONE  },
};
#else
static SGL_SERVO_T _arMTKSingleServoKey[] = {
    //{   SERVO(1),  1023,   535,     DKBIT_NONE},   //  8    // 39
    {   SERVO(1),   534,   387,     DKBIT_MENU},    //  162  // 164
    {   SERVO(1),   386,   297,     DKBIT_INPUT_SRC},      //  101  // 102
    {   SERVO(1),   296,   207,     DKBIT_VOL_UP},   //  8    // 39
    {   SERVO(1),   206,   122,     DKBIT_VOL_DOWN},      //  101  // 102
    {   SERVO(1),   121,   41,      DKBIT_PRG_UP},    //  162  // 164
    {   SERVO(1),   40,    0,       DKBIT_PRG_DOWN},    //  162  // 164  
    {   0,          0,     0,       BTN_NONE	  },
};

static SGL_GPIO_T _arMTKSingleGpioKey[] = {
    // GPIO,       Btm,    Key
    {   OPCTRL15,   0,    DKBIT_POWER },
    {   0,         0,    DKBIT_NONE  },
};
#endif
#define SINGLE_GPIO_KEY_LIST		(_arMTKSingleGpioKey)
#define SINGLE_SERVO_KEY_LIST       (_arMTKSingleServoKey)
#define MULTI_KEY_LIST              (_arMTKMultiKeyList)

#endif /* MAPLE_BUTTON_H */

