/* SPDX-License-Identifier: LGPL-2.1-only OR BSD-3-Clause */
/******************************************************************************
 *
 * This file is provided under a dual license.  When you use or
 * distribute this software, you may choose to be licensed under
 * version 2.1 of the GNU Lesser General Public License
 * ("LGPLv2.1 License") or BSD License.
 *
 * LGPLv2.1 License
 *
 * Copyright(C) 2019 MediaTek Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2.1 of the GNU Lesser General Public
 * License as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See https://www.gnu.org/licenses/old-licenses/lgpl-2.1.html for more
 * details.
 *
 * BSD LICENSE
 *
 * Copyright(C) 2019 MediaTek Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *  * Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *****************************************************************************/

#ifndef MTK_IR_PULSECHECK_TBL_H
#define MTK_IR_PULSECHECK_TBL_H


/* TV-1, 12bits command */
static const KEYUNIT_T _arpulsecheckKeyMap01[] =
{
    { 0x00, BTN_DIGIT_1      },  // #1,   1
    { 0x01, BTN_DIGIT_2      },  // #2,   2
    { 0x02, BTN_DIGIT_3      },  // #3,   3
    { 0x03, BTN_DIGIT_4      },  // #4,   4
    { 0x04, BTN_DIGIT_5      },  // #5,   5
    { 0x05, BTN_DIGIT_6      },  // #6,   6
    { 0x06, BTN_DIGIT_7      },  // #7,   7
    { 0x07, BTN_DIGIT_8      },  // #8,   8
    { 0x08, BTN_DIGIT_9      },  // #9,   9
    { 0x09, BTN_DIGIT_0      },  // #10,  10
    { 0x0a, BTN_CUSTOM_37    },  // #11,  11/* //add for maple
    { 0x0b, BTN_ENTER        },  // #12,  ENTER
#if defined(IR_PAA)
    { 0x0D, BTN_TV           },  //[Digital] For  U/C Digital
#elif defined(IR_EU_PAD) || defined(IR_CHD)
    { 0x0D, BTN_CUSTOM_68    },  //[Digital] For  U/C Digital    
#else
    //BLANK
#endif
#if defined(IR_COL_SA) || defined(IR_BZ)
    { 0x0e, BTN_EPG          },  // #15,  EPG
#else
    { 0x0e, BTN_CUSTOM_63    },  // /* CH-15 / 10KEY (Guide/Gemstar Key)) */
#endif
    { 0x10, BTN_PRG_UP       },  // #17,  CH-UP                        
    { 0x11, BTN_PRG_DOWN     },  // #18,  CH-DOWN                             
    { 0x12, BTN_VOL_UP       },  // #19,  VOLUME-UP                        
    { 0x13, BTN_VOL_DOWN     },  // #20,  VOLUME-DOWN                          
    { 0x14, BTN_MUTE         },  // #21,  MUTE                      
    { 0x15, BTN_POWER        },  // #22,  Power
#ifndef IR_BZ    
    { 0x16, BTN_CUSTOM_35    },  // #23,  Reset
#endif
    { 0x17, BTN_MTS          },  // #24,  MTS
    { 0x18, BTN_CUSTOM_1     },  // #25,  PICTURE-UP
    { 0x19, BTN_CUSTOM_2     },  // #26,  PICTURE-DOWN
    { 0x1a, BTN_CUSTOM_3     },  // #27,  COLOR-VIVID
    { 0x1b, BTN_CUSTOM_4     },  // #28,  COLOR-PALE
    { 0x1e, BTN_CUSTOM_5     },  // #31,  BRIGHTNESS-BRIGHT
    { 0x1f, BTN_CUSTOM_6     },  // #32,  BRIGHTNESS-DARK
    { 0x20, BTN_CUSTOM_8     },  // #33,  HUE-PURPLISH
    { 0x21, BTN_CUSTOM_7     },  // #34,  HUE-GREENISH
    { 0x22, BTN_CUSTOM_9     },  // #35,  SHARPNESS-SHARP
    { 0x23, BTN_CUSTOM_10    },  // #36,  SHARPNESS-SOFT
    { 0x24, BTN_CUSTOM_11    },  // #37,  VIDEO-RESET (External Input -> TV)
    { 0x25, BTN_INPUT_SRC    },  // #38,  VIDEO-SELECT (Input Select)
    { 0x26, BTN_CUSTOM_12    },  // #39,  BALANCE-LEFT
    { 0x27, BTN_CUSTOM_13    },  // #40,  BALANCE-RIGHT
    { 0x28, BTN_S_EFFECT     },  // #41,  SOUND (Sound mode)
    { 0x29, BTN_SURROUND     },  //Hua   // #42,  MATIRX / SURROUND(Surround)
#ifdef CC_MAPLE_TWO_WORLD_IR
      { 0x2a, BTN_CUSTOM_214   },  //Hua   // #43,  ANTENA-SELECT (ANT)
#else
  #ifdef IR_BZ
      { 0x2a, BTN_CUSTOM_68    },  //Hua   // #43,  ANTENA-SELECT (ANT)
  #else
      { 0x2a, BTN_TV_ANA 	     },  //Hua   // #43,  ANTENA-SELECT (ANT)
  #endif
#endif
    { 0x2e, BTN_POWER_ON     },  // #47,  Power on
    { 0x2f, BTN_POWER_OFF    },  // #48,  Power off 
    { 0x31, BTN_CUSTOM_38    },  // #50,  Timer count speed up //add for maple
	{ 0x32, BTN_CUSTOM_39	 },  // #51,  Timer count speed down //add for maple
    { 0x33, BTN_CURSOR_RIGHT },  // #52,  Cursor Right                   
    { 0x34, BTN_CURSOR_LEFT  },  // #53,  Cursor Left   
    { 0x36, BTN_SLEEP        },  // #55,  SLEEP   
//#if defined(IR_EU_PAD) || defined(IR_CHD)
    { 0x38, BTN_TV_ANA       },  //Hua  // #57,  TV //DAVID 20091228
//#elif defined(IR_PAA) || defined(IR_BZ)
//    { 0x38, BTN_TV           },  //Hua  // #57,  TV 
//#else
    // BLANK
//#endif
    { 0x39, BTN_CUSTOM_40    },  // #58,  other(test cmd) //add for maple
    { 0x3a, BTN_PRG_INFO     },  // #59,  DISPLAY
    { 0x3b, BTN_PREV_PRG     },  // #60,  JUMP 
    { 0x3E, BTN_CUSTOM_64    },	 //Hua   // #63,  CRT-OFF(Picture Off/Test-Aging
    { 0x3f, BTN_TTX          },  //Hua   // #64,  Teletext     
    { 0x40, BTN_CUSTOM_14    },  // #65,  VIDEO-1 (Direct AV1)
    { 0x41, BTN_CUSTOM_15    },  // #66,  VIDEO-2 (Direct AV2)
    { 0x42, BTN_CUSTOM_16    },  // #67,  VIDEO-3 (Direct Component1)
    { 0x43, BTN_CUSTOM_17    },  // #68,  ANALOG RGB (Direct PC)
    { 0x47, BTN_CUSTOM_18    },  // #72,  VIDEO-4 (Direct Component2)
#ifndef IR_BZ
    { 0x48, BTN_CUSTOM_19    },  // #73,  VIDEO-5 (Direct HDMI1)
    { 0x49, BTN_CUSTOM_20    },  // #74,  VIDEO-6 (Direct HDMI2)
#endif
    { 0x5b, BTN_PIP_POP      },  // #92,  PIP
#ifdef CC_MAPLE_TWO_WORLD_IR
    { 0x60, BTN_ROOT_MENU    },  // #97,  MENU	
#else
    { 0x60, BTN_MENU         },  // #97,  MENU  
#endif
    { 0x63, BTN_CUSTOM_60    },  // #100,    
    { 0x64, BTN_P_EFFECT     },  // #101, VIDEO PALETTE (Picture Mode)
    { 0x65, BTN_SELECT       },  // #102, SELECT  
    { 0x6b, BTN_CUSTOM_65    },  //Hua   // #108, AUTO PROGRAM(Channel Scan)   
    { 0x70, BTN_CUSTOM_21    },  // #113, TREBLE-UP        
    { 0x71, BTN_CUSTOM_22    },  // #114, TREBLE-DOWN  
    { 0x72, BTN_CUSTOM_23    },  // #115, BASS-UP
    { 0x73, BTN_CUSTOM_24    },  // #116, BASS-DOWN 
    { 0x74, BTN_CURSOR_UP    },  // #117, ANALOG-UP (Cursor Up)
    { 0x75, BTN_CURSOR_DOWN  },  // #118, ANALOG-DOWN (Cursor Down)
    { 0x7f, BTN_CUSTOM_36    },  // #128, Test 
};

/* TV adapter, 12bits command */
#ifndef IR_BZ
//for BZ model, these keys are removed
static const KEYUNIT_T _arpulsecheckKeyMap03[] =
{
    { 0x4C, BTN_RED          },
    { 0x4D, BTN_GREEN        },
    { 0x4E, BTN_YELLOW       },
    { 0x4F, BTN_BLUE         }
};
#endif

/* AV Master, 15bits command */
static const KEYUNIT_T _arpulsecheckKeyMap04[] =
{
    { 0x37, BTN_POWER_OFF    },  // #56,  SYSTEM OFF (Power off)
};

/* TV1G, 15bits command */
static const KEYUNIT_T _arpulsecheckKeyMap1A[] =
{
    { 0x3b,   BTN_CUSTOM_95  },  // #59,  Audio Description ON/OFF
    { 0x3c,   BTN_CUSTOM_96  },  // #60,  Audio Description Mixing level up
    { 0x3d,   BTN_CUSTOM_97  },  // #61,  Audio Description Mixing level down
    { 0x55,   BTN_CUSTOM_90  },  // #86,  New photo frame
    { 0x57,   BTN_CUSTOM_89  },  // #87,  TV/RADIO  
    { 0x58,   BTN_CUSTOM_34  },  // #89,  Sync Menu
    { 0x59,   BTN_CUSTOM_25  },  // #90,  HDMI ONLY SELECT (Toggle HDMI)
    { 0x5a,   BTN_CUSTOM_26  },  // #91,  HDMI1 INPUT SELECT (Direct HDMI1)
    { 0x5b,   BTN_CUSTOM_27  },  // #92,  HDMI2 INPUT SELECT (Direct HDMi2)
    { 0x5c,   BTN_CUSTOM_56  },  // #93,  HDMI3 INPUT SELECT (Direct HDMI3)
    { 0x5d,   BTN_CUSTOM_66  },  // #94,  HDMI4 INPUT SELECT (Direct HDMI4)  
    { 0x60,   BTN_CUSTOM_71  },  // Top Menu
    { 0x61,   BTN_CUSTOM_67  },  // Popup Menu
    { 0x62,   BTN_RECORD     },  // #99,  start recording //add for maple
	{ 0x63,   BTN_CUSTOM_41  },  // #100,  stop recording //add for maple
	{ 0x64,   BTN_CUSTOM_42  },  // #101,  reserve recording //add for maple
	{ 0x65,   BTN_CUSTOM_43  },  // #102,  title list recording //add for maple
	{ 0x67,   BTN_CUSTOM_44  },  // #104,  TV pause //add for maple		
    { 0x68,   BTN_CUSTOM_57  },  // #105, Info
    { 0x69,   BTN_CUSTOM_49  },  // #106, Next favorite channel
    { 0x6a,   BTN_CUSTOM_52  },  // #107, On demand
    { 0x6c,   BTN_CUSTOM_53  },  // #109, DMX menu
    { 0x6e,   BTN_CUSTOM_59  },  // #111, Guide
	{ 0x6f,   BTN_CUSTOM_45  },  // #112,  applicast on/off //add for maple
	{ 0x73,   BTN_CUSTOM_202 },  // #116, DISCOVER 
	{ 0x74,   BTN_CUSTOM_204 },  // #117,  Social View
	{ 0x75,   BTN_CUSTOM_46  },  // #118,  KEYPAD //add for maple	  	
	{ 0x76,   BTN_CUSTOM_205  },  // #119, Football Mode
    { 0x78,   BTN_CUSTOM_61  },  // #121, SCENE ON/OFF
	{ 0x79,   BTN_CUSTOM_91  },  // #122,  BIVL //add for maple    
    /*{ 0x7a,   BTN_WIDGET     },  // #123, Widgets (Yahoo/Opera)*/
	{ 0x7b,   BTN_CUSTOM_47  },  // #124,  OSIM(i-MANUAL) //add for maple  	
    { 0x7c,   BTN_NETFLIX    },  // #125, NETFLIX
    { 0x7d,   BTN_CUSTOM_91  },  // #126, Internet Video(PORTAL)
    { 0x7e,   BTN_CUSTOM_48  },  // #127, Track ID (X key) / Related Search (TBD) //add for maple  
};

/* TV-1E, 15bits command */
static const KEYUNIT_T _arpulsecheckKeyMapA4[] =
{
    { 0x10, BTN_CC           },  // #17,  CLOSED CAPTION MODE
#ifndef IR_BZ
    { 0x12, BTN_CUSTOM_30    },  // #19,  Componentl only seelct (Toggle Component)
#endif
    { 0x16, BTN_CUSTOM_29    },  // #23,  VIDEO ONLY SELECT (Toggle AV)
    { 0x17, BTN_CUSTOM_30    },  // #24,  Componentl only seelct (Toggle Component)
//#ifndef IR_BZ
    { 0x18, BTN_TV_ANA       },  //Hua  // #25,  Back to TV source
//#endif
    { 0x1f, BTN_SURROUND     },  //Hua  // #32, SOUND EFFECT(Surround)  
    { 0x36, BTN_CUSTOM_31    },  // #55,  HD1 (Direct Component1)
    { 0x37, BTN_COMPONENT_2  },  // #56,  HD2 (Direct Component2)
    { 0x3b, BTN_CUSTOM_69    },	 //Hua  // #60, WIDE(Normal/Full)       
    { 0x3d, BTN_ASPECT       },  // #62,  Wide Mode
    { 0x42, BTN_CUSTOM_72    },	 //Hua  // #67,  Wide Zoom
    { 0x5B, BTN_EPG          },  // #92,  
    { 0x77, BTN_PIP_POP	     },  // #120,    
};

/* TV-1EE, 15bits command */
static const KEYUNIT_T _arpulsecheckKeyMap97[] =
{
    { 0x0c, BTN_CUSTOM_73    },  // #13, BS10Key ]10Key^ //add for maple 
    { 0x0f, BTN_PAUSE        },  // #16, Play/Pause
    { 0x10, BTN_CUSTOM_74    },  // #17, BS/CS //add for maple 
    { 0x12, BTN_CUSTOM_75    },  // #19, Radio //add for maple     
	{ 0x13, BTN_CUSTOM_76    },  // #20, Independent Data //add for maple 
	{ 0x14, BTN_CUSTOM_77    },  // #21, Picture Change //add for maple	   
	{ 0x15, BTN_CUSTOM_78    },  // #22, d(Data) //add for maple 
    { 0x18, BTN_STOP         },  // #25,  Stop
    { 0x19, BTN_PAUSE        },  // #26,  Pause
    { 0x1a, BTN_PLAY         },  // #27,  Play 
    { 0x1b, BTN_FR           },  // #28,  Quick-Return 
    { 0x1c, BTN_FF           },  // #29,  Fast-Forward 
    { 0x1d, BTN_DIGIT_DOT    },  // #30,  DOT
    { 0x20, BTN_RECORD       },  // #33,  REC
    { 0x23, BTN_EXIT         },  // #36,  RETURN
    { 0x24, BTN_BLUE         },  // #37,  Blue
    { 0x25, BTN_RED          },  // #38,  Red
    { 0x26, BTN_GREEN        },  // #39,  Green
    { 0x27, BTN_YELLOW       },  // #40,  Yellow
    { 0x28, BTN_SUB_TITLE    },  // /* Sub Title */
	{ 0x2b, BTN_CUSTOM_79    },  // #44, CS //add for maple 
	{ 0x2c, BTN_CUSTOM_80	 },  // #45, BS //add for maple 
	{ 0x32, BTN_CUSTOM_81	 },  // #51, Terrestrial Digital //add for maple 	
    #ifdef CC_MAPLE_TWO_WORLD_IR
	{ 0x36, BTN_MENU         },  // #55,  TOOLS
	#else
    { 0x36, BTN_TOOLS        },  // #55,  TOOLS
    #endif
    { 0x37, BTN_CUSTOM_82	 },  // #56, Search //add for maple 
	{ 0x38, BTN_CUSTOM_213	 },  // #57, Media Change //add for maple 
	{ 0x39, BTN_CUSTOM_84	 },  // #58, Radio/Data //add for maple 
    { 0x3C, BTN_PREV         },  // #61,  Previous Skip
    { 0x3D, BTN_NEXT         },  // #62,  Forward Skip
    { 0x4a, BTN_CUSTOM_208   },  // #75,  SELECT
    { 0x4d, BTN_CUSTOM_211   },  // #78,  CURSOR LEFT
    { 0x4e, BTN_CUSTOM_212   },  // #79,  CURSOR RIGHT
    { 0x4f, BTN_CUSTOM_209   },  // #80,  CURSOR UP
    { 0x50, BTN_CUSTOM_210   },  // #81,  CURSOR DOWN
    { 0x6a, BTN_CUSTOM_92    },  // #107, Picture Reset=>RESET(Shop Remote Control Forced Dynamic)
	{ 0x78, BTN_CUSTOM_85	 },  // #121, Flash + //add for maple 
	{ 0x79, BTN_CUSTOM_86	 },  // #122, Flash - //add for maple 
    { 0x7b, BTN_S_EFFECT     },  // #124, Sound mode
    { 0x7c, BTN_CUSTOM_54    },  // #125, Demo Mode On/Off
};

/* TV-1EEE, 15bits command */
static const KEYUNIT_T _arpulsecheckKeyMap77[] =
{
//#if defined(IR_PAA)
//    { 0x0D, BTN_TV           },  //[Digital] For  U/C Digital
//#else
    { 0x0D, BTN_CUSTOM_68    },  //[Digital] For  U/C Digital = media change
//#endif
    { 0x32, BTN_CUSTOM_50    },  // #51,  SEEK+
    { 0x33, BTN_CUSTOM_51    },  // #52,  SEEK-
#if defined(IR_EU_PAD)
    /* BLANK */
#else
    { 0x36, BTN_POWER_SAVING },  // #55,  Power Saving
#endif    
    { 0x3b, BTN_CUSTOM_29    },	 //Hua  // #60,Video 1/2/3    
    { 0x4d, BTN_3D           },	 // #78,  Toggle the 3D Display Setting
    { 0x52, BTN_TV_DIG       },  // #83,  [Digital] For AEP Digital Model
    { 0x60, BTN_CUSTOM_33    },  // #97,  Home Theatre 
    { 0x76, BTN_FAVORITE     },  // #119, Favorite
    { 0x7B, BTN_CUSTOM_206   },  // #123, DEMO SURROUND   
};

/* TV-1H, 15bits command */
static const KEYUNIT_T _arpulsecheckKeyMapC4[] =
{
	{ 0x0C, BTN_CUSTOM_232	  }, // Advanced BS/CS
    { 0x22, BTN_CUSTOM_226    }, // Audio Output (Audio system)
    { 0x23, BTN_CUSTOM_227    }, // Audio Output (TV speaker)
    { 0x24, BTN_CUSTOM_228    }, // Audio Output (Toggle)
    { 0x25, BTN_CUSTOM_238    }, // DARWIN LOOP
    { 0x2a, BTN_CUSTOM_229   },  // Application Launcher
    { 0x2B, BTN_CUSTOM_239   },  // Acoustic Center Sync On/Off
    { 0x2C, BTN_CUSTOM_224    }, // Mute On
    { 0x2D, BTN_CUSTOM_225    }, // Mute Off
    { 0x3b, BTN_CUSTOM_201   },	 // #49   MIC ON/OFF
    { 0x44, BTN_CUSTOM_220    }, // #68,  Featured App
    { 0x45, BTN_CUSTOM_221    }, // #69,  Featured App (VOD)
    { 0x46, BTN_CUSTOM_219    }, // #70,  Google Play
    { 0x47, BTN_CUSTOM_230   },  // YouTube
    { 0x48, BTN_CUSTOM_231   }, // Recorder Menu
    { 0x49, BTN_CUSTOM_223    }, // STB Menu
	{ 0x4b, BTN_CUSTOM_203   },  // #75,  ACTION MENU
	{ 0x4d, BTN_CUSTOM_88	 },  // #77,  HELP
    { 0x4e, BTN_CUSTOM_87    },	 // #78,  Skyperfect TV premium
    { 0x4f, BTN_CUSTOM_222   },  // #79,  Android Menu
    { 0x6e, BTN_CUSTOM_233   },  // MIC FROM PAIRED REMOTE
    { 0x6f, BTN_CUSTOM_234   },  // MIC FROM UNPAIRED REMOTE
    { 0x70, BTN_CUSTOM_237   },  // GEAR KEY
    { 0x7b, BTN_CUSTOM_236   },  // Bluetooth Pairing
    { 0x7c, BTN_CUSTOM_235   },  // B2B CUSTOMIZE KEY
    { 0x7e, BTN_CUSTOM_207   },  // #126, Wireless Subwoofer On/Off 
    
    /* Reserved section, not real keys. */
    { 0xf1, BTN_CUSTOM_215   },  // Dummy key -- enter service mode
    { 0xf2, BTN_CUSTOM_216   },  // Dummy key -- self diagnostic
    { 0xf3, BTN_CUSTOM_217   },  // Dummy key -- active hotel mode
    { 0xf4, BTN_CUSTOM_218   },  // Dummy key -- exit hotel mode
};

/* TV-081F, 20bits command */
static const KEYUNIT_T _arpulsecheckKeyMap081F[] =
{
    { 0x00, BTN_CUSTOM_240   }, /* Partner App (customer requirement) */
    { 0x01, BTN_CUSTOM_241   }, /* Partner App (customer requirement) */
    { 0x02, BTN_CUSTOM_242   }, /* Partner App (customer requirement) */
    { 0x03, BTN_CUSTOM_243   }, /* Partner App (customer requirement) */
    { 0x04, BTN_CUSTOM_244   }, /* Partner App (customer requirement) */
    { 0x05, BTN_CUSTOM_245   }, /* Partner App (customer requirement) */
    { 0x06, BTN_CUSTOM_246   }, /* Partner App (customer requirement) */
    { 0x07, BTN_CUSTOM_247   }, /* Partner App (customer requirement) */
    { 0x08, BTN_CUSTOM_248   }, /* Partner App (customer requirement) */
    { 0x09, BTN_CUSTOM_249   }, /* Partner App (customer requirement) */
    { 0x0a, BTN_CUSTOM_250   }, /* Partner App (customer requirement) */
    { 0x0b, BTN_CUSTOM_251   }, /* Partner App (customer requirement) */
    { 0x0c, BTN_CUSTOM_252   }, /* Partner App (customer requirement) */
    { 0x0d, BTN_CUSTOM_253   }, /* Partner App (customer requirement) */
    { 0x0e, BTN_CUSTOM_254   }, /* Partner App (customer requirement) */
    { 0x0f, BTN_CUSTOM_255   }, /* Partner App (customer requirement) */
    { 0x10, BTN_CUSTOM_256   }, /* Partner App (customer requirement) */
    { 0x11, BTN_CUSTOM_257   }, /* Partner App (customer requirement) */
    { 0x12, BTN_CUSTOM_258   }, /* Partner App (customer requirement) */
    { 0x13, BTN_CUSTOM_259   }, /* Partner App (customer requirement) */
};

#endif /* MTK_IR_pulsecheck_TBL_H */

