//***************************************************************************
//!file     si_common.h
//!brief    Silicon Image common definitions header.
//
// No part of this work may be reproduced, modified, distributed, 
// transmitted, transcribed, or translated into any language or computer 
// format, in any form or by any means without written permission of 
// Silicon Image, Inc., 1060 East Arques Avenue, Sunnyvale, California 94085
//
// Copyright 2008-2010, Silicon Image, Inc.  All rights reserved.
//***************************************************************************/

#ifndef __SI_COMMON_H__
#define __SI_COMMON_H__

#include "si_datatypes.h"
#include "sk_configure.h"
#include "si_debug.h"
#include "x_printf.h"


#define SI_USE_SCHEDULER_IN_HAL     ENABLE

// Standard result codes are in the range of 0 - 4095
typedef enum _SiiResultCodes_t
{
    SII_SUCCESS      = 0,           // Success.
    SII_ERR_FAIL,                   // General failure.
    SII_ERR_INVALID_PARAMETER,      //
    SII_ERR_IN_USE,                 // Module already initialized.
    SII_ERR_NOT_AVAIL,              // Allocation of resources failed.

} SiiResultCodes_t;


#endif  // __SI_COMMON_H__
