/* SPDX-License-Identifier: LGPL-2.1-only OR BSD-3-Clause */
/******************************************************************************
 *
 * This file is provided under a dual license.  When you use or
 * distribute this software, you may choose to be licensed under
 * version 2.1 of the GNU Lesser General Public License
 * ("LGPLv2.1 License") or BSD License.
 *
 * LGPLv2.1 License
 *
 * Copyright(C) 2019 MediaTek Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2.1 of the GNU Lesser General Public
 * License as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See https://www.gnu.org/licenses/old-licenses/lgpl-2.1.html for more
 * details.
 *
 * BSD LICENSE
 *
 * Copyright(C) 2019 MediaTek Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *  * Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *****************************************************************************/
/*-----------------------------------------------------------------------------
 *
 * $Author: brianpc.huang $
 * $Date: 2015/05/29 $
 * $RCSfile: drv_autocolor.h,v $
 * $Revision: #1 $
 *
 *---------------------------------------------------------------------------*/

#ifndef _DRV_AUTOCOLOR_H_ 
#define _DRV_AUTOCOLOR_H_
//  IC ^Ӫ markoqdefine
	#ifndef CC_EEPROM_READY_AUTO_COLOR
		#define EEPROM_READY   1
       #else
		#define EEPROM_READY          CC_EEPROM_READY_AUTO_COLOR
	#endif


//#define EEPROM_READY  0   //IC ^Ӫj 0
//#define EEPROM_USAGE_debug 0

#define FULLY_HW_AUTO_CALIBRATION   1  //fully total cancel blank level shift by H/W
//#define DIGITAL_CALIBRATION   1
//#define ANALOG_CALIBRATION   1

#define AUTOCOLOR_NEW_METHOD
#ifdef FULLY_HW_AUTO_CALIBRATION
    #define HW_MEASURE_BLANK      0   // for read blank level during fixed period to solve VSAG problem
    #define DIGITAL_NEW_OFFSET    1   //using digital line average method must make sure the analog signal is >0
    #define E_FUSE_DO_OFFSET_CALIBRATION 1
    #define COMPENSATE_GAIN         0
    #if COMPENSATE_GAIN
         #define COMPENSATE_BY_ANALOG_GAIN 0 //default to use digital gain to do compensation
    #endif
#elif  defined (DIGITAL_CALIBRATION)
    #define HW_MEASURE_BLANK      1   //for reading blank level during fixed period to solve VSAG problem
    #define DIGITAL_NEW_OFFSET    1   //for reducing analog offset resolution to save chip area
    #define E_FUSE_DO_OFFSET_CALIBRATION 0  // I did not test the case of this define=1
    #define COMPENSATE_GAIN         0                   // I did not test the case of this define=1
    #if COMPENSATE_GAIN
         #define COMPENSATE_BY_ANALOG_GAIN 0 //default to use digital gain to do compensation
    #endif
#elif  defined(ANALOG_CALIBRATION   )
    #define HW_MEASURE_BLANK      0   //for reading blank level during fixed period to solve VSAG problem
    #define DIGITAL_NEW_OFFSET    0   //for reducing analog offset resolution to save chip area
    #define E_FUSE_DO_OFFSET_CALIBRATION 0  // I did not test the case of this define=1
    #define COMPENSATE_GAIN         0                   // I did not test the case of this define=1
    #if COMPENSATE_GAIN
         #define COMPENSATE_BY_ANALOG_GAIN 0 //default to use digital gain to do compensation
    #endif
#endif

#define PGA_4bit_offset 0   //test for next generation IC
/******************************************************************************
 * Header Files
 *****************************************************************************/
#include "typedef.h"

/******************************************************************************
 * Macro, Type Definition, and Variable Declaratoin
 *****************************************************************************/
extern void vDrvIntAutoColorStart(void) ;
void bDrvSetHDADCGain(UINT8 bOrder,UINT8 value);
void bDrvSetHDADCOffset(UINT8 bOrder,UINT8 value);
void vDrvSetHDADCDigitalOffset(UINT8 bOrder,UINT16 value);
 void bDrvSetHDADCGain_Digital(UINT8 bOrder, UINT16 value);

extern UINT8   _OnChipAutoColorState;
extern UINT8   _bAutoColorState0;
//extern UINT8   _bAutoColorIsr;
extern UINT8   _bGainOffset_channel;
extern UINT16  _wData_v1v2[3];
extern UINT8   _bMode;  //mtest_0110
extern UINT8   _bType;
extern UINT8  _bEEPROM_ready;
//extern  UINT8 _bDigSignBit;
//extern  UINT8 _bInitDigSignBit;

extern UINT8 bDrvOnChipGetVFESignalType(UINT8 bAutoInput);
extern UINT8 bDrvOnChipAutoColorCheckSignalReady(void);
extern UINT16 bDrvGetBlankVal(UINT8 bOrder);
extern UINT8 bDrvOnChipGetADCMaxMinValue(UINT8 bOrder, UINT8 bMode);
extern UINT8 bDrvOnChipGetADCMaxValueRGBYPBPR(UINT8 bOrder);
extern void vDrvOnChipAutoColor_GainOffset(UINT8 bMode); //for ON_CHIP_AUTO_COLOR
//extern void vChkOnChipOffsetEEPROM(void);
extern void vDrvOnChipAutoColorIteration(void);
extern void vDrvAdjustBlankLevel(void);
extern void vDrvEnableBlankLevelAdjust(void);
extern void vDrvEnableBlankLevelMeasure(void);
extern void vDrvEnableADCLinearityVerify(UINT8 bType);
extern void vDrvEnablePGALinearityVerify(void);
extern void vDrvPGALinearityVerify(void);
extern void vDrvADCLinearityVerify(void);
extern void vDrvHDTVMeasureSetting(UINT8 bField_Number);
extern void  vDrvHDTVClampMethodDefaultSetting(UINT8 bType);
extern void vDrvEnableVGARefVoltageVerify(UINT8 bType);
extern void vDrvEnableSyncSlicerRefVoltageVerify(UINT8 bType);
extern UINT8 vCust_Current_Cal_Status(void);
//#ifdef FULLY_HW_AUTO_CALIBRATION
extern void vDrvHDTV_HW_AUTO_ONOFF(UINT8 bMode, UINT8 bType);
//#endif
#if PGA_4bit_offset
         #define ADJUST_TOLRENCE 0X38   // 0x38=10bit 7 code.  can not bigger than 0X40,
#else
         #ifdef FULLY_HW_AUTO_CALIBRATION
         #define ADJUST_TOLRENCE 0X10   //0x10= 10bit 2 code         
		 #else
         #define ADJUST_TOLRENCE 0X08   //0x08= 10bit 1 code
         #endif
#endif

#define BLANK_RESET 0x08 //rock20060220
#define BLANK_HOLD 0x04
#define BLANK_ALWAYS 0x00
#define vDrvSetBlankStatus(bSta)	vWriteVDOINMsk(HDTV04, bSta, 0x0c, 1)
//#define vDrvSetBlankHold(bEnable)	vWriteVDOINMsk(HDTV04, (bEnable <<2), 0x04, 1)
#define vDrvClrSP1DE() 		vWriteVDOINMsk(VSRC00, 0x00, 0x10, 3)
#define vSetAutoClrState(bState)	(_bAutoColorState0 = bState)
#define bGetAutoClrState()	(_bAutoColorState0)
extern UINT8   _bAutoColorState0;
extern UINT16 _bAutoColorGain[4][3];/*#ifdef AUTOCOLOR_NEW_METHOD*/
extern UINT16  _bAutoColorOffset[4][3];
extern UINT16  _bAutoColorGain_for_EFuse[4][3];/*#endif*/
extern UINT8  _bAutoColorHistory[4];
extern UINT32 _dwBlankAvg_1[3]; //blank level for ch1, ch2, ch3
extern UINT32 _dwMaxLevelAvg_1[3];//maximum level for ch1, ch2, ch3

extern UINT8 _bOffsetCaliDone[4];

extern void vDrvIntAutoColorState(void) ;

extern void vDrvExtAutoColorStart(void) ;
extern void vDrvExtAutoColorLoad(void) ;
extern void vDrvExtAutoColorState(void) ;

enum
{
Pixel_16_per_line,
Pixel_32_per_line,
Pixel_64_per_line,
Pixel_128_per_line
};

enum
{
Start_line_0,
Start_Lline_8,
Start_line_16,
Start_line_24,
Start_line_32,
Start_line_40,
Start_line_48,
Start_line_56,
Start_line_64,
Start_line_72,
Start_line_80,
Start_line_88,
Start_line_96,
Start_line_104,
Start_line_112,
Start_line_120,
Start_line_128,
};

enum
{
Per_1_line,
Per_2_line,
Per_4_line,
Per_8_line,
Per_16_line,
Per_32_line,
Per_64_line,
Per_128_line
};
enum
{
Average_128_line,
Average_256_line,
Average_512_line,
Average_1024_line
};

enum
{
UPDATE_PER_1_FIELD,
UPDATE_PER_2_FIELD,
UPDATE_PER_4_FIELD,
UPDATE_PER_8_FIELD
};

enum
{
AFTER_ADJ,
BEFORE_ADJ
};

enum
{
CALI_DISABLE,
CALI_ENABLE
};
#endif
