/* SPDX-License-Identifier: LGPL-2.1-only OR BSD-3-Clause */
/******************************************************************************
 *
 * This file is provided under a dual license.  When you use or
 * distribute this software, you may choose to be licensed under
 * version 2.1 of the GNU Lesser General Public License
 * ("LGPLv2.1 License") or BSD License.
 *
 * LGPLv2.1 License
 *
 * Copyright(C) 2019 MediaTek Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2.1 of the GNU Lesser General Public
 * License as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See https://www.gnu.org/licenses/old-licenses/lgpl-2.1.html for more
 * details.
 *
 * BSD LICENSE
 *
 * Copyright(C) 2019 MediaTek Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *  * Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *****************************************************************************/

/*-----------------------------------------------------------------------------
 *
 * $Author: brianpc.huang $
 * $Date  $
 * $RCSfile: drv_hdmi.h,v $
 * $Revision: #1 $
 *
 *---------------------------------------------------------------------------*/
#ifndef __DRV_EARC__H
#define __DRV_EARC__H

#ifndef  __5895_EARC__
#define  __5895_EARC__
#endif
/*-----------------------------------------------------------------------*/
/*--------------------     Macro define   ------------------------*/
#ifndef HDMI_IF_AUDIO_DATABLOCK_SIZE
#define HDMI_IF_AUDIO_DATABLOCK_SIZE 3
#define HDMI_IF_SAD_MAX_DATA_BLOCK 10

#define UNITDELAY_000_0   0
#define UNITDELAY_001_4   4
#define UNITDELAY_010_8   8
#define UNITDELAY_011_12  12
#define UNITDELAY_100_16  16
#define UNITDELAY_101_20  20
#define UNITDELAY_110_24  24
#define UNITDELAY_111_28  28

typedef struct
{
    BOOL fgSet;
    UINT8 u1FormatNum;
    UINT8 au1AudDataBlock[HDMI_IF_AUDIO_DATABLOCK_SIZE*HDMI_IF_SAD_MAX_DATA_BLOCK];
}HDMI_IF_SAD_SET_DATA;
#endif

#define MAXIUcount 48
#define MAXUSERBITINDEX 48*8
#define ZERO_NUM_IU_DISTANCE   0

//clk
#define CBIT_SAMPLING_FREQ_22_0_5kHz_MASK       0x04
#define CBIT_SAMPLING_FREQ_44_1kHz_MASK         0x00
#define CBIT_SAMPLING_FREQ_88_2kHz_MASK         0x08
#define CBIT_SAMPLING_FREQ_176_4kHz_MASK        0x0C
#define CBIT_SAMPLING_FREQ_24kHz_MASK           0x06
#define CBIT_SAMPLING_FREQ_48kHz_MASK           0x02
#define CBIT_SAMPLING_FREQ_96kHz_MASK           0x0A
#define CBIT_SAMPLING_FREQ_192kHz_MASK          0x0E
#define CBIT_SAMPLING_FREQ_32kHz_MASK           0x03
#define CBIT_SAMPLING_FREQ_NOT_INDICATED_MASK   0x01
#define CBIT_SAMPLING_FREQ_768kHz_MASK          0x09

//channel
#define CBIT_NUMBER_CHANNEL_2_MASK              0x00 //same to commpressA
#define CBIT_NUMBER_CHANNEL_6_MASK              0x05
#define CBIT_NUMBER_CHANNEL_8_MASK              0x09
#define CBIT_NUMBER_CHANNEL_12_MASK             0xF9
#define CBIT_NUMBER_CHANNEL_16_MASK             0x0B
#define CBIT_NUMBER_CHANNEL_32_MASK             0x03
#define CBIT_NUMBER_COMPRESS_A_MASK             0xF0 //same to 2 channel
#define CBIT_NUMBER_COMPRESS_B_MASK             0x07

//bit length
#define CBIT_SAMPLE_LENGTH_default0_MASK        0x00
#define CBIT_SAMPLE_LENGTH_default1_MASK        0x01
#define CBIT_SAMPLE_LENGTH_20bit1_MASK          0x03
#define CBIT_SAMPLE_LENGTH_22bit_MASK           0x05
#define CBIT_SAMPLE_LENGTH_23bit_MASK           0x09
#define CBIT_SAMPLE_LENGTH_24bit_MASK           0x0B
#define CBIT_SAMPLE_LENGTH_21bit_MASK           0x0D
#define CBIT_SAMPLE_LENGTH_16bit_MASK           0x02
#define CBIT_SAMPLE_LENGTH_18bit_MASK           0x04
#define CBIT_SAMPLE_LENGTH_19bit_MASK           0x08
#define CBIT_SAMPLE_LENGTH_20bit0_MASK          0x0A
#define CBIT_SAMPLE_LENGTH_17bit_MASK           0x0C

//combination
#define CBIT_COMBINATIONS_FORMAT_MASK           0x3B
#define CBIT_COMBINATIONS_2CH_LPCM              0x00
#define CBIT_COMBINATIONS_MULTI_LPCM            0x20  //remove bit2
#define CBIT_COMBINATIONS_UNENCRYPTED           0x30
#define CBIT_COMBINATIONS_UNENCRYPTEDCOMPRESSED 0x02
#define CBIT_COMBINATIONS_ENCRYPTEDCOMPRESSED   0x0A
#define CBIT_COMBINATIONS_ENCRYPTEDMULTI_LPCM   0x2A
#define CBIT_COMBINATIONS_ENCRYPTED             0x3A

/* config with DE */
#define UTIL_DELAY_MAX                  28
#define UTIL_DELAY_DIFF_CNT             4
#define FREQ_METER_CM_CLK               0x00
#define FREQ_METER_DM_CLK               0x01
#define SYS_XTAL_CLK                    24

#define CAL_EARC_SRC_APLL2 0x5
#define EARC_AUD_FS_32K     1
#define EARC_AUD_FS_44P1K   2
#define EARC_AUD_FS_48K     3
#define EARC_AUD_FS_88P2K   4
#define EARC_AUD_FS_96K     5
#define EARC_AUD_FS_192K    6
#define EARC_AUD_FS_768K    7

#define EARC_CAPS_256_BYTE
#define HDMIEDID_SIZE_DEFAULT 256
#define EARC_CAP_SIZE_MAX     256
#define EARC_CAP_READ_0       120 /* 127 + 127 + 2 = 256, cann't config more than 64*2 read_num */
#define EARC_CAP_READ_1       136
#define EARC_CAP_READ_2       2
#define EARC_FIFO_SIZE_MAX    64  /* 64 byte */

/*-----------------------------------------------------------------------*/
/*-------------------    type define    ------------------------- */
/* Common Mode */
    /* eArc status and control */
#define EARC_DEV_ID_STA_CTL     0x74 //eArc status and control register
#define EARC_OFFSET_STA_CTL_RX  0xD0
#define EARC_OFFSET_STA_CTL_TX  0xD1
#define EARC_OFFSET_LATENCY_VAL 0xD2 //eArc Latency current value from eArc Rx; or Rx Adjust Delay after eARC Tx send Latency_Req
#define EARC_OFFSET_LATENCY_REQ 0xD3 //eArc Latency request by audio driver send to eARC Rx
    /* eArc Capability */
#define EARC_DEV_ID_CAP         0xA0 //eArc Capabilities Data Structure, ready only

#define earc_cap_read_available(val)    (val & (1<<3))  /* Get capability from Rx.   */
#define earc_latency_rx(val)            (val & (1<<4))  /* Get latency from eARC Rx. */

#define SW_HPD_ON  0x81
#define SW_HPD_OFF 0x80

#define EARC_INT_HB_LOST            (1<<24)
#define EARC_INT_HB_DONE            (1<<23)
#define EARC_INT_HB_ABORT           (1<<22)
#define EARC_PWR5V_FALLING          (1<<21)
#define EARC_PWR5V_RAISING          (1<<20)
#define EARC_SOFT_ECC_CNT_INT       (1<<19)
#define EARC_HPD_FALL               (1<<18)
#define EARC_HPD_RAISE              (1<<17)
#define EARC_INT_RSCV_PKT_ABORT     (1<<16)
#define EARC_INT_SEND_OK            (1<<15)
#define EARC_INT_RCV_OK             (1<<14)
#define EARC_INT_PHD_PHY_LOW        (1<<12)
#define EARC_INT_DISC_ABORT         (1<<11)
#define EARC_INT_SEND_FINISH        (1<<10)
#define EARC_INT_SEND_ABORT         (1<<9)
#define EARC_INT_RCV_FINISH         (1<<8)
#define EARC_INT_RCV_ABORT          (1<<7)
#define EARC_INT_SEND_LATCH_EMPTY_1 (1<<6)
#define EARC_INT_READ_NACK          (1<<5)
#define EARC_INT_RECV_LATCH_FULL_1  (1<<4)
#define EARC_INT_READ_RETRY         (1<<3)
#define EARC_INT_DETECT_COMMA       (1<<2)
#define EARC_INT_HEARTBEAT          (1<<1)
#define EARC_INT_TIMEOUT            (1<<0)

#define EARC_STAT_CHG              (1<<4)
#define EARC_CAP_CHG               (1<<3)

#define eARC_TIMER_PERIOD  5    // ms

enum EARC_MSG_ID {
    EARC_MSG_NONE = 0,
    EARC_MSG_SET_UI_OUTPUT,
    EARC_MSG_SET_UI_ENABLE,
    EARC_MSG_SET_ARC_STATUS,
    EARC_MSG_SET_HPD_STATUS,
    EARC_MSG_SET_BTHP_STATUS,
    EARC_MSG_INT_DISC_TIMEOUT,
    EARC_MSG_INT_5V_FALL,
    EARC_MSG_INT_5V_RISE,
    EARC_MSG_INT_HPD_FALL,
    EARC_MSG_INT_HPD_RISE,
    EARC_MSG_INT_DETECT_COMMA,
    EARC_MSG_INT_HB_LOST,
    EARC_MSG_CAP_PARSE,
    EARC_MSG_SET_AUDIO_PATH,
    EARC_MSG_MAX,
};

struct EARC_MSG {
    enum EARC_MSG_ID id;
    UINT32 u4Data;
};

typedef enum {
    SLEW_CTL_CM,
    SLEW_CTL_DM
} EARC_SLEW_CTL;

typedef enum
{
    EARC_TX_IDEL1 = 0,
    EARC_TX_DISC1_WAIT_COMMA,
    EARC_TX_DISC2_HEARTBEAT,
    EARC_TX_EARC_CONNECTED,
    EARC_TX_IDEL2,
    EARC_TX_H14B_ARC,
    EARC_TX_STATE_MAX,
}EARC_TX_STATE_E;


typedef enum
{
    EARC_HPD_LOW = 0,
    EARC_HPD_HIGH,
}EARC_HPD_STATE_E;

struct EARCAudCapability {
    UINT8 u1Capability;
    UINT8 u1AacLcCapability;
};

typedef enum{
    e_22_05_Khz = 0,
    e_44_1_khz = 1,
    e_88_2_Khz = 2,
    e_176_4_Khz = 3,
    e_24_Khz = 4,
    e_48_Khz = 5,
    e_96_Khz = 6,
    e_192_Khz = 7,
    e_32_Khz = 8,
    e_Sampleing_Frequency_Not_Indicated = 9,
    e_768_Khz = 10,
    e_705_Khz = 11,
    e_384_Khz = 12,
    e_352_Khz = 13,
    e_128_Khz = 14,
}eeARCclk;

typedef enum{
    e_0_16Bit = 0,
    e_0_18Bit = 1,
    e_0_19Bit = 2,
    e_0_20Bit = 3,
    e_0_17Bit = 4,

    e_1_20Bit = 5,
    e_1_22Bit = 6,
    e_1_23Bit = 7,
    e_1_24Bit = 8,
    e_1_21Bit = 9,
    e_default0,
    e_default1,
    e_word_length_not_indicated,
}eeARCBit;

typedef enum{
    e_2_channel = 0,
    e_6_channel_One_bit = 1,
    e_8_channel = 2,
    e_12_channel_One_bit = 3,
    e_16_channel = 4,
    e_32_channel = 5,
    e_Compressed_layout_A = 6,
    e_Compressed_layout_B = 7,
}eeARCChannel;

typedef enum{
    e_Unencrypted_2_channel_PCM = 0,
    e_Unencrypted_Multi_channel_PCM = 1,
    e_Unencrypted_format1 = 2, //Accroding 32,33,34,35
    e_Unencrypted_compressed = 3,
    e_Encrypted = 4,
    e_Encrypted_Multi_channel_LPCM = 5,
    e_Encrypted_format2 = 6,    //Accroding 32,33,34,35

}eeCombinations;

typedef struct{
    eeARCclk clk;
    eeARCBit bit;
    eeARCChannel channel;
    eeCombinations combinations;
}channelStatusStruct;

typedef enum
{
    SWITCH_EARC_OFF_ARC_ON  = 0,
    SWITCH_EARC_ON_ARC_OFF  = 1,
    SWITCH_EARC_ON_ARC_OFF2  = 2,
    SWITCH_EARC_OFF_ARC_OFF = 3,
    SWITCH_MAX          = 4
}eEarcSwitch;

typedef enum
{
    CAP_IN_CHG = 1,
    CAP_WAIT_TO_PARSE = 2,
    CAP_CHG_DONE = 3
}EARC_CAP_STATUS;


typedef struct
{
    BOOL fgEarcInit;
    EARC_TX_STATE_E u1EarcState;
    UINT8 u1WaitCommaCnt;
    BOOL fgStatusChg;
    BOOL fgParseStatus;
    BOOL fgCapChg; //whether capabilities data is in changing
    BOOL fgParseCap; //once capabilities data changed, set it to trigger mainloop parsing capabilities data
    BOOL fgRstHpd;
    BOOL bPre5VStatus;
    BOOL fgDelayReqArcInit;
    EARC_CAP_STATUS eCapStatus;
    UINT8 u1EarcId;
    UINT8 u1EarcOffset;
    UINT8 u1EarcNum;
    UINT8 u1EarcAbortCnt;
    UINT8 u1EarcRxLatency;
    UINT8 u1EarcWriteLatency;
    UINT8 u1EarcWriteLatencyData;
    UINT8 fgSet;
    UINT8 u1FormatNum;
    UINT8 uEnEarc;
    UINT8 uEnArc;
    UINT8 uEdidBackup;
    UINT8 au1CapData[256];
    UINT8 uEarcStatus;      //1: earc on,    0 earc off
    UINT8 uARCStatus;       //1: ARC on,     0 ARC off
    UINT8 uDiffStatus;      //1: diff on,    0 diff off
    UINT8 uSwHpdStatus;     //1: high,       0 low
    UINT8 uEdidHaveReplaced;//1:edid has replaced
    UINT8 uEarcTimeout;
    UINT8 uSetPhyHPDLow;
    UINT16 u1CapCounter;//how many capabilities data has been read.
}EARC_STATUS_T;

typedef struct
{
    UINT32 au4EarcReadData[16];
}EARC_READ_DATA_T;

typedef struct
{
    UINT32 au4EarcWriteData[4];
}EARC_WRITE_DATA_T;

typedef struct
{
    //CTA-861-G Descriptor
    UINT8 u1Cta861gDescOfs;
    UINT8 u1Cta861gDescLen;
    //Speaker Location Descriptor
    UINT8 u1SpkLocDescOfs;
    UINT8 u1SpkLocDescLen;
    //Audio Stream Layout
    UINT8 u1AudStmLayoutOfs;
    UINT8 u1AudStmLayoutLen;
    //Short Audio Descriptor
    UINT8 u1ShortAudDescOfs;
    UINT8 u1ShortAudDescLen;
    //Speaker Allocation Data Block
    UINT8 u1SpkAllocOfs;
    UINT8 u1SpkAllocLen;
}EARC_CAP_DATA_T;

typedef struct
{
    /* short audio data block */
    UINT16 sad_start_addr;
    UINT16 sad_end_addr;

    /* speaker allocation data block */
    UINT16 speaker_alloc_start_addr;
    UINT16 speaker_alloc_end_addr;

    /* speaker location data blcok */
    UINT16 speaker_loca_start_addr;
    UINT16 speaker_loca_end_addr;

    /* max size */

    /* padding */
    UINT8 padding_addr;
}EARC_EDID_ADDR;
/*-----------------------------------------------------------------------*/
/*-------------------    type declaration     ------------------- */
extern void vEarcSetStateMachine(UINT8 u1eARCSta);
extern void _vEarcDiffOnoff(UINT8 value);
extern void vTrigleEarc(void);
extern void vUpdateM5RawCapability(void);
extern void MenuesetEnabletest(BOOL bEn);
extern void _vEarcAudioFmtChg(BOOL value);
extern void _vEarcComAnaInit(void);
extern void _vEarcComDigitalInit(void);
extern BOOL _vEarcInit(void);
extern void vEarcRead(UINT8 u1Id, UINT8 u1Offset, UINT8 u1Num);
extern void _vAudIecClk(UINT8);
extern void _vEarcStatus(void);
extern BOOL vGetEarcRxLatency(UINT8* pEarcRxLatency);
extern BOOL vGetEarcCapData(HDMI_IF_SAD_SET_DATA* pEarcCapData);
extern void _vArcInit(void);
extern void vSetEarcLDDDP(UINT8 *pu1LDDP);
extern EARC_TX_STATE_E u1EarcGetStateMachine(void);
extern UINT8 u1GetCapDataNum(void);
extern void vGetEarcLDDDP(UINT8 *pu1LDDP);
extern BOOL vGetEarcCapRawData(void);
extern void vSetAudioChannelStatus(eeARCclk eClkValue,eeARCBit eBit, eeARCChannel eChannel,eeCombinations eCombination,UINT8 ca);
extern void vSetAudioMute(BOOL bValue);
extern BOOL vGetAudioMute(void);
extern void vSetAnalogReferenceApll2(BOOL bEn);
extern void setClk(UINT32 clk, BOOL ref_pll2);
extern void vHDMIEARCSuspend(void);
extern void vHDMIEARCResume(void);
extern void _vEarcAudioRst(UINT8 type, UINT8 value);
extern void vUpdateM5RawCapability(void);
extern void vSetSlewRate(void);
extern void vEARCEfuseUpdate(void);
extern void vArcEArcModeSwitch(UINT8 u1Mode);
extern void vWriteRightChannelStatus(channelStatusStruct structchannels);
extern void vWriteLeftChannelStatus(channelStatusStruct structchannels);
extern channelStatusStruct  uReadRightChannelStatus(void);
extern channelStatusStruct  uReadLeftChannelStatus(void);
extern void vSetLeftChannelStatusBit(unsigned int index,unsigned int bValue);
extern void vSetRightChannelStatusBit(unsigned int index,BOOL bValue);
extern int bGetLeftChannelStatusBit(unsigned int index);
extern int bGetRightChannelStatusBit(unsigned int index);
extern void vSendHDMI_HPD_trigle(void);
extern void vEarcTrigle(void);
extern void vEarcEnable(void);
extern void vArcEnable(void);
extern UINT8 uGetEarcEnableByte(void);
extern UINT8 uGetArcEnableByte(void);
extern UINT8 uSetEarcEnableByte(BOOL bValue);
extern void vByPassSlewRate(BOOL bValue);
extern void vEarcClrSetting(void);
extern void vEarcBackupEdid(UINT8 u1EdidType, UINT8* puEdidData, UINT16 u2Len);
extern void vEarcRestoreEdid(UINT8 u1EdidType, UINT8* puEdidData, UINT16 u2Len);
extern void vEARCWriteLatency(UINT8 latencyValue);
extern void vEarcMonitorSetting(BOOL value);
extern void vEarcWriteSWHpd(BOOL value);
extern void vEarcDiffSignalCtrl(BOOL value);
extern void vEarcSubLoop(void);
extern void vSimulateUserOperation(UINT8 arcValue,UINT8 eARCValue,UINT8 enable,UINT8 Tvstatus);
extern void vEarcPowerOff5vRst(void);
extern UINT8 GeteARCPortInfo(void);
extern UINT8 u1GetEarc5VStatus(void);
extern void vEARCParseCapData(UINT8* uEdidData, EARC_CAP_DATA_T* pCapData);
extern void vEARCDelayARCHandshake(void);
extern void vCECReqARCInit(void);
extern void vHDMIEARCTriggerHandshake(UINT8 u1Port,UINT8 u1force);
extern void vEarcHPDTrigger(UINT8 eHdmiPort, UINT8 u1force);

/*-----------------------------------------------------------------------*/
/*-----------------------------------------------------------------------*/
#endif
