/* SPDX-License-Identifier: GPL-2.0-only OR BSD-3-Clause */
/******************************************************************************
 *
 * This file is provided under a dual license.  When you use or
 * distribute this software, you may choose to be licensed under
 * version 2 of the GNU General Public License ("GPLv2 License")
 * or BSD License.
 *
 * GPLv2 License
 *
 * Copyright(C) 2019 MediaTek Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See http://www.gnu.org/licenses/gpl-2.0.html for more details.
 *
 * BSD LICENSE
 *
 * Copyright(C) 2019 MediaTek Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *  * Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *****************************************************************************/


#ifndef _DRV_FG_H_
#define _DRV_FG_H_
#include "fbm_drvif.h"

//////////////////////////////////////////////////////////////////////////////// 
// FW PORTING CFG , SHOULD BE REMOVE ON IC
// Data structure
//////////////////////////////////////////////////////////////////////////////// 
typedef enum
{
    E_CODECTYPE_MPV,
    E_CODECTYPE_MP4,
    E_CODECTYPE_H264,
    E_CODECTYPE_WMV,
    E_CODECTYPE_MJPEG,
    E_CODECTYPE_RV,
    E_CODECTYPE_AVS,
    E_CODECTYPE_VP6,
    E_CODECTYPE_VP8,
    E_CODECTYPE_RAW,
    E_CODECTYPE_OGG,
    E_CODECTYPE_JPG,
    E_CODECTYPE_PNG,
    E_CODECTYPE_H265,
    E_CODECTYPE_VP9,
    E_CODECTYPE_DV_H264,
    E_CODECTYPE_DV_H265,
    E_CODECTYPE_AVS2,
    E_CODECTYPE_SHVC,
    E_CODECTYPE_AV1,
    E_CODECTYPE_MAX
} FG_CODEC_TYPE_E;
typedef struct
{
    UINT32 u4Arg1;  // data type
    UPTR   u4Arg2;  //data address
    UINT32 u4Arg3;  //data size
    UINT32 u4Arg4;  //B2R Id
    UINT32 u4Arg5;  //for extend
} FG_MSG_T;

typedef struct
{
    UINT8 uApplyGrain;
    UINT16 u2GrainSeed;
    UINT8 uUpdateGrain;
    UINT8 uFilmGrainParamsRefIdx;  //not used by alg.
    UINT8 uNumYPoints;
    UINT8 uPointYValue[14];
    UINT8 uPointYScaling[14];
    UINT8 uChromaScalingFromLuma;
    UINT8 uNumCbPoints;
    UINT8 uPointCbValue[10];
    UINT8 uPointCbScaling[10];
    UINT8 uNumCrPoints;
    UINT8 uPointCrValue[10];
    UINT8 uPointCrScaling[10];
    UINT8 uGrainScaling;
    UINT8 uArCoeffLag;
    INT32 i4ArCoeffsY[24];
    INT32 i4ArCoeffsCb[25];
    INT32 i4ArCoeffsCr[25];
    UINT8 uArCoeffShift;
    UINT8 uGrainScaleShift;
    UINT8 uCbMult;
    UINT8 uCbLumaMult;
    UINT16 u2CbOffset;
    UINT8 uCrMult;
    UINT8 uCrLumaMult;
    UINT16 u2CrOffset;
    UINT8 uOverlapFlag;
    UINT8 uClipToRestrictedRange;
    UINT8 uMcIdentity;
    UINT8 uBitDepth;
    UINT8 uMonochrome;
}FG_VDEC_METADATA_INFO_T;

#pragma pack(push)
#pragma pack(1)
typedef struct
{
    UINT8 u1version;            // 1
    UINT16 u2length;            // 3
    UINT8 u1apply_grain;        // 4
    UINT8 u1update_grain;       // 5
    UINT8 u1num_y_points;       // 6
    UINT8 u1num_y_lut[14][2];   // 34
    UINT8 u1num_cb_points;      // 36
    UINT8 u1num_cb_lut[10][2];  // 55
    UINT8 u1num_cr_points;      // 56
    UINT8 u1num_cr_lut[10][2];  // 76
    UINT8 u1scaling_shift;      // 77
    UINT8 u1ar_coeff_lag;       // 78
    INT8 s1ar_coeff_y[24];      // 102
    INT8 s1ar_coeff_cb[25];     // 127
    INT8 s1ar_coeff_cr[25];     // 152
    UINT8 u1ar_coeff_shift;     // 153
    UINT8 u1cb_mult;            // 154
    UINT8 u1cb_luma_mult;       // 155
    UINT16 u2cb_offset;         // 157
    UINT8 u1cr_mult;            // 158
    UINT8 u1cr_luma_mult;       // 159
    UINT16 u2cr_offset;         // 161
    UINT8 u1overlap_flag;       // 162
    UINT8 u1clip_to_restricted_range; // 163
    UINT8 u1mc_identity;        // 164
    UINT8 u1bit_depth;          // 165
    UINT8 u1chroma_scaling_from_luma; // 166
    UINT8 u1grain_scale_shift;  // 167
    UINT16 u2random_seed;       // 169
    UINT8 u1monochrome;         // 170
} FG_ALG_METADATA_T;
#pragma pack(pop)

// Film Grain CTRL API
void vDrvFGSetDebugLvl(UINT32 u4FgDbgLvl, UINT16 u2FrameNum);
void vDrvSetFGEnable(BOOL bEnable);
void vDrvFGQuery(void);
//vDrvFGSet10BitMode: 10bit input, bEnable =1, 8bit input, bEnable=0
void vDrvFGSet10BitMode(UINT8 u1B2rId, BOOL bEnable);
void vDrvFGSetCodecType(UINT8 u1B2rId, FBM_VDEC_FMT_T u1CodecType);
void vFGMsg_SendEvent(FG_MSG_T tMsg);
void vDrvFGModechgdone(UINT8 u1Path);
void vDrvFGSWInit(void);
void vDrvFGHwInit(void);
void vDrvFGResume(void);
void vDrvFGTest(void);

#endif    // DRV_DI_H
