/*-----------------------------------------------------------------------------
 *
 * $Author$
 * $Date  $
 * $RCSfile: drv_hdmi.h,v $
 * $Revision$
 *
 *---------------------------------------------------------------------------*/
#ifndef _DRV_HDMICOM_H_
#define _DRV_HDMICOM_H_

#if defined(__KERNEL__)&&!defined(CC_UBOOT)
#include <linux/spinlock.h>
#endif


#define H_OK                          0x00000000
#define H_FALSE                       0x00000001

#define ISOK(hr)                      (hr >= 0)
#define ISFAIL(hr)                    (hr < 0)
#define SUCCEED(hr)                   ((hr >= 0)? 1: 0)

/***ERROR General usage***/
#define ERROR_OUTOFMEMORY                                               (0x80000000 | 0x00000002)
#define ERROR_BUFFER_OVERFLOW                                           (0x80000000 | 0x00000003)
#define ERROR_INSUFFICIENT_BUFFER                                       (0x80000000 | 0x00000004)
#define ERROR_BAD_FORMAT                                                (0x80000000 | 0x00000005)

#define ERROR_INVALID_PARAMETER                                         (0x80000000 | 0x00000006)
#define ERROR_INVALID_DATA                                              (0x80000000 | 0x00000007)
#define ERROR_NO_DATA                                                   (0x80000000 | 0x00000008)

#define ERROR_FILE_NOT_FOUND                                            (0x80000000 | 0x00000009)
#define ERROR_FILE_EXISTS                                               (0x80000000 | 0x0000000A)

#define ERROR_CANNOT_CREATE_FILE                                        (0x80000000 | 0x0000000B)
#define ERROR_SEM_NOT_FOUND                                             (0x80000000 | 0x0000000C)
#define ERROR_CODE_NOT_IMPLEMENTED                                      (0x80000000 | 0x0000000D)

#define ERROR_INVALID_DATA_LENGTH                                       (0x80000000 | 0x0000000E)

#define ERROR_CREATE_THREAD                                             (0x80000000 | 0x0000000F)
#define ERROR_GENERIC                                                   (0x80000000 | 0x00000010)


// HDCP usage
#define ERROR_LOAD_KEY                                                  (0x80000000 | 0x00010001)
#define ERROR_MSG_QUEUE_RECV                                            (0x80000000 | 0x00010002)
#define ERROR_MSG_QUEUE_SEND                                            (0x80000000 | 0x00010003)
#define ERROR_UNEXPECTED_STATE                                          (0x80000000 | 0x00010004)


#define ERROR_ENCRYPT_EKPUBKM                                           (0x80000000 | 0x00020001)
#define ERROR_COMPUTE_KD                                                (0x80000000 | 0x00020002)
#define ERROR_COMPUTE_HPRIME                                            (0x80000000 | 0x00020003)
#define ERROR_ENCRYPT_MASTER_KEY                                        (0x80000000 | 0x00020004)
#define ERROR_COMPUTE_L_PRIME                                           (0x80000000 | 0x00020005)
#define ERROR_COMPUTE_SESSION_KEY                                       (0x80000000 | 0x00020006)
#define ERROR_COMPUTE_NO_SOTREDKM                                       (0x80000000 | 0x00020007)
#define ERROR_COMPUTE_SOTREDKM                                          (0x80000000 | 0x00020008)
#define ERROR_COMPUTE_ENCRYPT_KM                                        (0x80000000 | 0x00020009)
#define ERROR_WRITE_STORED_KM                                           (0x80000000 | 0x0002000A)
#define ERROR_SELECT_STORED_KM                                          (0x80000000 | 0x0002000B)
#define ERROR_COMPUTE_H                                                 (0x80000000 | 0x0002000C)
#define ERROR_H_HPRIME_MISMATCH                                         (0x80000000 | 0x0002000D)
#define ERROR_VERIFY_CERT                                               (0x80000000 | 0x0002000E)
#define ERROR_COMPUTE_L                                                 (0x80000000 | 0x0002000F)
#define ERROR_L_LPRIME_MISMATCH                                         (0x80000000 | 0x00020010)
#define ERROR_MSBL_MSBLPRIME_MISMATCH                                   (0x80000000 | 0x00020011)
#define ERROR_ENCRYPT_SESSION_KEY                                       (0x80000000 | 0x00020012)
#define ERROR_GENERATE_RIV_KEY                                          (0x80000000 | 0x00020013)
#define ERROR_MAX_DEVS_EXCEEDED                                         (0x80000000 | 0x00020014)
#define ERROR_MAX_CASCADE_EXCEEDED                                      (0x80000000 | 0x00020015)
#define ERROR_COMPUTE_HDMI_V_TX                                         (0x80000000 | 0x00020016)
#define ERROR_VERIFY_MSB_V_TX                                           (0x80000000 | 0x00020017)
#define ERROR_MISMATCH_MSB_V_TX                                         (0x80000000 | 0x00020018)
#define ERROR_COMPUTE_STREAM_MANAGEMENT                                 (0x80000000 | 0x00020019)
#define ERROR_MISMATCH_STREAM_MANAGEMENT                                (0x80000000 | 0x0002001A)
#define ERROR_ROOL_OVER_SEQ_NUM_V                                       (0x80000000 | 0x0002001B)
#define ERROR_COMPUTE_HDMI_V                                            (0x80000000 | 0x0002001C)
#define ERROR_COMPUTE_M                                                 (0x80000000 | 0x0002001D)
#define ERROR_DOWNSTREAM_DEVICE_COUNT                                   (0x80000000 | 0x0002001E)
#define ERROR_COMPUTE_MIRACAST_V_TX                                     (0x80000000 | 0x0002001F)
#define ERROR_COMPUTE_HMAC_RIV                                          (0x80000000 | 0x00020020)
#define ERROR_HMAC_RIV_MISMATCH                                         (0x80000000 | 0x00020021)
#define ERROR_COMPUTE_KH                                                (0x80000000 | 0x00020022)


// HDMI usage
#define ERROR_PROCESS_CIPHER                                            (0x80000000 | 0x00025001)
#define ERROR_HDMI_FILL_CIPHER_KEY_TX                                   (0x80000000 | 0x00025002)
#define ERROR_HDMI_ENABLE_ENCRYPT_TX                                    (0x80000000 | 0x00025003)
#define ERROR_HDMI_INVALID_PORT_INDEX                                   (0x80000000 | 0x00025004)
#define ERROR_HDMI_INVALID_DEVICE_COUNT                                 (0x80000000 | 0x00025005)
#define ERROR_HDMI_SET_CONTENT_STREAM_TYPE                              (0x80000000 | 0x00025006)
#define ERROR_HDMI_INITIALIZE_HDMI_MODULE_TX                            (0x80000000 | 0x00025007)
#define ERROR_HDMI_SET_SKE_PASS_RX                                      (0x80000000 | 0x00025008)
#define ERROR_HDMI_INITIALIZE_HDMI_MODULE_RX                            (0x80000000 | 0x00025009)


// TEE usage
#define ERROR_OPEN_SESSION                                              (0x80000000 | 0x00050001)
#define ERROR_CLOSE_SESSION                                             (0x80000000 | 0x00050002)
#define ERROR_SET_FACSIMILE_SETTING                                     (0x80000000 | 0x00050003)
#define ERROR_OPEN_TEE_SERVICE                                          (0x80000000 | 0x00050004)
#define ERROR_CLOSE_TEE_SERVICE                                         (0x80000000 | 0x00050005)
#define ERROR_SECURE_READ                                               (0x80000000 | 0x00050006)
#define ERROR_GET_CERT_RX                                               (0x80000000 | 0x00050007)
#define ERROR_GET_LSB_V_TX                                              (0x80000000 | 0x00050008)
#define ERROR_SET_HDCP_VERSION                                          (0x80000000 | 0x00050009)
#define ERROR_SET_COMMON_SECURE_CONFIG                                  (0x80000000 | 0x0005000A)
#define ERROR_SET_MIRACAST_SECURE_CONFIG                                (0x80000000 | 0x0005000B)
#define ERROR_CREATE_DSCMB_SESSION                                      (0x80000000 | 0x0005000C)
#define ERROR_INIT_FRAME_BUFFER                                         (0x80000000 | 0x0005000D)
#define ERROR_SET_AES_KEY                                               (0x80000000 | 0x0005000E)
#define ERROR_SET_RIV                                                   (0x80000000 | 0x0005000F)
#define ERROR_SET_HDCP_TARGET                                           (0x80000000 | 0x00050010)
#define ERROR_GET_CONTENT_KEY                                           (0x80000000 | 0x00050011)


#define g_nHdcpHdmiRxPortCount         4

#define MSG_COUNT                      32

#define AKE_INIT_HDMI_SIZE             12
#define RTX_SIZE                       8
#define TX_CAPS_SIZE                   3
#define RRX_SIZE                       8
#define RX_CAPS_SIZE                   3
#define EKPUB_KM_SIZE                  128
#define EKH_KM_SIZE                    16
#define KM_SIZE                        16
#define m_SIZE                         16
#define H_PRIME_SIZE                   32
#define RN_SIZE                        8
#define L_PRIME_SIZE                   32
#define EDKEY_KS_SIZE                  16
#define MSBV_SIZE                      16
#define LSBV_SIZE                      16
#define MAX_RECEIVER_ID_LIST_SIZE      32
#define STATIC_STREAM_SIZE             16
#define M_SIZE                         32
#define M_PRIME_SIZE                   32
#define KD_SIZE                        32
#define KH_SIZE                        16
#define KS_SIZE                        16
#define RIV_SIZE                       8
#define HMAC_RIV_SIZE                  32
#define AES_KEY_SIZE                   16
#define AES_IV_SIZE                    16
#define MAX_LC_RETRY_TIMES             1023
#define SHA256_SIZE                    32
#define STORED_KM_HEADER_SIZE          32
#define STORED_KM_DATA_SIZE            48
#define STORED_KM_SIZE                 80
#define STORED_KM_FNAME_SIZE           (2*RECEIVER_ID_SIZE+4)
#define RX_STATUS_SIZE                 2
#define HDCP2_VERSION_SIZE             1
#define RXINFO_SIZE                    2
#define KS_XOR_LC128_SIZE              16


#define HEADER_SIZE                       4
#define LICENSED_CONSTANT_SIZE            16
#define SHA1_SIZE                         20
#define ROOT_PUBLIC_MODULUS_N_SIZE        384
#define ROOT_PUBLIC_EXPONENT_E_SIZE       1
#define RECEIVER_ID_SIZE                  5
#define DEVICE_PUBLIC_MODULUS_N_SIZE      128
#define DEVICE_PUBLIC_EXPONENT_E_SIZE     3
#define DCP_LLC_SIGNATURE_SIZE            384
#define P_SIZE                            64
#define Q_SIZE                            64
#define D_MOD_P_SIZE                      64
#define D_MOD_Q_SIZE                      64
#define Q_MOD_P_SIZE                      64
#define DEVICE_PUBLIC_CERTIFICATE_SIZE    522

//  Local Defines
#define HDCP22_MESSAGE_LENGTH_MAX        129U

// Msg Queue
#define MSQ_DATA_MAX_SIZE 1024

//Timeout
#define PAIRING_INFO_POLLING_DONE_TIMEOUT     400  // defined by MStar

//register define
#define TMDS_HDCP2_SOURCE_READ_OFFSET       130U


typedef enum
{
    C0 = 0,
    C1,
    C2,
    C3,
    C4
}EN_HDCP_FINITE_STATE_MACHINE_STATE;

typedef enum eHDMI_PORT_NO {
    HDMI_PORT_INIT = 0,
    HDMI_PORT_1,
    HDMI_PORT_2,
    HDMI_PORT_3,
    HDMI_PORT_4,
    HDMI_PORT_MAX
}E_HDMI_PORT_NUM;

typedef struct HDMI_HDCP22_PORT_INFO_T
{
    UINT8 u1HDMIPortId;           ///< Port ID should start from 1 which corresponds to HDMI "port 1".
    UINT8 u1Hdcp22PortId;         ///< HDCP22 Port ID
    BOOL bEnable;                 ///< HDMI Driver Port Enable
} HDMI_HDCP22_PORT_INFO_T;

HDMI_HDCP22_PORT_INFO_T _HDCPPortMapping[4] = {
//HDMI PortID,             HDCP22 PortID,                Enable
    {1,              HDMI_PORT_INIT,        TRUE},
    {2,              HDMI_PORT_1,           TRUE},
    {3,              HDMI_PORT_2,           TRUE},
    {4,              HDMI_PORT_3,           TRUE},
};

typedef enum
{
    Primal_State = 0,
    Null_message = 1,
    AKE_Init = 2,
    AKE_Send_Cert = 3,
    AKE_No_Stored_km = 4,
    AKE_Stored_km = 5,
    //AKE_Send_rrx = 6,
    AKE_Send_H_prime = 7,
    AKE_Send_Pairing_Info = 8,
    LC_Init = 9,
    LC_Send_L_prime = 10,
    SKE_Send_Eks = 11,
    HDMI_RxStatus = 21
}EN_HDCP_AUTHENTICATION_MESSAGE;


/*** protocol msg len ***/
const int MSG_LEN_HDMI[MSG_COUNT] =
{
    0,    //< Primal_State = 0
    0,    //< Null_message = 1,
    12,   //< AKE_Init = 2,
    534,  //< AKE_Send_Cert = 3,
    129,  //< AKE_No_Stored_Km = 4,
    33,   //< AKE_Stored_Km = 5,
    0,    //< AKE_Send_Rrx = 6,
    33,   //< AKE_Send_H_Prime = 7,
    17,   //< AKE_Send_Pairing_Info = 8,
    9,    //< LC_Init = 9,
    33,   //< LC_Send_L_Prime =10,
    25,   //< SKE_Send_Eks = 11,
    0,    //< RepeaterAuth_Send_ReceiverId_List = 12,
    0,    //< RTT_Ready = 13,
    0,    //< RTT_Challenge = 14,
    17,   //< RepeaterAuth_Send_Ack = 15,
    8,    //< RepeaterAuth_Stream_Manage = 16,
    33,   //< RepeaterAuth_Stream_Ready = 17,
    0,    //< Receiver_AuthStatus = 18,
    0,    //< AKE_Transmitter_Info = 19,
    0,    //< AKE_Receiver_Info = 20,
    3,    //< HDMI_RxStatus = 21,
    0,    //< = 22,
    0,    //< = 23,
    0,    //< = 24,
    0,    //< = 25,
    0,    //< = 26,
    0,    //< = 27,
    0,    //< = 28,
    0,    //< = 29,
    2,    //< = 30,
    0,    //< = 31,
};


typedef enum
{
    EN_HDCP_UNKNOWN = 0,
    EN_HDCP_IDLE,
    EN_HDCP_AUTH_FAIL,
    EN_HDCP_AUTH_SUCCESS,
    EN_HDCP_AUTH_PROCESSING,
    EN_HDCP_AUTH_MAX,

} EN_HDCP_STATUS;

typedef struct
{
    unsigned char bRx;
    unsigned char u8PortNumber;
    EN_HDCP_STATUS enHdcpStatus;

} ST_HDCP_STATUS;

typedef struct
{
    unsigned char u8ReceiverId[RECEIVER_ID_SIZE];
    unsigned char u8DevicePublicModulusN[DEVICE_PUBLIC_MODULUS_N_SIZE];
    unsigned char u8DevicePublicExponentE[DEVICE_PUBLIC_EXPONENT_E_SIZE];
    unsigned short u16Reserved2:4; //< must be 0x0> bit4
    unsigned short u16ProtocolDescriptor:4; //< possible values are 0x0 or 0x1> bit4
    unsigned short u16Reserved1:8; //< must be 0x00> bit8
    unsigned char u8DCP_LLC_Signature[DCP_LLC_SIGNATURE_SIZE];
} ST_HDCP_KEY_RX_DEVICE_PUBLIC_CERTIFICATE;

/***Msg queue***/
typedef struct stHdcpMsgElement
{
    struct stHdcpMsgElement *pstNext;
    unsigned char szText[MSQ_DATA_MAX_SIZE];
    int nSize;
} ST_HDCP_MSG_ELEMENT;

typedef struct
{
    ST_HDCP_MSG_ELEMENT *pstHead;
    ST_HDCP_MSG_ELEMENT *pstTail;
} ST_HDCP_MSG_QUEUE;


/*** Authentication Send/Receive Data Structure ***/
typedef struct
{
    unsigned char u8Rtx[RTX_SIZE];
    unsigned char u8TxCaps[TX_CAPS_SIZE];
} ST_HDCP_AKE_Init;

typedef struct
{
    ST_HDCP_KEY_RX_DEVICE_PUBLIC_CERTIFICATE stCertRx;
    unsigned char u8Rrx[RRX_SIZE];
    unsigned char u8RxCaps[RX_CAPS_SIZE];
} ST_HDCP_AKE_Send_Cert_HDMI;

typedef struct
{
    union
    {
        ST_HDCP_AKE_Send_Cert_HDMI stAkeCertHDMI;
    } uAkeCert;
} ST_HDCP_AKE_Send_Cert;

typedef struct
{
    unsigned char u8Ekpub_Km[EKPUB_KM_SIZE];
} ST_HDCP_AKE_No_Stored_km;

typedef struct
{
    unsigned char u8Ekh_Km[EKH_KM_SIZE];
    unsigned char u8m[m_SIZE];
} ST_HDCP_AKE_Stored_km;

typedef struct
{
    unsigned char u8Rrx[RRX_SIZE];
} ST_HDCP_AKE_Send_rrx;

typedef struct
{
    unsigned char u8H_Prime[H_PRIME_SIZE];
} ST_HDCP_AKE_Send_H_prime;

typedef struct
{
    unsigned char u8Ekh_Km[EKH_KM_SIZE];
} ST_HDCP_AKE_Send_Pairing_Info;

typedef struct
{
    unsigned char u8Rn[RN_SIZE];
} ST_HDCP_LC_Init;

typedef struct
{
    unsigned char u8L_Prime[L_PRIME_SIZE];
} ST_HDCP_LC_Send_L_prime;

typedef struct
{
    unsigned char u8Edkey_Ks[EDKEY_KS_SIZE];
    unsigned char u8Riv[RIV_SIZE];
    unsigned char u8HMAC_Riv[HMAC_RIV_SIZE];
} ST_HDCP_SKE_Send_Eks;

typedef struct
{
    unsigned char u8ReceiverId[RECEIVER_ID_SIZE];
} ST_HDCP_RECEIVER_ID;

typedef struct
{
    unsigned char u8StreamID;
    unsigned char u8Type;
} ST_HDCP_STREAMID_ELEMENT_HDMI;

typedef struct
{
    unsigned char u8Ready;
    unsigned char u8ReAuth;
} ST_HDCP_HDMI_RX_STATUS;


typedef struct
{
    unsigned char u8MsgId;
    union
    {
        ST_HDCP_AKE_Init                           AkeInit;
        ST_HDCP_AKE_Send_Cert                      AkeSendCert;
        ST_HDCP_AKE_No_Stored_km                   AkeNoStoredKm;
        ST_HDCP_AKE_Stored_km                      AkeStoredKm;
        ST_HDCP_AKE_Send_rrx                       AkeSendRrx;
        ST_HDCP_AKE_Send_H_prime                   AkeSendHprime;
        ST_HDCP_AKE_Send_Pairing_Info              AkeSendPairingInfo;
        ST_HDCP_LC_Init                            LcInit;
        ST_HDCP_LC_Send_L_prime                    LcSendLprime;
        ST_HDCP_SKE_Send_Eks                       SkeSendEks;
        ST_HDCP_HDMI_RX_STATUS                     HDMIRxStatus;
    } uData;
} __attribute__ ((packed)) ST_HDCP_MSG_FORMAT;


/***Into TZ info***/
typedef struct
{
    UINT8 u1PortNum;
    BOOL  fgSkePassEnable;
}HDCP22_INTO_TZ_SetSkePass_T;

typedef struct
{
    UINT8 u1PortNum;
    BOOL  fgInitModuleEnable;
}HDCP22_INTO_TZ_SetInitModule_T;

typedef struct
{
    UINT8 au1Ekpub_km[1024];
}HDCP22_INTO_TZ_SetMasterKeyNoStored_T;

typedef struct
{
    UINT8  au1Rtx[RTX_SIZE];
    UINT8  au1Rrx[RRX_SIZE];
    UINT32 Rtx_Len;
}HDCP22_INTO_TZ_SetIntegrity_T;

typedef struct
{
    UINT8  au1Hprime[H_PRIME_SIZE];
    UINT8  au1Rtx[RTX_SIZE];
    UINT8  au1RxCaps[RX_CAPS_SIZE];
    UINT8  au1TxCaps[TX_CAPS_SIZE];
}HDCP22_INTO_TZ_Compute_H_T;

typedef struct
{
    UINT8  au1m[m_SIZE]; // no use
}HDCP22_INTO_TZ_Compute_KH_T;

typedef struct
{
    UINT8  au1Ekh_km[EKH_KM_SIZE];
    UINT8  au1m[m_SIZE];
}HDCP22_INTO_TZ_GetEncryptKm_T;

typedef struct
{
    UINT8  au1m[m_SIZE];
    UINT8  au1Ekh_km[EKH_KM_SIZE];
}HDCP22_INTO_TZ_SetDecryptKm_T;

typedef struct
{
    UINT8  au1Lprime[L_PRIME_SIZE];
    UINT8  au1Rn[RN_SIZE];
    UINT8  au1Rrx[RRX_SIZE];
}HDCP22_INTO_TZ_GetCompute_L_T;

typedef struct
{
    UINT8  au1Edkey_ks[EDKEY_KS_SIZE];
    UINT8  au1Rtx[RTX_SIZE];
    UINT8  au1Rrx[RRX_SIZE];
    UINT8  au1Rn[RN_SIZE];
}HDCP22_INTO_TZ_SetComputeKs_T;

typedef struct
{
    UINT8  au1Ks[KS_SIZE]; //no use
}HDCP22_INTO_TZ_SetComputeKsXorLC128_T;

typedef struct
{
    UINT8  u1PortNum;
    UINT8  au1Riv[RIV_SIZE];
}HDCP22_INTO_TZ_SetProcessCipher_T;

typedef struct
{
    unsigned char bStoredKm;
    unsigned char bAkeInitSent;
    int nWatchDogTimer;
    EN_HDCP_FINITE_STATE_MACHINE_STATE enFsmMainState;
    EN_HDCP_AUTHENTICATION_MESSAGE enFsmSubState;
    EN_HDCP_STATUS enHdcpStatus;
    ST_HDCP_STATUS stHdcpStatus;

    // Authentication data
    ST_HDCP_KEY_RX_DEVICE_PUBLIC_CERTIFICATE stCertRx;
    unsigned char u8Rn[RN_SIZE];
    unsigned char u8Rtx[RTX_SIZE];
    unsigned char u8Rrx[RRX_SIZE];
    unsigned char u8TxCaps[TX_CAPS_SIZE];
    unsigned char u8RxCaps[RX_CAPS_SIZE];
    unsigned char u8Km[KM_SIZE];
    unsigned char u8m[m_SIZE];
    unsigned char u8H_Prime[H_PRIME_SIZE];
    unsigned char u8L_Prime[L_PRIME_SIZE];
    unsigned char u8Ekh_Km[EKH_KM_SIZE];
    unsigned char u8Edkey_Ks[EDKEY_KS_SIZE];
    unsigned char u8Riv[RIV_SIZE];
    unsigned char u8HMAC_Riv[HMAC_RIV_SIZE];
    unsigned char u8M[M_SIZE];
    unsigned char u8M_Prime[M_PRIME_SIZE];
    unsigned short u16DownstreamDeviceCount;
    unsigned short u16ContentStreamCount;

    // Receive message data
    ST_HDCP_SKE_Send_Eks stSkeEks;

    // HDMI usage
    unsigned char u8PortNumber;
#if defined(__KERNEL__)&&!defined(CC_UBOOT)
    spinlock_t SpinMsgLock;
    spinlock_t SpinAkeInitLock;
    HANDLE_T hHdcp22ThreadHdl;
    HANDLE_T hHdcp22Sema;
    HANDLE_T hWaitTimeSema;
#endif
    ST_HDCP_MSG_QUEUE *pstMsgQueue;
} ST_HDCP_CONTROL_DATA;



void vHdcpInit(void);
int sendI2cData(ST_HDCP_CONTROL_DATA *pstCtrlData, unsigned char *pu8Data, int nBufSize);
int sendData(ST_HDCP_CONTROL_DATA *pstCtrlData, ST_HDCP_MSG_FORMAT *pstMsg, int nLen);
void generateRandomData(unsigned char *pu8Data, int nDataLen);
int recv_SKE_Send_Eks(ST_HDCP_CONTROL_DATA *pstCtrlData, ST_HDCP_MSG_FORMAT *pstMsg);
int recv_LC_Init(ST_HDCP_CONTROL_DATA *pstCtrlData, ST_HDCP_MSG_FORMAT *pstMsg);
int recv_AKE_Stored_km(ST_HDCP_CONTROL_DATA *pstCtrlData, ST_HDCP_MSG_FORMAT *pstMsg);
int recv_AKE_No_Stored_km(ST_HDCP_CONTROL_DATA *pstCtrlData, ST_HDCP_MSG_FORMAT *pstMsg);
int recv_AKE_Init(ST_HDCP_CONTROL_DATA *pstCtrlData, ST_HDCP_MSG_FORMAT *pstMsg);
int recvI2cData(ST_HDCP_CONTROL_DATA *pstCtrlData, unsigned char *pu8Data, int *pnBytesRead);
int dispatchMsg(ST_HDCP_CONTROL_DATA *pstCtrlData, ST_HDCP_MSG_FORMAT *pstMsg);
int do_AuthProcessRx(ST_HDCP_CONTROL_DATA *pstCtrlData);
int send_LC_Send_L_prime(ST_HDCP_CONTROL_DATA *pstCtrlData);
int send_AKE_Send_Pairing_Info(ST_HDCP_CONTROL_DATA *pstCtrlData);
int send_AKE_Send_H_prime(ST_HDCP_CONTROL_DATA *pstCtrlData);
int send_AKE_Send_Cert(ST_HDCP_CONTROL_DATA *pstCtrlData);
int enableHdmiSkePassRx(unsigned char u8PortNumber, unsigned char bEnable);
void vHdcp22Mainloop(ST_HDCP_CONTROL_DATA *pstCtrlData);
void vHdcp22FetchMsg(UINT8 u1Port, UINT8* pu1MsgData, UINT32 dwDataLen);
void vHdcp22ClearMsgLen(UINT32);
UINT32 u4Hdcp22GetMsgSize(UINT32 dwBKOffset);
void vHdcp22IsrHandler(UINT8 u1Port);
void vHdcp22Thread( void * pvArgs );
void vHdcp22Init(void);
int vHdcp22_msg_q_create(ST_HDCP_MSG_QUEUE **ppstMsgQueue);
int vHdcpMsgQueueDestory(ST_HDCP_MSG_QUEUE **ppstMsgQueue);
int bHdcpMsgQueueEmpty(ST_HDCP_MSG_QUEUE *pstMsgQueue);
int hdcpMsgQueuePop(ST_HDCP_MSG_QUEUE *pstMsgQueue, unsigned char *szText, int *pnSize);
int u4hdcp22MsgQueuePush(ST_HDCP_MSG_QUEUE *pstMsgQueue, unsigned char *szText, int nSize);
int hdcpMsgQueuePrint(ST_HDCP_MSG_QUEUE *pstMsgQueue);
int initHdmiModuleRx(unsigned char u8PortNumber, unsigned char bEnable);
int initHdcp(ST_HDCP_CONTROL_DATA *pstCtrlData);
void dumpHexValue(unsigned char *pu8HexVal, unsigned int nLen);
void WaitForMsec(ST_HDCP_CONTROL_DATA *pstCtrlData, UINT32 TimeVal);
BOOL bHdcp22_PollingReadDone(UINT8 ucPortIdx);
BOOL bHdcp22_PollingWriteDone(UINT8 ucPortIdx);
void vHdcp22ByPortInit(UINT8 ucPortIdx);
E_HDMI_PORT_NUM u1Hdcp22PortMapping(E_HDMI_PORT_NUM ePort);
BOOL fgHDCP22SwIsValidPort(E_HDMI_PORT_NUM ePort);
void vHdcp22_SetReadyBit(UINT8 ucPortIdx, BOOL bIsReady);
void vHdcp22_SetReAuthBit(UINT8 ucPortIdx, BOOL bEnReAuth);
void vHdcp22_SendMsg(UINT8 ucPortIdx, UINT8* pucData, UINT32 dwDataLen);
void vHDCP22_PortInit(UINT8 ucPortIdx);
void vHDCP_WriteDoneInterruptEnable(UINT8 ucPortIdx, UINT8 bEnableIRQ);
int HCS_SetSkePass_Rx(unsigned char u1PortIdx, unsigned char bEnable);
int HCS_SetInitModule_Rx(unsigned char u1PortIdx, unsigned char bEnable);
int HCS_GetRxCert(unsigned char *pRxCert, unsigned int u32Length);
int HCS_SetMasterKeyNoStored(unsigned char *pEkpub_km);
int HCS_SetIntegrityKey(unsigned char *pu1Rtx, unsigned char *pu1Rrx, unsigned int Rtx_Len);
int HCS_GetComputeH(unsigned char *pu1Hprime, unsigned char *pu1Rtx, unsigned char *pu1RxCaps, unsigned char *pu1TxCaps);
int HCS_SetCompute_Kh(void);
int HCS_GetEncryptKm_UsingKh(unsigned char *pEkh_km, unsigned char *pm);
int HCS_SetDecryptKm_UsingKh(unsigned char *pm,unsigned char *pEkh_km);
int HCS_GetComputeL(unsigned char *pu1Lprime, unsigned char *pu1Rn, unsigned char *pu1Rrx);
int HCS_SetComputeKs(unsigned char *pu1Edkey_ks,unsigned char *pu1Rtx, unsigned char *pu1Rrx, unsigned char *pu1Rn);
int HCS_SetCompute_KsXorLC128(void);
int HCS_SetProcessCipherRx(unsigned char u1PortIdx, unsigned char *pu1RIV);



#endif

