/* SPDX-License-Identifier: LGPL-2.1-only OR BSD-3-Clause */
/******************************************************************************
 *
 * This file is provided under a dual license.  When you use or
 * distribute this software, you may choose to be licensed under
 * version 2.1 of the GNU Lesser General Public License
 * ("LGPLv2.1 License") or BSD License.
 *
 * LGPLv2.1 License
 *
 * Copyright(C) 2019 MediaTek Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2.1 of the GNU Lesser General Public
 * License as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See https://www.gnu.org/licenses/old-licenses/lgpl-2.1.html for more
 * details.
 *
 * BSD LICENSE
 *
 * Copyright(C) 2019 MediaTek Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *  * Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *****************************************************************************/


/*-----------------------------------------------------------------------------
 * Copyright (c) 2005, MediaTek, Inc.
 * All rights reserved.
 *
 * Unauthorized use, practice, perform, copy, distribution, reproduction,
 * or disclosure of this information in whole or in part is prohibited.
 *-----------------------------------------------------------------------------
 *
 * $Author: binghe.li $
 * $Date: 2016/05/12 $
 * $RCSfile: drv_mjc_hw.h $
 * $Revision: #8 $
 *
 *----------------------------------------------------------------------------*/

#ifndef _DRV_MJC_HW_H_
#define _DRV_MJC_HW_H_

/*----------------------------------------------------------------------------*
 * Header Files
*----------------------------------------------------------------------------*/
#include "typedef.h"
#include "feature.h"



/*====================End  Header Files ============================*/

/*----------------------------------------------------------------------------*
 * Definitions
 *----------------------------------------------------------------------------*/
#define MJC_REG_TBL_END 0xffffffff


typedef struct 
{	
    UINT32 u4Reg;	
    UINT32 u4Value;	
    UINT32 u4Mask;
} MJCREGTBL_T;

//mt5887
typedef enum {
    MODULE_IPM_L=0,
    MODULE_OPM_MI_F2_L=1,
    MODULE_OPM_ME_F2F3_L=2,
    MODULE_OPM_MI_F3_L=3,
    MODULE_OPM_L=4, 
    MODULE_IPM_R=5,
    MODULE_OPM_MI_F2_R=6,
    MODULE_OPM_ME_F2F3_R=7,
    MODULE_OPM_MI_F3_R=8,
    MODULE_OPM_R=9,
} MJC_MODULE_SEL; 

typedef enum {
    IPM_COMPRESS_6BITS=0,
    IPM_COMPRESS_8BITS=1,
    IPM_COMPRESS_10BITS=2,
} IPM_COMP_MODE_SEL; 

enum
{
    MJC_COLORTRANS_YCBCR601L_2_YCBCR601L = 0,    //0: YCbCr601(Limit) -> YCbCr601(Limit)
    MJC_COLORTRANS_YCBCR601F_2_YCBCR601L,        // 1:YCbCr601(Full) -> YCbCr601(Limit)
    MJC_COLORTRANS_YCBCR709L_2_YCBCR601L,        // 2:YCbCr709(Limit) -> YCbCr601(Limit)
    MJC_COLORTRANS_YCBCR709F_2_YCBCR601L,        // 3: YCbCr709(Full) -> YCbCr601(Limit)
    MJC_COLORTRANS_BT2020CL_2_BT2020CL,          // 4  BT2020C Limit -> BT2020 Limit
    MJC_COLORTRANS_BT2020CF_2_BT2020CL,          // 5 BT2020C Full -> BT2020 Limit
    MJC_COLORTRANS_BT2020L_2_YCBCR601L,          // 6   BT2020 Limit -> YCbCr601(Limit)
    MJC_COLORTRANS_BT2020F_2_YCBCR601L,          // 7  BT2020 Full -> YCbCr601(Limit)
    MJC_COLORTRANS_RGBL_2_YCBCR601L,            // 8    RGB(Limit) -> RGB (Full)
    MJC_COLORTRANS_RGBF_2_YCBCR601L,       // 9    RGB(Full) -> YCbCr601(Limit)
    MJC_COLORTRANS_BT2020_RGBL_2_BT2020_NCL_L, // 10  BT2020 RGB(Limit) -> BT2020_NCL_YUV(Limit)
    MJC_COLORTRANS_BT2020_RGBF_2_BT2020_NCL_L, // 11  BT2020 RGB(Full) -> BT2020_NCL_YUV(Limit)
    MJC_COLORTRANS_MAX
};

/*====================End  Definitions ============================*/
/*----------------------------------------------------------------------------*
 * Global/Static variables
 *----------------------------------------------------------------------------*/



/*====================End Global/Static variables =====================*/

/*----------------------------------------------------------------------------*
 * Function Members
 *----------------------------------------------------------------------------*/ 
void vDrvMJCSetClockEN(UINT8 u1COnOff);
void vDrvMJCSetMiuClockSel(UINT8 u1MiuClkSel);
void vDrvMJCIpCLKSel(UINT8 u1MjcIpClkSel);
void vDrvMJCIp2xCLKSel(UINT8 u1MjcIpClkSel);
void vDrvMJCR2ClockSel(UINT8 u1R2clkSel);



UINT8 u1DrvMJCGetOnOffStatus(void);


void vDrvMJCSetOutputPattern(UINT8 u1OnOff, UINT8 u1Mode, UINT8 u1FreeRun);
void vDrvMJCSetInputPattern(UINT8 u1OnOff, UINT8 u1Mode, UINT8 u1FreeRun);

//if mt5887
void MHal_Cpu_SetRegBaseAddr(UINT8 u1RiscSel,UINT32 u4IoBaseAddr);
void MHal_Cpu_SetUARTBaseAddr(UINT8 u1RiscSel,UINT32 u4IoBaseAddr);
void MHal_Cpu_SetRegR2En(UINT8 u1RiscSel,UINT8 u8val);
void MHal_Cpu_SetRegR2SdrAddr(UINT8 u1RiscSel,UINT32 u4SdrAddr);
void MHal_Cpu_R2QmemCtrl(UINT8 u1RiscSel,UINT8 u1QmemCtrl);
void MHal_Cpu_SetRegR2QmemAddr(UINT8 u1RiscSel, UINT32 u4QmemAddr);
void vDrvSetMjcIpmPten(UINT8 fgCtrl, UINT16 u2Width,UINT16 u2Height);
void vDrvSetMjcTestPtenGen(UINT8 fgCtrl, UINT16 u2Width,UINT16 u2Height);
void vDrvWriteMailBoxCmdtoMJC(UINT32 u4Addr,UINT16 u2CmdVal);
void vDrvEnableIRQToMJC(UINT8 u1IntSrc,UINT8 u1Polarity,UINT8 u1Ctrl);
void vDrvTriggerIRQToMJC(UINT32 u4IntNumber);
void vDrvClrIRQFromMJC(UINT32 U4ClrIntNumber);
void vDrvARMToR20_FIQ(UINT8 u1Ctrl);
void vDrvTriggerFIQToR20(void);


void vDrvMjcMemc(UINT8 fgCtrl);
void vDrvMjcEnableML(void);
void vDrvMjcRGBBypass(UINT8 fgOnOff);
void vDrvMjcMiuInitial( void );
void vDrvMjcIpmConfig(UINT8 fgImageMode);
void vDrvMjcLineOffset(MJC_MODULE_SEL eModuleSel,UINT16 u2LineOffset);
void vDrvMjcLineFetch(MJC_MODULE_SEL eModuleSel,UINT16 u2LineFetch);
//FBM INIT
void vDrvMjcBaseAddr(MJC_MODULE_SEL eModuleSel,UINT32 u4IpmBaseAddr);
void vDrvMjcMedsAddr_L(MJC_MODULE_SEL eModuleSel, UINT32 u4MedsBaseAddr);
void vDrvMjcMedsAddr_R(MJC_MODULE_SEL eModuleSel, UINT32 u4MedsBaseAddr);
void vDrvMemcX1S1Addr(UINT32 u4X1BaseAddr);
void vDrvMemcX2Y2F2S2WrAddr(UINT32 u4X2BaseAddr);
void vDrvMemcX2Y2F2S2RdAddr(UINT32 u4X2BaseAddr);
void vDrvMemcLOGOAddr(UINT32 u4LOGOBaseAddr);
void vDrvMemcHRWrAddr(UINT32 u4HrBaseAddr);
void vDrvMemcHRRdAddr(UINT32 u4HrBaseAddr);
void vDrvMemcHR23WrAddr(UINT32 u4HrBaseAddr);
void vDrvMemcHR23RdAddr(UINT32 u4HrBaseAddr);
void vDrvMemcDEFLICKERAddr(UINT32 u4DEFLICKERBaseAddr);
void vDrvMemcOSDYSAddr(UINT32 u4OSDYSBaseAddr);

void vDrvMjcIpmFifoDepth( UINT16 u2WFifo, UINT16 u2RFifo );
void vDrvMjcIpmForceAck( UINT16 fgAckCtrl );
void vDrvMjcIpmCompressMode( IPM_COMP_MODE_SEL eComPressMode );
void vDrvMjcOpmMiuCtrl( UINT8 fgMiuCtrl );
void vDrvMjcPipeLineCtrl(UINT16 u2PipeWidth, UINT16 u2PipeHeight);
void vDrvMjc444To422Ctrl(UINT8 fgCtrl);

void vDrvMjcInOutVTrigLine( UINT16 u2InVLine,UINT16 u2OutVLine );
void vMemcTopSetPatternAngle(UINT8 u1Angle);
void vMemcTopSetPatternGenEnable(UINT8 bOnOff);
void vMemcTopSetPatternGenYPat2(UINT8 u1Ypat2);
void vMemcTopSetPatternGenYPat1(UINT8 u1Ypat1);
void vMemcTopSetPatternGenDutyCycle(UINT8 u1DutyCycle);
void vMemcTopSetPatternColorMode(UINT8 u1ColorMode);
void vMemcTopSetPatternPatternMode(UINT8 u1PatternMode);
void vMemcTopSetPatternPattenLeftSide(UINT8 bLeftSide);
void vMemcTopSetPatternFreeRun(UINT8 bOnOff, UINT8 u1FreeRun);
void vMemcTopSetPatternBond(UINT8 bOnOff);

void vDrvMjcLevelCtrl(UINT8 u1MjcLevelCtrl);
void vDrvMjcDeBlur(UINT8 u1MjcDeBlur);
void vDrvMjcDeJudder(UINT8 u1MjcDeJudder);
void vMjcCadenceSupportMode(void);
UINT16 vDrvReadMailBoxCmdSts(UINT8 u1Offset);
void vDrvPscMjcDataSwap(UINT8 u1PscSwap, UINT8 u1MjcPreDataSwap);
void vDrvMJCSetMuxToOSTG(UINT8 u1Sel);

UINT32 u4DrvMemcGetRDIndex(void);
UINT32 u4DrvMemcGetWRIndex(void);
void vDrvMJC_SetColorFormat(UINT8 u1ExtEn,UINT8 u1MatriIdx);

/*====================End  Function Members =======================*/

#endif
