#ifndef __DRV_TECH_HDR_INT_H__
#define __DRV_TECH_HDR_INT_H__

#include "general.h"
#include "hw_sw.h"
//#include "hw_techni.h"

#define YUV_FULL_RANGE    1
#define YUV_LIMITED_RANGE 0

#define BT1886 0
#define PQ     1
#define LINEAR 2

typedef struct sl_hdr_metadata_variables {

  INT32 tmInputSignalBlackLevelOffset;
  INT32 tmInputSignalWhiteLevelOffset;
  INT32 shadowGain;
  INT32 highlightGain;
  INT32 midToneWidthAdjFactor;
  INT32 tmOutputFineTuningNumVal;
  INT32 tmOutputFineTuningX[10];
  INT32 tmOutputFineTuningY[10];
  INT32 saturationGainNumVal;
  INT32 saturationGainX[6];
  INT32 saturationGainY[6];
}sl_hdr_metadata_variables;

typedef struct sl_hdr_metadata_tables {
  INT32 luminanceMappingNumVal;
  INT32 luminanceMappingX[65];
  INT32 luminanceMappingY[65];
  INT32 colourCorrectionNumVal;
  INT32 colourCorrectionX[65];
  INT32 colourCorrectionY[65];
}sl_hdr_metadata_tables;

typedef struct sl_hdr_metadata{
  INT32 partID;
  INT32 majorSpecVersionID;
  INT32 minorSpecVersionID;
  INT32 payloadMode;
  INT32 hdrPicColourSpace;
  INT32 hdrDisplayColourSpace;
  INT32 hdrDisplayMaxLuminance;
  INT32 hdrDisplayMinLuminance;
  INT32 sdrPicColourSpace;
  INT32 sdrDisplayColourSpace;
  INT32 sdrDisplayMaxLuminance;
  INT32 sdrDisplayMinLuminance;
  INT32 matrixCoefficient[4];
  INT32 chromaToLumaInjection[2];
  INT32 kCoefficient[3];
  union
  {
    struct sl_hdr_metadata_variables variables;
    struct sl_hdr_metadata_tables tables;
  }u;
}sl_hdr_metadata;

/********************************** TECHNICOLOR HDR  ****************************************/
/*****************************************************************************************/

extern void Fill_MetadataRecovery(struct sl_hdr_metadata *sl_hdr_metadata, INT32 TargetDisplayLuminance, INT32 colour_primaries, INT32 transfer_characteristics);
extern void Compute_LUTs(struct sl_hdr_metadata *sl_hdr_metadata, INT32 TargetDisplayLuminance, INT32 yuv_range, UINT16 *mu0, UINT16 *mu1, INT32 *OCT, UINT16 *C_LUT, UINT16 *P_LUT, INT32 *inv_y_ratio, INT32 *inv_chroma_ratio, INT32 *footroom, INT32 *l_headroom, INT32 *c_headroom);
extern void Compute_C_LUT(struct sl_hdr_metadata *sl_hdr_metadata, INT32 TargetDisplayLuminance, INT32 cc_shift, UINT16 *C_LUT);
extern void Compute_P_LUT(struct sl_hdr_metadata *sl_hdr_metadata, INT32 TargetDisplayLuminance, INT32 mapy_cl, UINT16 *P_LUT);
extern void Fill_D_LUT(struct sl_hdr_metadata *sl_hdr_metadata, INT32 curve, INT32 TargetDisplayLuminance,UINT16 *D_LUT, UINT16 *D_LUT_THRESHOLD, UINT16 *D_LUT_STEP);

extern void Fill_S_LUT(UINT16 *LUT);

extern void Fill_I_LUT(UINT16 *LUT);
void vDrvTechniHDRWriteILUTs(void);
void vDrvTechniHDRWriteSLUTs(void);
void vDrvTechniHDRWriteOCT(void);
void vDrvTechniHDRWriteRange(void);
void vDrvTechniHDRWriteMu0Mu1(void);
void vDrvTechniHDRWriteColorSpace(void);
void vDrvTechniHDRRGB2YUV(void);
void vDrvTechniHDRWriteCLUTs(void);
void vDrvTechniHDRWriteDLUTs(void);
void vDrvTechniHDRWriteDStepThld(void);
void vDrvTechniHDRWritePLUTs(void);
#endif
