/* SPDX-License-Identifier: LGPL-2.1-only OR BSD-3-Clause */
/******************************************************************************
 *
 * This file is provided under a dual license.  When you use or
 * distribute this software, you may choose to be licensed under
 * version 2.1 of the GNU Lesser General Public License
 * ("LGPLv2.1 License") or BSD License.
 *
 * LGPLv2.1 License
 *
 * Copyright(C) 2019 MediaTek Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2.1 of the GNU Lesser General Public
 * License as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See https://www.gnu.org/licenses/old-licenses/lgpl-2.1.html for more
 * details.
 *
 * BSD LICENSE
 *
 * Copyright(C) 2019 MediaTek Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *  * Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *****************************************************************************/

/*-----------------------------------------------------------------------------
 *
 * $Author: victor.zhuo $
 * $Date: 2016/07/16 $
 * $RCSfile: drv_tnri.h,v $
 * $Revision: #1 $
 *
 *---------------------------------------------------------------------------*/
/** @file drv_tnr.h
 *  Brief of file drv_tnr.h.
 *  Details of file drv_tnr.h (optional).
 */

#ifndef DRV_TNR_H
#define DRV_TNR_H

//////////////////////////////////////////////////////////////////////////////// 
// Include files
//////////////////////////////////////////////////////////////////////////////// 

#include "x_typedef.h"
#include "general.h"
#include "feature.h"
#include "drv_tdtv_drvif.h"
#include "vdp_if.h"
#include "vdo_rm.h"
////////////////////////////////////////////////////////////////////////////////
// FW PORTING CFG , SHOULD BE REMOVE ON IC
////////////////////////////////////////////////////////////////////////////////


#define TNR_READ_FLD(u2Addr, u4Fld) \
     IO32ReadFldAlign(u2Addr, u4Fld)

//#ifndef LOG_MDDI_REG
#define TNR_WRITE_FLD(u2Addr, u4Value, u4Fld) \
    vIO32WriteFldAlign(u2Addr, u4Value, u4Fld)

#define TNR_WRITE32_MSK(u2Addr, u4Value,  u4Msk) \
    vIO32Write4BMsk(u2Addr, u4Value, u4Msk)
//#else
//void TNR_WRITE_FLD(UINT8 u1VdpId, UINT16 u2Addr, UINT32 u4Value, UINT32 u4Fld);
//void TNR_WRITE32_MSK(UINT8 u1VdpId, UINT16 u2Addr, UINT32 u4Value, UINT32 u4Msk);
//#endif


#define TNR_SET_RES_CNT_DOWN 40
#define TNR_CLOCK 648000000

typedef struct {
    UINT8 u1OnOff;
    UINT8 u18bit;
    UINT8 u1fg422;
    UINT16 u2BufWidth;
    UINT16 u2BufHeight;
    UINT32 u4BufSize;
    UINT32 u4BufAddr;
    UINT8 u1IsUFO;
    UINT8 u1HFRMode;
    UINT8 u1HFRFactorM;
    UINT8 u1HFRFactoryN;
    UINT32 u4Update; 
}TNR_STATIC_STATE;

typedef struct
{
    UINT16 u2Width;
    UINT16 u2Height;
}TNR_SET_RES_STATE;

typedef struct
{
    UINT8 u1SetResCnt;
}TNR_DYN_VAR;
//global variable which doesn't cuse modechange or set resolution


/**
 * @brief TNR SRM callback function
 * @param u4Arg1 VDP_1/VDP_2
 * @param u4Arg2 configuration
 * @param u4SramMode sram mode
 */
void vDrvTNRSrmCb(UINT32 u4VdpId, UINT32 u4SrmMode, UINT32 u4PDSize, UINT32 u4TDTV);


/**
 * @brief Initialize PSCAN register values
 * @param u1VdpId VDP_1/VDP_2
 */
void vDrvTNRSwInit(void);
void vDrvTNRHwInit(void);
void vDrvTNRSetLBitMode(void);
void _vDrvTNRSetLBitMode(UINT8 u18bit);
void vDrvTNRSetFrameBuf(void);
void vDrvTNRSetMIBModeChangeFlag(UINT8 u1OnOff);
void vDrvTNRSwitch(UINT8 u1OnOff);

void vDrvTNRSwInit(void);
void vDrvTNRHwInit(void);
void vDrvNRSetMDPTNROnOff(UINT8 u1OnOff);
void vDrvNRSetMDPTNRParam(void);
#ifdef CC_MAPLE_CUST_DRV
void vDrvNRSetMDPTNRParam_Cust(void);
#endif
void vDrvTNRSetDemoRange(UINT8 bOnOff, UINT8 bRegion, UINT16 wXCenter);
void vDrvTNRSetForceBypass(BOOL fgBypass);
void vDrvTNRPQISR(void);

UINT8 vDrvIsTnrOnoff(void);

void vDrvTNRSetHFRMode(UINT8 u1OnOff);
void vDrvTNRSetBldFactor(UINT8 u1M, UINT8 u1N);


#ifdef CC_SUPPORT_STR
//-----------------------------------------------------
//
// MIB ( DI/NR ) 
// added for MIB suspend/resume  function
//-----------------------------------------------------
void vDrvTNRSuspend(void);
void vDrvTNRResume(void);
#endif

void vDrvTNRSetDoubleBuffer(UINT8 u1OnOff);
void vDrvTNRSetClkReset(UINT8 u1OnOff);

void vDrvTNRSetDramCtrl(UINT8 u1OnOff);
void vDrvTNRSetParam(void);
void vDrvTNRResolutionSetting(UINT8 u1TNROnOff);

UINT8 u1DrvTNRModeChange(void);

void vDrvTNRLoopRoutine(void);
int vDrvTnrEnSetChg(void);


#endif    // DRV_TNR_H
