#include "x_hal_5381.h"

//----------------------Analog --------------------------------------------
//#define IO_ANA_EARC_BASE        (IO_VIRT+0x12029000)
#define IO_ANA_EARC_BASE        (0 + 0x12029000)
#define RG_EARC_MODE Fld(1,1,AC_MSKB0)  //[1:1]

//Page ANA_EARC
#define RG_REG_EARC_CFG0 (IO_ANA_EARC_BASE + 0x000)
    #define RG_EARC_BIAS_EN Fld(1,31,AC_MSKB3)//[31:31]
    #define RG_EARC_TX_DM_EN Fld(1,30,AC_MSKB3)//[30:30]
    #define RG_EARC_TX_CM_EN Fld(1,29,AC_MSKB3)//[29:29]
    #define RG_EARCRX_CMRX_HPF_EN Fld(1,28,AC_MSKB3)//[28:28]
    #define RG_EARC_TERM_300_EN Fld(1,27,AC_MSKB3)//[27:27]
    #define RG_EARC_COMP_EN Fld(1,26,AC_MSKB3)//[26:26]
    #define RG_EARC_CM_CS_CTRL  Fld(5,19,AC_MSKB2) //[23:19]
    #define RG_EARC_TERM_EN      Fld(1,18,AC_MSKB2)//[18:18]
    #define RG_EARC_DM_CS_CTRL   Fld(5,11,AC_MSKB1)//[15:11]
    #define RG_EARC_ZSEL         Fld(5,3,AC_MSKB0) //[7:3]
    #define RG_EARC_EN_DA_MODE   Fld(1,2,AC_MSKB0) //[2:2]
    #define RG_ARC_EN            Fld(1,1,AC_MSKB0) //[1:1]
    #define RG_EARC_DIV3_RSTB    Fld(1,0,AC_MSKB0) //[0:0]
    #define RG_EARC_CLR          Fld(32,0,AC_FULLDW)//[31:0]
#define RG_REG_EARC_CFG1 (IO_ANA_EARC_BASE + 0x004)
    #define RG_EARC_TX_DIV_CTRL     Fld(5,27,AC_MSKB3) //[31:27]
    #define RG_EARC_SER_EN          Fld(1,26,AC_MSKB3) //[26:26]
    #define RG_EARC_TX_CLK_SEL      Fld(1,25,AC_MSKB3) //[25:25]
    #define RG_EARC_TX_CLK_DIG_SEL  Fld(1,24,AC_MSKB3) //[24:24]
    #define RG_EARC_CM_SLEW_CTRL    Fld(5,19,AC_MSKB2) //[23:19]
    #define RG_EARC_DM_SLEW_CTRL    Fld(5,11,AC_MSKB1) //[15:11]
    #define RG_EARC_FM_SEL          Fld(5,3,AC_MSKB0)  //[7:3]

#define RG_REG_EARC_CFG2 (IO_ANA_EARC_BASE + 0x008)
    #define RG_EARC_REV_H               Fld(8,24,AC_MSKB3) //[31:24]
    #define RG_EARC_REV_L               Fld(8,16,AC_MSKB2) //[23:16]
    #define RG_EARCTX_INTR_CAL          Fld(6,10,AC_MSKB1) //[15:10]
    #define RG_EARCTX_CM_SLEW_OSC_EN    Fld(1,6 ,AC_MSKB0) //[9 : 9]
    #define RG_EARCTX_DM_SLEW_OSC_EN    Fld(1,5 ,AC_MSKB0) //[8 : 8]
    #define RG_EARCTXPLL_DIV6_EN        Fld(1,4 ,AC_MSKB0) //[7 : 7]
    #define RG_EARCTXPLL_DIV6_MON_EN    Fld(1,3 ,AC_MSKB0) //[6 : 6]
    #define RG_EARCTXPLL_DIV10_EN       Fld(1,2 ,AC_MSKB0) //[5 : 5]

#define RG_REG_EARC_CFG3 (IO_ANA_EARC_BASE + 0x00C)

#define RG_REG_EARC_CFG4 (IO_ANA_EARC_BASE + 0x010)
    #define RG_EARCTXPLL_EN                 Fld(1,31,AC_MSKB3)       //[31:31]
    #define RG_EARCTXPLL_POSDIV             Fld(3,28,AC_MSKB3)       //[30:28]
    #define RG_EARCTXPLL_PREDIV             Fld(2,26,AC_MSKB3)       //[27:26]
    #define RG_EARCTXPLL_SDM_FRA_EN         Fld(1,25,AC_MSKB3)       //[25:25]
    #define RG_EARCTXPLL_DIV3_EN            Fld(1,24,AC_MSKB3)       //[24:24]
    #define RG_EARCTXPLL_GLITCHFREE_EN      Fld(1,17,AC_MSKB2)       //[18:18]
    #define RG_EARCTXPLL_BLP                Fld(1,15,AC_MSKB1)       //[16:16]
    #define RG_EARCTXPLL_BP                 Fld(1,14,AC_MSKB1)       //[15:15]
    #define RG_EARCTXPLL_BR                 Fld(1,13,AC_MSKB1)       //[14:14]
    #define RG_EARCTXPLL_RST_DLY            Fld(2,11,AC_MSKB1)       //[13:12]
    #define RG_EARCTXPLL_LVROD_EN           Fld(1,10,AC_MSKB1)       //[11:11]

#define RG_REG_EARC_CFG5 (0x10033000 + 0x03C)
    #define RG_APLL2_RESERVE            Fld(8,24,AC_MSKB3)       //[31:24]
    #define RG_APLL2_EN                 Fld(1,0 ,AC_MSKB0)       //[0 :0 ]
#define RG_REG_EARC_CFG6 (0x1000D000 + 0xE40)
    #define RG_DA_APLL2_SDM_PWR_ON      Fld(1,7 ,AC_MSKB0)       //[7:7]
    #define RG_DA_EARCTXPLL_SDM_PWR_ON  Fld(1,16,AC_MSKB2)       //[16:16]
#define RG_REG_EARC_CFG7 (0x1000D000 + 0xE44)
    #define RG_DA_APLL2_SDM_ISO_EN      Fld(1,7 ,AC_MSKB0)       //[7:7]
    #define RG_DA_EARCTXPLL_SDM_ISO_EN  Fld(1,16,AC_MSKB2)       //[16:16]
#define RG_REG_EARC_CFG8 (0x10033000 + 0x060)
    #define RG_APLL2_DIV6_EN            Fld(1,13,AC_MSKB1)       //[13:13]
    #define RG_APLL2_LDO_EN             Fld(1,18,AC_MSKB2)       //[18:18]
    #define RG_APLL2_DIV8_DIV10_SEL     Fld(1,11,AC_MSKB1)       //[11:11]

//----------------------Digital --------------------------------------------
#define eARC_base 0x10608000

    //Page EARC_1
#define COMMA_TIMER_RX_TGL (eARC_base + 0x000)
    #define RG_TX_TIMER_EARC_TGL_CM_MAX Fld(11,16,AC_MSKW32)//[26:16]
    #define RG_TX_TIMER_EARC_TGL_CM_MIN Fld(11,0,AC_MSKW10)//[10:0]
#define COMMA_TIMER_RX_BIT (eARC_base + 0x004)
    #define RG_TX_TIMER_EARC_BIT_CM_MAX Fld(11,16,AC_MSKW32)//[26:16]
    #define RG_TX_TIMER_EARC_BIT_CM_MIN Fld(11,0,AC_MSKW10)//[10:0]
#define COMMA_TIMER_DISC_CONF_1 (eARC_base + 0x008)
    #define RG_TX_TIMER_OFF_MIN Fld(8,24,AC_FULLB3)//[31:24]
    #define RG_TX_TIMER_OFF_MAX Fld(8,16,AC_FULLB2)//[23:16]
    #define RG_TX_TIMER_WAIT_SLV Fld(8,8,AC_FULLB1)//[15:8]
#define COMMA_TIMER_DISC_CONF_2 (eARC_base + 0x00C)
    #define RG_TX_TIMER_ON_MIN Fld(8,24,AC_FULLB3)//[31:24]
    #define RG_TX_TIMER_ON_MAX Fld(8,16,AC_FULLB2)//[23:16]
#define COMMA_TIMER_DISC_CONF_3 (eARC_base + 0x010)
    #define RG_TX_TIMER_CM_DRIVE_STOP Fld(11,16,AC_MSKW32)//[26:16]
    #define RG_SEND_RSVD Fld(1,8,AC_MSKB1)//[8:8]
    #define RG_TX_TIMER_EARC_HEARTBEAT Fld(8,0,AC_FULLB0)//[7:0]
#define COMMA_TIMER_TX_CONF_1 (eARC_base + 0x014)
    #define RG_TX_TIMER_CM_RESPONSE Fld(8,24,AC_FULLB3)//[31:24]
    #define RG_TX_TIMER_CM_TURNOVER Fld(8,16,AC_FULLB2)//[23:16]
    #define RG_TX_TIMER_EARC_TGL_CM Fld(8,0,AC_FULLB0)//[7:0]
#define COMMA_INT_CONFIG (eARC_base + 0x018)
    #define RG_INT_CLR_ALL Fld(31,0,AC_MSKDW)//[0:31]
    #define RG_INT_HB_LOST_CLR Fld(1,24,AC_MSKB3)//[24:24]
    #define RG_INT_HB_DONE_CLR Fld(1,23,AC_MSKB2)//[23:23]
    #define RG_INT_HB_ABORT_CLR Fld(1,22,AC_MSKB2)//[22:22]
    #define RG_INT_PWR5V_FALL_CLR Fld(1,21,AC_MSKB2)//[21:21]
    #define RG_INT_PWR5V_RAISE_CLR Fld(1,20,AC_MSKB2)//[20:20]
    #define RG_INT_SOFT_ECC_CNT_CLR Fld(1,19,AC_MSKB2)//[19:19]
    #define RG_INT_HPD_FALL_CLR Fld(1,18,AC_MSKB2)//[18:18]
    #define RG_INT_HPD_RAISE_CLR Fld(1,17,AC_MSKB2)//[17:17]
    #define RG_INT_RSV_PKT_ABORT_CLR Fld(1,16,AC_MSKB2)//[16:16]
    #define RG_INT_SEND_OK_CLR Fld(1,15,AC_MSKB1)//[15:15]
    #define RG_INT_RCV_OK_CLR Fld(1,14,AC_MSKB1)//[14:14]
    #define RG_INT_PHD_PHY_LOW_CLR Fld(1,12,AC_MSKB1)//[12:12]
    #define RG_INT_DISC_ABORT_CLR Fld(1,11,AC_MSKB1)//[11:11]
    #define RG_INT_WRITE_FINISH_CLR Fld(1,10,AC_MSKB1)//[10:10]
    #define RG_INT_WRITE_ABORT_CLR Fld(1,9,AC_MSKB1)//[9:9]
    #define RG_INT_READ_FINISH_CLR Fld(1,8,AC_MSKB1)//[8:8]
    #define RG_INT_READ_ABORT_CLR Fld(1,7,AC_MSKB0)//[7:7]
    #define RG_INT_WRITE_FIFO_EMPTY_CLR Fld(1,6,AC_MSKB0)//[6:6]
    #define RG_INT_READ_NACK_CLR Fld(1,5,AC_MSKB0)//[5:5]
    #define RG_INT_READ_FIFO_FULL_CLR Fld(1,4,AC_MSKB0)//[4:4]
    #define RG_INT_READ_RETRY_CLR Fld(1,3,AC_MSKB0)//[3:3]
    #define RG_INT_DETECT_COMMA_CLR Fld(1,2,AC_MSKB0)//[2:2]
    #define RG_INT_HEARTBEAT_CLR Fld(1,1,AC_MSKB0)//[1:1]
    #define RG_INT_TIMEOUT_CLR Fld(1,0,AC_MSKB0)//[0:0]
#define COMMA_TOP_CONFIG (eARC_base + 0x01C)
    #define RG_FSM_STATUS_SEL Fld(1,24,AC_MSKB3)//[24:24]
    #define RG_RCV_ECC_ERROR_BYPASS Fld(1,23,AC_MSKB2)//[23:23]
    #define RG_SOFT_AUD Fld(1,22,AC_MSKB2)//[22:22]
    #define RG_SOFT_BUF Fld(1,21,AC_MSKB2)//[21:21]
    #define RG_SOFT_DIS Fld(1,20,AC_MSKB2)//[20:20]
    #define RG_SOFT_FSM Fld(1,19,AC_MSKB2)//[19:19]
    #define RG_SOFT_RCV Fld(1,18,AC_MSKB2)//[18:18]
    #define RG_SOFT_SND Fld(1,17,AC_MSKB2)//[17:17]
    #define RG_MONI_SEL Fld(3,13,AC_MSKB1)//[15:13]
    #define RG_HPD_PHY_SOFT Fld(1,9,AC_MSKB1)//[9:9]
    #define RG_HPD_PHY_SOFT_MODE Fld(1,8,AC_MSKB1)//[8:8]
    #define RG_HTP_EN_SOFT Fld(1,6,AC_MSKB0)//[6:6]
    #define RG_HTP_O_SOFT Fld(1,5,AC_MSKB0)//[5:5]
    #define RG_HTP_SOFT Fld(1,4,AC_MSKB0)//[4:4]
    #define RG_RD_STOP Fld(1,3,AC_MSKB0)//[3:3]
    #define RG_WR_STOP Fld(1,2,AC_MSKB0)//[2:2]
    #define RG_PWR_VALUE Fld(1,1,AC_MSKB0)//[1:1]
    #define RG_PWR_SEL Fld(1,0,AC_MSKB0)//[0:0]
#define COMMA_TOP_CONTROL (eARC_base + 0x020)
    #define RG_HEARTBEAT_EN Fld(1,31,AC_MSKB3)//[31:31]
    #define RG_HB_TIMER_CLEAN Fld(1,30,AC_MSKB3)//[30:30]
    #define RG_SOFT_HEARTBEAT_EN Fld(1,19,AC_MSKB2)//[19:19]
    #define RG_FREQ_METER_START Fld(1,18,AC_MSKB2)//[18:18]
    #define RG_USER_SET_EN Fld(1,15,AC_MSKB1)//[15:15]
    #define RG_USER_BITS_CRC_LOAD Fld(1,13,AC_MSKB1)//[13:13]
    #define RG_CLEAR_FSM_DEBUG_STATUS Fld(1,12,AC_MSKB1)//[12:12]
    #define RG_READ_START Fld(1,11,AC_MSKB1)//[11:11]
    #define RG_WRITE_START Fld(1,10,AC_MSKB1)//[10:10]
    #define RG_CONTINUE_RCV Fld(1,9,AC_MSKB1)//[9:9]
    #define RG_CLR_READ_LATCH Fld(1,8,AC_MSKB1)//[8:8]
    #define RG_NUM_CONFIG_RD_EN Fld(1,7,AC_MSKB0)//[7:7]
    #define RG_NUM_CONFIG_WR_EN Fld(1,6,AC_MSKB0)//[6:6]
    #define RG_CONTINUE_SND Fld(1,5,AC_MSKB0)//[5:5]
    #define RG_WRITE_DATA_CONFIG_EN Fld(1,4,AC_MSKB0)//[4:4]
    #define RG_COMMA_NUM_CLR Fld(1,3,AC_MSKB0)//[3:3]
    #define RG_LOST_HEARTBEAT Fld(1,2,AC_MSKB0)//[2:2]
    #define RG_HEARTBEAT_ACK Fld(1,1,AC_MSKB0)//[1:1]
#define COMMA_DISC_TIMER (eARC_base + 0x024)
    #define RG_MS_COUNTER Fld(11,16,AC_MSKW32)//[26:16]
    #define RG_COMMA_NUM_SEND Fld(4,8,AC_MSKB1)//[11:8]
    #define RG_US_COUNTER Fld(8,0,AC_FULLB0)//[7:0]
#define COMMA_ADDR_SEND (eARC_base + 0x028)
    #define RG_OFFSET_ADDR Fld(8,8,AC_FULLB1)//[15:8]
    #define RG_DVC_ADDR Fld(8,0,AC_FULLB0)//[7:0]
#define COMMA_DATA_SEND_1 (eARC_base + 0x02C)
    #define RG_WR_DATA_CONFIGURE_1 Fld(32,0,AC_FULLDW)//[31:0]
#define COMMA_DATA_SEND_2 (eARC_base + 0x030)
    #define RG_WR_DATA_CONFIGURE_2 Fld(32,0,AC_FULLDW)//[31:0]
#define COMMA_DATA_SEND_3 (eARC_base + 0x034)
    #define RG_WR_DATA_CONFIGURE_3 Fld(32,0,AC_FULLDW)//[31:0]
#define COMMA_DATA_SEND_4 (eARC_base + 0x038)
    #define RG_WR_DATA_CONFIGURE_4 Fld(32,0,AC_FULLDW)//[31:0]
#define COMMA_NUM_CONFIG (eARC_base + 0x03C)
    #define RG_RD_NUM_CONFIGURE Fld(8,8,AC_FULLB1)//[15:8]
    #define RG_WR_NUM_CONFIGURE Fld(8,0,AC_FULLB0)//[7:0]
#define COMMA_SOFT_CNTRL (eARC_base + 0x040)
    #define RG_SOFT_BACKUP_CNTRL Fld(24,0,AC_MSKDW)//[23:0]
#define AUDIO_CONFIG (eARC_base + 0x044)
    #define RG_AUDIO_RESET Fld(1,31,AC_MSKB3)//[31:31]
    #define RG_AUDIO_TRANS_EN Fld(1,30,AC_MSKB3)//[30:30]
    #define RG_SPDIF_EN Fld(1,29,AC_MSKB3)//[29:29]
    #define RG_NO_HBR_SEL Fld(1,28,AC_MSKB3)//[28:28]
    #define RG_BYPASS_SPDIF_B Fld(1,26,AC_MSKB3)//[26:26]
	#define RG_MUTE_EN  Fld(1,7,AC_MSKB0)//[7:7]
    #define RG_VALID_VALUE_1 Fld(1,6,AC_MSKB0)//[6:6]
    #define RG_VALID_VALUE_2 Fld(1,5,AC_MSKB0)//[5:5]
    #define RG_VALID_SELECT Fld(1,4,AC_MSKB0)//[4:4]
    #define RG_USE_SOFT_CHAN Fld(1,3,AC_MSKB0)//[3:3]
    #define RG_USE_SOFT_USER Fld(1,2,AC_MSKB0)//[2:2]
    #define RG_HBR_RESET Fld(1,1,AC_MSKB0)//[1:1]
    #define RG_AUDIO_SYNC_AUTO Fld(1,0,AC_MSKB0)//[0:0]
#define AUDIO_CHAN_LEFT_1 (eARC_base + 0x048)
    #define RG_CH_STATUS_L_1 Fld(32,0,AC_FULLDW)//[31:0]
#define AUDIO_CHAN_LEFT_2 (eARC_base + 0x04C)
    #define RG_CH_STATUS_L_2 Fld(32,0,AC_FULLDW)//[31:0]
#define AUDIO_CHAN_LEFT_3 (eARC_base + 0x050)
    #define RG_CH_STATUS_L_3 Fld(32,0,AC_FULLDW)//[31:0]
#define AUDIO_CHAN_LEFT_4 (eARC_base + 0x054)
    #define RG_CH_STATUS_L_4 Fld(32,0,AC_FULLDW)//[31:0]
#define AUDIO_CHAN_LEFT_5 (eARC_base + 0x058)
    #define RG_CH_STATUS_L_5 Fld(32,0,AC_FULLDW)//[31:0]
#define AUDIO_CHAN_LEFT_6 (eARC_base + 0x05C)
    #define RG_CH_STATUS_L_6 Fld(32,0,AC_FULLDW)//[31:0]
#define AUDIO_CHAN_RIGHT_1 (eARC_base + 0x060)
    #define RG_CH_STATUS_R_1 Fld(32,0,AC_FULLDW)//[31:0]
#define AUDIO_CHAN_RIGHT_2 (eARC_base + 0x064)
    #define RG_CH_STATUS_R_2 Fld(32,0,AC_FULLDW)//[31:0]
#define AUDIO_CHAN_RIGHT_3 (eARC_base + 0x068)
    #define RG_CH_STATUS_R_3 Fld(32,0,AC_FULLDW)//[31:0]
#define AUDIO_CHAN_RIGHT_4 (eARC_base + 0x06C)
    #define RG_CH_STATUS_R_4 Fld(32,0,AC_FULLDW)//[31:0]
#define AUDIO_CHAN_RIGHT_5 (eARC_base + 0x070)
    #define RG_CH_STATUS_R_5 Fld(32,0,AC_FULLDW)//[31:0]
#define AUDIO_CHAN_RIGHT_6 (eARC_base + 0x074)
    #define RG_CH_STATUS_R_6 Fld(32,0,AC_FULLDW)//[31:0]
#define AUDIO_USER_LEFT_1 (eARC_base + 0x078)
    #define RG_USER_L_1 Fld(32,0,AC_FULLDW)//[31:0]
#define AUDIO_USER_LEFT_2 (eARC_base + 0x07C)
    #define RG_USER_L_2 Fld(32,0,AC_FULLDW)//[31:0]
#define AUDIO_USER_LEFT_3 (eARC_base + 0x080)
    #define RG_USER_L_3 Fld(32,0,AC_FULLDW)//[31:0]
#define AUDIO_USER_LEFT_4 (eARC_base + 0x084)
    #define RG_USER_L_4 Fld(32,0,AC_FULLDW)//[31:0]
#define AUDIO_USER_LEFT_5 (eARC_base + 0x088)
    #define RG_USER_L_5 Fld(32,0,AC_FULLDW)//[31:0]
#define AUDIO_USER_LEFT_6 (eARC_base + 0x08C)
    #define RG_USER_L_6 Fld(32,0,AC_FULLDW)//[31:0]
#define AUDIO_USER_RIGHT_1 (eARC_base + 0x090)
    #define RG_USER_R_1 Fld(32,0,AC_FULLDW)//[31:0]
#define AUDIO_USER_RIGHT_2 (eARC_base + 0x094)
    #define RG_USER_R_2 Fld(32,0,AC_FULLDW)//[31:0]
#define AUDIO_USER_RIGHT_3 (eARC_base + 0x098)
    #define RG_USER_R_3 Fld(32,0,AC_FULLDW)//[31:0]
#define AUDIO_USER_RIGHT_4 (eARC_base + 0x09C)
    #define RG_USER_R_4 Fld(32,0,AC_FULLDW)//[31:0]
#define AUDIO_USER_RIGHT_5 (eARC_base + 0x0A0)
    #define RG_USER_R_5 Fld(32,0,AC_FULLDW)//[31:0]
#define AUDIO_USER_RIGHT_6 (eARC_base + 0x0A4)
    #define RG_USER_R_6 Fld(32,0,AC_FULLDW)//[31:0]
#define AUDIO_USER_CRC (eARC_base + 0x0A8)
    #define RG_USER_BITS_CRC Fld(8,24,AC_FULLB3)//[31:24]
    #define RG_CRC_EN Fld(1,0,AC_MSKB0)//[0:0]
#define COMMA_INT_MASK (eARC_base + 0x0AC)
    #define RG_INT_HB_LOST_EN Fld(1,24,AC_MSKB3)//[24:24]
    #define RG_INT_HB_DONE_EN Fld(1,23,AC_MSKB2)//[23:23]
    #define RG_INT_HB_ABORT_EN Fld(1,22,AC_MSKB2)//[22:22]
    #define RG_INT_PWR5V_FALL_EN Fld(1,21,AC_MSKB2)//[21:21]
    #define RG_INT_PWR5V_RAISE_EN Fld(1,20,AC_MSKB2)//[20:20]
    #define RG_INT_SOFT_ECC_CNT_EN Fld(1,19,AC_MSKB2)//[19:19]
    #define RG_INT_HPD_FALL_EN Fld(1,18,AC_MSKB2)//[18:18]
    #define RG_INT_HPD_RAISE_EN Fld(1,17,AC_MSKB2)//[17:17]
    #define RG_INT_RSCV_PKT_ABORT_EN Fld(1,16,AC_MSKB2)//[16:16]
    #define RG_INT_SEND_OK_EN Fld(1,15,AC_MSKB1)//[15:15]
    #define RG_INT_RCV_OK_EN Fld(1,14,AC_MSKB1)//[14:14]
    #define RG_INT_PHD_PHY_LOW_EN Fld(1,12,AC_MSKB1)//[12:12]
    #define RG_INT_DISC_ABORT_EN Fld(1,11,AC_MSKB1)//[11:11]
    #define RG_INT_WRITE_FINISH_EN Fld(1,10,AC_MSKB1)//[10:10]
    #define RG_INT_WRITE_ABORT_EN Fld(1,9,AC_MSKB1)//[9:9]
    #define RG_INT_READ_FINISH_EN Fld(1,8,AC_MSKB1)//[8:8]
    #define RG_INT_READ_ABORT_EN Fld(1,7,AC_MSKB0)//[7:7]
    #define RG_INT_WRITE_FIFO_EMPTY_EN Fld(1,6,AC_MSKB0)//[6:6]
    #define RG_INT_READ_NACK_EN Fld(1,5,AC_MSKB0)//[5:5]
    #define RG_INT_READ_FIFO_FULL_EN Fld(1,4,AC_MSKB0)//[4:4]
    #define RG_INT_READ_RETRY_EN Fld(1,3,AC_MSKB0)//[3:3]
    #define RG_INT_DETECT_COMMA_EN Fld(1,2,AC_MSKB0)//[2:2]
    #define RG_INT_HEARTBEAT_EN Fld(1,1,AC_MSKB0)//[1:1]
    #define RG_INT_TIMEOUT_EN Fld(1,0,AC_MSKB0)//[0:0]
#define COMMA_SOFT_ECC_1 (eARC_base + 0x0B0)
    #define RG_SOFT_ECC_1 Fld(32,0,AC_FULLDW)//[31:0]
#define COMMA_SOFT_ECC_2 (eARC_base + 0x0B4)
    #define COMMA_SOFT_ECC_2_SOFT_ECC_2 Fld(32,0,AC_FULLDW)//[31:0]
#define COMMA_TIMER_DISC_CONF_4 (eARC_base + 0x0B8)
    #define RG_TX_TIMER_TIMEOUT_MAX Fld(16,0,AC_FULLW10)//[15:0]
#define COMMA_READ_1 (eARC_base + 0x100)
    #define RG_SND_PACKET_FSM Fld(12,16,AC_MSKW32)//[27:16]
    #define RG_RSV_PACKET_FSM Fld(12,0,AC_MSKW10)//[11:0]
#define COMMA_READ_2 (eARC_base + 0x104)
    #define RG_RECEIVE_CD Fld(1,30,AC_MSKB3)//[30:30]
    #define RG_RECEIVE_PARITY Fld(1,29,AC_MSKB3)//[29:29]
    #define RG_RECEIVE_ECC Fld(5,24,AC_MSKB3)//[28:24]
    #define RG_DISC_PART_ABORT_STATUS Fld(8,16,AC_FULLB2)//[23:16]
    #define RG_SND_RCV_PACKET_ABORT_STATUS Fld(16,0,AC_FULLW10)//[15:0]
#define COMMA_READ_3 (eARC_base + 0x108)
    #define RG_RCV_RETRY_NUMBER Fld(8,24,AC_FULLB3)//[31:24]
#define COMMA_READ_4 (eARC_base + 0x10C)
    #define RG_PWR5V_PHY Fld(1,14,AC_MSKB1)//[14:14]
    #define RG_HPD_PHY Fld(1,13,AC_MSKB1)//[13:13]
    #define RG_EARC_CM_IN Fld(1,12,AC_MSKB1)//[12:12]
    #define RG_DISC_FSM Fld(12,0,AC_MSKW10)//[11:0]
#define COMMA_READ_5 (eARC_base + 0x110)
    #define RG_DEBUG_DEV_ADDR Fld(8,24,AC_FULLB3)//[31:24]
    #define RG_DEBUG_OFFSET_ADDR Fld(8,16,AC_FULLB2)//[23:16]
    #define RG_common_off_timer Fld(8,8,AC_FULLB1)//[15:8]s
#define COMMA_SAMPLE (eARC_base + 0x144)
    #define RG_DEGLITCH_LENGTH Fld(8,24,AC_FULLB3)//[31:24]
    #define RG_SAMPLE_STEP Fld(8,16,AC_FULLB2)//[23:16]
#define COMMA_DEBUG_READ (eARC_base + 0x14C)
    #define RG_SOFT_ECC_COUNTER Fld(3,20,AC_MSKB2)//[22:20]
#define COMMA_READ_INTER (eARC_base + 0x200)
    #define RG_INT_HB_LOST Fld(1,24,AC_MSKB3)//[24:24]
    #define RG_INT_HB_DONE Fld(1,23,AC_MSKB2)//[23:23]
    #define RG_INT_HB_ABORT Fld(1,22,AC_MSKB2)//[22:22]
    #define RG_INT_PWR5V_FALL Fld(1,21,AC_MSKB2)//[21:21]
    #define RG_INT_PWR5V_RAISE Fld(1,20,AC_MSKB2)//[20:20]
    #define RG_INT_SOFT_ECC_CNT Fld(1,19,AC_MSKB2)//[19:19]
    #define RG_INT_HPD_FALL Fld(1,18,AC_MSKB2)//[18:18]
    #define RG_INT_HPD_RAISE Fld(1,17,AC_MSKB2)//[17:17]
    #define RG_INT_RSCV_PKT_ABORT Fld(1,16,AC_MSKB2)//[16:16]
    #define RG_INT_SEND_OK Fld(1,15,AC_MSKB1)//[15:15]
    #define RG_INT_RCV_OK Fld(1,14,AC_MSKB1)//[14:14]
    #define RG_INT_PHD_PHY_LOW Fld(1,12,AC_MSKB1)//[12:12]
    #define RG_INT_DISC_ABORT Fld(1,11,AC_MSKB1)//[11:11]
    #define RG_INT_WRITE_FINISH Fld(1,10,AC_MSKB1)//[10:10]
    #define RG_INT_WRITE_ABORT Fld(1,9,AC_MSKB1)//[9:9]
    #define RG_INT_READ_FINISH Fld(1,8,AC_MSKB1)//[8:8]
    #define RG_INT_READ_ABORT Fld(1,7,AC_MSKB0)//[7:7]
    #define RG_INT_WRITE_FIFO_EMPTY Fld(1,6,AC_MSKB0)//[6:6]
    #define RG_INT_READ_NACK Fld(1,5,AC_MSKB0)//[5:5]
    #define RG_INT_READ_FIFO_FULL Fld(1,4,AC_MSKB0)//[4:4]
    #define RG_INT_READ_RETRY Fld(1,3,AC_MSKB0)//[3:3]
    #define RG_INT_DETECT_COMMA Fld(1,2,AC_MSKB0)//[2:2]
    #define RG_INT_HEARTBEAT Fld(1,1,AC_MSKB0)//[1:1]
    #define RG_INT_TIMEOUT Fld(1,0,AC_MSKB0)//[0:0]
#define AUDIO_CONFIG_1 (eARC_base + 0x204)
    #define RG_ECC_RVT_EN Fld(1,8,AC_MSKB1)//[8:8]
    #define RG_ECC_CNT Fld(8,0,AC_FULLB0)//[7:0]
#define ANA_DA_BACKUP (eARC_base + 0x208)
    #define RG_DM_4 Fld(1,30,AC_MSKB3)//[30:30]
    #define RG_DM_3 Fld(1,29,AC_MSKB3)//[29:29]
    #define RG_SOFT_PCW_CHG Fld(1,28,AC_MSKB3)//[28:28]
    #define RG_DM_1 Fld(1,18,AC_MSKB2)//[18:18]
    #define RG_DM_0 Fld(1,17,AC_MSKB2)//[17:17]
    #define RG_BYPASS_RD_STOP Fld(1,16,AC_MSKB2)//[16:16]
#define COMMA_READ_LATCH_1 (eARC_base + 0x210)
    #define RG_COMMA_READ_1 Fld(32,0,AC_FULLDW) //[31:0]
#define COMMA_READ_LATCH_2 (eARC_base + 0x214)
    #define RG_COMMA_READ_2 Fld(32,0,AC_FULLDW)//[31:0]
#define COMMA_READ_LATCH_3 (eARC_base + 0x218)
    #define RG_COMMA_READ_3 Fld(32,0,AC_FULLDW)//[31:0]
#define COMMA_READ_LATCH_4 (eARC_base + 0x21C)
    #define RG_COMMA_READ_4 Fld(32,0,AC_FULLDW)//[31:0]
#define COMMA_RSCV_PKT (eARC_base + 0x220)
    #define RG_PRMB_SYNC Fld(1,17,AC_MSKB2)//[17:17]
    #define RG_BYPASS_RCV_ERROR Fld(1,16,AC_MSKB2)//[16:16]
    #define RG_RSV_ECC_OUT_RVT Fld(1,1,AC_MSKB0)//[1:1]
    #define RG_RSV_ECC_IN_RVT Fld(1,0,AC_MSKB0)//[0:0]
#define COMMA_SND_PKT (eARC_base + 0x224)
    #define RG_SND_ECC_OUT_RVT Fld(1,1,AC_MSKB0)//[1:1]
    #define RG_SND_ECC_IN_RVT Fld(1,0,AC_MSKB0)//[0:0]
#define COMMA_DISCOV (eARC_base + 0x228)
    #define RG_TX_TIMER_EARC_LOST_HB Fld(8,24,AC_FULLB3)//[31:24]
    #define RG_RAW_CNT_OFF Fld(1,9,AC_MSKB2)//[21:21]
    #define RG_RAW_CLEAN Fld(1,8,AC_MSKB2)//[20:20]
    #define RG_HW_HB_DONE_EN Fld(1,19,AC_MSKB2)//[19:19]
    #define RG_HW_HB_LOST_EN Fld(1,18,AC_MSKB2)//[18:18]
    #define RG_JUSTIFY_EN Fld(1,17,AC_MSKB2)//[17:17]
    #define RG_HPD_DOWN Fld(1,16,AC_MSKB2)//[16:16]
    #define RG_BYPASS_COMMA_OFF_IN_TGL1_LOW Fld(1,6,AC_MSKB0)//[4:4]
    #define RG_BYPASS_COMMA_OFF_IN_TGL0 Fld(1,5,AC_MSKB0)//[4:4]
    #define RG_DETECT_EN Fld(1,4,AC_MSKB0)//[4:4]
    #define RG_JUSTIFY_BYPASS Fld(1,3,AC_MSKB0)//[3:3]
    #define RG_FORCE_HPD_ON Fld(1,1,AC_MSKB0)//[1:1]
    #define RG_DISC_1MS_DELAY_BYPASS Fld(1,0,AC_MSKB0)//[0:0]
    #define RG_COMMA_OFF_RELAX Fld(1,2,AC_MSKB0)//[2:2]
#define COMMA_FSM (eARC_base + 0x22C)
    #define RG_HB_D1_INIT Fld(8,24,AC_MSKB3)//[31:24] 8'h81
    #define RG_HB_D0_MASK Fld(8,16,AC_MSKB2)//[23:16] 8'h18
    #define RG_SOFT_HEARTBEAT_MODE Fld(1,9,AC_MSKB1)//[9:9]
    #define RG_HB_SKIP Fld(1,8,AC_MSKB1)//[8:8]
    #define RG_HB_ERR_MASK Fld(8,0,AC_FULLB0)//[7:0]
#define COMMA_TOP_CNT_READ (eARC_base + 0x230)
    #define RG_COMMA_TOP_CNT_READ Fld(32,0,AC_FULLDW)//[31:0]
#define COMMA_FREQ_METER (eARC_base + 0x234)
    #define RG_FREQ_METER_CLK Fld(16,16,AC_MSKDW)//[31:16]
    #define RG_FREQ_METER_SEL Fld(2,14,AC_MSKB1)//[15:14]
    #define RG_DM_FREQ_SEL Fld(1,11,AC_MSKB1)//[11:11]
    #define RG_FREQ_METER_ENABLE Fld(1,10,AC_MSKB1)//[10:10]
    #define RG_FREQ_METER_CNT Fld(10,0,AC_MSKW10)//[9:0]
#define EARCTXPLL_SDM_PCW (eARC_base + 0x238)
    #define RG_EARC_PCW_SOFT_SEL Fld(1,31,AC_MSKB3)//[31:31]
    #define RG_EARC_PCW_SOFT Fld(31,0,AC_MSKDW)//[30:0]
#define COMMA_READ_FSM (eARC_base + 0x23C)
    #define RG_HB_D0_VALUE Fld(8,0,AC_FULLB0)//[7:0]
#define COMMA_READ_LATCH_5 (eARC_base + 0x240)
    #define RG_COMMA_READ_5 Fld(32,0,AC_FULLDW)//[31:0]
#define COMMA_READ_LATCH_6 (eARC_base + 0x244)
    #define RG_COMMA_READ_6 Fld(32,0,AC_FULLDW)//[31:0]
#define COMMA_READ_LATCH_7 (eARC_base + 0x248)
    #define RG_COMMA_READ_7 Fld(32,0,AC_FULLDW)//[31:0]
#define COMMA_READ_LATCH_8 (eARC_base + 0x24C)
    #define RG_COMMA_READ_8 Fld(32,0,AC_FULLDW)//[31:0]
#define COMMA_READ_LATCH_9 (eARC_base + 0x250)
    #define RG_COMMA_READ_9 Fld(32,0,AC_FULLDW)//[31:0]
#define COMMA_READ_LATCH_10 (eARC_base + 0x254)
    #define RG_COMMA_READ_10 Fld(32,0,AC_FULLDW)//[31:0]

    //Page EARC_2
#define COMMA_READ_LATCH_11 (eARC_base + 0x258)
    #define RG_COMMA_READ_11 Fld(32,0,AC_FULLDW)//[31:0]
#define COMMA_READ_LATCH_12 (eARC_base + 0x25C)
    #define RG_COMMA_READ_12 Fld(32,0,AC_FULLDW)//[31:0]
#define COMMA_READ_LATCH_13 (eARC_base + 0x260)
    #define RG_COMMA_READ_13 Fld(32,0,AC_FULLDW)//[31:0]
#define COMMA_READ_LATCH_14 (eARC_base + 0x264)
    #define RG_COMMA_READ_14 Fld(32,0,AC_FULLDW)//[31:0]
#define COMMA_READ_LATCH_15 (eARC_base + 0x268)
    #define RG_COMMA_READ_15 Fld(32,0,AC_FULLDW)//[31:0]
#define COMMA_READ_LATCH_16 (eARC_base + 0x26C)
    #define RG_COMMA_READ_16 Fld(32,0,AC_FULLDW)//[31:0]
#define AUDIO_CHAN_SET_1 (eARC_base + 0x270)
    #define RG_AUDIO_CHAN_SET_1 Fld(32,0,AC_FULLDW)//[31:0]
#define AUDIO_CHAN_SET_2 (eARC_base + 0x274)
    #define RG_AUDIO_CHAN_SET_2 Fld(32,0,AC_FULLDW)//[31:0]
#define AUDIO_CHAN_SET_3 (eARC_base + 0x278)
    #define RG_AUDIO_CHAN_SET_3 Fld(32,0,AC_FULLDW)//[31:0]
#define AUDIO_CHAN_SET_4 (eARC_base + 0x27C)
    #define RG_AUDIO_CHAN_SET_4 Fld(32,0,AC_FULLDW)//[31:0]
#define AUDIO_CHAN_SET_5 (eARC_base + 0x280)
    #define RG_AUDIO_CHAN_SET_5 Fld(32,0,AC_FULLDW)//[31:0]
#define AUDIO_CHAN_SET_6 (eARC_base + 0x284)
    #define RG_AUDIO_CHAN_SET_6 Fld(32,0,AC_FULLDW)//[31:0]
#define AUDIO_CHAN_CLR_1 (eARC_base + 0x288)
    #define RG_AUDIO_CHAN_CLR_1 Fld(32,0,AC_FULLDW)//[31:0]
#define AUDIO_CHAN_CLR_2 (eARC_base + 0x28C)
    #define RG_AUDIO_CHAN_CLR_2 Fld(32,0,AC_FULLDW)//[31:0]
#define AUDIO_CHAN_CLR_3 (eARC_base + 0x290)
    #define RG_AUDIO_CHAN_CLR_3 Fld(32,0,AC_FULLDW)//[31:0]
#define AUDIO_CHAN_CLR_4 (eARC_base + 0x294)
    #define RG_AUDIO_CHAN_CLR_4 Fld(32,0,AC_FULLDW)//[31:0]
#define AUDIO_CHAN_CLR_5 (eARC_base + 0x298)
    #define RG_AUDIO_CHAN_CLR_5 Fld(32,0,AC_FULLDW)//[31:0]
#define AUDIO_CHAN_CLR_6 (eARC_base + 0x29C)
    #define RG_AUDIO_CHAN_CLR_6 Fld(32,0,AC_FULLDW)//[31:0]

#define RG_EARC_MONITOR_ADD1 0x1000D580
#define RG_EARC_MONITOR_ADD2 0x1000D584
#define RG_EARC_BYTE0_SET Fld(8,0, AC_MSKB0)
#define RG_EARC_BYTE1_SET Fld(8,8, AC_MSKB0)
#define RG_EARC_BYTE2_SET Fld(8,16, AC_MSKB0)
#define RG_EARC_BYTE3_SET Fld(8,24, AC_MSKB0)


#define EARC_TRIGLE_ADDR 0x10008094
#define EARC_TRIGLE_utility  Fld(8,16,AC_MSKB2)
#define EARC_TRIGLE_hpd      Fld(8,8, AC_MSKB1)

#define RG_EARC_EFUSE_ADDR  0x10008660
#define RG_EARC_ZSEL_EFUSE  Fld(5,27,AC_MSKB3)
#define RG_EARC_DM_CS_CTRL_EFUSE1 Fld(2,22,AC_MSKB2)
#define RG_EARC_DM_CS_CTRL_EFUSE2 Fld(3,24,AC_MSKB3)
#define RG_EARC_CM_CS_CTRL_EFUSE Fld(5,17,AC_MSKB2)

 /*Should be control by audio driver, need to by modify*/
#define RG_AUDIO_ACK_CFG (IO_VIRT+0x00005000)
#define FLD_AUDIO_IEC_DIV Fld(3,4,AC_MSKB0)//[6:4]
#define HDMI21_RX_CHST1 (eARC_base + 0x820)
#define HDMI21_RX_SW_OW (eARC_base + 0x820)

#define CBIT_SAMPLING_FREQUENCY_CLK_FLD         Fld(4,24,AC_MSKB3)
#define CBIT_NUMBER_CHANNEL_FLD                 Fld(4,12,AC_MSKB1)
#define CBIT_SAMPLE_LENGTH_FLD                  Fld(4,0,AC_MSKB0)
#define CBIT_COMBINATIONS_FORMAT_MFLD           Fld(6,0,AC_MSKB0)

#define WRITEBYTEINDEX(addr,x,bValue)  {                                                  \
                int data;                                                                 \
                data = IO32ReadFldAlign(addr,Fld(32,0,AC_FULLDW));                        \
                bValue > 0 ? (data = data | (1<<x)): (data = data & (~(1 << x)));         \
                vIO32WriteFldAlign(addr,data,Fld(32,0,AC_FULLDW));                        \
    }

#define READBYTEINDEX(addr,x)   {                                                         \
                int data;                                                                 \
                int r;                                                                    \
                data = IO32ReadFldAlign(addr,Fld(32,0,AC_FULLDW));                        \
                (data & (1 << x)) > 0 ? (r = 1):(r= 0);                                   \
                return r;                                                                 \
}

