#ifndef _HW_HPCPLL_H_
#define _HW_HPCPLL_H_

#define IO_HPCPLL_BASE (IO_VIRT + 0x34000)
#define IO_ARMPLL_BASE (IO_VIRT + 0x34000)

// HPCPLL
#define REG_HPCPLL_CFG1 (IO_HPCPLL_BASE + 0x204)
    #define FLD_RG_HPCPLL_BP Fld(1,11,AC_MSKB1)//[11:11]
    #define FLD_RG_HPCPLL_BR Fld(1,10,AC_MSKB1)//[10:10]
    #define FLD_RG_HPCPLL_RST_DLY Fld(2,8,AC_MSKB1)//[9:8]
    #define FLD_RG_HPCPLL_SDM_FRA_EN Fld(1,7,AC_MSKB0)//[7:7]
    #define FLD_RG_HPCPLL_DIV3_EN Fld(1,6,AC_MSKB0)//[6:6]
    #define FLD_RG_HPCPLL_GLITCH_FREE_EN Fld(1,5,AC_MSKB0)//[5:5]
    #define FLD_RG_HPCPLL_BLP Fld(1,4,AC_MSKB0)//[4:4]
    #define FLD_RG_HPCPLL_POSDIV Fld(3,1,AC_MSKB0)//[3:1]
    #define FLD_RG_HPCPLL_EN Fld(1,0,AC_MSKB0)//[0:0]
#define REG_HPCPLL_CFG2 (IO_HPCPLL_BASE + 0x208)
    #define FLD_RG_HPCPLL_TST_EN Fld(1,31,AC_MSKB3)//[31:31]
    #define FLD_RG_HPCPLL_LVROD_EN Fld(1,30,AC_MSKB3)//[30:30]
    #define FLD_RG_HPCPLL_VOD_EN Fld(1,29,AC_MSKB3)//[29:29]
    #define FLD_RG_HPCPLL_RESERVE Fld(8,16,AC_FULLB2)//[23:16]
    #define FLD_RG_HPCPLL_TSTCK_EN Fld(1,14,AC_MSKB1)//[14:14]
    #define FLD_RG_HPCPLL_TST_SEL Fld(2,12,AC_MSKB1)//[13:12]
    #define FLD_RG_HPCPLL_TSTOD_EN Fld(1,10,AC_MSKB1)//[10:10]
    #define FLD_RG_HPCPLL_A2DCK_EN Fld(1,9,AC_MSKB1)//[9:9]
    #define FLD_RG_HPCPLL_TSTOP_EN Fld(1,8,AC_MSKB1)//[8:8]

//ARMPLL
#define REG_ARMPLL_CFG0 (IO_ARMPLL_BASE + 0x300)
    #define FLD_RG_ARMPLL_SDM_PCW Fld(32,0,AC_FULLDW)//[31:0]
#define REG_ARMPLL_CFG1 (IO_ARMPLL_BASE + 0x304)
    #define FLD_RG_ARMPLL_SDM_PCW_CHG Fld(1,31,AC_MSKB3)//[31:31]
    #define FLD_RG_ARMPLL_BP Fld(1,11,AC_MSKB1)//[11:11]
    #define FLD_RG_ARMPLL_BR Fld(1,10,AC_MSKB1)//[10:10]
    #define FLD_RG_ARMPLL_RST_DLY Fld(2,8,AC_MSKB1)//[9:8]
    #define FLD_RG_ARMPLL_SDM_FRA_EN Fld(1,7,AC_MSKB0)//[7:7]
    #define FLD_RG_ARMPLL_DIV3_EN Fld(1,6,AC_MSKB0)//[6:6]
    #define FLD_RG_ARMPLL_GLITCH_FREE_EN Fld(1,5,AC_MSKB0)//[5:5]
    #define FLD_RG_ARMPLL_BLP Fld(1,4,AC_MSKB0)//[4:4]
    #define FLD_RG_ARMPLL_POSDIV Fld(3,1,AC_MSKB0)//[3:1]
    #define FLD_RG_ARMPLL_EN Fld(1,0,AC_MSKB0)//[0:0]
#define REG_ARMPLL_CFG2 (IO_ARMPLL_BASE + 0x308)
    #define FLD_RG_ARMPLL_TST_EN Fld(1,31,AC_MSKB3)//[31:31]
    #define FLD_RG_ARMPLL_LVROD_EN Fld(1,30,AC_MSKB3)//[30:30]
    #define FLD_RG_ARMPLL_VOD_EN Fld(1,29,AC_MSKB3)//[29:29]
    #define FLD_RG_ARMPLL_RESERVE Fld(8,16,AC_FULLB2)//[23:16]
    #define FLD_RG_ARMPLL_TSTCK_EN Fld(1,14,AC_MSKB1)//[14:14]
    #define FLD_RG_ARMPLL_TST_SEL Fld(2,12,AC_MSKB1)//[13:12]
    #define FLD_RG_ARMPLL_TSTOD_EN Fld(1,10,AC_MSKB1)//[10:10]
    #define FLD_RG_ARMPLL_A2DCK_EN Fld(1,9,AC_MSKB1)//[9:9]
    #define FLD_RG_ARMPLL_TSTOP_EN Fld(1,8,AC_MSKB1)//[8:8]

//CCIPLL
#define REG_CCIPLL_CFG0 (IO_ARMPLL_BASE + 0x400)
    #define FLD_RG_CCIPLL_SDM_PCW Fld(32,0,AC_FULLDW)//[31:0]
#define REG_CCIPLL_CFG1 (IO_ARMPLL_BASE + 0x404)
    #define FLD_RG_CCIPLL_SDM_PCW_CHG Fld(1,31,AC_MSKB3)//[31:31]
    #define FLD_RG_CCIPLL_BP Fld(1,11,AC_MSKB1)//[11:11]
    #define FLD_RG_CCIPLL_BR Fld(1,10,AC_MSKB1)//[10:10]
    #define FLD_RG_CCIPLL_RST_DLY Fld(2,8,AC_MSKB1)//[9:8]
    #define FLD_RG_CCIPLL_SDM_FRA_EN Fld(1,7,AC_MSKB0)//[7:7]
    #define FLD_RG_CCIPLL_DIV3_EN Fld(1,6,AC_MSKB0)//[6:6]
    #define FLD_RG_CCIPLL_GLITCH_FREE_EN Fld(1,5,AC_MSKB0)//[5:5]
    #define FLD_RG_CCIPLL_BLP Fld(1,4,AC_MSKB0)//[4:4]
    #define FLD_RG_CCIPLL_POSDIV Fld(3,1,AC_MSKB0)//[3:1]
    #define FLD_RG_CCIPLL_EN Fld(1,0,AC_MSKB0)//[0:0]
#define REG_CCIPLL_CFG2 (IO_ARMPLL_BASE + 0x408)
    #define FLD_RG_CCIPLL_TST_EN Fld(1,31,AC_MSKB3)//[31:31]
    #define FLD_RG_CCIPLL_LVROD_EN Fld(1,30,AC_MSKB3)//[30:30]
    #define FLD_RG_CCIPLL_VOD_EN Fld(1,29,AC_MSKB3)//[29:29]
    #define FLD_RG_CCIPLL_RESERVE Fld(8,16,AC_FULLB2)//[23:16]
    #define FLD_RG_CCIPLL_TSTCK_EN Fld(1,14,AC_MSKB1)//[14:14]
    #define FLD_RG_CCIPLL_TST_SEL Fld(2,12,AC_MSKB1)//[13:12]
    #define FLD_RG_CCIPLL_TSTOD_EN Fld(1,10,AC_MSKB1)//[10:10]
    #define FLD_RG_CCIPLL_A2DCK_EN Fld(1,9,AC_MSKB1)//[9:9]
    #define FLD_RG_CCIPLL_TSTOP_EN Fld(1,8,AC_MSKB1)//[8:8]

//G3DPLL
#define REG_G3DPLL_CFG0 (IO_HPCPLL_BASE + 0x500)
    #define FLD_RG_G3DPLL_SDM_PCW Fld(32,0,AC_FULLDW)//[31:0]
#define REG_G3DPLL_CFG1 (IO_HPCPLL_BASE + 0x504)
    #define FLD_RG_G3DPLL_SDM_PCW_CHG Fld(1,31,AC_MSKB3)//[31:31]
    #define FLD_RG_G3DPLL_BP Fld(1,11,AC_MSKB1)//[11:11]
    #define FLD_RG_G3DPLL_BR Fld(1,10,AC_MSKB1)//[10:10]
    #define FLD_RG_G3DPLL_RST_DLY Fld(2,8,AC_MSKB1)//[9:8]
    #define FLD_RG_G3DPLL_SDM_FRA_EN Fld(1,7,AC_MSKB0)//[7:7]
    #define FLD_RG_G3DPLL_DIV3_EN Fld(1,6,AC_MSKB0)//[6:6]
    #define FLD_RG_G3DPLL_GLITCH_FREE_EN Fld(1,5,AC_MSKB0)//[5:5]
    #define FLD_RG_G3DPLL_BLP Fld(1,4,AC_MSKB0)//[4:4]
    #define FLD_RG_G3DPLL_POSDIV Fld(3,1,AC_MSKB0)//[3:1]
    #define FLD_RG_G3DPLL_EN Fld(1,0,AC_MSKB0)//[0:0]
#define REG_G3DPLL_CFG2 (IO_HPCPLL_BASE + 0x508)
    #define FLD_RG_G3DPLL_TST_EN Fld(1,31,AC_MSKB3)//[31:31]
    #define FLD_RG_G3DPLL_LVROD_EN Fld(1,30,AC_MSKB3)//[30:30]
    #define FLD_RG_G3DPLL_VOD_EN Fld(1,29,AC_MSKB3)//[29:29]
    #define FLD_RG_G3DPLL_RESERVE Fld(8,16,AC_FULLB2)//[23:16]
    #define FLD_RG_G3DPLL_TSTCK_EN Fld(1,14,AC_MSKB1)//[14:14]
    #define FLD_RG_G3DPLL_TST_SEL Fld(2,12,AC_MSKB1)//[13:12]
    #define FLD_RG_G3DPLL_TSTOD_EN Fld(1,10,AC_MSKB1)//[10:10]
    #define FLD_RG_G3DPLL_A2DCK_EN Fld(1,9,AC_MSKB1)//[9:9]
    #define FLD_RG_G3DPLL_TSTOP_EN Fld(1,8,AC_MSKB1)//[8:8]

#endif /* _HW_HPCPLL_H_ */

