#ifndef _HW_MJC_CMQ_H_
#define _HW_MJC_CMQ_H_
#include "x_hal_5381.h"

#ifndef CC_FPGA
#define IO_ADDR_OFST IO_VIRT
#else
#define IO_ADDR_OFST 0xf0000000
#endif

#define MEMC_CMQ (IO_ADDR_OFST + 0x44000)

//Page CMQ_1
#define MEMC_CMQ_HV_0 (MEMC_CMQ + 0x000)
    #define MEMC_CMQ_H_TOTAL_IN Fld(16,16,AC_FULLW32)//[31:16]
    #define MEMC_CMQ_VSYNC_TOTAL_IN Fld(16,0,AC_FULLW10)//[15:0]
#define MEMC_CMQ_HV_1 (MEMC_CMQ + 0x004)
    #define MEMC_CMQ_V_TRIG_TARGET Fld(16,16,AC_FULLW32)//[31:16]
    #define MEMC_CMQ_V_TRIG_TARGET_FIRST_FRAME Fld(16,0,AC_FULLW10)//[15:0]
#define MEMC_CMQ_INFO (MEMC_CMQ + 0x008)
    #define MEMC_CMQ_SET_CMD_NUM Fld(4,28,AC_MSKB3)//[31:28]
    #define MEMC_CMQ_SET_COMMAND_START Fld(1,27,AC_MSKB3)//[27:27]
    #define MEMC_CMQ_CQ_TOTAL Fld(4,23,AC_MSKW32)//[26:23]
    #define MEMC_CMQ_CQ_INIT Fld(4,19,AC_MSKB2)//[22:19]
    #define MEMC_CMQ_CQ_MUX_SEL Fld(1,18,AC_MSKB2)//[18:18]
    #define MEMC_CMQ_ATPG_CT Fld(1,17,AC_MSKB2)//[17:17]
    #define MEMC_CMQ_ATPG_OB Fld(1,16,AC_MSKB2)//[16:16]
    #define MEMC_CMQ_MJCMV_RD_DRAM_EN Fld(1,15,AC_MSKB1)//[15:15]
    #define MEMC_CMQ_MJCMV_RD_DRAM_TIM Fld(4,11,AC_MSKB1)//[14:11]
    #define MEMC_CMQ_MJCMV_WR_DRAM_EN Fld(1,10,AC_MSKB1)//[10:10]
    #define MEMC_CMQ_MJCMV_WR_DRAM_TIM Fld(4,6,AC_MSKW10)//[9:6]
    #define MEMC_CMQ_DMA_RD_DRAM_EN Fld(1,5,AC_MSKB0)//[5:5]
    #define MEMC_CMQ_DMA_RD_DRAM_TIM Fld(4,1,AC_MSKB0)//[4:1]
#define MEMC_CQ_FB_Y_0 (MEMC_CMQ + 0x00C)
    #define MEMC_CMQ_FB_Y0_ADDR Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_CQ_FB_Y_1 (MEMC_CMQ + 0x010)
    #define MEMC_CMQ_FB_Y1_ADDR Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_CQ_FB_Y_2 (MEMC_CMQ + 0x014)
    #define MEMC_CMQ_FB_Y2_ADDR Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_CQ_FB_Y_3 (MEMC_CMQ + 0x018)
    #define MEMC_CMQ_FB_Y3_ADDR Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_CQ_FB_Y_4 (MEMC_CMQ + 0x01C)
    #define MEMC_CMQ_FB_Y4_ADDR Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_CQ_FB_Y_5 (MEMC_CMQ + 0x020)
    #define MEMC_CMQ_FB_Y5_ADDR Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_CQ_FB_Y_6 (MEMC_CMQ + 0x024)
    #define MEMC_CMQ_FB_Y6_ADDR Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_CQ_FB_Y_7 (MEMC_CMQ + 0x028)
    #define MEMC_CMQ_FB_Y7_ADDR Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_CQ_FB_Y_8 (MEMC_CMQ + 0x02C)
    #define MEMC_CMQ_FB_Y8_ADDR Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_CQ_FB_Y_9 (MEMC_CMQ + 0x030)
    #define MEMC_CMQ_FB_Y9_ADDR Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_CQ_FB_Y_10 (MEMC_CMQ + 0x034)
    #define MEMC_CMQ_FB_Y10_ADDR Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_CQ_FB_Y_11 (MEMC_CMQ + 0x038)
    #define MEMC_CMQ_FB_Y11_ADDR Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_CQ_FB_Y_12 (MEMC_CMQ + 0x03C)
    #define MEMC_CMQ_FB_Y12_ADDR Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_CQ_FB_Y_13 (MEMC_CMQ + 0x040)
    #define MEMC_CMQ_FB_Y13_ADDR Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_CQ_FB_Y_14 (MEMC_CMQ + 0x044)
    #define MEMC_CMQ_FB_Y14_ADDR Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_CQ_FB_Y_15 (MEMC_CMQ + 0x048)
    #define MEMC_CMQ_FB_Y15_ADDR Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_CQ_FB_C_0 (MEMC_CMQ + 0x04C)
    #define MEMC_CMQ_FB_C0_ADDR Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_CQ_FB_C_1 (MEMC_CMQ + 0x050)
    #define MEMC_CMQ_FB_C1_ADDR Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_CQ_FB_C_2 (MEMC_CMQ + 0x054)
    #define MEMC_CMQ_FB_C2_ADDR Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_CQ_FB_C_3 (MEMC_CMQ + 0x058)
    #define MEMC_CMQ_FB_C3_ADDR Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_CQ_FB_C_4 (MEMC_CMQ + 0x05C)
    #define MEMC_CMQ_FB_C4_ADDR Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_CQ_FB_C_5 (MEMC_CMQ + 0x060)
    #define MEMC_CMQ_FB_C5_ADDR Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_CQ_FB_C_6 (MEMC_CMQ + 0x064)
    #define MEMC_CMQ_FB_C6_ADDR Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_CQ_FB_C_7 (MEMC_CMQ + 0x068)
    #define MEMC_CMQ_FB_C7_ADDR Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_CQ_FB_C_8 (MEMC_CMQ + 0x06C)
    #define MEMC_CMQ_FB_C8_ADDR Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_CQ_FB_C_9 (MEMC_CMQ + 0x070)
    #define MEMC_CMQ_FB_C9_ADDR Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_CQ_FB_C_10 (MEMC_CMQ + 0x074)
    #define MEMC_CMQ_FB_C10_ADDR Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_CQ_FB_C_11 (MEMC_CMQ + 0x078)
    #define MEMC_CMQ_FB_C11_ADDR Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_CQ_FB_C_12 (MEMC_CMQ + 0x07C)
    #define MEMC_CMQ_FB_C12_ADDR Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_CQ_FB_C_13 (MEMC_CMQ + 0x080)
    #define MEMC_CMQ_FB_C13_ADDR Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_CQ_FB_C_14 (MEMC_CMQ + 0x084)
    #define MEMC_CMQ_FB_C14_ADDR Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_CQ_FB_C_15 (MEMC_CMQ + 0x088)
    #define MEMC_CMQ_FB_C15_ADDR Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_CQ_MV_0 (MEMC_CMQ + 0x08C)
    #define MEMC_CMQ_MV0_ADDR Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_CQ_MV_1 (MEMC_CMQ + 0x090)
    #define MEMC_CMQ_MV1_ADDR Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_CQ_MV_2 (MEMC_CMQ + 0x094)
    #define MEMC_CMQ_MV2_ADDR Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_CQ_MV_3 (MEMC_CMQ + 0x098)
    #define MEMC_CMQ_MV3_ADDR Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_CQ_MV_4 (MEMC_CMQ + 0x09C)
    #define MEMC_CMQ_MV4_ADDR Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_CQ_MV_5 (MEMC_CMQ + 0x0A0)
    #define MEMC_CMQ_MV5_ADDR Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_CQ_MV_6 (MEMC_CMQ + 0x0A4)
    #define MEMC_CMQ_MV6_ADDR Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_CQ_MV_7 (MEMC_CMQ + 0x0A8)
    #define MEMC_CMQ_MV7_ADDR Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_CQ_MV_8 (MEMC_CMQ + 0x0AC)
    #define MEMC_CMQ_MV8_ADDR Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_CQ_MV_9 (MEMC_CMQ + 0x0B0)
    #define MEMC_CMQ_MV9_ADDR Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_CQ_MV_10 (MEMC_CMQ + 0x0B4)
    #define MEMC_CMQ_MV10_ADDR Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_CQ_MV_11 (MEMC_CMQ + 0x0B8)
    #define MEMC_CMQ_MV11_ADDR Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_CQ_MV_12 (MEMC_CMQ + 0x0BC)
    #define MEMC_CMQ_MV12_ADDR Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_CQ_MV_13 (MEMC_CMQ + 0x0C0)
    #define MEMC_CMQ_MV13_ADDR Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_CQ_MV_14 (MEMC_CMQ + 0x0C4)
    #define MEMC_CMQ_MV14_ADDR Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_CQ_MV_15 (MEMC_CMQ + 0x0C8)
    #define MEMC_CMQ_MV15_ADDR Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_CQ_REG_0 (MEMC_CMQ + 0x0CC)
    #define MEMC_CMQ_PLD_FB_Y2_ADDR Fld(4,28,AC_MSKB3)//[31:28]
    #define MEMC_CMQ_PLD_FB_C1_ADDR Fld(4,24,AC_MSKB3)//[27:24]
    #define MEMC_CMQ_PLD_FB_Y1_ADDR Fld(4,20,AC_MSKB2)//[23:20]
    #define MEMC_CMQ_ACT_FB_Y3_ADDR Fld(4,16,AC_MSKB2)//[19:16]
    #define MEMC_CMQ_ACT_FB_C2_ADDR Fld(4,12,AC_MSKB1)//[15:12]
    #define MEMC_CMQ_ACT_FB_Y2_ADDR Fld(4,8,AC_MSKB1)//[11:8]
    #define MEMC_CMQ_ACT_FB_C1_ADDR Fld(4,4,AC_MSKB0)//[7:4]
    #define MEMC_CMQ_ACT_FB_Y1_ADDR Fld(4,0,AC_MSKB0)//[3:0]
#define MEMC_CQ_REG_1 (MEMC_CMQ + 0x0D0)
    #define MEMC_CMQ_MV_TD_WR_ADR Fld(4,28,AC_MSKB3)//[31:28]
    #define MEMC_CMQ_MV_PV_RD_ADR Fld(4,24,AC_MSKB3)//[27:24]
    #define MEMC_CMQ_MV_CU_RD_ADR Fld(4,20,AC_MSKB2)//[23:20]
    #define MEMC_CMQ_MV_CU_WR_ADR Fld(4,16,AC_MSKB2)//[19:16]
    #define MEMC_CMQ_MV_BI_RD_ADR Fld(4,12,AC_MSKB1)//[15:12]
    #define MEMC_CMQ_MV_BI_WR_ADR Fld(4,8,AC_MSKB1)//[11:8]
    #define MEMC_CMQ_PLD_FB_Y3_ADDR Fld(4,4,AC_MSKB0)//[7:4]
    #define MEMC_CMQ_PLD_FB_C2_ADDR Fld(4,0,AC_MSKB0)//[3:0]
#define MEMC_CQ_REG_2 (MEMC_CMQ + 0x0D4)
    #define MEMC_CMQ_ACT_MC_2X_MODE Fld(1,19,AC_MSKB2)//[19:19]
    #define MEMC_CMQ_ACT_ME2_EN Fld(1,18,AC_MSKB2)//[18:18]
    #define MEMC_CMQ_ACT_ME3_EN Fld(1,17,AC_MSKB2)//[17:17]
    #define MEMC_CMQ_ACT_BGMV_KEEP Fld(1,16,AC_MSKB2)//[16:16]
    #define MEMC_CMQ_ACT_MVEXP_FLAG Fld(1,15,AC_MSKB1)//[15:15]
    #define MEMC_CMQ_PLD_ME_24_60_PREBI Fld(1,14,AC_MSKB1)//[14:14]
    #define MEMC_CMQ_ACT_ME_24_60_PREBI_DLY Fld(1,13,AC_MSKB1)//[13:13]
    #define MEMC_CMQ_ACT_ME_24_60_PREBI Fld(1,12,AC_MSKB1)//[12:12]
    #define MEMC_CMQ_ACT_ME_IDX_TOGGLE Fld(1,11,AC_MSKB1)//[11:11]
    #define MEMC_CMQ_ACT_ME_POS_OTHR_SEL Fld(2,9,AC_MSKB1)//[10:9]
    #define MEMC_CMQ_ACT_ME2_PAIR_FIRST Fld(1,8,AC_MSKB1)//[8:8]
    #define MEMC_CMQ_MV_READ_ZERO_TD Fld(1,7,AC_MSKB0)//[7:7]
    #define MEMC_CMQ_MV_READ_ZERO_BI Fld(1,6,AC_MSKB0)//[6:6]
    #define MEMC_CMQ_MV_READ_ZERO_CU Fld(1,5,AC_MSKB0)//[5:5]
    #define MEMC_CMQ_MV_READ_ZERO_PV Fld(1,4,AC_MSKB0)//[4:4]
    #define MEMC_CMQ_MV_TD_RD_ADR Fld(4,0,AC_MSKB0)//[3:0]
#define MEMC_CQ_REG_3 (MEMC_CMQ + 0x0D8)
    #define MEMC_CMQ_ACT_MC_ORI_EN Fld(1,21,AC_MSKB2)//[21:21]
    #define MEMC_CMQ_PLD_ME_ONLY_FRM Fld(1,20,AC_MSKB2)//[20:20]
    #define MEMC_CMQ_ACT_ME_ONLY_FRM Fld(1,19,AC_MSKB2)//[19:19]
    #define MEMC_CMQ_PLD_RESCAN_FRM_EN Fld(1,18,AC_MSKB2)//[18:18]
    #define MEMC_CMQ_ACT_RESCAN_FRM_EN Fld(1,17,AC_MSKB2)//[17:17]
    #define MEMC_CMQ_PLD_PAIR_FIRST Fld(1,16,AC_MSKB2)//[16:16]
    #define MEMC_CMQ_ACT_PAIR_FIRST_DLY Fld(1,15,AC_MSKB1)//[15:15]
    #define MEMC_CMQ_ACT_PAIR_FIRST Fld(1,14,AC_MSKB1)//[14:14]
    #define MEMC_CMQ_ACT_INTP_NUM2 Fld(5,9,AC_MSKB1)//[13:9]
    #define MEMC_CMQ_ACT_INTP_NUM1 Fld(5,4,AC_MSKW10)//[8:4]
    #define MEMC_CMQ_ACT_INTP_DEN Fld(4,0,AC_MSKB0)//[3:0]
#define MEMC_CQ_REG_4 (MEMC_CMQ + 0x0DC)
    #define MEMC_CMQ_ACT_MC2_NUM_RGN0 Fld(8,16,AC_FULLB2)//[23:16]
    #define MEMC_CMQ_ACT_MC1_NUM_RGN0 Fld(8,8,AC_FULLB1)//[15:8]
    #define MEMC_CMQ_ACT_MV1_NUM Fld(8,0,AC_FULLB0)//[7:0]
#define MEMC_CQ_REG_5 (MEMC_CMQ + 0x0E0)
    #define MEMC_CMQ_ACT_MV2_NUM Fld(8,16,AC_FULLB2)//[23:16]
    #define MEMC_CMQ_ACT_MC2_NUM_RGN2 Fld(8,8,AC_FULLB1)//[15:8]
    #define MEMC_CMQ_ACT_MC2_NUM_RGN1 Fld(8,0,AC_FULLB0)//[7:0]
#define MEMC_CQ_REG_6 (MEMC_CMQ + 0x0E4)
    #define MEMC_CMQ_EXTRA_CMD_ADDR_0 Fld(12,16,AC_MSKW32)//[27:16]
    #define MEMC_CMQ_ACT_MC1_NUM_RGN2 Fld(8,8,AC_FULLB1)//[15:8]
    #define MEMC_CMQ_ACT_MC1_NUM_RGN1 Fld(8,0,AC_FULLB0)//[7:0]
#define MEMC_CQ_REG_7 (MEMC_CMQ + 0x0E8)
    #define MEMC_CMQ_EXTRA_CMD_ADDR_2 Fld(12,12,AC_MSKW21)//[23:12]
    #define MEMC_CMQ_EXTRA_CMD_ADDR_1 Fld(12,0,AC_MSKW10)//[11:0]
#define MEMC_CQ_REG_8 (MEMC_CMQ + 0x0EC)
    #define MEMC_CMQ_EXTRA_CMD_ADDR_4 Fld(12,12,AC_MSKW21)//[23:12]
    #define MEMC_CMQ_EXTRA_CMD_ADDR_3 Fld(12,0,AC_MSKW10)//[11:0]
#define MEMC_CQ_REG_9 (MEMC_CMQ + 0x0F0)
    #define MEMC_CMQ_EXTRA_CMD_DATA_0 Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_CQ_REG_10 (MEMC_CMQ + 0x0F4)
    #define MEMC_CMQ_EXTRA_CMD_DATA_1 Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_CQ_REG_11 (MEMC_CMQ + 0x0F8)
    #define MEMC_CMQ_EXTRA_CMD_DATA_2 Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_CQ_REG_12 (MEMC_CMQ + 0x0FC)
    #define MEMC_CMQ_EXTRA_CMD_DATA_3 Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_CQ_REG_13 (MEMC_CMQ + 0x100)
    #define MEMC_CMQ_EXTRA_CMD_DATA_4 Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_CQ_REG_14 (MEMC_CMQ + 0x104)
    #define MEMC_CMQ_EXTRA_CMD_MASK_0 Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_CQ_REG_15 (MEMC_CMQ + 0x108)
    #define MEMC_CMQ_EXTRA_CMD_MASK_1 Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_CQ_REG_16 (MEMC_CMQ + 0x10C)
    #define MEMC_CMQ_EXTRA_CMD_MASK_2 Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_CQ_REG_17 (MEMC_CMQ + 0x110)
    #define MEMC_CMQ_EXTRA_CMD_MASK_3 Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_CQ_REG_18 (MEMC_CMQ + 0x114)
    #define MEMC_CMQ_EXTRA_CMD_MASK_4 Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_CQ_REG_19 (MEMC_CMQ + 0x118)
    #define MEMC_CMQ_WDMA_WRITE_DRAM_EN Fld(1,17,AC_MSKB2)//[17:17]
    #define MEMC_CMQ_RDMA_READ_DRAM_EN Fld(1,16,AC_MSKB2)//[16:16]
    #define MEMC_CMQ_RG_WDMA_FB_C_ADDR Fld(4,12,AC_MSKB1)//[15:12]
    #define MEMC_CMQ_RG_WDMA_FB_Y_ADDR Fld(4,8,AC_MSKB1)//[11:8]
    #define MEMC_CMQ_RG_RDMA_FB_C_ADDR Fld(4,4,AC_MSKB0)//[7:4]
    #define MEMC_CMQ_RG_RDMA_FB_Y_ADDR Fld(4,0,AC_MSKB0)//[3:0]
#define MEMC_CQ_REG_20 (MEMC_CMQ + 0x11C)
    #define MEMC_CMQ_WDMA_DRAM_REQ_C_EN Fld(1,19,AC_MSKB2)//[19:19]
    #define MEMC_CMQ_WDMA_DRAM_REQ_Y_EN Fld(1,18,AC_MSKB2)//[18:18]
    #define MEMC_CMQ_RDMA_DRAM_C_EN Fld(1,17,AC_MSKB2)//[17:17]
    #define MEMC_CMQ_RDMA_DRAM_Y_EN Fld(1,16,AC_MSKB2)//[16:16]
    #define MEMC_CMQ_WDMA_DRAM_REQ_C_TIM Fld(4,12,AC_MSKB1)//[15:12]
    #define MEMC_CMQ_WDMA_DRAM_REQ_Y_TIM Fld(4,8,AC_MSKB1)//[11:8]
    #define MEMC_CMQ_RDMA_DRAM_C_TIM Fld(4,4,AC_MSKB0)//[7:4]
    #define MEMC_CMQ_RDMA_DRAM_Y_TIM Fld(4,0,AC_MSKB0)//[3:0]
#define MEMC_CQ_REG_21 (MEMC_CMQ + 0x120)
    #define MEMC_CMQ_EXTRA_CMD_ADDR_6 Fld(12,12,AC_MSKW21)//[23:12]
    #define MEMC_CMQ_EXTRA_CMD_ADDR_5 Fld(12,0,AC_MSKW10)//[11:0]
#define MEMC_CQ_REG_22 (MEMC_CMQ + 0x124)
    #define MEMC_CMQ_EXTRA_CMD_ADDR_8 Fld(12,12,AC_MSKW21)//[23:12]
    #define MEMC_CMQ_EXTRA_CMD_ADDR_7 Fld(12,0,AC_MSKW10)//[11:0]
#define MEMC_CQ_REG_23 (MEMC_CMQ + 0x128)
    #define MEMC_CMQ_EXTRA_CMD_ADDR_9 Fld(12,0,AC_MSKW10)//[11:0]
#define MEMC_CQ_REG_24 (MEMC_CMQ + 0x12C)
    #define MEMC_CMQ_EXTRA_CMD_DATA_5 Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_CQ_REG_25 (MEMC_CMQ + 0x130)
    #define MEMC_CMQ_EXTRA_CMD_DATA_6 Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_CQ_REG_26 (MEMC_CMQ + 0x134)
    #define MEMC_CMQ_EXTRA_CMD_DATA_7 Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_CQ_REG_27 (MEMC_CMQ + 0x138)
    #define MEMC_CMQ_EXTRA_CMD_DATA_8 Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_CQ_REG_28 (MEMC_CMQ + 0x13C)
    #define MEMC_CMQ_EXTRA_CMD_DATA_9 Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_CQ_REG_29 (MEMC_CMQ + 0x140)
    #define MEMC_CMQ_EXTRA_CMD_MASK_5 Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_CQ_REG_30 (MEMC_CMQ + 0x144)
    #define MEMC_CMQ_EXTRA_CMD_MASK_6 Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_CQ_REG_31 (MEMC_CMQ + 0x148)
    #define MEMC_CMQ_EXTRA_CMD_MASK_7 Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_CQ_REG_32 (MEMC_CMQ + 0x14C)
    #define MEMC_CMQ_EXTRA_CMD_MASK_8 Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_CQ_REG_33 (MEMC_CMQ + 0x150)
    #define MEMC_CMQ_EXTRA_CMD_MASK_9 Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_CQ_REG_34 (MEMC_CMQ + 0x154)
    #define MEMC_CMQ_CMQ_SW_RST Fld(1,31,AC_MSKB3)//[31:31]
    #define MEMC_CMQ_CMQ_SW_START Fld(1,30,AC_MSKB3)//[30:30]
    #define MEMC_CMQ_CMQ_POST_SW_START Fld(1,29,AC_MSKB3)//[29:29]
    #define MEMC_CMQ_CMQ_PRE_SW_START Fld(1,28,AC_MSKB3)//[28:28]
    #define MEMC_CMQ_MJC_PREADY_MUX Fld(1,27,AC_MSKB3)//[27:27]
    #define MEMC_CMQ_CMQ_PREADY_MUX Fld(1,26,AC_MSKB3)//[26:26]
    #define MEMC_CMQ_CMQ_VSYNC_INV Fld(1,25,AC_MSKB3)//[25:25]
    #define MEMC_CMQ_CMQ_HV_INPUT_MUX Fld(1,24,AC_MSKB3)//[24:24]
#define MEMC_CQ_REG_35 (MEMC_CMQ + 0x158)
    #define MEMC_CMQ_CQ_PROC_NUM Fld(4,4,AC_MSKB0)//[7:4]
    #define MEMC_CMQ_FRAME_START_WRITE_DONE Fld(1,2,AC_MSKB0)//[2:2]
    #define MEMC_CMQ_CQ_WRITE_DONE Fld(1,1,AC_MSKB0)//[1:1]
    #define MEMC_CMQ_CQ_BUSY Fld(1,0,AC_MSKB0)//[0:0]
#define MEMC_CQ_REG_36 (MEMC_CMQ + 0x15C)
    #define MEMC_CMQ_RDMA_YADDR_STATUS Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_CQ_REG_37 (MEMC_CMQ + 0x160)
    #define MEMC_CMQ_RDMA_CADDR_STATUS Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_CQ_REG_38 (MEMC_CMQ + 0x164)
    #define MEMC_CMQ_WDMA_YADDR_STATUS Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_CQ_REG_39 (MEMC_CMQ + 0x168)
    #define MEMC_CMQ_WDMA_CADDR_STATUS Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_CQ_REG_40 (MEMC_CMQ + 0x16C)
    #define MEMC_CMQ_CMQ_WRITE_MEMC_DONE_EN Fld(1,31,AC_MSKB3)//[31:31]
    #define MEMC_CMQ_CMQ_WRITE_MEMC_DONE_CLR Fld(1,30,AC_MSKB3)//[30:30]
    #define MEMC_CMQ_CMQ_WRITE_MEMC_ERR_EN Fld(1,29,AC_MSKB3)//[29:29]
    #define MEMC_CMQ_CMQ_WRITE_MEMC_ERR_CLR Fld(1,28,AC_MSKB3)//[28:28]
    #define MEMC_CMQ_CMQ_WRITE_MEMC_SOF_EN Fld(1,27,AC_MSKB3)//[27:27]
    #define MEMC_CMQ_CMQ_WRITE_MEMC_SOF_CLR Fld(1,26,AC_MSKB3)//[26:26]
    #define MEMC_CMQ_SMI2DRAM_DMA_ADDR_OVERFLOW_EN Fld(1,25,AC_MSKB3)//[25:25]
    #define MEMC_CMQ_SMI2DRAM_DMA_ADDR_OVERFLOW_CLR Fld(1,24,AC_MSKB3)//[24:24]
    #define MEMC_CMQ_SMI2DRAM_DMA_ADDR_UNDERFLOW_EN Fld(1,23,AC_MSKB2)//[23:23]
    #define MEMC_CMQ_SMI2DRAM_DMA_ADDR_UNDERFLOW_CLR Fld(1,22,AC_MSKB2)//[22:22]
    #define MEMC_CMQ_SMI2DRAM_DMA_DATA_OVERFLOW_EN Fld(1,21,AC_MSKB2)//[21:21]
    #define MEMC_CMQ_SMI2DRAM_DMA_DATA_OVERFLOW_CLR Fld(1,20,AC_MSKB2)//[20:20]
    #define MEMC_CMQ_SMI2DRAM_DMA_DATA_UNDERFLOW_EN Fld(1,19,AC_MSKB2)//[19:19]
    #define MEMC_CMQ_SMI2DRAM_DMA_DATA_UNDERFLOW_CLR Fld(1,18,AC_MSKB2)//[18:18]
    #define MEMC_CMQ_SMI2DRAM_MV_ADDR_OVERFLOW_EN Fld(1,17,AC_MSKB2)//[17:17]
    #define MEMC_CMQ_SMI2DRAM_MV_ADDR_OVERFLOW_CLR Fld(1,16,AC_MSKB2)//[16:16]
    #define MEMC_CMQ_SMI2DRAM_MV_ADDR_UNDERFLOW_EN Fld(1,15,AC_MSKB1)//[15:15]
    #define MEMC_CMQ_SMI2DRAM_MV_ADDR_UNDERFLOW_CLR Fld(1,14,AC_MSKB1)//[14:14]
    #define MEMC_CMQ_SMI2DRAM_MV_DATA_OVERFLOW_EN Fld(1,13,AC_MSKB1)//[13:13]
    #define MEMC_CMQ_SMI2DRAM_MV_DATA_OVERFLOW_CLR Fld(1,12,AC_MSKB1)//[12:12]
    #define MEMC_CMQ_SMI2DRAM_MV_DATA_UNDERFLOW_EN Fld(1,11,AC_MSKB1)//[11:11]
    #define MEMC_CMQ_SMI2DRAM_MV_DATA_UNDERFLOW_CLR Fld(1,10,AC_MSKB1)//[10:10]
#define MEMC_CQ_REG_41 (MEMC_CMQ + 0x170)
    #define MEMC_CMQ_MJC_FRAME_DONE_STATUS Fld(1,31,AC_MSKB3)//[31:31]
    #define MEMC_CMQ_MEMC_PRE_FRAME_DONE_STATUS Fld(1,30,AC_MSKB3)//[30:30]
    #define MEMC_CMQ_MEMC_POST_FRAME_DONE_STATUS Fld(1,29,AC_MSKB3)//[29:29]
    #define MEMC_CMQ_WRITE_MEMC_DONE_STATUS Fld(1,28,AC_MSKB3)//[28:28]
    #define MEMC_CMQ_WRITE_MEMC_ERR_STATUS Fld(1,27,AC_MSKB3)//[27:27]
    #define MEMC_CMQ_WRITE_MEMC_SOF_STATUS Fld(1,26,AC_MSKB3)//[26:26]
    #define MEMC_CMQ_FSM_STATUS Fld(6,20,AC_MSKW32)//[25:20]
#define MEMC_CQ_REG_42 (MEMC_CMQ + 0x174)
    #define MEMC_CMQ_MJC_FRAME_DONE_STATUS_CLR Fld(1,31,AC_MSKB3)//[31:31]
    #define MEMC_CMQ_MEMC_PRE_FRAME_DONE_STATUS_CLR Fld(1,30,AC_MSKB3)//[30:30]
    #define MEMC_CMQ_MEMC_POST_FRAME_DONE_STATUS_CLR Fld(1,29,AC_MSKB3)//[29:29]
    #define MEMC_CMQ_WRITE_MEMC_DONE_STATUS_CLR Fld(1,28,AC_MSKB3)//[28:28]
    #define MEMC_CMQ_WRITE_MEMC_ERR_STATUS_CLR Fld(1,27,AC_MSKB3)//[27:27]
    #define MEMC_CMQ_WRITE_MEMC_SOF_STATUS_CLR Fld(1,26,AC_MSKB3)//[26:26]
#define MEMC_CQ_REG_43 (MEMC_CMQ + 0x178)
    #define MEMC_CMQ_V_TOTAL Fld(16,16,AC_FULLW32)//[31:16]
    #define MEMC_CMQ_V_CNT Fld(16,0,AC_FULLW10)//[15:0]
#define MEMC_MEMC_READ_00 (MEMC_CMQ + 0x200)
    #define MEMC_CMQ_START_READ_NUM_MV_RD Fld(5,10,AC_MSKB1)//[14:10]
    #define MEMC_CMQ_START_READ_NUM_DMA_RD Fld(6,4,AC_MSKW10)//[9:4]
    #define MEMC_CMQ_MJCMV_RD_TPM1R_DELSEL Fld(2,2,AC_MSKB0)//[3:2]
    #define MEMC_CMQ_DMA_RD_TPM1R_DELSEL Fld(2,0,AC_MSKB0)//[1:0]
#define MEMC_MEMC_READ_01 (MEMC_CMQ + 0x204)
    #define MEMC_CMQ_MV_ADDR_LIMIT Fld(16,16,AC_FULLW32)//[31:16]
    #define MEMC_CMQ_DMA_ADDR_LIMIT Fld(16,0,AC_FULLW10)//[15:0]
#define MEMC_MEMC_READ_02 (MEMC_CMQ + 0x208)
    #define MEMC_CMQ_ASYNC_VSYNC_RST_AT_RISE Fld(1,20,AC_MSKB2)//[20:20]
    #define MEMC_CMQ_MV_ASYNC_VSYNC_RST_SEL Fld(1,19,AC_MSKB2)//[19:19]
    #define MEMC_CMQ_DMA_ASYNC_VSYNC_RST_SEL Fld(1,18,AC_MSKB2)//[18:18]
    #define MEMC_CMQ_MV_ASYNC_VSYNC_RST_EN Fld(1,17,AC_MSKB2)//[17:17]
    #define MEMC_CMQ_DMA_ASYNC_VSYNC_RST_EN Fld(1,16,AC_MSKB2)//[16:16]
    #define MEMC_CMQ_DMA_BURST_DIFF_THR Fld(8,8,AC_FULLB1)//[15:8]
    #define MEMC_CMQ_DMA_REQ_LIMIT Fld(8,0,AC_FULLB0)//[7:0]

//Page CMQ_2
#define MEMC_MEMC_AXI1_00 (MEMC_CMQ + 0x300)
    #define MEMC_CMQ_MJCMV_WR_SW_RST Fld(1,7,AC_MSKB0)//[7:7]
    #define MEMC_CMQ_MJCMV_WR_DRAM_P_CLK_SW_RST Fld(1,6,AC_MSKB0)//[6:6]
    #define MEMC_CMQ_MJCMV_WR_DRAM_M_CLK_SW_RST Fld(1,5,AC_MSKB0)//[5:5]
    #define MEMC_CMQ_MJCMV_WR_AGENT_P_CLK_SW_RST Fld(1,4,AC_MSKB0)//[4:4]
    #define MEMC_CMQ_MJCMV_WR_AGENT_M_CLK_SW_RST Fld(1,3,AC_MSKB0)//[3:3]
    #define MEMC_CMQ_MJCMV_WR_BLD_CLK_SW_RST Fld(1,2,AC_MSKB0)//[2:2]
    #define MEMC_CMQ_MJCMV_WR_APB_CLK_SW_RST Fld(1,1,AC_MSKB0)//[1:1]
    #define MEMC_CMQ_MJCMV_WR_BIM_CLK_SW_RST Fld(1,0,AC_MSKB0)//[0:0]
#define MEMC_MEMC_AXI1_01 (MEMC_CMQ + 0x304)
    #define MEMC_CMQ_MJCMV_WR_DA_ARB_PIPW_TIM Fld(4,28,AC_MSKB3)//[31:28]
    #define MEMC_CMQ_MJCMV_WR_DA_ARB_MAINW_TIM Fld(4,24,AC_MSKB3)//[27:24]
    #define MEMC_CMQ_MJCMV_WR_DA_ARB_BLDR_TIM Fld(4,20,AC_MSKB2)//[23:20]
    #define MEMC_CMQ_MJCMV_WR_DA_ARB_DMMONSEL Fld(6,12,AC_MSKW21)//[17:12]
    #define MEMC_CMQ_MJCMV_WR_DA_ARB_DMAGBALL Fld(1,10,AC_MSKB1)//[10:10]
    #define MEMC_CMQ_MJCMV_WR_DA_ARB_DMARBRST Fld(1,9,AC_MSKB1)//[9:9]
    #define MEMC_CMQ_MJCMV_WR_DA_ARB_DMTIMARBEN Fld(1,8,AC_MSKB1)//[8:8]
    #define MEMC_CMQ_MJCMV_WR_DA_ARB_DMAGBMEND Fld(1,7,AC_MSKB0)//[7:7]
    #define MEMC_CMQ_MJCMV_WR_DA_ARB_DMAGBMAGID Fld(3,4,AC_MSKB0)//[6:4]
    #define MEMC_CMQ_MJCMV_WR_DA_ARB_DMAGBMBEG Fld(1,3,AC_MSKB0)//[3:3]
    #define MEMC_CMQ_MJCMV_WR_DA_ARB_PIPW_EN Fld(1,2,AC_MSKB0)//[2:2]
    #define MEMC_CMQ_MJCMV_WR_DA_ARB_MAINW_EN Fld(1,1,AC_MSKB0)//[1:1]
    #define MEMC_CMQ_MJCMV_WR_DA_ARB_BLDR_EN Fld(1,0,AC_MSKB0)//[0:0]
#define MEMC_MEMC_AXI1_02 (MEMC_CMQ + 0x308)
    #define MEMC_CMQ_MJCMV_WR_C_MAIN_10B_SEL Fld(1,10,AC_MSKB1)//[10:10]
    #define MEMC_CMQ_MJCMV_WR_C_MODE_SEL Fld(2,8,AC_MSKB1)//[9:8]
    #define MEMC_CMQ_MJCMV_WR_C_BLD_DEBUG_SEL Fld(4,4,AC_MSKB0)//[7:4]
    #define MEMC_CMQ_MJCMV_WR_REQUEST_QUEUE_EMPTY Fld(1,0,AC_MSKB0)//[0:0]
#define MEMC_MEMC_AXI1_04 (MEMC_CMQ + 0x310)
    #define MEMC_CMQ_MJCMV_WR_DMMERGE_MON Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_MEMC_AXI1_05 (MEMC_CMQ + 0x314)
    #define MEMC_CMQ_MJCMV_WR_BLD_IRQ_X Fld(5,11,AC_MSKB1)//[15:11]
    #define MEMC_CMQ_MJCMV_WR_BLDIRQ_H7_X Fld(1,10,AC_MSKB1)//[10:10]
    #define MEMC_CMQ_MJCMV_WR_BLDIRQ_H6_X Fld(1,9,AC_MSKB1)//[9:9]
    #define MEMC_CMQ_MJCMV_WR_BLDIRQ_H5_X Fld(1,8,AC_MSKB1)//[8:8]
    #define MEMC_CMQ_MJCMV_WR_BLDIRQ_H4_X Fld(1,7,AC_MSKB0)//[7:7]
    #define MEMC_CMQ_MJCMV_WR_BLDIRQ_H3_X Fld(1,6,AC_MSKB0)//[6:6]
    #define MEMC_CMQ_MJCMV_WR_BLDIRQ_H2_X Fld(1,5,AC_MSKB0)//[5:5]
    #define MEMC_CMQ_MJCMV_WR_BLDIRQ_H1_X Fld(1,4,AC_MSKB0)//[4:4]
    #define MEMC_CMQ_MJCMV_WR_BLDIRQ_H0_X Fld(1,3,AC_MSKB0)//[3:3]
    #define MEMC_CMQ_MJCMV_WR_BLDIRQ_MMU_X Fld(1,2,AC_MSKB0)//[2:2]
    #define MEMC_CMQ_MJCMV_WR_BLDIRQ_ERR_X Fld(1,1,AC_MSKB0)//[1:1]
    #define MEMC_CMQ_MJCMV_WR_BLDIRQ_X Fld(1,0,AC_MSKB0)//[0:0]
#define MEMC_MEMC_AXI1_06 (MEMC_CMQ + 0x318)
    #define MEMC_CMQ_MJCMV_WR_BLD_CSR_ATPG_OB Fld(1,4,AC_MSKB0)//[4:4]
    #define MEMC_CMQ_MJCMV_WR_BLD_CSR_ATPG_CT Fld(1,3,AC_MSKB0)//[3:3]
    #define MEMC_CMQ_MJCMV_WR_TPM1R_DELSEL Fld(2,1,AC_MSKB0)//[2:1]
    #define MEMC_CMQ_MJCMV_WR_BGAXI_MERGE_ENA Fld(1,0,AC_MSKB0)//[0:0]
#define MEMC_MEMC_AXI1_07 (MEMC_CMQ + 0x31C)
    #define MEMC_CMQ_MJCMV_WR_BGG3D_IRQ_REG Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_MEMC_AXI1_08 (MEMC_CMQ + 0x320)
    #define MEMC_CMQ_MJCMV_WR_BGG3D_IRQ_REG2 Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_MEMC_AXI1_09 (MEMC_CMQ + 0x324)
    #define MEMC_CMQ_MJCMV_WR_BGG3D_AXI_REG Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_MEMC_AXI1_10 (MEMC_CMQ + 0x328)
    #define MEMC_CMQ_MJCMV_WR_BGG3D_AXI_REG1 Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_MEMC_AXI1_11 (MEMC_CMQ + 0x330)
    #define MEMC_CMQ_MJCMV_WR_BGG3D_MERGE_REG Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_MEMC_AXI1_12 (MEMC_CMQ + 0x334)
    #define MEMC_CMQ_MJCMV_WR_BGG3D_MERGE_REG2 Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_MEMC_AXI1_13 (MEMC_CMQ + 0x338)
    #define MEMC_CMQ_MJCMV_WR_MFG_MEM_REG_AR_FCTRL_EN Fld(1,10,AC_MSKB1)//[10:10]
    #define MEMC_CMQ_MJCMV_WR_MFG_MEM_DEPTH_VAL Fld(6,4,AC_MSKW10)//[9:4]
    #define MEMC_CMQ_MJCMV_WR_MFG_MEM_SLV_SYNC_SEL Fld(2,2,AC_MSKB0)//[3:2]
    #define MEMC_CMQ_MJCMV_WR_MFG_MEM_MST_SYNC_SEL Fld(2,0,AC_MSKB0)//[1:0]
#define MEMC_MEMC_AXI1_14 (MEMC_CMQ + 0x33C)
    #define MEMC_CMQ_MJCMV_WR_REORDER_WRITE Fld(1,4,AC_MSKB0)//[4:4]
    #define MEMC_CMQ_MJCMV_WR_RLEN_ERROR Fld(1,3,AC_MSKB0)//[3:3]
    #define MEMC_CMQ_MJCMV_WR_WLEN_ERROR Fld(1,2,AC_MSKB0)//[2:2]
    #define MEMC_CMQ_MJCMV_WR_READ_FAIL Fld(1,1,AC_MSKB0)//[1:1]
    #define MEMC_CMQ_MJCMV_WR_WRITE_FAIL Fld(1,0,AC_MSKB0)//[0:0]
#define MEMC_MEMC_AXI1_15 (MEMC_CMQ + 0x340)
    #define MEMC_CMQ_MJCMV_WR_WRITE_FAIL_ADDR Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_MEMC_AXI1_16 (MEMC_CMQ + 0x344)
    #define MEMC_CMQ_MJCMV_WR_READ_FAIL_ADDR Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_MEMC_AXI1_17 (MEMC_CMQ + 0x348)
    #define MEMC_CMQ_MJCMV_WR_WLEN_ERROR_ADDR Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_MEMC_AXI1_18 (MEMC_CMQ + 0x34C)
    #define MEMC_CMQ_MJCMV_WR_RLEN_ERROR_ADDR Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_MEMC_AXI1_19 (MEMC_CMQ + 0x350)
    #define MEMC_CMQ_MJCMV_WR_REORDER_WRITE_ADDR Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_MEMC_AXI1_20 (MEMC_CMQ + 0x354)
    #define MEMC_CMQ_MJCMV_WR_WPSTCTL_DEBUG0 Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_MEMC_AXI1_21 (MEMC_CMQ + 0x358)
    #define MEMC_CMQ_MJCMV_WR_WPSTCTL_DEBUG1 Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_MEMC_AXI1_22 (MEMC_CMQ + 0x35C)
    #define MEMC_CMQ_MJCMV_WR_WPSTCTL_DEBUG2 Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_MEMC_AXI1_23 (MEMC_CMQ + 0x360)
    #define MEMC_CMQ_MJCMV_WR_RPSTCTL_DEBUG0 Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_MEMC_AXI1_24 (MEMC_CMQ + 0x364)
    #define MEMC_CMQ_MJCMV_WR_MERGECTL_DEBUG0 Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_MEMC_AXI1_25 (MEMC_CMQ + 0x368)
    #define MEMC_CMQ_MJCMV_WR_MERGECTL_DEBUG1 Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_MEMC_AXI1_26 (MEMC_CMQ + 0x36C)
    #define MEMC_CMQ_MJCMV_WR_MERGECTL_DEBUG2 Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_MEMC_AXI1_27 (MEMC_CMQ + 0x370)
    #define MEMC_CMQ_MJCMV_WR_MERGECTL_DEBUG3 Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_MEMC_AXI1_28 (MEMC_CMQ + 0x374)
    #define MEMC_CMQ_MJCMV_WR_MERGECTL_DEBUG4 Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_MEMC_AXI1_29 (MEMC_CMQ + 0x378)
    #define MEMC_CMQ_MJCMV_WR_MERGECTL_DEBUG5 Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_MEMC_AXI1_30 (MEMC_CMQ + 0x37C)
    #define MEMC_CMQ_MJCMV_WR_MERGECTL_DEBUG6 Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_MEMC_AXI1_31 (MEMC_CMQ + 0x380)
    #define MEMC_CMQ_MJCMV_WR_MERGECTL_DEBUG7 Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_MEMC_AXI1_32 (MEMC_CMQ + 0x384)
    #define MEMC_CMQ_MJCMV_WR_MERGECTL_DEBUG8 Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_MEMC_AXI1_33 (MEMC_CMQ + 0x388)
    #define MEMC_CMQ_MJCMV_WR_MERGECTL_DEBUG9 Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_MEMC_AXI1_34 (MEMC_CMQ + 0x38C)
    #define MEMC_CMQ_MJCMV_WR_MERGECTL_DEBUG10 Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_MEMC_AXI1_35 (MEMC_CMQ + 0x390)
    #define MEMC_CMQ_MJCMV_WR_MERGECTL_DEBUG11 Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_MEMC_AXI1_36 (MEMC_CMQ + 0x394)
    #define MEMC_CMQ_MJCMV_WR_MERGECTL_DEBUG12 Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_MEMC_AXI1_37 (MEMC_CMQ + 0x398)
    #define MEMC_CMQ_MJCMV_WR_MERGECTL_DEBUG13 Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_MEMC_AXI1_38 (MEMC_CMQ + 0x39C)
    #define MEMC_CMQ_MJCMV_WR_MERGECTL_DEBUG14 Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_MEMC_AXI1_39 (MEMC_CMQ + 0x3A0)
    #define MEMC_CMQ_MJCMV_WR_MERGECTL_DEBUG15 Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_MEMC_AXI1_40 (MEMC_CMQ + 0x3A4)
    #define MEMC_CMQ_MJCMV_WR_MERGECTL_DEBUG16 Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_MEMC_AXI1_41 (MEMC_CMQ + 0x3A8)
    #define MEMC_CMQ_MJCMV_WR_MERGECTL_DEBUG17 Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_MEMC_AXI1_42 (MEMC_CMQ + 0x3AC)
    #define MEMC_CMQ_MJCMV_WR_MERGECTL_DEBUG18 Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_MEMC_AXI1_43 (MEMC_CMQ + 0x3B0)
    #define MEMC_CMQ_MJCMV_WR_MERGECTL_DEBUG19 Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_MEMC_AXI1_44 (MEMC_CMQ + 0x3B4)
    #define MEMC_CMQ_MJCMV_WR_MERGECTL_DEBUG20 Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_MEMC_AXI1_45 (MEMC_CMQ + 0x3B8)
    #define MEMC_CMQ_MJCMV_WR_MERGECTL_DEBUG21 Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_MEMC_AXI1_46 (MEMC_CMQ + 0x3BC)
    #define MEMC_CMQ_MJCMV_WR_MERGECTL_DEBUG22 Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_MEMC_AXI1_47 (MEMC_CMQ + 0x3C0)
    #define MEMC_CMQ_MJCMV_WR_MERGECTL_DEBUG23 Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_MEMC_AXI1_48 (MEMC_CMQ + 0x3C4)
    #define MEMC_CMQ_MJCMV_WR_MERGECTL_DEBUG24 Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_MEMC_AXI1_49 (MEMC_CMQ + 0x3C8)
    #define MEMC_CMQ_MJCMV_WR_MERGECTL_DEBUG25 Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_MEMC_AXI1_50 (MEMC_CMQ + 0x3CC)
    #define MEMC_CMQ_MJCMV_WR_AXI_DRAMIF_DEBUG0 Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_MEMC_AXI1_51 (MEMC_CMQ + 0x3D0)
    #define MEMC_CMQ_MJCMV_WR_AXI_DRAMIF_DEBUG1 Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_MEMC_AXI1_52 (MEMC_CMQ + 0x3D4)
    #define MEMC_CMQ_MJCMV_WR_AXI_DRAMIF_DEBUG2 Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_MEMC_AXI1_53 (MEMC_CMQ + 0x3D8)
    #define MEMC_CMQ_MJCMV_WR_AXI_DRAMIF_DEBUG3 Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_MEMC_AXI1_54 (MEMC_CMQ + 0x3DC)
    #define MEMC_CMQ_MJCMV_WR_AXI_DRAMIF_DEBUG4 Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_MEMC_AXI1_55 (MEMC_CMQ + 0x3E0)
    #define MEMC_CMQ_MJCMV_WR_AXI_WRITE_DEBUG00 Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_MEMC_AXI1_56 (MEMC_CMQ + 0x3E4)
    #define MEMC_CMQ_MJCMV_WR_AXI_WRITE_DEBUG01 Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_MEMC_AXI1_57 (MEMC_CMQ + 0x3E8)
    #define MEMC_CMQ_MJCMV_WR_AXI_WRITE_DEBUG02 Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_MEMC_AXI1_58 (MEMC_CMQ + 0x3EC)
    #define MEMC_CMQ_MJCMV_WR_AXI_WRITE_DEBUG03 Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_MEMC_AXI1_59 (MEMC_CMQ + 0x3F0)
    #define MEMC_CMQ_MJCMV_WR_AXI_WRITE_DEBUG04 Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_MEMC_AXI1_60 (MEMC_CMQ + 0x3F4)
    #define MEMC_CMQ_MJCMV_WR_AXI_WRITE_DEBUG05 Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_MEMC_AXI1_61 (MEMC_CMQ + 0x3F8)
    #define MEMC_CMQ_MJCMV_WR_AXI_WRITE_DEBUG06 Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_MEMC_AXI1_62 (MEMC_CMQ + 0x3FC)
    #define MEMC_CMQ_MJCMV_WR_AXI_WRITE_DEBUG07 Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_MEMC_AXI1_63 (MEMC_CMQ + 0x400)
    #define MEMC_CMQ_MJCMV_WR_AXI_WRITE_DEBUG08 Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_MEMC_AXI1_64 (MEMC_CMQ + 0x404)
    #define MEMC_CMQ_MJCMV_WR_AXI_WRITE_DEBUG09 Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_MEMC_AXI1_65 (MEMC_CMQ + 0x408)
    #define MEMC_CMQ_MJCMV_WR_AXI_WRITE_DEBUG10 Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_MEMC_AXI1_66 (MEMC_CMQ + 0x40C)
    #define MEMC_CMQ_MJCMV_WR_AXI_WRITE_DEBUG11 Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_MEMC_AXI1_67 (MEMC_CMQ + 0x410)
    #define MEMC_CMQ_MJCMV_WR_AXI_READ_DEBUG00 Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_MEMC_AXI1_68 (MEMC_CMQ + 0x414)
    #define MEMC_CMQ_MJCMV_WR_AXI_READ_DEBUG01 Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_MEMC_AXI1_69 (MEMC_CMQ + 0x418)
    #define MEMC_CMQ_MJCMV_WR_AXI_READ_DEBUG02 Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_MEMC_AXI1_70 (MEMC_CMQ + 0x41C)
    #define MEMC_CMQ_MJCMV_WR_AXI_READ_DEBUG03 Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_MEMC_AXI1_71 (MEMC_CMQ + 0x420)
    #define MEMC_CMQ_MJCMV_WR_AXI_READ_DEBUG04 Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_MEMC_AXI1_72 (MEMC_CMQ + 0x424)
    #define MEMC_CMQ_MJCMV_WR_AXI_READ_DEBUG05 Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_MEMC_AXI1_73 (MEMC_CMQ + 0x428)
    #define MEMC_CMQ_MJCMV_WR_AXI_READ_DEBUG06 Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_MEMC_AXI1_74 (MEMC_CMQ + 0x430)
    #define MEMC_CMQ_MJCMV_WR_AXI_READ_DEBUG07 Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_MEMC_AXI1_75 (MEMC_CMQ + 0x434)
    #define MEMC_CMQ_MJCMV_WR_AXI_READ_DEBUG08 Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_MEMC_AXI1_76 (MEMC_CMQ + 0x438)
    #define MEMC_CMQ_MJCMV_WR_AXI_READ_DEBUG09 Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_MEMC_AXI1_77 (MEMC_CMQ + 0x43C)
    #define MEMC_CMQ_MJCMV_WR_AXI_READ_DEBUG10 Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_MEMC_AXI1_78 (MEMC_CMQ + 0x440)
    #define MEMC_CMQ_MJCMV_WR_AXI_READ_DEBUG11 Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_MEMC_AXI1_79 (MEMC_CMQ + 0x444)
    #define MEMC_CMQ_MJCMV_WR_AXI_READ_DEBUG12 Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_MEMC_AXI1_80 (MEMC_CMQ + 0x448)
    #define MEMC_CMQ_MJCMV_WR_AXI_READ_DEBUG13 Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_MEMC_AXI1_81 (MEMC_CMQ + 0x44C)
    #define MEMC_CMQ_MJCMV_WR_AXI_READ_DEBUG14 Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_MEMC_AXI1_82 (MEMC_CMQ + 0x450)
    #define MEMC_CMQ_MJCMV_WR_AXI_READ_DEBUG15 Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_MEMC_AXI1_83 (MEMC_CMQ + 0x454)
    #define MEMC_CMQ_MJCMV_WR_AXI_READ_DEBUG16 Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_MEMC_AXI1_84 (MEMC_CMQ + 0x458)
    #define MEMC_CMQ_MJCMV_WR_AXI_DEBUG0 Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_MEMC_AXI1_85 (MEMC_CMQ + 0x45C)
    #define MEMC_CMQ_MJCMV_WR_IRQGP_DEBUG Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_MEMC_AXI1_86 (MEMC_CMQ + 0x460)
    #define MEMC_CMQ_MJCMV_WR_BGCHKSUM_CLR Fld(1,0,AC_MSKB0)//[0:0]
#define MEMC_MEMC_AXI1_87 (MEMC_CMQ + 0x464)
    #define MEMC_CMQ_MJCMV_WR_AXI_DRAMIF_IN_RD_ADDR_CHKSUM Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_MEMC_AXI1_88 (MEMC_CMQ + 0x468)
    #define MEMC_CMQ_MJCMV_WR_AXI_DRAMIF_IN_RD_DATA_CHKSUM Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_MEMC_AXI1_89 (MEMC_CMQ + 0x46C)
    #define MEMC_CMQ_MJCMV_WR_AXI_DRAMIF_IN_WR_ADDR_CHKSUM Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_MEMC_AXI1_90 (MEMC_CMQ + 0x470)
    #define MEMC_CMQ_MJCMV_WR_AXI_DRAMIF_IN_WR_DATA_CHKSUM Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_MEMC_AXI1_91 (MEMC_CMQ + 0x474)
    #define MEMC_CMQ_MJCMV_WR_AXI_DRAMIF_OUT_RD_ADDR_CHKSUM Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_MEMC_AXI1_92 (MEMC_CMQ + 0x478)
    #define MEMC_CMQ_MJCMV_WR_AXI_DRAMIF_OUT_RD_DATA_CHKSUM Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_MEMC_AXI1_93 (MEMC_CMQ + 0x47C)
    #define MEMC_CMQ_MJCMV_WR_AXI_DRAMIF_OUT_WR_ADDR_CHKSUM Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_MEMC_AXI1_94 (MEMC_CMQ + 0x480)
    #define MEMC_CMQ_MJCMV_WR_AXI_DRAMIF_OUT_WR_DATA_CHKSUM Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_MEMC_AXI1_95 (MEMC_CMQ + 0x484)
    #define MEMC_CMQ_MJCMV_WR_MERGE_OUT_RD_ADDR_CHKSUM Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_MEMC_AXI1_96 (MEMC_CMQ + 0x488)
    #define MEMC_CMQ_MJCMV_WR_MERGE_OUT_RD_DATA_CHKSUM Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_MEMC_AXI1_97 (MEMC_CMQ + 0x48C)
    #define MEMC_CMQ_MJCMV_WR_MERGE_OUT_WR_ADDR_CHKSUM Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_MEMC_AXI1_98 (MEMC_CMQ + 0x490)
    #define MEMC_CMQ_MJCMV_WR_MERGE_OUT_WR_DATA_CHKSUM Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_MEMC_AXI1_99 (MEMC_CMQ + 0x494)
    #define MEMC_CMQ_MJCMV_WR_BM_LENGTH_COUNTER_CHA Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_MEMC_AXI1_100 (MEMC_CMQ + 0x498)
    #define MEMC_CMQ_MJCMV_WR_BM_CYCLE_COUNTER_CHA Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_MEMC_AXI1_101 (MEMC_CMQ + 0x49C)
    #define MEMC_CMQ_MJCMV_WR_BM_LENGTH_COUNTER_CHB Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_MEMC_AXI1_102 (MEMC_CMQ + 0x4A0)
    #define MEMC_CMQ_MJCMV_WR_BM_CYCLE_COUNTER_CHB Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_MEMC_AXI1_103 (MEMC_CMQ + 0x4A4)
    #define MEMC_CMQ_MJCMV_WR_BM_LENGTH_COUNTER_CHC Fld(32,0,AC_FULLDW)//[31:0]
#define MEMC_MEMC_AXI1_104 (MEMC_CMQ + 0x4A8)
    #define MEMC_CMQ_MJCMV_WR_BM_CYCLE_COUNTER_CHC Fld(32,0,AC_FULLDW)//[31:0]

#endif