#ifndef _HW_P2S_H_
#define _HW_P2S_H_

#define P2S_BASE  (IO_VIRT_SRE+ 0x41000)

#define PAT_MON_00 (P2S_BASE + 0xC40)
    #define C_MON_SELFGEN_EN Fld(1,31,AC_MSKB3)//[31:31]
    #define C_MON_SELF_DISP_R_EN Fld(1,30,AC_MSKB3)//[30:30]
    #define C_MON_SELF_FLD_EN Fld(1,29,AC_MSKB3)//[29:29]
    #define C_MON_SELF_VT Fld(13,16,AC_MSKW32)//[28:16]
    #define C_MON_TIME_MODE Fld(2,14,AC_MSKB1)//[15:14]
    #define C_MON_SELF_HT Fld(14,0,AC_MSKW10)//[13:0]
#define PAT_MON_01 (P2S_BASE + 0xC44)
    #define C_MON_TIME_EN Fld(4,28,AC_MSKB3)//[31:28]
    #define C_MON_V_ACT Fld(12,16,AC_MSKW32)//[27:16]
    #define C_MON_TIME_STEP Fld(3,13,AC_MSKB1)//[15:13]
    #define C_MON_H_ACT Fld(13,0,AC_MSKW10)//[12:0]
#define PAT_MON_02 (P2S_BASE + 0xC48)
    #define C_MON_SELF_DE_N Fld(5,27,AC_MSKB3)//[31:27]
    #define C_MON_NOISE_EN Fld(3,24,AC_MSKB3)//[26:24]
    #define C_MON_V_OFFSET Fld(8,16,AC_FULLB2)//[23:16]
    #define C_MON_PAT_TYPE Fld(4,12,AC_MSKB1)//[15:12]
    #define C_MON_NOISE_LEVEL Fld(4,8,AC_MSKB1)//[11:8]
    #define C_MON_H_OFFSET Fld(8,0,AC_FULLB0)//[7:0]
#define PAT_MON_03 (P2S_BASE + 0xC4C)
    #define C_MON_SELF_DE_M Fld(5,27,AC_MSKB3)//[31:27]
    #define PRE_PAT_MON_ATPG_OB Fld(1,26,AC_MSKB3)//[26:26]
    #define PRE_PAT_MON_ATPG_CT Fld(1,25,AC_MSKB3)//[25:25]
    #define C_MON_GRID_WIDTH Fld(1,24,AC_MSKB3)//[24:24]
    #define C_MON_V_GRID Fld(8,16,AC_FULLB2)//[23:16]
    #define C_MON_BORDER_EN Fld(4,12,AC_MSKB1)//[15:12]
    #define C_MON_MAX_F Fld(4,8,AC_MSKB1)//[11:8]
    #define C_MON_H_GRID Fld(8,0,AC_FULLB0)//[7:0]
#define PAT_MON_04 (P2S_BASE + 0xC50)
    #define C_MON_HV_MODE Fld(2,30,AC_MSKB3)//[31:30]
    #define C_MON_FC_CR Fld(10,20,AC_MSKW32)//[29:20]
    #define C_MON_FC_CB Fld(10,10,AC_MSKW21)//[19:10]
    #define C_MON_FC_Y Fld(10,0,AC_MSKW10)//[9:0]
#define PAT_MON_05 (P2S_BASE + 0xC54)
    #define C_MON_COLOR_MODE Fld(2,30,AC_MSKB3)//[31:30]
    #define C_MON_BC_CR Fld(10,20,AC_MSKW32)//[29:20]
    #define C_MON_BC_CB Fld(10,10,AC_MSKW21)//[19:10]
    #define C_MON_BC_Y Fld(10,0,AC_MSKW10)//[9:0]
#define PAT_MON_06 (P2S_BASE + 0xC58)
    #define C_MON_PRB_EN Fld(4,28,AC_MSKB3)//[31:28]
    #define C_MON_PRB_Y_POS Fld(12,16,AC_MSKW32)//[27:16]
    #define C_MON_PRB_CURSOR_ON Fld(1,15,AC_MSKB1)//[15:15]
    #define C_MON_PRB_OSD_ON Fld(1,14,AC_MSKB1)//[14:14]
    #define C_MON_VS_NOT_ALIGN_H Fld(1,13,AC_MSKB1)//[13:13]
    #define C_MON_PRB_X_POS Fld(13,0,AC_MSKW10)//[12:0]
#define PAT_MON_07 (P2S_BASE + 0xC5C)
    #define S_MON_PRB_DISP_R Fld(1,31,AC_MSKB3)//[31:31]
    #define S_MON_PRB_FLD Fld(1,30,AC_MSKB3)//[30:30]
    #define S_MON_PRB_CR Fld(10,20,AC_MSKW32)//[29:20]
    #define S_MON_PRB_CB Fld(10,10,AC_MSKW21)//[19:10]
    #define S_MON_PRB_Y Fld(10,0,AC_MSKW10)//[9:0]
#if 0    
#define STA_3X3_MON_00 (P2S_BASE + 0xC00)
    #define STATUS_3X3 Fld(14,0,AC_MSKW10)//[13:0]
#define TRANS_MON_00 (P2S_BASE + 0xC04)
    #define C_OUT_S2P Fld(1,31,AC_MSKB3)//[31:31]
    #define C_OUT_S1P Fld(1,30,AC_MSKB3)//[30:30]
    #define C_OUT_S0P Fld(1,29,AC_MSKB3)//[29:29]
    #define C_CLAMP_S2P Fld(1,28,AC_MSKB3)//[28:28]
    #define C_CLAMP_S1P Fld(1,27,AC_MSKB3)//[27:27]
    #define C_CLAMP_S0P Fld(1,26,AC_MSKB3)//[26:26]
    #define C_IN_S2P Fld(1,25,AC_MSKB3)//[25:25]
    #define C_IN_S1P Fld(1,24,AC_MSKB3)//[24:24]
    #define C_IN_S0P Fld(1,23,AC_MSKB2)//[23:23]
    #define C_IN_OFFSET_1P Fld(11,12,AC_MSKW21)//[22:12]
    #define C_MON_EASY_BP3X3 Fld(1,11,AC_MSKB1)//[11:11]
    #define C_IN_OFFSET_0P Fld(11,0,AC_MSKW10)//[10:0]
#define TRANS_MON_01 (P2S_BASE + 0xC08)
    #define C_OUT_OFFSET_0P Fld(11,12,AC_MSKW21)//[22:12]
    #define C_IN_OFFSET_2P Fld(11,0,AC_MSKW10)//[10:0]
#define TRANS_MON_02 (P2S_BASE + 0xC0C)
    #define C_OUT_OFFSET_2P Fld(11,12,AC_MSKW21)//[22:12]
    #define C_OUT_OFFSET_1P Fld(11,0,AC_MSKW10)//[10:0]
#define TRANS_MON_03 (P2S_BASE + 0xC10)
    #define COEFF_01P Fld(12,12,AC_MSKW21)//[23:12]
    #define COEFF_00P Fld(12,0,AC_MSKW10)//[11:0]
#define TRANS_MON_04 (P2S_BASE + 0xC14)
    #define COEFF_10P Fld(12,12,AC_MSKW21)//[23:12]
    #define COEFF_02P Fld(12,0,AC_MSKW10)//[11:0]
#define TRANS_MON_05 (P2S_BASE + 0xC18)
    #define COEFF_12P Fld(12,12,AC_MSKW21)//[23:12]
    #define COEFF_11P Fld(12,0,AC_MSKW10)//[11:0]
#define TRANS_MON_06 (P2S_BASE + 0xC1C)
    #define COEFF_21P Fld(12,12,AC_MSKW21)//[23:12]
    #define COEFF_20P Fld(12,0,AC_MSKW10)//[11:0]
#define TRANS_MON_07 (P2S_BASE + 0xC20)
    #define C_ERR_DFN Fld(1,31,AC_MSKB3)//[31:31]
    #define C_REG_INDEX Fld(5,20,AC_MSKW32)//[24:20]
    #define C_INPUT_SELP Fld(4,16,AC_MSKB2)//[19:16]
    #define C_BP_VSYNC Fld(1,15,AC_MSKB1)//[15:15]
    #define C_CONTROL_SEL Fld(3,12,AC_MSKB1)//[14:12]
    #define COEFF_22P Fld(12,0,AC_MSKW10)//[11:0]    
#define TRANS_MON_08 (P2S_BASE + 0xC24)
    #define PRE_TRAN_MON_ATPG_CT Fld(1,31,AC_MSKB3)//[31:31]
    #define PRE_TRAN_MON_ATPG_OB Fld(1,30,AC_MSKB3)//[30:30]
    #define C_CONTROL_REG Fld(30,0,AC_MSKDW)//[29:0]
#endif     
#define TRANS_MON_09 (P2S_BASE + 0xC28)
    #define C_RESERVE Fld(32,0,AC_FULLDW)//[31:0]   
#define P2S_4K1K_00 (P2S_BASE + 0xCC0)
    #define P2S_RESERVE_0 Fld(3,29,AC_MSKB3)//[31:29]
    #define SET_RES_HSYNC_CNT Fld(8,21,AC_MSKW32)//[28:21]
    #define P2S_DEBUG_TEST Fld(2,19,AC_MSKB2)//[20:19]
    #define VSYNC_FALL_RESET_CEN_CNT Fld(1,18,AC_MSKB2)//[18:18]
    #define P2S_4K1K_MODE Fld(1,17,AC_MSKB2)//[17:17]
    #define P2S_SOURCE_SWITCH Fld(1,16,AC_MSKB2)//[16:16]
    #define P2S_SETRES_EN Fld(1,15,AC_MSKB1)//[15:15]
    #define P2S_DBUF Fld(1,14,AC_MSKB1)//[14:14]
    #define MON_SYNC_TO_MAIN Fld(1,13,AC_MSKB1)//[13:13]
    #define SEL_4K1K_P2S Fld(1,12,AC_MSKB1)//[12:12]
    #define P2S_H_WIDTH Fld(12,0,AC_MSKW10)//[11:0]
#define P2S_4K1K_01 (P2S_BASE + 0xCC4)
    #define PRE_P2S_4K1K_ATPG_CT Fld(1,31,AC_MSKB3)//[31:31]
    #define PRE_P2S_4K1K_ATPG_OB Fld(1,30,AC_MSKB3)//[30:30]
    #define P2S_RESERVE_1 Fld(17,13,AC_MSKDW)//[29:13]
    #define P2S_SET_RES_STATUS Fld(1,12,AC_MSKB1)//[12:12]
    #define C_AHEAD_STATE Fld(1,11,AC_MSKB1)//[11:11]
    #define C_OUT_H_CNT Fld(11,0,AC_MSKW10)//[10:0]
#define P2S_4K1K_02 (P2S_BASE + 0xCC8)
    #define C_RIGHT_HALF_IN_H_CNT Fld(11,16,AC_MSKW32)//[26:16]
    #define C_LEFT_HALF_IN_H_CNT Fld(11,0,AC_MSKW10)//[10:0]
#define P2S_4K1K_03 (P2S_BASE + 0xCCC)
    #define C_RIGHT_HALF_CEN_IN_CNT Fld(12,16,AC_MSKW32)//[27:16]
    #define C_LEFT_HALF_CEN_IN_CNT Fld(12,0,AC_MSKW10)//[11:0]
#define P2S_4K1K_04 (P2S_BASE + 0xCD0)
    #define P2S_RESERVE_2 Fld(10,22,AC_MSKW32)//[31:22]
    #define C_RIGHT_HALF_IN_V_CNT Fld(11,11,AC_MSKW21)//[21:11]
    #define C_LEFT_HALF_IN_V_CNT Fld(11,0,AC_MSKW10)//[10:0]
#define PRE_DS_MAIN_P2S_00 (P2S_BASE + 0xC60)
    #define PRE_DSCALE_H_1 Fld(16,16,AC_FULLW32)//[31:16]
    #define PRE_DSCALER_V_1 Fld(16,0,AC_FULLW10)//[15:0]
#define PRE_DS_MAIN_P2S_01 (P2S_BASE + 0xC64)
    #define PRE_DSCALE_H_INIT_1 Fld(16,16,AC_FULLW32)//[31:16]
    #define PRE_DSCALE_V_INIT_1 Fld(16,0,AC_FULLW10)//[15:0]
#define PRE_DS_MAIN_P2S_02 (P2S_BASE + 0xC68)
    #define PRE_DSCALE_H_INIT_RIGHT_1 Fld(16,16,AC_FULLW32)//[31:16]
    #define PRE_DSCALE_V_INIT_RIGHT_1 Fld(16,0,AC_FULLW10)//[15:0]
#define PRE_DS_MAIN_P2S_03 (P2S_BASE + 0xC6C)
    #define PREDS_MAIN_OUT_H Fld(16,16,AC_FULLW32)//[31:16]
    #define PREDS_MAIN_OUT_V Fld(16,0,AC_FULLW10)//[15:0]
#define PRE_DS_MAIN_P2S_04 (P2S_BASE + 0xC70)
    #define PREDS_MAIN_IN_H Fld(16,16,AC_FULLW32)//[31:16]
    #define PREDS_MAIN_IN_V Fld(16,0,AC_FULLW10)//[15:0]
#define PRE_DS_MAIN_P2S_05 (P2S_BASE + 0xC74)
    #define PREDSMAIN_P2S_ATPG_CT Fld(1,31,AC_MSKB3)//[31:31]
    #define PREDSMAIN_P2S_ATPG_OB Fld(1,30,AC_MSKB3)//[30:30]
    #define MAIN_SET_RES_CLEAR_O Fld(1,27,AC_MSKB3)//[27:27]
    #define MAIN_SET_RES_CLEAR_I Fld(1,26,AC_MSKB3)//[26:26]
    #define MAIN_SET_RES_FINISH_O Fld(1,25,AC_MSKB3)//[25:25]
    #define MAIN_SET_RES_FINISH_I Fld(1,24,AC_MSKB3)//[24:24]
    #define MAIN_SETRES_ACT_LINE Fld(8,16,AC_FULLB2)//[23:16]
    #define MAIN_SEL_HVCNT Fld(1,15,AC_MSKB1)//[15:15]
    #define MAIN_CLR_HVCNT Fld(1,14,AC_MSKB1)//[14:14]
    #define MAIN_VCEN_ACT_AT_SYNC Fld(1,13,AC_MSKB1)//[13:13]
    #define MAIN_HCEN_ACT_AT_SYNC Fld(1,12,AC_MSKB1)//[12:12]
    #define PREDS_3DTV_MODE_1 Fld(4,8,AC_MSKB1)//[11:8]
    #define PREDS_LR_PAIR_CTRL Fld(2,6,AC_MSKB0)//[7:6]
    #define PREDS_3DTV_INV Fld(1,5,AC_MSKB0)//[5:5]
    #define PREDS_MAIN_SETRES Fld(1,4,AC_MSKB0)//[4:4]
    #define PREDS_M_INV_VSYNC Fld(1,3,AC_MSKB0)//[3:3]
    #define PREDS_MAIN_SETRES_EN Fld(1,2,AC_MSKB0)//[2:2]
    #define PRE_DSCALE_H_BYPASS_1 Fld(1,1,AC_MSKB0)//[1:1]
    #define PRE_DSCALE_V_BYPASS_1 Fld(1,0,AC_MSKB0)//[0:0]
#define PRE_DS_MAIN_P2S_06 (P2S_BASE + 0xC78)
    #define MAIN_H_ACTIVE Fld(16,16,AC_FULLW32)//[31:16]
    #define MAIN_H_TOTAL Fld(16,0,AC_FULLW10)//[15:0]
#define PRE_DS_MAIN_P2S_07 (P2S_BASE + 0xC7C)
    #define MAIN_V_ACTIVE Fld(16,16,AC_FULLW32)//[31:16]
    #define MAIN_V_TOTAL Fld(16,0,AC_FULLW10)//[15:0]
#define PRE_DS_MAIN_P2S_08 (P2S_BASE + 0xC80)
    #define PRE_DSCALE_V_INIT_BTM_1 Fld(16,16,AC_FULLW32)//[31:16]
    #define PRE_DSCALE_V_INIT_RIGHT_BTM_1 Fld(16,0,AC_FULLW10)//[15:0]
#define PRE_DS_MAIN_P2S_09 (P2S_BASE + 0xC84)
    #define PREDS_3D_FIELD_EN_1 Fld(1,31,AC_MSKB3)//[31:31]
    #define PREDS_3D_FIELD_INV_1 Fld(1,30,AC_MSKB3)//[30:30]
    #define PREDS_RESERVE_0 Fld(1,0,AC_MSKB0)//[0:0]
#define PRE_DS_MAIN_P2S_0A (P2S_BASE + 0xC88)
    #define PREDS_H_PHASE_INIT_SIGN_1 Fld(1,31,AC_MSKB3)//[31:31]
    #define PREDS_H_PHASE_INIT_INTG_1 Fld(3,28,AC_MSKB3)//[30:28]
    #define PREDS_H_PHASE_INIT_FRAC_1 Fld(20,8,AC_MSKDW)//[27:8]
    #define PREDS_FIR_COEF_SEL Fld(3,0,AC_MSKB0)//[2:0]
#define PRE_DS_MAIN_P2S_0B (P2S_BASE + 0xC8C)
    #define PREDS_H_PHASE_DELTA_INTG_1 Fld(3,28,AC_MSKB3)//[30:28]
    #define PREDS_H_PHASE_DELTA_FRAC_1 Fld(20,8,AC_MSKDW)//[27:8]
    #define PREDS_FIR_EN Fld(1,7,AC_MSKB0)//[7:7]
    #define PREDS_FIR_DLY_SEL Fld(4,3,AC_MSKB0)//[6:3]
    #define PREDS_FIR_INPUT_DLY_SEL Fld(1,1,AC_MSKB0)//[1:1]
    #define PREDS_CEN_OUT_SEL Fld(1,0,AC_MSKB0)//[0:0]
#define PRE_DS_MON_P2S_00 (P2S_BASE + 0xC90)
    #define MON_PRE_DSCALE_H_1 Fld(16,16,AC_FULLW32)//[31:16]
    #define MON_PRE_DSCALER_V_1 Fld(16,0,AC_FULLW10)//[15:0]
#define PRE_DS_MON_P2S_01 (P2S_BASE + 0xC94)
    #define MON_PRE_DSCALE_H_INIT_1 Fld(16,16,AC_FULLW32)//[31:16]
    #define MON_PRE_DSCALE_V_INIT_1 Fld(16,0,AC_FULLW10)//[15:0]
#define PRE_DS_MON_P2S_02 (P2S_BASE + 0xC98)
    #define MON_PRE_DSCALE_H_INIT_RIGHT_1 Fld(16,16,AC_FULLW32)//[31:16]
    #define MON_PRE_DSCALE_V_INIT_RIGHT_1 Fld(16,0,AC_FULLW10)//[15:0]
#define PRE_DS_MON_P2S_03 (P2S_BASE + 0xC9C)
    #define MON_PREDS_MAIN_OUT_H Fld(16,16,AC_FULLW32)//[31:16]
    #define MON_PREDS_MAIN_OUT_V Fld(16,0,AC_FULLW10)//[15:0]
#define PRE_DS_MON_P2S_04 (P2S_BASE + 0xCA0)
    #define MON_PREDS_MAIN_IN_H Fld(16,16,AC_FULLW32)//[31:16]
    #define MON_PREDS_MAIN_IN_V Fld(16,0,AC_FULLW10)//[15:0]
#define PRE_DS_MON_P2S_05 (P2S_BASE + 0xCA4)
    #define MON_PREDSMON_P2S_ATPG_CT Fld(1,31,AC_MSKB3)//[31:31]
    #define MON_PREDSMON_P2S_ATPG_OB Fld(1,30,AC_MSKB3)//[30:30]
    #define MON_MAIN_SET_RES_CLEAR_O Fld(1,27,AC_MSKB3)//[27:27]
    #define MON_MAIN_SET_RES_CLEAR_I Fld(1,26,AC_MSKB3)//[26:26]
    #define MON_MAIN_SET_RES_FINISH_O Fld(1,25,AC_MSKB3)//[25:25]
    #define MON_MAIN_SET_RES_FINISH_I Fld(1,24,AC_MSKB3)//[24:24]
    #define MON_MAIN_SETRES_ACT_LINE Fld(8,16,AC_FULLB2)//[23:16]
    #define MON_MAIN_SEL_HVCNT Fld(1,15,AC_MSKB1)//[15:15]
    #define MON_MAIN_CLR_HVCNT Fld(1,14,AC_MSKB1)//[14:14]
    #define MON_MAIN_VCEN_ACT_AT_SYNC Fld(1,13,AC_MSKB1)//[13:13]
    #define MON_MAIN_HCEN_ACT_AT_SYNC Fld(1,12,AC_MSKB1)//[12:12]
    #define MON_PREDS_3DTV_MODE_1 Fld(4,8,AC_MSKB1)//[11:8]
    #define MON_PREDS_LR_PAIR_CTRL Fld(2,6,AC_MSKB0)//[7:6]
    #define MON_PREDS_3DTV_INV Fld(1,5,AC_MSKB0)//[5:5]
    #define MON_PREDS_MAIN_SETRES Fld(1,4,AC_MSKB0)//[4:4]
    #define MON_PREDS_M_INV_VSYNC Fld(1,3,AC_MSKB0)//[3:3]
    #define MON_PREDS_MAIN_SETRES_EN Fld(1,2,AC_MSKB0)//[2:2]
    #define MON_PRE_DSCALE_H_BYPASS_1 Fld(1,1,AC_MSKB0)//[1:1]
    #define MON_PRE_DSCALE_V_BYPASS_1 Fld(1,0,AC_MSKB0)//[0:0]
#define PRE_DS_MON_P2S_06 (P2S_BASE + 0xCA8)
    #define MON_MAIN_H_ACTIVE Fld(16,16,AC_FULLW32)//[31:16]
    #define MON_MAIN_H_TOTAL Fld(16,0,AC_FULLW10)//[15:0]
#define PRE_DS_MON_P2S_07 (P2S_BASE + 0xCAC)
    #define MON_MAIN_V_ACTIVE Fld(16,16,AC_FULLW32)//[31:16]
    #define MON_MAIN_V_TOTAL Fld(16,0,AC_FULLW10)//[15:0]
#define PRE_DS_MON_P2S_08 (P2S_BASE + 0xCB0)
    #define MON_PRE_DSCALE_V_INIT_BTM_1 Fld(16,16,AC_FULLW32)//[31:16]
    #define MON_PRE_DSCALE_V_INIT_RIGHT_BTM_1 Fld(16,0,AC_FULLW10)//[15:0]
#define PRE_DS_MON_P2S_09 (P2S_BASE + 0xCB4)
    #define MON_PREDS_3D_FIELD_EN_1 Fld(1,31,AC_MSKB3)//[31:31]
    #define MON_PREDS_3D_FIELD_INV_1 Fld(1,30,AC_MSKB3)//[30:30]
    #define MON_PREDS_RESERVE_0 Fld(1,0,AC_MSKB0)//[0:0]
#define PRE_DS_MON_P2S_0A (P2S_BASE + 0xCB8)
    #define MON_PREDS_H_PHASE_INIT_SIGN_1 Fld(1,31,AC_MSKB3)//[31:31]
    #define MON_PREDS_H_PHASE_INIT_INTG_1 Fld(3,28,AC_MSKB3)//[30:28]
    #define MON_PREDS_H_PHASE_INIT_FRAC_1 Fld(20,8,AC_MSKDW)//[27:8]
    #define MON_PREDS_FIR_COEF_SEL Fld(3,0,AC_MSKB0)//[2:0]
#define PRE_DS_MON_P2S_0B (P2S_BASE + 0xCBC)
    #define MON_PREDS_H_PHASE_DELTA_INTG_1 Fld(3,28,AC_MSKB3)//[30:28]
    #define MON_PREDS_H_PHASE_DELTA_FRAC_1 Fld(20,8,AC_MSKDW)//[27:8]
    #define MON_PREDS_FIR_EN Fld(1,7,AC_MSKB0)//[7:7]
    #define MON_PREDS_FIR_DLY_SEL Fld(4,3,AC_MSKB0)//[6:3]
    #define MON_PREDS_FIR_INPUT_DLY_SEL Fld(1,1,AC_MSKB0)//[1:1]
    #define MON_PREDS_CEN_OUT_SEL Fld(1,0,AC_MSKB0)//[0:0]

#endif

