/* SPDX-License-Identifier: LGPL-2.1-only OR BSD-3-Clause */
/******************************************************************************
 *
 * This file is provided under a dual license.  When you use or
 * distribute this software, you may choose to be licensed under
 * version 2.1 of the GNU Lesser General Public License
 * ("LGPLv2.1 License") or BSD License.
 *
 * LGPLv2.1 License
 *
 * Copyright(C) 2019 MediaTek Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2.1 of the GNU Lesser General Public
 * License as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See https://www.gnu.org/licenses/old-licenses/lgpl-2.1.html for more
 * details.
 *
 * BSD LICENSE
 *
 * Copyright(C) 2019 MediaTek Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *  * Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *****************************************************************************/


#ifndef _HW_TECHNICOLOR_HDR_H_
#define _HW_TECHNICOLOR_HDR_H_
#define IO_TECH_HDR_BASE (IO_VIRT_SRE + 0x45000)
#endif

#ifndef _HW_TECHNI_H_
#define _HW_TECHNI_H_

#include "x_hal_5381.h"

#define IO_PRE_DS_BASE  (IO_VIRT+ 0x41000)

//Page TECHNICOLOR_HDR
#define TECH_HDR_00 (IO_TECH_HDR_BASE + 0xB00)
    #define FORCE_SRAM_CS_ON Fld(1,17,AC_MSKB2)//[17:17]
    #define VA_READ_LATEST_WDATA Fld(1,16,AC_MSKB2)//[16:16]
    #define RDATA_BYTE_EN_SEL Fld(2,14,AC_MSKB1)//[15:14]
    #define WDATA_BYTE_EN_SEL Fld(2,12,AC_MSKB1)//[13:12]
    #define TECH_RD_AUTO_INC_ADDR Fld(1,11,AC_MSKB1)//[11:11]
    #define TECH_WR_AUTO_INC_ADDR Fld(1,10,AC_MSKB1)//[10:10]
    #define PIO_MODE Fld(1,9,AC_MSKB1)//[9:9]
    #define FORCE_WR_NO_WAIT Fld(1,8,AC_MSKB1)//[8:8]
    #define TECH_MAX_WAIT_CYCLE Fld(8,0,AC_FULLB0)//[7:0]
#define TECH_HDR_01 (IO_TECH_HDR_BASE + 0xB04)
    #define CPURW_ACTIVE_IS Fld(1,13,AC_MSKB1)//[13:13]
    #define CPURW_ACTIVE_VPP_PN Fld(1,12,AC_MSKB1)//[12:12]
    #define CPURW_ACTIVE_PN Fld(1,11,AC_MSKB1)//[11:11]
    #define CPURW_ACTIVE_VPP_D Fld(1,10,AC_MSKB1)//[10:10]
    #define CPURW_ACTIVE_D Fld(1,9,AC_MSKB1)//[9:9]
    #define CPURW_ACTIVE_VPP_C Fld(1,8,AC_MSKB1)//[8:8]
    #define CPU_SEL_SRAM_0 Fld(1,7,AC_MSKB0)//[7:7]
    #define CPURW_ACTIVE_C Fld(1,6,AC_MSKB0)//[6:6]
    #define TABLE_WAIT_VSYNC Fld(1,5,AC_MSKB0)//[5:5]
    #define FILL_TABLE_READY Fld(1,4,AC_MSKB0)//[4:4]
    #define TECH_READ_FINISH Fld(1,3,AC_MSKB0)//[3:3]
    #define TECH_READ Fld(1,2,AC_MSKB0)//[2:2]
    #define TECH_WRITE_FINISH Fld(1,1,AC_MSKB0)//[1:1]
    #define TECH_WRITE Fld(1,0,AC_MSKB0)//[0:0]
#define TECH_HDR_02 (IO_TECH_HDR_BASE + 0xB08)
    #define TECH_COE_SEL Fld(5,24,AC_MSKB3)//[28:24]
    #define TECH_CPU_SRAM_ADDR Fld(12,12,AC_MSKW21)//[23:12]
    #define TECH_R_ADDR Fld(12,0,AC_MSKW10)//[11:0]
#define TECH_HDR_03 (IO_TECH_HDR_BASE + 0xB0C)
    #define TECH_WDATA_00 Fld(32,0,AC_FULLDW)//[31:0]
#define TECH_HDR_04 (IO_TECH_HDR_BASE + 0xB10)
    #define RDATA_00 Fld(32,0,AC_FULLDW)//[31:0]
#define TECH_HDR_05 (IO_TECH_HDR_BASE + 0xB14)
    #define HDR_COEF_PP_RD_PN Fld(1,3,AC_MSKB0)//[3:3]
    #define HDR_COEF_PP_RD_D Fld(1,2,AC_MSKB0)//[2:2]
    #define HDR_COEF_PP_RD_C Fld(1,1,AC_MSKB0)//[1:1]
    #define HDR_COEF_PP_WRT_A Fld(1,0,AC_MSKB0)//[0:0]
#define TECH_HDR_06 (IO_TECH_HDR_BASE + 0xB18)
    #define TECH_COLOR_SPACE Fld(2,28,AC_MSKB3)//[29:28]
    #define TECH_HDR_CONTAINER Fld(1,27,AC_MSKB3)//[27:27]
    #define TECH_YUV_RANGE Fld(1,26,AC_MSKB3)//[26:26]
    #define TECH_ALPHA_B Fld(13,13,AC_MSKDW)//[25:13]
    #define TECH_ALPHA_A Fld(13,0,AC_MSKW10)//[12:0]
#define TECH_HDR_07 (IO_TECH_HDR_BASE + 0xB1C)
    #define OCT2 Fld(10,20,AC_MSKW32)//[29:20]
    #define OCT1 Fld(10,10,AC_MSKW21)//[19:10]
    #define OCT0 Fld(10,0,AC_MSKW10)//[9:0]
#define TECH_HDR_08 (IO_TECH_HDR_BASE + 0xB20)
    #define OCT5 Fld(10,20,AC_MSKW32)//[29:20]
    #define OCT4 Fld(10,10,AC_MSKW21)//[19:10]
    #define OCT3 Fld(10,0,AC_MSKW10)//[9:0]
#define TECH_HDR_09 (IO_TECH_HDR_BASE + 0xB24)
    #define BA Fld(11,16,AC_MSKW32)//[26:16]
    #define OCT6 Fld(10,0,AC_MSKW10)//[9:0]
#define TECH_HDR_10 (IO_TECH_HDR_BASE + 0xB28)
    #define D_THRESHOLD1 Fld(13,16,AC_MSKW32)//[28:16]
    #define D_THRESHOLD0 Fld(13,0,AC_MSKW10)//[12:0]
#define TECH_HDR_11 (IO_TECH_HDR_BASE + 0xB2C)
    #define D_STEP3 Fld(4,28,AC_MSKB3)//[31:28]
    #define D_STEP2 Fld(4,24,AC_MSKB3)//[27:24]
    #define D_STEP1 Fld(4,20,AC_MSKB2)//[23:20]
    #define D_STEP0 Fld(4,16,AC_MSKB2)//[19:16]
    #define D_THRESHOLD2 Fld(13,0,AC_MSKW10)//[12:0]
#define TECH_HDR_12 (IO_TECH_HDR_BASE + 0xB30)
    #define TECH_O_SIGNED Fld(1,8,AC_MSKB1)//[8:8]
    #define TECH_I_SIGNED Fld(1,7,AC_MSKB0)//[7:7]
    #define TECH_EXT_TABLE_EN Fld(1,6,AC_MSKB0)//[6:6]
    #define TECH_INT_TABLE_SEL Fld(4,2,AC_MSKB0)//[5:2]
    #define TECH_CT_BYPASS Fld(1,1,AC_MSKB0)//[1:1]
    #define TECH_CT_EN Fld(1,0,AC_MSKB0)//[0:0]
#define TECH_HDR_13 (IO_TECH_HDR_BASE + 0xB34)
    #define TECH_EXT_C01 Fld(13,16,AC_MSKW32)//[28:16]
    #define TECH_EXT_C00 Fld(13,0,AC_MSKW10)//[12:0]
#define TECH_HDR_14 (IO_TECH_HDR_BASE + 0xB38)
    #define TECH_EXT_C10 Fld(13,16,AC_MSKW32)//[28:16]
    #define TECH_EXT_C02 Fld(13,0,AC_MSKW10)//[12:0]
#define TECH_HDR_15 (IO_TECH_HDR_BASE + 0xB3C)
    #define TECH_EXT_C12 Fld(13,16,AC_MSKW32)//[28:16]
    #define TECH_EXT_C11 Fld(13,0,AC_MSKW10)//[12:0]
#define TECH_HDR_16 (IO_TECH_HDR_BASE + 0xB40)
    #define TECH_EXT_C21 Fld(13,16,AC_MSKW32)//[28:16]
    #define TECH_EXT_C20 Fld(13,0,AC_MSKW10)//[12:0]
#define TECH_HDR_17 (IO_TECH_HDR_BASE + 0xB44)
    #define TECH_EXT_C22 Fld(13,0,AC_MSKW10)//[12:0]
#define TECH_HDR_18 (IO_TECH_HDR_BASE + 0xB48)
    #define TECH_EXT_PRE_ADD_2 Fld(9,20,AC_MSKW32)//[28:20]
    #define TECH_EXT_PRE_ADD_1 Fld(9,10,AC_MSKW21)//[18:10]
    #define TECH_EXT_PRE_ADD_0 Fld(9,0,AC_MSKW10)//[8:0]
#define TECH_HDR_19 (IO_TECH_HDR_BASE + 0xB4C)
    #define TECH_EXT_POST_ADD_2 Fld(9,20,AC_MSKW32)//[28:20]
    #define TECH_EXT_POST_ADD_1 Fld(9,10,AC_MSKW21)//[18:10]
    #define TECH_EXT_POST_ADD_0 Fld(9,0,AC_MSKW10)//[8:0]
#define TECH_HDR_20 (IO_TECH_HDR_BASE + 0xB50)
    #define HDR_DB_EN Fld(1,1,AC_MSKB0)//[1:1]
    #define C_TECH_HDR_MAIN_BYPASS Fld(1,0,AC_MSKB0)//[0:0]
#define TECHNICOLOR_HDR_ATPG (IO_TECH_HDR_BASE + 0xBFC)
    #define TECHNICOLOR_HDR_ATPG_OB Fld(1,1,AC_MSKB0)//[1:1]
    #define TECHNICOLOR_HDR_ATPG_CT Fld(1,0,AC_MSKB0)//[0:0]    
#endif    
