/* SPDX-License-Identifier: LGPL-2.1-only OR BSD-3-Clause */
/******************************************************************************
 *
 * This file is provided under a dual license.  When you use or
 * distribute this software, you may choose to be licensed under
 * version 2.1 of the GNU Lesser General Public License
 * ("LGPLv2.1 License") or BSD License.
 *
 * LGPLv2.1 License
 *
 * Copyright(C) 2019 MediaTek Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2.1 of the GNU Lesser General Public
 * License as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See https://www.gnu.org/licenses/old-licenses/lgpl-2.1.html for more
 * details.
 *
 * BSD LICENSE
 *
 * Copyright(C) 2019 MediaTek Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *  * Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *****************************************************************************/

/*-----------------------------------------------------------------------------
  *
  * $Author: jiewen.zhou $
  * $Date  $
  * $RCSfile: hw_tg.h,v $
  * $Revision: #2 $
  *
  *---------------------------------------------------------------------------*/
  
#ifndef _HW_TG_H_
#define _HW_TG_H_

#define TCONIO_VIRT IO_VIRT

//TCON_TOP
#define TMGR0 (IO_VIRT + 0x02008000)
    #define TMGR0_CKRST_CFG Fld(16,16,AC_FULLW32)//[31:16]
		#define TMGR0_CKRST_CFG_VB1 Fld(1,20,AC_MSKB2)//[20:20]
    #define TMGR0_CKEN_CFG Fld(16,0,AC_FULLW10)//[15:0]
        #define CKEN_CFG_2Port_FIFO Fld(1, 15, AC_MSKB1)  //[15:15]  
        #define CKEN_CFG_Pixel_Reorder Fld(1, 14, AC_MSKB1)  //[14:14] 
        #define CKEN_CFG_LVDS_TX Fld(1, 13, AC_MSKB1)  //[13:13] 
        #define CKEN_CFG_PPML Fld(1, 12, AC_MSKB1)  //[12:12]
        #define CKEN_CFG_LVDS_ANA Fld(1, 8, AC_MSKB1)  //[8:8]
        #define CKEN_CFG_EPI Fld(1, 6, AC_MSKB0)  //[6:6]
	    #define CKEN_CFG_iDP Fld(1, 5, AC_MSKB0)  //[5:5], no use
        #define CKEN_CFG_VB1 Fld(1, 4, AC_MSKB0)  //[4:4]
        #define CKEN_CFG_MLVDS Fld(1, 3, AC_MSKB0)  //[3:3]
		#define CKEN_CFG_PWM_SCAN Fld(1, 2, AC_MSKB0)  //[2:2]
        #define CKEN_CFG_TCON Fld(1, 1, AC_MSKB0)  //[1:1]
        #define CKEN_CFG_EH Fld(1, 0, AC_MSKB0)  //[0:0]

#define TMGR1 (IO_VIRT + 0x02008004)
    #define TMGR1_MON_SEL Fld(8,8,AC_FULLB1)//[15:8]
    #define TMGR1_RG_TCLK_DBGSEL Fld(1,1,AC_MSKB0)//[1:1]

#define TMGR2 (IO_VIRT + 0x02008008)
    #define TMGR2_TCLK_PLLRST Fld(1,31,AC_MSKB3)//[31:31]
    #define TMGR2_TCLK_PLLSEL Fld(3,28,AC_MSKB3)//[30:28]
    #define TMGR2_TCLK_PLLBP Fld(1,27,AC_MSKB3)//[27:27]
    	#define TMGR2_CKRST_CFG_VB1OSD Fld(1,20,AC_MSKB2)//[20:20]
    #define TMGR2_RG_FIFO_CK_SEL Fld(3,16,AC_MSKB2)//[18:16]
    #define TMGR2_CKEN_CFG1 Fld(16,0,AC_FULLW10)//[15:0]

#define TMGR3 (IO_VIRT + 0x0200800C)
	#define TMGR3_RG_VB1_DE_SEL Fld(1,18,AC_MSKB2)//[18:18]
	#define TMGR3_RG_VB1_VS_SEL Fld(1,17,AC_MSKB2)//[17:17]
	#define TMGR3_RG_VB1_HS_SEL Fld(1,16,AC_MSKB2)//[16:16]
	#define TMGR3_RG_OSD_SYNC_SEL Fld(1,15,AC_MSKB1)//[15:15]
    #define TMGR3_RG_TCON_OUT_SEL Fld(3,12,AC_MSKB1)//[14:12]
    #define TMGR3_TCON_HS_PWM_P Fld(1,5,AC_MSKB0)//[5:5]
    #define TMGR3_TCON_VS_PWM_P Fld(1,4,AC_MSKB0)//[4:4]
    #define TMGR3_TCON_DE_OUT_P Fld(1,2,AC_MSKB0)//[2:2]
    #define TMGR3_TCON_HS_OUT_P Fld(1,1,AC_MSKB0)//[1:1]
    #define TMGR3_TCON_VS_OUT_P Fld(1,0,AC_MSKB0)//[0:0]

#define TMGR4 (IO_VIRT + 0x02008010)
    #define TMGR4_OSD_DIS_VS_ALIGN Fld(1, 14, AC_MSKB1) //[14:14]
    #define TMGR4_OSD_SYNC_SEL Fld(1, 13, AC_MSKB1) //[13:13]
    #define TMGR4_OSD_SYNC_POL_SEL Fld(1, 12, AC_MSKB1) //[12:12]
    #define TMGR4_OSD_1CH2CH_EN Fld(1, 11, AC_MSKB1) //[11:11]
	#define TMGR4_SYNC_FIFO_EN Fld(1, 10, AC_MSKB1) //[10:10]
    #define TMGR4_SYNC_FIFO_AUTO_RST Fld(1, 9, AC_MSKB1) //[9:9]
    #define TMGR4_DATA_SYNC_AUTO Fld(1, 8, AC_MSKB1) //[8:8]
    #define TMGR4_DIS_HW_SWITCH Fld(1, 7, AC_MSKB0) //[7:7]
    #define TMGR4_DIS_VS_ALIGN Fld(1, 6, AC_MSKB0) //[6:6]
	#define TMGR4_1CHTO2CH_EN Fld(1,5,AC_MSKB0)//[5:5]
	#define TMGR4_OSD_SRC_SEL Fld(1,4,AC_MSKB0)//[4:4]
    #define TMGR4_SYNC_UPDATE_MODE Fld(1,3,AC_MSKB0)//[3:3]
    #define TMGR4_VDO_SRC_SEL Fld(1,0,AC_MSKB0)//[0:0]

#define TMGR5 (IO_VIRT + 0x02008014)
    #define TMGR5_TX_CLK_CTS_INV Fld(1,29,AC_MSKB3)//[29:29]
    #define TMGR5_TX_CLK_INV Fld(1,28,AC_MSKB3)//[28:28]
    #define TMGR5_RG_FIFO_CTRL Fld(3,20,AC_MSKB2)//[22:20]
    #define TMGR5_RG_FIFO_EN Fld(1, 16, AC_MSKB2) //16

#define TMGR6 (IO_VIRT + 0x02008018)
    #define TMGR6_VB1_CHC_OSD_SEL Fld(1,3,AC_MSKB0)//[3:3]
        #define DEFAULT_AS_CHC 0
        #define USE_AS_OSD     1
	#define TMGR6_RG_HS_PWM_SEL Fld(1,1,AC_MSKB0)//[1:1]
	#define TMGR6_RG_VS_PWM_SEL Fld(1,0,AC_MSKB0)//[0:0]

#define TMGR7 (IO_VIRT + 0x0200801C)
    #define TMGR7_RG_LOOPPAT_2TO1 Fld(1,25,AC_MSKB3)//[25:25]
    #define TMGR7_RG_LOOPPAT_EN Fld(1,24,AC_MSKB3)//[24:24]
    #define TMGR7_IMP_CAL_SETB Fld(1,22,AC_MSKB2)//[22:22]
    #define TMGR7_IMP_CAL_SET Fld(1,21,AC_MSKB2)//[21:21]
    #define TMGR7_RG_RXIMP Fld(4,15,AC_MSKW21)//[18:15]
    #define TMGR7_RG_AUTOK_RX_IMP Fld(1,12,AC_MSKB1)//[12:12]
    #define TMGR7_RG_TXIMP Fld(4,8,AC_MSKB1)//[11:8]
    #define TMGR7_REG_IMP_DP_DIS Fld(1,7,AC_MSKB0)//[7:7]
    #define TMGR7_RG_IMPFREQSEL Fld(1,6,AC_MSKB0)//[6:6]
    #define TMGR7_RG_AUTOK_TX_IMP Fld(1,4,AC_MSKB0)//[4:4]
    #define TMGR7_REG_SEL_1_ALL Fld(1,2,AC_MSKB0)//[2:2]
    #define TMGR7_SAPIS_MODE_SYNC Fld(1,1,AC_MSKB0)//[1:1]
    #define TMGR7_CTL_EN_CALIBRATION Fld(1,0,AC_MSKB0)//[0:0]

#define TMGR8 (IO_VIRT + 0x02008020)
    #define TMGR8_RG_LVDSA_TERM_ECK Fld(4,28,AC_MSKB3)//[31:28]
    #define TMGR8_RG_LVDSA_TERM_O0 Fld(4,24,AC_MSKB3)//[27:24]
    #define TMGR8_RG_LVDSA_TERM_O1 Fld(4,20,AC_MSKB2)//[23:20]
    #define TMGR8_RG_LVDSA_TERM_O2 Fld(4,16,AC_MSKB2)//[19:16]
    #define TMGR8_RG_LVDSA_TERM_O3 Fld(4,12,AC_MSKB1)//[15:12]
    #define TMGR8_RG_LVDSA_TERM_O4 Fld(4,8,AC_MSKB1)//[11:8]
    #define TMGR8_RG_LVDSA_TERM_O5 Fld(4,4,AC_MSKB0)//[7:4]
    #define TMGR8_RG_LVDSA_TERM_OCK Fld(4,0,AC_MSKB0)//[3:0]

#define TMGR9 (IO_VIRT + 0x02008024)
    #define TMGR9_RG_LVDSA_TERM_E0 Fld(4,20,AC_MSKB2)//[23:20]
    #define TMGR9_RG_LVDSA_TERM_E1 Fld(4,16,AC_MSKB2)//[19:16]
    #define TMGR9_RG_LVDSA_TERM_E2 Fld(4,12,AC_MSKB1)//[15:12]
    #define TMGR9_RG_LVDSA_TERM_E3 Fld(4,8,AC_MSKB1)//[11:8]
    #define TMGR9_RG_LVDSA_TERM_E4 Fld(4,4,AC_MSKB0)//[7:4]
    #define TMGR9_RG_LVDSA_TERM_E5 Fld(4,0,AC_MSKB0)//[3:0]
    
#define TMGR10 (IO_VIRT + 0x02008028)
    #define TMGR10_RG_LVDSA_IMP_CALI_EN Fld(12,0,AC_MSKW10)//[11:0]
    
#define TMGR11 (IO_VIRT + 0x0200802C)
    #define TMGR11_RG_TMDS_PG0 Fld(32,0,AC_FULLDW)//[31:0]
    
#define TMGR12 (IO_VIRT + 0x02008030)
    #define TMGR12_RG_TMDS_PG1 Fld(32,0,AC_FULLDW)//[31:0]
    
#define TMGR13 (IO_VIRT + 0x02008034)
    #define TMGR13_RG_TMDS_PG2 Fld(32,0,AC_FULLDW)//[31:0]
    
#define TMGR14 (IO_VIRT + 0x02008038)
    #define TMGR14_RG_TMDS_CTRL_CK Fld(24,0,AC_MSKDW)//[23:0]
    
#define TMGR15 (IO_VIRT + 0x0200803C)
    #define TMGR15_RG_TMDS_CTRL_INV Fld(24,0,AC_MSKDW)//[23:0]

#define TMGR16 (IO_VIRT + 0x02008040)
    #define TMGR16_RG_TMDS_CTRL_REG_EN Fld(24,0,AC_MSKDW)//[23:0]

#define TMGR17 (IO_VIRT + 0x02008044)
    #define TMGR17_RG_TMDS_REG_VALUE Fld(10,0,AC_MSKW10)//[9:0]

#define TMGR18 (IO_VIRT + 0x02008048)
	#define TMGR18_RG_FIFO_SEL Fld(3,12,AC_MSKB1)//[14:12]
	#define TMGR18_RG_SAME_HTPDN Fld(1,9,AC_MSKB1)//[9:9]
	#define TMGR18_RG_SAME_LOCKN Fld(1,8,AC_MSKB1)//[8:8]
	#define TMGR18_RG_HTPD_VALUE_OSD Fld(1,7,AC_MSKB0)//[7:7]
	#define TMGR18_RG_HTPD_CTRL_OSD Fld(1,6,AC_MSKB0)//[6:6]
	#define TMGR18_RG_LOCK_VALUE_OSD Fld(1,5,AC_MSKB0)//[5:5]
	#define TMGR18_RG_LOCK_CTRL_OSD Fld(1,4,AC_MSKB0)//[4:4]
	#define TMGR18_RG_HTPD_VALUE Fld(1,3,AC_MSKB0)//[3:3]
	#define TMGR18_RG_HTPD_CTRL Fld(1,2,AC_MSKB0)//[2:2]
    #define TMGR18_RG_LOCK_VALUE Fld(1,1,AC_MSKB0)//[1:1]
    #define TMGR18_RG_LOCK_CTRL Fld(1,0,AC_MSKB0)//[0:0]

#define TMGR19 (IO_VIRT + 0x0200804C)
	#define TMGR19_RG_LVDSB_TERM_ECK Fld(4,28,AC_MSKB3)//[31:28]
	#define TMGR19_RG_LVDSB_TERM_O0 Fld(4,24,AC_MSKB3)//[27:24]
	#define TMGR19_RG_LVDSB_TERM_O1 Fld(4,20,AC_MSKB2)//[23:20]
	#define TMGR19_RG_LVDSB_TERM_O2 Fld(4,16,AC_MSKB2)//[19:16]
	#define TMGR19_RG_LVDSB_TERM_O3 Fld(4,12,AC_MSKB1)//[15:12]
	#define TMGR19_RG_LVDSB_TERM_O4 Fld(4,8,AC_MSKB1)//[11:8]
	#define TMGR19_RG_LVDSB_TERM_O5 Fld(4,4,AC_MSKB0)//[7:4]
	#define TMGR19_RG_LVDSB_TERM_OCK Fld(4,0,AC_MSKB0)//[3:0]

#define TMGR20 (IO_VIRT + 0x02008050)
	#define TMGR20_RG_LVDSB_TERM_E0 Fld(4,20,AC_MSKB2)//[23:20]
	#define TMGR20_RG_LVDSB_TERM_E1 Fld(4,16,AC_MSKB2)//[19:16]
	#define TMGR20_RG_LVDSB_TERM_E2 Fld(4,12,AC_MSKB1)//[15:12]
	#define TMGR20_RG_LVDSB_TERM_E3 Fld(4,8,AC_MSKB1)//[11:8]
	#define TMGR20_RG_LVDSB_TERM_E4 Fld(4,4,AC_MSKB0)//[7:4]
	#define TMGR20_RG_LVDSB_TERM_E5 Fld(4,0,AC_MSKB0)//[3:0]

#define TMGR21 (IO_VIRT + 0x02008054)
	#define TMGR21_RG_LVDSB_IMP_CALI_EN Fld(12,0,AC_MSKW10)//[11:0]

#define TMGR24 (IO_VIRT + 0x02008060)
    #define TMGR24_DA_IMPCAL_TX_LAT Fld(4,16,AC_MSKB2)//[19:16]
    #define TMGR24_GEN_STATE Fld(3,12,AC_MSKB1)//[14:12]
    #define TMGR24_IMP_PD Fld(1,8,AC_MSKB1)//[8:8]
    #define TMGR24_IMP_CALIB_DONE Fld(1,4,AC_MSKB0)//[4:4]
    #define TMGR24_HOLD Fld(1,0,AC_MSKB0)//[0:0]

//----------------------Capy NEW-----------------------------//
#define TMGR25 (IO_VIRT + 0x02008064)
    #define TMGR25_A_PORT_O0_SEL Fld(5,25,AC_MSKB3) //[29:25]
    #define TMGR25_A_PORT_O1_SEL Fld(5,20,AC_MSKW32)//[24:20]
    #define TMGR25_A_PORT_O2_SEL Fld(5,15,AC_MSKW21)//[19:15]
    #define TMGR25_A_PORT_O3_SEL Fld(5,10,AC_MSKB1) //[14:10]
    #define TMGR25_A_PORT_O4_SEL Fld(5,5,AC_MSKW10) //[9:5]
    #define TMGR25_A_PORT_OCK_SEL Fld(5,0,AC_MSKB0) //[4:0]
#define TMGR26 (IO_VIRT + 0x02008068)
    #define TMGR26_A_PORT_E0_SEL Fld(5,25,AC_MSKB3) //[29:25]
    #define TMGR26_A_PORT_E1_SEL Fld(5,20,AC_MSKW32)//[24:20]
    #define TMGR26_A_PORT_E2_SEL Fld(5,15,AC_MSKW21)//[19:15]
    #define TMGR26_A_PORT_E3_SEL Fld(5,10,AC_MSKB1) //[14:10]
    #define TMGR26_A_PORT_E4_SEL Fld(5,5,AC_MSKW10) //[9:5]
    #define TMGR26_A_PORT_ECK_SEL Fld(5,0,AC_MSKB0) //[4:0]
#define TMGR27 (IO_VIRT + 0x0200806C)
    #define TMGR27_B_PORT_O0_SEL Fld(5,25,AC_MSKB3) //[29:25]
    #define TMGR27_B_PORT_O1_SEL Fld(5,20,AC_MSKW32)//[24:20]
    #define TMGR27_B_PORT_O2_SEL Fld(5,15,AC_MSKW21)//[19:15]
    #define TMGR27_B_PORT_O3_SEL Fld(5,10,AC_MSKB1) //[14:10]
    #define TMGR27_B_PORT_O4_SEL Fld(5,5,AC_MSKW10) //[9:5]
    #define TMGR27_B_PORT_OCK_SEL Fld(5,0,AC_MSKB0) //[4:0]
#define TMGR28 (IO_VIRT + 0x02008070)
    #define TMGR28_B_PORT_E0_SEL Fld(5,25,AC_MSKB3) //[29:25]
    #define TMGR28_B_PORT_E1_SEL Fld(5,20,AC_MSKW32)//[24:20]
    #define TMGR28_B_PORT_E2_SEL Fld(5,15,AC_MSKW21)//[19:15]
    #define TMGR28_B_PORT_E3_SEL Fld(5,10,AC_MSKB1) //[14:10]
    #define TMGR28_B_PORT_E4_SEL Fld(5,5,AC_MSKW10) //[9:5]
    #define TMGR28_B_PORT_ECK_SEL Fld(5,0,AC_MSKB0) //[4:0]
#define TMGR29 (IO_VIRT + 0x02008074)
    #define TMGR29_VB1_PORT0_SEL Fld(5,25,AC_MSKB3) //[29:25]
    #define TMGR29_VB1_PORT1_SEL Fld(5,20,AC_MSKW32)//[24:20]
    #define TMGR29_VB1_PORT2_SEL Fld(5,15,AC_MSKW21)//[19:15]
    #define TMGR29_VB1_PORT3_SEL Fld(5,10,AC_MSKB1) //[14:10]
    #define TMGR29_VB1_PORT4_SEL Fld(5,5,AC_MSKW10) //[9:5]
    #define TMGR29_VB1_PORT5_SEL Fld(5,0,AC_MSKB0)  //[4:0]
#define TMGR30 (IO_VIRT + 0x02008078)
    #define TMGR30_VB1_PORT7_SEL Fld(5,5,AC_MSKW10)//[9:5]
    #define TMGR30_VB1_PORT6_SEL Fld(5,0,AC_MSKB0) //[4:0]
#define TMGR31 (IO_VIRT + 0x0200807C)
    #define TMGR31_MSTAR_CH4_SWAP Fld(2,10,AC_MSKB1)//[11:10]
    #define TMGR31_MSTAR_CH3_SWAP Fld(2,8,AC_MSKB1) //[9:8]
    #define TMGR31_MSTAR_CH2_SWAP Fld(2,6,AC_MSKB0) //[7:6]
    #define TMGR31_MSTAR_CH1_SWAP Fld(2,4,AC_MSKB0) //[7:6]
    #define TMGR31_MSTAR_DE_INV Fld(1,3,AC_MSKB0)   //[3:3]
    #define TMGR31_MSTAR_HS_INV Fld(1,2,AC_MSKB0)   //[2:2]
    #define TMGR31_MSTAR_VS_INV Fld(1,1,AC_MSKB0)   //[1:1]
    #define TMGR31_MSTAR_SRC_SEL Fld(1,0,AC_MSKB0)   //[0:0]
        #define SRC_FROM_OSTG   0
        #define SRC_FROM_MSTAR  1
#define TMGR32 (IO_VIRT + 0x02008080)
    #define TMGR32_MSTAR_CH4_Y_SWAP Fld(2,30,AC_MSKB3)//[31:30]
    #define TMGR32_MSTAR_CH4_B_SWAP Fld(2,28,AC_MSKB3)//[29:28]
    #define TMGR32_MSTAR_CH4_G_SWAP Fld(2,26,AC_MSKB3)//[27:26]
    #define TMGR32_MSTAR_CH4_R_SWAP Fld(2,24,AC_MSKB3)//[25:24]
    #define TMGR32_MSTAR_CH3_Y_SWAP Fld(2,22,AC_MSKB2)//[23:22]
    #define TMGR32_MSTAR_CH3_B_SWAP Fld(2,20,AC_MSKB2)//[21:20]
    #define TMGR32_MSTAR_CH3_G_SWAP Fld(2,18,AC_MSKB2)//[19:18]
    #define TMGR32_MSTAR_CH3_R_SWAP Fld(2,16,AC_MSKB2)//[17:16]
    #define TMGR32_MSTAR_CH2_Y_SWAP Fld(2,14,AC_MSKB1)//[15:14]
    #define TMGR32_MSTAR_CH2_B_SWAP Fld(2,12,AC_MSKB1)//[13:12]
    #define TMGR32_MSTAR_CH2_G_SWAP Fld(2,10,AC_MSKB1)//[11:10]
    #define TMGR32_MSTAR_CH2_R_SWAP Fld(2,8,AC_MSKB1) //[9:8]
    #define TMGR32_MSTAR_CH1_Y_SWAP Fld(2,6,AC_MSKB0) //[7:6]
    #define TMGR32_MSTAR_CH1_B_SWAP Fld(2,4,AC_MSKB0) //[5:4]
    #define TMGR32_MSTAR_CH1_G_SWAP Fld(2,2,AC_MSKB0) //[3:2]
    #define TMGR32_MSTAR_CH1_R_SWAP Fld(2,0,AC_MSKB0) //[1:0]
//----------------------Capy NEW-----------------------------//

//TCON
#define GR0 (IO_VIRT + 0x02008800)
    #define GR0_TC_EN Fld(1,31,AC_MSKB3)//[31:31]
    #define GR0_TCTG_HM Fld(1,30,AC_MSKB3)//[30:30]
    #define GR0_TCTG_FCR Fld(14,16,AC_MSKW32)//[29:16]
    #define GR0_TCTG_OEN Fld(16,0,AC_FULLW10)//[15:0]
        #define GR0_TCTG_OEN_GCLK Fld(1, 3, AC_MSKB0)
        #define GR0_TCTG_OEN_GCLK_END Fld(1, 8, AC_MSKB1)
        #define GR0_TCTG_OEN_MCLK Fld(1, 4, AC_MSKB0)
        #define GR0_TCTG_OEN_GST Fld(1, 5, AC_MSKB0)
        #define GR0_TCTG_OEN_GST_END Fld(1, 9, AC_MSKB1)
        #define GR0_TCTG_OEN_EO Fld(1, 6, AC_MSKB0)
        #define GR0_TCTG_OEN_EO2 Fld(1, 10, AC_MSKB1)
        #define GR0_TCTG_OEN_VCOM_DYN Fld(1, 7, AC_MSKB0)

        #define GR0_TCTG_OEN_TCONF Fld(1,15, AC_MSKB1)
        #define GR0_TCTG_OEN_TCONE Fld(1,14, AC_MSKB1)
        #define GR0_TCTG_OEN_TCOND Fld(1,13, AC_MSKB1)
        #define GR0_TCTG_OEN_TCONC Fld(1,12, AC_MSKB1)
        #define GR0_TCTG_OEN_TCONB Fld(1,11, AC_MSKB1)
        #define GR0_TCTG_OEN_TCONA Fld(1,10, AC_MSKB1)
        #define GR0_TCTG_OEN_TCON9 Fld(1, 9, AC_MSKB1)
        #define GR0_TCTG_OEN_TCON8 Fld(1, 8, AC_MSKB1)
        #define GR0_TCTG_OEN_TCON7 Fld(1, 7, AC_MSKB0)
        #define GR0_TCTG_OEN_TCON6 Fld(1, 6, AC_MSKB0)
        #define GR0_TCTG_OEN_TCON5 Fld(1, 5, AC_MSKB0)
        #define GR0_TCTG_OEN_TCON4 Fld(1, 4, AC_MSKB0)
        #define GR0_TCTG_OEN_TCON3 Fld(1, 3, AC_MSKB0)
        #define GR0_TCTG_OEN_TCON2 Fld(1, 2, AC_MSKB0)
        #define GR0_TCTG_OEN_TCON1 Fld(1, 1, AC_MSKB0)
        #define GR0_TCTG_OEN_TCON0 Fld(1, 0, AC_MSKB0)
		
#define GR1 (IO_VIRT + 0x02008804)
    #define GR1_DPC_SWEN Fld(1,31,AC_MSKB3)//[31:31]
    #define GR1_DPC_EN Fld(1,30,AC_MSKB3)//[30:30]
	#define GR1_FCNT_RESET Fld(1,29,AC_MSKB3)//[29:29]
	#define GR1_TCINT_DIS_DE Fld(1,28,AC_MSKB3)//[28:28]
    #define GR1_TCTG_HSINV Fld(1,27,AC_MSKB3)//[27:27]
    #define GR1_TCTG_VSINV Fld(1,26,AC_MSKB3)//[26:26]
    #define GR1_DPC_SW_MODE Fld(3,23,AC_MSKW32)//[25:23]
    #define GR1_TCON_INT_CLR Fld(6,16,AC_MSKB2)//[21:16]
    #define GR1_TCON_INT_EN Fld(6,8,AC_MSKB1)//[13:8]
    #define GR1_TCON_INT Fld(6,0,AC_MSKB0)//[5:0]

#define GR2 (IO_VIRT + 0x02008808)
    #define GR2_DPC_VTCSEL Fld(1,31,AC_MSKB3)//[31:31]
    #define GR2_DPC_VTF Fld(12,16,AC_MSKW32)//[27:16]
    #define GR2_DPC_VTR Fld(12,0,AC_MSKW10)//[11:0]

#define GR3 (IO_VIRT + 0x0200880C)
    #define GR3_DPC_VMRSEL Fld(1,31,AC_MSKB3)//[31:31]
    #define GR3_DPC_VMINV Fld(1,30,AC_MSKB3)//[30:30]
    #define GR3_DPC_VMNOTGL Fld(1,29,AC_MSKB3)//[29:29]
    #define GR3_FINV_SEL Fld(2,24,AC_MSKB3)//[25:24]
    #define GR3_GR_MON_SEL Fld(4,20,AC_MSKB2)//[23:20]
    #define GR3_LINE_OS Fld(3,16,AC_MSKB2)//[18:16]
    #define GR3_DPC_VMLCNT Fld(8,8,AC_FULLB1)//[15:8]
    #define GR3_DPC_VMHCNT Fld(8,0,AC_FULLB0)//[7:0]

#define GR4 (IO_VIRT + 0x02008810)
    #define GR4_TG_MUXSEL_B15 Fld(4,28,AC_MSKB3)//[31:28]
    #define GR4_TG_MUXSEL_B14 Fld(4,24,AC_MSKB3)//[27:24]
    #define GR4_TG_MUXSEL_B13 Fld(4,20,AC_MSKB2)//[23:20]
    #define GR4_TG_MUXSEL_B12 Fld(4,16,AC_MSKB2)//[19:16]
    #define GR4_TG_MUXSEL_B11 Fld(4,12,AC_MSKB1)//[15:12]
    #define GR4_TG_MUXSEL_B10 Fld(4,8,AC_MSKB1)//[11:8]
    #define GR4_TG_MUXSEL_B9 Fld(4,4,AC_MSKB0)//[7:4]
    #define GR4_TG_MUXSEL_B8 Fld(4,0,AC_MSKB0)//[3:0]

#define GR5 (IO_VIRT + 0x02008814)
    #define GR5_TG_MUXSEL_B7 Fld(4,28,AC_MSKB3)//[31:28]
    #define GR5_TG_MUXSEL_B6 Fld(4,24,AC_MSKB3)//[27:24]
    #define GR5_TG_MUXSEL_B5 Fld(4,20,AC_MSKB2)//[23:20]
    #define GR5_TG_MUXSEL_B4 Fld(4,16,AC_MSKB2)//[19:16]
    #define GR5_TG_MUXSEL_B3 Fld(4,12,AC_MSKB1)//[15:12]
    #define GR5_TG_MUXSEL_B2 Fld(4,8,AC_MSKB1)//[11:8]
    #define GR5_TG_MUXSEL_B1 Fld(4,4,AC_MSKB0)//[7:4]
    #define GR5_TG_MUXSEL_B0 Fld(4,0,AC_MSKB0)//[3:0]

#define GR6 (IO_VIRT + 0x02008818)
    #define GR6_TG_MODE15 Fld(2,30,AC_MSKB3)//[31:30]
    #define GR6_TG_MODE14 Fld(2,28,AC_MSKB3)//[29:28]
    #define GR6_TG_MODE13 Fld(2,26,AC_MSKB3)//[27:26]
    #define GR6_TG_MODE12 Fld(2,24,AC_MSKB3)//[25:24]
    #define GR6_TG_MODE11 Fld(2,22,AC_MSKB2)//[23:22]
    #define GR6_TG_MODE10 Fld(2,20,AC_MSKB2)//[21:20]
    #define GR6_TG_MODE9 Fld(2,18,AC_MSKB2)//[19:18]
    #define GR6_TG_MODE8 Fld(2,16,AC_MSKB2)//[17:16]
    #define GR6_TG_MODE7 Fld(2,14,AC_MSKB1)//[15:14]
    #define GR6_TG_MODE6 Fld(2,12,AC_MSKB1)//[13:12]
    #define GR6_TG_MODE5 Fld(2,10,AC_MSKB1)//[11:10]
    #define GR6_TG_MODE4 Fld(2,8,AC_MSKB1)//[9:8]
    #define GR6_TG_MODE3 Fld(2,6,AC_MSKB0)//[7:6]
    #define GR6_TG_MODE2 Fld(2,4,AC_MSKB0)//[5:4]
    #define GR6_TG_MODE1 Fld(2,2,AC_MSKB0)//[3:2]
    #define GR6_TG_MODE0 Fld(2,0,AC_MSKB0)//[1:0]

#define GR7 (IO_VIRT + 0x0200881C)
    #define GR7_TCO_MUTE Fld(16,16,AC_FULLW32)//[31:16]
    #define GR7_TCO_DEFAULT Fld(16,0,AC_FULLW10)//[15:0]

#define GR8 (IO_VIRT + 0x02008820)
    #define GR8_TCGPO Fld(16,16,AC_FULLW32)//[31:16]
    #define GR8_TCGPOEN Fld(16,0,AC_FULLW10)//[15:0]
        #define GR8_TCGPO_A Fld(1, 26, AC_MSKB3) //26
        #define GR8_TCGPOEN_A Fld(1, 10, AC_MSKB1) //10

#define GR9 (IO_VIRT + 0x02008824)
    #define GR9_CMD_EN Fld(4,16,AC_MSKB2)//[19:16]
    #define GR9_ABNF_EN Fld(16,0,AC_FULLW10)//[15:0]
#define GR10 (IO_VIRT + 0x02008828)
    #define GR10_TG_MUXSEL_C7 Fld(4,28,AC_MSKB3)//[31:28]
    #define GR10_TG_MUXSEL_C6 Fld(4,24,AC_MSKB3)//[27:24]
    #define GR10_TG_MUXSEL_C5 Fld(4,20,AC_MSKB2)//[23:20]
    #define GR10_TG_MUXSEL_C4 Fld(4,16,AC_MSKB2)//[19:16]
    #define GR10_TG_MUXSEL_C3 Fld(4,12,AC_MSKB1)//[15:12]
    #define GR10_TG_MUXSEL_C2 Fld(4,8,AC_MSKB1)//[11:8]
    #define GR10_TG_MUXSEL_C1 Fld(4,4,AC_MSKB0)//[7:4]
    #define GR10_TG_MUXSEL_C0 Fld(4,0,AC_MSKB0)//[3:0]
#define GR11 (IO_VIRT + 0x0200882C)
    #define GR11_TG_MUXSEL_D7 Fld(4,28,AC_MSKB3)//[31:28]
    #define GR11_TG_MUXSEL_D6 Fld(4,24,AC_MSKB3)//[27:24]
    #define GR11_TG_MUXSEL_D5 Fld(4,20,AC_MSKB2)//[23:20]
    #define GR11_TG_MUXSEL_D4 Fld(4,16,AC_MSKB2)//[19:16]
    #define GR11_TG_MUXSEL_D3 Fld(4,12,AC_MSKB1)//[15:12]
    #define GR11_TG_MUXSEL_D2 Fld(4,8,AC_MSKB1)//[11:8]
    #define GR11_TG_MUXSEL_D1 Fld(4,4,AC_MSKB0)//[7:4]
    #define GR11_TG_MUXSEL_D0 Fld(4,0,AC_MSKB0)//[3:0]
#define GR12 (IO_VIRT + 0x02008830)
    #define GR12_TCTG_VCNT_INT Fld(12,16,AC_MSKW32)//[27:16]
    #define GR12_TCTG_FCNT_INT Fld(14,0,AC_MSKW10)//[13:0]

#define TCSEL0 (IO_VIRT + 0x02008838)
    #define TCSEL0_TG_OUTSEL15 Fld(4,28,AC_MSKB3)//[31:28]
    #define TCSEL0_TG_OUTSEL14 Fld(4,24,AC_MSKB3)//[27:24]
    #define TCSEL0_TG_OUTSEL13 Fld(4,20,AC_MSKB2)//[23:20]
    #define TCSEL0_TG_OUTSEL12 Fld(4,16,AC_MSKB2)//[19:16]
    #define TCSEL0_TG_OUTSEL11 Fld(4,12,AC_MSKB1)//[15:12]
    #define TCSEL0_TG_OUTSEL10 Fld(4,8,AC_MSKB1)//[11:8]
    #define TCSEL0_TG_OUTSEL9 Fld(4,4,AC_MSKB0)//[7:4]
    #define TCSEL0_TG_OUTSEL8 Fld(4,0,AC_MSKB0)//[3:0]
#define TCSEL1 (IO_VIRT + 0x0200883C)
    #define TCSEL1_TG_OUTSEL7 Fld(4,28,AC_MSKB3)//[31:28]
    #define TCSEL1_TG_OUTSEL6 Fld(4,24,AC_MSKB3)//[27:24]
    #define TCSEL1_TG_OUTSEL5 Fld(4,20,AC_MSKB2)//[23:20]
    #define TCSEL1_TG_OUTSEL4 Fld(4,16,AC_MSKB2)//[19:16]
    #define TCSEL1_TG_OUTSEL3 Fld(4,12,AC_MSKB1)//[15:12]
    #define TCSEL1_TG_OUTSEL2 Fld(4,8,AC_MSKB1)//[11:8]
    #define TCSEL1_TG_OUTSEL1 Fld(4,4,AC_MSKB0)//[7:4]
    #define TCSEL1_TG_OUTSEL0 Fld(4,0,AC_MSKB0)//[3:0]

#define CRCR0 (IO_VIRT + 0x02008A40)
    #define CRC_FCNT Fld(4,16,AC_MSKB2)//[19:16]
    #define CRC_ENABLE Fld(16,0,AC_FULLW10)//[15:0]
    
#define CRCR1 (IO_VIRT + 0x02008A44)
    #define CRC_VE Fld(12,16,AC_MSKW32)//[27:16]
    #define CRC_VS Fld(12,0,AC_MSKW10)//[11:0]
    
#define CRCR2 (IO_VIRT + 0x02008A48)
    #define CRC_RESULT Fld(32,0,AC_FULLDW)//[31:0]

#endif
