#ifndef _HW_VM_H_
#define _HW_VM_H_
#define IO_VM_BASE 0x00015000

//Page VM_TOP
#define EMBEDDING_ON (IO_VM_BASE + 0x000)
    #define EMBEDDING_ON_WATERMARK_ON Fld(1,0,AC_MSKB0)//[0:0]
    #define EMBEDDING_ON_VIDEOMARK_SOFWARE_RESET_B Fld(1,1,AC_MSKB0)//[1:1]
    #define EMBEDDING_ON_FRAME_RST_ENABLE Fld(1,2,AC_MSKB0)//[2:2]
    #define EMBEDDING_ON_BACKGROUND_EMBEDDING_ON Fld(1,16,AC_MSKB2)//[16:16]
    #define EMBEDDING_ON_SYMBOL_BACKGROUND_EMBED_ENABLE Fld(1,17,AC_MSKB2)//[17:17]
    #define EMBEDDING_ON_VM_BYPASS_MODE Fld(1,23,AC_MSKB2)//[23:23]
#define FREQUENCY_DISTANCE_0 (IO_VM_BASE + 0x004)
    #define FREQUENCY_DISTANCE_0_FREQUENCY_DISTANCE_0_0 Fld(8,0,AC_FULLB0)//[7:0]
    #define FREQUENCY_DISTANCE_0_FREQUENCY_DISTANCE_0_1 Fld(8,8,AC_FULLB1)//[15:8]
    #define FREQUENCY_DISTANCE_0_FREQUENCY_DISTANCE_0_2 Fld(8,16,AC_FULLB2)//[23:16]
#define FREQUENCY_DISTANCE_1 (IO_VM_BASE + 0x008)
    #define FREQUENCY_DISTANCE_1_FREQUENCY_DISTANCE_1_0 Fld(8,0,AC_FULLB0)//[7:0]
    #define FREQUENCY_DISTANCE_1_FREQUENCY_DISTANCE_1_1 Fld(8,8,AC_FULLB1)//[15:8]
    #define FREQUENCY_DISTANCE_1_FREQUENCY_DISTANCE_1_2 Fld(8,16,AC_FULLB2)//[23:16]
#define FREQUENCY_DISTANCE_2 (IO_VM_BASE + 0x00C)
    #define FREQUENCY_DISTANCE_2_FREQUENCY_DISTANCE_2_0 Fld(8,0,AC_FULLB0)//[7:0]
    #define FREQUENCY_DISTANCE_2_FREQUENCY_DISTANCE_2_1 Fld(8,8,AC_FULLB1)//[15:8]
    #define FREQUENCY_DISTANCE_2_FREQUENCY_DISTANCE_2_2 Fld(8,16,AC_FULLB2)//[23:16]
#define EMBEDDING_CONFIG_0 (IO_VM_BASE + 0x010)
    #define EMBEDDING_CONFIG_0_DIRECTION_MAX Fld(12,0,AC_MSKW10)//[11:0]
    #define EMBEDDING_CONFIG_0_STRENGTH_MULTIPLY Fld(8,16,AC_FULLB2)//[23:16]
#define SYMBOLS_INFO (IO_VM_BASE + 0x014)
    #define SYMBOLS_INFO_SYMBOLS_ROWS Fld(8,0,AC_FULLB0)//[7:0]
    #define SYMBOLS_INFO_SYMBOLS_COLS Fld(8,8,AC_FULLB1)//[15:8]
    #define SYMBOLS_INFO_SYMBOLS_SIZE Fld(8,16,AC_FULLB2)//[23:16]
    #define SYMBOLS_INFO_SYMBOLS_SCALER_CONTROL Fld(8,24,AC_FULLB3)//[31:24]
#define SYMBOLS_POS (IO_VM_BASE + 0x018)
    #define SYMBOLS_POS_SYMBOLS_XPOS Fld(16,0,AC_FULLW10)//[15:0]
    #define SYMBOLS_POS_SYMBOLS_YPOS Fld(16,16,AC_FULLW32)//[31:16]
#define SYMBOLS_SPACING (IO_VM_BASE + 0x01C)
    #define SYMBOLS_SPACING_SPACING_HORZ Fld(16,0,AC_FULLW10)//[15:0]
    #define SYMBOLS_SPACING_SPACING_VERT Fld(16,16,AC_FULLW32)//[31:16]
#define EMBEDDING_STRENGTH_THRESHOLD_10_0 (IO_VM_BASE + 0x100)
    #define EMBEDDING_STRENGTH_THRESHOLD_10_0_EMBEDDING_STRENGTH_THRESHOLD_10_1 Fld(14,0,AC_MSKW10)//[13:0]
    #define EMBEDDING_STRENGTH_THRESHOLD_10_0_EMBEDDING_STRENGTH_THRESHOLD_10_2 Fld(14,16,AC_MSKW32)//[29:16]
#define EMBEDDING_STRENGTH_THRESHOLD_10_1 (IO_VM_BASE + 0x104)
    #define EMBEDDING_STRENGTH_THRESHOLD_10_1_EMBEDDING_STRENGTH_THRESHOLD_10_3 Fld(14,0,AC_MSKW10)//[13:0]
    #define EMBEDDING_STRENGTH_THRESHOLD_10_1_EMBEDDING_STRENGTH_THRESHOLD_10_4 Fld(14,16,AC_MSKW32)//[29:16]
#define EMBEDDING_STRENGTH_THRESHOLD_10_2 (IO_VM_BASE + 0x108)
    #define EMBEDDING_STRENGTH_THRESHOLD_10_2_EMBEDDING_STRENGTH_THRESHOLD_10_5 Fld(14,0,AC_MSKW10)//[13:0]
    #define EMBEDDING_STRENGTH_THRESHOLD_10_2_EMBEDDING_STRENGTH_THRESHOLD_10_6 Fld(14,16,AC_MSKW32)//[29:16]
#define EMBEDDING_STRENGTH_THRESHOLD_10_3 (IO_VM_BASE + 0x10C)
    #define EMBEDDING_STRENGTH_THRESHOLD_10_3_EMBEDDING_STRENGTH_THRESHOLD_10_7 Fld(14,0,AC_MSKW10)//[13:0]
    #define EMBEDDING_STRENGTH_THRESHOLD_10_3_EMBEDDING_STRENGTH_THRESHOLD_10_8 Fld(14,16,AC_MSKW32)//[29:16]
#define EMBEDDING_STRENGTH_THRESHOLD_10_4 (IO_VM_BASE + 0x110)
    #define EMBEDDING_STRENGTH_THRESHOLD_10_4_EMBEDDING_STRENGTH_THRESHOLD_10_9 Fld(14,0,AC_MSKW10)//[13:0]
    #define EMBEDDING_STRENGTH_THRESHOLD_10_4_EMBEDDING_STRENGTH_THRESHOLD_10_10 Fld(14,16,AC_MSKW32)//[29:16]
#define EMBEDDING_STRENGTH_THRESHOLD_10_5 (IO_VM_BASE + 0x114)
    #define EMBEDDING_STRENGTH_THRESHOLD_10_5_EMBEDDING_STRENGTH_THRESHOLD_10_11 Fld(14,0,AC_MSKW10)//[13:0]
    #define EMBEDDING_STRENGTH_THRESHOLD_10_5_EMBEDDING_STRENGTH_THRESHOLD_10_12 Fld(14,16,AC_MSKW32)//[29:16]
#define EMBEDDING_STRENGTH_THRESHOLD_8_0 (IO_VM_BASE + 0x118)
    #define EMBEDDING_STRENGTH_THRESHOLD_8_0_EMBEDDING_STRENGTH_THRESHOLD_8_1 Fld(14,0,AC_MSKW10)//[13:0]
    #define EMBEDDING_STRENGTH_THRESHOLD_8_0_EMBEDDING_STRENGTH_THRESHOLD_8_2 Fld(14,16,AC_MSKW32)//[29:16]
#define EMBEDDING_STRENGTH_THRESHOLD_8_1 (IO_VM_BASE + 0x11C)
    #define EMBEDDING_STRENGTH_THRESHOLD_8_1_EMBEDDING_STRENGTH_THRESHOLD_8_3 Fld(14,0,AC_MSKW10)//[13:0]
#define EMBEDDING_STRENGTH_THRESHOLD_12_0 (IO_VM_BASE + 0x120)
    #define EMBEDDING_STRENGTH_THRESHOLD_12_0_EMBEDDING_STRENGTH_THRESHOLD_12_1 Fld(14,0,AC_MSKW10)//[13:0]
    #define EMBEDDING_STRENGTH_THRESHOLD_12_0_EMBEDDING_STRENGTH_THRESHOLD_12_2 Fld(14,16,AC_MSKW32)//[29:16]
#define EMBEDDING_STRENGTH_THRESHOLD_12_1 (IO_VM_BASE + 0x124)
    #define EMBEDDING_STRENGTH_THRESHOLD_12_1_EMBEDDING_STRENGTH_THRESHOLD_12_3 Fld(14,0,AC_MSKW10)//[13:0]
    #define EMBEDDING_STRENGTH_THRESHOLD_12_1_EMBEDDING_STRENGTH_THRESHOLD_12_4 Fld(14,16,AC_MSKW32)//[29:16]
#define EMBEDDING_STRENGTH_THRESHOLD_12_2 (IO_VM_BASE + 0x128)
    #define EMBEDDING_STRENGTH_THRESHOLD_12_2_EMBEDDING_STRENGTH_THRESHOLD_12_5 Fld(14,0,AC_MSKW10)//[13:0]
    #define EMBEDDING_STRENGTH_THRESHOLD_12_2_EMBEDDING_STRENGTH_THRESHOLD_12_6 Fld(14,16,AC_MSKW32)//[29:16]
#define EMBEDDING_STRENGTH_THRESHOLD_12_3 (IO_VM_BASE + 0x12C)
    #define EMBEDDING_STRENGTH_THRESHOLD_12_3_EMBEDDING_STRENGTH_THRESHOLD_12_7 Fld(14,0,AC_MSKW10)//[13:0]
    #define EMBEDDING_STRENGTH_THRESHOLD_12_3_EMBEDDING_STRENGTH_THRESHOLD_12_8 Fld(14,16,AC_MSKW32)//[29:16]
#define EMBEDDING_STRENGTH_THRESHOLD_12_4 (IO_VM_BASE + 0x130)
    #define EMBEDDING_STRENGTH_THRESHOLD_12_4_EMBEDDING_STRENGTH_THRESHOLD_12_9 Fld(14,0,AC_MSKW10)//[13:0]
    #define EMBEDDING_STRENGTH_THRESHOLD_12_4_EMBEDDING_STRENGTH_THRESHOLD_12_10 Fld(14,16,AC_MSKW32)//[29:16]
#define EMBEDDING_STRENGTH_THRESHOLD_12_5 (IO_VM_BASE + 0x134)
    #define EMBEDDING_STRENGTH_THRESHOLD_12_5_EMBEDDING_STRENGTH_THRESHOLD_12_11 Fld(14,0,AC_MSKW10)//[13:0]
    #define EMBEDDING_STRENGTH_THRESHOLD_12_5_EMBEDDING_STRENGTH_THRESHOLD_12_12 Fld(14,16,AC_MSKW32)//[29:16]
#define EMBEDDING_STRENGTH_THRESHOLD_12_6 (IO_VM_BASE + 0x138)
    #define EMBEDDING_STRENGTH_THRESHOLD_12_6_EMBEDDING_STRENGTH_THRESHOLD_12_13 Fld(14,0,AC_MSKW10)//[13:0]
    #define EMBEDDING_STRENGTH_THRESHOLD_12_6_EMBEDDING_STRENGTH_THRESHOLD_12_14 Fld(14,16,AC_MSKW32)//[29:16]
#define EMBEDDING_STRENGTH_THRESHOLD_12_7 (IO_VM_BASE + 0x13C)
    #define EMBEDDING_STRENGTH_THRESHOLD_12_7_EMBEDDING_STRENGTH_THRESHOLD_12_15 Fld(14,0,AC_MSKW10)//[13:0]
    #define EMBEDDING_STRENGTH_THRESHOLD_12_7_EMBEDDING_STRENGTH_THRESHOLD_12_16 Fld(14,16,AC_MSKW32)//[29:16]
#define EMBEDDING_STRENGTH_THRESHOLD_12_8 (IO_VM_BASE + 0x140)
    #define EMBEDDING_STRENGTH_THRESHOLD_12_8_EMBEDDING_STRENGTH_THRESHOLD_12_17 Fld(14,0,AC_MSKW10)//[13:0]
    #define EMBEDDING_STRENGTH_THRESHOLD_12_8_EMBEDDING_STRENGTH_THRESHOLD_12_18 Fld(14,16,AC_MSKW32)//[29:16]
#define EMBEDDING_STRENGTH_THRESHOLD_12_9 (IO_VM_BASE + 0x144)
    #define EMBEDDING_STRENGTH_THRESHOLD_12_9_EMBEDDING_STRENGTH_THRESHOLD_12_19 Fld(14,0,AC_MSKW10)//[13:0]
    #define EMBEDDING_STRENGTH_THRESHOLD_12_9_EMBEDDING_STRENGTH_THRESHOLD_12_20 Fld(14,16,AC_MSKW32)//[29:16]
#define EMBEDDING_STRENGTH_THRESHOLD_12_10 (IO_VM_BASE + 0x148)
    #define EMBEDDING_STRENGTH_THRESHOLD_12_10_EMBEDDING_STRENGTH_THRESHOLD_12_21 Fld(14,0,AC_MSKW10)//[13:0]
    #define EMBEDDING_STRENGTH_THRESHOLD_12_10_EMBEDDING_STRENGTH_THRESHOLD_12_22 Fld(14,16,AC_MSKW32)//[29:16]
#define EMBEDDING_STRENGTH_THRESHOLD_12_11 (IO_VM_BASE + 0x14C)
    #define EMBEDDING_STRENGTH_THRESHOLD_12_11_EMBEDDING_STRENGTH_THRESHOLD_12_23 Fld(14,0,AC_MSKW10)//[13:0]
    #define EMBEDDING_STRENGTH_THRESHOLD_12_11_EMBEDDING_STRENGTH_THRESHOLD_12_24 Fld(14,16,AC_MSKW32)//[29:16]
#define EMBEDDING_STRENGTH_THRESHOLD_12_12 (IO_VM_BASE + 0x150)
    #define EMBEDDING_STRENGTH_THRESHOLD_12_12_EMBEDDING_STRENGTH_THRESHOLD_12_25 Fld(14,0,AC_MSKW10)//[13:0]
    #define EMBEDDING_STRENGTH_THRESHOLD_12_12_EMBEDDING_STRENGTH_THRESHOLD_12_26 Fld(14,16,AC_MSKW32)//[29:16]
#define EMBEDDING_STRENGTH_THRESHOLD_12_13 (IO_VM_BASE + 0x154)
    #define EMBEDDING_STRENGTH_THRESHOLD_12_13_EMBEDDING_STRENGTH_THRESHOLD_12_27 Fld(14,0,AC_MSKW10)//[13:0]
    #define EMBEDDING_STRENGTH_THRESHOLD_12_13_EMBEDDING_STRENGTH_THRESHOLD_12_28 Fld(14,16,AC_MSKW32)//[29:16]
#define EMBEDDING_STRENGTH_THRESHOLD_12_14 (IO_VM_BASE + 0x158)
    #define EMBEDDING_STRENGTH_THRESHOLD_12_14_EMBEDDING_STRENGTH_THRESHOLD_12_29 Fld(14,0,AC_MSKW10)//[13:0]
    #define EMBEDDING_STRENGTH_THRESHOLD_12_14_EMBEDDING_STRENGTH_THRESHOLD_12_30 Fld(14,16,AC_MSKW32)//[29:16]
#define EMBEDDING_STRENGTH_THRESHOLD_12_15 (IO_VM_BASE + 0x15C)
    #define EMBEDDING_STRENGTH_THRESHOLD_12_15_EMBEDDING_STRENGTH_THRESHOLD_12_31 Fld(14,0,AC_MSKW10)//[13:0]
    #define EMBEDDING_STRENGTH_THRESHOLD_12_15_EMBEDDING_STRENGTH_THRESHOLD_12_32 Fld(14,16,AC_MSKW32)//[29:16]
#define EMBEDDING_STRENGTH_THRESHOLD_12_16 (IO_VM_BASE + 0x160)
    #define EMBEDDING_STRENGTH_THRESHOLD_12_16_EMBEDDING_STRENGTH_THRESHOLD_12_33 Fld(14,0,AC_MSKW10)//[13:0]
    #define EMBEDDING_STRENGTH_THRESHOLD_12_16_EMBEDDING_STRENGTH_THRESHOLD_12_34 Fld(14,16,AC_MSKW32)//[29:16]
#define EMBEDDING_STRENGTH_THRESHOLD_12_17 (IO_VM_BASE + 0x164)
    #define EMBEDDING_STRENGTH_THRESHOLD_12_17_EMBEDDING_STRENGTH_THRESHOLD_12_35 Fld(14,0,AC_MSKW10)//[13:0]
    #define EMBEDDING_STRENGTH_THRESHOLD_12_17_EMBEDDING_STRENGTH_THRESHOLD_12_36 Fld(14,16,AC_MSKW32)//[29:16]
#define EMBEDDING_STRENGTH_THRESHOLD_12_18 (IO_VM_BASE + 0x168)
    #define EMBEDDING_STRENGTH_THRESHOLD_12_18_EMBEDDING_STRENGTH_THRESHOLD_12_37 Fld(14,0,AC_MSKW10)//[13:0]
    #define EMBEDDING_STRENGTH_THRESHOLD_12_18_EMBEDDING_STRENGTH_THRESHOLD_12_38 Fld(14,16,AC_MSKW32)//[29:16]
#define EMBEDDING_STRENGTH_THRESHOLD_12_19 (IO_VM_BASE + 0x16C)
    #define EMBEDDING_STRENGTH_THRESHOLD_12_19_EMBEDDING_STRENGTH_THRESHOLD_12_39 Fld(14,0,AC_MSKW10)//[13:0]
    #define EMBEDDING_STRENGTH_THRESHOLD_12_19_EMBEDDING_STRENGTH_THRESHOLD_12_40 Fld(14,16,AC_MSKW32)//[29:16]
#define EMBEDDING_STRENGTH_THRESHOLD_12_20 (IO_VM_BASE + 0x170)
    #define EMBEDDING_STRENGTH_THRESHOLD_12_20_EMBEDDING_STRENGTH_THRESHOLD_12_41 Fld(14,0,AC_MSKW10)//[13:0]
    #define EMBEDDING_STRENGTH_THRESHOLD_12_20_EMBEDDING_STRENGTH_THRESHOLD_12_42 Fld(14,16,AC_MSKW32)//[29:16]
#define EMBEDDING_STRENGTH_THRESHOLD_12_21 (IO_VM_BASE + 0x174)
    #define EMBEDDING_STRENGTH_THRESHOLD_12_21_EMBEDDING_STRENGTH_THRESHOLD_12_43 Fld(14,0,AC_MSKW10)//[13:0]
    #define EMBEDDING_STRENGTH_THRESHOLD_12_21_EMBEDDING_STRENGTH_THRESHOLD_12_44 Fld(14,16,AC_MSKW32)//[29:16]
#define EMBEDDING_STRENGTH_THRESHOLD_12_22 (IO_VM_BASE + 0x178)
    #define EMBEDDING_STRENGTH_THRESHOLD_12_22_EMBEDDING_STRENGTH_THRESHOLD_12_45 Fld(14,0,AC_MSKW10)//[13:0]
    #define EMBEDDING_STRENGTH_THRESHOLD_12_22_EMBEDDING_STRENGTH_THRESHOLD_12_46 Fld(14,16,AC_MSKW32)//[29:16]
#define EMBEDDING_STRENGTH_THRESHOLD_12_23 (IO_VM_BASE + 0x17C)
    #define EMBEDDING_STRENGTH_THRESHOLD_12_23_EMBEDDING_STRENGTH_THRESHOLD_12_47 Fld(14,0,AC_MSKW10)//[13:0]
    #define EMBEDDING_STRENGTH_THRESHOLD_12_23_EMBEDDING_STRENGTH_THRESHOLD_12_48 Fld(14,16,AC_MSKW32)//[29:16]
#define EMBEDDING_STRENGTH_THRESHOLD_10_BG_0 (IO_VM_BASE + 0x180)
    #define EMBEDDING_STRENGTH_THRESHOLD_10_BG_0_EMBEDDING_STRENGTH_THRESHOLD_10_BG_1 Fld(14,0,AC_MSKW10)//[13:0]
    #define EMBEDDING_STRENGTH_THRESHOLD_10_BG_0_EMBEDDING_STRENGTH_THRESHOLD_10_BG_2 Fld(14,16,AC_MSKW32)//[29:16]
#define EMBEDDING_STRENGTH_THRESHOLD_10_BG_1 (IO_VM_BASE + 0x184)
    #define EMBEDDING_STRENGTH_THRESHOLD_10_BG_1_EMBEDDING_STRENGTH_THRESHOLD_10_BG_3 Fld(14,0,AC_MSKW10)//[13:0]
    #define EMBEDDING_STRENGTH_THRESHOLD_10_BG_1_EMBEDDING_STRENGTH_THRESHOLD_10_BG_4 Fld(14,16,AC_MSKW32)//[29:16]
#define EMBEDDING_STRENGTH_THRESHOLD_10_BG_2 (IO_VM_BASE + 0x188)
    #define EMBEDDING_STRENGTH_THRESHOLD_10_BG_2_EMBEDDING_STRENGTH_THRESHOLD_10_BG_5 Fld(14,0,AC_MSKW10)//[13:0]
    #define EMBEDDING_STRENGTH_THRESHOLD_10_BG_2_EMBEDDING_STRENGTH_THRESHOLD_10_BG_6 Fld(14,16,AC_MSKW32)//[29:16]
#define EMBEDDING_STRENGTH_THRESHOLD_10_BG_3 (IO_VM_BASE + 0x18C)
    #define EMBEDDING_STRENGTH_THRESHOLD_10_BG_3_EMBEDDING_STRENGTH_THRESHOLD_10_BG_7 Fld(14,0,AC_MSKW10)//[13:0]
    #define EMBEDDING_STRENGTH_THRESHOLD_10_BG_3_EMBEDDING_STRENGTH_THRESHOLD_10_BG_8 Fld(14,16,AC_MSKW32)//[29:16]
#define EMBEDDING_STRENGTH_THRESHOLD_10_BG_4 (IO_VM_BASE + 0x190)
    #define EMBEDDING_STRENGTH_THRESHOLD_10_BG_4_EMBEDDING_STRENGTH_THRESHOLD_10_BG_9 Fld(14,0,AC_MSKW10)//[13:0]
    #define EMBEDDING_STRENGTH_THRESHOLD_10_BG_4_EMBEDDING_STRENGTH_THRESHOLD_10_BG_10 Fld(14,16,AC_MSKW32)//[29:16]
#define EMBEDDING_STRENGTH_THRESHOLD_10_BG_5 (IO_VM_BASE + 0x194)
    #define EMBEDDING_STRENGTH_THRESHOLD_10_BG_5_EMBEDDING_STRENGTH_THRESHOLD_10_BG_11 Fld(14,0,AC_MSKW10)//[13:0]
    #define EMBEDDING_STRENGTH_THRESHOLD_10_BG_5_EMBEDDING_STRENGTH_THRESHOLD_10_BG_12 Fld(14,16,AC_MSKW32)//[29:16]
#define EMBEDDING_STRENGTH_THRESHOLD_8_BG_0 (IO_VM_BASE + 0x198)
    #define EMBEDDING_STRENGTH_THRESHOLD_8_BG_0_EMBEDDING_STRENGTH_THRESHOLD_8_BG_1 Fld(14,0,AC_MSKW10)//[13:0]
    #define EMBEDDING_STRENGTH_THRESHOLD_8_BG_0_EMBEDDING_STRENGTH_THRESHOLD_8_BG_2 Fld(14,16,AC_MSKW32)//[29:16]
#define EMBEDDING_STRENGTH_THRESHOLD_8_BG_1 (IO_VM_BASE + 0x19C)
    #define EMBEDDING_STRENGTH_THRESHOLD_8_BG_1_EMBEDDING_STRENGTH_THRESHOLD_8_BG_3 Fld(14,0,AC_MSKW10)//[13:0]
#define EMBEDDING_STRENGTH_THRESHOLD_12_BG_0 (IO_VM_BASE + 0x1A0)
    #define EMBEDDING_STRENGTH_THRESHOLD_12_BG_0_EMBEDDING_STRENGTH_THRESHOLD_12_BG_1 Fld(14,0,AC_MSKW10)//[13:0]
    #define EMBEDDING_STRENGTH_THRESHOLD_12_BG_0_EMBEDDING_STRENGTH_THRESHOLD_12_BG_2 Fld(14,16,AC_MSKW32)//[29:16]
#define EMBEDDING_STRENGTH_THRESHOLD_12_BG_1 (IO_VM_BASE + 0x1A4)
    #define EMBEDDING_STRENGTH_THRESHOLD_12_BG_1_EMBEDDING_STRENGTH_THRESHOLD_12_BG_3 Fld(14,0,AC_MSKW10)//[13:0]
    #define EMBEDDING_STRENGTH_THRESHOLD_12_BG_1_EMBEDDING_STRENGTH_THRESHOLD_12_BG_4 Fld(14,16,AC_MSKW32)//[29:16]
#define EMBEDDING_STRENGTH_THRESHOLD_12_BG_2 (IO_VM_BASE + 0x1A8)
    #define EMBEDDING_STRENGTH_THRESHOLD_12_BG_2_EMBEDDING_STRENGTH_THRESHOLD_12_BG_5 Fld(14,0,AC_MSKW10)//[13:0]
    #define EMBEDDING_STRENGTH_THRESHOLD_12_BG_2_EMBEDDING_STRENGTH_THRESHOLD_12_BG_6 Fld(14,16,AC_MSKW32)//[29:16]
#define EMBEDDING_STRENGTH_THRESHOLD_12_BG_3 (IO_VM_BASE + 0x1AC)
    #define EMBEDDING_STRENGTH_THRESHOLD_12_BG_3_EMBEDDING_STRENGTH_THRESHOLD_12_BG_7 Fld(14,0,AC_MSKW10)//[13:0]
    #define EMBEDDING_STRENGTH_THRESHOLD_12_BG_3_EMBEDDING_STRENGTH_THRESHOLD_12_BG_8 Fld(14,16,AC_MSKW32)//[29:16]
#define EMBEDDING_STRENGTH_THRESHOLD_12_BG_4 (IO_VM_BASE + 0x1B0)
    #define EMBEDDING_STRENGTH_THRESHOLD_12_BG_4_EMBEDDING_STRENGTH_THRESHOLD_12_BG_9 Fld(14,0,AC_MSKW10)//[13:0]
    #define EMBEDDING_STRENGTH_THRESHOLD_12_BG_4_EMBEDDING_STRENGTH_THRESHOLD_12_BG_10 Fld(14,16,AC_MSKW32)//[29:16]
#define EMBEDDING_STRENGTH_THRESHOLD_12_BG_5 (IO_VM_BASE + 0x1B4)
    #define EMBEDDING_STRENGTH_THRESHOLD_12_BG_5_EMBEDDING_STRENGTH_THRESHOLD_12_BG_11 Fld(14,0,AC_MSKW10)//[13:0]
    #define EMBEDDING_STRENGTH_THRESHOLD_12_BG_5_EMBEDDING_STRENGTH_THRESHOLD_12_BG_12 Fld(14,16,AC_MSKW32)//[29:16]
#define EMBEDDING_STRENGTH_THRESHOLD_12_BG_6 (IO_VM_BASE + 0x1B8)
    #define EMBEDDING_STRENGTH_THRESHOLD_12_BG_6_EMBEDDING_STRENGTH_THRESHOLD_12_BG_13 Fld(14,0,AC_MSKW10)//[13:0]
    #define EMBEDDING_STRENGTH_THRESHOLD_12_BG_6_EMBEDDING_STRENGTH_THRESHOLD_12_BG_14 Fld(14,16,AC_MSKW32)//[29:16]
#define EMBEDDING_STRENGTH_THRESHOLD_12_BG_7 (IO_VM_BASE + 0x1BC)
    #define EMBEDDING_STRENGTH_THRESHOLD_12_BG_7_EMBEDDING_STRENGTH_THRESHOLD_12_BG_15 Fld(14,0,AC_MSKW10)//[13:0]
    #define EMBEDDING_STRENGTH_THRESHOLD_12_BG_7_EMBEDDING_STRENGTH_THRESHOLD_12_BG_16 Fld(14,16,AC_MSKW32)//[29:16]
#define EMBEDDING_STRENGTH_THRESHOLD_12_BG_8 (IO_VM_BASE + 0x1C0)
    #define EMBEDDING_STRENGTH_THRESHOLD_12_BG_8_EMBEDDING_STRENGTH_THRESHOLD_12_BG_17 Fld(14,0,AC_MSKW10)//[13:0]
    #define EMBEDDING_STRENGTH_THRESHOLD_12_BG_8_EMBEDDING_STRENGTH_THRESHOLD_12_BG_18 Fld(14,16,AC_MSKW32)//[29:16]
#define EMBEDDING_STRENGTH_THRESHOLD_12_BG_9 (IO_VM_BASE + 0x1C4)
    #define EMBEDDING_STRENGTH_THRESHOLD_12_BG_9_EMBEDDING_STRENGTH_THRESHOLD_12_BG_19 Fld(14,0,AC_MSKW10)//[13:0]
    #define EMBEDDING_STRENGTH_THRESHOLD_12_BG_9_EMBEDDING_STRENGTH_THRESHOLD_12_BG_20 Fld(14,16,AC_MSKW32)//[29:16]
#define EMBEDDING_STRENGTH_THRESHOLD_12_BG_10 (IO_VM_BASE + 0x1C8)
    #define EMBEDDING_STRENGTH_THRESHOLD_12_BG_10_EMBEDDING_STRENGTH_THRESHOLD_12_BG_21 Fld(14,0,AC_MSKW10)//[13:0]
    #define EMBEDDING_STRENGTH_THRESHOLD_12_BG_10_EMBEDDING_STRENGTH_THRESHOLD_12_BG_22 Fld(14,16,AC_MSKW32)//[29:16]
#define EMBEDDING_STRENGTH_THRESHOLD_12_BG_11 (IO_VM_BASE + 0x1CC)
    #define EMBEDDING_STRENGTH_THRESHOLD_12_BG_11_EMBEDDING_STRENGTH_THRESHOLD_12_BG_23 Fld(14,0,AC_MSKW10)//[13:0]
    #define EMBEDDING_STRENGTH_THRESHOLD_12_BG_11_EMBEDDING_STRENGTH_THRESHOLD_12_BG_24 Fld(14,16,AC_MSKW32)//[29:16]
#define EMBEDDING_STRENGTH_THRESHOLD_12_BG_12 (IO_VM_BASE + 0x1D0)
    #define EMBEDDING_STRENGTH_THRESHOLD_12_BG_12_EMBEDDING_STRENGTH_THRESHOLD_12_BG_25 Fld(14,0,AC_MSKW10)//[13:0]
    #define EMBEDDING_STRENGTH_THRESHOLD_12_BG_12_EMBEDDING_STRENGTH_THRESHOLD_12_BG_26 Fld(14,16,AC_MSKW32)//[29:16]
#define EMBEDDING_STRENGTH_THRESHOLD_12_BG_13 (IO_VM_BASE + 0x1D4)
    #define EMBEDDING_STRENGTH_THRESHOLD_12_BG_13_EMBEDDING_STRENGTH_THRESHOLD_12_BG_27 Fld(14,0,AC_MSKW10)//[13:0]
    #define EMBEDDING_STRENGTH_THRESHOLD_12_BG_13_EMBEDDING_STRENGTH_THRESHOLD_12_BG_28 Fld(14,16,AC_MSKW32)//[29:16]
#define EMBEDDING_STRENGTH_THRESHOLD_12_BG_14 (IO_VM_BASE + 0x1D8)
    #define EMBEDDING_STRENGTH_THRESHOLD_12_BG_14_EMBEDDING_STRENGTH_THRESHOLD_12_BG_29 Fld(14,0,AC_MSKW10)//[13:0]
    #define EMBEDDING_STRENGTH_THRESHOLD_12_BG_14_EMBEDDING_STRENGTH_THRESHOLD_12_BG_30 Fld(14,16,AC_MSKW32)//[29:16]
#define EMBEDDING_STRENGTH_THRESHOLD_12_BG_15 (IO_VM_BASE + 0x1DC)
    #define EMBEDDING_STRENGTH_THRESHOLD_12_BG_15_EMBEDDING_STRENGTH_THRESHOLD_12_BG_31 Fld(14,0,AC_MSKW10)//[13:0]
    #define EMBEDDING_STRENGTH_THRESHOLD_12_BG_15_EMBEDDING_STRENGTH_THRESHOLD_12_BG_32 Fld(14,16,AC_MSKW32)//[29:16]
#define EMBEDDING_STRENGTH_THRESHOLD_12_BG_16 (IO_VM_BASE + 0x1E0)
    #define EMBEDDING_STRENGTH_THRESHOLD_12_BG_16_EMBEDDING_STRENGTH_THRESHOLD_12_BG_33 Fld(14,0,AC_MSKW10)//[13:0]
    #define EMBEDDING_STRENGTH_THRESHOLD_12_BG_16_EMBEDDING_STRENGTH_THRESHOLD_12_BG_34 Fld(14,16,AC_MSKW32)//[29:16]
#define EMBEDDING_STRENGTH_THRESHOLD_12_BG_17 (IO_VM_BASE + 0x1E4)
    #define EMBEDDING_STRENGTH_THRESHOLD_12_BG_17_EMBEDDING_STRENGTH_THRESHOLD_12_BG_35 Fld(14,0,AC_MSKW10)//[13:0]
    #define EMBEDDING_STRENGTH_THRESHOLD_12_BG_17_EMBEDDING_STRENGTH_THRESHOLD_12_BG_36 Fld(14,16,AC_MSKW32)//[29:16]
#define EMBEDDING_STRENGTH_THRESHOLD_12_BG_18 (IO_VM_BASE + 0x1E8)
    #define EMBEDDING_STRENGTH_THRESHOLD_12_BG_18_EMBEDDING_STRENGTH_THRESHOLD_12_BG_37 Fld(14,0,AC_MSKW10)//[13:0]
    #define EMBEDDING_STRENGTH_THRESHOLD_12_BG_18_EMBEDDING_STRENGTH_THRESHOLD_12_BG_38 Fld(14,16,AC_MSKW32)//[29:16]
#define EMBEDDING_STRENGTH_THRESHOLD_12_BG_19 (IO_VM_BASE + 0x1EC)
    #define EMBEDDING_STRENGTH_THRESHOLD_12_BG_19_EMBEDDING_STRENGTH_THRESHOLD_12_BG_39 Fld(14,0,AC_MSKW10)//[13:0]
    #define EMBEDDING_STRENGTH_THRESHOLD_12_BG_19_EMBEDDING_STRENGTH_THRESHOLD_12_BG_40 Fld(14,16,AC_MSKW32)//[29:16]
#define EMBEDDING_STRENGTH_THRESHOLD_12_BG_20 (IO_VM_BASE + 0x1F0)
    #define EMBEDDING_STRENGTH_THRESHOLD_12_BG_20_EMBEDDING_STRENGTH_THRESHOLD_12_BG_41 Fld(14,0,AC_MSKW10)//[13:0]
    #define EMBEDDING_STRENGTH_THRESHOLD_12_BG_20_EMBEDDING_STRENGTH_THRESHOLD_12_BG_42 Fld(14,16,AC_MSKW32)//[29:16]
#define EMBEDDING_STRENGTH_THRESHOLD_12_BG_21 (IO_VM_BASE + 0x1F4)
    #define EMBEDDING_STRENGTH_THRESHOLD_12_BG_21_EMBEDDING_STRENGTH_THRESHOLD_12_BG_43 Fld(14,0,AC_MSKW10)//[13:0]
    #define EMBEDDING_STRENGTH_THRESHOLD_12_BG_21_EMBEDDING_STRENGTH_THRESHOLD_12_BG_44 Fld(14,16,AC_MSKW32)//[29:16]
#define EMBEDDING_STRENGTH_THRESHOLD_12_BG_22 (IO_VM_BASE + 0x1F8)
    #define EMBEDDING_STRENGTH_THRESHOLD_12_BG_22_EMBEDDING_STRENGTH_THRESHOLD_12_BG_45 Fld(14,0,AC_MSKW10)//[13:0]
    #define EMBEDDING_STRENGTH_THRESHOLD_12_BG_22_EMBEDDING_STRENGTH_THRESHOLD_12_BG_46 Fld(14,16,AC_MSKW32)//[29:16]
#define EMBEDDING_STRENGTH_THRESHOLD_12_BG_23 (IO_VM_BASE + 0x1FC)
    #define EMBEDDING_STRENGTH_THRESHOLD_12_BG_23_EMBEDDING_STRENGTH_THRESHOLD_12_BG_47 Fld(14,0,AC_MSKW10)//[13:0]
    #define EMBEDDING_STRENGTH_THRESHOLD_12_BG_23_EMBEDDING_STRENGTH_THRESHOLD_12_BG_48 Fld(14,16,AC_MSKW32)//[29:16]
#define VIDEOMARK_CONFIG_20 (IO_VM_BASE + 0x020)
    #define VIDEOMARK_CONFIG_20_RG_SCALER Fld(8,0,AC_FULLB0)//[7:0]
    #define VIDEOMARK_CONFIG_20_RG_STORAGE_STRIDE Fld(8,8,AC_FULLB1)//[15:8]
    #define VIDEOMARK_CONFIG_20_RG_HS_POLARITY Fld(1,16,AC_MSKB2)//[16:16]
    #define VIDEOMARK_CONFIG_20_RG_VS_POLARITY Fld(1,17,AC_MSKB2)//[17:17]
    #define VIDEOMARK_CONFIG_20_RG_INTERLACE_EN Fld(1,18,AC_MSKB2)//[18:18]
    #define VIDEOMARK_CONFIG_20_RG_3D_EN Fld(1,19,AC_MSKB2)//[19:19]
    #define VIDEOMARK_CONFIG_20_RG_BIT_MODE Fld(2,24,AC_MSKB3)//[25:24]
    #define VIDEOMARK_CONFIG_20_RG_MARK_TRUNCATE_EN Fld(1,26,AC_MSKB3)//[26:26]
    #define VIDEOMARK_CONFIG_20_RG_DE_MODE Fld(1,28,AC_MSKB3)//[28:28]
#define VIDEOMARK_CONFIG_24 (IO_VM_BASE + 0x024)
    #define VIDEOMARK_CONFIG_24_RG_H_ACTIVE_START Fld(16,0,AC_FULLW10)//[15:0]
    #define VIDEOMARK_CONFIG_24_RG_H_ACTIVE_END Fld(16,16,AC_FULLW32)//[31:16]
#define VIDEOMARK_CONFIG_28 (IO_VM_BASE + 0x028)
    #define VIDEOMARK_CONFIG_28_RG_ODD_V_ACTIVE_START Fld(16,0,AC_FULLW10)//[15:0]
    #define VIDEOMARK_CONFIG_28_RG_ODD_V_ACTIVE_END Fld(16,16,AC_FULLW32)//[31:16]
#define VIDEOMARK_CONFIG_2C (IO_VM_BASE + 0x02C)
    #define VIDEOMARK_CONFIG_2C_RG_EVEN_V_ACTIVE_START Fld(16,0,AC_FULLW10)//[15:0]
    #define VIDEOMARK_CONFIG_2C_RG_EVEN_V_ACTIVE_END Fld(16,16,AC_FULLW32)//[31:16]
#define VIDEOMARK_CONFIG_34 (IO_VM_BASE + 0x034)
    #define VIDEOMARK_CONFIG_34_RG_UPDATE_LUT Fld(1,0,AC_MSKB0)//[0:0]
#define VIDEOMARK_CONFIG_38 (IO_VM_BASE + 0x038)
    #define VIDEOMARK_CONFIG_38_RG_UPDATE_DATA Fld(20,0,AC_MSKDW)//[19:0]
    #define VIDEOMARK_CONFIG_38_RG_UPDATE_ADDR Fld(10,20,AC_MSKW32)//[29:20]
    #define VIDEOMARK_CONFIG_38_RG_UPDATE_ADDA Fld(32,0,AC_FULLDW)//[31:0]
#define VIDEOMARK_CONFIG_3C (IO_VM_BASE + 0x03C)
    #define VIDEOMARK_CONFIG_3C_RG_AVAIL_PXL_PER_LINE Fld(13,0,AC_MSKW10)//[12:0]
#define VIDEOMARK_CONFIG_40 (IO_VM_BASE + 0x040)
    #define VIDEOMARK_CONFIG_40_RG_EMBD_STRGTH_CON0 Fld(7,0,AC_MSKB0)//[6:0]
    #define VIDEOMARK_CONFIG_40_RG_EMBD_STRGTH_CON1 Fld(7,8,AC_MSKB1)//[14:8]
    #define VIDEOMARK_CONFIG_40_RG_EMBD_STRGTH_CON2 Fld(7,16,AC_MSKB2)//[22:16]
    #define VIDEOMARK_CONFIG_40_RG_EMBD_STRGTH_CON3 Fld(7,24,AC_MSKB3)//[30:24]
#define VIDEOMARK_CONFIG_44 (IO_VM_BASE + 0x044)
    #define VIDEOMARK_CONFIG_44_RG_EMBD_STRGTH_CON4 Fld(7,0,AC_MSKB0)//[6:0]
    #define VIDEOMARK_CONFIG_44_RG_EMBD_STRGTH_CON5 Fld(7,8,AC_MSKB1)//[14:8]
    #define VIDEOMARK_CONFIG_44_RG_EMBD_STRGTH_CON6 Fld(7,16,AC_MSKB2)//[22:16]
    #define VIDEOMARK_CONFIG_44_RG_EMBD_STRGTH_CON7 Fld(7,24,AC_MSKB3)//[30:24]
#define VIDEOMARK_CONFIG_48 (IO_VM_BASE + 0x048)
    #define VIDEOMARK_CONFIG_48_RG_EMBD_STRGTH_BG_CON0 Fld(7,0,AC_MSKB0)//[6:0]
    #define VIDEOMARK_CONFIG_48_RG_EMBD_STRGTH_BG_CON1 Fld(7,8,AC_MSKB1)//[14:8]
    #define VIDEOMARK_CONFIG_48_RG_EMBD_STRGTH_BG_CON2 Fld(7,16,AC_MSKB2)//[22:16]
    #define VIDEOMARK_CONFIG_48_RG_EMBD_STRGTH_BG_CON3 Fld(7,24,AC_MSKB3)//[30:24]
#define VIDEOMARK_CONFIG_4C (IO_VM_BASE + 0x04C)
    #define VIDEOMARK_CONFIG_4C_RG_EMBD_STRGTH_BG_CON4 Fld(7,0,AC_MSKB0)//[6:0]
    #define VIDEOMARK_CONFIG_4C_RG_EMBD_STRGTH_BG_CON5 Fld(7,8,AC_MSKB1)//[14:8]
    #define VIDEOMARK_CONFIG_4C_RG_EMBD_STRGTH_BG_CON6 Fld(7,16,AC_MSKB2)//[22:16]
    #define VIDEOMARK_CONFIG_4C_RG_EMBD_STRGTH_BG_CON7 Fld(7,24,AC_MSKB3)//[30:24]
#define VIDEOMARK_CONFIG_80 (IO_VM_BASE + 0x080)
    #define VIDEOMARK_CONFIG_80_HORIZONTAL_PIXEL_COUNTER Fld(13,0,AC_MSKW10)//[12:0]
    #define VIDEOMARK_CONFIG_80_VERTICAL_LINE_COUNTER Fld(12,16,AC_MSKW32)//[27:16]
#define VIDEOMARK_CONFIG_84 (IO_VM_BASE + 0x084)
    #define VIDEOMARK_CONFIG_84_VIDEOMARK_HORIZONTAL_START Fld(13,0,AC_MSKW10)//[12:0]
    #define VIDEOMARK_CONFIG_84_VIDEOMARK_HORIZONTAL_END Fld(13,16,AC_MSKW32)//[28:16]
#define VIDEOMARK_CONFIG_88 (IO_VM_BASE + 0x088)
    #define VIDEOMARK_CONFIG_88_ODD_VIDEOMARK_VERTICAL_START Fld(13,0,AC_MSKW10)//[12:0]
    #define VIDEOMARK_CONFIG_88_ODD_VIDEOMARK_VERTICAL_END Fld(13,16,AC_MSKW32)//[28:16]
#define VIDEOMARK_CONFIG_8C (IO_VM_BASE + 0x08C)
    #define VIDEOMARK_CONFIG_8C_EVEN_VIDEOMARK_VERTICAL_START Fld(13,0,AC_MSKW10)//[12:0]
    #define VIDEOMARK_CONFIG_8C_EVEN_VIDEOMARK_VERTICAL_END Fld(13,16,AC_MSKW32)//[28:16]
#define VIDEOMARK_CONFIG_90 (IO_VM_BASE + 0x090)
    #define VIDEOMARK_CONFIG_90_SRAM_ODD_WR_VSTART Fld(13,0,AC_MSKW10)//[12:0]
    #define VIDEOMARK_CONFIG_90_SRAM_ODD_WR_VEND Fld(13,16,AC_MSKW32)//[28:16]
#define VIDEOMARK_CONFIG_94 (IO_VM_BASE + 0x094)
    #define VIDEOMARK_CONFIG_94_SRAM_EVEN_WR_VSTART Fld(13,0,AC_MSKW10)//[12:0]
    #define VIDEOMARK_CONFIG_94_SRAM_EVEN_WR_VEND Fld(13,16,AC_MSKW32)//[28:16]
#define VIDEOMARK_CONFIG_98 (IO_VM_BASE + 0x098)
    #define VIDEOMARK_CONFIG_98_EVEN_VIDEOMARK_SYMBOL_WIDTH Fld(13,0,AC_MSKW10)//[12:0]
    #define VIDEOMARK_CONFIG_98_EVEN_VIDEOMARK_SYMBOL_HEIGHT Fld(13,16,AC_MSKW32)//[28:16]

//Page VIDEOMARK_VIDEOMARK
#define VM_RY_CT_00 (IO_VM_BASE + 0x400)
    #define VM_RY_CT_00_VIDEOMARK_ATPG_OB Fld(1,26,AC_MSKB3)//[26:26]
    #define VM_RY_CT_00_VIDEOMARK_ATPG_CT Fld(1,25,AC_MSKB3)//[25:25]
    #define VM_RY_CT_00_VIDEOMARK_MODE Fld(1,24,AC_MSKB3)//[24:24]
    #define VM_RY_CT_00_EXT_C00_RY Fld(13,11,AC_MSKW21)//[23:11]
    #define VM_RY_CT_00_O_SIGNED_RY Fld(1,10,AC_MSKB1)//[10:10]
    #define VM_RY_CT_00_I_SIGNED_RY Fld(1,9,AC_MSKB1)//[9:9]
    #define VM_RY_CT_00_EXT_TABLE_SEL_RY Fld(1,8,AC_MSKB1)//[8:8]
    #define VM_RY_CT_00_INT_TABLE_SEL_RY Fld(4,4,AC_MSKB0)//[7:4]
    #define VM_RY_CT_00_C_OUT_U10_EN_RY Fld(1,3,AC_MSKB0)//[3:3]
    #define VM_RY_CT_00_C_LSB_0_EN_RY Fld(1,2,AC_MSKB0)//[2:2]
    #define VM_RY_CT_00_CT_BYPASS_RY Fld(1,1,AC_MSKB0)//[1:1]
    #define VM_RY_CT_00_CT_EN_RY Fld(1,0,AC_MSKB0)//[0:0]
#define VM_RY_CT_01 (IO_VM_BASE + 0x404)
    #define VM_RY_CT_01_EXT_C02_RY Fld(13,13,AC_MSKDW)//[25:13]
    #define VM_RY_CT_01_EXT_C01_RY Fld(13,0,AC_MSKW10)//[12:0]
#define VM_RY_CT_02 (IO_VM_BASE + 0x408)
    #define VM_RY_CT_02_EXT_C11_RY Fld(13,13,AC_MSKDW)//[25:13]
    #define VM_RY_CT_02_EXT_C10_RY Fld(13,0,AC_MSKW10)//[12:0]
#define VM_RY_CT_03 (IO_VM_BASE + 0x40C)
    #define VM_RY_CT_03_EXT_C20_RY Fld(13,13,AC_MSKDW)//[25:13]
    #define VM_RY_CT_03_EXT_C12_RY Fld(13,0,AC_MSKW10)//[12:0]
#define VM_RY_CT_04 (IO_VM_BASE + 0x410)
    #define VM_RY_CT_04_EXT_C22_RY Fld(13,13,AC_MSKDW)//[25:13]
    #define VM_RY_CT_04_EXT_C21_RY Fld(13,0,AC_MSKW10)//[12:0]
#define VM_RY_CT_05 (IO_VM_BASE + 0x414)
    #define VM_RY_CT_05_EXT_PRE_ADD_2_RY Fld(9,20,AC_MSKW32)//[28:20]
    #define VM_RY_CT_05_EXT_PRE_ADD_1_RY Fld(9,10,AC_MSKW21)//[18:10]
    #define VM_RY_CT_05_EXT_PRE_ADD_O_RY Fld(9,0,AC_MSKW10)//[8:0]
#define VM_RY_CT_06 (IO_VM_BASE + 0x418)
    #define VM_RY_CT_06_EXT_POST_ADD_2_RY Fld(9,20,AC_MSKW32)//[28:20]
    #define VM_RY_CT_06_EXT_POST_ADD_1_RY Fld(9,10,AC_MSKW21)//[18:10]
    #define VM_RY_CT_06_EXT_POST_ADD_O_RY Fld(9,0,AC_MSKW10)//[8:0]
#define VM_RY_CT_07 (IO_VM_BASE + 0x41C)
    #define VM_RY_CT_07_EXT_C00_YR Fld(13,11,AC_MSKW21)//[23:11]
    #define VM_RY_CT_07_O_SIGNED_YR Fld(1,10,AC_MSKB1)//[10:10]
    #define VM_RY_CT_07_I_SIGNED_YR Fld(1,9,AC_MSKB1)//[9:9]
    #define VM_RY_CT_07_EXT_TABLE_SEL_YR Fld(1,8,AC_MSKB1)//[8:8]
    #define VM_RY_CT_07_INT_TABLE_SEL_YR Fld(4,4,AC_MSKB0)//[7:4]
    #define VM_RY_CT_07_C_OUT_U10_EN_YR Fld(1,3,AC_MSKB0)//[3:3]
    #define VM_RY_CT_07_C_LSB_0_EN_YR Fld(1,2,AC_MSKB0)//[2:2]
    #define VM_RY_CT_07_CT_BYPASS_YR Fld(1,1,AC_MSKB0)//[1:1]
    #define VM_RY_CT_07_CT_EN_YR Fld(1,0,AC_MSKB0)//[0:0]
#define VM_RY_CT_08 (IO_VM_BASE + 0x420)
    #define VM_RY_CT_08_EXT_C02_YR Fld(13,13,AC_MSKDW)//[25:13]
    #define VM_RY_CT_08_EXT_C01_YR Fld(13,0,AC_MSKW10)//[12:0]
#define VM_RY_CT_09 (IO_VM_BASE + 0x424)
    #define VM_RY_CT_09_EXT_C11_YR Fld(13,13,AC_MSKDW)//[25:13]
    #define VM_RY_CT_09_EXT_C10_YR Fld(13,0,AC_MSKW10)//[12:0]
#define VM_RY_CT_10 (IO_VM_BASE + 0x428)
    #define VM_RY_CT_10_EXT_C20_YR Fld(13,13,AC_MSKDW)//[25:13]
    #define VM_RY_CT_10_EXT_C12_YR Fld(13,0,AC_MSKW10)//[12:0]
#define VM_RY_CT_11 (IO_VM_BASE + 0x42C)
    #define VM_RY_CT_11_EXT_C22_YR Fld(13,13,AC_MSKDW)//[25:13]
    #define VM_RY_CT_11_EXT_C21_YR Fld(13,0,AC_MSKW10)//[12:0]
#define VM_RY_CT_12 (IO_VM_BASE + 0x430)
    #define VM_RY_CT_12_EXT_PRE_ADD_2_YR Fld(9,20,AC_MSKW32)//[28:20]
    #define VM_RY_CT_12_EXT_PRE_ADD_1_YR Fld(9,10,AC_MSKW21)//[18:10]
    #define VM_RY_CT_12_EXT_PRE_ADD_0_YR Fld(9,0,AC_MSKW10)//[8:0]
#define VM_RY_CT_13 (IO_VM_BASE + 0x434)
    #define VM_RY_CT_13_EXT_POST_ADD_2_YR Fld(9,20,AC_MSKW32)//[28:20]
    #define VM_RY_CT_13_EXT_POST_ADD_1_YR Fld(9,10,AC_MSKW21)//[18:10]
    #define VM_RY_CT_13_EXT_POST_ADD_0_YR Fld(9,0,AC_MSKW10)//[8:0]
#define VM_RY_CT_28 (IO_VM_BASE + 0x438)
    #define VM_RY_CT_28_BYPASS_VM_TOP_B Fld(1,31,AC_MSKB3)//[31:31]
    #define VM_RY_CT_28_CHANNEL_1_DEBUG_PORT Fld(31,0,AC_MSKDW)//[30:0]
#define VM_RY_CT_14 (IO_VM_BASE + 0x500)
    #define VM_RY_CT_14_VIDEOMARK_MODE_CH2 Fld(1,24,AC_MSKB3)//[24:24]
    #define VM_RY_CT_14_EXT_C00_RY_CH2 Fld(13,11,AC_MSKW21)//[23:11]
    #define VM_RY_CT_14_O_SIGNED_RY_CH2 Fld(1,10,AC_MSKB1)//[10:10]
    #define VM_RY_CT_14_I_SIGNED_RY_CH2 Fld(1,9,AC_MSKB1)//[9:9]
    #define VM_RY_CT_14_EXT_TABLE_SEL_RY_CH2 Fld(1,8,AC_MSKB1)//[8:8]
    #define VM_RY_CT_14_INT_TABLE_SEL_RY_CH2 Fld(4,4,AC_MSKB0)//[7:4]
    #define VM_RY_CT_14_C_OUT_U10_EN_RY_CH2 Fld(1,3,AC_MSKB0)//[3:3]
    #define VM_RY_CT_14_C_LSB_0_EN_RY_CH2 Fld(1,2,AC_MSKB0)//[2:2]
    #define VM_RY_CT_14_CT_BYPASS_RY_CH2 Fld(1,1,AC_MSKB0)//[1:1]
    #define VM_RY_CT_14_CT_EN_RY_CH2 Fld(1,0,AC_MSKB0)//[0:0]
#define VM_RY_CT_15 (IO_VM_BASE + 0x504)
    #define VM_RY_CT_15_EXT_C02_RY_CH2 Fld(13,13,AC_MSKDW)//[25:13]
    #define VM_RY_CT_15_EXT_C01_RY_CH2 Fld(13,0,AC_MSKW10)//[12:0]
#define VM_RY_CT_16 (IO_VM_BASE + 0x508)
    #define VM_RY_CT_16_EXT_C11_RY_CH2 Fld(13,13,AC_MSKDW)//[25:13]
    #define VM_RY_CT_16_EXT_C10_RY_CH2 Fld(13,0,AC_MSKW10)//[12:0]
#define VM_RY_CT_17 (IO_VM_BASE + 0x50C)
    #define VM_RY_CT_17_EXT_C20_RY_CH2 Fld(13,13,AC_MSKDW)//[25:13]
    #define VM_RY_CT_17_EXT_C12_RY_CH2 Fld(13,0,AC_MSKW10)//[12:0]
#define VM_RY_CT_18 (IO_VM_BASE + 0x510)
    #define VM_RY_CT_18_EXT_C22_RY_CH2 Fld(13,13,AC_MSKDW)//[25:13]
    #define VM_RY_CT_18_EXT_C21_RY_CH2 Fld(13,0,AC_MSKW10)//[12:0]
#define VM_RY_CT_19 (IO_VM_BASE + 0x514)
    #define VM_RY_CT_19_EXT_PRE_ADD_2_RY_CH2 Fld(9,20,AC_MSKW32)//[28:20]
    #define VM_RY_CT_19_EXT_PRE_ADD_1_RY_CH2 Fld(9,10,AC_MSKW21)//[18:10]
    #define VM_RY_CT_19_EXT_PRE_ADD_O_RY_CH2 Fld(9,0,AC_MSKW10)//[8:0]
#define VM_RY_CT_20 (IO_VM_BASE + 0x518)
    #define VM_RY_CT_20_EXT_POST_ADD_2_RY_CH2 Fld(9,20,AC_MSKW32)//[28:20]
    #define VM_RY_CT_20_EXT_POST_ADD_1_RY_CH2 Fld(9,10,AC_MSKW21)//[18:10]
    #define VM_RY_CT_20_EXT_POST_ADD_O_RY_CH2 Fld(9,0,AC_MSKW10)//[8:0]
#define VM_RY_CT_21 (IO_VM_BASE + 0x51C)
    #define VM_RY_CT_21_EXT_C00_YR_CH2 Fld(13,11,AC_MSKW21)//[23:11]
    #define VM_RY_CT_21_O_SIGNED_YR_CH2 Fld(1,10,AC_MSKB1)//[10:10]
    #define VM_RY_CT_21_I_SIGNED_YR_CH2 Fld(1,9,AC_MSKB1)//[9:9]
    #define VM_RY_CT_21_EXT_TABLE_SEL_YR_CH2 Fld(1,8,AC_MSKB1)//[8:8]
    #define VM_RY_CT_21_INT_TABLE_SEL_YR_CH2 Fld(4,4,AC_MSKB0)//[7:4]
    #define VM_RY_CT_21_C_OUT_U10_EN_YR_CH2 Fld(1,3,AC_MSKB0)//[3:3]
    #define VM_RY_CT_21_C_LSB_0_EN_YR_CH2 Fld(1,2,AC_MSKB0)//[2:2]
    #define VM_RY_CT_21_CT_BYPASS_YR_CH2 Fld(1,1,AC_MSKB0)//[1:1]
    #define VM_RY_CT_21_CT_EN_YR_CH2 Fld(1,0,AC_MSKB0)//[0:0]
#define VM_RY_CT_22 (IO_VM_BASE + 0x520)
    #define VM_RY_CT_22_EXT_C02_YR_CH2 Fld(13,13,AC_MSKDW)//[25:13]
    #define VM_RY_CT_22_EXT_C01_YR_CH2 Fld(13,0,AC_MSKW10)//[12:0]
#define VM_RY_CT_23 (IO_VM_BASE + 0x524)
    #define VM_RY_CT_23_EXT_C11_YR_CH2 Fld(13,13,AC_MSKDW)//[25:13]
    #define VM_RY_CT_23_EXT_C10_YR_CH2 Fld(13,0,AC_MSKW10)//[12:0]
#define VM_RY_CT_24 (IO_VM_BASE + 0x528)
    #define VM_RY_CT_24_EXT_C20_YR_CH2 Fld(13,13,AC_MSKDW)//[25:13]
    #define VM_RY_CT_24_EXT_C12_YR_CH2 Fld(13,0,AC_MSKW10)//[12:0]
#define VM_RY_CT_25 (IO_VM_BASE + 0x52C)
    #define VM_RY_CT_25_EXT_C22_YR_CH2 Fld(13,13,AC_MSKDW)//[25:13]
    #define VM_RY_CT_25_EXT_C21_YR_CH2 Fld(13,0,AC_MSKW10)//[12:0]
#define VM_RY_CT_26 (IO_VM_BASE + 0x530)
    #define VM_RY_CT_26_EXT_PRE_ADD_2_YR_CH2 Fld(9,20,AC_MSKW32)//[28:20]
    #define VM_RY_CT_26_EXT_PRE_ADD_1_YR_CH2 Fld(9,10,AC_MSKW21)//[18:10]
    #define VM_RY_CT_26_EXT_PRE_ADD_0_YR_CH2 Fld(9,0,AC_MSKW10)//[8:0]
#define VM_RY_CT_27 (IO_VM_BASE + 0x534)
    #define VM_RY_CT_27_EXT_POST_ADD_2_YR_CH2 Fld(9,20,AC_MSKW32)//[28:20]
    #define VM_RY_CT_27_EXT_POST_ADD_1_YR_CH2 Fld(9,10,AC_MSKW21)//[18:10]
    #define VM_RY_CT_27_EXT_POST_ADD_0_YR_CH2 Fld(9,0,AC_MSKW10)//[8:0]
#define VM_RY_CT_29 (IO_VM_BASE + 0x538)
    #define VM_RY_CT_29_CHANNEL_2_DEBUG_PORT Fld(32,0,AC_FULLDW)//[31:0]

#endif
