/* SPDX-License-Identifier: LGPL-2.1-only OR BSD-3-Clause */
/******************************************************************************
 *
 * This file is provided under a dual license.  When you use or
 * distribute this software, you may choose to be licensed under
 * version 2.1 of the GNU Lesser General Public License
 * ("LGPLv2.1 License") or BSD License.
 *
 * LGPLv2.1 License
 *
 * Copyright(C) 2019 MediaTek Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2.1 of the GNU Lesser General Public
 * License as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See https://www.gnu.org/licenses/old-licenses/lgpl-2.1.html for more
 * details.
 *
 * BSD LICENSE
 *
 * Copyright(C) 2019 MediaTek Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *  * Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *****************************************************************************/

/*-----------------------------------------------------------------------------
 *
 * $Author: jiangang.li $
 * $Date: 2015/06/27 $
 * $RCSfile: vdo_chip.h $
 * $Revision: #2 $
 *
 *---------------------------------------------------------------------------*/
/** @file vdo_chip.h
 *  Brief of file vdo_chip.h.
 *  Details of file vdo_chip.h (optional).
 */

#ifndef VDO_CHIP_H
#define VDO_CHIP_H

#include "hw_mjcfd.h"
//#include "drv_mjc.h"

//-----------------------------------------------------------------------------
// Type definitions
//-----------------------------------------------------------------------------
//#define SUPPORT_MJC             (1)

#define FIELD_TO_STR(x)    #x

#define MJC_INIT(x)             vDrvMJCInit(x)
#define MJC_FRAME_DELAY()       u1DrvMJCGetFrmDelay10x()
#if 0
#define MJC_FD_INFO()           IO32ReadFldAlign(MJCFD_08, MJCFD_FD_INFO)
#define MJC_DRAM_STATUS                                                             \
    {MJC_STA_FB_01,     MJC_STA_WFIFO_OVF,      FIELD_TO_STR(MJC_STA_WFIFO_OVF)},   \
    {MJC_STA_SYS_00,    MJC_STA_INIT_UNDER,     FIELD_TO_STR(MJC_STA_INIT_UNDER)},  \
    {MJC_STA_SYS_00,    MJC_STA_PROC_UNDER,     FIELD_TO_STR(MJC_STA_PROC_UNDER)},  \
    {MJC_STA_SYS_00,    MJC_STA_PROC_UNDER,     FIELD_TO_STR(MJC_STA_RPT_MB_UDF)},  \
    {MJC_STA_SYS_00,    MJC_STA_PROC_UNDER,     FIELD_TO_STR(MJC_STA_RPT_QMB_UDF)},
#define MJC_DRAM_STATUS_CLEAR                                                       \
    {MJC_FB_01,         MJC_DRAM_STATUS_CLR},                                       \
    {MJC_SYS_00,        MJC_RD_UNDER_RST},
#endif

#define SCPIP_GET_DISPR()       u1ScpipGetOutDispR()

//-----------------------------------------------------------------------------
// Public functions
//-----------------------------------------------------------------------------

#endif //#ifndef VDO_CHIP_H
