/* SPDX-License-Identifier: LGPL-2.1-only OR BSD-3-Clause */
/******************************************************************************
 *
 * This file is provided under a dual license.  When you use or
 * distribute this software, you may choose to be licensed under
 * version 2.1 of the GNU Lesser General Public License
 * ("LGPLv2.1 License") or BSD License.
 *
 * LGPLv2.1 License
 *
 * Copyright(C) 2019 MediaTek Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2.1 of the GNU Lesser General Public
 * License as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See https://www.gnu.org/licenses/old-licenses/lgpl-2.1.html for more
 * details.
 *
 * BSD LICENSE
 *
 * Copyright(C) 2019 MediaTek Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *  * Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *****************************************************************************/

/*-----------------------------------------------------------------------------
 * $RCSfile: u_config_dbg_level.h,v $
 * $Revision: #1 $
 * $Date: 2015/05/29 $
 * $Author: brianpc.huang $
 *
 * Description:
 *         This header file contains all default debug levels for every
 *         middleware software module.
 *---------------------------------------------------------------------------*/
#ifndef _U_CONFIG_DBG_LEVEL_H_
#define _U_CONFIG_DBG_LEVEL_H_

/*-----------------------------------------------------------------------------
                    include files
-----------------------------------------------------------------------------*/
#include "u_dbg.h"

/*-----------------------------------------------------------------------------
                    macros, defines, typedefs, enums
 ----------------------------------------------------------------------------*/
/* Determine the default common or central debug level   */
/* Note that only the DBG_INIT_LEVEL_MW_DBG will require */
/* a check if DBG_INIT_LEVEL_COMMON has been set.        */
#ifdef DBG_INIT_LEVEL_COMMON
#undef DBG_INIT_LEVEL_MW_DBG
#define DBG_INIT_LEVEL_MW_DBG   DBG_INIT_LEVEL_COMMON
#else
#ifndef DBG_INIT_LEVEL_MW_DBG
#define DBG_INIT_LEVEL_MW_DBG   DBG_LEVEL_NONE
#endif
#endif

/* AEE default debug level */
#ifndef DBG_INIT_LEVEL_MW_AEE
#define DBG_INIT_LEVEL_MW_AEE   DBG_LEVEL_NONE
#endif

/* ATV Manager default debug level */
#ifndef DBG_INIT_LEVEL_MW_ATV_MNGR
#define DBG_INIT_LEVEL_MW_ATV_MNGR   DBG_LEVEL_NONE
#endif

/* ATV Line Translator default debug level */
#ifndef DBG_INIT_LEVEL_MW_ATV_LINE_XLS
#define DBG_INIT_LEVEL_MW_ATV_LINE_XLS   DBG_LEVEL_NONE
#endif

/* ATV 8202 Translator default debug level */
#ifndef DBG_INIT_LEVEL_MW_ATV_8202_XLS
#define DBG_INIT_LEVEL_MW_ATV_8202_XLS   DBG_LEVEL_NONE
#endif

/* ATV 8205 Translator default debug level */
#ifndef DBG_INIT_LEVEL_MW_ATV_8205_XLS
#define DBG_INIT_LEVEL_MW_ATV_8205_XLS   DBG_LEVEL_NONE
#endif

/* Compression library default debug level */
#ifndef DBG_INIT_LEVEL_MW_CL
#define DBG_INIT_LEVEL_MW_CL   DBG_LEVEL_NONE
#endif

/* Configuration Manager default debug level */
#ifndef DBG_INIT_LEVEL_MW_CFG
#define DBG_INIT_LEVEL_MW_CFG   DBG_LEVEL_NONE
#endif

/* Connection Manager default debug level */
#ifndef DBG_INIT_LEVEL_MW_CONN_MNGR
#define DBG_INIT_LEVEL_MW_CONN_MNGR   DBG_LEVEL_NONE
#endif

/* Date Time library default debug level */
#ifndef DBG_INIT_LEVEL_MW_DT
#define DBG_INIT_LEVEL_MW_DT   DBG_LEVEL_NONE
#endif

/* Event Context default debug level */
#ifndef DBG_INIT_LEVEL_MW_EVCTX
#define DBG_INIT_LEVEL_MW_EVCTX   DBG_LEVEL_NONE
#endif

/* File Manager default debug level */
#ifndef DBG_INIT_LEVEL_MW_FILE_MNGR
#define DBG_INIT_LEVEL_MW_FILE_MNGR   DBG_LEVEL_NONE
#endif

/* Favorite List Manager default debug level */
#ifndef DBG_INIT_LEVEL_MW_FLM
#define DBG_INIT_LEVEL_MW_FLM   DBG_LEVEL_NONE
#endif

/* Font library default debug level */
#ifndef DBG_INIT_LEVEL_MW_FONT
#define DBG_INIT_LEVEL_MW_FONT   DBG_LEVEL_NONE
#endif

/* Graphic library default debug level */
#ifndef DBG_INIT_LEVEL_MW_GRAPHIC
#define DBG_INIT_LEVEL_MW_GRAPHIC   DBG_LEVEL_NONE
#endif

/* HTML Parser default debug level */
#ifndef DBG_INIT_LEVEL_MW_HTML_PSR
#define DBG_INIT_LEVEL_MW_HTML_PSR   DBG_LEVEL_NONE
#endif

/* Image library Manager default debug level */
#ifndef DBG_INIT_LEVEL_MW_IMG
#define DBG_INIT_LEVEL_MW_IMG   DBG_LEVEL_NONE
#endif

/* mfmtrecg default debug level */
#ifndef DBG_INIT_LEVEL_MW_MFMTRECG
#define DBG_INIT_LEVEL_MW_MFMTRECG   DBG_LEVEL_NONE
#endif

/* mheg5 default debug level */
#ifndef DBG_INIT_LEVEL_MW_MHEG5
#define DBG_INIT_LEVEL_MW_MHEG5     DBG_LEVEL_NONE
#endif

/* EWS_PA default debug level */
#ifndef DBG_INIT_LEVEL_MW_EWS_PA
#define DBG_INIT_LEVEL_MW_EWS_PA     DBG_LEVEL_NONE
#endif


/* msvctx default debug level */
#ifndef DBG_INIT_LEVEL_MW_MSVCTX
#define DBG_INIT_LEVEL_MW_MSVCTX   DBG_LEVEL_NONE
#endif

/* minfo default debug level */
#ifndef DBG_INIT_LEVEL_MW_MINFO
#define DBG_INIT_LEVEL_MW_MINFO   DBG_LEVEL_NONE
#endif

/* midxbuld default debug level */
#ifndef DBG_INIT_LEVEL_MW_MIDXBULD
#define DBG_INIT_LEVEL_MW_MIDXBULD   DBG_LEVEL_NONE
#endif

/* IO Manager default debug level */
#ifndef DBG_INIT_LEVEL_MW_IO_MNGR
#ifndef LINUX_AUTO_TEST
#define DBG_INIT_LEVEL_MW_IO_MNGR   DBG_LEVEL_NONE
#else
#define DBG_INIT_LEVEL_MW_IO_MNGR   DBG_LEVEL_INFO
#endif
#endif

/* OS default debug level */
#ifndef DBG_INIT_LEVEL_MW_OS
#define DBG_INIT_LEVEL_MW_OS   DBG_LEVEL_NONE
#endif

/* POD default debug level */
#ifndef DBG_INIT_LEVEL_MW_POD
#define DBG_INIT_LEVEL_MW_POD   DBG_LEVEL_NONE
#endif

/* MW CI default debug level */
#ifndef DBG_INIT_LEVEL_MW_CI
#define DBG_INIT_LEVEL_MW_CI   DBG_LEVEL_NONE
#endif

#ifndef DBG_INIT_LEVEL_MW_CI_LAYER
#define DBG_INIT_LEVEL_MW_CI_LAYER   DBG_LEVEL_NONE
#endif


/* Process Manager default debug level */
#ifndef DBG_INIT_LEVEL_MW_PRC_MNGR
#define DBG_INIT_LEVEL_MW_PRC_MNGR   DBG_LEVEL_NONE
#endif

/* Stream Manager default debug level */
#ifndef DBG_INIT_LEVEL_MW_STRM_MNGR
#define DBG_INIT_LEVEL_MW_STRM_MNGR   DBG_LEVEL_NONE
#endif

/* Subtitle stream handler default debug level */
#ifndef DBG_INIT_LEVEL_MW_SM_SBTL
#define DBG_INIT_LEVEL_MW_SM_SBTL     DBG_LEVEL_NONE
#endif

/* Teletext stream handler default debug level */
#ifndef DBG_INIT_LEVEL_MW_SM_TTX
#define DBG_INIT_LEVEL_MW_SM_TTX      DBG_LEVEL_NONE
#endif

/* Service Context default debug level */
#ifndef DBG_INIT_LEVEL_MW_SVCTX
#define DBG_INIT_LEVEL_MW_SVCTX   DBG_LEVEL_NONE
#endif

/* Service Context Record Handler default debug level */
#ifndef DBG_INIT_LEVEL_MW_REC_HDLR
#define DBG_INIT_LEVEL_MW_REC_HDLR   DBG_LEVEL_NONE
#endif

/* SVL default debug level */
#ifndef DBG_INIT_LEVEL_MW_SVL
#define DBG_INIT_LEVEL_MW_SVL   DBG_LEVEL_NONE
#endif

/* SVL Builder default debug level */
#ifndef DBG_INIT_LEVEL_MW_SVL_BLDR
#define DBG_INIT_LEVEL_MW_SVL_BLDR   DBG_LEVEL_NONE
#endif

/* Event database default debug level */
#ifndef DBG_INIT_LEVEL_MW_EDB
#define DBG_INIT_LEVEL_MW_EDB   DBG_LEVEL_NONE
#endif


/* Table Manager default debug level */
#ifndef DBG_INIT_LEVEL_MW_TBL_MNGR
#define DBG_INIT_LEVEL_MW_TBL_MNGR   DBG_LEVEL_NONE
#endif

/* TSL default debug level */
#ifndef DBG_INIT_LEVEL_MW_TSL
#define DBG_INIT_LEVEL_MW_TSL   DBG_LEVEL_NONE
#endif

/* DF_Mngr default debug level */
#ifndef DBG_INIT_LEVEL_MW_DFM
#define DBG_INIT_LEVEL_MW_DFM   DBG_LEVEL_NONE
#endif

/* Widget Manager default debug level */
#ifndef DBG_INIT_LEVEL_MW_WGL_MNGR
#define DBG_INIT_LEVEL_MW_WGL_MNGR   DBG_LEVEL_NONE
#endif

/* Date Time library default debug level */
#ifndef DBG_INIT_LEVEL_MW_DATETIME_LIB
#define DBG_INIT_LEVEL_MW_DATETIME_LIB  DBG_LEVEL_NONE
#endif

#ifndef DBG_INIT_LEVEL_MW_SEC_MNGR
#define DBG_INIT_LEVEL_MW_SEC_MNGR  DBG_LEVEL_ALL
#endif

/* Broadcast handler default debug level */
#ifndef DBG_INIT_LEVEL_MW_BRDCST
#define DBG_INIT_LEVEL_MW_BRDCST  DBG_LEVEL_NONE
#endif

/* Analog Broadcast handler default debug level */
#ifndef DBG_INIT_LEVEL_MW_ANALOG_BRDCST
#define DBG_INIT_LEVEL_MW_ANALOG_BRDCST  DBG_LEVEL_NONE
#endif

/* Out-of-band handler default debug level */
#ifndef DBG_INIT_LEVEL_MW_OUTOFBAND
#define DBG_INIT_LEVEL_MW_OUTOFBAND  DBG_LEVEL_NONE
#endif

/* AVC connection handler default debug level */
#ifndef DBG_INIT_LEVEL_MW_AVC_HANDLER
#define DBG_INIT_LEVEL_MW_AVC_HANDLER  DBG_LEVEL_NONE
#endif

/* Playback connection handler default debug level */
#ifndef DBG_INIT_LEVEL_MW_CM_PLAYBACK
#define DBG_INIT_LEVEL_MW_CM_PLAYBACK  DBG_LEVEL_NONE
#endif

/* FM Radio handler default debug level */
#ifndef DBG_INIT_LEVEL_MW_FM_RADIO
#define DBG_INIT_LEVEL_MW_FM_RADIO DBG_LEVEL_NONE
#endif

/* PSI Engine default debug level */
#ifndef DBG_INIT_LEVEL_MW_PSI
#define DBG_INIT_LEVEL_MW_PSI  DBG_LEVEL_NONE
#endif

/* SCTE-SI Engine default debug level */
#ifndef DBG_INIT_LEVEL_MW_SCTE_SI_ENG
#define DBG_INIT_LEVEL_MW_SCTE_SI_ENG  DBG_LEVEL_NONE
#endif

/* Device Status Manager default debug level */
#ifndef DBG_INIT_LEVEL_MW_DSM
#define DBG_INIT_LEVEL_MW_DSM  DBG_LEVEL_NONE
#endif

/* Section Engine default debug level */
#ifndef DBG_INIT_LEVEL_MW_SECT
#define DBG_INIT_LEVEL_MW_SECT  DBG_LEVEL_NONE
#endif

/* Rating Region Context default debug level */
#ifndef DBG_INIT_LEVEL_MW_RRCTX
#define DBG_INIT_LEVEL_MW_RRCTX   DBG_LEVEL_NONE
#endif

/* Power Control Library default debug level */
#ifndef DBG_INIT_LEVEL_MW_PCL
#define DBG_INIT_LEVEL_MW_PCL   DBG_LEVEL_NONE
#endif

/* VBI Filter default debug level */
#ifndef DBG_INIT_LEVEL_MW_VBI_FLTR
#define DBG_INIT_LEVEL_MW_VBI_FLTR  DBG_LEVEL_NONE
#endif

/* X-Socket library default debug level */
#ifndef DBG_INIT_LEVEL_MW_SOCK_LIB
#define DBG_INIT_LEVEL_MW_SOCK_LIB    DBG_LEVEL_NONE
#endif

/* Resolver library default debug level. */
#ifndef DBG_INIT_LEVEL_MW_RESOLV_LIB
#define DBG_INIT_LEVEL_MW_RESOLV_LIB  DBG_LEVEL_NONE
#endif

/* CEC Manager default debug level */
#ifndef DBG_INIT_LEVEL_MW_CEC_MNGR
#define DBG_INIT_LEVEL_MW_CEC_MNGR    DBG_LEVEL_NONE
#endif

/* TV Guide default debug level */
#ifndef DBG_INIT_LEVEL_MW_TVGUIDE
#define DBG_INIT_LEVEL_MW_TVGUIDE  DBG_LEVEL_NONE
#endif

/* SSU Manager default debug level */
#ifndef DBG_INIT_LEVEL_MW_SSU_MNGR
#define DBG_INIT_LEVEL_MW_SSU_MNGR    DBG_LEVEL_NONE
#endif

/* DSMCC default debug level */
#ifndef DBG_INIT_LEVEL_MW_DSMCC
#define DBG_INIT_LEVEL_MW_DSMCC    DBG_LEVEL_NONE
#endif

/* HBBTV DSMCC default debug level */
#ifndef DBG_INIT_LEVEL_MW_HBBTV_DSMCC
#define DBG_INIT_LEVEL_MW_HBBTV_DSMCC    DBG_LEVEL_NONE
#endif

/* TOD client default debug level */
#ifndef DBG_INIT_LEVEL_MW_TOD
#define DBG_INIT_LEVEL_MW_TOD    DBG_LEVEL_NONE
#endif

/* TFTP client default debug level */
#ifndef DBG_INIT_LEVEL_MW_TFTP
#define DBG_INIT_LEVEL_MW_TFTP    DBG_LEVEL_NONE
#endif

/* ReadWrtie lock default debug level */
#ifndef DBG_INIT_LEVEL_MW_RWL_LIB
#define DBG_INIT_LEVEL_MW_RWL_LIB   DBG_LEVEL_NONE
#endif

/* Network list default debug level */
#ifndef DBG_INIT_LEVEL_MW_NWL
#define DBG_INIT_LEVEL_MW_NWL       DBG_LEVEL_NONE
#endif

/* DRM default debug level */
#ifndef DBG_INIT_LEVEL_MW_DRM
#define DBG_INIT_LEVEL_MW_DRM   DBG_LEVEL_NONE
#endif

/* Large Object List default debug level */
#ifndef DBG_INIT_LEVEL_MW_LOL
#define DBG_INIT_LEVEL_MW_LOL       DBG_LEVEL_NONE
#endif

/* Record Utility default debug level */
#ifndef DBG_INIT_LEVEL_MW_REC_UTIL
#define DBG_INIT_LEVEL_MW_REC_UTIL   DBG_LEVEL_NONE
#endif

/* Satellite List default debug level */
#ifndef DBG_INIT_LEVEL_MW_SATL
#define DBG_INIT_LEVEL_MW_SATL      DBG_LEVEL_NONE
#endif

/* Bsl List default debug level */
#ifndef DBG_INIT_LEVEL_MW_BSL
#define DBG_INIT_LEVEL_MW_BSL      DBG_LEVEL_NONE
#endif

/* List Manager default debug level */
#ifndef DBG_INIT_LEVEL_MW_LSTM
#define DBG_INIT_LEVEL_MW_LSTM      DBG_LEVEL_NONE
#endif

/* Chip Specification Library default debug level */
#ifndef DBG_INIT_LEVEL_MW_CHIP_SPEC
#define DBG_INIT_LEVEL_MW_CHIP_SPEC   DBG_LEVEL_NONE
#endif

/* Ginga default debug level */
#ifndef DBG_INIT_LEVEL_MW_GINGA
#define DBG_INIT_LEVEL_MW_GINGA     DBG_LEVEL_NONE
#endif

/* Mux Utility default debug level */
#ifndef DBG_INIT_LEVEL_MW_MUX_UTIL
#define DBG_INIT_LEVEL_MW_MUX_UTIL   DBG_LEVEL_NONE
#endif

#endif /* _U_CONFIG_DBG_LEVEL_H_ */

