/* SPDX-License-Identifier: LGPL-2.1-only OR BSD-3-Clause */
/******************************************************************************
 *
 * This file is provided under a dual license.  When you use or
 * distribute this software, you may choose to be licensed under
 * version 2.1 of the GNU Lesser General Public License
 * ("LGPLv2.1 License") or BSD License.
 *
 * LGPLv2.1 License
 *
 * Copyright(C) 2019 MediaTek Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2.1 of the GNU Lesser General Public
 * License as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See https://www.gnu.org/licenses/old-licenses/lgpl-2.1.html for more
 * details.
 *
 * BSD LICENSE
 *
 * Copyright(C) 2019 MediaTek Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *  * Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *****************************************************************************/

/*----------------------------------------------------------------------------*/
/*! @file u_sm_sbtl_event.h 
 *  $RCSfile: $
 *  $Revision: #1 $
 *  $Date: 2015/05/29 $
 *  $Author: brianpc.huang $
 *  
 *  @par Description:
 *         This header file contains Subtitle Stream handler specific 
 *         events.
 */
/*----------------------------------------------------------------------------*/

#ifndef _U_SM_SBTL_EVENT_H_
#define _U_SM_SBTL_EVENT_H_


/*-----------------------------------------------------------------------------
                    include files
-----------------------------------------------------------------------------*/

#include "u_common.h"
#include "u_sm_event.h"

/*----------------------------------------------------------------------------*/
/*! @addtogroup groupMW_STRM_MNGR_SBTL_HDLR
*  @{  
*/
/*----------------------------------------------------------------------------*/

/*-----------------------------------------------------------------------------
                    macros, defines, typedefs, enums
-----------------------------------------------------------------------------*/

#define SM_EVN_SBTL_APP_OPEN_REQ           ((SM_EVN_TYPE_T) SM_EVN_GRP_SBTL + 0)    /**< message APP_OPEN */
#define SM_EVN_SBTL_APP_PLAY_REQ           ((SM_EVN_TYPE_T) SM_EVN_GRP_SBTL + 1)    /**< message APP_PLAY */
#define SM_EVN_SBTL_APP_STOP_REQ           ((SM_EVN_TYPE_T) SM_EVN_GRP_SBTL + 2)    /**< message APP_STOP */
#define SM_EVN_SBTL_APP_CLOSE_REQ          ((SM_EVN_TYPE_T) SM_EVN_GRP_SBTL + 3)    /**< message APP_CLOSE */
#define SM_EVN_SBTL_DRV_OPENED             ((SM_EVN_TYPE_T) SM_EVN_GRP_SBTL + 4)    /**< message DRV_OPENED */
#define SM_EVN_SBTL_DRV_PLAYED             ((SM_EVN_TYPE_T) SM_EVN_GRP_SBTL + 5)    /**< message DRV_PLAYED */
#define SM_EVN_SBTL_DRV_STOPPED            ((SM_EVN_TYPE_T) SM_EVN_GRP_SBTL + 6)    /**< message DRV_STOPPED */
#define SM_EVN_SBTL_DRV_CLOSED             ((SM_EVN_TYPE_T) SM_EVN_GRP_SBTL + 7)    /**< message DRV_CLOSED */
#define SM_EVN_SBTL_DRV_ERR                ((SM_EVN_TYPE_T) SM_EVN_GRP_SBTL + 8)    /**< message DRV_ERR */
#define SM_EVN_SBTL_SCDB_RECORD_DEL        ((SM_EVN_TYPE_T) SM_EVN_GRP_SBTL + 9)    /**< message SCDB_RECORD_DEL */
#define SM_EVN_SBTL_SCDB_RECORD_MOD        ((SM_EVN_TYPE_T) SM_EVN_GRP_SBTL + 10)   /**< message SCDB_RECORD_MOD */
#define SM_EVN_SBTL_INTERNAL_ERR           ((SM_EVN_TYPE_T) SM_EVN_GRP_SBTL + 11)   /**< message INTERNAL_ERR */


/*-----------------------------------------------------------------------------
                    functions declarations
-----------------------------------------------------------------------------*/


#endif /* _U_SM_SBTL_EVENT_H_ */

/*----------------------------------------------------------------------------*/
/*! @} */                                            /* end of groupMW_STRM_MNGR_SBTL_HDLR */
/*----------------------------------------------------------------------------*/


