/* SPDX-License-Identifier: LGPL-2.1-only OR BSD-3-Clause */
/******************************************************************************
 *
 * This file is provided under a dual license.  When you use or
 * distribute this software, you may choose to be licensed under
 * version 2.1 of the GNU Lesser General Public License
 * ("LGPLv2.1 License") or BSD License.
 *
 * LGPLv2.1 License
 *
 * Copyright(C) 2019 MediaTek Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2.1 of the GNU Lesser General Public
 * License as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See https://www.gnu.org/licenses/old-licenses/lgpl-2.1.html for more
 * details.
 *
 * BSD LICENSE
 *
 * Copyright(C) 2019 MediaTek Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *  * Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *****************************************************************************/

/*-----------------------------------------------------------------------------
 *
 * $Author: brianpc.huang $
 * $Date: 2015/05/29 $
 * $RCSfile: sif_sw_if.h,v $
 * $Revision: #1 $
 *
 *---------------------------------------------------------------------------*/

/** @file sif_sw_if.h
 *  This file declare the public function prototype in sif_sw_if.c.
 */

#ifndef SIF_SW_IF_H
#define SIF_SW_IF_H


//---------------------------------------------------------------------------
// Include files
//---------------------------------------------------------------------------
#include "x_os.h"
#include "x_typedef.h"

//---------------------------------------------------------------------------
// Constant definitions
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
// Type definitions
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
// Inter-file functions
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
// Public functions
//---------------------------------------------------------------------------
EXTERN VOID SIFSW_Init(UINT32 u4SDA, UINT32 u4SCL);
EXTERN VOID SIFSW_Remove(VOID);
EXTERN BOOL SIFSW_WaitAckOK(UINT8 bDevice, UINT16 wDelayUs, UINT8 bRetry);
EXTERN UINT8 SIFSW_WriteData(UINT8 bDevAddr, UINT8 bSubAddr, UINT8 bDataCount,
                             UINT8 *pbData, UINT16 bOption);
EXTERN UINT8 SIFSW_ReadData(UINT8 bDevAddr, UINT8 bSubAddr, UINT16 bDataCount,
                            UINT8 *pbData, UINT16 bOption);
EXTERN UINT8 SIFSW_WriteDataNoSubAddr(UINT8 bDevAddr, UINT8 bDataCount,
                                      UINT8 *pbData, UINT32 bOption, UINT16 u2Delay,
                                      UINT16 u2SyncTimeout);
EXTERN UINT8 SIFSW_ReadDataNoSubAddr(UINT8 bDevAddr, UINT16 bDataCount,
                                     UINT8 *pbData, UINT32 bOption, UINT16 u2Delay,
                                     UINT16 u2SyncTimeout);
EXTERN UINT8 SifEDIDReadByte(UINT8 u1EDID_ID, UINT8 u1SubAddr, UINT8 *pbData);
EXTERN UINT8 Sif_WriteEDIDData(UINT8 u1EDID_ID, UINT8 *pBuf, UINT8 size);
EXTERN UINT8 SIFSW_X_Read(UINT8 u1CHannelID, UINT16 u2ClkDiv, UINT8 u1DevAddr, UINT8 u1WordAddrNum, UINT32 u4WordAddr,
                  UINT8 *pu1Buf, UINT16 u2ByteCnt);
EXTERN UINT8 SIFSW_X_Write(UINT8 u1CHannelID, UINT16 u2ClkDiv, UINT8 u1DevAddr, UINT8 u1WordAddrNum, UINT32 u4WordAddr,
                  UINT8 *pu1Buf, UINT16 u2ByteCnt);

#endif /* SIF_SW_IF_H */
