/* SPDX-License-Identifier: LGPL-2.1-only OR BSD-3-Clause */
/******************************************************************************
 *
 * This file is provided under a dual license.  When you use or
 * distribute this software, you may choose to be licensed under
 * version 2.1 of the GNU Lesser General Public License
 * ("LGPLv2.1 License") or BSD License.
 *
 * LGPLv2.1 License
 *
 * Copyright(C) 2019 MediaTek Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2.1 of the GNU Lesser General Public
 * License as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See https://www.gnu.org/licenses/old-licenses/lgpl-2.1.html for more
 * details.
 *
 * BSD LICENSE
 *
 * Copyright(C) 2019 MediaTek Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *  * Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *****************************************************************************/


#ifndef __C_BT_MW_AVRCP_H__
#define __C_BT_MW_AVRCP_H__

 /******************** AVRCP ********************/

 INT32 c_btm_avrcp_get_mediaInfo(avrcp_medioInfo_t *mediaInfo);

 INT32 c_btm_avrcp_get_play_status(bt_player_status_values_t *pt_playStatus);

 INT32 c_btm_avrcp_send_get_playstatus_cmd(VOID);

 INT32 c_btm_avrcp_passthrough_cmd(BTCmdType bt_cmd_type, BTN_ACTION button_action);

 INT32 c_btm_bt_avrcp_get_capabilities(avrcp_apability_type_t type);

 INT32 c_btm_register_avrcp_notification(CHAR* pNotificationStr);
 INT32 c_btm_set_volume(UINT8 i4_volume);

 /*for PTS test*/
 INT32 c_btm_set_trackstatus(CHAR *ptrack_status);
 INT32 c_btm_send_volume_change_rsp_handler(UINT8 u1_volume);


 INT32 c_btm_send_track_change_rsp_handler(UINT8 u1track_selected);


 INT32 c_btm_set_large_element_attribute_response_handler(UINT8 u1enable);


 INT32 c_btm_send_pts_test_handler(UINT8 fgenable);


 INT32 c_btm_bt_avrcp_get_capabilities(avrcp_apability_type_t type);


#endif /* __C_BT_MW_AVRCP_H__ */
