/* SPDX-License-Identifier: LGPL-2.1-only OR BSD-3-Clause */
/******************************************************************************
 *
 * This file is provided under a dual license.  When you use or
 * distribute this software, you may choose to be licensed under
 * version 2.1 of the GNU Lesser General Public License
 * ("LGPLv2.1 License") or BSD License.
 *
 * LGPLv2.1 License
 *
 * Copyright(C) 2019 MediaTek Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2.1 of the GNU Lesser General Public
 * License as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See https://www.gnu.org/licenses/old-licenses/lgpl-2.1.html for more
 * details.
 *
 * BSD LICENSE
 *
 * Copyright(C) 2019 MediaTek Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *  * Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *****************************************************************************/

/*-----------------------------------------------------------------------------
 * $RCSfile: u_atv_mngr.h,v $
 * $Revision: #1 $
 * $Date: 2015/05/29 $
 * $Author: brianpc.huang $
 * $CCRevision: /main/DTV_X_HQ_int/5 $
 * $SWAuthor: Albert Liu $
 * $MD5HEX: bcd09d703137357b24d195d8f5601a3a $
 *
 * Description: 
 *         This header file contains ATV Manager specific definitions,
 *         which are exported.
 *---------------------------------------------------------------------------*/

#ifndef _U_ATV_MNGR_H_
#define _U_ATV_MNGR_H_


#include "u_common.h"
#include "u_handle.h"
#include "u_sys_name.h"
#include "u_handle_grp.h"

/*-----------------------------------------------------------------------------
                    include files
 ----------------------------------------------------------------------------*/


/* ATV Manager Return Code */
#define ATVMR_OK                                    ((INT32)     0)  
#define ATVMR_INV_ARG                               ((INT32)    -1)
#define ATVMR_REG_HANDLER_NO_ENTRY                  ((INT32)    -2)
#define ATVMR_REG_HANDLER_ALLOC_FAILED              ((INT32)    -3)
#define ATVMR_UPDATE_HANDLER_NOT_FOUND              ((INT32)    -4)
#define ATVMR_UNREG_HANDLER_NOT_FOUND               ((INT32)    -5)
#define ATVMR_UART_NOT_SUPPORT                      ((INT32)    -6)
#define ATVMR_TX_MSG_QUE_FULL                       ((INT32)    -7)
#define ATVMR_TX_MSG_XLS_FAILED                     ((INT32)    -8)
#define ATVMR_CONNECT_NOT_READY                     ((INT32)    -9)
#define ATVMR_TX_INV_MSG                            ((INT32)    -10)
#define ATVMR_INV_MSG_BODY_LEN                      ((INT32)    -11)
#define ATVMR_INV_MSG_BODY_CONTENT                  ((INT32)    -12)
#define ATVMR_AEE_OUT_OF_RESOURCES                  ((INT32)    -13)
#define ATVMR_AEE_NO_RIGHTS                         ((INT32)    -14)
#define ATVMR_INV_STATE                             ((INT32)    -15)

/*-----------------------------------------------------------------------------
                    macros, defines, typedefs, enums
 ----------------------------------------------------------------------------*/

typedef VOID (*x_atv_msg_handler_nfy_fct)(
    HANDLE_T        h_handle,
    VOID*           pv_tag,
    UINT8           ui1_inmsg_id,
    UINT8   ui1_inmsg_type,
    UINT16          ui2_inmsg_body_len,
    const UINT8*    pui1_inmsg_body);

typedef VOID (*x_atv_fail_handler_nfy_fct)(
    HANDLE_T        h_handle,
    VOID*           pv_tag,
    UINT8           ui1_inmsg_id,
    UINT8           ui1_inmsg_type);



#endif /* _U_ATV_MNGR_H_ */
