/* SPDX-License-Identifier: LGPL-2.1-only OR BSD-3-Clause */
/******************************************************************************
 *
 * This file is provided under a dual license.  When you use or
 * distribute this software, you may choose to be licensed under
 * version 2.1 of the GNU Lesser General Public License
 * ("LGPLv2.1 License") or BSD License.
 *
 * LGPLv2.1 License
 *
 * Copyright(C) 2019 MediaTek Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2.1 of the GNU Lesser General Public
 * License as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See https://www.gnu.org/licenses/old-licenses/lgpl-2.1.html for more
 * details.
 *
 * BSD LICENSE
 *
 * Copyright(C) 2019 MediaTek Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *  * Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *****************************************************************************/

/*----------------------------------------------------------------------------*/
/*! @file u_uc_str.h 
 *  $RCSfile: $
 *  $Revision: #1 $
 *  $Date: 2015/05/29 $
 *  $Author: brianpc.huang $
 *  
 *  @par Description:
 *         This contains 'Unicode String' exported macros, definitons,
 *         and structures.
 */
/*----------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------*/
/*! @defgroup groupMW_UNICODE Unicode Lib
 *
 *  @ingroup groupMW
 *  @brief Provides constant,type definitions and function of the  Unicode Lib
 *   ..  Unicode Lib Lib is a middleware component that is responsible for unicode transition
 *
 *  %MW Application API would be used by TV Application, lot of these APIs 
 *  would
 *   be wrapped from Exported API
 *
 *  @see groupMW
 *  @{
 */
/*----------------------------------------------------------------------------*/
#ifndef _U_UC_STR_H_
#define _U_UC_STR_H_


/*-----------------------------------------------------------------------------
                    include files
 ----------------------------------------------------------------------------*/
#include "u_uc.h"
/*------------------------------------------------------------------*/
/*! @enum E_MUL_BYTE_TYPE
 *  @brief This structure enumerates mutil bytes character type. 
 *  @code
 *  typedef enum
 * {
 *   MUL_BYTE_GB2312,
 *   MUL_BYTE_BIG5,
 *   MUL_BYTE_SHIFT_JIS,
 *   MUL_BYTE_KR
  * }  E_MUL_BYTE_TYPE;
 *  @endcode
 *  @li@c  MUL_BYTE_GB2312                                 - Code type GB2312.
 *  @li@c  MUL_BYTE_BIG5                                - Code type BIG5.
 *  @li@c  MUL_BYTE_SHIFT_JIS                                 - Code type SHIFT_JIS.
 *  @li@c  MUL_BYTE_KR                                -Code type KR.
 */
/*------------------------------------------------------------------*/

typedef enum
{
    MUL_BYTE_GB2312,
    MUL_BYTE_BIG5,
    MUL_BYTE_SHIFT_JIS,
    MUL_BYTE_KR,
    MUL_BYTE_GB18030,
    MUL_BYTE_UTF8,
    MUL_BYTE_KOI8_R,
    MUL_BYTE_CODEPAGE874,
    MUL_BYTE_CODEPAGE1250,
    MUL_BYTE_CODEPAGE1251,
    MUL_BYTE_CODEPAGE1252,
    MUL_BYTE_CODEPAGE1253,
    MUL_BYTE_CODEPAGE1254,
    MUL_BYTE_CODEPAGE1255,
    MUL_BYTE_CODEPAGE1256,
    MUL_BYTE_CODEPAGE1257,
    MUL_BYTE_CODEPAGE1258,
    MUL_BYTE__ISO8859_2,
    MUL_BYTE__ISO8859_5,
    MUL_BYTE__ISO8859_7,
    MUL_BYTE__ISO8859_8,
    MUL_BYTE__ISO8859_9,
    MUL_BYTE__ISO8859_16
    
}  E_MUL_BYTE_TYPE;

#endif  /* _U_UC_STR_H */
/*----------------------------------------------------------------------------*/
/*! @} */   /* end of  groupMW_UNICODE*/
/*----------------------------------------------------------------------------*/
