/* SPDX-License-Identifier: LGPL-2.1-only OR BSD-3-Clause */
/******************************************************************************
 *
 * This file is provided under a dual license.  When you use or
 * distribute this software, you may choose to be licensed under
 * version 2.1 of the GNU Lesser General Public License
 * ("LGPLv2.1 License") or BSD License.
 *
 * LGPLv2.1 License
 *
 * Copyright(C) 2019 MediaTek Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2.1 of the GNU Lesser General Public
 * License as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See https://www.gnu.org/licenses/old-licenses/lgpl-2.1.html for more
 * details.
 *
 * BSD LICENSE
 *
 * Copyright(C) 2019 MediaTek Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *  * Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *****************************************************************************/

/*-----------------------------------------------------------------------------
 * $RCSfile: x_bsl.h,v $
 * $Revision: #1 $
 * $Date: 2015/05/29 $
 * $Author: brianpc.huang $
 *
 * Description: 
 *    This header file contains Satellite list (BSL) database
 *    API definitions, which are exported to other Middleware components
 *    and applications.
 *         
 *---------------------------------------------------------------------------*/

#ifndef _X_BSL_H_
#define _X_BSL_H_

/*---------------------------------------------------------------------------
                    include files
----------------------------------------------------------------------------*/

//#include "u_bsl.h"

#include "u_bsl.h"


/*-------------------------------------------------------------------------
                    functions declarations
 --------------------------------------------------------------------------*/
/*
extern
BOOL x_bsl_get_largest_rec_id(HANDLE_T h_bsl, UINT16* pui2_rec_id);

extern
BOOL x_bsl_get_smallest_rec_id(HANDLE_T h_bsl, UINT16* pui2_rec_id);
*/

extern
INT32 x_bsl_create
(
    const CHAR*         ps_bsl_name,
    UINT16              ui2_bsl_id,
    BSL_MEM_POLICY_T    e_mem_policy,
    UINT16              ui2_max_nb_rec,
    VOID*               pv_tag,
    x_bsl_nfy_fct       pf_nfy,
    HANDLE_T*           ph_bsl
);

extern
INT32 x_bsl_delete
(
    HANDLE_T      h_bsl
);

extern
INT32 x_bsl_clean
(
    HANDLE_T      h_bsl
);

extern
INT32 x_bsl_add_rec
(
    HANDLE_T            h_bsl,
    const BSL_REC_T*    pt_bsl_rec
);

extern
INT32 x_bsl_qry_rec_id
(
    HANDLE_T            h_bsl,
    BSL_REC_ID_QRY_T    e_bsl_qry_option,
    UINT16*             pui2_rec_id	
);


extern
INT32 x_bsl_del_rec
(
    HANDLE_T            h_bsl,
    UINT16              ui2_bsl_rec_id
);

extern
INT32 x_bsl_update_rec
(
    HANDLE_T            h_bsl,
    const BSL_REC_T*    pt_bsl_rec,
    BOOL                b_must_exist  
);

extern
INT32 x_bsl_lock
(
    HANDLE_T            h_bsl
);

extern
INT32 x_bsl_unlock
(
    HANDLE_T            h_bsl
);

extern INT32 x_bsl_read_lock
(
    HANDLE_T            h_bsl
);

extern INT32 x_bsl_read_unlock
(
    HANDLE_T            h_bsl
);

extern
INT32 x_bsl_fs_load
(
    HANDLE_T            h_dir,
    const CHAR*         ps_bsl_path,
    UINT16              ui2_bsl_id,
    const CHAR*         ps_bsl_name,
    VOID*               pv_tag,
    x_bsl_nfy_fct       pf_nfy,
    HANDLE_T*           ph_bsl
);

extern
INT32 x_bsl_fs_store
(
    HANDLE_T            h_dir,
    const CHAR*         ps_bsl_path,
    UINT16              ui2_bsl_id
);

extern
INT32 x_bsl_fs_del
(
    HANDLE_T            h_dir,
    const CHAR*         ps_bsl_path,
    UINT16              ui2_bsl_id
);

extern
INT32 x_bsl_fs_qry
(
    HANDLE_T            h_dir,
    const CHAR*         ps_bsl_path,
    UINT16              ui2_idx,
    UINT16*             pui2_bsl_id,
    CHAR*               ps_bsl_name
);

extern
INT32 x_bsl_fs_sync
(
    HANDLE_T      h_bsl,
    HANDLE_T      h_dir,
    const CHAR*   ps_bsl_path,
    UINT16        ui2_bsl_id
);

extern
INT32 x_bsl_open
(
    UINT16          ui2_bsl_id,
    VOID*           pv_tag,
    x_bsl_nfy_fct   pf_nfy,
    HANDLE_T*       ph_bsl
);

extern
INT32 x_bsl_open_by_name
(
    const CHAR*         ps_bsl_name,
    VOID*               pv_tag,
    x_bsl_nfy_fct       pf_nfy,
    HANDLE_T*           ph_bsl
);

extern
INT32 x_bsl_close
(
    HANDLE_T            h_bsl
);

extern
INT32 x_bsl_get_handle_info
(
    HANDLE_T            h_bsl,
    UINT16*             pui2_bsl_id,
    CHAR*               ps_bsl_name
);

extern
INT32 x_bsl_get_rec
(
    HANDLE_T            h_bsl,
    UINT16              ui2_bsl_rec_id,
    BSL_REC_T*          pt_bsl_rec,
    UINT32*             pui4_ver_id
);

extern
INT32 x_bsl_get_num_recs
(
    HANDLE_T            h_bsl,
    UINT16*             pui2_num_recs,
    UINT32*             pui4_ver_id
);

extern
INT32 x_bsl_get_rec_by_rec_idx
(
    HANDLE_T            h_bsl,
    UINT16              ui2_idx,
    BSL_REC_T*          pt_bsl_rec,
    UINT32*             pui4_ver_id
);

extern
INT32 x_bsl_get_num_rec_by_freq
(
    HANDLE_T      h_bsl,
    UINT32        ui4_freq,
    UINT16*       pui2_num_recs,
    UINT32*       pui4_ver_id
);



extern
INT32 x_bsl_get_num_rec_by_header
(
    HANDLE_T            h_bsl,
    BSL_REC_HEADER_T* 	pt_rec_hdr,
    UINT16*       			pui2_num_recs,
    UINT32*             pui4_ver_id
);


extern
INT32 x_bsl_get_rec_by_header
(
    HANDLE_T            h_bsl,
    BSL_REC_HEADER_T* 	pt_rec_hdr,
    BSL_REC_T*          pt_bsl_rec,
    UINT16        			ui2_idx,
    UINT32*             pui4_ver_id
);


extern
INT32 x_bsl_rec_init
(
    BSL_REC_T*    pt_bsl_rec
);

extern INT32 x_bsl_get_info
(
    HANDLE_T      h_bsl
);

extern INT32 x_bsl_set_cursor
(
    HANDLE_T        h_bsl,
    BSL_ITERATE_T   e_pos
);

extern INT32 x_bsl_read_cursor
(
    HANDLE_T            h_bsl,
    BSL_REC_T*          pt_bsl_rec,
    UINT32*             pui4_ver_id
);

extern INT32 x_bsl_sort_rec
(
    HANDLE_T      h_bsl,
    UINT32*       pui4_ver_id 
);

extern INT32 x_bsl_fs_store_given_file_handle
(
    HANDLE_T        h_file,
    UINT16          ui2_bsl_id  
);

extern
INT32 x_bsl_fs_sync_given_file_handle
(
    HANDLE_T    h_bsl,  
    HANDLE_T    h_file,
    UINT16      ui2_bsl_id
);


#endif /* _X_BSL_H_ */
