/* SPDX-License-Identifier: LGPL-2.1-only OR BSD-3-Clause */
/******************************************************************************
 *
 * This file is provided under a dual license.  When you use or
 * distribute this software, you may choose to be licensed under
 * version 2.1 of the GNU Lesser General Public License
 * ("LGPLv2.1 License") or BSD License.
 *
 * LGPLv2.1 License
 *
 * Copyright(C) 2019 MediaTek Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2.1 of the GNU Lesser General Public
 * License as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See https://www.gnu.org/licenses/old-licenses/lgpl-2.1.html for more
 * details.
 *
 * BSD LICENSE
 *
 * Copyright(C) 2019 MediaTek Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *  * Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *****************************************************************************/

/*-----------------------------------------------------------------------------
 * $RCSfile: x_df_mngr.h,v $
 * $Revision: #1 $
 * $Date: 2015/05/29 $
 * $Author: brianpc.huang $
 *
 * Description:
 *         This header file contains Download Function Manager specific 
 *      definitions, which are exported.
 *---------------------------------------------------------------------------*/

#ifndef _X_DFM_H_
#define _X_DFM_H_


/*-----------------------------------------------------------------------------
                    include files
-----------------------------------------------------------------------------*/

#include "x_handle.h"
#include "u_wgl_common.h"
#include "u_df_mngr.h"


/*-----------------------------------------------------------------------------
                    functions declarations
 ----------------------------------------------------------------------------*/
extern INT32    x_dfm_open(
                    const CHAR*         ps_dfm_name,
                    HANDLE_T*           ph_dfm
                    );
extern INT32    x_dfm_close(
                    HANDLE_T            ph_dfm
                    );
extern INT32    x_dfm_load_logo(
                    HANDLE_T            h_dfm,
                    UINT16              ui2_on_id,
                    UINT16              ui2_svc_id,
                    UINT16              ui2_scan_idx,
                    VOID*               pv_tag,
                    x_dfm_nfy_fct       pt_nfy,
                    HANDLE_T*           ph_logo,
                    DFM_COND_T*         pe_cond
                    );
extern INT32    x_dfm_get_cond(
                    HANDLE_T            h_dfm,
                    HANDLE_T            h_logo,
                    DFM_COND_T*         pe_cond
                    );
extern INT32    x_dfm_get_logo_type(
                    HANDLE_T            h_dfm,
                    HANDLE_T            h_logo,
                    UINT8*              pui1_logo_types,/* |= */
                    DFM_COND_T*         pe_cond
                    );

extern INT32    x_dfm_get_logo_data(
                    HANDLE_T            h_dfm,
                    HANDLE_T            h_logo,
                    DFM_LOGO_TYPE_T     t_logo_type,
                    WGL_HIMG_TPL_T*     pt_img,/*this is a WGL_HIMG_TPL_T, Don't free it*/
                    DFM_COND_T*         pe_cond
                    );

extern INT32    x_dfm_get_logo_file_path(
                    HANDLE_T            h_dfm,
                    HANDLE_T            h_logo,
                    DFM_LOGO_TYPE_T     t_logo_type,
                    CHAR*               pc_file_path,
                    DFM_COND_T*         pe_cond
                    );

extern INT32    x_dfm_free_logo(
                    HANDLE_T            h_dfm,
                    HANDLE_T            h_logo
                    );

extern INT32 x_dfm_change_svc(
                    HANDLE_T         h_dfm,
                    UINT16           ui2_onid,
                    UINT16           ui2_service_ID,
                    UINT16           ui2_scan_idx
                         );
#endif /* _X_DFM_H */


