/* SPDX-License-Identifier: LGPL-2.1-only OR BSD-3-Clause */
/******************************************************************************
 *
 * This file is provided under a dual license.  When you use or
 * distribute this software, you may choose to be licensed under
 * version 2.1 of the GNU Lesser General Public License
 * ("LGPLv2.1 License") or BSD License.
 *
 * LGPLv2.1 License
 *
 * Copyright(C) 2019 MediaTek Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2.1 of the GNU Lesser General Public
 * License as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See https://www.gnu.org/licenses/old-licenses/lgpl-2.1.html for more
 * details.
 *
 * BSD LICENSE
 *
 * Copyright(C) 2019 MediaTek Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *  * Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *****************************************************************************/

/*-----------------------------------------------------------------------------
 * $RCSfile: x_dm.h,v $
 * $Revision: #1 $
 * $Date: 2015/05/29 $
 * $Author: brianpc.huang $
 * $SWAuthor: $
 *
 * Description: 
 *         This file contains all the transition effect interface APIs  
 *---------------------------------------------------------------------------*/

#ifndef _X_DM_H_
#define _X_DM_H_

#include "u_dm.h"
extern INT32 x_dm_init(
    DM_INIT_PARM_T  *pt_init);

extern INT32 x_dm_reg_nfy_fct(
    DM_EVT_CAT_T    t_evt_cat,
    x_dm_nfy_fct    pf_nfy,      
    DM_EVT_FILTR_T  *pt_filtr,
    VOID            *pv_tag, 
    HANDLE_T        *ph_nfy);

extern INT32 x_dm_unreg_nfy_fct(
    HANDLE_T        h_nfy);

extern INT32 x_dm_get_device_info(
    HANDLE_T        h_dev, 
    DM_DEV_INF_T    *pt_inf);

extern INT32 x_dm_get_devices(
    DM_DEV_FILTR_T *pt_filtr, 
    DM_DEV_STAT_T *pt_stat,
    UINT32 *pui4_dev_ns);

extern INT32 x_dm_get_device(
    DM_DEV_SPEC_T *pt_spec,
    HANDLE_T *ph_dev);

extern BOOL x_dm_query_automnt(
    DM_HW_TYPE_T  t_hw_type,
    DM_DEV_TYPE_T t_dev_type);
    
extern INT32 x_dm_umount_remove(char* ps_dev_name);

extern INT32 x_dm_odd_spindle_control(
    HANDLE_T h_dev, 
    DM_DEV_IO_SPIN_CTRL_T t_spin_ctrl,
    VOID *pv_tag,
    x_dm_ioc_fct pf_ioc_fct,
    HANDLE_T *ph_ioc);

extern INT32 x_dm_hdd_spindle_control(
    HANDLE_T h_dev, 
    VOID *pv_parm);

extern INT32 x_dm_odd_tray_control(
    HANDLE_T h_dev, 
    DM_DEV_IO_TRAY_CTRL_T t_tray_ctrl,
    VOID *pv_tag,
    x_dm_ioc_fct pf_ioc_fct,
    HANDLE_T *ph_ioc);

extern INT32 x_dm_odd_read_dvd_struct(
    HANDLE_T h_dev,
    DM_DEV_IO_MED_READ_DVD_STRUCT_T *pt_struct);

extern INT32 x_dm_odd_read_kcd(
    HANDLE_T h_dev,
    DM_DEV_IO_MED_READ_KCD_T *pt_kcd);

extern INT32 x_dm_odd_com_report_key(
    HANDLE_T h_dev, 
    DM_DEV_IO_COM_REPORT_KEY_T *pt_key);

extern INT32 x_dm_odd_com_send_key(
    HANDLE_T h_dev, 
    DM_DEV_IO_COM_SEND_KEY_T *pt_key);

extern INT32 x_dm_odd_com_get_feature(
    HANDLE_T h_dev, 
    DM_DEV_IO_COM_GET_FEATURE_T *pt_feature);

extern INT32 x_dm_odd_read_cd(
    HANDLE_T h_dev, 
    DM_DEV_MED_DISC_READ_CD_T *pt_read_cd);

extern INT32 x_dm_odd_read_cd_async(
    HANDLE_T h_dev, 
    DM_DEV_MED_DISC_READ_CD_T *pt_read_cd,
    VOID *pv_tag,
    x_dm_ioc_fct pf_ioc_fct,
    HANDLE_T *ph_ioc);

extern INT32 x_dm_odd_read_cd_text(
    HANDLE_T h_dev, 
    DM_DEV_MED_READ_CD_TEXT_T *pt_read_txt);

extern INT32 x_dm_odd_read_disc_info(
    HANDLE_T h_dev, 
    VOID *pv_parm);

extern INT32 x_dm_odd_get_standby_timer(
    HANDLE_T h_dev, 
    UINT32 *pui4_time);

extern INT32 x_dm_hdd_get_standby_timer(
    HANDLE_T h_dev, 
    UINT32 *pui4_time);

extern INT32 x_dm_odd_set_standby_timer(
    HANDLE_T h_dev, 
    UINT32 ui4_time);

extern INT32 x_dm_hdd_set_standby_timer(
    HANDLE_T h_dev, 
    UINT32 ui4_time);

extern INT32 x_dm_odd_flush_cache(
    HANDLE_T h_dev, 
    VOID *pv_parm);

extern INT32 x_dm_hdd_flush_cache(
    HANDLE_T h_dev, 
    VOID *pv_parm);

extern INT32 x_dm_odd_low_format(
    HANDLE_T h_dev, 
    VOID *pv_parm);

extern INT32 x_dm_nand_low_format(
    HANDLE_T h_dev, 
    VOID *pv_parm);

extern INT32 x_dm_odd_disc_finalize(
    HANDLE_T h_dev, 
    VOID *pv_parm);

extern INT32 x_dm_odd_disc_unfinalize(
    HANDLE_T h_dev, 
    VOID *pv_parm);

extern INT32 x_dm_odd_disc_upgrade(
    HANDLE_T h_dev, 
    VOID *pv_parm);

extern INT32 x_dm_get_uuid(
    const CHAR * ps_dev_name,
    CHAR * ps_uuid);

extern INT32 x_dm_odd_set_io_speed(
    HANDLE_T h_dev, 
    VOID *pv_parm);

extern INT32 x_dm_odd_hw_reset(
    HANDLE_T h_dev, 
    VOID *pv_parm);

extern INT32 x_dm_odd_release_bus(
    HANDLE_T h_dev, 
    VOID *pv_parm);

extern INT32 x_dm_odd_test_unit_ready(
    HANDLE_T h_dev, 
    VOID *pv_parm);

extern INT32 x_dm_odd_get_event_status(
    HANDLE_T h_dev, 
    VOID *pv_parm);

extern INT32 x_dm_odd_mechanism_status(
    HANDLE_T h_dev, 
    VOID *pv_parm);

extern INT32 x_dm_odd_set_book_type(
    HANDLE_T h_dev, 
    VOID *pv_parm);

extern INT32 x_dm_odd_flashless_download(
    HANDLE_T h_dev, 
    VOID *pv_parm);

extern INT32 x_dm_odd_set_transfer_mode(
    HANDLE_T h_dev, 
    VOID *pv_parm);

extern INT32 x_dm_odd_read_buffer_capacity(
    HANDLE_T h_dev, 
    VOID *pv_parm);

extern INT32 x_dm_odd_do_opc(
    HANDLE_T h_dev, 
    VOID *pv_parm);

extern INT32 x_dm_odd_read_dvd_structure(
    HANDLE_T h_dev, 
    VOID *pv_parm);

extern INT32 x_dm_odd_vendor_inquiry(
    HANDLE_T h_dev, 
    VOID *pv_parm);

extern INT32 x_dm_odd_auto_tune(
    HANDLE_T h_dev, 
    VOID *pv_parm);

extern INT32 x_dm_odd_get_med_nwa(
    HANDLE_T h_dev, 
    UINT32 *pui4_nwa);

extern INT32 x_dm_odd_get_med_toc_hdr(
    HANDLE_T h_dev, 
    DM_DEV_MED_DISC_TOC_HEADER_T *pt_toc_hdr);

extern INT32 x_dm_odd_get_med_toc_ent(
    HANDLE_T h_dev,
    DM_DEV_MED_DISC_TOC_ENTRY_T *pt_toc_ent);

extern INT32 x_dm_odd_get_sess_ns(
    HANDLE_T h_dev,
    UINT32 *pui4_sess_ns);

extern INT32 x_dm_odd_get_sess_inf(
    HANDLE_T h_dev,
    UINT32 ui4_sess_no,
    DM_DEV_MED_DISC_SESS_INFO_T *pt_inf);

extern INT32 x_dm_odd_get_trk_ns(
    HANDLE_T h_dev,
    UINT32 *pui4_trk_ns);

extern INT32 x_dm_odd_get_trk_inf(
    HANDLE_T h_dev,
    UINT32 ui4_trk_no,
    DM_DEV_MED_DISC_TRK_INFO_T *pt_inf);

extern INT32 x_dm_odd_get_sector_sz(
    HANDLE_T h_dev,
    UINT32 ui4_lba,
    DM_DEV_MED_DISC_SECTOR_SIZE_TYPE_T *pt_sz);

extern INT32 x_dm_odd_get_last_sense_key(
    HANDLE_T h_dev, 
    UINT32 *pui4_key);

extern INT32 x_dm_odd_get_current_speed(
    HANDLE_T h_dev, 
    UINT32 *pui4_speed);

/*zink CSR BT*/
extern INT32 x_dm_bt_send_io_req(
    HANDLE_T            h_dev,
    BOOL                b_in_isr,
    DM_USB_BT_IO_REQ_T* pt_io_req);
                          
extern INT32 x_dm_bt_get_io_req_num(
    HANDLE_T                    h_dev, 
    DM_USB_BT_IO_REQ_NUM_T*     pt_req_num); 

extern INT32 x_dm_get_usb_port_number(
    UINT8*                      pui1_usb_port_num);

extern INT32 x_dm_iso_attach(
    const CHAR* ps_iso);

extern INT32 x_dm_iso_detach(
    const CHAR* ps_iso);

extern INT32 x_dm_get_device_serialNum(
    const CHAR* ps_devName,
    CHAR* ps_serialNum);

extern INT32 x_dm_vold_nfy_handler(
    const CHAR* ps_mnt,
    const CHAR* ps_dev,
    UINT32      ui4_event);

extern INT32 x_dm_vold_set_do_cb(
    x_dm_vold_cb_func pf_nfy);

extern INT32 x_dm_get_dongle_index(
    const CHAR* ps_puid);

extern INT32 x_dm_get_dev_port_by_name(
		const CHAR* ps_dev_name,
		UINT8 *pui1_changed_usb_port);

extern INT32 x_dm_dev_resend_notify();

#endif

