/* SPDX-License-Identifier: LGPL-2.1-only OR BSD-3-Clause */
/******************************************************************************
 *
 * This file is provided under a dual license.  When you use or
 * distribute this software, you may choose to be licensed under
 * version 2.1 of the GNU Lesser General Public License
 * ("LGPLv2.1 License") or BSD License.
 *
 * LGPLv2.1 License
 *
 * Copyright(C) 2019 MediaTek Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2.1 of the GNU Lesser General Public
 * License as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See https://www.gnu.org/licenses/old-licenses/lgpl-2.1.html for more
 * details.
 *
 * BSD LICENSE
 *
 * Copyright(C) 2019 MediaTek Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *  * Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *****************************************************************************/

/*-----------------------------------------------------------------------------
 * $RCSfile: x_dsmcc_db.h,v $
 * $Revision: #2 $
 * $Date: 2015/06/04 $
 * $Author: jingjing.huang $
 *
 * Description:
 *         This header file contains DSMCC Data Broadcast specific
 *         definitions, which are exported.
 *-------------------------------------------------------------------------*/

#ifndef _X_DSMCC_DB_H_
#define _X_DSMCC_DB_H_


/*---------------------------------------------------------------------------
                    include files
---------------------------------------------------------------------------*/

#include "x_handle_grp.h"
#include "x_common.h"
#include "x_tm.h"
#include "u_dsmcc_db.h"


/*---------------------------------------------------------------------------
                    functions declarations
 --------------------------------------------------------------------------*/

extern INT32 x_dsmcc_db_load_dsi_by_pid_ts_id (HANDLE_T       h_root,
                                               MPEG_2_PID_T   t_pid,
                                               UINT16         ui2_ts_id,
                                               TM_SRC_TYPE_T  e_src_type,
                                               VOID*          pv_src_info,
                                               VOID*          pv_nfy_tag,
                                               x_tm_nfy_fct   pf_nfy,
                                               HANDLE_T*      ph_dsi,
                                               TM_COND_T*     pe_cond);
extern INT32 x_dsmcc_db_load_dsi_by_pid_ts_descr (HANDLE_T       h_root,
                                                  MPEG_2_PID_T   t_pid,
                                                  TS_DESCR_T*    pt_ts_descr,
                                                  TM_SRC_TYPE_T  e_src_type,
                                                  VOID*          pv_src_info,
                                                  VOID*          pv_nfy_tag,
                                                  x_tm_nfy_fct   pf_nfy,
                                                  HANDLE_T*      ph_dsi,
                                                  TM_COND_T*     pe_cond);

extern INT32 x_dsmcc_db_load_module_async (HANDLE_T      h_dii,
                                           UINT16        ui2_module_idx,
                                           UINT32        ui4_offs,
                                           SIZE_T        z_buff_len,
                                           UINT8*        pui1_buff,
                                           VOID*         pv_nfy_tag,
                                           x_tm_nfy_fct  pf_nfy,
                                           HANDLE_T*     ph_db_module,
                                           TM_COND_T*    pe_cond);

extern INT32 x_dsmcc_db_load_module_async_ex (HANDLE_T      h_dii,
                                              UINT16        ui2_module_idx,
                                              UINT32        ui4_offs,
                                              SIZE_T        z_buff_len,
                                              UINT8*        pui1_buff,
                                              UINT32        ui4_offs_2,
                                              SIZE_T        z_buff_len_2,
                                              UINT8*        pui1_buff_2,
                                              VOID*         pv_nfy_tag,
                                              x_tm_nfy_fct  pf_nfy,
                                              HANDLE_T*     ph_db_module,
                                              TM_COND_T*    pe_cond);
extern INT32 x_dsmcc_db_load_module_async_ddb_detect (HANDLE_T      h_dii,
                                                UINT16        ui2_module_idx,
                                                UINT32        ui4_offs,
                                                SIZE_T        z_buff_len,
                                                UINT8*        pui1_buff,
                                                VOID*         pv_nfy_tag,
                                                x_tm_nfy_fct  pf_nfy,
                                                HANDLE_T*     ph_db_module,
                                                TM_COND_T*    pe_cond);


extern INT32 x_dsmcc_db_get_num_groups (HANDLE_T    h_dsi,
                                        UINT16*     pui2_num_groups,
                                        TM_COND_T*  pe_cond);
extern INT32 x_dsmcc_db_get_group_info (HANDLE_T                h_dsi,
                                        UINT16                  ui2_group_idx,
                                        DSMCC_DB_SPEC_T         e_dsmcc_db_spec,
                                        DSMCC_DB_GROUP_INFO_T*  pt_group_info,
                                        TM_COND_T*              pe_cond);

extern INT32 x_dsmcc_db_get_module_by_idx (HANDLE_T    h_dii,
                                           UINT16      ui2_module_idx,
                                           UINT32      ui4_offs,
                                           SIZE_T      z_buff_len,
                                           UINT8*      pui1_buff,
                                           SIZE_T*     pz_buff_loaded,
                                           TM_COND_T*  pe_cond);
extern INT32 x_dsmcc_db_get_module_by_idx_timeout (HANDLE_T    h_dii,
                                                   UINT16      ui2_module_idx,
                                                   UINT32      ui4_offs,
                                                   SIZE_T      z_buff_len,
                                                   UINT8*      pui1_buff,
                                                   SIZE_T*     pz_buff_loaded,
                                                   UINT32      ui4_timeout,
                                                   TM_COND_T*  pe_cond);

extern INT32 x_dsmcc_db_parse_group_all_comp_descr (HANDLE_T        h_dsi,
                                                    UINT16          ui2_group_idx,
                                                    DSMCC_DB_SPEC_T e_dsmcc_db_spec,
                                                    VOID*           pv_data,
                                                    SIZE_T          z_data_len,
                                                    x_tm_parse_fct  pf_parse,
                                                    TM_COND_T*      pe_cond);
extern INT32 x_dsmcc_db_parse_group_info (HANDLE_T        h_dsi,
                                          UINT16          ui2_group_idx,
                                          DSMCC_DB_SPEC_T e_dsmcc_db_spec,
                                          VOID*           pv_data,
                                          SIZE_T          z_data_len,
                                          x_tm_parse_fct  pf_parse,
                                          TM_COND_T*      pe_cond);
extern INT32 x_dsmcc_db_parse_group_private_data (HANDLE_T        h_dsi,
                                                  DSMCC_DB_SPEC_T e_dsmcc_db_spec,
                                                  VOID*           pv_data,
                                                  SIZE_T          z_data_len,
                                                  x_tm_parse_fct  pf_parse,
                                                  TM_COND_T*      pe_cond);

extern INT32 x_dsmcc_db_new_ddb_status (DATA_OBJ_T*  pt_data);

extern INT32 x_dsmcc_db_new_ddb_status_ex (DATA_OBJ_T*  pt_data);

#endif /* _X_DSMCC_DB_H_ */

