/* SPDX-License-Identifier: LGPL-2.1-only OR BSD-3-Clause */
/******************************************************************************
 *
 * This file is provided under a dual license.  When you use or
 * distribute this software, you may choose to be licensed under
 * version 2.1 of the GNU Lesser General Public License
 * ("LGPLv2.1 License") or BSD License.
 *
 * LGPLv2.1 License
 *
 * Copyright(C) 2019 MediaTek Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2.1 of the GNU Lesser General Public
 * License as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See https://www.gnu.org/licenses/old-licenses/lgpl-2.1.html for more
 * details.
 *
 * BSD LICENSE
 *
 * Copyright(C) 2019 MediaTek Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *  * Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *****************************************************************************/

/*-----------------------------------------------------------------------------
 * $RCSfile: x_lst_mngr.h,v $
 * $Revision: #1 $
 * $Date: 2015/05/29 $
 * $Author: brianpc.huang $
 * $CCRevision: /main/DTV_X/DTV_X_HQ_int/20 $
 * $SWAuthor: Pedro Tsai $
 * $MD5HEX: aa3109d410702d35a82d86c6386592c7 $
 *
 * Description:
 *         This header file contains Large Object list related API definitions,
 *         which are exported to other Middleware components.
 *
 *---------------------------------------------------------------------------*/

#ifndef _X_LST_MNGR_H_
#define _X_LST_MNGR_H_

#include "u_lst_mngr.h"

extern INT32 x_lst_mngr_init_list_id_by_type(UINT16            ui2_lst_id,
                                             LST_MNGR_LST_TYPE_T e_type);

extern INT32 x_lst_mngr_deinit_list_id_by_type(UINT16            ui2_lst_id,
                                               LST_MNGR_LST_TYPE_T e_type);

extern INT32 x_lst_mngr_init_list_id(UINT16            ui2_lst_id,
                                     UINT32            ui4_lst_mask);

extern INT32 x_lst_mngr_deinit_list_id(UINT16            ui2_lst_id,
                                       UINT32            ui4_lst_mask,
                                       BOOL              b_force);

extern INT32 x_lst_mngr_fs_store(HANDLE_T          h_dir,
                                 const CHAR*       ps_lst_path,
                                 UINT16            ui2_lst_id,
                                 UINT32            ui4_lst_mask);
extern INT32 x_lst_mngr_fs_multiple_store(HANDLE_T          h_dir,
                          const CHAR*       ps_lst_path,
                          const UINT16*     pui2_lst_id,
                          const UINT32*     pui4_lst_mask,
                          UINT16            ui2_elem_count);

extern INT32 x_lst_mngr_fs_sync(HANDLE_T          h_dir,
                                const CHAR*       ps_lst_path,
                                UINT16            ui2_lst_id,
                                UINT32            ui4_lst_mask);

extern INT32 x_lst_mngr_reg_dual_bank(HANDLE_T             h_dir,
                                      const CHAR*          ps_main_path,
                                      const CHAR*          ps_sub_path,
                                      x_lst_mngr_get_fct   pf_get,
                                      x_lst_mngr_set_fct   pf_set);
extern INT32 lst_mngr_reg_dual_bank(HANDLE_T             h_dir,
                                    const CHAR*          ps_main_path,
                                    const CHAR*          ps_sub_path,
                                    lst_mngr_get_fct     pf_get,
                                    lst_mngr_set_fct     pf_set,
                                    VOID*                pv_get_tag,
                                    VOID*                pv_set_tag);

extern INT32 x_lst_mngr_dual_bank_fs_store(UINT16            ui2_lst_id,
                                           UINT32            ui4_lst_mask,
                                           LST_MNGR_DUAL_BANK_AS_MODE_T e_as_mode);

extern INT32 x_lst_mngr_dual_bank_fs_multiple_store(UINT16*            pui2_lst_id,
                                    UINT32*            pui4_lst_mask,
                                    UINT16             ui2_elem_count,
                                    LST_MNGR_DUAL_BANK_AS_MODE_T e_as_mode);

extern INT32 x_lst_mngr_dual_bank_fs_sync(UINT16            ui2_lst_id,
                                          UINT32            ui4_lst_mask);

extern UINT8 x_lst_mngr_get_dual_bank_status(VOID);

extern VOID  x_lst_mngr_reset_dual_bank_status(VOID);

extern INT32 x_lst_mngr_reg_default_db(UINT16              ui2_lst_id,
                                       UINT32              ui4_lst_mask,
                                       HANDLE_T            h_dir,
                                       const CHAR*         ps_def_db_path,
                                       UINT16              ui2_def_db_lst_id);

extern INT32 x_lst_mngr_load_default_db(UINT16            ui2_lst_id,
                                        UINT32            ui4_lst_mask,
                                        BOOL              b_clean_list);

extern INT32 x_lst_mngr_dual_bank_fs_sync_with_fallback(UINT16  ui2_lst_id,
                                                        UINT32  ui4_lst_mask);

extern INT32 x_lst_mngr_swap_svl_rec(HANDLE_T          h_svl,
                                     UINT16            ui2_svl_rec_id_A,
                                     UINT16            ui2_svl_rec_id_B);

extern INT32 x_lst_mngr_copy_svl_rec(HANDLE_T          h_svl,
                                     UINT16            ui2_svl_rec_id,
                                     UINT16            ui2_new_rec_id,
                                     UINT32            ui4_new_channel_id);

extern INT32 x_lst_mngr_clean_svl(HANDLE_T             h_svl,
                                  LST_MNGR_CLEAN_T*    pt_clean);

extern INT32 x_lst_mngr_clean_tsl(HANDLE_T             h_tsl,
                                  LST_MNGR_CLEAN_T*    pt_clean);

extern INT32 x_lst_mngr_clean_satl_ch(
              UINT16  ui2_satl_id,
              UINT16  ui2_satl_rec_id,
              BOOL    b_clean_tsl);

#endif /* _X_LST_MNGR_H_ */


