/*----------------------------------------------------------------------------*
 * No Warranty                                                                *
 * Except as may be otherwise agreed to in writing, no warranties of any      *
 * kind, whether express or implied, are given by MTK with respect to any MTK *
 * Deliverables or any use thereof, and MTK Deliverables are provided on an   *
 * "AS IS" basis.  MTK hereby expressly disclaims all such warranties,        *
 * including any implied warranties of merchantability, non-infringement and  *
 * fitness for a particular purpose and any warranties arising out of course  *
 * of performance, course of dealing or usage of trade.  Parties further      *
 * acknowledge that Company may, either presently and/or in the future,       *
 * instruct MTK to assist it in the development and the implementation, in    *
 * accordance with Company's designs, of certain softwares relating to        *
 * Company's product(s) (the "Services").  Except as may be otherwise agreed  *
 * to in writing, no warranties of any kind, whether express or implied, are  *
 * given by MTK with respect to the Services provided, and the Services are   *
 * provided on an "AS IS" basis.  Company further acknowledges that the       *
 * Services may contain errors, that testing is important and Company is      *
 * solely responsible for fully testing the Services and/or derivatives       *
 * thereof before they are used, sublicensed or distributed.  Should there be *
 * any third party action brought against MTK, arising out of or relating to  *
 * the Services, Company agree to fully indemnify and hold MTK harmless.      *
 * If the parties mutually agree to enter into or continue a business         *
 * relationship or other arrangement, the terms and conditions set forth      *
 * hereunder shall remain effective and, unless explicitly stated otherwise,  *
 * shall prevail in the event of a conflict in the terms in any agreements    *
 * entered into between the parties.                                          *
 *---------------------------------------------------------------------------*/
/*-----------------------------------------------------------------------------
 * Copyright (c) 2005, MediaTek, Inc.
 * All rights reserved.
 *
 * Unauthorized use, practice, perform, copy, distribution, reproduction,
 * or disclosure of this information in whole or in part is prohibited.
 *-----------------------------------------------------------------------------
 * $RCSfile: x_mux_util_rec_obsvr.h,v $
 * $Revision: #1 $
 * $Date: 2015/05/29 $
 * $Author: brianpc.huang $
 * $CCRevision: /main/DTV_X_HQ_int/5 $
 * $SWAuthor: Clear Case Administrator $
 * $MD5HEX: e5a2644d77eac094a5d2aa1496612a57 $
 *
 * Description:
 *         This contains Mux Utility record utility  exported macros, definitons,
 *         and structures.
 *---------------------------------------------------------------------------*/

#ifndef _X_MUX_UTIL_REC_OBSVR_H_
#define _X_MUX_UTIL_REC_OBSVR_H_

#include "u_common.h"
#include "u_handle.h"

#include "u_mux_util.h"

/*-----------------------------------------------------------------------------
                    macros, defines, typedefs, enums
-----------------------------------------------------------------------------*/
#define MUX_UTIL_REC_DB_IDX                 ( 0 )
/*-----------------------------------------------------------------------------
                    FUNCTION DECLARED
-----------------------------------------------------------------------------*/

extern INT32 x_mux_util_rec_obsvr_open( HANDLE_T*                      ph_handle ,
                                                MUX_UTIL_REC_OBSVR_CONFIG_T*  pt_rec_obsvr_cfg);


extern INT32 x_mux_util_rec_obsvr_get( HANDLE_T                   h_handle,
                                              MUX_UTIL_OBSVR_GET_TYPE   e_obsvr_get_type,
                                              VOID*                      pv_obsvr_get_info,
                                              SIZE_T*                    pz_obsvr_get_info_size );
extern INT32 x_mux_util_rec_obsvr_set( HANDLE_T                   h_handle ,
                                              MUX_UTIL_OBSVR_SET_TYPE   e_obsvr_set_type,
                                              VOID*                      pv_obsvr_set_info,
                                              SIZE_T                     z_obsvr_set_info_size );
extern INT32 x_mux_util_rec_obsvr_close( HANDLE_T  h_handle );


extern INT32 x_mux_util_rec_open( MUX_UTIL_REC_CONFIG_T* pt_mu_rec_cfg,
                                       HANDLE_T*              ph_handle );

extern INT32 x_mux_util_rec_start ( HANDLE_T  h_handle );

extern INT32 x_mux_util_rec_stop ( HANDLE_T  h_handle );

extern INT32 x_mux_util_rec_get  ( HANDLE_T                h_handle,
                                MUX_UTIL_REC_GET_TYPE   e_rec_get_type,
                                VOID*                   pv_rec_get_info,
                                SIZE_T*                 pz_rec_get_info_size );
extern INT32 x_mux_util_rec_set   ( HANDLE_T               h_handle ,
                                MUX_UTIL_REC_SET_TYPE   e_rec_set_type,
                                VOID*                   pv_rec_set_info,
                                SIZE_T                  z_rec_set_info_size );
extern INT32 x_mux_util_rec_close ( HANDLE_T  h_handle );


#endif /*end of _X_MUX_UTIL_REC_OBSRVR_H_ */



