/* SPDX-License-Identifier: LGPL-2.1-only OR BSD-3-Clause */
/******************************************************************************
 *
 * This file is provided under a dual license.  When you use or
 * distribute this software, you may choose to be licensed under
 * version 2.1 of the GNU Lesser General Public License
 * ("LGPLv2.1 License") or BSD License.
 *
 * LGPLv2.1 License
 *
 * Copyright(C) 2019 MediaTek Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2.1 of the GNU Lesser General Public
 * License as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See https://www.gnu.org/licenses/old-licenses/lgpl-2.1.html for more
 * details.
 *
 * BSD LICENSE
 *
 * Copyright(C) 2019 MediaTek Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *  * Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *****************************************************************************/

/*-----------------------------------------------------------------------------
 * $RCSfile: x_sb_eng.h,v $
 * $Revision: #2 $
 * $Date: 2015/06/01 $
 * $Author: cheng.liu $
 * $CCRevision: /main/DTV_X_HQ_int/10 $
 * $SWAuthor: Justin Deng $
 * $MD5HEX: f8bd805e0bea4a94d30f8bbfa87d8a87 $
 *
 * Description:
 *         This header file contains SVL Builder specific
 *         definitions, which are shared with other modules.
 *---------------------------------------------------------------------------*/
#ifndef _X_SB_ENG_H_
#define _X_SB_ENG_H_

/*-----------------------------------------------------------------------------
                    include files
 ----------------------------------------------------------------------------*/
#include "u_svl.h"
#include "u_sb_eng.h"

#include "x_leakage_test.h"
/*-----------------------------------------------------------------------------
                    macros, defines, typedefs, enums
 ----------------------------------------------------------------------------*/


/*-----------------------------------------------------------------------------
                    functions declaraions
 ----------------------------------------------------------------------------*/

#define x_sb_mem_alloc(size)                        x_sb_lm_mem_alloc(size, __FILE__, __LINE__, __func__)  /**<sb memory alloc        */
#define x_sb_mem_free(pv_mem_block)                 x_sb_lm_mem_free(pv_mem_block)    /**<sb memory free        */        
#define x_sb_mem_realloc(pv_mem_block, z_size)      x_mem_realloc(pv_mem_block,z_size)    /**<sb memory reallocate */

INT32 x_sb_reg_engine(
    const CHAR*         ps_eng_name,
    SB_ENG_FCT_TBL_T*   pt_eng_fct_tbl);

VOID x_sb_base_ctrl_list_lock(VOID);

VOID x_sb_base_ctrl_list_unlock(VOID);

INT32 x_sb_get_bldr_data(
    HANDLE_T            h_builder_base,
    VOID**              ppv_bldr_data);

INT32 x_sb_activate_eng_task_basic(
    const CHAR*         ps_eng_name,
    BOOL                b_retry);

INT32 x_sb_activate_eng_task(
    const CHAR*         ps_eng_name);

INT32 x_sb_activate_eng_task_by_timer(
    const CHAR*         ps_eng_name);

INT32 x_sb_eng_cond_change_nfy(
    HANDLE_T            h_builder_base,
    SB_COND_T           e_sb_cond);

INT32 x_sb_eng_svl_sort_cmp (
    const SVL_REC_T*     pt_svl_rec_1,
    const SVL_REC_T*     pt_svl_rec_2,
    SVL_COMPARE_INFO_T   e_compare_info);

INT32 x_sb_eng_svl_search_cmp (
    const SVL_REC_T*     pt_svl_rec,
    const VOID*          pv_data_to_compare,
    SVL_COMPARE_INFO_T   e_compare_info);

VOID x_sb_set_secure_log(BOOL b_on);

BOOL x_sb_get_secure_log(VOID);

extern INT32 sb_find_eng_by_handle(
                HANDLE_T            h_builder,
                SB_ENG_CTRL_T**     ppt_eng);

#endif /* _X_SB_ENG_H_ */

