/* SPDX-License-Identifier: LGPL-2.1-only OR BSD-3-Clause */
/******************************************************************************
 *
 * This file is provided under a dual license.  When you use or
 * distribute this software, you may choose to be licensed under
 * version 2.1 of the GNU Lesser General Public License
 * ("LGPLv2.1 License") or BSD License.
 *
 * LGPLv2.1 License
 *
 * Copyright(C) 2019 MediaTek Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2.1 of the GNU Lesser General Public
 * License as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See https://www.gnu.org/licenses/old-licenses/lgpl-2.1.html for more
 * details.
 *
 * BSD LICENSE
 *
 * Copyright(C) 2019 MediaTek Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *  * Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *****************************************************************************/

/*-----------------------------------------------------------------------------
 * $RCSfile: x_sort_search.h,v $
 * $Revision: #1 $
 * $Date: 2015/05/29 $
 * $Author: brianpc.huang $
 *
 * Description: 
 *         This header file contains sorting and searching function API.
 *         
 *---------------------------------------------------------------------------*/

#ifndef _X_SORT_SEARCH_H_
#define _X_SORT_SEARCH_H_

/*---------------------------------------------------------------------------
                    include files
----------------------------------------------------------------------------*/

#include "u_sort_search.h"

/*-------------------------------------------------------------------------
                    functions declarations
 --------------------------------------------------------------------------*/

/*
  Quicksort function.
*/
                        
extern 
INT32 x_qsort
(
    VOID*            pv_array,
    SIZE_T           z_num_elem,
    SIZE_T           z_size_of_elem,
    x_sort_cmp_fct   pf_cmp_fct,
    VOID*            pv_opt_param
);

/*
  Binary search function.
*/
extern 
INT32 x_binary_search
(
    const VOID*      pv_array,
    SIZE_T           z_num_elem,
    SIZE_T           z_size_of_elem,
    x_search_cmp_fct pf_cmp_fct,
    const VOID*      pv_search_param,
    INT32            i4_idx,
    VOID*            pv_opt_param,
    INT32*           pi4_result
);

/*
  Binary search function with ability to specified the index to select
  an entry from among multiple entries with the same key.
*/
INT32 x_bin_search
(
    const VOID*      pv_array,
    SIZE_T           z_num_elem,
    SIZE_T           z_size_of_elem,
    x_search_cmp_fct pf_cmp_fct,
    const VOID*      pv_search_param,
    INT32            i4_idx,
    VOID*            pv_opt_param,
    INT32*           pi4_result,
    INT32*           pi4_lower_idx,
    INT32*           pi4_upper_idx
);

/*
  This function is only avaiable if -DDEBUG compiler flag is defined.
*/
extern
INT32  x_get_qsort_recur(VOID);


#endif /* _X_SORT_SEARCH_H_ */
