/* SPDX-License-Identifier: LGPL-2.1-only OR BSD-3-Clause */
/******************************************************************************
 *
 * This file is provided under a dual license.  When you use or
 * distribute this software, you may choose to be licensed under
 * version 2.1 of the GNU Lesser General Public License
 * ("LGPLv2.1 License") or BSD License.
 *
 * LGPLv2.1 License
 *
 * Copyright(C) 2019 MediaTek Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2.1 of the GNU Lesser General Public
 * License as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See https://www.gnu.org/licenses/old-licenses/lgpl-2.1.html for more
 * details.
 *
 * BSD LICENSE
 *
 * Copyright(C) 2019 MediaTek Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *  * Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *****************************************************************************/

/*-----------------------------------------------------------------------------
 * $RCSfile: x_version.h,v $
 * $Revision: #1 $
 * $Date: 2015/05/29 $
 * $Author: brianpc.huang $
 * $CCRevision: /main/DTV_X/DTV_X_HQ_int/18 $
 * $SWAuthor: Ben Tsai $
 * $MD5HEX: bfc5747cf2764dd90482fe2a2c6298d2 $
 *
 * Description:
 *         This header file contains Middleware startup definitions, which
 *         are exported.
 *---------------------------------------------------------------------------*/

#ifndef _X_VERSION_H_
#define _X_VERSION_H_

/*----------------------------------------------------------------------------*/
/*! @addtogroup groupMW_START
 *  @{
 */
/*----------------------------------------------------------------------------*/


/*-----------------------------------------------------------------------------
                    include files
-----------------------------------------------------------------------------*/

#include "x_common.h"


/*-----------------------------------------------------------------------------
                    functions declarations
 ----------------------------------------------------------------------------*/
/*------------------------------------------------------------------*/
/*! @brief This API will return a reference to the zero terminated
 *         build name string.
 *  @param [in]     - None
 *  @param [out]    - None
 *  @return  Build name string.
 *  @retval      - None
 */
/*------------------------------------------------------------------*/
extern const CHAR* x_sys_get_build_name (VOID);

/*-----------------------------------------------------------------------------
  functions declarations
  ----------------------------------------------------------------------------*/
/*------------------------------------------------------------------*/
/*! @brief This API will return a reference to the zero terminated
 *         build name string.
 *  @param [in]     - None
 *  @param [out]    - None
 *  @return  Build name string.
 *  @retval      - None
 */
/*------------------------------------------------------------------*/
extern const CHAR* x_sys_get_build_cmd (VOID);
/*------------------------------------------------------------------*/
/*! @brief This API will return a reference to the zero terminated
 *         customer string.
 *  @param [in]     - None
 *  @param [out]    - None
 *  @return Customer string.
 *  @retval      - None
 */
/*------------------------------------------------------------------*/
extern const CHAR* x_sys_get_customer (VOID);

/*------------------------------------------------------------------*/
/*! @brief This API will return a reference to the zero terminated
 *         company string.
 *  @param [in]     - None
 *  @param [out]    - None
 *  @return Customer string.
 *  @retval      - None
 */
/*------------------------------------------------------------------*/
extern const CHAR* x_sys_get_company(VOID);


/*------------------------------------------------------------------*/
/*! @brief This API will return a reference to the zero terminated
 *         model name string.
 *  @param [in]     - None
 *  @param [out]    - None
 *  @return Model name string.
 *  @retval      - None
 */
/*------------------------------------------------------------------*/
extern const CHAR* x_sys_get_model_name (VOID);

/*------------------------------------------------------------------*/
/*! @brief This API will return a reference to the zero terminated
 *         version string.
 *  @param [in]     - None
 *  @param [out]    - None
 *  @return  Version string.
 *  @retval      - None
 */
/*------------------------------------------------------------------*/
extern const CHAR* x_sys_get_version (VOID);

/*------------------------------------------------------------------*/
/*! @brief This API will return a reference to the zero terminated
 *         customer version string. If there is no customer version
 *         return version string.
 *  @param [in]     - None
 *  @param [out]    - None
 *  @return Customer version string.
 *  @retval      - None
 */
/*------------------------------------------------------------------*/
extern const CHAR* x_sys_get_customer_version (VOID);

/*------------------------------------------------------------------*/
/*! @brief This API will return a reference to the zero terminated
 *         serial number string.
 *  @param [in]     - None
 *  @param [out]    - None
 *  @return Serial number string.
 *  @retval      - None
 */
/*------------------------------------------------------------------*/
extern const CHAR* x_sys_get_serial_number (VOID);

/*----------------------------------------------------------------------------*/
/*! @} */                                          /* end of groupMW_START */
/*----------------------------------------------------------------------------*/

#endif /* _X_VERSION_H_ */

