/* SPDX-License-Identifier: LGPL-2.1-only OR BSD-3-Clause */
/******************************************************************************
 *
 * This file is provided under a dual license.  When you use or
 * distribute this software, you may choose to be licensed under
 * version 2.1 of the GNU Lesser General Public License
 * ("LGPLv2.1 License") or BSD License.
 *
 * LGPLv2.1 License
 *
 * Copyright(C) 2019 MediaTek Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2.1 of the GNU Lesser General Public
 * License as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See https://www.gnu.org/licenses/old-licenses/lgpl-2.1.html for more
 * details.
 *
 * BSD LICENSE
 *
 * Copyright(C) 2019 MediaTek Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *  * Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *****************************************************************************/
/*-----------------------------------------------------------------------------
 * $RCSfile: wgl_special_char.h,v $
 * $Revision: #1 $
 * $Date: 2017/01/04 $
 * $Author: caoping.hu $
 * $CCRevision: /main/DTV_X_HQ_int/13 $
 * $SWAuthor: Iolo Tsai $
 * $MD5HEX:  $
 *
 * Description: 
 *         This header file contains public interfaces, constant and type 
 *         definitions of the Widget Library.
 *---------------------------------------------------------------------------*/

#ifndef _X_WGL_DBG_H_
#define _X_WGL_DBG_H_

/*debug tools*/
#ifdef _WGL_SETS_DEBUG

#define WGL_ASSERT( condition )                                             \
    {                                                                       \
        if (!(condition))                                                   \
        {                                                                   \
            DBG_ERROR(("\n File : %s, Line : %d ", __FILE__, __LINE__));     \
            DBG_ABORT(DBG_MOD_WGL);                                                 \
        }                                                                   \
    }
    
    #define WGL_DEBUG_CATCH_FAIL(ret_value)                                 \
            { if((i4_ret=(ret_value))<0) return i4_ret; }
#else

    #define WGL_ASSERT( condition )                                         \
        if (!(condition)) {;}
    
    #define WGL_DEBUG_CATCH_FAIL(ret_value)                                 \
            { if((i4_ret=(ret_value))<0) return i4_ret; }

#endif


#define WGL_CHECK_INTERNAL( inter_condition )                               \
    {                                                                       \
        if (!(inter_condition))                                             \
        {                                                                   \
			DBG_ERROR(("WGLR_INTERNAL_ERROR\n"));							\
            return WGLR_INTERNAL_ERROR;                                     \
        }                                                                   \
    }

#define WGL_CHECK_OK( ret_value )                                           \
    {                                                                       \
        if (ret_value ! WGLR_OK)                                            \
        {                                                                   \
            return ret_value;                                               \
        }                                                                   \
    }

#endif

