//***************************************************************************
//!file     si_drv_tx_simple.h
//!brief    SiI9687 Tx Simple Driver API functions.
//
// No part of this work may be reproduced, modified, distributed,
// transmitted, transcribed, or translated into any language or computer
// format, in any form or by any means without written permission of
// Silicon Image, Inc., 1060 East Arques Avenue, Sunnyvale, California 94085
//
// Copyright 2008-2010, Silicon Image, Inc.  All rights reserved.
//***************************************************************************/

#ifndef __SI_DRVTXSIMPLE_H__
#define __SI_DRVTXSIMPLE_H__
#include "si_drv_internal.h"

//------------------------------------------------------------------------------
//  Manifest Constants
//------------------------------------------------------------------------------

typedef enum
{
    SiiTX_MUTE_CHANGE      = 0x0001,
    SiiTX_CONNECT_CHANGE   = 0x0002,
    SiiTX_MUTE_ON          = 0x0004,
    SiiTX_MUTE_OFF         = 0x0008,
} TxSimpleStatusFlags_t;


//-------------------------------------------------------------------------------
//  Driver Function Prototypes
//-------------------------------------------------------------------------------

bool_t SiiDrvTxSimpleInitialize( void );

//------------------------------------------------------------------------------
// Function:    SiiTxSimpleStatus
// Description: Returns a status flag word containing TX0-specific
//              information about the state of the device.
// Parameters:  none
// Returns:     Sixteen-bit status flags word for the Tx0 Component
//------------------------------------------------------------------------------

uint16_t SiiDrvTxSimpleStatus ( void );

void SiiDrvTxSimpleMute( bool_t doMute );
void SiiDrvTxSimpleTmdsEnable( bool_t enable );
void SiiDrvTxSwingCtrl ( bool_t colorDepth );
void SiiDrvTxSimpleProcessInterrupts ( void );


#endif  // __SI_DRVTXSIMPLE_H__

