/* SPDX-License-Identifier: LGPL-2.1-only OR BSD-3-Clause */
/******************************************************************************
 *
 * This file is provided under a dual license.  When you use or
 * distribute this software, you may choose to be licensed under
 * version 2.1 of the GNU Lesser General Public License
 * ("LGPLv2.1 License") or BSD License.
 *
 * LGPLv2.1 License
 *
 * Copyright(C) 2019 MediaTek Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2.1 of the GNU Lesser General Public
 * License as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See https://www.gnu.org/licenses/old-licenses/lgpl-2.1.html for more
 * details.
 *
 * BSD LICENSE
 *
 * Copyright(C) 2019 MediaTek Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *  * Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *****************************************************************************/

/*-----------------------------------------------------------------------------
 *
 * $Author: chi.yu $
 * $Date: 2015/06/11 $
 * $RCSfile: dmx_pcr.h,v $
 * $Revision: #2 $
 *
 *---------------------------------------------------------------------------*/

/** @file dmx_pcr.h
 *  Brief of file dmx_pcr.h.
 *  Details of file dmx_pcr.h (optional).
 */

#ifndef DMX_PCR_H
#define DMX_PCR_H


//---------------------------------------------------------------------------
// Include files
//---------------------------------------------------------------------------

#include "x_typedef.h"


//---------------------------------------------------------------------------
// Type definitions
//---------------------------------------------------------------------------

#define DMX_PCR_INV_PIDIDX    0xff

// STC Log Mask
#define STC_DTV_CONN         (1 << 0)
#define STC_MMP_CONN         (1 << 1)
#define STC_SRC_VAL          (1 << 2)
#define STC_STC_VAL          (1 << 3)
#define STC_SET_VAL          (1 << 4)
#define STC_CTL_STACK        (1 << 5)
#define STC_SET_STACK        (1 << 6)
#define STC_PCR_LOOP         (1 << 7)
#define STC_PCR_MON          (1 << 8)
#define STC_PTS_DIFF         (1 << 9)


#define STC_COMM             ((STC_DTV_CONN) | (STC_MMP_CONN))

//---------------------------------------------------------------------------
// Inter-file functions
//---------------------------------------------------------------------------
extern void _DMX_PcrReInitHW(void);

extern void _DMX_PcrInit(void);

extern void _DMX_IntPcr(UINT32 u4Status);

extern BOOL STC_ChkStcStatusDrift(UINT8 u1StcId);

extern BOOL STC_ChkStcStatusValid(UINT8 u1StcId);
#if defined(CC_MAPLE_CUST_DRV)
extern void STC_SetSyncMode2(UINT8 ucStcId, UINT8 ucAdecId, UINT8 ucAdec2Id, UINT8 ucVdecId, UINT32 u4SyncMode);
#endif

#ifdef CC_53XX_SWDMX_V2 
EXTERN VOID STC_SoftwareStcISR(HANDLE_T  pt_tm_handle, VOID *pv_tag);
#endif
//---------------------------------------------------------------------------
// Public functions
//---------------------------------------------------------------------------


#endif    // DMX_PCR_H

