/*----------------------------------------------------------------------------*
 * No Warranty                                                                *
 * Except as may be otherwise agreed to in writing, no warranties of any      *
 * kind, whether express or implied, are given by MTK with respect to any MTK *
 * Deliverables or any use thereof, and MTK Deliverables are provided on an   *
 * "AS IS" basis.  MTK hereby expressly disclaims all such warranties,        *
 * including any implied warranties of merchantability, non-infringement and  *
 * fitness for a particular purpose and any warranties arising out of course  *
 * of performance, course of dealing or usage of trade.  Parties further      *
 * acknowledge that Company may, either presently and/or in the future,       *
 * instruct MTK to assist it in the development and the implementation, in    *
 * accordance with Company's designs, of certain softwares relating to        *
 * Company's product(s) (the "Services").  Except as may be otherwise agreed  *
 * to in writing, no warranties of any kind, whether express or implied, are  *
 * given by MTK with respect to the Services provided, and the Services are   *
 * provided on an "AS IS" basis.  Company further acknowledges that the       *
 * Services may contain errors, that testing is important and Company is      *
 * solely responsible for fully testing the Services and/or derivatives       *
 * thereof before they are used, sublicensed or distributed.  Should there be *
 * any third party action brought against MTK, arising out of or relating to  *
 * the Services, Company agree to fully indemnify and hold MTK harmless.      *
 * If the parties mutually agree to enter into or continue a business         *
 * relationship or other arrangement, the terms and conditions set forth      *
 * hereunder shall remain effective and, unless explicitly stated otherwise,  *
 * shall prevail in the event of a conflict in the terms in any agreements    *
 * entered into between the parties.                                          *
 *---------------------------------------------------------------------------*/
#ifndef _MSDC_BASIC_H_
#define _MSDC_BASIC_H_
#include "msdc_drv.h"

#define MSDC_STS_CHK_TIMEOUT    (1 * 60 * 1000)        /* 1 minute timeout */

/* status error report */
#define MSDC_ADDRESS_OUT_OF_RANGE   (1 << 31)
#define MSDC_ADDRESS_MISALIGN   	(1 << 30)
#define MSDC_BLOCK_LEN_ERROR   		(1 << 29)
#define MSDC_ERASE_SEQ_ERROR   		(1 << 28)
#define MSDC_ERASE_PARAM_ERROR   	(1 << 27)
#define MSDC_WP_VIOLATION   		(1 << 26)
#define MSDC_DEVICE_IS_LOCKED  		(1 << 25)
#define MSDC_LOCK_UNLOCK_FAILED  	(1 << 24)
#define MSDC_COM_CRC_ERROR   		(1 << 23)
#define MSDC_ILLEGAL_COMMAND   		(1 << 22)
#define MSDC_DEVICE_ECC_FAILED		(1 << 21)
#define MSDC_CC_ERROR   			(1 << 20)
#define MSDC_GENERIC_ERROR   		(1 << 19)
/* bit 17/18 is ignored in SPEC */
#define MSDC_CID_CSD_OVERWRITE		(1 << 16)
#define MSDC_WP_ERASE_SKIP   		(1 << 15)
/* bit 14 is ignored in SPEC */
#define MSDC_ERASE_RESET   			(1 << 13)
#define MSDC_READY_FOR_DATA			(1 << 8)
#define MSDC_SWITCH_ERROR  			(1 << 7)
#define MSDC_EXCEPTION_EVENT   		(1 << 6)
#define MSDC_APP_CMD		   		(1 << 5)


typedef struct __status_error__
{
	INT32 error_bit;
	char* error_str;
}status_error;

/* basic function in basic.c export */
extern VOID MsdcStopDMA(VOID);
extern INT32 MsdcWaitHostIdle(UINT32 timeout);
extern INT32 MsdcWaitClkStable(VOID);
extern INT32 MsdcReset(VOID);
extern INT32 MsdcClrFifo(VOID);
extern VOID MsdcChkFifo(VOID);
extern VOID MsdcClrIntr(VOID);
extern INT32 MsdcWaitIntr(UINT32 vector, UINT32 timeoutCnt, UINT32 waitMode);
extern INT32 MsdcErrorHandling(msdc_cmd *pCmd);
extern INT32 MsdcGetStatus(UINT32 *pBuff);
extern VOID MsdcFifoPathSelAndInit(VOID);
extern VOID MsdcDumpRegister(VOID);
extern VOID MsdcInfoInit(VOID);
extern VOID MsdcDescriptorConfig(VOID *pBuff, UINT32 u4BufLen);
extern INT32 MsdcReqDataStop(VOID);
extern VOID MsdcDrvSet(UINT32 CLK, UINT32 CMD, UINT32 DAT);
extern UINT32 MsdcDrvGet(UINT32 IDX);
extern int MsdcCheckEmmcTrans(void);

#if MSDC_AES_SUPPORT
extern void Msdc_AES_Open(void);
extern void Msdc_AES_Close(void);
extern void Msdc_AES_DEC_Switch(void);
extern void Msdc_AES_ENC_Switch(void);
extern void Msdc_AES_InitConfig(void);
extern void Msdc_AES_SetKey(void);
#endif
#endif // #ifndef _MSDC_BASIC_H_
