/* SPDX-License-Identifier: LGPL-2.1-only OR BSD-3-Clause */
/******************************************************************************
 *
 * This file is provided under a dual license.  When you use or
 * distribute this software, you may choose to be licensed under
 * version 2.1 of the GNU Lesser General Public License
 * ("LGPLv2.1 License") or BSD License.
 *
 * LGPLv2.1 License
 *
 * Copyright(C) 2019 MediaTek Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2.1 of the GNU Lesser General Public
 * License as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See https://www.gnu.org/licenses/old-licenses/lgpl-2.1.html for more
 * details.
 *
 * BSD LICENSE
 *
 * Copyright(C) 2019 MediaTek Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *  * Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *****************************************************************************/

#ifndef MTK_CUST_EEPROM_H
#define MTK_CUST_EEPROM_H
//#include "drv_default.h"
enum
{
	DRV_CUSTOM_EEPROM_START= DRVCUST_EEPROM_CUSTOM_DRIVER_OFFSET,
	EEP_PANEL_INDEX_OFFSET1= DRV_CUSTOM_EEPROM_START,
	EEP_PANEL_INDEX_OFFSET2,
	EEP_PANEL_INDEX_OFFSET3,
	EEP_PANEL_AUTO_DETECT,
	EEP_COUNTRY_OFFSET1,
	EEP_COUNTRY_OFFSET2,
	EEP_COUNTRY_OFFSET3,
	EEP_TUNER_TYPE_0,
	EEP_TUNER_TYPE_1,
	EEP_TUNER_TYPE_2,
	EEP_CEC_MENU_LANG_START,
	EEP_CEC_MENU_LANG_END= EEP_CEC_MENU_LANG_START + 4 -1 ,
	EEP_CEC_ENABLE,
	EEP_CEC_ONE_TOUCH_PLAY_ENABLE,
	EEP_HDMI_EDID_FORMAT_OFFSET_START,
	EEP_HDMI_EDID_FORMAT_OFFSET_END= EEP_HDMI_EDID_FORMAT_OFFSET_START +4 -1,
	EEP_HDMI_EDID_LDDP_OFFSET,
	EEP_VGA_EDID_INDEX_OFFSET,
	EEP_BRDCAST_SOURCE_OFFSET,                //Mingsheng 121009 add for demod warm/cool bootup refine 
	EEP_MHL_RCP_RECEIVE_ENABLE,//eggy add for cbus rcp receive
	EEP_HDMI_HPD_RTC_TOGGLE,
        EEP_HDMI_EARC_ENABLE,

	EEP_HOTKEY_WAKEUP_OFFSET = HOTKEY_WAKEUP_EEP_OFFSET,
	EEP_HOTKEY_WAKEUP_NUM = DRVCUST_EEPROM_CUSTOM_DRIVER_OFFSET + DRVCUST_EEPROM_CUSTOM_DRIVER_SIZE -1,
	DRV_CUSTOM_EEPROM_END = EEP_HOTKEY_WAKEUP_NUM 
	//don't add the eeprom here,please add before EEP_HOTKEY_WAKEUP_OFFSET
};
#ifndef PANEL_INDEX_OFFSET1
#define PANEL_INDEX_OFFSET1         EEP_PANEL_INDEX_OFFSET1
#endif

#ifndef PANEL_INDEX_OFFSET2
#define PANEL_INDEX_OFFSET2         EEP_PANEL_INDEX_OFFSET2
#endif

#ifndef PANEL_INDEX_OFFSET3
#define PANEL_INDEX_OFFSET3         EEP_PANEL_INDEX_OFFSET3
#endif

#ifndef PANEL_AUTO_DETECT_OFFSET
#define PANEL_AUTO_DETECT_OFFSET    EEP_PANEL_AUTO_DETECT
#endif

#ifndef EEPROM_COUNTRY_OFFSET1
#define EEPROM_COUNTRY_OFFSET1      EEP_COUNTRY_OFFSET1
#endif

#ifndef EEPROM_COUNTRY_OFFSET2
#define EEPROM_COUNTRY_OFFSET2      EEP_COUNTRY_OFFSET2
#endif

#ifndef EEPROM_COUNTRY_OFFSET3
#define EEPROM_COUNTRY_OFFSET3      EEP_COUNTRY_OFFSET3
#endif

#ifndef DEFAULT_TUNER_TYPE_OFST0
#define DEFAULT_TUNER_TYPE_OFST0    EEP_TUNER_TYPE_0
#endif
#ifndef DEFAULT_TUNER_TYPE_OFST1
#define DEFAULT_TUNER_TYPE_OFST1    EEP_TUNER_TYPE_1
#endif
#ifndef DEFAULT_TUNER_TYPE_OFST2
#define DEFAULT_TUNER_TYPE_OFST2    EEP_TUNER_TYPE_2
#endif

#ifndef EEPROM_CEC_MENU_LANGUAGE_OFFSET
#define EEPROM_CEC_MENU_LANGUAGE_OFFSET         (EEP_CEC_MENU_LANG_START)
#endif

#ifndef EEPROM_CEC_ENABLE_OFFSET 
#define EEPROM_CEC_ENABLE_OFFSET              (EEP_CEC_ENABLE)
#endif
#ifndef EEPROM_CEC_ONE_TOUCH_PLAY_ENABLE_OFFSET 
#define EEPROM_CEC_ONE_TOUCH_PLAY_ENABLE_OFFSET (EEP_CEC_ONE_TOUCH_PLAY_ENABLE)
#endif

#ifndef EEPROM_HDMI_EDID_FORMAT_OFFSET
#define EEPROM_HDMI_EDID_FORMAT_OFFSET      (EEP_HDMI_EDID_FORMAT_OFFSET_START)
#endif

#ifndef EEPROM_HDMI_EDID_LDDP_OFFSET
#define EEPROM_HDMI_EDID_LDDP_OFFSET        (EEP_HDMI_EDID_LDDP_OFFSET)
#endif

#ifndef EEPROM_VGA_EDID_INDEX_OFFSET
#define EEPROM_VGA_EDID_INDEX_OFFSET     (EEP_VGA_EDID_INDEX_OFFSET)
#endif

#ifndef EEPROM_BRDCAST_SOURCE_OFFSET1
#define EEPROM_BRDCAST_SOURCE_OFFSET1      EEP_BRDCAST_SOURCE_OFFSET
#endif

#ifndef EEPROM_MHL_RCP_RECEIVE_OFFSET
#define EEPROM_MHL_RCP_RECEIVE_OFFSET EEP_MHL_RCP_RECEIVE_ENABLE
#endif

#ifndef EEPROM_HDMI_HPD_RTC_TOGGLE_OFFSET
#define EEPROM_HDMI_HPD_RTC_TOGGLE_OFFSET EEP_HDMI_HPD_RTC_TOGGLE
#endif

#ifndef EEPROM_HDMI_EARC_ENABLE_OFFSET
#define EEPROM_HDMI_EARC_ENABLE_OFFSET EEP_HDMI_EARC_ENABLE
#endif

#endif /*MTK_CUST_EEPROM_H */

