#ifndef _HW_MJC_CORE_H_
#define _HW_MJC_CORE_H_
#include "x_hal_5381.h"

#ifndef CC_FPGA
#define IO_ADDR_OFST IO_VIRT
#else
#define IO_ADDR_OFST 0xf0000000
#endif

#define MEMC_MJC (IO_ADDR_OFST + 0x45000)

//Page DMA
#define MJC_RDMA00 (MEMC_MJC + 0x100)
    #define MJC_C_RDMA_Y_PITCH Fld(12,16,AC_MSKW32)//[27:16]
    #define MJC_C_RDMA_ALC_BLK Fld(1,13,AC_MSKB1)//[13:13]
    #define MJC_C_RDMA_ALC_BLK_CHRM_SWP Fld(1,12,AC_MSKB1)//[12:12]
    #define MJC_C_RDMA_10B_MODE Fld(1,10,AC_MSKB1)//[10:10]
    #define MJC_C_RDMA_10B_EN Fld(1,8,AC_MSKB1)//[8:8]
    #define MJC_C_RDMA_BLK_PITCH Fld(8,0,AC_FULLB0)//[7:0]
#define MJC_RDMA01 (MEMC_MJC + 0x104)
    #define MJC_C_RDMA_CR_PITCH Fld(12,16,AC_MSKW32)//[27:16]
    #define MJC_C_RDMA_CB_PITCH Fld(12,0,AC_MSKW10)//[11:0]
#define MJC_RDMA02 (MEMC_MJC + 0x108)
    #define MJC_C_RDMA_RID_ULTRA Fld(1,30,AC_MSKB3)//[30:30]
    #define MJC_C_RDMA_RID_MODE Fld(1,29,AC_MSKB3)//[29:29]
    #define MJC_C_RDMA_RID_EN Fld(1,28,AC_MSKB3)//[28:28]
    #define MJC_C_RDMA_REQ_REST Fld(12,16,AC_MSKW32)//[27:16]
    #define MJC_C_RDMA_RQST_SIZE_M1 Fld(2,12,AC_MSKB1)//[13:12]
    #define MJC_C_RDMA_FIFO_SIZE_M1 Fld(3,8,AC_MSKB1)//[10:8]
    #define MJC_C_RDMA_REQ_STOP Fld(1,5,AC_MSKB0)//[5:5]
    #define MJC_C_RDMA_RESET Fld(1,4,AC_MSKB0)//[4:4]
    #define MJC_C_RDMA_PAT_MODE Fld(1,1,AC_MSKB0)//[1:1]
    #define MJC_C_RDMA_PAT_EN Fld(1,0,AC_MSKB0)//[0:0]
#define MJC_RDMA03 (MEMC_MJC + 0x10C)
    #define MJC_C_RDMA_SEP_BURST Fld(1,19,AC_MSKB2)//[19:19]
    #define MJC_C_RDMA_BURST_BND128B Fld(1,18,AC_MSKB2)//[18:18]
    #define MJC_C_RDMA_ULTRA_EN Fld(1,17,AC_MSKB2)//[17:17]
    #define MJC_C_RDMA_PREULTRA_EN Fld(1,16,AC_MSKB2)//[16:16]
    #define MJC_C_RDMA_PREULTRA_TH_HIGH_OFS Fld(3,12,AC_MSKB1)//[14:12]
    #define MJC_C_RDMA_ULTRA_TH_HIGH_OFS Fld(3,8,AC_MSKB1)//[10:8]
    #define MJC_C_RDMA_PREULTRA_TH_LOW_OFS Fld(3,4,AC_MSKB0)//[6:4]
    #define MJC_C_RDMA_ULTRA_TH_LOW Fld(3,0,AC_MSKB0)//[2:0]
#define MJC_RDMA_SLD00 (MEMC_MJC + 0x110)
    #define MJC_C_RDMA_CNTP_STA_CLR Fld(1,17,AC_MSKB2)//[17:17]
    #define MJC_C_RDMA_CNTP_STA_UPD Fld(1,16,AC_MSKB2)//[16:16]
    #define MJC_C_RDMA_SLOWDOWN_SHT Fld(3,12,AC_MSKB1)//[14:12]
    #define MJC_C_RDMA_SLOWDOWN_FORCE Fld(1,10,AC_MSKB1)//[10:10]
    #define MJC_C_RDMA_CNTP_INIT Fld(1,9,AC_MSKB1)//[9:9]
    #define MJC_C_RDMA_SLOWDOWN_INIT Fld(1,8,AC_MSKB1)//[8:8]
    #define MJC_C_RDMA_CNTP_ULTRA Fld(1,7,AC_MSKB0)//[7:7]
    #define MJC_C_RDMA_CNTP_PREULTRA Fld(1,6,AC_MSKB0)//[6:6]
    #define MJC_C_RDMA_TH_ULTRA Fld(1,5,AC_MSKB0)//[5:5]
    #define MJC_C_RDMA_TH_PREULTRA Fld(1,4,AC_MSKB0)//[4:4]
    #define MJC_C_RDMA_SLOWDOWN_EN Fld(1,1,AC_MSKB0)//[1:1]
    #define MJC_C_RDMA_CNTP_EN Fld(1,0,AC_MSKB0)//[0:0]
#define MJC_RDMA_SLD01 (MEMC_MJC + 0x114)
    #define MJC_C_RDMA_CNTP_STOP Fld(24,0,AC_MSKDW)//[23:0]
#define MJC_RDMA_SLD02 (MEMC_MJC + 0x118)
    #define MJC_C_RDMA_CNTP_TARGET Fld(24,0,AC_MSKDW)//[23:0]
#define MJC_RDMA_SLD03 (MEMC_MJC + 0x11C)
    #define MJC_C_RDMA_CNTP_WIN Fld(12,0,AC_MSKW10)//[11:0]
#define MJC_RDMA_DBG00 (MEMC_MJC + 0x130)
    #define MJC_C_RDMA_DEBUG_SEL_B Fld(5,8,AC_MSKB1)//[12:8]
    #define MJC_C_RDMA_DEBUG_SEL_A Fld(5,0,AC_MSKB0)//[4:0]
#define MJC_RDMA_DBG01 (MEMC_MJC + 0x138)
    #define MJC_C_RDMA_SW_SCRATCH_A Fld(32,0,AC_FULLDW)//[31:0]
#define MJC_RDMA_DBG02 (MEMC_MJC + 0x13C)
    #define MJC_C_RDMA_SW_SCRATCH_B Fld(32,0,AC_FULLDW)//[31:0]
#define MJC_RDMA_STA00 (MEMC_MJC + 0x140)
    #define MJC_STA_RDMA_AG_GRP_CNT Fld(2,28,AC_MSKB3)//[29:28]
    #define MJC_STA_RDMA_AG_BRST_CNT Fld(5,20,AC_MSKW32)//[24:20]
    #define MJC_STA_RDMA_AG_BLK_Y Fld(10,8,AC_MSKW21)//[17:8]
    #define MJC_STA_RDMA_AG_BLK_X Fld(5,0,AC_MSKB0)//[4:0]
#define MJC_RDMA_STA01 (MEMC_MJC + 0x144)
    #define MJC_STA_RDMA_AG_GRP_CNT_D1 Fld(2,28,AC_MSKB3)//[29:28]
    #define MJC_STA_RDMA_AG_BRST_CNT_D1 Fld(5,20,AC_MSKW32)//[24:20]
    #define MJC_STA_RDMA_AG_BLK_Y_D1 Fld(10,8,AC_MSKW21)//[17:8]
    #define MJC_STA_RDMA_AG_BLK_X_D1 Fld(5,0,AC_MSKB0)//[4:0]
#define MJC_RDMA_STA02 (MEMC_MJC + 0x148)
    #define MJC_STA_RDMA_FFW_GRP_CNT Fld(2,28,AC_MSKB3)//[29:28]
    #define MJC_STA_RDMA_FFW_BRST_CNT Fld(5,20,AC_MSKW32)//[24:20]
    #define MJC_STA_RDMA_FFW_BLK_Y Fld(10,8,AC_MSKW21)//[17:8]
    #define MJC_STA_RDMA_FFW_BLK_X Fld(5,0,AC_MSKB0)//[4:0]
#define MJC_RDMA_STA03 (MEMC_MJC + 0x14C)
    #define MJC_STA_RDMA_EMI_BUSY Fld(1,9,AC_MSKB1)//[9:9]
    #define MJC_STA_RDMA_SLOWDOWN Fld(1,8,AC_MSKB1)//[8:8]
    #define MJC_STA_RDMA_MEM_STALL Fld(1,5,AC_MSKB0)//[5:5]
    #define MJC_STA_RDMA_FAKE_ALE_GEN Fld(1,4,AC_MSKB0)//[4:4]
    #define MJC_STA_RDMA_WAIT_DLE Fld(1,1,AC_MSKB0)//[1:1]
    #define MJC_STA_RDMA_DRAM_REQ Fld(1,0,AC_MSKB0)//[0:0]
#define MJC_RDMA_STA04 (MEMC_MJC + 0x150)
    #define MJC_STA_RDMA_PROC_CNT Fld(32,0,AC_FULLDW)//[31:0]
#define MJC_RDMA_STA05 (MEMC_MJC + 0x154)
    #define MJC_STA_RDMA_PROC_CNT_MAX Fld(32,0,AC_FULLDW)//[31:0]
#define MJC_RDMA_STA06 (MEMC_MJC + 0x158)
    #define MJC_STA_RDMA_PROC_CNT_MIN Fld(32,0,AC_FULLDW)//[31:0]
#define MJC_WDMA_0 (MEMC_MJC + 0x160)
    #define MJC_C_WDMA_DIS_WRSP Fld(1,24,AC_MSKB3)//[24:24]
    #define MJC_C_WDMA_ISSUE_REQ_TH Fld(6,16,AC_MSKB2)//[21:16]
    #define MJC_C_WDMA_ISSUE_OUTS_TH Fld(3,8,AC_MSKB1)//[10:8]
    #define MJC_C_WDMA_BUF_PRE_FULL_TH Fld(4,0,AC_MSKB0)//[3:0]
#define MJC_WDMA_1 (MEMC_MJC + 0x164)
    #define MJC_C_SPLIT_BURST_EN Fld(1,31,AC_MSKB3)//[31:31]
    #define MJC_C_SPLIT_BND128_EN Fld(1,30,AC_MSKB3)//[30:30]
    #define MJC_C_SPLIT_BND256_EN Fld(1,29,AC_MSKB3)//[29:29]
    #define MJC_C_WDMA_FRAME_PITCH Fld(13,16,AC_MSKW32)//[28:16]
    #define MJC_C_WDMA_OPT_SWAP_UV Fld(1,13,AC_MSKB1)//[13:13]
    #define MJC_C_WDMA_ENABLE Fld(1,12,AC_MSKB1)//[12:12]
    #define MJC_C_WDMA_SW_RST Fld(1,8,AC_MSKB1)//[8:8]
    #define MJC_C_WDMA_WARM_RST Fld(1,4,AC_MSKB0)//[4:4]
    #define MJC_C_WDMA_DEBUG_SEL Fld(4,0,AC_MSKB0)//[3:0]
#define MJC_WDMA_2 (MEMC_MJC + 0x168)
    #define MJC_C_WDMA_ULTRA_EN Fld(1,31,AC_MSKB3)//[31:31]
    #define MJC_C_WDMA_PREULTRA_EN Fld(1,30,AC_MSKB3)//[30:30]
    #define MJC_C_WDMA_PREULTRA_TH_L Fld(6,24,AC_MSKB3)//[29:24]
    #define MJC_C_WDMA_ULTRA_TH_L_OFS Fld(6,16,AC_MSKB2)//[21:16]
    #define MJC_C_WDMA_PREULTRA_TH_H_OFS Fld(6,8,AC_MSKB1)//[13:8]
    #define MJC_C_WDMA_ULTRA_TH_H_OFS Fld(6,0,AC_MSKB0)//[5:0]
#define MJC_WDMA_3 (MEMC_MJC + 0x16C)
    #define MJC_C_WDMA_10B_EN Fld(1,31,AC_MSKB3)//[31:31]
    #define MJC_C_WDMA_10B_MODE Fld(1,30,AC_MSKB3)//[30:30]
    #define MJC_C_WDMA_ISSUE_REQ_REST Fld(10,16,AC_MSKW32)//[25:16]
    #define MJC_C_WDMA_CRC_EN Fld(1,8,AC_MSKB1)//[8:8]
    #define MJC_C_WDMA_CRC_CLR Fld(7,0,AC_MSKB0)//[6:0]
#define MJC_WDMA_CRC0 (MEMC_MJC + 0x170)
    #define MJC_STA_WDMA_CRC_0 Fld(24,0,AC_MSKDW)//[23:0]
#define MJC_WDMA_CRC1 (MEMC_MJC + 0x174)
    #define MJC_STA_WDMA_CRC_1 Fld(24,0,AC_MSKDW)//[23:0]
#define MJC_WDMA_CRC2 (MEMC_MJC + 0x178)
    #define MJC_STA_WDMA_CRC_2 Fld(24,0,AC_MSKDW)//[23:0]
#define MJC_WDMA_CRC3 (MEMC_MJC + 0x17C)
    #define MJC_STA_WDMA_CRC_3 Fld(24,0,AC_MSKDW)//[23:0]
#define MJC_WDMA_CRC4 (MEMC_MJC + 0x180)
    #define MJC_STA_WDMA_CRC_4 Fld(24,0,AC_MSKDW)//[23:0]
#define MJC_WDMA_CRC5 (MEMC_MJC + 0x184)
    #define MJC_STA_WDMA_CRC_5 Fld(24,0,AC_MSKDW)//[23:0]
#define MJC_WDMA_CRC6 (MEMC_MJC + 0x188)
    #define MJC_STA_WDMA_CRC_6 Fld(24,0,AC_MSKDW)//[23:0]
#define MJC_WDMA_MON0 (MEMC_MJC + 0x18C)
    #define MJC_STA_WDMA_MON_0 Fld(32,0,AC_FULLDW)//[31:0]
#define MJC_WDMA_MON1 (MEMC_MJC + 0x190)
    #define MJC_STA_WDMA_MON_1 Fld(32,0,AC_FULLDW)//[31:0]
#define MJC_WDMA_MON2 (MEMC_MJC + 0x194)
    #define MJC_STA_WDMA_MON_2 Fld(32,0,AC_FULLDW)//[31:0]
#define MJC_WDMA_MON3 (MEMC_MJC + 0x198)
    #define MJC_STA_WDMA_MON_3 Fld(32,0,AC_FULLDW)//[31:0]
#define MJC_WDMA_MON4 (MEMC_MJC + 0x19C)
    #define MJC_STA_WDMA_MON_4 Fld(32,0,AC_FULLDW)//[31:0]
#define MJC_WDMA_MON5 (MEMC_MJC + 0x1A0)
    #define MJC_STA_WDMA_MON_5 Fld(32,0,AC_FULLDW)//[31:0]
#define MJC_STA_WDMA (MEMC_MJC + 0x1A4)
    #define MJC_STA_WDMA_WARM_RST_DONE Fld(1,0,AC_MSKB0)//[0:0]
#define MJC_DRAM_MV (MEMC_MJC + 0x1A8)
    #define MJC_C_DRAM_MVR_PRE_FW_EN Fld(1,30,AC_MSKB3)//[30:30]
    #define MJC_C_DRAM_MVR_ULTRA Fld(1,29,AC_MSKB3)//[29:29]
    #define MJC_C_DRAM_MVR_PREULTRA Fld(1,28,AC_MSKB3)//[28:28]
    #define MJC_C_DRAM_MVW_PRE_FW_EN Fld(1,26,AC_MSKB3)//[26:26]
    #define MJC_C_DRAM_MVW_ULTRA Fld(1,25,AC_MSKB3)//[25:25]
    #define MJC_C_DRAM_MVW_PREULTRA Fld(1,24,AC_MSKB3)//[24:24]
    #define MJC_STA_DRAM_MVR_BUSY Fld(1,1,AC_MSKB0)//[1:1]
    #define MJC_STA_DRAM_MVW_BUSY Fld(1,0,AC_MSKB0)//[0:0]
#define MJC_DMA_ATPG (MEMC_MJC + 0x1FC)
    #define MJC_DMA_ATPG_CT Fld(1,1,AC_MSKB0)//[1:1]
    #define MJC_DMA_ATPG_OB Fld(1,0,AC_MSKB0)//[0:0]

//Page FS
#define MJC_FS_00 (MEMC_MJC + 0xC00)
    #define MJC_FRAME_START Fld(1,31,AC_MSKB3)//[31:31]
    #define MJC_PLD_CFG_OK Fld(1,30,AC_MSKB3)//[30:30]
    #define MJC_INIT_LOAD_EN Fld(1,29,AC_MSKB3)//[29:29]
    #define MJC_INIT_LOAD_MODE Fld(1,28,AC_MSKB3)//[28:28]
    #define MJC_PRELOAD_EN Fld(1,27,AC_MSKB3)//[27:27]
    #define MJC_PRELOAD_MODE Fld(1,26,AC_MSKB3)//[26:26]
    #define MJC_ACT_FILM_MODE Fld(1,9,AC_MSKB1)//[9:9]
    #define MJC_ACT_MC_2X_MODE Fld(1,8,AC_MSKB1)//[8:8]
    #define MJC_ACT_ME2_EN Fld(1,5,AC_MSKB0)//[5:5]
    #define MJC_ACT_ME3_EN Fld(1,4,AC_MSKB0)//[4:4]
    #define MJC_ACT_LR3D_INFO_OUT Fld(1,2,AC_MSKB0)//[2:2]
    #define MJC_PLD_LR3D_INFO_OUT Fld(1,1,AC_MSKB0)//[1:1]
    #define MJC_3D_MODE Fld(1,0,AC_MSKB0)//[0:0]
#define MJC_FS_01 (MEMC_MJC + 0xC04)
    #define MJC_ACT_MC_ORI_EN Fld(1,23,AC_MSKB2)//[23:23]
    #define MJC_PLD_ME_ONLY_MODE Fld(1,22,AC_MSKB2)//[22:22]
    #define MJC_ACT_ME_ONLY_MODE Fld(1,21,AC_MSKB2)//[21:21]
    #define MJC_PLD_RESCAN_FRM_EN Fld(1,20,AC_MSKB2)//[20:20]
    #define MJC_ACT_RESCAN_FRM_EN Fld(1,19,AC_MSKB2)//[19:19]
    #define MJC_PLD_PAIR_FIRST Fld(1,18,AC_MSKB2)//[18:18]
    #define MJC_ACT_PAIR_FIRST_DLY Fld(1,17,AC_MSKB2)//[17:17]
    #define MJC_ACT_PAIR_FIRST Fld(1,16,AC_MSKB2)//[16:16]
    #define MJC_ACT_INT_NUM2 Fld(5,9,AC_MSKB1)//[13:9]
    #define MJC_ACT_INT_NUM1 Fld(5,4,AC_MSKW10)//[8:4]
    #define MJC_ACT_INT_DEN Fld(4,0,AC_MSKB0)//[3:0]
#define MJC_FS_02 (MEMC_MJC + 0xC08)
    #define MJC_ACT_BGMV_KEEP Fld(1,8,AC_MSKB1)//[8:8]
    #define MJC_ACT_MVEXP_FLAG Fld(1,7,AC_MSKB0)//[7:7]
    #define MJC_PLD_ME_24_60_PREBI Fld(1,6,AC_MSKB0)//[6:6]
    #define MJC_ACT_ME_24_60_PREBI_DLY Fld(1,5,AC_MSKB0)//[5:5]
    #define MJC_ACT_ME_24_60_PREBI Fld(1,4,AC_MSKB0)//[4:4]
    #define MJC_ACT_ME_IDX_TOGGLE Fld(1,3,AC_MSKB0)//[3:3]
    #define MJC_ACT_ME_POS_OTHR_SEL Fld(2,1,AC_MSKB0)//[2:1]
    #define MJC_ACT_ME2_PAIR_FIRST Fld(1,0,AC_MSKB0)//[0:0]
#define MJC_FS_03 (MEMC_MJC + 0xC0C)
    #define MJC_ACT_MC2_NUM_RGN0 Fld(8,16,AC_FULLB2)//[23:16]
    #define MJC_ACT_MC1_NUM_RGN0 Fld(8,8,AC_FULLB1)//[15:8]
    #define MJC_ACT_MV1_NUM Fld(8,0,AC_FULLB0)//[7:0]
#define MJC_FS_04 (MEMC_MJC + 0xC10)
    #define MJC_ACT_MC1_NUM_RGN2 Fld(8,8,AC_FULLB1)//[15:8]
    #define MJC_ACT_MC1_NUM_RGN1 Fld(8,0,AC_FULLB0)//[7:0]
#define MJC_FS_05 (MEMC_MJC + 0xC14)
    #define MJC_ACT_MV2_NUM Fld(8,16,AC_FULLB2)//[23:16]
    #define MJC_ACT_MC2_NUM_RGN2 Fld(8,8,AC_FULLB1)//[15:8]
    #define MJC_ACT_MC2_NUM_RGN1 Fld(8,0,AC_FULLB0)//[7:0]
#define MJC_FS_06 (MEMC_MJC + 0xC18)
    #define MJC_SEQ_1ST_FRM Fld(1,28,AC_MSKB3)//[28:28]
    #define MJC_MV_READ_ZERO_TD Fld(1,27,AC_MSKB3)//[27:27]
    #define MJC_MV_READ_ZERO_BI Fld(1,26,AC_MSKB3)//[26:26]
    #define MJC_MV_READ_ZERO_CU Fld(1,25,AC_MSKB3)//[25:25]
    #define MJC_MV_READ_ZERO_PV Fld(1,24,AC_MSKB3)//[24:24]
    #define MJC_ACT_SCNCHG_FLG_EN Fld(1,22,AC_MSKB2)//[22:22]
    #define MJC_ACT_SCNCHG_FLG Fld(1,21,AC_MSKB2)//[21:21]
    #define MJC_ACT_APL_SCNCHG_FLG Fld(1,20,AC_MSKB2)//[20:20]
    #define MJC_ACT_DSR_OFST_MV_TF_PV Fld(4,16,AC_MSKB2)//[19:16]
    #define MJC_ACT_DSR_OFST_MV_TF_CU Fld(4,12,AC_MSKB1)//[15:12]
    #define MJC_ACT_DSR_OFST_MV_BI_TP Fld(4,8,AC_MSKB1)//[11:8]
    #define MJC_ACT_DSR_OFST_MV_OFF Fld(1,4,AC_MSKB0)//[4:4]
    #define MJC_PLD_DSR_PYE_OFST Fld(4,0,AC_MSKB0)//[3:0]
#define MJC_FS_07 (MEMC_MJC + 0xC1C)
    #define MJC_MV_BI_WR_ADR Fld(32,0,AC_FULLDW)//[31:0]
#define MJC_FS_08 (MEMC_MJC + 0xC20)
    #define MJC_MV_BI_RD_ADR Fld(32,0,AC_FULLDW)//[31:0]
#define MJC_FS_09 (MEMC_MJC + 0xC24)
    #define MJC_MV_CU_WR_ADR Fld(32,0,AC_FULLDW)//[31:0]
#define MJC_FS_0A (MEMC_MJC + 0xC28)
    #define MJC_MV_CU_RD_ADR Fld(32,0,AC_FULLDW)//[31:0]
#define MJC_FS_0B (MEMC_MJC + 0xC2C)
    #define MJC_MV_PV_RD_ADR Fld(32,0,AC_FULLDW)//[31:0]
#define MJC_FS_0C (MEMC_MJC + 0xC30)
    #define MJC_MV_TD_WR_ADR Fld(32,0,AC_FULLDW)//[31:0]
#define MJC_FS_0D (MEMC_MJC + 0xC34)
    #define MJC_MV_TD_RD_ADR Fld(32,0,AC_FULLDW)//[31:0]
#define MJC_FS_0F (MEMC_MJC + 0xC3C)
    #define MJC_WDMA_Y1_ADDR Fld(32,0,AC_FULLDW)//[31:0]
#define MJC_FS_10 (MEMC_MJC + 0xC40)
    #define MJC_WDMA_C1_ADDR Fld(32,0,AC_FULLDW)//[31:0]
#define MJC_FS_11 (MEMC_MJC + 0xC44)
    #define MJC_WDMA_Y2_ADDR Fld(32,0,AC_FULLDW)//[31:0]
#define MJC_FS_12 (MEMC_MJC + 0xC48)
    #define MJC_WDMA_C2_ADDR Fld(32,0,AC_FULLDW)//[31:0]
#define MJC_FS_13 (MEMC_MJC + 0xC4C)
    #define MJC_ACT_FB_Y1_ADDR Fld(32,0,AC_FULLDW)//[31:0]
#define MJC_FS_14 (MEMC_MJC + 0xC50)
    #define MJC_ACT_FB_C1_ADDR Fld(32,0,AC_FULLDW)//[31:0]
#define MJC_FS_15 (MEMC_MJC + 0xC54)
    #define MJC_ACT_FB_V1_ADDR Fld(32,0,AC_FULLDW)//[31:0]
#define MJC_FS_16 (MEMC_MJC + 0xC58)
    #define MJC_ACT_FB_Y2_ADDR Fld(32,0,AC_FULLDW)//[31:0]
#define MJC_FS_17 (MEMC_MJC + 0xC5C)
    #define MJC_ACT_FB_C2_ADDR Fld(32,0,AC_FULLDW)//[31:0]
#define MJC_FS_18 (MEMC_MJC + 0xC60)
    #define MJC_ACT_FB_V2_ADDR Fld(32,0,AC_FULLDW)//[31:0]
#define MJC_FS_19 (MEMC_MJC + 0xC64)
    #define MJC_ACT_FB_Y3_ADDR Fld(32,0,AC_FULLDW)//[31:0]
#define MJC_FS_1A (MEMC_MJC + 0xC68)
    #define MJC_PLD_FB_Y1_ADDR Fld(32,0,AC_FULLDW)//[31:0]
#define MJC_FS_1B (MEMC_MJC + 0xC6C)
    #define MJC_PLD_FB_C1_ADDR Fld(32,0,AC_FULLDW)//[31:0]
#define MJC_FS_1C (MEMC_MJC + 0xC70)
    #define MJC_PLD_FB_V1_ADDR Fld(32,0,AC_FULLDW)//[31:0]
#define MJC_FS_1D (MEMC_MJC + 0xC74)
    #define MJC_PLD_FB_Y2_ADDR Fld(32,0,AC_FULLDW)//[31:0]
#define MJC_FS_1E (MEMC_MJC + 0xC78)
    #define MJC_PLD_FB_C2_ADDR Fld(32,0,AC_FULLDW)//[31:0]
#define MJC_FS_1F (MEMC_MJC + 0xC7C)
    #define MJC_PLD_FB_V2_ADDR Fld(32,0,AC_FULLDW)//[31:0]
#define MJC_FS_20 (MEMC_MJC + 0xC80)
    #define MJC_PLD_FB_Y3_ADDR Fld(32,0,AC_FULLDW)//[31:0]
#define MJC_FS_21 (MEMC_MJC + 0xC84)
    #define MJC_CAL_FRAME_CYCLE_EN Fld(1,22,AC_MSKB2)//[22:22]
    #define MJC_STA_FRAME_CYCLE Fld(22,0,AC_MSKDW)//[21:0]
#define MJC_FS_22 (MEMC_MJC + 0xC88)
    #define MJC_PDWN_INTP_MC Fld(1,18,AC_MSKB2)//[18:18]
    #define MJC_PDWN_NYE_DATA Fld(1,17,AC_MSKB2)//[17:17]
    #define MJC_PDWN_CHROMA_DATA Fld(1,16,AC_MSKB2)//[16:16]
    #define MJC_CLK_ALWAYS_ON Fld(1,15,AC_MSKB1)//[15:15]
    #define MJC_CLK_OFF_DUR Fld(12,0,AC_MSKW10)//[11:0]
#define MJC_STA_FS_00 (MEMC_MJC + 0xC8C)
    #define MJC_STA_DSR_NYE_OFST Fld(6,4,AC_MSKW10)//[9:4]
    #define MJC_STA_DSR_PYE_OFST Fld(4,0,AC_MSKB0)//[3:0]
#define MJC_FS_24 (MEMC_MJC + 0xC90)
    #define MJC_FW_ACT_PBND_UP Fld(12,12,AC_MSKW21)//[23:12]
    #define MJC_FW_ACT_PBND_DN Fld(12,0,AC_MSKW10)//[11:0]
#define MJC_FS_25 (MEMC_MJC + 0xC94)
    #define MJC_FW_ACT_PBND_LF Fld(12,12,AC_MSKW21)//[23:12]
    #define MJC_FW_ACT_PBND_RT Fld(12,0,AC_MSKW10)//[11:0]
#define MJC_FS_26 (MEMC_MJC + 0xC98)
    #define MJC_ACT_LPB_FW_EN Fld(1,28,AC_MSKB3)//[28:28]
    #define MJC_FW_ACT_LPB_UP Fld(12,12,AC_MSKW21)//[23:12]
    #define MJC_FW_ACT_LPB_DN Fld(12,0,AC_MSKW10)//[11:0]
#define MJC_FS_27 (MEMC_MJC + 0xC9C)
    #define MJC_FW_ACT_LPB_LF Fld(12,12,AC_MSKW21)//[23:12]
    #define MJC_FW_ACT_LPB_RT Fld(12,0,AC_MSKW10)//[11:0]
#define MJC_FS_28 (MEMC_MJC + 0xCA0)
    #define MJC_ACT_DSR_OFST_MV_SEL_EN Fld(1,10,AC_MSKB1)//[10:10]
    #define MJC_ACT_DSR_OFST_MV_BI_WR_SEL Fld(2,8,AC_MSKB1)//[9:8]
    #define MJC_ACT_DSR_OFST_MV_BI_RD_SEL Fld(2,6,AC_MSKB0)//[7:6]
    #define MJC_ACT_DSR_OFST_MV_CU_WR_SEL Fld(2,4,AC_MSKB0)//[5:4]
    #define MJC_ACT_DSR_OFST_MV_CU_RD_SEL Fld(2,2,AC_MSKB0)//[3:2]
    #define MJC_ACT_DSR_OFST_MV_PV_RD_SEL Fld(2,0,AC_MSKB0)//[1:0]
#define MJC_FS_REV0 (MEMC_MJC + 0xCF0)
    #define MJC_FM_RESERVED0 Fld(32,0,AC_FULLDW)//[31:0]
#define MJC_FS_ATPG (MEMC_MJC + 0xCFC)
    #define MJC_FS_ATPG_OB Fld(1,1,AC_MSKB0)//[1:1]
    #define MJC_FS_ATPG_CT Fld(1,0,AC_MSKB0)//[0:0]

//Page MC
#define MJC_MC_00 (MEMC_MJC + 0x400)
    #define MJC_MC_BLOCK_PERIOD Fld(8,24,AC_FULLB3)//[31:24]
    #define MJC_MC_INTP_MODE_RGN2 Fld(6,16,AC_MSKB2)//[21:16]
    #define MJC_MC_INTP_MODE_RGN1 Fld(6,8,AC_MSKB1)//[13:8]
    #define MJC_MC_INTP_MODE_RGN0 Fld(6,0,AC_MSKB0)//[5:0]
#define MJC_MC_01 (MEMC_MJC + 0x404)
    #define MJC_MC_TRUE_RPT_MAN_PV Fld(1,31,AC_MSKB3)//[31:31]
    #define MJC_MC_TRUE_RPT_MAN_CU Fld(1,30,AC_MSKB3)//[30:30]
    #define MJC_LBOX_STA_OVM_EN Fld(1,27,AC_MSKB3)//[27:27]
    #define MJC_LBOX_STA_EN Fld(1,26,AC_MSKB3)//[26:26]
    #define MJC_TRUE_REPEAT Fld(1,25,AC_MSKB3)//[25:25]
    #define MJC_TRUE_REPEAT_AT_CHG Fld(1,24,AC_MSKB3)//[24:24]
    #define MJC_APL_DBG_EN Fld(1,19,AC_MSKB2)//[19:19]
    #define MJC_SCN_DBG_EN Fld(1,17,AC_MSKB2)//[17:17]
    #define MJC_MC_DBG_EN Fld(1,16,AC_MSKB2)//[16:16]
    #define MJC_MC_DBG_WIDTH Fld(4,12,AC_MSKB1)//[15:12]
    #define MJC_MC_FREEFUN Fld(1,9,AC_MSKB1)//[9:9]
    #define MJC_FORCE_MC_INTP Fld(1,8,AC_MSKB1)//[8:8]
    #define MJC_MC_INTP_NUM Fld(4,4,AC_MSKB0)//[7:4]
    #define MJC_MC_INTP_DEN Fld(4,0,AC_MSKB0)//[3:0]
#define MJC_MC_02 (MEMC_MJC + 0x408)
    #define MJC_GET_CURR_SEL Fld(1,31,AC_MSKB3)//[31:31]
    #define MJC_MC_OPINT_C_H_EN Fld(1,30,AC_MSKB3)//[30:30]
    #define MJC_MC_OPINT_C_V_EN Fld(1,29,AC_MSKB3)//[29:29]
    #define MJC_MC_OPINT_Y_H_EN Fld(1,28,AC_MSKB3)//[28:28]
    #define MJC_MC_OPINT_Y_V_EN Fld(1,27,AC_MSKB3)//[27:27]
    #define MJC_INTP_FMD_EN Fld(1,26,AC_MSKB3)//[26:26]
    #define MJC_INTP_RAW_DBG_EN Fld(1,25,AC_MSKB3)//[25:25]
    #define MJC_INTP_MIRROR_EN Fld(1,24,AC_MSKB3)//[24:24]
    #define MJC_INTP_MIX_EN Fld(1,21,AC_MSKB2)//[21:21]
    #define MJC_FRM_FBACK_EN_LFRT Fld(2,12,AC_MSKB1)//[13:12]
    #define MJC_MC_INTP_FBK Fld(4,8,AC_MSKB1)//[11:8]
#define MJC_MC_03 (MEMC_MJC + 0x40C)
    #define MJC_FORCE_STA_GAIN_VAL Fld(4,20,AC_MSKB2)//[23:20]
    #define MJC_FORCE_STA_GAIN_CLIP_EN Fld(1,17,AC_MSKB2)//[17:17]
    #define MJC_FORCE_STA_GAIN_EN Fld(1,16,AC_MSKB2)//[16:16]
    #define MJC_HQF_MODE_RGN2 Fld(2,4,AC_MSKB0)//[5:4]
    #define MJC_HQF_MODE_RGN1 Fld(2,2,AC_MSKB0)//[3:2]
    #define MJC_HQF_MODE_RGN0 Fld(2,0,AC_MSKB0)//[1:0]
#define MJC_MC_04 (MEMC_MJC + 0x410)
    #define MJC_LBOX_OFST_MODE Fld(4,24,AC_MSKB3)//[27:24]
    #define MJC_LBOX_OFST_LF_MAX Fld(4,20,AC_MSKB2)//[23:20]
    #define MJC_LBOX_OFST_UD_MAX Fld(4,16,AC_MSKB2)//[19:16]
    #define MJC_LBOX_OFST_LF_THR Fld(4,12,AC_MSKB1)//[15:12]
    #define MJC_LBOX_OFST_UD_THR Fld(4,8,AC_MSKB1)//[11:8]
    #define MJC_LBOX_OFST_LF_FIX Fld(4,4,AC_MSKB0)//[7:4]
    #define MJC_LBOX_OFST_UD_FIX Fld(4,0,AC_MSKB0)//[3:0]
#define MJC_MC_05 (MEMC_MJC + 0x414)
    #define MJC_UNI_MBG_FG_ONLY Fld(1,31,AC_MSKB3)//[31:31]
    #define MJC_UNI_MBG_EN Fld(1,30,AC_MSKB3)//[30:30]
    #define MJC_OVL_UNI_EN Fld(1,28,AC_MSKB3)//[28:28]
    #define MJC_OVL_UNI_SEL Fld(1,27,AC_MSKB3)//[27:27]
    #define MJC_UNI_MIRROR_OFF Fld(1,23,AC_MSKB2)//[23:23]
    #define MJC_MC_42A_ST_INTP_MD Fld(1,22,AC_MSKB2)//[22:22]
    #define MJC_MC_42A_WT_EN Fld(1,21,AC_MSKB2)//[21:21]
    #define MJC_CMX_WT_EN Fld(1,20,AC_MSKB2)//[20:20]
    #define MJC_FMD_WT_EN Fld(1,19,AC_MSKB2)//[19:19]
    #define MJC_OCC_WT_EN Fld(1,16,AC_MSKB2)//[16:16]
    #define MJC_MBG_ZRY_THR Fld(4,12,AC_MSKB1)//[15:12]
    #define MJC_MBG_ZRX_THR Fld(4,8,AC_MSKB1)//[11:8]
    #define MJC_OVL_WT_EN Fld(1,1,AC_MSKB0)//[1:1]
#define MJC_MC_06 (MEMC_MJC + 0x418)
    #define MJC_BK_STA_INFO_SEL Fld(4,28,AC_MSKB3)//[31:28]
    #define MJC_BK_GRID_EN Fld(1,20,AC_MSKB2)//[20:20]
    #define MJC_VDB_MV_GAIN Fld(2,16,AC_MSKB2)//[17:16]
    #define MJC_VDB_REV_SEL Fld(1,14,AC_MSKB1)//[14:14]
    #define MJC_VDB_SHOW_MV Fld(1,13,AC_MSKB1)//[13:13]
    #define MJC_VDB_IN_MV_PATH Fld(1,12,AC_MSKB1)//[12:12]
    #define MJC_VDB_INFO_SEL Fld(8,4,AC_MSKW10)//[11:4]
    #define MJC_VDB_MODU_SEL Fld(4,0,AC_MSKB0)//[3:0]
#define MJC_MC_07 (MEMC_MJC + 0x41C)
    #define MJC_VDB_V Fld(8,24,AC_FULLB3)//[31:24]
    #define MJC_VDB_U Fld(8,16,AC_FULLB2)//[23:16]
#define MJC_MC_08 (MEMC_MJC + 0x420)
    #define MJC_VDB_CODE_VAL Fld(16,16,AC_FULLW32)//[31:16]
    #define MJC_VDB_CODE_SEL Fld(8,8,AC_FULLB1)//[15:8]
    #define MJC_VDB_CODE_V_START Fld(4,4,AC_MSKB0)//[7:4]
    #define MJC_VDB_CODE_H_START Fld(4,0,AC_MSKB0)//[3:0]
#define MJC_MC_09 (MEMC_MJC + 0x424)
    #define MJC_CHR_INTP_SELF_MODE Fld(4,12,AC_MSKB1)//[15:12]
    #define MJC_CHR_INTP_SELF_EN Fld(1,8,AC_MSKB1)//[8:8]
    #define MJC_VDB_UV_EN Fld(1,3,AC_MSKB0)//[3:3]
    #define MJC_VDB_Y_EN Fld(1,2,AC_MSKB0)//[2:2]
    #define MJC_FORCE_NO_UV Fld(1,1,AC_MSKB0)//[1:1]
    #define MJC_FORCE_NO_Y Fld(1,0,AC_MSKB0)//[0:0]
#define MJC_MC_0A (MEMC_MJC + 0x428)
    #define MJC_FORCE_MV_MD2_EN Fld(1,29,AC_MSKB3)//[29:29]
    #define MJC_FORCE_MV_MD1_EN Fld(1,28,AC_MSKB3)//[28:28]
    #define MJC_FORCE_MVX Fld(10,16,AC_MSKW32)//[25:16]
    #define MJC_FORCE_MVY Fld(9,0,AC_MSKW10)//[8:0]
#define MJC_MC_0B (MEMC_MJC + 0x42C)
    #define MJC_DEMO_BAR_EN Fld(1,28,AC_MSKB3)//[28:28]
    #define MJC_SPLIT_MODE Fld(2,24,AC_MSKB3)//[25:24]
    #define MJC_SPLIT_BND_RT Fld(12,12,AC_MSKW21)//[23:12]
    #define MJC_SPLIT_BND_LF Fld(12,0,AC_MSKW10)//[11:0]
#define MJC_MC_0C (MEMC_MJC + 0x430)
    #define MJC_BAR_V Fld(8,24,AC_FULLB3)//[31:24]
    #define MJC_BAR_U Fld(8,16,AC_FULLB2)//[23:16]
    #define MJC_BAR_Y Fld(8,8,AC_FULLB1)//[15:8]
    #define MJC_BAR_WIDTH Fld(8,0,AC_FULLB0)//[7:0]
#define MJC_MC_0D (MEMC_MJC + 0x434)
    #define MJC_SPLIT_BND_DN Fld(12,12,AC_MSKW21)//[23:12]
    #define MJC_SPLIT_BND_UP Fld(12,0,AC_MSKW10)//[11:0]
#define MJC_MC_16 (MEMC_MJC + 0x454)
    #define MJC_MC_INTP_OSD Fld(6,24,AC_MSKB3)//[29:24]
    #define MJC_OSD_BOUND_RIGHT_0 Fld(12,12,AC_MSKW21)//[23:12]
    #define MJC_OSD_BOUND_LEFT_0 Fld(12,0,AC_MSKW10)//[11:0]
#define MJC_MC_17 (MEMC_MJC + 0x458)
    #define MJC_OLD_OSD_MASK Fld(1,25,AC_MSKB3)//[25:25]
    #define MJC_OSD_BAR_EN Fld(1,24,AC_MSKB3)//[24:24]
    #define MJC_OSD_BOUND_DOWN_0 Fld(12,12,AC_MSKW21)//[23:12]
    #define MJC_OSD_BOUND_UP_0 Fld(12,0,AC_MSKW10)//[11:0]
#define MJC_MC_18 (MEMC_MJC + 0x45C)
    #define MJC_OSD_BOUND_UP_2_11_4 Fld(8,24,AC_FULLB3)//[31:24]
    #define MJC_OSD_BOUND_RIGHT_1 Fld(12,12,AC_MSKW21)//[23:12]
    #define MJC_OSD_BOUND_LEFT_1 Fld(12,0,AC_MSKW10)//[11:0]
#define MJC_MC_19 (MEMC_MJC + 0x460)
    #define MJC_OSD_BOUND_DOWN_2_11_4 Fld(8,24,AC_FULLB3)//[31:24]
    #define MJC_OSD_BOUND_DOWN_1 Fld(12,12,AC_MSKW21)//[23:12]
    #define MJC_OSD_BOUND_UP_1 Fld(12,0,AC_MSKW10)//[11:0]
#define MJC_MC_1A (MEMC_MJC + 0x464)
    #define MJC_OSD_BOUND_DOWN_2 Fld(4,28,AC_MSKB3)//[31:28]
    #define MJC_OSD_BOUND_UP_2_3_0 Fld(4,24,AC_MSKB3)//[27:24]
    #define MJC_OSD_BOUND_RIGHT_2 Fld(12,12,AC_MSKW21)//[23:12]
    #define MJC_OSD_BOUND_LEFT_2 Fld(12,0,AC_MSKW10)//[11:0]
#define MJC_MC_1B (MEMC_MJC + 0x468)
    #define MJC_OSD_BOUND_UP_4_11_4 Fld(8,24,AC_FULLB3)//[31:24]
    #define MJC_OSD_BOUND_RIGHT_3 Fld(12,12,AC_MSKW21)//[23:12]
    #define MJC_OSD_BOUND_LEFT_3 Fld(12,0,AC_MSKW10)//[11:0]
#define MJC_MC_1C (MEMC_MJC + 0x46C)
    #define MJC_OSD_BOUND_DOWN_4_11_4 Fld(8,24,AC_FULLB3)//[31:24]
    #define MJC_OSD_BOUND_DOWN_3 Fld(12,12,AC_MSKW21)//[23:12]
    #define MJC_OSD_BOUND_UP_3 Fld(12,0,AC_MSKW10)//[11:0]
#define MJC_MC_1D (MEMC_MJC + 0x470)
    #define MJC_OSD_BOUND_DOWN_4 Fld(4,28,AC_MSKB3)//[31:28]
    #define MJC_OSD_BOUND_UP_4 Fld(4,24,AC_MSKB3)//[27:24]
    #define MJC_OSD_BOUND_RIGHT_4 Fld(12,12,AC_MSKW21)//[23:12]
    #define MJC_OSD_BOUND_LEFT_4 Fld(12,0,AC_MSKW10)//[11:0]
#define MJC_MC_1E (MEMC_MJC + 0x474)
    #define MJC_MC_MVX_BND_OFST_N Fld(4,25,AC_MSKB3)//[28:25]
    #define MJC_MC_MVX_BND_OFST_P Fld(4,20,AC_MSKB2)//[23:20]
    #define MJC_MC_MVY_BND_OFST_CU_N Fld(4,15,AC_MSKW21)//[18:15]
    #define MJC_MC_MVY_BND_OFST_CU_P Fld(4,10,AC_MSKB1)//[13:10]
    #define MJC_MC_MVY_BND_OFST_PV_N Fld(4,5,AC_MSKW10)//[8:5]
    #define MJC_MC_MVY_BND_OFST_PV_P Fld(4,0,AC_MSKB0)//[3:0]
#define MJC_MC_1F (MEMC_MJC + 0x478)
    #define MJC_MC_MVX_OUT_OFST_N Fld(5,25,AC_MSKB3)//[29:25]
    #define MJC_MC_MVX_OUT_OFST_P Fld(5,20,AC_MSKW32)//[24:20]
    #define MJC_MC_MVY_OUT_OFST_CU_N Fld(5,15,AC_MSKW21)//[19:15]
    #define MJC_MC_MVY_OUT_OFST_CU_P Fld(5,10,AC_MSKB1)//[14:10]
    #define MJC_MC_MVY_OUT_OFST_PV_N Fld(5,5,AC_MSKW10)//[9:5]
    #define MJC_MC_MVY_OUT_OFST_PV_P Fld(5,0,AC_MSKB0)//[4:0]
#define MJC_MC_LPB_0 (MEMC_MJC + 0x47C)
    #define MJC_LPB_LF_OFST Fld(12,16,AC_MSKW32)//[27:16]
    #define MJC_LPB_RT_OFST Fld(12,0,AC_MSKW10)//[11:0]
#define MJC_MC_LPB_1 (MEMC_MJC + 0x480)
    #define MJC_LPB_UP_OFST Fld(12,16,AC_MSKW32)//[27:16]
    #define MJC_LPB_DN_OFST Fld(12,0,AC_MSKW10)//[11:0]
#define MJC_MC_LPB_2 (MEMC_MJC + 0x484)
    #define MJC_LPB_LF_SKIP Fld(12,16,AC_MSKW32)//[27:16]
    #define MJC_LPB_RT_SKIP Fld(12,0,AC_MSKW10)//[11:0]
#define MJC_MC_LPB_3 (MEMC_MJC + 0x488)
    #define MJC_LPB_UP_SKIP Fld(12,16,AC_MSKW32)//[27:16]
    #define MJC_LPB_DN_SKIP Fld(12,0,AC_MSKW10)//[11:0]
#define MJC_MC_LPB_4 (MEMC_MJC + 0x48C)
    #define MJC_LPB_Y_THRES Fld(8,0,AC_FULLB0)//[7:0]
#define MJC_STA_LPB_0 (MEMC_MJC + 0x490)
    #define MJC_STA_LPB_UP_NX Fld(12,16,AC_MSKW32)//[27:16]
    #define MJC_STA_LPB_DN_NX Fld(12,0,AC_MSKW10)//[11:0]
#define MJC_STA_LPB_1 (MEMC_MJC + 0x494)
    #define MJC_STA_LPB_LF_NX Fld(12,16,AC_MSKW32)//[27:16]
    #define MJC_STA_LPB_RT_NX Fld(12,0,AC_MSKW10)//[11:0]
#define MJC_STA_LPB_2 (MEMC_MJC + 0x498)
    #define MJC_STA_LPB_UP_CU Fld(12,16,AC_MSKW32)//[27:16]
    #define MJC_STA_LPB_DN_CU Fld(12,0,AC_MSKW10)//[11:0]
#define MJC_STA_LPB_3 (MEMC_MJC + 0x49C)
    #define MJC_STA_LPB_LF_CU Fld(12,16,AC_MSKW32)//[27:16]
    #define MJC_STA_LPB_RT_CU Fld(12,0,AC_MSKW10)//[11:0]
#define MJC_STA_APL (MEMC_MJC + 0x4A0)
    #define MJC_STA_LPB_APL_NX Fld(16,16,AC_FULLW32)//[31:16]
    #define MJC_STA_LPB_APL_CU Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_MC_2B (MEMC_MJC + 0x4A8)
    #define MJC_BK_LR_SEL Fld(1,21,AC_MSKB2)//[21:21]
    #define MJC_BK_Y_SEL Fld(9,12,AC_MSKW21)//[20:12]
    #define MJC_BK_X_SEL Fld(9,0,AC_MSKW10)//[8:0]
#define MJC_STA_MC_0F (MEMC_MJC + 0x4AC)
    #define MJC_STA_BK_INFO Fld(32,0,AC_FULLDW)//[31:0]
#define MJC_MC_2C (MEMC_MJC + 0x4B0)
    #define MJC_MC_4TAP_COEF_A5 Fld(6,24,AC_MSKB3)//[29:24]
    #define MJC_MC_4TAP_COEF_A4 Fld(6,18,AC_MSKB2)//[23:18]
    #define MJC_MC_4TAP_COEF_A3 Fld(6,12,AC_MSKW21)//[17:12]
    #define MJC_MC_4TAP_COEF_A2 Fld(6,6,AC_MSKW10)//[11:6]
    #define MJC_MC_4TAP_COEF_A1 Fld(6,0,AC_MSKB0)//[5:0]
#define MJC_MC_2D (MEMC_MJC + 0x4B4)
    #define MJC_MC_4TAP_COEF_C2 Fld(8,24,AC_FULLB3)//[31:24]
    #define MJC_MC_4TAP_COEF_C1 Fld(8,16,AC_FULLB2)//[23:16]
    #define MJC_MC_4TAP_COEF_A7 Fld(6,6,AC_MSKW10)//[11:6]
    #define MJC_MC_4TAP_COEF_A6 Fld(6,0,AC_MSKB0)//[5:0]
#define MJC_MC_2E (MEMC_MJC + 0x4B8)
    #define MJC_MC_4TAP_COEF_C6 Fld(8,24,AC_FULLB3)//[31:24]
    #define MJC_MC_4TAP_COEF_C5 Fld(8,16,AC_FULLB2)//[23:16]
    #define MJC_MC_4TAP_COEF_C4 Fld(8,8,AC_FULLB1)//[15:8]
    #define MJC_MC_4TAP_COEF_C3 Fld(8,0,AC_FULLB0)//[7:0]
#define MJC_MC_2F (MEMC_MJC + 0x4BC)
    #define MJC_MC_FPR_R_EN Fld(1,24,AC_MSKB3)//[24:24]
    #define MJC_MC_FPR_L_EN Fld(1,23,AC_MSKB2)//[23:23]
    #define MJC_MC_FPR_IDX1_EN Fld(1,22,AC_MSKB2)//[22:22]
    #define MJC_MC_FPR_IDX0_EN Fld(1,21,AC_MSKB2)//[21:21]
    #define MJC_MC_FPR_LINE_SEL Fld(1,20,AC_MSKB2)//[20:20]
    #define MJC_MC_FPR_LINE_NUM Fld(12,8,AC_MSKW21)//[19:8]
    #define MJC_MC_4TAP_COEF_C7 Fld(8,0,AC_FULLB0)//[7:0]
#define MJC_MC_ATPG (MEMC_MJC + 0x4FC)
    #define MJC_MC_BAK_UP Fld(30,2,AC_MSKDW)//[31:2]
    #define MJC_MC_ATPG_CT Fld(1,1,AC_MSKB0)//[1:1]
    #define MJC_MC_ATPG_OB Fld(1,0,AC_MSKB0)//[0:0]

//Page ME_1
#define MJC_ME_00 (MEMC_MJC + 0x200)
    #define MJC_ME_ADAP_WDV_BLK Fld(1,31,AC_MSKB3)//[31:31]
    #define MJC_ME_WDV_BLK Fld(1,30,AC_MSKB3)//[30:30]
    #define MJC_FORCE_POS_SHFT_EN Fld(1,29,AC_MSKB3)//[29:29]
    #define MJC_SCNCHG_MODE_3D Fld(1,28,AC_MSKB3)//[28:28]
    #define MJC_BEC_SAD_TH Fld(15,8,AC_MSKW21)//[22:8]
    #define MJC_BEC_BLK_TH Fld(3,4,AC_MSKB0)//[6:4]
#define MJC_ME_01 (MEMC_MJC + 0x204)
    #define MJC_SAD_YC_MIX_SEL Fld(2,30,AC_MSKB3)//[31:30]
    #define MJC_VAR_COR_TH Fld(4,24,AC_MSKB3)//[27:24]
    #define MJC_SAD_COR_TH Fld(4,20,AC_MSKB2)//[23:20]
    #define MJC_ZEROMV_SAD_TH Fld(15,0,AC_MSKW10)//[14:0]
#define MJC_ME_02 (MEMC_MJC + 0x208)
    #define MJC_SCNCHG_ZR_EN Fld(1,31,AC_MSKB3)//[31:31]
    #define MJC_SCNCHG_FRST_LTCH_EN Fld(1,30,AC_MSKB3)//[30:30]
    #define MJC_SCNCHG_MTHD Fld(2,28,AC_MSKB3)//[29:28]
    #define MJC_VAR_COR_SEL Fld(1,27,AC_MSKB3)//[27:27]
    #define MJC_SAD_COR_SEL Fld(1,26,AC_MSKB3)//[26:26]
    #define MJC_MV_RMP_EN Fld(1,25,AC_MSKB3)//[25:25]
    #define MJC_SCNCHG_EN Fld(1,24,AC_MSKB3)//[24:24]
    #define MJC_SCNCHG_SEL_TH Fld(24,0,AC_MSKDW)//[23:0]
#define MJC_ME_03 (MEMC_MJC + 0x20C)
    #define MJC_ZERO_SAD_PENLTY Fld(8,24,AC_FULLB3)//[31:24]
    #define MJC_RAND_SAD_PENLTY Fld(8,16,AC_FULLB2)//[23:16]
    #define MJC_TMPR_SAD_PENLTY_S Fld(8,8,AC_FULLB1)//[15:8]
    #define MJC_SPAT_SAD_PENLTY Fld(8,0,AC_FULLB0)//[7:0]
#define MJC_ME_04 (MEMC_MJC + 0x210)
    #define MJC_BD_ZERO_SAD_PENLTY Fld(8,24,AC_FULLB3)//[31:24]
    #define MJC_BD_RAND_SAD_PENLTY Fld(8,16,AC_FULLB2)//[23:16]
    #define MJC_BD_TMPR_SAD_PENLTY Fld(8,8,AC_FULLB1)//[15:8]
    #define MJC_BD_SPAT_SAD_PENLTY Fld(8,0,AC_FULLB0)//[7:0]
#define MJC_ME_05 (MEMC_MJC + 0x214)
    #define MJC_TMPR_2ND_PENLTY_S Fld(8,24,AC_FULLB3)//[31:24]
    #define MJC_SMOOTH_SAD_PENLTY Fld(8,16,AC_FULLB2)//[23:16]
    #define MJC_SMOOTH_TH Fld(15,0,AC_MSKW10)//[14:0]
#define MJC_ME_06 (MEMC_MJC + 0x218)
    #define MJC_ME_BND_DOWN Fld(8,24,AC_FULLB3)//[31:24]
    #define MJC_ME_BND_UP Fld(8,16,AC_FULLB2)//[23:16]
    #define MJC_ME_BND_RIGHT Fld(8,8,AC_FULLB1)//[15:8]
    #define MJC_ME_BND_LEFT Fld(8,0,AC_FULLB0)//[7:0]
#define MJC_ME_07 (MEMC_MJC + 0x21C)
    #define MJC_SCNCHG_SEL Fld(1,31,AC_MSKB3)//[31:31]
    #define MJC_SCNCHG_TH1 Fld(3,28,AC_MSKB3)//[30:28]
    #define MJC_SCNCHG_TH2 Fld(3,24,AC_MSKB3)//[26:24]
    #define MJC_SCNCHG_TH3 Fld(24,0,AC_MSKDW)//[23:0]
#define MJC_ME_08 (MEMC_MJC + 0x220)
    #define MJC_SCNCHG_TH4 Fld(24,0,AC_MSKDW)//[23:0]
#define MJC_ME_09 (MEMC_MJC + 0x224)
    #define MJC_ME2_STIL_MV_PNLTY_TH Fld(5,19,AC_MSKB2)//[23:19]
    #define MJC_ME2_STIL_MV_PNLTY_GAIN Fld(3,16,AC_MSKB2)//[18:16]
    #define MJC_SMOOTH_BLK_TH Fld(4,12,AC_MSKB1)//[15:12]
    #define MJC_ME_MVPNLTY_SEL Fld(4,8,AC_MSKB1)//[11:8]
    #define MJC_MV_PNLTY_BLKTH Fld(4,4,AC_MSKB0)//[7:4]
    #define MJC_ZERO_SAD_BLKTH Fld(4,0,AC_MSKB0)//[3:0]
#define MJC_ME_0A (MEMC_MJC + 0x228)
    #define MJC_HLR_BND_V Fld(8,24,AC_FULLB3)//[31:24]
    #define MJC_TMPR_BLK_TH Fld(4,16,AC_MSKB2)//[19:16]
    #define MJC_TMPR_SAD_PENLTY_M Fld(8,8,AC_FULLB1)//[15:8]
    #define MJC_TMPR_2ND_PENLTY_M Fld(8,0,AC_FULLB0)//[7:0]
#define MJC_ME_0B (MEMC_MJC + 0x22C)
    #define MJC_HLR_FG_V_TH Fld(8,8,AC_FULLB1)//[15:8]
    #define MJC_HLR_FG_H_TH Fld(8,0,AC_FULLB0)//[7:0]
#define MJC_ME_0C (MEMC_MJC + 0x230)
    #define MJC_LBOX_LR_ACT_TH Fld(8,24,AC_FULLB3)//[31:24]
    #define MJC_LBOX_UD_ACT_TH Fld(8,16,AC_FULLB2)//[23:16]
    #define MJC_HLR_BG_V_TH Fld(8,8,AC_FULLB1)//[15:8]
    #define MJC_HLR_BG_H_TH Fld(8,0,AC_FULLB0)//[7:0]
#define MJC_ME_0D (MEMC_MJC + 0x234)
    #define MJC_SCNCHG_APL_FRM_CNT Fld(8,24,AC_FULLB3)//[31:24]
    #define MJC_ADAP_GAIN_ZB_AREA_TH2 Fld(3,17,AC_MSKB2)//[19:17]
    #define MJC_LBOX_CAND_EN Fld(1,16,AC_MSKB2)//[16:16]
    #define MJC_ADAP_GAIN_ZB_AREA_TH Fld(8,0,AC_FULLB0)//[7:0]
#define MJC_ME_0E (MEMC_MJC + 0x238)
    #define MJC_SCNCHG_APL_TH_2 Fld(16,16,AC_FULLW32)//[31:16]
    #define MJC_SCNCHG_APL_TH Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_ME_0F (MEMC_MJC + 0x23C)
    #define MJC_ME_RESERVED1 Fld(31,1,AC_MSKDW)//[31:1]
    #define MJC_ME3_FIN_SCNCHG_OPT Fld(1,0,AC_MSKB0)//[0:0]
#define MJC_ME_10 (MEMC_MJC + 0x240)
    #define MJC_GMV_PENLTY Fld(8,24,AC_FULLB3)//[31:24]
    #define MJC_EDGEV_PENALTY_MED_TH Fld(7,16,AC_MSKB2)//[22:16]
    #define MJC_ME_LPF_EDGE_TH Fld(8,8,AC_FULLB1)//[15:8]
#define MJC_ME_12 (MEMC_MJC + 0x248)
    #define MJC_ME_RESERVED2 Fld(32,0,AC_FULLDW)//[31:0]
#define MJC_ME_13 (MEMC_MJC + 0x24C)
    #define MJC_ME_RESERVED3 Fld(32,0,AC_FULLDW)//[31:0]
#define MJC_ME_14 (MEMC_MJC + 0x250)
    #define MJC_ME_RESERVED4 Fld(32,0,AC_FULLDW)//[31:0]
#define MJC_ME_15 (MEMC_MJC + 0x254)
    #define MJC_ME_RESERVED5 Fld(32,0,AC_FULLDW)//[31:0]
#define MJC_ME_16 (MEMC_MJC + 0x258)
    #define MJC_MIN_BLK_SAD_TH Fld(15,16,AC_MSKW32)//[30:16]
    #define MJC_ZEROMV_SAD_TH2 Fld(15,0,AC_MSKW10)//[14:0]
#define MJC_ME_17 (MEMC_MJC + 0x25C)
    #define MJC_SMOOTH_STA_TH2 Fld(15,16,AC_MSKW32)//[30:16]
    #define MJC_SMOOTH_STA_TH Fld(15,0,AC_MSKW10)//[14:0]
#define MJC_ME_18 (MEMC_MJC + 0x260)
    #define MJC_MVMED_NZBLK_SEL Fld(3,28,AC_MSKB3)//[30:28]
    #define MJC_MV_PNLTY_RNG Fld(4,24,AC_MSKB3)//[27:24]
    #define MJC_MV_PNLTY_BLKTH2 Fld(4,20,AC_MSKB2)//[23:20]
    #define MJC_MV_PNLTY_EG_TH Fld(4,16,AC_MSKB2)//[19:16]
    #define MJC_EDGE_PENALTY_FM_TH Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_ME_19 (MEMC_MJC + 0x264)
    #define MJC_NOZERO_MV_EN Fld(2,30,AC_MSKB3)//[31:30]
    #define MJC_FG_HLR_TYPE Fld(3,27,AC_MSKB3)//[29:27]
    #define MJC_HLR_SEL Fld(2,25,AC_MSKB3)//[26:25]
    #define MJC_HLR_EN Fld(1,24,AC_MSKB3)//[24:24]
    #define MJC_HLR_BND_H Fld(8,16,AC_FULLB2)//[23:16]
    #define MJC_HLR_TH_H Fld(8,8,AC_FULLB1)//[15:8]
    #define MJC_HLR_TH_V Fld(8,0,AC_FULLB0)//[7:0]
#define MJC_ME_1A (MEMC_MJC + 0x268)
    #define MJC_ME_STIL_SAD_TH Fld(8,24,AC_FULLB3)//[31:24]
    #define MJC_ME_STIL_LBOX_EN Fld(1,23,AC_MSKB2)//[23:23]
    #define MJC_ME_STIL_ZP_OFF Fld(1,22,AC_MSKB2)//[22:22]
    #define MJC_ME_STIL_BLKTH_EN Fld(1,19,AC_MSKB2)//[19:19]
    #define MJC_ME_STIL_EG_OFF Fld(1,18,AC_MSKB2)//[18:18]
    #define MJC_VLRG_NZMV_EN Fld(1,17,AC_MSKB2)//[17:17]
    #define MJC_ADAP_NZMV_EN Fld(1,16,AC_MSKB2)//[16:16]
    #define MJC_NZMV_TH1 Fld(8,8,AC_FULLB1)//[15:8]
    #define MJC_NZMV_TH2 Fld(8,0,AC_FULLB0)//[7:0]
#define MJC_ME_1B (MEMC_MJC + 0x26C)
    #define MJC_EDGEH_WDBLK Fld(1,31,AC_MSKB3)//[31:31]
    #define MJC_EDGEV_WDBLK Fld(1,30,AC_MSKB3)//[30:30]
    #define MJC_EDGEV_OFF Fld(1,28,AC_MSKB3)//[28:28]
    #define MJC_CHROMA_EDGE_PENALTY_OFF Fld(1,27,AC_MSKB3)//[27:27]
    #define MJC_EDGE_PENALTY_SEL Fld(3,24,AC_MSKB3)//[26:24]
    #define MJC_EDGE_PENALTY_TH1 Fld(8,8,AC_FULLB1)//[15:8]
    #define MJC_EDGE_PENALTY_TH2 Fld(8,0,AC_FULLB0)//[7:0]
#define MJC_ME_1C (MEMC_MJC + 0x270)
    #define MJC_SMOOTH_BLK_TH2 Fld(4,28,AC_MSKB3)//[31:28]
    #define MJC_SMOOTH_RNG Fld(4,24,AC_MSKB3)//[27:24]
    #define MJC_SMOOTH_SAD_PENLTY2 Fld(8,16,AC_FULLB2)//[23:16]
    #define MJC_SMOOTH_TH2 Fld(15,0,AC_MSKW10)//[14:0]
#define MJC_ME_1D (MEMC_MJC + 0x274)
    #define MJC_ME_LPF_WD Fld(1,31,AC_MSKB3)//[31:31]
    #define MJC_EDGE_PENALTY_MED_TH Fld(7,24,AC_MSKB3)//[30:24]
    #define MJC_HLR_GMV_PRTC_OFF Fld(1,23,AC_MSKB2)//[23:23]
    #define MJC_EDGE0_STA_TH Fld(7,16,AC_MSKB2)//[22:16]
    #define MJC_HLR_GMV_TH_H Fld(8,8,AC_FULLB1)//[15:8]
    #define MJC_HLR_GMV_TH_V Fld(8,0,AC_FULLB0)//[7:0]
#define MJC_ME_1E (MEMC_MJC + 0x278)
    #define MJC_ME_LPF_SEL Fld(1,30,AC_MSKB3)//[30:30]
    #define MJC_ZERO_SMOOTH_PNLTY_EN Fld(2,28,AC_MSKB3)//[29:28]
    #define MJC_ADAP_GAIN_SEL_X Fld(2,26,AC_MSKB3)//[27:26]
    #define MJC_ADAP_GAIN_SEL_Y Fld(2,24,AC_MSKB3)//[25:24]
    #define MJC_ADAP_GAIN_MVEQ_TH Fld(8,16,AC_FULLB2)//[23:16]
    #define MJC_ADAP_GAIN_ZB_TH Fld(15,0,AC_MSKW10)//[14:0]
#define MJC_ME_1F (MEMC_MJC + 0x27C)
    #define MJC_BND_HLR_TH_H Fld(8,24,AC_FULLB3)//[31:24]
    #define MJC_BND_HLR_TH_V Fld(8,16,AC_FULLB2)//[23:16]
    #define MJC_BND_HLR_GMV_TH_H Fld(8,8,AC_FULLB1)//[15:8]
    #define MJC_BND_HLR_GMV_TH_V Fld(8,0,AC_FULLB0)//[7:0]
#define MJC_ME_20 (MEMC_MJC + 0x280)
    #define MJC_ADAP_GAIN_EG_RNG Fld(8,24,AC_FULLB3)//[31:24]
    #define MJC_ADAP_GAIN_EG_TH2 Fld(8,16,AC_FULLB2)//[23:16]
    #define MJC_ME_3FRM_SEL_SAD_TH Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_ME_21 (MEMC_MJC + 0x284)
    #define MJC_ADAP_OCC_OTHR_SEL_V_EN Fld(1,22,AC_MSKB2)//[22:22]
    #define MJC_ADAP_OCC_OTHR_SEL Fld(2,20,AC_MSKB2)//[21:20]
    #define MJC_HLR_OTHR_SEL Fld(2,18,AC_MSKB2)//[19:18]
    #define MJC_BND_NZMV_EN Fld(1,16,AC_MSKB2)//[16:16]
    #define MJC_BND_NZMV_UP_BND Fld(4,12,AC_MSKB1)//[15:12]
    #define MJC_BND_NZMV_DN_BND Fld(4,8,AC_MSKB1)//[11:8]
    #define MJC_BND_NZMV_LF_BND Fld(4,4,AC_MSKB0)//[7:4]
    #define MJC_BND_NZMV_RT_BND Fld(4,0,AC_MSKB0)//[3:0]
#define MJC_ME_22 (MEMC_MJC + 0x288)
    #define MJC_ME_3FRM_HLR_TH_H Fld(8,24,AC_FULLB3)//[31:24]
    #define MJC_ME_3FRM_HLR_TH_V Fld(8,16,AC_FULLB2)//[23:16]
    #define MJC_VLRG_NZMV_TH Fld(8,8,AC_FULLB1)//[15:8]
#define MJC_ME_23 (MEMC_MJC + 0x28C)
    #define MJC_ME_3FRM_EDGEH_WDBLK Fld(1,31,AC_MSKB3)//[31:31]
    #define MJC_ME_3FRM_EDGEV_WDBLK Fld(1,30,AC_MSKB3)//[30:30]
    #define MJC_ME_3FRM_EDGEV_OFF Fld(1,28,AC_MSKB3)//[28:28]
    #define MJC_ME_3FRM_EDGE_PENALTY_SEL Fld(3,24,AC_MSKB3)//[26:24]
    #define MJC_ME_3FRM_EDGE_PENALTY_TH1 Fld(8,8,AC_FULLB1)//[15:8]
    #define MJC_ME_3FRM_EDGE_PENALTY_TH2 Fld(8,0,AC_FULLB0)//[7:0]
#define MJC_ME_24 (MEMC_MJC + 0x290)
    #define MJC_ME_3FRM_SMOOTH_BLK_TH2 Fld(4,28,AC_MSKB3)//[31:28]
    #define MJC_ME_3FRM_SMOOTH_RNG Fld(4,24,AC_MSKB3)//[27:24]
    #define MJC_ME_3FRM_SMOOTH_SAD_PENLTY2 Fld(8,16,AC_FULLB2)//[23:16]
    #define MJC_ME_3FRM_SMOOTH_TH2 Fld(15,0,AC_MSKW10)//[14:0]
#define MJC_ME_25 (MEMC_MJC + 0x294)
    #define MJC_ME_3FRM_MVPNLTY_SEL Fld(4,28,AC_MSKB3)//[31:28]
    #define MJC_ME_3FRM_SAD_OCC_EN Fld(1,26,AC_MSKB3)//[26:26]
    #define MJC_ME_3FRM_STA_SEL Fld(1,25,AC_MSKB3)//[25:25]
    #define MJC_ME_3FRM_SMOOTH_SAD_PENLTY Fld(8,16,AC_FULLB2)//[23:16]
    #define MJC_ME_3FRM_EDGE_PENALTY_MED_TH Fld(7,8,AC_MSKB1)//[14:8]
    #define MJC_ME_3FRM_EDGEV_PENALTY_MED_TH Fld(7,0,AC_MSKB0)//[6:0]
#define MJC_ME_26 (MEMC_MJC + 0x298)
    #define MJC_ME_MMPNLTY_SEL_2 Fld(4,28,AC_MSKB3)//[31:28]
    #define MJC_ADAP_GAIN_SEL2_X Fld(2,26,AC_MSKB3)//[27:26]
    #define MJC_ADAP_GAIN_SEL2_Y Fld(2,24,AC_MSKB3)//[25:24]
    #define MJC_ADAP_GAIN_EG_TH Fld(8,16,AC_FULLB2)//[23:16]
    #define MJC_ME_PPC_CORE_EN Fld(1,1,AC_MSKB0)//[1:1]
    #define MJC_ME_PPC_EN Fld(1,0,AC_MSKB0)//[0:0]
#define MJC_ME_27 (MEMC_MJC + 0x29C)
    #define MJC_ME_MMPNLTY_EGTH Fld(8,24,AC_FULLB3)//[31:24]
    #define MJC_ME_MMPNLTY_SEL Fld(4,16,AC_MSKB2)//[19:16]
    #define MJC_ME_MFPNLTY_SEL_1 Fld(4,12,AC_MSKB1)//[15:12]
    #define MJC_ME_MFPNLTY_SEL_2 Fld(4,8,AC_MSKB1)//[11:8]
    #define MJC_ME_MMPNLTY_BLKTH Fld(4,4,AC_MSKB0)//[7:4]
    #define MJC_ME_MFPNLTY_BLKTH Fld(4,0,AC_MSKB0)//[3:0]
#define MJC_ME_28 (MEMC_MJC + 0x2A0)
    #define MJC_ME_MFPNLTY_EGTH1 Fld(8,24,AC_FULLB3)//[31:24]
#define MJC_ME_29 (MEMC_MJC + 0x2A4)
    #define MJC_ME_MF_GLBV_TH Fld(8,24,AC_FULLB3)//[31:24]
    #define MJC_ME2_MF_ME3OCC_OFF Fld(1,14,AC_MSKB1)//[14:14]
    #define MJC_ME2_MF_OCC_OFF Fld(1,13,AC_MSKB1)//[13:13]
    #define MJC_ME3_MF_OCC_OFF Fld(1,12,AC_MSKB1)//[12:12]
    #define MJC_ME_LBOX_AUTO Fld(1,9,AC_MSKB1)//[9:9]
    #define MJC_MF_LBOX_CLIP_EN Fld(1,8,AC_MSKB1)//[8:8]
    #define MJC_ME_MFPNLTY_EGTH2 Fld(8,0,AC_FULLB0)//[7:0]
#define MJC_ME_2A (MEMC_MJC + 0x2A8)
    #define MJC_ME_WDV_BLK_UP_BND Fld(8,24,AC_FULLB3)//[31:24]
    #define MJC_ME_WDV_BLK_DN_BND Fld(8,16,AC_FULLB2)//[23:16]
#define MJC_ME_2B (MEMC_MJC + 0x2AC)
    #define MJC_PPC_ADAP_OFF Fld(1,16,AC_MSKB2)//[16:16]
    #define MJC_PPC_ADAP_OFF_RNG Fld(8,8,AC_FULLB1)//[15:8]
    #define MJC_PPC_ADAP_OFF_EG_TH Fld(8,0,AC_FULLB0)//[7:0]
#define MJC_ME_2C (MEMC_MJC + 0x2B0)
    #define MJC_GMV_EN Fld(1,31,AC_MSKB3)//[31:31]
    #define MJC_GMV_MODE Fld(1,30,AC_MSKB3)//[30:30]
    #define MJC_GMV_INTRVL_LBOX Fld(1,29,AC_MSKB3)//[29:29]
    #define MJC_GMV_BI_USE_TF Fld(1,28,AC_MSKB3)//[28:28]
    #define MJC_GMV_OSMP_LR_SEL Fld(1,27,AC_MSKB3)//[27:27]
    #define MJC_MV_GMV_INTRVL_Y Fld(8,16,AC_FULLB2)//[23:16]
    #define MJC_MV_GMV_INTRVL_X Fld(8,8,AC_FULLB1)//[15:8]
    #define MJC_ME_GMV_PNLTY2_MV_TH Fld(8,0,AC_FULLB0)//[7:0]
#define MJC_ME_2D (MEMC_MJC + 0x2B4)
    #define MJC_MV_CAND_NUM_UP Fld(4,28,AC_MSKB3)//[31:28]
    #define MJC_MV_INSERT_ZERO_Y Fld(1,17,AC_MSKB2)//[17:17]
    #define MJC_MV_INSERT_ZERO_X Fld(1,16,AC_MSKB2)//[16:16]
    #define MJC_ME_GMVBLK_EQ_TH Fld(8,8,AC_FULLB1)//[15:8]
    #define MJC_GMV_PENLTY2 Fld(8,0,AC_FULLB0)//[7:0]
#define MJC_ME_2E (MEMC_MJC + 0x2B8)
    #define MJC_ME_ONLY_SORT_EN Fld(1,30,AC_MSKB3)//[30:30]
    #define MJC_MV_FORCE_ME_OUT_EN Fld(2,28,AC_MSKB3)//[29:28]
    #define MJC_MV_FORCE_ME_OUT_Y Fld(8,20,AC_MSKW32)//[27:20]
    #define MJC_MV_FORCE_ME_OUT_X Fld(8,12,AC_MSKW21)//[19:12]
    #define MJC_RAND_SEED_TYPE Fld(2,10,AC_MSKB1)//[11:10]
    #define MJC_RAND_TABLE_TYPE Fld(2,8,AC_MSKB1)//[9:8]
    #define MJC_MV_RAND_Y_GAIN Fld(3,4,AC_MSKB0)//[6:4]
    #define MJC_MV_RAND_X_GAIN Fld(3,0,AC_MSKB0)//[2:0]
#define MJC_ME_2F (MEMC_MJC + 0x2BC)
    #define MJC_MV_SORT_EN Fld(1,31,AC_MSKB3)//[31:31]
    #define MJC_MV_SORT_ORDER Fld(3,28,AC_MSKB3)//[30:28]
    #define MJC_MV_3FRM_Y_BOUND Fld(8,20,AC_MSKW32)//[27:20]
    #define MJC_MV_X_BOUND Fld(9,8,AC_MSKW21)//[16:8]
    #define MJC_MV_Y_BOUND Fld(8,0,AC_FULLB0)//[7:0]
#define MJC_ME_30 (MEMC_MJC + 0x2C0)
    #define MJC_RAND_Y_FAC3 Fld(4,28,AC_MSKB3)//[31:28]
    #define MJC_RAND_Y_FAC2 Fld(4,24,AC_MSKB3)//[27:24]
    #define MJC_RAND_Y_FAC1 Fld(4,20,AC_MSKB2)//[23:20]
    #define MJC_RAND_Y_FAC0 Fld(4,16,AC_MSKB2)//[19:16]
    #define MJC_RAND_X_FAC3 Fld(4,12,AC_MSKB1)//[15:12]
    #define MJC_RAND_X_FAC2 Fld(4,8,AC_MSKB1)//[11:8]
    #define MJC_RAND_X_FAC1 Fld(4,4,AC_MSKB0)//[7:4]
    #define MJC_RAND_X_FAC0 Fld(4,0,AC_MSKB0)//[3:0]
#define MJC_ME_31 (MEMC_MJC + 0x2C4)
    #define MJC_BD_BIG_RAND_SAD_PENLTY Fld(8,15,AC_MSKW21)//[22:15]
    #define MJC_BIG_RAND_SAD_PENLTY Fld(8,7,AC_MSKW10)//[14:7]
    #define MJC_MV_BIG_RAND_X_GAIN Fld(3,4,AC_MSKB0)//[6:4]
    #define MJC_MV_BIG_RAND_Y_GAIN Fld(3,1,AC_MSKB0)//[3:1]
#define MJC_ME_33 (MEMC_MJC + 0x2CC)
    #define MJC_RGN_SAD_CPURW_ATPG_OB Fld(1,31,AC_MSKB3)//[31:31]
    #define MJC_RGN_SAD_CPURW_ATPG_CT Fld(1,30,AC_MSKB3)//[30:30]
    #define MJC_RGN_SRAM_FORCE_SEL_EN Fld(1,20,AC_MSKB2)//[20:20]
    #define MJC_RGN_SRAM_FORCE_W Fld(1,19,AC_MSKB2)//[19:19]
    #define MJC_RGN_SRAM_FORCE_R Fld(1,18,AC_MSKB2)//[18:18]
    #define MJC_RGN_SAD_R_FORCE_SRAM_CS_ON Fld(1,17,AC_MSKB2)//[17:17]
    #define MJC_RGN_SAD_R_VA_READ_LATEST_WDATA Fld(1,16,AC_MSKB2)//[16:16]
    #define MJC_RGN_SAD_R_RDATA_BYTE_EN_SEL Fld(2,14,AC_MSKB1)//[15:14]
    #define MJC_RGN_SAD_R_WDATA_BYTE_EN_SEL Fld(2,12,AC_MSKB1)//[13:12]
    #define MJC_RGN_SAD_R_RD_AUTO_INC_ADDR Fld(1,11,AC_MSKB1)//[11:11]
    #define MJC_RGN_SAD_R_WR_AUTO_INC_ADDR Fld(1,10,AC_MSKB1)//[10:10]
    #define MJC_RGN_SAD_R_PIO_MODE Fld(1,9,AC_MSKB1)//[9:9]
    #define MJC_RGN_SAD_R_FORCE_WR_NO_WAIT Fld(1,8,AC_MSKB1)//[8:8]
    #define MJC_RGN_SAD_R_MAX_WAIT_CYCLE Fld(8,0,AC_FULLB0)//[7:0]
#define MJC_ME_34 (MEMC_MJC + 0x2D0)
    #define MJC_STA_RGN_SAD_CPU_SRAM_ADDR Fld(8,16,AC_FULLB2)//[23:16]
    #define MJC_RGN_SAD_R_ADDR Fld(8,0,AC_FULLB0)//[7:0]
#define MJC_ME_35 (MEMC_MJC + 0x2D4)
    #define MJC_RGN_SAD_R_WDATA_00 Fld(32,0,AC_FULLDW)//[31:0]
#define MJC_ME_36 (MEMC_MJC + 0x2D8)
    #define MJC_STA_R_RDATA_00 Fld(32,0,AC_FULLDW)//[31:0]
#define MJC_ME_37 (MEMC_MJC + 0x2DC)
    #define MJC_FW_RGN_SAD_EN Fld(1,8,AC_MSKB1)//[8:8]
    #define MJC_STA_RGN_SAD_CPU_SEL_SRAM_0 Fld(1,7,AC_MSKB0)//[7:7]
    #define MJC_RGN_SAD_R_CPURW_ACTIVE Fld(1,6,AC_MSKB0)//[6:6]
    #define MJC_STA_RGN_SAD_TABLE_WAIT_VSYNC Fld(1,5,AC_MSKB0)//[5:5]
    #define MJC_RGN_SAD_R_FILL_TABLE_READY Fld(1,4,AC_MSKB0)//[4:4]
    #define MJC_STA_RGN_SAD_READ_FINISH Fld(1,3,AC_MSKB0)//[3:3]
    #define MJC_RGN_SAD_R_READ Fld(1,2,AC_MSKB0)//[2:2]
    #define MJC_STA_RGN_SAD_WRITE_FINISH Fld(1,1,AC_MSKB0)//[1:1]
    #define MJC_RGN_SAD_R_WRITE Fld(1,0,AC_MSKB0)//[0:0]
#define MJC_ME_38 (MEMC_MJC + 0x2E0)
    #define MJC_ZB_ME2_FW_WR_EN Fld(1,31,AC_MSKB3)//[31:31]
    #define MJC_ZB_ME3_FW_WR_EN Fld(1,30,AC_MSKB3)//[30:30]
    #define MJC_ZB_FW_ADDR Fld(4,24,AC_MSKB3)//[27:24]
#define MJC_ME_39 (MEMC_MJC + 0x2E4)
    #define MJC_ZB_ME2_FW_WR_DATA Fld(16,16,AC_FULLW32)//[31:16]
    #define MJC_ZB_ME3_FW_WR_DATA Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_ME_3A (MEMC_MJC + 0x2E8)
    #define MJC_STA_ZB_ME2_FW_RD_DATA Fld(16,16,AC_FULLW32)//[31:16]
    #define MJC_STA_ZB_ME3_FW_RD_DATA Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_ME_3B (MEMC_MJC + 0x2EC)
    #define MJC_ME2_GMV_WR_EN Fld(1,31,AC_MSKB3)//[31:31]
    #define MJC_ME2_GMV_X_WR_DATA Fld(10,16,AC_MSKW32)//[25:16]
    #define MJC_ME2_GMV_Y_WR_DATA Fld(9,0,AC_MSKW10)//[8:0]
#define MJC_ME_3C (MEMC_MJC + 0x2F0)
    #define MJC_STA_ME2_GMV_X_RD_DATA Fld(10,16,AC_MSKW32)//[25:16]
    #define MJC_STA_ME2_GMV_Y_RD_DATA Fld(9,0,AC_MSKW10)//[8:0]

//Page ME_2
#define MJC_ME_3D (MEMC_MJC + 0x2F4)
    #define MJC_ME3_GMV_WR_EN Fld(1,31,AC_MSKB3)//[31:31]
    #define MJC_ME3_GMV_X_WR_DATA Fld(10,16,AC_MSKW32)//[25:16]
    #define MJC_ME3_GMV_Y_WR_DATA Fld(9,0,AC_MSKW10)//[8:0]
#define MJC_ME_3E (MEMC_MJC + 0x2F8)
    #define MJC_STA_ME3_GMV_X_RD_DATA Fld(10,16,AC_MSKW32)//[25:16]
    #define MJC_STA_ME3_GMV_Y_RD_DATA Fld(9,0,AC_MSKW10)//[8:0]
#define MJC_STA_ME_00 (MEMC_MJC + 0x300)
    #define MJC_SUM_ZERO_SAD_SEL Fld(31,0,AC_MSKDW)//[30:0]
#define MJC_STA_ME_01 (MEMC_MJC + 0x304)
    #define MJC_STA_LES_SEL Fld(31,0,AC_MSKDW)//[30:0]
#define MJC_STA_ME_02 (MEMC_MJC + 0x308)
    #define MJC_SCNCHG_OK Fld(1,20,AC_MSKB2)//[20:20]
    #define MJC_MV_FINAL_CAND_NUM Fld(4,16,AC_MSKB2)//[19:16]
    #define MJC_BEC Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_STA_ME_03 (MEMC_MJC + 0x30C)
    #define MJC_SUM_MIN_BLK Fld(16,16,AC_FULLW32)//[31:16]
    #define MJC_SUM_BLKZERO2 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_STA_ME_04 (MEMC_MJC + 0x310)
    #define MJC_SUM_SMOOTH_BLK2 Fld(16,16,AC_FULLW32)//[31:16]
    #define MJC_SUM_SMOOTH_BLK Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_STA_ME_05 (MEMC_MJC + 0x314)
    #define MJC_SUM_ZERO_VAR_PREV Fld(30,0,AC_MSKDW)//[29:0]
#define MJC_STA_ME_06 (MEMC_MJC + 0x318)
    #define MJC_SUM_ZERO_VAR_CURR Fld(30,0,AC_MSKDW)//[29:0]
#define MJC_STA_ME_07 (MEMC_MJC + 0x31C)
    #define MJC_SUM_MIN_VAR_PREV Fld(30,0,AC_MSKDW)//[29:0]
#define MJC_STA_ME_08 (MEMC_MJC + 0x320)
    #define MJC_SUM_MIN_VAR_CURR Fld(30,0,AC_MSKDW)//[29:0]
#define MJC_STA_ME_09 (MEMC_MJC + 0x324)
    #define MJC_SUM_ZBSAD_VAR Fld(32,0,AC_FULLDW)//[31:0]
#define MJC_STA_ME_0A (MEMC_MJC + 0x328)
    #define MJC_LES_VAR Fld(32,0,AC_FULLDW)//[31:0]
#define MJC_STA_ME_0B (MEMC_MJC + 0x32C)
    #define MJC_SUM_BLKZERO Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_STA_ME_0C (MEMC_MJC + 0x330)
    #define MJC_ZERO_EDGE0_CNT Fld(23,0,AC_MSKDW)//[22:0]
#define MJC_STA_ME_0D (MEMC_MJC + 0x334)
    #define MJC_ZERO_EDGE1_CNT Fld(23,0,AC_MSKDW)//[22:0]
#define MJC_STA_ME_0E (MEMC_MJC + 0x338)
    #define MJC_ZERO_EDGE0_BLK Fld(16,16,AC_FULLW32)//[31:16]
    #define MJC_ZERO_EDGE1_BLK Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_STA_ME_0F (MEMC_MJC + 0x33C)
    #define MJC_ME3_SUM_ZERO_SAD Fld(31,0,AC_MSKDW)//[30:0]
#define MJC_STA_ME_10 (MEMC_MJC + 0x340)
    #define MJC_ME3_LES Fld(31,0,AC_MSKDW)//[30:0]
#define MJC_STA_ME_11 (MEMC_MJC + 0x344)
    #define MJC_ME3_SUM_MIN_BLK Fld(16,16,AC_FULLW32)//[31:16]
    #define MJC_ME3_SUM_BLKZERO2 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_STA_ME_12 (MEMC_MJC + 0x348)
    #define MJC_ME3_ZERO_EDGE1_BLK Fld(16,16,AC_FULLW32)//[31:16]
    #define MJC_ME3_SUM_BLKZERO Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_STA_ME_13 (MEMC_MJC + 0x34C)
    #define MJC_STA_PA_TAR_UP_SAD Fld(25,0,AC_MSKDW)//[24:0]
#define MJC_STA_ME_14 (MEMC_MJC + 0x350)
    #define MJC_STA_PA_REF_UP_SAD Fld(25,0,AC_MSKDW)//[24:0]
#define MJC_STA_ME_15 (MEMC_MJC + 0x354)
    #define MJC_STA_PA_TAR_DN_SAD Fld(25,0,AC_MSKDW)//[24:0]
#define MJC_STA_ME_16 (MEMC_MJC + 0x358)
    #define MJC_STA_PA_REF_DN_SAD Fld(25,0,AC_MSKDW)//[24:0]
#define MJC_ME_PNLTYGAIN_0 (MEMC_MJC + 0x35C)
    #define MJC_ME_MMPNLTY_GAIN Fld(5,16,AC_MSKB2)//[20:16]
    #define MJC_ME_MFPNLTY_GAIN Fld(5,8,AC_MSKB1)//[12:8]
    #define MJC_ME_MVPNLTY_GAIN Fld(5,0,AC_MSKB0)//[4:0]
#define MJC_ME_PNLTYGAIN_1 (MEMC_MJC + 0x360)
    #define MJC_ME3_SAD_B_GAIN Fld(5,24,AC_MSKB3)//[28:24]
    #define MJC_ME3_SAD_F_GAIN Fld(5,16,AC_MSKB2)//[20:16]
    #define MJC_ME2_SAD_C_GAIN Fld(5,8,AC_MSKB1)//[12:8]
    #define MJC_ME2_SAD_Y_GAIN Fld(5,0,AC_MSKB0)//[4:0]
#define MJC_ME_CAND_7_8 (MEMC_MJC + 0x364)
    #define MJC_ME3_8TH_CAND_EN Fld(1,6,AC_MSKB0)//[6:6]
    #define MJC_ME3_7TH_CAND_SEL Fld(1,5,AC_MSKB0)//[5:5]
    #define MJC_ME3_7TH_CAND_EN Fld(1,4,AC_MSKB0)//[4:4]
    #define MJC_ME2_8TH_CAND_SEL Fld(1,3,AC_MSKB0)//[3:3]
    #define MJC_ME2_8TH_CAND_EN Fld(1,2,AC_MSKB0)//[2:2]
    #define MJC_ME2_7TH_CAND_SEL Fld(1,1,AC_MSKB0)//[1:1]
    #define MJC_ME2_7TH_CAND_EN Fld(1,0,AC_MSKB0)//[0:0]
#define MJC_ME_BIG_CAND (MEMC_MJC + 0x368)
    #define MJC_BIG_RAND_Y_FAC1 Fld(5,24,AC_MSKB3)//[28:24]
    #define MJC_BIG_RAND_Y_FAC0 Fld(5,16,AC_MSKB2)//[20:16]
    #define MJC_BIG_RAND_X_FAC1 Fld(5,8,AC_MSKB1)//[12:8]
    #define MJC_BIG_RAND_X_FAC0 Fld(5,0,AC_MSKB0)//[4:0]
#define MJC_ME_TBA_0 (MEMC_MJC + 0x380)
    #define MJC_TBA_VIDEO_ONLY Fld(1,24,AC_MSKB3)//[24:24]
    #define MJC_ME3_TBA_FMEQ_Y_THR Fld(4,20,AC_MSKB2)//[23:20]
    #define MJC_ME3_TBA_FMEQ_X_THR Fld(4,16,AC_MSKB2)//[19:16]
    #define MJC_ME3_RGN_SAD_CLP_TH Fld(8,8,AC_FULLB1)//[15:8]
    #define MJC_GMV_BI_M3_VSYNC_SEL Fld(1,6,AC_MSKB0)//[6:6]
    #define MJC_ME3_VAR_MIN_PCN_SFT Fld(2,4,AC_MSKB0)//[5:4]
    #define MJC_ME3_VLPF_SAD_COR_TH Fld(4,0,AC_MSKB0)//[3:0]
#define MJC_ME_TBA_1 (MEMC_MJC + 0x384)
    #define MJC_ME3_TBA_TZEQ_Y_THR Fld(4,28,AC_MSKB3)//[31:28]
    #define MJC_ME3_TBA_TZEQ_X_THR Fld(4,24,AC_MSKB3)//[27:24]
    #define MJC_ME3_TBA_TMEQ_Y_THR Fld(4,20,AC_MSKB2)//[23:20]
    #define MJC_ME3_TBA_TMEQ_X_THR Fld(4,16,AC_MSKB2)//[19:16]
    #define MJC_ME3_TBA_SAD_RGN_HV_SWP Fld(1,11,AC_MSKB1)//[11:11]
    #define MJC_ME3_TBA_SAD_SEL Fld(1,10,AC_MSKB1)//[10:10]
    #define MJC_ME3_TBA_GMV_SEL Fld(1,9,AC_MSKB1)//[9:9]
    #define MJC_ME3_TBA_MGEQ_SEL_EN Fld(1,8,AC_MSKB1)//[8:8]
    #define MJC_ME3_TBA_MGEQ_Y_THR Fld(4,4,AC_MSKB0)//[7:4]
    #define MJC_ME3_TBA_MGEQ_X_THR Fld(4,0,AC_MSKB0)//[3:0]
#define MJC_ME_TBA_2 (MEMC_MJC + 0x388)
    #define MJC_ME_BND_FG_ZERO_SAD_EN Fld(1,26,AC_MSKB3)//[26:26]
    #define MJC_ME_BND_FG_MF_CHK2 Fld(1,25,AC_MSKB3)//[25:25]
    #define MJC_ME_BND_FG_MF_CHK1 Fld(1,24,AC_MSKB3)//[24:24]
    #define MJC_ME_BND_FG_SAD_TH2 Fld(8,16,AC_FULLB2)//[23:16]
    #define MJC_ME_BND_FG_SAD_TH1 Fld(8,8,AC_FULLB1)//[15:8]
    #define MJC_ME_BND_FG_MVY_TH Fld(4,4,AC_MSKB0)//[7:4]
    #define MJC_ME3_DIR_7TH_CAND_SEL Fld(1,1,AC_MSKB0)//[1:1]
#define MJC_ME_CLP_0 (MEMC_MJC + 0x38C)
    #define MJC_ME_EDGE_PENLTY_CLIP_EN Fld(1,27,AC_MSKB3)//[27:27]
    #define MJC_ME_MMPNLTY_CLIP_EN Fld(1,26,AC_MSKB3)//[26:26]
    #define MJC_ME_MFPNLTY_CLIP_EN Fld(1,25,AC_MSKB3)//[25:25]
    #define MJC_ME_MVPNLTY_CLIP_EN Fld(1,24,AC_MSKB3)//[24:24]
    #define MJC_ME_MMPNLTY_CLIP_TH Fld(8,16,AC_FULLB2)//[23:16]
    #define MJC_ME_MFPNLTY_CLIP_TH Fld(8,8,AC_FULLB1)//[15:8]
    #define MJC_ME_MVPNLTY_CLIP_TH Fld(8,0,AC_FULLB0)//[7:0]
#define MJC_ME_CLP_1 (MEMC_MJC + 0x390)
    #define MJC_ME3_EDGE_PENLTY_CLIP_EN Fld(1,27,AC_MSKB3)//[27:27]
    #define MJC_ME3_MMPNLTY_CLIP_EN Fld(1,26,AC_MSKB3)//[26:26]
    #define MJC_ME3_MFPNLTY_CLIP_EN Fld(1,25,AC_MSKB3)//[25:25]
    #define MJC_ME3_MVPNLTY_CLIP_EN Fld(1,24,AC_MSKB3)//[24:24]
    #define MJC_ME3_MMPNLTY_CLIP_TH Fld(8,16,AC_FULLB2)//[23:16]
    #define MJC_ME3_MFPNLTY_CLIP_TH Fld(8,8,AC_FULLB1)//[15:8]
    #define MJC_ME3_MVPNLTY_CLIP_TH Fld(8,0,AC_FULLB0)//[7:0]
#define MJC_ME_CLP_2 (MEMC_MJC + 0x394)
    #define MJC_ME_BND_FG_SAD_TH3 Fld(8,24,AC_FULLB3)//[31:24]
    #define MJC_ME3_EDGE_PENLTY_CLIP_TH Fld(12,12,AC_MSKW21)//[23:12]
    #define MJC_ME_EDGE_PENLTY_CLIP_TH Fld(12,0,AC_MSKW10)//[11:0]
#define MJC_STA_GMV_BI (MEMC_MJC + 0x398)
    #define MJC_ME2_STA_GMV_X Fld(10,16,AC_MSKW32)//[25:16]
    #define MJC_ME2_STA_GMV_Y_FIX Fld(9,0,AC_MSKW10)//[8:0]
#define MJC_STA_GMV_TF (MEMC_MJC + 0x39C)
    #define MJC_ME3_STA_GMV_X Fld(10,16,AC_MSKW32)//[25:16]
    #define MJC_ME3_STA_GMV_Y_FIX Fld(9,0,AC_MSKW10)//[8:0]
#define MJC_ME_PPCGMV (MEMC_MJC + 0x3A0)
    #define MJC_PPC_GMV_INTRVL_LBOX Fld(1,29,AC_MSKB3)//[29:29]
    #define MJC_ME_DSR_HIST_BND_EN Fld(1,28,AC_MSKB3)//[28:28]
    #define MJC_ME_DSR_HIST_BND Fld(4,24,AC_MSKB3)//[27:24]
    #define MJC_PPC_GMV_INTRVL_Y Fld(8,16,AC_FULLB2)//[23:16]
    #define MJC_PPC_GMV_INTRVL_X Fld(8,8,AC_FULLB1)//[15:8]
    #define MJC_ME_MVY_HIST_VAR_TH Fld(8,0,AC_FULLB0)//[7:0]
#define MJC_ME_MVY_HIST_00 (MEMC_MJC + 0x3C0)
    #define MJC_STA_DSR_BLK_MVY_HIST_G1_1 Fld(16,16,AC_FULLW32)//[31:16]
    #define MJC_STA_DSR_BLK_MVY_HIST_G1_0 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_ME_MVY_HIST_01 (MEMC_MJC + 0x3C4)
    #define MJC_STA_DSR_BLK_MVY_HIST_G1_3 Fld(16,16,AC_FULLW32)//[31:16]
    #define MJC_STA_DSR_BLK_MVY_HIST_G1_2 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_ME_MVY_HIST_02 (MEMC_MJC + 0x3C8)
    #define MJC_STA_DSR_BLK_MVY_HIST_G1_5 Fld(16,16,AC_FULLW32)//[31:16]
    #define MJC_STA_DSR_BLK_MVY_HIST_G1_4 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_ME_MVY_HIST_03 (MEMC_MJC + 0x3CC)
    #define MJC_STA_DSR_BLK_MVY_HIST_G2_0 Fld(16,16,AC_FULLW32)//[31:16]
    #define MJC_STA_DSR_BLK_MVY_HIST_G1_6 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_ME_MVY_HIST_04 (MEMC_MJC + 0x3D0)
    #define MJC_STA_DSR_BLK_MVY_HIST_G2_2 Fld(16,16,AC_FULLW32)//[31:16]
    #define MJC_STA_DSR_BLK_MVY_HIST_G2_1 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_ME_MVY_HIST_05 (MEMC_MJC + 0x3D4)
    #define MJC_STA_DSR_BLK_MVY_HIST_G2_4 Fld(16,16,AC_FULLW32)//[31:16]
    #define MJC_STA_DSR_BLK_MVY_HIST_G2_3 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_ME_MVY_HIST_06 (MEMC_MJC + 0x3D8)
    #define MJC_STA_DSR_BLK_MVY_HIST_G2_6 Fld(16,16,AC_FULLW32)//[31:16]
    #define MJC_STA_DSR_BLK_MVY_HIST_G2_5 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_ME_MVY_HIST_07 (MEMC_MJC + 0x3DC)
    #define MJC_STA_DSR_RGN_MVY_HIST_G1_3 Fld(8,24,AC_FULLB3)//[31:24]
    #define MJC_STA_DSR_RGN_MVY_HIST_G1_2 Fld(8,16,AC_FULLB2)//[23:16]
    #define MJC_STA_DSR_RGN_MVY_HIST_G1_1 Fld(8,8,AC_FULLB1)//[15:8]
    #define MJC_STA_DSR_RGN_MVY_HIST_G1_0 Fld(8,0,AC_FULLB0)//[7:0]
#define MJC_ME_MVY_HIST_08 (MEMC_MJC + 0x3E0)
    #define MJC_STA_DSR_RGN_MVY_HIST_G1_7 Fld(8,24,AC_FULLB3)//[31:24]
    #define MJC_STA_DSR_RGN_MVY_HIST_G1_6 Fld(8,16,AC_FULLB2)//[23:16]
    #define MJC_STA_DSR_RGN_MVY_HIST_G1_5 Fld(8,8,AC_FULLB1)//[15:8]
    #define MJC_STA_DSR_RGN_MVY_HIST_G1_4 Fld(8,0,AC_FULLB0)//[7:0]
#define MJC_ME_MVY_HIST_09 (MEMC_MJC + 0x3E4)
    #define MJC_STA_DSR_RGN_MVY_HIST_G1_10 Fld(8,16,AC_FULLB2)//[23:16]
    #define MJC_STA_DSR_RGN_MVY_HIST_G1_9 Fld(8,8,AC_FULLB1)//[15:8]
    #define MJC_STA_DSR_RGN_MVY_HIST_G1_8 Fld(8,0,AC_FULLB0)//[7:0]
#define MJC_ME_MVY_HIST_10 (MEMC_MJC + 0x3E8)
    #define MJC_STA_DSR_RGN_MVY_HIST_G2_3 Fld(8,24,AC_FULLB3)//[31:24]
    #define MJC_STA_DSR_RGN_MVY_HIST_G2_2 Fld(8,16,AC_FULLB2)//[23:16]
    #define MJC_STA_DSR_RGN_MVY_HIST_G2_1 Fld(8,8,AC_FULLB1)//[15:8]
    #define MJC_STA_DSR_RGN_MVY_HIST_G2_0 Fld(8,0,AC_FULLB0)//[7:0]
#define MJC_ME_MVY_HIST_11 (MEMC_MJC + 0x3EC)
    #define MJC_STA_DSR_RGN_MVY_HIST_G2_7 Fld(8,24,AC_FULLB3)//[31:24]
    #define MJC_STA_DSR_RGN_MVY_HIST_G2_6 Fld(8,16,AC_FULLB2)//[23:16]
    #define MJC_STA_DSR_RGN_MVY_HIST_G2_5 Fld(8,8,AC_FULLB1)//[15:8]
    #define MJC_STA_DSR_RGN_MVY_HIST_G2_4 Fld(8,0,AC_FULLB0)//[7:0]
#define MJC_ME_MVY_HIST_12 (MEMC_MJC + 0x3F0)
    #define MJC_STA_DSR_RGN_MVY_HIST_G2_10 Fld(8,16,AC_FULLB2)//[23:16]
    #define MJC_STA_DSR_RGN_MVY_HIST_G2_9 Fld(8,8,AC_FULLB1)//[15:8]
    #define MJC_STA_DSR_RGN_MVY_HIST_G2_8 Fld(8,0,AC_FULLB0)//[7:0]
#define MJC_ME_OBPNT_00 (MEMC_MJC + 0x3F4)
    #define MJC_STA_ME_OBPNT_0 Fld(32,0,AC_FULLDW)//[31:0]
#define MJC_ME_OBPNT_01 (MEMC_MJC + 0x3F8)
    #define MJC_STA_ME_OBPNT_1 Fld(32,0,AC_FULLDW)//[31:0]
#define MJC_ME_ATPG (MEMC_MJC + 0x3FC)
    #define MJC_STA_ME_OBPNT_2 Fld(16,16,AC_FULLW32)//[31:16]
    #define MJC_ME_ATPG_OB Fld(1,1,AC_MSKB0)//[1:1]
    #define MJC_ME_ATPG_CT Fld(1,0,AC_MSKB0)//[0:0]

//Page MV_1
#define MJC_MV_00 (MEMC_MJC + 0x800)
    #define MJC_MV_INIT_FAST_CNT Fld(2,30,AC_MSKB3)//[31:30]
    #define MJC_DRAM_FORCE_MV_WR Fld(1,28,AC_MSKB3)//[28:28]
    #define MJC_MV_NO_ERSION Fld(1,26,AC_MSKB3)//[26:26]
    #define MJC_MV_WRITE_TEST Fld(1,25,AC_MSKB3)//[25:25]
    #define MJC_MV_DRAM_WRITE_ZERO Fld(1,24,AC_MSKB3)//[24:24]
#define MJC_MV_02 (MEMC_MJC + 0x808)
    #define MJC_ME2_USE_ME3TMP Fld(2,28,AC_MSKB3)//[29:28]
#define MJC_MV_03 (MEMC_MJC + 0x80C)
    #define MJC_MV3_RAND_SRC_SEL Fld(2,26,AC_MSKB3)//[27:26]
    #define MJC_MV2_RAND_SRC_SEL Fld(2,24,AC_MSKB3)//[25:24]
#define MJC_MV_04 (MEMC_MJC + 0x810)
    #define MJC_MV_CROS_MIN_TH2 Fld(4,28,AC_MSKB3)//[31:28]
    #define MJC_MV_BDR_CNT_TH Fld(4,16,AC_MSKB2)//[19:16]
    #define MJC_MV_DIAG_MED_TH Fld(4,12,AC_MSKB1)//[15:12]
    #define MJC_MV_CROS_MIN_TH Fld(4,8,AC_MSKB1)//[11:8]
    #define MJC_MV_Y_DIF_COR_TH Fld(4,4,AC_MSKB0)//[7:4]
    #define MJC_MV_X_DIF_COR_TH Fld(4,0,AC_MSKB0)//[3:0]
#define MJC_MV_05 (MEMC_MJC + 0x814)
    #define MJC_MV_FORCE_VSI_VALUE Fld(6,20,AC_MSKW32)//[25:20]
    #define MJC_MV_BDR_SFT Fld(4,16,AC_MSKB2)//[19:16]
    #define MJC_MV_NRM_SFT Fld(4,12,AC_MSKB1)//[15:12]
    #define MJC_MV_MIX_SFT Fld(4,8,AC_MSKB1)//[11:8]
    #define MJC_MV_NRM_RSSEL Fld(2,4,AC_MSKB0)//[5:4]
    #define MJC_MV_BDR_RSSEL Fld(2,0,AC_MSKB0)//[1:0]
#define MJC_MV_06 (MEMC_MJC + 0x818)
    #define MJC_MV_MIX_BDR_AVG_GAIN Fld(4,28,AC_MSKB3)//[31:28]
    #define MJC_MV_MIX_BDR_MED_GAIN Fld(4,24,AC_MSKB3)//[27:24]
    #define MJC_MV_MIX_NRM_AVG_GAIN Fld(4,20,AC_MSKB2)//[23:20]
    #define MJC_MV_MIX_NRM_MED_GAIN Fld(4,16,AC_MSKB2)//[19:16]
    #define MJC_MV_BDR_AVG_VSI_GAIN Fld(4,12,AC_MSKB1)//[15:12]
    #define MJC_MV_BDR_MED_VSI_GAIN Fld(4,8,AC_MSKB1)//[11:8]
    #define MJC_MV_NRM_AVG_VSI_GAIN Fld(4,4,AC_MSKB0)//[7:4]
    #define MJC_MV_NRM_MED_VSI_GAIN Fld(4,0,AC_MSKB0)//[3:0]
#define MJC_MV_07 (MEMC_MJC + 0x81C)
    #define MJC_MV_VSI_FORCE_BDR Fld(1,23,AC_MSKB2)//[23:23]
    #define MJC_MV_VSI_MIX_EN Fld(1,22,AC_MSKB2)//[22:22]
    #define MJC_MV_VSI_SCH_NRM Fld(1,21,AC_MSKB2)//[21:21]
    #define MJC_MV_VSI_FORCE_NRM Fld(1,20,AC_MSKB2)//[20:20]
    #define MJC_MV_VSI_DIAG_SEL Fld(1,18,AC_MSKB2)//[18:18]
    #define MJC_MV_VSI_BDR_33 Fld(1,17,AC_MSKB2)//[17:17]
    #define MJC_MV_VSI_NRM_33 Fld(1,16,AC_MSKB2)//[16:16]
    #define MJC_MV_LBOX_OVL_NUM Fld(4,12,AC_MSKB1)//[15:12]
    #define MJC_MV_LBOX_OVL_OFF Fld(1,8,AC_MSKB1)//[8:8]
    #define MJC_MV_LBOX_VSI_NUM Fld(4,4,AC_MSKB0)//[7:4]
    #define MJC_MV_LBOX_VSI_BDR Fld(1,0,AC_MSKB0)//[0:0]
#define MJC_MV_08 (MEMC_MJC + 0x820)
    #define MJC_MV_CMX_SM_Y_THR Fld(4,28,AC_MSKB3)//[31:28]
    #define MJC_MV_CMX_SM_X_THR Fld(4,24,AC_MSKB3)//[27:24]
    #define MJC_MV_CMX_EQ_Y_THR Fld(4,20,AC_MSKB2)//[23:20]
    #define MJC_MV_CMX_EQ_X_THR Fld(4,16,AC_MSKB2)//[19:16]
    #define MJC_MV_CMX_IGNORE_TPDF Fld(1,13,AC_MSKB1)//[13:13]
    #define MJC_MV_CMX_SEL Fld(1,12,AC_MSKB1)//[12:12]
#define MJC_MV_09 (MEMC_MJC + 0x824)
    #define MJC_MV_OCC_REF_DLT_GAIN Fld(7,24,AC_MSKB3)//[30:24]
    #define MJC_MV_OCC_SLF_DLT_GAIN Fld(7,16,AC_MSKB2)//[22:16]
    #define MJC_MV_OCC_ERO_GAIN Fld(4,12,AC_MSKB1)//[15:12]
    #define MJC_MV_OCC_SMALL_OFF Fld(1,10,AC_MSKB1)//[10:10]
    #define MJC_MV_VSI_IGNORE_GDFG Fld(1,9,AC_MSKB1)//[9:9]
    #define MJC_MV_VSI_IGNORE_BGMV Fld(1,8,AC_MSKB1)//[8:8]
    #define MJC_MV_OCC_IGNORE_FBG Fld(1,7,AC_MSKB0)//[7:7]
    #define MJC_MV_OCC_IGNORE_ZBL Fld(1,6,AC_MSKB0)//[6:6]
    #define MJC_MV_OCC_IGNORE_BDR Fld(1,5,AC_MSKB0)//[5:5]
    #define MJC_MV_NO_VSI_MODE Fld(1,1,AC_MSKB0)//[1:1]
    #define MJC_MV_NO_OCC_MODE Fld(1,0,AC_MSKB0)//[0:0]
#define MJC_MV_0A (MEMC_MJC + 0x828)
    #define MJC_MV_OVL_RGN_SEL Fld(1,28,AC_MSKB3)//[28:28]
    #define MJC_MV_NO_OVL_MODE Fld(1,24,AC_MSKB3)//[24:24]
    #define MJC_MV_OVL_Y_TH2 Fld(4,20,AC_MSKB2)//[23:20]
    #define MJC_MV_OVL_X_TH2 Fld(4,16,AC_MSKB2)//[19:16]
    #define MJC_MV_OVL_S_TH Fld(4,8,AC_MSKB1)//[11:8]
    #define MJC_MV_OVL_Y_TH Fld(4,4,AC_MSKB0)//[7:4]
    #define MJC_MV_OVL_X_TH Fld(4,0,AC_MSKB0)//[3:0]
#define MJC_MV_0B (MEMC_MJC + 0x82C)
    #define MJC_MV_42A_STILL_ONLY Fld(1,16,AC_MSKB2)//[16:16]
    #define MJC_MV_42A_ST_Y_THR Fld(8,8,AC_FULLB1)//[15:8]
    #define MJC_MV_42A_ST_X_THR Fld(8,0,AC_FULLB0)//[7:0]
#define MJC_MV_0E (MEMC_MJC + 0x838)
    #define MJC_MV_CRC_START Fld(1,31,AC_MSKB3)//[31:31]
#define MJC_MV_0F (MEMC_MJC + 0x83C)
    #define MJC_MV_CRC_CLEAR Fld(1,31,AC_MSKB3)//[31:31]
#define MJC_MV_11 (MEMC_MJC + 0x844)
    #define MJC_MV_FMD_DLT_GAIN Fld(6,0,AC_MSKB0)//[5:0]
#define MJC_MV_13 (MEMC_MJC + 0x848)
    #define MJC_MV_PSG_V_BD_HT Fld(8,24,AC_FULLB3)//[31:24]
    #define MJC_MV_PSG_H_BD_WD Fld(8,16,AC_FULLB2)//[23:16]
    #define MJC_MV_PSG_LR3D_MODE Fld(2,8,AC_MSKB1)//[9:8]
    #define MJC_MV_PSG_OCC_BG_SEL Fld(1,4,AC_MSKB0)//[4:4]
    #define MJC_MV_PSG_BD_AUTO Fld(1,1,AC_MSKB0)//[1:1]
#define MJC_MV_14 (MEMC_MJC + 0x84C)
    #define MJC_MV_PSG_MV_YLRG_THR Fld(4,28,AC_MSKB3)//[31:28]
    #define MJC_MV_PSG_BDRVSI_THR Fld(4,24,AC_MSKB3)//[27:24]
    #define MJC_MV_PSG_NRMVSI_THR Fld(4,20,AC_MSKB2)//[23:20]
    #define MJC_MV_PSG_OCCSAD_THR Fld(4,16,AC_MSKB2)//[19:16]
    #define MJC_MV_PSG_MV_SMAG_SEL Fld(1,8,AC_MSKB1)//[8:8]
    #define MJC_MV_PSG_MV_SMAG_THR Fld(4,4,AC_MSKB0)//[7:4]
    #define MJC_MV_PSG_MV_PMAG_THR Fld(4,0,AC_MSKB0)//[3:0]
#define MJC_MV_15 (MEMC_MJC + 0x850)
    #define MJC_MV_PSG_BST_GAIN_CNT_TH4 Fld(4,28,AC_MSKB3)//[31:28]
    #define MJC_MV_PSG_BST_GAIN_CNT_TH3 Fld(4,24,AC_MSKB3)//[27:24]
    #define MJC_MV_PSG_BST_GAIN_CNT_TH2 Fld(4,20,AC_MSKB2)//[23:20]
    #define MJC_MV_PSG_BST_GAIN_CNT_TH1 Fld(4,16,AC_MSKB2)//[19:16]
    #define MJC_MV_PSG_BST_GAIN_EN Fld(1,12,AC_MSKB1)//[12:12]
    #define MJC_MV_PSG_SAD_GAIN_EN Fld(1,4,AC_MSKB0)//[4:4]
    #define MJC_MV_PSG_SAD_GAIN_COR Fld(4,0,AC_MSKB0)//[3:0]
#define MJC_MV_16 (MEMC_MJC + 0x854)
    #define MJC_MV_PSG_MVM_GAIN_96 Fld(4,28,AC_MSKB3)//[31:28]
    #define MJC_MV_PSG_MVM_GAIN_80 Fld(4,24,AC_MSKB3)//[27:24]
    #define MJC_MV_PSG_MVM_GAIN_64 Fld(4,20,AC_MSKB2)//[23:20]
    #define MJC_MV_PSG_MVM_GAIN_56 Fld(4,16,AC_MSKB2)//[19:16]
    #define MJC_MV_PSG_MVM_GAIN_48 Fld(4,12,AC_MSKB1)//[15:12]
    #define MJC_MV_PSG_MVM_GAIN_40 Fld(4,8,AC_MSKB1)//[11:8]
    #define MJC_MV_PSG_MVM_GAIN_32 Fld(4,4,AC_MSKB0)//[7:4]
    #define MJC_MV_PSG_MVM_GAIN_24 Fld(4,0,AC_MSKB0)//[3:0]
#define MJC_MV_17 (MEMC_MJC + 0x858)
    #define MJC_MV_PSG_BAD_MT_MSK Fld(12,16,AC_MSKW32)//[27:16]
    #define MJC_MV_PSG_MSAD_AD_THR Fld(4,12,AC_MSKB1)//[15:12]
    #define MJC_MV_PSG_MVM_GAIN_MAX Fld(4,0,AC_MSKB0)//[3:0]
#define MJC_MV_18 (MEMC_MJC + 0x85C)
    #define MJC_MV_PSG_MV_ERR4_MAX Fld(4,28,AC_MSKB3)//[31:28]
    #define MJC_MV_PSG_MV_ERR3_COR Fld(4,24,AC_MSKB3)//[27:24]
    #define MJC_MV_PSG_MV_ERR3_MSK Fld(8,16,AC_FULLB2)//[23:16]
    #define MJC_MV_PSG_MV_ERR2_MAX Fld(4,12,AC_MSKB1)//[15:12]
    #define MJC_MV_PSG_MV_ERR1_COR Fld(4,8,AC_MSKB1)//[11:8]
    #define MJC_MV_PSG_MV_ERR1_MSK Fld(8,0,AC_FULLB0)//[7:0]
#define MJC_MV_19 (MEMC_MJC + 0x860)
    #define MJC_MV_PSG_OCC_ERR2_MAX Fld(4,12,AC_MSKB1)//[15:12]
    #define MJC_MV_PSG_OCC_ERR1_COR Fld(4,8,AC_MSKB1)//[11:8]
    #define MJC_MV_PSG_OCC_ERR1_MSK Fld(8,0,AC_FULLB0)//[7:0]
#define MJC_MV_1A (MEMC_MJC + 0x864)
    #define MJC_MV_PSG_OCC_HST_MSK Fld(4,16,AC_MSKB2)//[19:16]
    #define MJC_MV_PSG_OSD_ERR2_MAX Fld(4,8,AC_MSKB1)//[11:8]
    #define MJC_MV_PSG_OSD_ERR2_MSK Fld(4,4,AC_MSKB0)//[7:4]
    #define MJC_MV_PSG_OSD_ERR1_MSK Fld(4,0,AC_MSKB0)//[3:0]
#define MJC_MV_1B (MEMC_MJC + 0x868)
    #define MJC_MV_PSG_ZR_Y_THR Fld(4,16,AC_MSKB2)//[19:16]
    #define MJC_MV_PSG_ZR_X_THR Fld(4,12,AC_MSKB1)//[15:12]
    #define MJC_MV_PSG_EQ_S_THR Fld(4,8,AC_MSKB1)//[11:8]
    #define MJC_MV_PSG_EQ_Y_THR Fld(4,4,AC_MSKB0)//[7:4]
    #define MJC_MV_PSG_EQ_X_THR Fld(4,0,AC_MSKB0)//[3:0]
#define MJC_MV_22 (MEMC_MJC + 0x874)
    #define MJC_MVC_OCC_H_TH Fld(8,24,AC_FULLB3)//[31:24]
    #define MJC_MVC_OCC_V_TH Fld(8,16,AC_FULLB2)//[23:16]
#define MJC_MV_24 (MEMC_MJC + 0x878)
    #define MJC_MV_MESC_FRM_CNT Fld(8,24,AC_FULLB3)//[31:24]
    #define MJC_MV_YAPL_FRM_CNT Fld(8,16,AC_FULLB2)//[23:16]
#define MJC_MV_2A (MEMC_MJC + 0x890)
    #define MJC_MVC_PRJ_SFT_Y_THR Fld(4,20,AC_MSKB2)//[23:20]
    #define MJC_MVC_PRJ_SFT_X_THR Fld(4,16,AC_MSKB2)//[19:16]
#define MJC_MV_2B (MEMC_MJC + 0x894)
    #define MJC_MVC_OTHR_SEL Fld(2,24,AC_MSKB3)//[25:24]
    #define MJC_MVC_CRCT_SEL_2 Fld(2,22,AC_MSKB2)//[23:22]
    #define MJC_MVC_CRCT_SEL_1 Fld(2,20,AC_MSKB2)//[21:20]
    #define MJC_MVC_PFLT_SEL Fld(2,18,AC_MSKB2)//[19:18]
    #define MJC_MVC_WD_X Fld(1,17,AC_MSKB2)//[17:17]
    #define MJC_MVC_WD_Y Fld(1,16,AC_MSKB2)//[16:16]
    #define MJC_MVC_CRCT_TH_H Fld(8,8,AC_FULLB1)//[15:8]
    #define MJC_MVC_CRCT_TH_V Fld(8,0,AC_FULLB0)//[7:0]
#define MJC_MV_2C (MEMC_MJC + 0x898)
    #define MJC_MV_MAJOR_BDR_THR Fld(4,28,AC_MSKB3)//[31:28]
    #define MJC_MV_MAJOR_CNT_THR Fld(4,24,AC_MSKB3)//[27:24]
    #define MJC_MV_MAJOR_Y_THR Fld(4,20,AC_MSKB2)//[23:20]
    #define MJC_MV_MAJOR_X_THR Fld(4,16,AC_MSKB2)//[19:16]
    #define MJC_MV_HLEAD_Y_THR Fld(4,12,AC_MSKB1)//[15:12]
    #define MJC_MV_HLEAD_X_THR Fld(4,8,AC_MSKB1)//[11:8]
    #define MJC_MV_NZERO_Y_THR Fld(4,4,AC_MSKB0)//[7:4]
    #define MJC_MV_NZERO_X_THR Fld(4,0,AC_MSKB0)//[3:0]
#define MJC_MV_2D (MEMC_MJC + 0x89C)
    #define MJC_MV_BG_IIR_SEL Fld(1,28,AC_MSKB3)//[28:28]
    #define MJC_MV_BG_DBG_NO_KEEP Fld(1,24,AC_MSKB3)//[24:24]
    #define MJC_MV_MAJOR_DBG_SEL Fld(4,20,AC_MSKB2)//[23:20]
    #define MJC_MV_HLEAD_DBG_SEL Fld(4,16,AC_MSKB2)//[19:16]
    #define MJC_MV_BG_CNT_THR Fld(8,8,AC_FULLB1)//[15:8]
    #define MJC_MV_BG_KEEP_SEL Fld(1,7,AC_MSKB0)//[7:7]
    #define MJC_MV_BG_FGBG_CHK Fld(1,6,AC_MSKB0)//[6:6]
    #define MJC_MV_BG_CNT_SEL Fld(1,5,AC_MSKB0)//[5:5]
    #define MJC_MV_BG_CNT_EN Fld(1,4,AC_MSKB0)//[4:4]
    #define MJC_MV_BG_FGBG_DFVAL Fld(1,3,AC_MSKB0)//[3:3]
    #define MJC_MV_MAJOR_CHECK_EN Fld(1,0,AC_MSKB0)//[0:0]
#define MJC_MV_2E (MEMC_MJC + 0x8A0)
    #define MJC_MVC_KEEP_Y_TH2 Fld(4,28,AC_MSKB3)//[31:28]
    #define MJC_MVC_KEEP_X_TH2 Fld(4,24,AC_MSKB3)//[27:24]
    #define MJC_MVC_KEEP_Y_TH1 Fld(4,20,AC_MSKB2)//[23:20]
    #define MJC_MVC_KEEP_X_TH1 Fld(4,16,AC_MSKB2)//[19:16]
    #define MJC_MVC_VRNG_TH Fld(8,8,AC_FULLB1)//[15:8]
    #define MJC_MVC_TPOS_EN Fld(1,4,AC_MSKB0)//[4:4]
    #define MJC_MVC_KEEP_MOD Fld(3,1,AC_MSKB0)//[3:1]
    #define MJC_MV_BYPASS_MVC Fld(1,0,AC_MSKB0)//[0:0]
#define MJC_MV_2F (MEMC_MJC + 0x8A4)
    #define MJC_MV_TOC_BIDF_Y_THR Fld(4,28,AC_MSKB3)//[31:28]
    #define MJC_MV_TOC_BIDF_X_THR Fld(4,24,AC_MSKB3)//[27:24]
    #define MJC_MV_TOC_BGCHK_Y_THR Fld(4,20,AC_MSKB2)//[23:20]
    #define MJC_MV_TOC_BGCHK_X_THR Fld(4,16,AC_MSKB2)//[19:16]
    #define MJC_MV_TOC_FGEX_YGAIN Fld(4,12,AC_MSKB1)//[15:12]
    #define MJC_MV_TOC_BGEX_YGAIN Fld(4,8,AC_MSKB1)//[11:8]
    #define MJC_MV_TOC_FGEX_XGAIN Fld(4,4,AC_MSKB0)//[7:4]
    #define MJC_MV_TOC_BGEX_XGAIN Fld(4,0,AC_MSKB0)//[3:0]
#define MJC_MV_30 (MEMC_MJC + 0x8A8)
    #define MJC_MV_BG_LG_Y_THR Fld(8,24,AC_FULLB3)//[31:24]
    #define MJC_MV_BG_LG_X_THR Fld(8,16,AC_FULLB2)//[23:16]
    #define MJC_MV_BG_EQ_Y_THR Fld(4,12,AC_MSKB1)//[15:12]
    #define MJC_MV_BG_EQ_X_THR Fld(4,8,AC_MSKB1)//[11:8]
    #define MJC_MV_TOC_ZERO_Y_THR Fld(4,4,AC_MSKB0)//[7:4]
    #define MJC_MV_TOC_ZERO_X_THR Fld(4,0,AC_MSKB0)//[3:0]
#define MJC_MV_31 (MEMC_MJC + 0x8AC)
    #define MJC_MV_TOC_TF_Y_THR Fld(4,28,AC_MSKB3)//[31:28]
    #define MJC_MV_TOC_TF_X_THR Fld(4,24,AC_MSKB3)//[27:24]
    #define MJC_MV_TOC_BGF_EX_Y Fld(1,23,AC_MSKB2)//[23:23]
    #define MJC_MV_TOC_BGF_EX_X Fld(1,22,AC_MSKB2)//[22:22]
    #define MJC_MV_TOC_BGF_EX_SEL Fld(1,21,AC_MSKB2)//[21:21]
    #define MJC_MV_TOC_BGF_TPOS_EN Fld(1,20,AC_MSKB2)//[20:20]
    #define MJC_MV_TOC_TPOS_EN Fld(1,19,AC_MSKB2)//[19:19]
    #define MJC_MV_TOC_ZBL_BOTH Fld(1,18,AC_MSKB2)//[18:18]
    #define MJC_MV_TOC_RANGE_TPOS_EN Fld(1,17,AC_MSKB2)//[17:17]
    #define MJC_MV_BGF_NO_BD Fld(1,16,AC_MSKB2)//[16:16]
    #define MJC_MV_BGF_H_BD Fld(8,8,AC_FULLB1)//[15:8]
    #define MJC_MV_BGF_V_BD Fld(8,0,AC_FULLB0)//[7:0]
#define MJC_MV_32 (MEMC_MJC + 0x8B0)
    #define MJC_CA_BLK_APL_FORCE_FMD Fld(1,22,AC_MSKB2)//[22:22]
    #define MJC_CA_BLK_APL_FORCE_VSI Fld(1,21,AC_MSKB2)//[21:21]
    #define MJC_CA_BLK_APL_OCC_OFF Fld(1,20,AC_MSKB2)//[20:20]
    #define MJC_CA_BLK_FBK_FORCE_FMD Fld(1,18,AC_MSKB2)//[18:18]
    #define MJC_CA_BLK_FBK_FORCE_VSI Fld(1,17,AC_MSKB2)//[17:17]
    #define MJC_CA_BLK_FBK_OCC_OFF Fld(1,16,AC_MSKB2)//[16:16]
    #define MJC_CA_OSD_REV_WT_OFF Fld(1,12,AC_MSKB1)//[12:12]
    #define MJC_CA_OSD_FORCE_FMD_TP2 Fld(1,10,AC_MSKB1)//[10:10]
    #define MJC_CA_OSD_FORCE_FMD_TP1 Fld(1,9,AC_MSKB1)//[9:9]
    #define MJC_CA_OSD_FORCE_FMD_TP0 Fld(1,8,AC_MSKB1)//[8:8]
    #define MJC_CA_OSD_FORCE_VSI_TP2 Fld(1,6,AC_MSKB0)//[6:6]
    #define MJC_CA_OSD_FORCE_VSI_TP1 Fld(1,5,AC_MSKB0)//[5:5]
    #define MJC_CA_OSD_FORCE_VSI_TP0 Fld(1,4,AC_MSKB0)//[4:4]
    #define MJC_CA_OSD_OCC_OFF_TP1 Fld(1,1,AC_MSKB0)//[1:1]
    #define MJC_CA_OSD_OCC_OFF_TP0 Fld(1,0,AC_MSKB0)//[0:0]
#define MJC_MV_33 (MEMC_MJC + 0x8B4)
    #define MJC_MV_TOC_FGEX_YGAIN2 Fld(4,28,AC_MSKB3)//[31:28]
    #define MJC_MV_TOC_BGEX_YGAIN2 Fld(4,24,AC_MSKB3)//[27:24]
    #define MJC_MV_TOC_FGEX_XGAIN2 Fld(4,20,AC_MSKB2)//[23:20]
    #define MJC_MV_TOC_BGEX_XGAIN2 Fld(4,16,AC_MSKB2)//[19:16]
    #define MJC_MV_TOC_TFDF_Y_THR Fld(4,12,AC_MSKB1)//[15:12]
    #define MJC_MV_TOC_TFDF_X_THR Fld(4,8,AC_MSKB1)//[11:8]
    #define MJC_MV_TOC_BI_OUT_BND_CHK Fld(1,6,AC_MSKB0)//[6:6]
    #define MJC_MV_TOC_2D_PRJ_MD Fld(2,4,AC_MSKB0)//[5:4]
    #define MJC_MV_TOC_TB_CHK_MD Fld(2,0,AC_MSKB0)//[1:0]
#define MJC_MV_34 (MEMC_MJC + 0x8B8)
    #define MJC_MV_TOC_FGEX_YMAX Fld(4,28,AC_MSKB3)//[31:28]
    #define MJC_MV_TOC_FGEX_YMIN Fld(4,24,AC_MSKB3)//[27:24]
    #define MJC_MV_TOC_BGEX_YMAX Fld(4,20,AC_MSKB2)//[23:20]
    #define MJC_MV_TOC_BGEX_YMIN Fld(4,16,AC_MSKB2)//[19:16]
    #define MJC_MV_TOC_FGEX_XMAX Fld(4,12,AC_MSKB1)//[15:12]
    #define MJC_MV_TOC_FGEX_XMIN Fld(4,8,AC_MSKB1)//[11:8]
    #define MJC_MV_TOC_BGEX_XMAX Fld(4,4,AC_MSKB0)//[7:4]
    #define MJC_MV_TOC_BGEX_XMIN Fld(4,0,AC_MSKB0)//[3:0]
#define MJC_MV_36 (MEMC_MJC + 0x8BC)
    #define MJC_MV_EXP_OVL Fld(1,3,AC_MSKB0)//[3:3]
    #define MJC_MV_EXP_OCC Fld(1,2,AC_MSKB0)//[2:2]
    #define MJC_MV_EXP_MVC Fld(1,1,AC_MSKB0)//[1:1]
    #define MJC_MV_EXP_PMC Fld(1,0,AC_MSKB0)//[0:0]
#define MJC_MV_37 (MEMC_MJC + 0x8C0)
    #define MJC_CA_LFB_GDFG_MVY_THR Fld(4,28,AC_MSKB3)//[31:28]
    #define MJC_CA_LFB_GDFG_MVX_THR Fld(4,24,AC_MSKB3)//[27:24]
    #define MJC_CA_LFB_GDFG_SM_TH1 Fld(4,16,AC_MSKB2)//[19:16]
    #define MJC_CA_LFB_GDFG_BC_TH2 Fld(4,12,AC_MSKB1)//[15:12]
    #define MJC_CA_LFB_GDFG_BC_TH1 Fld(4,8,AC_MSKB1)//[11:8]
    #define MJC_CA_LFB_GDFG_AD_TH2 Fld(4,4,AC_MSKB0)//[7:4]
    #define MJC_CA_LFB_GDFG_AD_TH1 Fld(4,0,AC_MSKB0)//[3:0]
#define MJC_MV_38 (MEMC_MJC + 0x8C4)
    #define MJC_CA_LFB_MVY_EQ_THR Fld(4,20,AC_MSKB2)//[23:20]
    #define MJC_CA_LFB_MVX_EQ_THR Fld(4,16,AC_MSKB2)//[19:16]
    #define MJC_CA_LFB_GDFG_MAJ3_TH2 Fld(6,8,AC_MSKB1)//[13:8]
    #define MJC_CA_LFB_GDFG_MAJ3_TH1 Fld(6,0,AC_MSKB0)//[5:0]
#define MJC_MV_39 (MEMC_MJC + 0x8C8)
    #define MJC_ADAP_OCC_OTHR_SEL_TH Fld(4,8,AC_MSKB1)//[11:8]
    #define MJC_MV_MFB_EQ_Y_THR Fld(4,4,AC_MSKB0)//[7:4]
    #define MJC_MV_MFB_EQ_X_THR Fld(4,0,AC_MSKB0)//[3:0]
#define MJC_MV_3B (MEMC_MJC + 0x8CC)
    #define MJC_MV_FLT_CHG_VIO_THR Fld(4,28,AC_MSKB3)//[31:28]
    #define MJC_MV_FLT_OBJ_WD_THR Fld(4,24,AC_MSKB3)//[27:24]
    #define MJC_MV_FLT_ZR_Y_THR Fld(4,20,AC_MSKB2)//[23:20]
    #define MJC_MV_FLT_ZR_X_THR Fld(4,16,AC_MSKB2)//[19:16]
    #define MJC_MV_FLT_SML_ALL_TH1 Fld(4,12,AC_MSKB1)//[15:12]
    #define MJC_MV_FLT_SML_ALL_TH0 Fld(4,8,AC_MSKB1)//[11:8]
    #define MJC_MV_FLT_SML_OBJ_TH1 Fld(4,4,AC_MSKB0)//[7:4]
    #define MJC_MV_FLT_SML_OBJ_TH0 Fld(4,0,AC_MSKB0)//[3:0]
#define MJC_MV_3C (MEMC_MJC + 0x8D0)
    #define MJC_MV_FLT_EN Fld(1,28,AC_MSKB3)//[28:28]
    #define MJC_MV_FLT_ADF_EN Fld(1,27,AC_MSKB3)//[27:27]
    #define MJC_MV_FLT_DEF_3X3 Fld(1,26,AC_MSKB3)//[26:26]
    #define MJC_MV_FLT_BDR_EN Fld(1,25,AC_MSKB3)//[25:25]
    #define MJC_MV_FLT_NRM_EN Fld(1,24,AC_MSKB3)//[24:24]
    #define MJC_MV_FLT_SEL_NEAR Fld(1,20,AC_MSKB2)//[20:20]
    #define MJC_MV_FLT_IGNORE_SML_CHG Fld(1,16,AC_MSKB2)//[16:16]
    #define MJC_MV_FLT_BDR_CLST_THR Fld(4,4,AC_MSKB0)//[7:4]
    #define MJC_MV_FLT_NRM_CLST_THR Fld(4,0,AC_MSKB0)//[3:0]
#define MJC_MV_3D (MEMC_MJC + 0x8D4)
    #define MJC_MV_FLT_DECI_EQ_Y_THR Fld(4,28,AC_MSKB3)//[31:28]
    #define MJC_MV_FLT_DECI_EQ_X_THR Fld(4,24,AC_MSKB3)//[27:24]
    #define MJC_MV_FLT_CLST_EQ_Y_THR Fld(4,20,AC_MSKB2)//[23:20]
    #define MJC_MV_FLT_CLST_EQ_X_THR Fld(4,16,AC_MSKB2)//[19:16]
    #define MJC_MV_FLT_SCAN_EQ_Y_THR Fld(4,12,AC_MSKB1)//[15:12]
    #define MJC_MV_FLT_SCAN_EQ_X_THR Fld(4,8,AC_MSKB1)//[11:8]
    #define MJC_MV_FLT_SORT_EQ_Y_THR Fld(4,4,AC_MSKB0)//[7:4]
    #define MJC_MV_FLT_SORT_EQ_X_THR Fld(4,0,AC_MSKB0)//[3:0]
#define MJC_CA_00 (MEMC_MJC + 0x8D8)
    #define MJC_CA_OSD_CRN_RAW_THR Fld(7,24,AC_MSKB3)//[30:24]
    #define MJC_CA_OSD_CRN_EGM_THR Fld(6,16,AC_MSKB2)//[21:16]
    #define MJC_CA_OSD_CRN_EGV_THR Fld(6,8,AC_MSKB1)//[13:8]
    #define MJC_CA_OSD_CRN_EGH_THR Fld(6,0,AC_MSKB0)//[5:0]
#define MJC_CA_01 (MEMC_MJC + 0x8DC)
    #define MJC_CA_OSD_EG_ACC_THR Fld(6,24,AC_MSKB3)//[29:24]
    #define MJC_CA_OSD_EG_MIN Fld(6,16,AC_MSKB2)//[21:16]
    #define MJC_CA_OSD_EG_MAX Fld(6,8,AC_MSKB1)//[13:8]
    #define MJC_CA_OSD_EG_OFST Fld(6,0,AC_MSKB0)//[5:0]

//Page MV_2
#define MJC_CA_02 (MEMC_MJC + 0x8E0)
    #define MJC_CA_OSD_CRN_MIN Fld(7,16,AC_MSKB2)//[22:16]
    #define MJC_CA_OSD_CRN_MAX Fld(7,8,AC_MSKB1)//[14:8]
    #define MJC_CA_OSD_CRN_OFST Fld(7,0,AC_MSKB0)//[6:0]
#define MJC_CA_03 (MEMC_MJC + 0x8E4)
    #define MJC_CA_OSD_CRN_EGS_THR Fld(4,20,AC_MSKB2)//[23:20]
    #define MJC_CA_OSD_EGV2_BLK_THR Fld(4,16,AC_MSKB2)//[19:16]
    #define MJC_CA_OSD_EGH2_BLK_THR Fld(4,12,AC_MSKB1)//[15:12]
    #define MJC_CA_OSD_EGV_BLK_THR Fld(4,8,AC_MSKB1)//[11:8]
    #define MJC_CA_OSD_EGH_BLK_THR Fld(4,4,AC_MSKB0)//[7:4]
    #define MJC_CA_OSD_CRN_BLK_THR Fld(4,0,AC_MSKB0)//[3:0]
#define MJC_CA_04 (MEMC_MJC + 0x8E8)
    #define MJC_CA_OSD_EGV_MVY_THR Fld(4,28,AC_MSKB3)//[31:28]
    #define MJC_CA_OSD_EGH_MVX_THR Fld(4,24,AC_MSKB3)//[27:24]
    #define MJC_CA_OSD_DET_BD_LR Fld(4,12,AC_MSKB1)//[15:12]
    #define MJC_CA_OSD_DET_BD_UD Fld(4,8,AC_MSKB1)//[11:8]
    #define MJC_CA_OSD_DET_BD_AUTO Fld(1,0,AC_MSKB0)//[0:0]
#define MJC_CA_05 (MEMC_MJC + 0x8EC)
    #define MJC_CA_OSD_ZRY_TH2 Fld(4,28,AC_MSKB3)//[31:28]
    #define MJC_CA_OSD_ZRX_TH2 Fld(4,24,AC_MSKB3)//[27:24]
    #define MJC_CA_OSD_ZRY_TH1 Fld(4,20,AC_MSKB2)//[23:20]
    #define MJC_CA_OSD_ZRX_TH1 Fld(4,16,AC_MSKB2)//[19:16]
    #define MJC_CA_OSD_ZERO_CHK_EN Fld(1,12,AC_MSKB1)//[12:12]
    #define MJC_CA_OSD_BOC_CHK_EN Fld(1,8,AC_MSKB1)//[8:8]
    #define MJC_CA_OSD_WHITE_THR Fld(6,0,AC_MSKB0)//[5:0]
#define MJC_CA_06 (MEMC_MJC + 0x8F0)
    #define MJC_CA_OSD_EGV_EN Fld(1,30,AC_MSKB3)//[30:30]
    #define MJC_CA_OSD_EGH_EN Fld(1,29,AC_MSKB3)//[29:29]
    #define MJC_CA_OSD_CRN_EN Fld(1,28,AC_MSKB3)//[28:28]
    #define MJC_CA_OSD_CRN_THIN_CHK Fld(1,24,AC_MSKB3)//[24:24]
    #define MJC_CA_OSD_EGV_CNT_THR Fld(8,16,AC_FULLB2)//[23:16]
    #define MJC_CA_OSD_EGH_CNT_THR Fld(8,8,AC_FULLB1)//[15:8]
    #define MJC_CA_OSD_CRN_CNT_THR Fld(8,0,AC_FULLB0)//[7:0]
#define MJC_CA_07 (MEMC_MJC + 0x8F4)
    #define MJC_CA_BOC_PRJ_Y_EXT Fld(4,28,AC_MSKB3)//[31:28]
    #define MJC_CA_BOC_PRJ_X_EXT Fld(4,24,AC_MSKB3)//[27:24]
    #define MJC_CA_BOC_EDG_Y_THR Fld(4,20,AC_MSKB2)//[23:20]
    #define MJC_CA_BOC_EDG_X_THR Fld(4,16,AC_MSKB2)//[19:16]
    #define MJC_CA_FGBG_MSAD_CHK Fld(1,0,AC_MSKB0)//[0:0]
#define MJC_CA_08 (MEMC_MJC + 0x8F8)
    #define MJC_CA_SAD_VAR_THR Fld(6,24,AC_MSKB3)//[29:24]
    #define MJC_CA_SAD_EDG_MIN Fld(6,16,AC_MSKB2)//[21:16]
    #define MJC_CA_SAD_EDG_MAX Fld(6,8,AC_MSKB1)//[13:8]
    #define MJC_CA_SAD_DBG_THR Fld(8,0,AC_FULLB0)//[7:0]
#define MJC_CA_09 (MEMC_MJC + 0x8FC)
    #define MJC_CA_SAD_EDG_COR Fld(4,20,AC_MSKB2)//[23:20]
    #define MJC_CA_CFB_SAD_THR Fld(4,16,AC_MSKB2)//[19:16]
    #define MJC_CA_CFB_ZR_Y_THR Fld(4,12,AC_MSKB1)//[15:12]
    #define MJC_CA_CFB_ZR_X_THR Fld(4,8,AC_MSKB1)//[11:8]
    #define MJC_CA_CFB_EQ_Y_THR Fld(4,4,AC_MSKB0)//[7:4]
    #define MJC_CA_CFB_EQ_X_THR Fld(4,0,AC_MSKB0)//[3:0]
#define MJC_CA_0A (MEMC_MJC + 0x900)
    #define MJC_CA_LFB_ADP_XY_THR Fld(4,28,AC_MSKB3)//[31:28]
    #define MJC_CA_LFB_ADP_EN Fld(1,24,AC_MSKB3)//[24:24]
    #define MJC_CA_LFB_ADP_Y_OFST Fld(4,20,AC_MSKB2)//[23:20]
    #define MJC_CA_LFB_ADP_X_OFST Fld(4,16,AC_MSKB2)//[19:16]
    #define MJC_CA_LFB_ADP_Y_TH1 Fld(4,12,AC_MSKB1)//[15:12]
    #define MJC_CA_LFB_ADP_X_TH1 Fld(4,8,AC_MSKB1)//[11:8]
    #define MJC_CA_LFB_ADP_Y_TH0 Fld(4,4,AC_MSKB0)//[7:4]
    #define MJC_CA_LFB_ADP_X_TH0 Fld(4,0,AC_MSKB0)//[3:0]
#define MJC_CA_0B (MEMC_MJC + 0x904)
    #define MJC_CA_OSD_SW_RST Fld(1,30,AC_MSKB3)//[30:30]
    #define MJC_CA_OSD_ROW_DEC_EN Fld(1,29,AC_MSKB3)//[29:29]
    #define MJC_CA_OSD_ROW_RST_EN Fld(1,28,AC_MSKB3)//[28:28]
    #define MJC_CA_OSD_FRM_DEC_EN Fld(1,25,AC_MSKB3)//[25:25]
    #define MJC_CA_OSD_FRM_RST_EN Fld(1,24,AC_MSKB3)//[24:24]
    #define MJC_CA_OSD_EGV_CNT_DEC Fld(8,16,AC_FULLB2)//[23:16]
    #define MJC_CA_OSD_EGH_CNT_DEC Fld(8,8,AC_FULLB1)//[15:8]
    #define MJC_CA_OSD_CRN_CNT_DEC Fld(8,0,AC_FULLB0)//[7:0]
#define MJC_CA_0C (MEMC_MJC + 0x908)
    #define MJC_CA_OSD_STL_CNT_DEC Fld(8,24,AC_FULLB3)//[31:24]
    #define MJC_CA_LFB_IGNORE_GBG Fld(1,11,AC_MSKB1)//[11:11]
    #define MJC_CA_LFB_IGNORE_SBG Fld(1,10,AC_MSKB1)//[10:10]
    #define MJC_CA_LFB_IGNORE_SFG Fld(1,9,AC_MSKB1)//[9:9]
    #define MJC_CA_LFB_IGNORE_SAD Fld(1,8,AC_MSKB1)//[8:8]
    #define MJC_CA_LFB_MJ3_THR Fld(8,0,AC_FULLB0)//[7:0]
#define MJC_CA_0D (MEMC_MJC + 0x90C)
    #define MJC_CA_HOC_BOC_SET2_BKY_TH Fld(4,8,AC_MSKB1)//[11:8]
    #define MJC_CA_HOC_BOC_SET2_EN Fld(1,7,AC_MSKB0)//[7:7]
    #define MJC_CA_HOC_TOC_IGNORE_NBR Fld(1,6,AC_MSKB0)//[6:6]
#define MJC_CA_0E (MEMC_MJC + 0x910)
    #define MJC_CA_BLK_FBK3_MSK1 Fld(4,28,AC_MSKB3)//[31:28]
    #define MJC_CA_BLK_FBK2_MSK2 Fld(4,24,AC_MSKB3)//[27:24]
    #define MJC_CA_BLK_FBK2_MSK1 Fld(4,20,AC_MSKB2)//[23:20]
    #define MJC_CA_BLK_FBK1_MSK2 Fld(4,16,AC_MSKB2)//[19:16]
    #define MJC_CA_BLK_FBK1_MSK1 Fld(7,8,AC_MSKB1)//[14:8]
    #define MJC_CA_BLK_FBK4_EN Fld(1,3,AC_MSKB0)//[3:3]
    #define MJC_CA_BLK_FBK3_EN Fld(1,2,AC_MSKB0)//[2:2]
    #define MJC_CA_BLK_FBK2_EN Fld(1,1,AC_MSKB0)//[1:1]
    #define MJC_CA_BLK_FBK1_EN Fld(1,0,AC_MSKB0)//[0:0]
#define MJC_CA_0F (MEMC_MJC + 0x914)
    #define MJC_CA_BLK_FBK_SAD_THR Fld(8,8,AC_FULLB1)//[15:8]
    #define MJC_CA_BLK_FBK2_CNT_THR Fld(4,4,AC_MSKB0)//[7:4]
    #define MJC_CA_BLK_FBK1_CNT_THR Fld(4,0,AC_MSKB0)//[3:0]
#define MJC_STA_MV_00 (MEMC_MJC + 0x918)
    #define MJC_STA_MAJOR_CNT1 Fld(16,16,AC_FULLW32)//[31:16]
    #define MJC_STA_MAJOR_CNT0 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_STA_MV_01 (MEMC_MJC + 0x91C)
    #define MJC_STA_MAJOR_CNT3 Fld(16,16,AC_FULLW32)//[31:16]
    #define MJC_STA_MAJOR_CNT2 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_STA_MV_02 (MEMC_MJC + 0x920)
    #define MJC_STA_MAJOR_CNT5 Fld(16,16,AC_FULLW32)//[31:16]
    #define MJC_STA_MAJOR_CNT4 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_STA_MV_03 (MEMC_MJC + 0x924)
    #define MJC_STA_MAJOR_CNT7 Fld(16,16,AC_FULLW32)//[31:16]
    #define MJC_STA_MAJOR_CNT6 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_STA_MV_04 (MEMC_MJC + 0x928)
    #define MJC_STA_MAJOR_MV0 Fld(19,0,AC_MSKDW)//[18:0]
#define MJC_STA_MV_05 (MEMC_MJC + 0x92C)
    #define MJC_STA_MAJOR_MV1 Fld(19,0,AC_MSKDW)//[18:0]
#define MJC_STA_MV_06 (MEMC_MJC + 0x930)
    #define MJC_STA_MAJOR_MV2 Fld(19,0,AC_MSKDW)//[18:0]
#define MJC_STA_MV_07 (MEMC_MJC + 0x934)
    #define MJC_STA_MAJOR_MV3 Fld(19,0,AC_MSKDW)//[18:0]
#define MJC_STA_MV_08 (MEMC_MJC + 0x938)
    #define MJC_STA_MAJOR_MV4 Fld(19,0,AC_MSKDW)//[18:0]
#define MJC_STA_MV_09 (MEMC_MJC + 0x93C)
    #define MJC_STA_MAJOR_MV5 Fld(19,0,AC_MSKDW)//[18:0]
#define MJC_STA_MV_0A (MEMC_MJC + 0x940)
    #define MJC_STA_MAJOR_MV6 Fld(19,0,AC_MSKDW)//[18:0]
#define MJC_STA_MV_0E (MEMC_MJC + 0x944)
    #define MJC_DBG_HLEAD_CNT Fld(8,16,AC_FULLB2)//[23:16]
    #define MJC_DBG_MAJOR_CNT Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_STA_MV_0F (MEMC_MJC + 0x948)
    #define MJC_MV_CRC Fld(32,0,AC_FULLDW)//[31:0]
#define MJC_STA_PSG_00 (MEMC_MJC + 0x94C)
    #define MJC_BDR_VSI_SUM Fld(16,16,AC_FULLW32)//[31:16]
    #define MJC_NRM_VSI_SUM Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_STA_PSG_01 (MEMC_MJC + 0x950)
    #define MJC_TOTAL_CNT Fld(16,16,AC_FULLW32)//[31:16]
    #define MJC_MOT_VAR_SUM Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_STA_PSG_02 (MEMC_MJC + 0x954)
    #define MJC_BAD_MOT_CNT Fld(16,16,AC_FULLW32)//[31:16]
    #define MJC_TOTAL_MOT_CNT Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_STA_PSG_03 (MEMC_MJC + 0x958)
    #define MJC_GOOD_VAR_CNT Fld(16,16,AC_FULLW32)//[31:16]
    #define MJC_GOOD_MOT_CNT Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_STA_PSG_04 (MEMC_MJC + 0x95C)
    #define MJC_MVY_LRG_CNT Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_STA_PSG_05 (MEMC_MJC + 0x960)
    #define MJC_BAD_BGMV_CNT Fld(16,16,AC_FULLW32)//[31:16]
    #define MJC_GOOD_BGMV_CNT Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_STA_PSG_06 (MEMC_MJC + 0x964)
    #define MJC_OSD_CNT Fld(16,16,AC_FULLW32)//[31:16]
    #define MJC_OCC_CNT Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_STA_PSG_07 (MEMC_MJC + 0x968)
    #define MJC_MV_ERR2 Fld(16,16,AC_FULLW32)//[31:16]
    #define MJC_MV_ERR1 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_STA_PSG_08 (MEMC_MJC + 0x96C)
    #define MJC_MV_ERR4 Fld(16,16,AC_FULLW32)//[31:16]
    #define MJC_MV_ERR3 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_STA_PSG_09 (MEMC_MJC + 0x970)
    #define MJC_OCC_ERR2 Fld(16,16,AC_FULLW32)//[31:16]
    #define MJC_OCC_ERR1 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_STA_PSG_0A (MEMC_MJC + 0x974)
    #define MJC_OSD_ERR2 Fld(16,16,AC_FULLW32)//[31:16]
    #define MJC_OSD_ERR1 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_STA_OHT_00 (MEMC_MJC + 0x97C)
    #define MJC_OCC_HST_X1 Fld(16,16,AC_FULLW32)//[31:16]
    #define MJC_OCC_HST_X0 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_STA_OHT_01 (MEMC_MJC + 0x980)
    #define MJC_OCC_HST_X3 Fld(16,16,AC_FULLW32)//[31:16]
    #define MJC_OCC_HST_X2 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_STA_OHT_02 (MEMC_MJC + 0x984)
    #define MJC_OCC_HST_X5 Fld(16,16,AC_FULLW32)//[31:16]
    #define MJC_OCC_HST_X4 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_STA_OHT_03 (MEMC_MJC + 0x988)
    #define MJC_OCC_HST_X7 Fld(16,16,AC_FULLW32)//[31:16]
    #define MJC_OCC_HST_X6 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_STA_OHT_04 (MEMC_MJC + 0x98C)
    #define MJC_OCC_HST_Y1 Fld(16,16,AC_FULLW32)//[31:16]
    #define MJC_OCC_HST_Y0 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_STA_OHT_05 (MEMC_MJC + 0x990)
    #define MJC_OCC_HST_Y3 Fld(16,16,AC_FULLW32)//[31:16]
    #define MJC_OCC_HST_Y2 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_STA_OHT_06 (MEMC_MJC + 0x994)
    #define MJC_OCC_HST_Y4 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_STA_BG (MEMC_MJC + 0x99C)
    #define MJC_MV_BG Fld(19,0,AC_MSKDW)//[18:0]
    #define MJC_STA_MV_BG_X Fld(10,9,AC_MSKW21)//[18:9]
    #define MJC_STA_MV_BG_Y Fld(9,0,AC_MSKW10)//[8:0]
#define MJC_STA_MH_00 (MEMC_MJC + 0x9A0)
    #define MJC_MV_X_GRM01 Fld(16,16,AC_FULLW32)//[31:16]
    #define MJC_MV_X_GRM00 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_STA_MH_01 (MEMC_MJC + 0x9A4)
    #define MJC_MV_X_GRM03 Fld(16,16,AC_FULLW32)//[31:16]
    #define MJC_MV_X_GRM02 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_STA_MH_02 (MEMC_MJC + 0x9A8)
    #define MJC_MV_X_GRM05 Fld(16,16,AC_FULLW32)//[31:16]
    #define MJC_MV_X_GRM04 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_STA_MH_03 (MEMC_MJC + 0x9AC)
    #define MJC_MV_X_GRM07 Fld(16,16,AC_FULLW32)//[31:16]
    #define MJC_MV_X_GRM06 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_STA_MH_04 (MEMC_MJC + 0x9B0)
    #define MJC_MV_X_GRM09 Fld(16,16,AC_FULLW32)//[31:16]
    #define MJC_MV_X_GRM08 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_STA_MH_05 (MEMC_MJC + 0x9B4)
    #define MJC_MV_X_GRM11 Fld(16,16,AC_FULLW32)//[31:16]
    #define MJC_MV_X_GRM10 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_STA_MH_06 (MEMC_MJC + 0x9B8)
    #define MJC_MV_X_GRM13 Fld(16,16,AC_FULLW32)//[31:16]
    #define MJC_MV_X_GRM12 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_STA_MH_07 (MEMC_MJC + 0x9BC)
    #define MJC_MV_X_GRM15 Fld(16,16,AC_FULLW32)//[31:16]
    #define MJC_MV_X_GRM14 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_STA_MH_08 (MEMC_MJC + 0x9C0)
    #define MJC_MV_X_GRM17 Fld(16,16,AC_FULLW32)//[31:16]
    #define MJC_MV_X_GRM16 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_STA_MH_09 (MEMC_MJC + 0x9C4)
    #define MJC_MV_X_GRM19 Fld(16,16,AC_FULLW32)//[31:16]
    #define MJC_MV_X_GRM18 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_STA_MH_0A (MEMC_MJC + 0x9C8)
    #define MJC_MV_Y_GRM01 Fld(16,16,AC_FULLW32)//[31:16]
    #define MJC_MV_Y_GRM00 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_STA_MH_0B (MEMC_MJC + 0x9CC)
    #define MJC_MV_Y_GRM03 Fld(16,16,AC_FULLW32)//[31:16]
    #define MJC_MV_Y_GRM02 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_STA_MH_0C (MEMC_MJC + 0x9D0)
    #define MJC_MV_Y_GRM05 Fld(16,16,AC_FULLW32)//[31:16]
    #define MJC_MV_Y_GRM04 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_STA_MH_0D (MEMC_MJC + 0x9D4)
    #define MJC_MV_Y_GRM07 Fld(16,16,AC_FULLW32)//[31:16]
    #define MJC_MV_Y_GRM06 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_STA_MH_0E (MEMC_MJC + 0x9D8)
    #define MJC_MV_Y_GRM09 Fld(16,16,AC_FULLW32)//[31:16]
    #define MJC_MV_Y_GRM08 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_STA_MH_0F (MEMC_MJC + 0x9DC)
    #define MJC_MV_Y_GRM11 Fld(16,16,AC_FULLW32)//[31:16]
    #define MJC_MV_Y_GRM10 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_STA_MH_10 (MEMC_MJC + 0x9E0)
    #define MJC_MV_Y_GRM13 Fld(16,16,AC_FULLW32)//[31:16]
    #define MJC_MV_Y_GRM12 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_STA_MH_11 (MEMC_MJC + 0x9E4)
    #define MJC_MV_Y_GRM15 Fld(16,16,AC_FULLW32)//[31:16]
    #define MJC_MV_Y_GRM14 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_STA_MH_12 (MEMC_MJC + 0x9E8)
    #define MJC_MV_X2_GRM1 Fld(16,16,AC_FULLW32)//[31:16]
    #define MJC_MV_X2_GRM0 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_STA_MH_13 (MEMC_MJC + 0x9EC)
    #define MJC_MV_X2_GRM3 Fld(16,16,AC_FULLW32)//[31:16]
    #define MJC_MV_X2_GRM2 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_STA_MH_14 (MEMC_MJC + 0x9F0)
    #define MJC_MV_X2_GRM5 Fld(16,16,AC_FULLW32)//[31:16]
    #define MJC_MV_X2_GRM4 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_STA_MH_15 (MEMC_MJC + 0x9F4)
    #define MJC_MV_X2_GRM7 Fld(16,16,AC_FULLW32)//[31:16]
    #define MJC_MV_X2_GRM6 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_STA_MH_16 (MEMC_MJC + 0x9F8)
    #define MJC_MV_Y2_GRM1 Fld(16,16,AC_FULLW32)//[31:16]
    #define MJC_MV_Y2_GRM0 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_STA_MH_17 (MEMC_MJC + 0x9FC)
    #define MJC_MV_Y2_GRM3 Fld(16,16,AC_FULLW32)//[31:16]
    #define MJC_MV_Y2_GRM2 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_STA_MH_18 (MEMC_MJC + 0xA00)
    #define MJC_MV_Y2_GRM5 Fld(16,16,AC_FULLW32)//[31:16]
    #define MJC_MV_Y2_GRM4 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_STA_MH_19 (MEMC_MJC + 0xA04)
    #define MJC_MV_Y2_GRM7 Fld(16,16,AC_FULLW32)//[31:16]
    #define MJC_MV_Y2_GRM6 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_STA_MH_1A (MEMC_MJC + 0xA08)
    #define MJC_MV_ZERO Fld(16,16,AC_FULLW32)//[31:16]
#define MJC_MV_FRM_DS (MEMC_MJC + 0xA0C)
    #define MJC_MV_FRM_DS_GAIN_EN Fld(1,28,AC_MSKB3)//[28:28]
    #define MJC_MV_FRM_DS_CLIP_EN Fld(1,24,AC_MSKB3)//[24:24]
    #define MJC_MV_FRM_DS_X_GAIN Fld(4,20,AC_MSKB2)//[23:20]
    #define MJC_MV_FRM_DS_Y_GAIN Fld(4,16,AC_MSKB2)//[19:16]
    #define MJC_MV_FRM_DS_X_CLIP Fld(8,8,AC_FULLB1)//[15:8]
    #define MJC_MV_FRM_DS_Y_CLIP Fld(8,0,AC_FULLB0)//[7:0]
#define MJC_MV_DRAM1 (MEMC_MJC + 0xA1C)
    #define MJC_STA_RD_ALE_CNT Fld(8,8,AC_FULLB1)//[15:8]
    #define MJC_STA_RD_DLE_CNT Fld(8,0,AC_FULLB0)//[7:0]
#define MJC_MV_DRAM2 (MEMC_MJC + 0xA20)
    #define MJC_C_MV_DRAM_TEST_PAT Fld(1,24,AC_MSKB3)//[24:24]
    #define MJC_C_MV_DRAM_WRITE_RSP Fld(1,20,AC_MSKB2)//[20:20]
    #define MJC_MV_DRAM_DEBUG Fld(2,16,AC_MSKB2)//[17:16]
    #define MJC_MV_DRAM_LIMIT Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_MV_PAD2 (MEMC_MJC + 0xA24)
    #define MJC_MV_PAD_BND_FG_H_OFST Fld(8,0,AC_FULLB0)//[7:0]
#define MJC_MV_PAD (MEMC_MJC + 0xA28)
    #define MJC_MV_PAD_DN_OS_REF Fld(4,28,AC_MSKB3)//[31:28]
    #define MJC_MV_PAD_UP_OS_REF Fld(4,24,AC_MSKB3)//[27:24]
    #define MJC_MV_PAD_DN_OS_TAR Fld(4,20,AC_MSKB2)//[23:20]
    #define MJC_MV_PAD_UP_OS_TAR Fld(4,16,AC_MSKB2)//[19:16]
    #define MJC_MV_PAD_DN_HT Fld(4,12,AC_MSKB1)//[15:12]
    #define MJC_MV_PAD_UP_HT Fld(4,8,AC_MSKB1)//[11:8]
    #define MJC_MV_PAD_DN_HT_FG Fld(4,4,AC_MSKB0)//[7:4]
    #define MJC_MV_PAD_UP_HT_FG Fld(4,0,AC_MSKB0)//[3:0]
#define MJC_CA_PAD (MEMC_MJC + 0xA2C)
    #define MJC_MV_PAD_DN_EN Fld(1,31,AC_MSKB3)//[31:31]
    #define MJC_MV_PAD_UP_EN Fld(1,30,AC_MSKB3)//[30:30]
    #define MJC_MV_PAD_BND_FG_DET_DN_EN Fld(1,29,AC_MSKB3)//[29:29]
    #define MJC_MV_PAD_BND_FG_DET_UP_EN Fld(1,28,AC_MSKB3)//[28:28]
    #define MJC_MV_PAD_BND_FG_STA_RST Fld(1,27,AC_MSKB3)//[27:27]
    #define MJC_CA_OSD_ZERO_CHK_PAD_OFF Fld(1,26,AC_MSKB3)//[26:26]
    #define MJC_CA_OSD_BOC_CHK_PAD_OFF Fld(1,25,AC_MSKB3)//[25:25]
    #define MJC_CA_OSD_CNT_THR_PAD_SEL Fld(1,24,AC_MSKB3)//[24:24]
    #define MJC_CA_OSD_EGV_CNT_THR_PAD Fld(8,16,AC_FULLB2)//[23:16]
    #define MJC_CA_OSD_EGH_CNT_THR_PAD Fld(8,8,AC_FULLB1)//[15:8]
    #define MJC_CA_OSD_CRN_CNT_THR_PAD Fld(8,0,AC_FULLB0)//[7:0]
#define MJC_MV_TBA_0 (MEMC_MJC + 0xA50)
    #define MJC_TBA_BND_DN Fld(8,24,AC_FULLB3)//[31:24]
    #define MJC_TBA_BND_UP Fld(8,16,AC_FULLB2)//[23:16]
    #define MJC_TBA_BND_RT Fld(8,8,AC_FULLB1)//[15:8]
    #define MJC_TBA_BND_LF Fld(8,0,AC_FULLB0)//[7:0]
#define MJC_MV_TBA_1 (MEMC_MJC + 0xA54)
    #define MJC_TBA_ZRGMV_OFF Fld(1,17,AC_MSKB2)//[17:17]
    #define MJC_TBA_BND_LBOX_AUTO Fld(1,16,AC_MSKB2)//[16:16]
#define MJC_MV_TBA_3 (MEMC_MJC + 0xA5C)
    #define MJC_TBA_YEG_RTO_CLP_TH_N Fld(4,28,AC_MSKB3)//[31:28]
    #define MJC_TBA_YEG_RTO_CLP_TH_P Fld(4,24,AC_MSKB3)//[27:24]
    #define MJC_TBA_YAV_RTO_CLP_TH_N Fld(4,20,AC_MSKB2)//[23:20]
    #define MJC_TBA_YAV_RTO_CLP_TH_P Fld(4,16,AC_MSKB2)//[19:16]
    #define MJC_TBA_VAR_RTO_CLP_TH_N Fld(4,12,AC_MSKB1)//[15:12]
    #define MJC_TBA_VAR_RTO_CLP_TH_P Fld(4,8,AC_MSKB1)//[11:8]
    #define MJC_TBA_SAD_RTO_CLP_TH_N Fld(4,4,AC_MSKB0)//[7:4]
    #define MJC_TBA_SAD_RTO_CLP_TH_P Fld(4,0,AC_MSKB0)//[3:0]

//Page MV_3
#define MJC_MV_TBA_4 (MEMC_MJC + 0xA60)
    #define MJC_TBA_MVDF_LMRM_SUM_TH Fld(4,28,AC_MSKB3)//[31:28]
    #define MJC_TBA_MVDF_LMRM_MAX_TH Fld(4,24,AC_MSKB3)//[27:24]
    #define MJC_TBA_MVDF_LR_SUM_TH Fld(4,20,AC_MSKB2)//[23:20]
    #define MJC_TBA_MVDF_LR_MAX_TH Fld(4,16,AC_MSKB2)//[19:16]
    #define MJC_TBA_PCCV_RTO_TH Fld(5,10,AC_MSKB1)//[14:10]
    #define MJC_TBA_CNCV_RTO_TH Fld(5,5,AC_MSKW10)//[9:5]
    #define MJC_TBA_PCUC_RTO_TH Fld(5,0,AC_MSKB0)//[4:0]
#define MJC_MV_TBA_5 (MEMC_MJC + 0xA64)
    #define MJC_MV_TBA_WT_EN Fld(1,24,AC_MSKB3)//[24:24]
    #define MJC_MV_TBA_STR_ADR_L Fld(24,0,AC_MSKDW)//[23:0]
#define MJC_MV_TBA_6 (MEMC_MJC + 0xA68)
    #define MJC_MV_TBA_END_ADR_L Fld(24,0,AC_MSKDW)//[23:0]
#define MJC_MV_TBA_7 (MEMC_MJC + 0xA6C)
    #define MJC_TBA_TFOCC_FORCE_EN Fld(1,31,AC_MSKB3)//[31:31]
    #define MJC_TBA_TFOCC_FORCE_TYP Fld(3,28,AC_MSKB3)//[30:28]
    #define MJC_TBA_MV_MED_VIO_TH Fld(4,24,AC_MSKB3)//[27:24]
    #define MJC_TBA_MV_TB_VIO_TH Fld(4,20,AC_MSKB2)//[23:20]
    #define MJC_TBA_AVG_DYR_CLP_TH Fld(4,12,AC_MSKB1)//[15:12]
    #define MJC_TBA_VAR_REF_CLP_TH Fld(4,8,AC_MSKB1)//[11:8]
    #define MJC_TBA_AVG_REF_CLP_TH Fld(4,4,AC_MSKB0)//[7:4]
    #define MJC_TBA_SAD_REF_CLP_TH Fld(4,0,AC_MSKB0)//[3:0]
#define MJC_MV_TBA_8 (MEMC_MJC + 0xA70)
    #define MJC_TBA_MV_VIO_MSK Fld(4,12,AC_MSKB1)//[15:12]
    #define MJC_TBA_YAV_RTO_CLP_TH2_P Fld(4,8,AC_MSKB1)//[11:8]
    #define MJC_TBA_VAR_RTO_CLP_TH2_P Fld(4,4,AC_MSKB0)//[7:4]
    #define MJC_TBA_SAD_RTO_CLP_TH2_P Fld(4,0,AC_MSKB0)//[3:0]
#define MJC_MV_TBA_9 (MEMC_MJC + 0xA74)
    #define MJC_TBA_SMLOBJ_MODE Fld(1,23,AC_MSKB2)//[23:23]
    #define MJC_TBA_3D_MODE Fld(1,22,AC_MSKB2)//[22:22]
    #define MJC_PCN_SAD_REF_SFT Fld(2,18,AC_MSKB2)//[19:18]
    #define MJC_PCN_DYR_REF_SFT Fld(2,16,AC_MSKB2)//[17:16]
#define MJC_CA_TBA_0 (MEMC_MJC + 0xA78)
    #define MJC_CA_TBA_PT_EQ_Y_THR Fld(4,28,AC_MSKB3)//[31:28]
    #define MJC_CA_TBA_PT_EQ_X_THR Fld(4,24,AC_MSKB3)//[27:24]
    #define MJC_CA_TBA_PZ_EQ_Y_THR Fld(4,20,AC_MSKB2)//[23:20]
    #define MJC_CA_TBA_PZ_EQ_X_THR Fld(4,16,AC_MSKB2)//[19:16]
    #define MJC_CA_TBA_PB_EQ_Y_THR Fld(4,12,AC_MSKB1)//[15:12]
    #define MJC_CA_TBA_PB_EQ_X_THR Fld(4,8,AC_MSKB1)//[11:8]
    #define MJC_CA_TBA_NB_EQ_Y_THR Fld(4,4,AC_MSKB0)//[7:4]
    #define MJC_CA_TBA_NB_EQ_X_THR Fld(4,0,AC_MSKB0)//[3:0]
#define MJC_CA_TBA_1 (MEMC_MJC + 0xA7C)
    #define MJC_CA_TBA_EDG_Y_THR Fld(4,20,AC_MSKB2)//[23:20]
    #define MJC_CA_TBA_EDG_X_THR Fld(4,16,AC_MSKB2)//[19:16]
    #define MJC_CA_TBA_PTDF_CNT2_TH Fld(4,4,AC_MSKB0)//[7:4]
    #define MJC_CA_TBA_PTDF_CNT1_TH Fld(4,0,AC_MSKB0)//[3:0]
#define MJC_MV_OOB (MEMC_MJC + 0xA80)
    #define MJC_MV_WT_OOB_CLEAR Fld(1,31,AC_MSKB3)//[31:31]
    #define MJC_MV_RD_OOB_CLEAR Fld(1,27,AC_MSKB3)//[27:27]
    #define MJC_STA_RD_TF_OOB Fld(1,6,AC_MSKB0)//[6:6]
    #define MJC_STA_RD_BI_OOB Fld(1,5,AC_MSKB0)//[5:5]
    #define MJC_STA_RD_TD_OOB Fld(1,4,AC_MSKB0)//[4:4]
    #define MJC_STA_WT_TF_OOB Fld(1,2,AC_MSKB0)//[2:2]
    #define MJC_STA_WT_BI_OOB Fld(1,1,AC_MSKB0)//[1:1]
    #define MJC_STA_WT_TD_OOB Fld(1,0,AC_MSKB0)//[0:0]
#define MJC_STA_GMV_M3 (MEMC_MJC + 0xA88)
    #define MJC_GMV_BI_M3_X Fld(10,16,AC_MSKW32)//[25:16]
    #define MJC_GMV_BI_M3_Y Fld(9,0,AC_MSKW10)//[8:0]
#define MJC_MV_TBA_A (MEMC_MJC + 0xA8C)
    #define MJC_TBA_GMV_SEL Fld(2,25,AC_MSKB3)//[26:25]
    #define MJC_TBA_MVEXP_OFF Fld(1,24,AC_MSKB3)//[24:24]
    #define MJC_MV_TBA_STR_ADR_R Fld(24,0,AC_MSKDW)//[23:0]
#define MJC_MV_TBA_B (MEMC_MJC + 0xA90)
    #define MJC_MV_TBA_END_ADR_R Fld(24,0,AC_MSKDW)//[23:0]
#define MJC_MV_TBA_C (MEMC_MJC + 0xA94)
    #define MJC_TBA_CST_GAIN_SEL Fld(8,0,AC_FULLB0)//[7:0]
#define MJC_STA_TBA_0 (MEMC_MJC + 0xA98)
    #define MJC_STA_RTO_SAD_CNT Fld(24,0,AC_MSKDW)//[23:0]
#define MJC_STA_TBA_1 (MEMC_MJC + 0xA9C)
    #define MJC_STA_RTO_AVG_CNT Fld(24,0,AC_MSKDW)//[23:0]
#define MJC_STA_TBA_2 (MEMC_MJC + 0xAA0)
    #define MJC_STA_RTO_EDG_CNT Fld(24,0,AC_MSKDW)//[23:0]
#define MJC_STA_TBA_3 (MEMC_MJC + 0xAA4)
    #define MJC_STA_CNCV_CNT Fld(16,16,AC_FULLW32)//[31:16]
    #define MJC_STA_PCUC_CNT Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_STA_TBA_4 (MEMC_MJC + 0xAA8)
    #define MJC_STA_TBA_GTRK_MAX_VLID_FRM_CNT Fld(6,16,AC_MSKB2)//[21:16]
    #define MJC_STA_PCCV_CNT Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_MV_TBA_D (MEMC_MJC + 0xAAC)
    #define MJC_TBA_LR_REF_USE_LC Fld(1,31,AC_MSKB3)//[31:31]
    #define MJC_TBA_CNCV_RTO_TH3 Fld(5,21,AC_MSKW32)//[25:21]
    #define MJC_TBA_PCUC_RTO_TH3 Fld(5,16,AC_MSKB2)//[20:16]
    #define MJC_TBA_EDG_RTO_TH3 Fld(4,12,AC_MSKB1)//[15:12]
    #define MJC_TBA_AVG_RTO_TH3 Fld(4,8,AC_MSKB1)//[11:8]
    #define MJC_TBA_VAR_RTO_TH3 Fld(4,4,AC_MSKB0)//[7:4]
    #define MJC_TBA_SAD_RTO_TH3 Fld(4,0,AC_MSKB0)//[3:0]
#define MJC_MV_TBA_E (MEMC_MJC + 0xAB0)
    #define MJC_DIR_HOC_DET_MSK_F Fld(4,12,AC_MSKB1)//[15:12]
    #define MJC_DIR_HOC_DET_MSK_V Fld(4,8,AC_MSKB1)//[11:8]
    #define MJC_DIR_AOC2_EN_MSK_F Fld(2,6,AC_MSKB0)//[7:6]
    #define MJC_DIR_AOC1_EN_MSK_F Fld(2,4,AC_MSKB0)//[5:4]
    #define MJC_DIR_AOC2_EN_MSK_V Fld(2,2,AC_MSKB0)//[3:2]
    #define MJC_DIR_AOC1_EN_MSK_V Fld(2,0,AC_MSKB0)//[1:0]
#define MJC_MV_TBA_F (MEMC_MJC + 0xAB4)
    #define MJC_DIR_HOC_CHK_4_MSK_V Fld(8,24,AC_FULLB3)//[31:24]
    #define MJC_DIR_HOC_CHK_3_MSK_V Fld(8,16,AC_FULLB2)//[23:16]
    #define MJC_DIR_HOC_CHK_2_MSK_V Fld(8,8,AC_FULLB1)//[15:8]
    #define MJC_DIR_HOC_CHK_1_MSK_V Fld(8,0,AC_FULLB0)//[7:0]
#define MJC_MV_TBA_10 (MEMC_MJC + 0xAB8)
    #define MJC_DIR_HOC_CHK_4_MSK_F Fld(8,24,AC_FULLB3)//[31:24]
    #define MJC_DIR_HOC_CHK_3_MSK_F Fld(8,16,AC_FULLB2)//[23:16]
    #define MJC_DIR_HOC_CHK_2_MSK_F Fld(8,8,AC_FULLB1)//[15:8]
    #define MJC_DIR_HOC_CHK_1_MSK_F Fld(8,0,AC_FULLB0)//[7:0]
#define MJC_MV_DSC_0 (MEMC_MJC + 0xABC)
    #define MJC_MV_DSC_X_GAIN_EN Fld(1,27,AC_MSKB3)//[27:27]
    #define MJC_MV_DSC_Y_GAIN_EN Fld(1,26,AC_MSKB3)//[26:26]
    #define MJC_MV_DSC_X_CLIP_EN Fld(1,25,AC_MSKB3)//[25:25]
    #define MJC_MV_DSC_Y_CLIP_EN Fld(1,24,AC_MSKB3)//[24:24]
    #define MJC_MV_DSC_X_GAIN Fld(4,20,AC_MSKB2)//[23:20]
    #define MJC_MV_DSC_Y_GAIN Fld(4,16,AC_MSKB2)//[19:16]
    #define MJC_MV_DSC_Y_CLIP Fld(8,8,AC_FULLB1)//[15:8]
    #define MJC_MV_DSC_X_CLIP Fld(8,0,AC_FULLB0)//[7:0]
#define MJC_MV_DSC_1 (MEMC_MJC + 0xAC0)
    #define MJC_MV_DSC_X_BLK_TH Fld(8,24,AC_FULLB3)//[31:24]
    #define MJC_MV_DSC_Y_BLK_TH Fld(8,16,AC_FULLB2)//[23:16]
    #define MJC_MV_DSC_X_FDP_TH Fld(8,8,AC_FULLB1)//[15:8]
    #define MJC_MV_DSC_Y_FDP_TH Fld(8,0,AC_FULLB0)//[7:0]
#define MJC_MV_DSC_2 (MEMC_MJC + 0xAC4)
    #define MJC_MV_DSC_BLK_EN_V Fld(1,31,AC_MSKB3)//[31:31]
    #define MJC_MV_DSC_FDP_EN_V Fld(1,30,AC_MSKB3)//[30:30]
    #define MJC_MV_DSC_MEG_EN_V Fld(1,29,AC_MSKB3)//[29:29]
    #define MJC_MV_DSC_BFB_EN_V Fld(1,28,AC_MSKB3)//[28:28]
    #define MJC_MV_DSC_BLK_EN_F Fld(1,27,AC_MSKB3)//[27:27]
    #define MJC_MV_DSC_FDP_EN_F Fld(1,26,AC_MSKB3)//[26:26]
    #define MJC_MV_DSC_MEG_EN_F Fld(1,25,AC_MSKB3)//[25:25]
    #define MJC_MV_DSC_BFB_EN_F Fld(1,24,AC_MSKB3)//[24:24]
    #define MJC_MV_DSC_X_MEG_TH Fld(8,8,AC_FULLB1)//[15:8]
    #define MJC_MV_DSC_Y_MEG_TH Fld(8,0,AC_FULLB0)//[7:0]
#define MJC_MV_FDP_0 (MEMC_MJC + 0xAC8)
    #define MJC_FDP_APLSC_OFF Fld(1,28,AC_MSKB3)//[28:28]
    #define MJC_FDP_MESC_OFF Fld(1,27,AC_MSKB3)//[27:27]
    #define MJC_STA_FRM_DROP Fld(1,26,AC_MSKB3)//[26:26]
    #define MJC_FDP_FW_FORCE Fld(1,25,AC_MSKB3)//[25:25]
    #define MJC_FDP_HW_EN Fld(1,24,AC_MSKB3)//[24:24]
    #define MJC_FDP_PCCN_CNT_TH1 Fld(8,16,AC_FULLB2)//[23:16]
    #define MJC_FDP_PCCN_CNT_TH2 Fld(8,8,AC_FULLB1)//[15:8]
    #define MJC_FDP_PCCV_CNT_TH Fld(8,0,AC_FULLB0)//[7:0]
#define MJC_MV_FDP_1 (MEMC_MJC + 0xACC)
    #define MJC_FDP_MV_TPDF_CNT_TH Fld(12,0,AC_MSKW10)//[11:0]
#define MJC_CA_MEG_0 (MEMC_MJC + 0xAD0)
    #define MJC_CA_MEG_LMV_X_TH Fld(8,24,AC_FULLB3)//[31:24]
    #define MJC_CA_MEG_LMV_Y_TH Fld(8,16,AC_FULLB2)//[23:16]
    #define MJC_CA_MEG_XGEY_TH Fld(4,12,AC_MSKB1)//[15:12]
    #define MJC_CA_MEG_YGEX_TH Fld(4,8,AC_MSKB1)//[11:8]
    #define MJC_CA_MEG_SEL_MV_GAIN Fld(3,4,AC_MSKB0)//[6:4]
    #define MJC_CA_MEG_SEL_MV_OFST Fld(3,0,AC_MSKB0)//[2:0]
#define MJC_CA_MEG_1 (MEMC_MJC + 0xAD4)
    #define MJC_CA_MEG_SEL_MV_CLIP Fld(4,28,AC_MSKB3)//[31:28]
    #define MJC_CA_MEG_SAD_TH Fld(4,24,AC_MSKB3)//[27:24]
    #define MJC_CA_MEG_VSI_TH Fld(4,20,AC_MSKB2)//[23:20]
    #define MJC_CA_MEG_EDG_TH Fld(4,16,AC_MSKB2)//[19:16]
    #define MJC_CA_MEG_VAR_TH Fld(4,12,AC_MSKB1)//[15:12]
#define MJC_STA_MEG_0 (MEMC_MJC + 0xAD8)
    #define MJC_STA_MEG_SAD_ERR_CNT Fld(16,16,AC_FULLW32)//[31:16]
    #define MJC_STA_MEG_VSI_ERR_CNT Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_STA_MEG_1 (MEMC_MJC + 0xADC)
    #define MJC_STA_MEG_MOV_EDG_CNT Fld(16,16,AC_FULLW32)//[31:16]
    #define MJC_STA_MEG_TEXTURE_CNT Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_MVTPDF_0 (MEMC_MJC + 0xAE0)
    #define MJC_MV_TPDF_MIN_X_TH Fld(8,24,AC_FULLB3)//[31:24]
    #define MJC_MV_TPDF_MIN_Y_TH Fld(8,16,AC_FULLB2)//[23:16]
    #define MJC_MV_TPDF_DIF_X_TH Fld(8,8,AC_FULLB1)//[15:8]
    #define MJC_MV_TPDF_DIF_Y_TH Fld(8,0,AC_FULLB0)//[7:0]
#define MJC_STA_MVTPDF (MEMC_MJC + 0xAE4)
    #define MJC_STA_MV_TPDF_CNT Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_STA_MV_0B (MEMC_MJC + 0xAE8)
    #define MJC_STA_MAJOR_MV7 Fld(19,0,AC_MSKDW)//[18:0]
#define MJC_STA_MV_0C (MEMC_MJC + 0xAEC)
    #define MJC_DBG_MAJOR_MV Fld(19,0,AC_MSKDW)//[18:0]
#define MJC_STA_MV_0D (MEMC_MJC + 0xAF0)
    #define MJC_DBG_HLEAD_MV Fld(19,0,AC_MSKDW)//[18:0]
#define MJC_CA_AFB_0 (MEMC_MJC + 0xAF4)
    #define MJC_CA_AFB_MV_RFM_RBG_THR Fld(4,28,AC_MSKB3)//[31:28]
    #define MJC_CA_AFB_MV_RFM_RBG_CHK Fld(1,27,AC_MSKB3)//[27:27]
    #define MJC_CA_AFB_MV_RFM_PGR_CHK Fld(1,26,AC_MSKB3)//[26:26]
    #define MJC_CA_AFB_MV_RFM_ZBL_CHK Fld(1,25,AC_MSKB3)//[25:25]
    #define MJC_CA_AFB_MV_RFM_EN Fld(1,24,AC_MSKB3)//[24:24]
    #define MJC_CA_AFB_EF_VS_GH_TH1 Fld(4,20,AC_MSKB2)//[23:20]
    #define MJC_CA_AFB_AD_VS_IJ_TH1 Fld(4,16,AC_MSKB2)//[19:16]
    #define MJC_CA_AFB_EF_VS_AD_TH1 Fld(4,12,AC_MSKB1)//[15:12]
    #define MJC_CA_AFB_P_VS_R_TH1 Fld(4,8,AC_MSKB1)//[11:8]
    #define MJC_CA_AFB_E_VS_F_TH1 Fld(4,4,AC_MSKB0)//[7:4]
    #define MJC_CA_AFB_T_PR_DIST Fld(4,0,AC_MSKB0)//[3:0]
#define MJC_CA_AFB_1 (MEMC_MJC + 0xAF8)
    #define MJC_CA_AFB_EFBC_CHK Fld(1,29,AC_MSKB3)//[29:29]
    #define MJC_CA_AD_OUT_SR_CHK Fld(1,28,AC_MSKB3)//[28:28]
    #define MJC_CA_AD_OUT_SR_V_SKIP Fld(4,24,AC_MSKB3)//[27:24]
    #define MJC_CA_OSD_STL_CNT_THR Fld(8,16,AC_FULLB2)//[23:16]
    #define MJC_CA_OSD_AD_CHV_CNT_TH3 Fld(4,12,AC_MSKB1)//[15:12]
    #define MJC_CA_AFB_FM_FO_CST_TH1 Fld(6,6,AC_MSKW10)//[11:6]
    #define MJC_CA_AFB_FM_BO_CST_TH1 Fld(6,0,AC_MSKB0)//[5:0]
#define MJC_CA_OSD_STL_1 (MEMC_MJC + 0xAFC)
    #define MJC_CA_OSD_OCC_DET_3 Fld(1,27,AC_MSKB3)//[27:27]
    #define MJC_CA_OSD_OCC_DET_2 Fld(1,26,AC_MSKB3)//[26:26]
    #define MJC_CA_OSD_OCC_DET_1 Fld(1,25,AC_MSKB3)//[25:25]
    #define MJC_CA_OSD_STL_BLK_DET Fld(1,24,AC_MSKB3)//[24:24]
    #define MJC_CA_OSD_STL_CHV_TH Fld(4,20,AC_MSKB2)//[23:20]
    #define MJC_CA_OSD_STL_EGV_TH Fld(4,16,AC_MSKB2)//[19:16]
    #define MJC_CA_OSD_STL_EGH_TH Fld(4,12,AC_MSKB1)//[15:12]
    #define MJC_CA_OSD_STL_CRN_TH Fld(4,8,AC_MSKB1)//[11:8]
    #define MJC_CA_OSD_STL_SAD_TH Fld(8,0,AC_FULLB0)//[7:0]
#define MJC_CA_OSD_STL_2 (MEMC_MJC + 0xB00)
    #define MJC_CA_OSD_AD_STL_CNT_TH2 Fld(4,28,AC_MSKB3)//[31:28]
    #define MJC_CA_OSD_AD_CHV_CNT_TH2 Fld(4,24,AC_MSKB3)//[27:24]
    #define MJC_CA_OSD_AD_CHV_CNT_TH1 Fld(4,20,AC_MSKB2)//[23:20]
    #define MJC_CA_OSD_AD_STL_CNT_TH1 Fld(4,16,AC_MSKB2)//[19:16]
    #define MJC_CA_OSD_AD_MVY_TH Fld(8,8,AC_FULLB1)//[15:8]
    #define MJC_CA_OSD_AD_MVX_TH Fld(8,0,AC_FULLB0)//[7:0]
#define MJC_MV_DSR_0 (MEMC_MJC + 0xB04)
    #define MJC_MV_ME_V_STR_EN_DN Fld(1,25,AC_MSKB3)//[25:25]
    #define MJC_MV_ME_V_STR_EN_UP Fld(1,24,AC_MSKB3)//[24:24]
    #define MJC_MV_ME_V_STR_OFST_DN Fld(4,20,AC_MSKB2)//[23:20]
    #define MJC_MV_ME_V_STR_OFST_UP Fld(4,16,AC_MSKB2)//[19:16]
#define MJC_STA_BDFG_U0 (MEMC_MJC + 0xB1C)
    #define MJC_STA_BND_FG_X_POS_U0 Fld(9,16,AC_MSKW32)//[24:16]
    #define MJC_STA_BND_FG_BKCNT_U0 Fld(6,8,AC_MSKB1)//[13:8]
    #define MJC_STA_BND_FG_FMCNT_U0 Fld(6,0,AC_MSKB0)//[5:0]
#define MJC_STA_BDFG_U1 (MEMC_MJC + 0xB20)
    #define MJC_STA_BND_FG_X_POS_U1 Fld(9,16,AC_MSKW32)//[24:16]
    #define MJC_STA_BND_FG_BKCNT_U1 Fld(6,8,AC_MSKB1)//[13:8]
    #define MJC_STA_BND_FG_FMCNT_U1 Fld(6,0,AC_MSKB0)//[5:0]
#define MJC_STA_BDFG_U2 (MEMC_MJC + 0xB24)
    #define MJC_STA_BND_FG_X_POS_U2 Fld(9,16,AC_MSKW32)//[24:16]
    #define MJC_STA_BND_FG_BKCNT_U2 Fld(6,8,AC_MSKB1)//[13:8]
    #define MJC_STA_BND_FG_FMCNT_U2 Fld(6,0,AC_MSKB0)//[5:0]
#define MJC_STA_BDFG_D0 (MEMC_MJC + 0xB28)
    #define MJC_STA_BND_FG_X_POS_D0 Fld(9,16,AC_MSKW32)//[24:16]
    #define MJC_STA_BND_FG_BKCNT_D0 Fld(6,8,AC_MSKB1)//[13:8]
    #define MJC_STA_BND_FG_FMCNT_D0 Fld(6,0,AC_MSKB0)//[5:0]
#define MJC_STA_BDFG_D1 (MEMC_MJC + 0xB2C)
    #define MJC_STA_BND_FG_X_POS_D1 Fld(9,16,AC_MSKW32)//[24:16]
    #define MJC_STA_BND_FG_BKCNT_D1 Fld(6,8,AC_MSKB1)//[13:8]
    #define MJC_STA_BND_FG_FMCNT_D1 Fld(6,0,AC_MSKB0)//[5:0]
#define MJC_STA_BDFG_D2 (MEMC_MJC + 0xB30)
    #define MJC_STA_BND_FG_X_POS_D2 Fld(9,16,AC_MSKW32)//[24:16]
    #define MJC_STA_BND_FG_BKCNT_D2 Fld(6,8,AC_MSKB1)//[13:8]
    #define MJC_STA_BND_FG_FMCNT_D2 Fld(6,0,AC_MSKB0)//[5:0]
#define MJC_CA_AFB_2 (MEMC_MJC + 0xB34)
    #define MJC_CA_AFB_BC_GAIN Fld(4,8,AC_MSKB1)//[11:8]
    #define MJC_CA_AFB_BC_THR Fld(8,0,AC_FULLB0)//[7:0]
#define MJC_DSR_FW_BND_1 (MEMC_MJC + 0xB40)
    #define MJC_MV_DSR_FORCE_TF_UPBD_EN Fld(1,20,AC_MSKB2)//[20:20]
    #define MJC_MV_DSR_FORCE_TF_LOBD_EN Fld(1,16,AC_MSKB2)//[16:16]
    #define MJC_MV_DSR_TF_UPBD Fld(8,8,AC_FULLB1)//[15:8]
    #define MJC_MV_DSR_TF_LOBD Fld(8,0,AC_FULLB0)//[7:0]
#define MJC_STA_BG_0 (MEMC_MJC + 0xB44)
    #define MJC_STA_HLEAD_FLAG0 Fld(1,24,AC_MSKB3)//[24:24]
    #define MJC_STA_HLEAD_MV0 Fld(19,0,AC_MSKDW)//[18:0]
#define MJC_STA_BG_1 (MEMC_MJC + 0xB48)
    #define MJC_STA_HLEAD_FLAG1 Fld(1,24,AC_MSKB3)//[24:24]
    #define MJC_STA_HLEAD_MV1 Fld(19,0,AC_MSKDW)//[18:0]
#define MJC_STA_BG_2 (MEMC_MJC + 0xB4C)
    #define MJC_STA_HLEAD_FLAG2 Fld(1,24,AC_MSKB3)//[24:24]
    #define MJC_STA_HLEAD_MV2 Fld(19,0,AC_MSKDW)//[18:0]
#define MJC_STA_BG_3 (MEMC_MJC + 0xB50)
    #define MJC_STA_HLEAD_FLAG3 Fld(1,24,AC_MSKB3)//[24:24]
    #define MJC_STA_HLEAD_MV3 Fld(19,0,AC_MSKDW)//[18:0]
#define MJC_STA_BG_4 (MEMC_MJC + 0xB54)
    #define MJC_STA_HLEAD_FLAG4 Fld(1,24,AC_MSKB3)//[24:24]
    #define MJC_STA_HLEAD_MV4 Fld(19,0,AC_MSKDW)//[18:0]
#define MJC_STA_BG_5 (MEMC_MJC + 0xB58)
    #define MJC_STA_HLEAD_FLAG5 Fld(1,24,AC_MSKB3)//[24:24]
    #define MJC_STA_HLEAD_MV5 Fld(19,0,AC_MSKDW)//[18:0]
#define MJC_STA_BG_6 (MEMC_MJC + 0xB5C)
    #define MJC_STA_HLEAD_FLAG6 Fld(1,24,AC_MSKB3)//[24:24]
    #define MJC_STA_HLEAD_MV6 Fld(19,0,AC_MSKDW)//[18:0]
#define MJC_STA_BG_7 (MEMC_MJC + 0xB60)
    #define MJC_STA_HLEAD_FLAG7 Fld(1,24,AC_MSKB3)//[24:24]
    #define MJC_STA_HLEAD_MV7 Fld(19,0,AC_MSKDW)//[18:0]
#define MJC_FW_BG_0 (MEMC_MJC + 0xB64)
    #define MJC_FW_HLEAD_EN Fld(1,28,AC_MSKB3)//[28:28]
    #define MJC_FW_HLEAD_FLAG0 Fld(1,24,AC_MSKB3)//[24:24]
    #define MJC_FW_HLEAD_MV0 Fld(19,0,AC_MSKDW)//[18:0]
#define MJC_FW_BG_1 (MEMC_MJC + 0xB68)
    #define MJC_FW_HLEAD_FLAG1 Fld(1,24,AC_MSKB3)//[24:24]
    #define MJC_FW_HLEAD_MV1 Fld(19,0,AC_MSKDW)//[18:0]
#define MJC_FW_BG_2 (MEMC_MJC + 0xB6C)
    #define MJC_FW_HLEAD_FLAG2 Fld(1,24,AC_MSKB3)//[24:24]
    #define MJC_FW_HLEAD_MV2 Fld(19,0,AC_MSKDW)//[18:0]
#define MJC_FW_BG_3 (MEMC_MJC + 0xB70)
    #define MJC_FW_HLEAD_FLAG3 Fld(1,24,AC_MSKB3)//[24:24]
    #define MJC_FW_HLEAD_MV3 Fld(19,0,AC_MSKDW)//[18:0]
#define MJC_FW_BG_4 (MEMC_MJC + 0xB74)
    #define MJC_FW_HLEAD_FLAG4 Fld(1,24,AC_MSKB3)//[24:24]
    #define MJC_FW_HLEAD_MV4 Fld(19,0,AC_MSKDW)//[18:0]
#define MJC_FW_BG_5 (MEMC_MJC + 0xB78)
    #define MJC_FW_HLEAD_FLAG5 Fld(1,24,AC_MSKB3)//[24:24]
    #define MJC_FW_HLEAD_MV5 Fld(19,0,AC_MSKDW)//[18:0]
#define MJC_FW_BG_6 (MEMC_MJC + 0xB7C)
    #define MJC_FW_HLEAD_FLAG6 Fld(1,24,AC_MSKB3)//[24:24]
    #define MJC_FW_HLEAD_MV6 Fld(19,0,AC_MSKDW)//[18:0]
#define MJC_FW_BG_7 (MEMC_MJC + 0xB80)
    #define MJC_FW_HLEAD_FLAG7 Fld(1,24,AC_MSKB3)//[24:24]
    #define MJC_FW_HLEAD_MV7 Fld(19,0,AC_MSKDW)//[18:0]
#define MJC_FW_BG_8 (MEMC_MJC + 0xB84)
    #define MJC_FW_BG_EN Fld(1,28,AC_MSKB3)//[28:28]
    #define MJC_FW_BG_MV Fld(19,0,AC_MSKDW)//[18:0]
#define MJC_FW_BDFG_U0 (MEMC_MJC + 0xB88)
    #define MJC_FW_BDFG_EN Fld(1,28,AC_MSKB3)//[28:28]
    #define MJC_FW_BDFG_X_POS_U0 Fld(9,16,AC_MSKW32)//[24:16]
    #define MJC_FW_BDFG_BKCNT_U0 Fld(6,8,AC_MSKB1)//[13:8]
    #define MJC_FW_BDFG_FMCNT_U0 Fld(6,0,AC_MSKB0)//[5:0]
#define MJC_FW_BDFG_U1 (MEMC_MJC + 0xB8C)
    #define MJC_FW_BDFG_X_POS_U1 Fld(9,16,AC_MSKW32)//[24:16]
    #define MJC_FW_BDFG_BKCNT_U1 Fld(6,8,AC_MSKB1)//[13:8]
    #define MJC_FW_BDFG_FMCNT_U1 Fld(6,0,AC_MSKB0)//[5:0]
#define MJC_FW_BDFG_U2 (MEMC_MJC + 0xB90)
    #define MJC_FW_BDFG_X_POS_U2 Fld(9,16,AC_MSKW32)//[24:16]
    #define MJC_FW_BDFG_BKCNT_U2 Fld(6,8,AC_MSKB1)//[13:8]
    #define MJC_FW_BDFG_FMCNT_U2 Fld(6,0,AC_MSKB0)//[5:0]
#define MJC_FW_BDFG_D0 (MEMC_MJC + 0xB94)
    #define MJC_FW_BDFG_X_POS_D0 Fld(9,16,AC_MSKW32)//[24:16]
    #define MJC_FW_BDFG_BKCNT_D0 Fld(6,8,AC_MSKB1)//[13:8]
    #define MJC_FW_BDFG_FMCNT_D0 Fld(6,0,AC_MSKB0)//[5:0]

//Page MV_4
#define MJC_FW_BDFG_D1 (MEMC_MJC + 0xB98)
    #define MJC_FW_BDFG_X_POS_D1 Fld(9,16,AC_MSKW32)//[24:16]
    #define MJC_FW_BDFG_BKCNT_D1 Fld(6,8,AC_MSKB1)//[13:8]
    #define MJC_FW_BDFG_FMCNT_D1 Fld(6,0,AC_MSKB0)//[5:0]
#define MJC_FW_BDFG_D2 (MEMC_MJC + 0xB9C)
    #define MJC_FW_BDFG_X_POS_D2 Fld(9,16,AC_MSKW32)//[24:16]
    #define MJC_FW_BDFG_BKCNT_D2 Fld(6,8,AC_MSKB1)//[13:8]
    #define MJC_FW_BDFG_FMCNT_D2 Fld(6,0,AC_MSKB0)//[5:0]
#define MJC_STA_OSD (MEMC_MJC + 0xBA0)
    #define MJC_STA_OSD_AVG_EGH Fld(6,24,AC_MSKB3)//[29:24]
    #define MJC_STA_OSD_AVG_EGV Fld(6,16,AC_MSKB2)//[21:16]
    #define MJC_STA_OSD_FRM_CNT Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_FW_OSD (MEMC_MJC + 0xBA4)
    #define MJC_FW_OSD_AVG_EGH Fld(6,24,AC_MSKB3)//[29:24]
    #define MJC_FW_OSD_AVG_EGV Fld(6,16,AC_MSKB2)//[21:16]
    #define MJC_FW_OSD_FRM_RST Fld(1,8,AC_MSKB1)//[8:8]
    #define MJC_FW_OSD_EN Fld(1,0,AC_MSKB0)//[0:0]
#define MJC_MV_ATPG (MEMC_MJC + 0xBFC)
    #define MJC_MV_BAK_UP Fld(30,2,AC_MSKDW)//[31:2]
    #define MJC_MV_ATPG_CT Fld(1,1,AC_MSKB0)//[1:1]
    #define MJC_MV_ATPG_OB Fld(1,0,AC_MSKB0)//[0:0]

//Page SA
#define MJC_SA_00 (MEMC_MJC + 0xEC0)
    #define MJC_ME_LBOX_HALO_REDUCE_EN Fld(1,27,AC_MSKB3)//[27:27]
    #define MJC_MC_LBOX_HALO_REDUCE_EN Fld(1,26,AC_MSKB3)//[26:26]
    #define MJC_RESCAN_DEBUG_EN Fld(1,25,AC_MSKB3)//[25:25]
    #define MJC_RESCAN_EN Fld(1,24,AC_MSKB3)//[24:24]
    #define MJC_DBG_NEXT_FRM Fld(1,23,AC_MSKB2)//[23:23]
    #define MJC_PREF_EARLY_LINE_CNT Fld(4,19,AC_MSKB2)//[22:19]
    #define MJC_ME_ACCESS_MODE Fld(1,7,AC_MSKB0)//[7:7]
    #define MJC_SRAM_CS_FIX_HIGH_REGION_EN Fld(1,6,AC_MSKB0)//[6:6]
    #define MJC_LOW_POWER_AG_READ_EN Fld(1,5,AC_MSKB0)//[5:5]
    #define MJC_RW_TRANS_PATCH Fld(1,4,AC_MSKB0)//[4:4]
    #define MJC_SA_SRAM_CS_FIXED_HIGH Fld(1,3,AC_MSKB0)//[3:3]
    #define MJC_SRAM_LADDER_2T_MODE Fld(1,2,AC_MSKB0)//[2:2]
    #define MJC_FRAME_LADDER_PATCH Fld(1,1,AC_MSKB0)//[1:1]
    #define MJC_BLK_LADDER_PATCH Fld(1,0,AC_MSKB0)//[0:0]
#define MJC_SA_01 (MEMC_MJC + 0xEC4)
    #define MJC_FB_FLIP_PROT Fld(1,28,AC_MSKB3)//[28:28]
    #define MJC_PRELOAD_FRQ_CNT Fld(8,20,AC_MSKW32)//[27:20]
    #define MJC_MSK_ME_DAT Fld(1,19,AC_MSKB2)//[19:19]
    #define MJC_FW_AUTO_RP_DBGSEL Fld(7,12,AC_MSKW21)//[18:12]
    #define MJC_SA_PREF_FREQ_CNT Fld(8,0,AC_FULLB0)//[7:0]
#define MJC_SA_02 (MEMC_MJC + 0xEC8)
    #define MJC_SA_RESERVED Fld(32,0,AC_FULLDW)//[31:0]
#define MJC_SA_03 (MEMC_MJC + 0xECC)
    #define MJC_PRELOAD_FREQ_SEL Fld(2,30,AC_MSKB3)//[31:30]
    #define MJC_PRELOAD_FRQ_CNT_NYE Fld(8,20,AC_MSKW32)//[27:20]
    #define MJC_STA_SA_PRELOAD_NON_FIN Fld(1,10,AC_MSKB1)//[10:10]
    #define MJC_FORCE_EVEN_IDX_EN Fld(1,9,AC_MSKB1)//[9:9]
    #define MJC_ME_ONLY_SA_READY_DLY Fld(9,0,AC_MSKW10)//[8:0]
#define MJC_SA_04 (MEMC_MJC + 0xED0)
    #define MJC_LBOX_SA_ME_RT Fld(4,12,AC_MSKB1)//[15:12]
    #define MJC_LBOX_SA_ME_LF Fld(4,8,AC_MSKB1)//[11:8]
    #define MJC_LBOX_SA_ME_DN Fld(4,4,AC_MSKB0)//[7:4]
    #define MJC_LBOX_SA_ME_UP Fld(4,0,AC_MSKB0)//[3:0]
#define MJC_SA_05 (MEMC_MJC + 0xED4)
    #define MJC_SRAM_C1E_FIX_HIGH Fld(8,24,AC_FULLB3)//[31:24]
    #define MJC_SRAM_C2E_FIX_HIGH Fld(8,16,AC_FULLB2)//[23:16]
    #define MJC_SRAM_Y1O_FIX_HIGH Fld(8,8,AC_FULLB1)//[15:8]
    #define MJC_SRAM_Y2O_FIX_HIGH Fld(8,0,AC_FULLB0)//[7:0]
#define MJC_SA_06 (MEMC_MJC + 0xED8)
    #define MJC_SRAM_Y1E_FIX_HIGH Fld(8,16,AC_FULLB2)//[23:16]
    #define MJC_SRAM_Y2E_FIX_HIGH Fld(8,8,AC_FULLB1)//[15:8]
    #define MJC_SRAM_Y3E_FIX_HIGH Fld(8,0,AC_FULLB0)//[7:0]
#define MJC_SA_ATPG (MEMC_MJC + 0xEFC)
    #define MJC_SA_ATPG_OB Fld(1,1,AC_MSKB0)//[1:1]
    #define MJC_SA_ATPG_CT Fld(1,0,AC_MSKB0)//[0:0]

//Page SYS
#define MJC_SYS_DRAM (MEMC_MJC + 0x000)
    #define MJC_DRAM_MV_RD_EN Fld(1,7,AC_MSKB0)//[7:7]
    #define MJC_DRAM_MV_WR_EN Fld(1,6,AC_MSKB0)//[6:6]
    #define MJC_DRAM_OUT_RD_EN Fld(1,5,AC_MSKB0)//[5:5]
#define MJC_SYS_BASIC (MEMC_MJC + 0x004)
    #define MJC_C_MJC_VSRCH_MODE Fld(3,29,AC_MSKB3)//[31:29]
    #define MJC_BLK16_MODE Fld(1,24,AC_MSKB3)//[24:24]
    #define MJC_HEIGHT_FX Fld(12,12,AC_MSKW21)//[23:12]
    #define MJC_WIDTH Fld(12,0,AC_MSKW10)//[11:0]
#define MJC_SYS_DBG (MEMC_MJC + 0x008)
    #define MJC_DBG_MODE Fld(8,24,AC_FULLB3)//[31:24]
#define MJC_SYS_FIN (MEMC_MJC + 0x00C)
    #define MJC_C_FINISH_IGNORE_RD Fld(1,6,AC_MSKB0)//[6:6]
    #define MJC_C_FINISH_IGNORE_WM Fld(1,5,AC_MSKB0)//[5:5]
    #define MJC_C_FINISH_IGNORE_WD Fld(1,4,AC_MSKB0)//[4:4]
    #define MJC_C_FINISH_IGNORE_SA Fld(1,3,AC_MSKB0)//[3:3]
    #define MJC_C_FINISH_IGNORE_ME Fld(1,2,AC_MSKB0)//[2:2]
    #define MJC_C_FINISH_IGNORE_MV Fld(1,1,AC_MSKB0)//[1:1]
    #define MJC_C_FINISH_IGNORE_MC Fld(1,0,AC_MSKB0)//[0:0]
#define MJC_STA_RDY (MEMC_MJC + 0x010)
    #define MJC_STA_MJC_FINISH Fld(1,31,AC_MSKB3)//[31:31]
    #define MJC_STA_RDMA_RDY Fld(1,5,AC_MSKB0)//[5:5]
    #define MJC_STA_WDMA_RDY Fld(1,4,AC_MSKB0)//[4:4]
    #define MJC_STA_SA_RDY_EXT Fld(1,3,AC_MSKB0)//[3:3]
    #define MJC_STA_ME_RDY_EXT Fld(1,2,AC_MSKB0)//[2:2]
    #define MJC_STA_MV_RDY_EXT Fld(1,1,AC_MSKB0)//[1:1]
    #define MJC_STA_MC_RDY_EXT Fld(1,0,AC_MSKB0)//[0:0]
#define MJC_STA_DBG (MEMC_MJC + 0x014)
    #define MJC_STA_MJC_DBG Fld(16,0,AC_FULLW10)//[15:0]
    #define MJC_STA_MJC_DBG_0 Fld(8,0,AC_FULLB0)//[7:0]
#define MJC_STA_INTR (MEMC_MJC + 0x070)
    #define MJC_STA_INT3 Fld(1,3,AC_MSKB0)//[3:3]
    #define MJC_STA_INT2 Fld(1,2,AC_MSKB0)//[2:2]
    #define MJC_STA_INT1 Fld(1,1,AC_MSKB0)//[1:1]
    #define MJC_STA_INT0 Fld(1,0,AC_MSKB0)//[0:0]
#define MJC_SYS_RST (MEMC_MJC + 0x0E0)
    #define MJC_RST_CTRL Fld(7,16,AC_MSKB2)//[22:16]
    #define MJC_RST_CORE Fld(1,19,AC_MSKB2)//[22:16]
#define MJC_SYS_INTR (MEMC_MJC + 0x0E4)
    #define MJC_INT_POL_SEL Fld(4,28,AC_MSKB3)//[31:28]
    #define MJC_INT_CLEAR Fld(4,24,AC_MSKB3)//[27:24]
    #define MJC_INT_MASK Fld(4,20,AC_MSKB2)//[23:20]
    #define MJC_CLR_MODE Fld(1,19,AC_MSKB2)//[19:19]
#define MJC_SYS_ATPG (MEMC_MJC + 0x0FC)
    #define MJC_SYS_RESERVED Fld(30,2,AC_MSKDW)//[31:2]
    #define MJC_SYS_ATPG_CT Fld(1,1,AC_MSKB0)//[1:1]
    #define MJC_SYS_ATPG_OB Fld(1,0,AC_MSKB0)//[0:0]


#endif