/* SPDX-License-Identifier: LGPL-2.1-only OR BSD-3-Clause */
/******************************************************************************
 *
 * This file is provided under a dual license.  When you use or
 * distribute this software, you may choose to be licensed under
 * version 2.1 of the GNU Lesser General Public License
 * ("LGPLv2.1 License") or BSD License.
 *
 * LGPLv2.1 License
 *
 * Copyright(C) 2019 MediaTek Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2.1 of the GNU Lesser General Public
 * License as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See https://www.gnu.org/licenses/old-licenses/lgpl-2.1.html for more
 * details.
 *
 * BSD LICENSE
 *
 * Copyright(C) 2019 MediaTek Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *  * Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *****************************************************************************/


/*****************************************************************************
 *
 * Filename:
 * ---------
 *   $Workfile: hw_ycproc.h $
 *
 * Project:
 * --------
 *   MT5381
 *
 * Description:
 * ------------
 *   LCPROC register definition
 *
 * Author:
 * -------
 *   Jeffrey Xuan
 *
 * Last changed:
 * -------------
 * $Author: robin.zhang $
 *
 * $Modtime: 07/04/06 1:22p $
 *
 * $Revision: #2 $
****************************************************************************/

#ifndef _HW_YCPROC_H_
#define _HW_YCPROC_H_

#include "hw_vdoin.h"
#define IO_POSTCOLOR_BASE (IO_VIRT_SRE + 0x1A000)

#define IO_PREPROC_BASE   (IO_VIRT_SRE + 0x41000)

// TOP
#define TOP_MAIN_00 (IO_PREPROC_BASE + 0x000)
    #define C_METRIC_DATA_SEL Fld(1,27,AC_MSKB3)//[27:27]
    #define C_METRIC_V_INV Fld(1,26,AC_MSKB3)//[26:26]
    #define C_DET_DATA_SEL Fld(1,25,AC_MSKB3)//[25:25]
    #define C_DET_V_INV Fld(1,24,AC_MSKB3)//[24:24]
    #define BYPASS_DIV2_REGEN_M Fld(1,23,AC_MSKB2)//[23:23]
    #define C_M2V_INV Fld(1,22,AC_MSKB2)//[22:22]
    #define C_M2F_INV Fld(1,21,AC_MSKB2)//[21:21]
    #define C_MAIN_V_RST Fld(1,20,AC_MSKB2)//[20:20]
    #define C_MAIN_OUT_RGB Fld(1,5,AC_MSKB0)//[5:5]
    #define C_MAIN_OUT_BLANK Fld(1,4,AC_MSKB0)//[4:4]
    #define C_CRC_SEL Fld(2,2,AC_MSKB0)//[3:2]
    #define C_NR_SRC_SEL Fld(1,1,AC_MSKB0)//[1:1]
    #define C_MAIN_NR_EN Fld(1,0,AC_MSKB0)//[0:0]
#define TOP_MAIN_01 (IO_PREPROC_BASE + 0x004)
    // #define C_RST_CTRL Fld(8,24,AC_FULLB3)//[31:24]
    #define C_PRE_PROC_DBG_MODE Fld(4,5,AC_MSKW10)//[8:5]
    #define C_DBG_OUT_SEL Fld(5,0,AC_MSKB0)//[4:0]
#define TOP_PIP_00 (IO_PREPROC_BASE + 0x200)
    #define C_SHOW_POS_PIP_POSITION Fld(1,31,AC_MSKB3)//[31:31]
    #define C_SHOW_PIP_STEP Fld(1,27,AC_MSKB3)//[27:27]
    #define BYPASS_DIV2_REGEN_P Fld(1,23,AC_MSKB2)//[23:23]
    //#define C_P2H_INV Fld(1,23,AC_MSKB2)//[23:23]
    #define C_P2V_INV Fld(1,22,AC_MSKB2)//[22:22]
    #define C_P2F_INV Fld(1,21,AC_MSKB2)//[21:21]
    #define C_PIP2_V_RST Fld(1,20,AC_MSKB2)//[20:20]
    #define C_PIP_OUT_RGB Fld(1,5,AC_MSKB0)//[5:5]
    #define C_PIP_OUT_BLANK Fld(1,4,AC_MSKB0)//[4:4]
    #define C_PIP_SRC_SEL Fld(1,0,AC_MSKB0)//[0:0]
#define TOP_PIP_01 (IO_PREPROC_BASE + 0x204)
    #define C_SHOW_POS_PIP_X Fld(11,16,AC_MSKW32)//[26:16]
    #define C_SHOW_POS_PIP_Y Fld(11,0,AC_MSKW10)//[10:0]

// CRC
#define CRC_00 (IO_PREPROC_BASE + 0x020)
#define CRC_PIP_00 (IO_PREPROC_BASE + 0x220)
    #define C_BOT_L_EN_MAIN Fld(1,31,AC_MSKB3)//[31:31]
    #define C_TOP_L_EN_MAIN Fld(1,30,AC_MSKB3)//[30:30]
    #define C_V_IN_MASK_MAIN Fld(10,20,AC_MSKW32)//[29:20]
    #define C_C_IN_MASK_MAIN Fld(10,10,AC_MSKW21)//[19:10]
    #define C_Y_IN_MASK_MAIN Fld(10,0,AC_MSKW10)//[9:0]
#define CRC_01 (IO_PREPROC_BASE + 0x024)
#define CRC_PIP_01 (IO_PREPROC_BASE + 0x224)
    #define C_BOT_R_EN_MAIN Fld(1,31,AC_MSKB3)//[31:31]
    #define C_TOP_R_EN_MAIN Fld(1,30,AC_MSKB3)//[30:30]
    #define C_CHECK_SUM_MODE_MAIN Fld(1,29,AC_MSKB3)//[29:29]
    #define C_STILL_CHECK_TRIG_MAIN Fld(1,28,AC_MSKB3)//[28:28]
    #define C_STILL_CHECK_MAX_MAIN Fld(8,20,AC_MSKW32)//[27:20]
    #define C_CRC_CLR Fld(1,0,AC_MSKB0)//[0:0]
#define CRC_02 (IO_PREPROC_BASE + 0x028)
#define CRC_PIP_02 (IO_PREPROC_BASE + 0x228)
    #define C_CLIP_H_START_MAIN Fld(13,12,AC_MSKDW)//[24:12]
    #define C_CLIP_V_START_MAIN Fld(12,0,AC_MSKW10)//[11:0]
#define CRC_03 (IO_PREPROC_BASE + 0x02C)
#define CRC_PIP_03 (IO_PREPROC_BASE + 0x22C)
    #define PIP_ATPG_CT Fld(1,31,AC_MSKB3)//[31:31]
    #define PIP_ATPG_OB Fld(1,30,AC_MSKB3)//[30:30]
    #define C_CLIP_H_END_MAIN Fld(13,12,AC_MSKDW)//[24:12]
    #define C_CLIP_V_END_MAIN Fld(12,0,AC_MSKW10)//[11:0]

#define STA_CRC_MAIN_01 (IO_PREPROC_BASE + 0x044)
    #define STA_CRC_H_OUT Fld(32,0,AC_FULLDW)//[31:0]
#define STA_CRC_MAIN_02 (IO_PREPROC_BASE + 0x048)
    #define STA_CRC_V_OUT Fld(32,0,AC_FULLDW)//[31:0]
#define STA_CRC_MAIN_03 (IO_PREPROC_BASE + 0x04C)
    #define MAIN_ATPG_CT Fld(1,31,AC_MSKB3)//[31:31]
    #define MAIN_ATPG_OB Fld(1,30,AC_MSKB3)//[30:30]
    #define STA_NON_STILL_CNT Fld(4,2,AC_MSKB0)//[5:2]
    #define STA_STILL_CHECK_DONE Fld(1,1,AC_MSKB0)//[1:1]
    #define STA_CRC_MAIN_RDY Fld(1,0,AC_MSKB0)//[0:0]

// YCBCR2YC
#define YCBCR2YC_MAIN_00 (IO_PREPROC_BASE + 0x1F0)
#define YCBCR2YC_PIP_00 (IO_PREPROC_BASE + 0x3F0)
    #define C_MAIN_LEFT_PADDING Fld(1,7,AC_MSKB0)//[7:7]
    #define C_MAIN_MIRROR_MODE Fld(1,6,AC_MSKB0)//[6:6]
    #define C_MAIN_EVEN_EXTEND Fld(1,5,AC_MSKB0)//[5:5]
    #define C_MAIN_NOSYNC_BLOCK Fld(1,4,AC_MSKB0)//[4:4]
    #define C_MAIN_KEEP_LAST_DATA Fld(1,3,AC_MSKB0)//[3:3]
    #define C_MAIN_HSYNC_BLACK Fld(1,2,AC_MSKB0)//[2:2]
    #define C_MAIN_FILTER_ON Fld(1,1,AC_MSKB0)//[1:1]
    #define C_MAIN_ENA Fld(1,0,AC_MSKB0)//[0:0]

// PAT_GEN
#define PAT_MAIN_00 (IO_PREPROC_BASE + 0x0C0)
#define PAT_PIP_00 (IO_PREPROC_BASE + 0x2B0)
    #define C_MAIN_SELFGEN_EN Fld(1,31,AC_MSKB3)//[31:31]
    #define C_MAIN_SELF_DISP_R_EN Fld(1,30,AC_MSKB3)//[30:30]
    #define C_MAIN_SELF_FLD_EN Fld(1,29,AC_MSKB3)//[29:29]
    #define C_MAIN_SELF_VT Fld(13,16,AC_MSKW32)//[28:16]
    #define C_MAIN_TIME_MODE Fld(2,14,AC_MSKB1)//[15:14]
    #define C_MAIN_SELF_HT Fld(14,0,AC_MSKW10)//[13:0]
#define PAT_MAIN_01 (IO_PREPROC_BASE + 0x0C4)
#define PAT_PIP_01 (IO_PREPROC_BASE + 0x2C4)
    #define C_MAIN_TIME_EN Fld(4,28,AC_MSKB3)//[31:28]
    #define C_MAIN_V_ACT Fld(12,16,AC_MSKW32)//[27:16]
    #define C_MAIN_TIME_STEP Fld(3,13,AC_MSKB1)//[15:13]
    #define C_MAIN_H_ACT Fld(13,0,AC_MSKW10)//[12:0]
#define PAT_MAIN_02 (IO_PREPROC_BASE + 0x0C8)
#define PAT_PIP_02 (IO_PREPROC_BASE + 0x2C8)
    #define C_MAIN_SELF_DE_N Fld(5,27,AC_MSKB3)//[31:27]
    #define C_MAIN_NOISE_EN Fld(3,24,AC_MSKB3)//[26:24]
    #define C_MAIN_V_OFFSET Fld(8,16,AC_FULLB2)//[23:16]
    #define C_MAIN_PAT_TYPE Fld(4,12,AC_MSKB1)//[15:12]
    #define C_MAIN_NOISE_LEVEL Fld(4,8,AC_MSKB1)//[11:8]
    #define C_MAIN_H_OFFSET Fld(8,0,AC_FULLB0)//[7:0]
#define PAT_MAIN_03 (IO_PREPROC_BASE + 0x0CC)
#define PAT_PIP_03 (IO_PREPROC_BASE + 0x2CC)
    #define C_MAIN_SELF_DE_M Fld(5,27,AC_MSKB3)//[31:27]
    #define PRE_PAT_MAIN_ATPG_OB Fld(1,26,AC_MSKB3)//[26:26]
    #define PRE_PAT_MAIN_ATPG_CT Fld(1,25,AC_MSKB3)//[25:25]
    #define C_MAIN_GRID_WIDTH Fld(1,24,AC_MSKB3)//[24:24]
    #define C_MAIN_V_GRID Fld(8,16,AC_FULLB2)//[23:16]
    #define C_MAIN_BORDER_EN Fld(4,12,AC_MSKB1)//[15:12]
    #define C_MAIN_MAX_F Fld(4,8,AC_MSKB1)//[11:8]
    #define C_MAIN_H_GRID Fld(8,0,AC_FULLB0)//[7:0]
#define PAT_MAIN_04 (IO_PREPROC_BASE + 0x0D0)
#define PAT_PIP_04 (IO_PREPROC_BASE + 0x2D0)
    #define C_MAIN_HV_MODE Fld(2,30,AC_MSKB3)//[31:30]
    #define C_MAIN_FC_CR Fld(10,20,AC_MSKW32)//[29:20]
    #define C_MAIN_FC_CB Fld(10,10,AC_MSKW21)//[19:10]
    #define C_MAIN_FC_Y Fld(10,0,AC_MSKW10)//[9:0]
#define PAT_MAIN_05 (IO_PREPROC_BASE + 0x0D4)
#define PAT_PIP_05 (IO_PREPROC_BASE + 0x2D4)
    #define C_MAIN_COLOR_MODE Fld(2,30,AC_MSKB3)//[31:30]
    #define C_MAIN_BC_CR Fld(10,20,AC_MSKW32)//[29:20]
    #define C_MAIN_BC_CB Fld(10,10,AC_MSKW21)//[19:10]
    #define C_MAIN_BC_Y Fld(10,0,AC_MSKW10)//[9:0]
#define PAT_MAIN_06 (IO_PREPROC_BASE + 0x0D8)
    #define C_MAIN_VS_NOT_ALIGN_H Fld(1,13,AC_MSKB1)//[13:13]
#define PAT_PIP_06 (IO_PREPROC_BASE + 0x2D8)
    #define C_MAIN_PRB_EN Fld(4,28,AC_MSKB3)//[31:28]
    #define C_MAIN_PRB_Y_POS Fld(12,16,AC_MSKW32)//[27:16]
    #define C_MAIN_PRB_CURSOR_ON Fld(1,15,AC_MSKB1)//[15:15]
    #define C_MAIN_PRB_OSD_ON Fld(1,14,AC_MSKB1)//[14:14]
     #define C_PIP_VS_NOT_ALIGN_H Fld(1,13,AC_MSKB1)//[13:13]
    #define C_MAIN_PRB_X_POS Fld(13,0,AC_MSKW10)//[12:0]
#define PAT_MAIN_07 (IO_PREPROC_BASE + 0x0DC)
#define PAT_PIP_07 (IO_PREPROC_BASE + 0x2DC)
    #define S_MAIN_PRB_DISP_R Fld(1,31,AC_MSKB3)//[31:31]
    #define S_MAIN_PRB_FLD Fld(1,30,AC_MSKB3)//[30:30]
    #define S_MAIN_PRB_CR Fld(10,20,AC_MSKW32)//[29:20]
    #define S_MAIN_PRB_CB Fld(10,10,AC_MSKW21)//[19:10]
    #define S_MAIN_PRB_Y Fld(10,0,AC_MSKW10)//[9:0]

#define PAT_MAIN_08 (IO_PREPROC_BASE + 0x0E0)
    #define C_SET_RESOLUTION Fld(1,31,AC_MSKB3)//[31:31]
    #define C_DOUBLE_BUFFER_DIS Fld(1,30,AC_MSKB3)//[30:30]
    #define C_3RD_EN_SYNC_MAIN Fld(1,29,AC_MSKB3)//[29:29]
    #define C_3RD_U_Y_SWITCH Fld(1,28,AC_MSKB3)//[28:28]
    #define C_3RD_DAT_SYNC_MAIN Fld(1,27,AC_MSKB3)//[27:27]
    #define C_MAIN_PAT_RESERVE Fld(27,0,AC_MSKDW)//[26:0]  

//  3x3 MATRIX
#define TRANS_MAIN_00 (IO_PREPROC_BASE + 0x084)
#define TRANS_PIP_00 (IO_PREPROC_BASE + 0x284)
#define TRANS_MON_00 (IO_PREPROC_BASE + 0xC04)
    #define OUT_S2P Fld(1,31,AC_MSKB3)//[31:31]
    #define OUT_S1P Fld(1,30,AC_MSKB3)//[30:30]
    #define OUT_S0P Fld(1,29,AC_MSKB3)//[29:29]
    #define CLAMP_S2P Fld(1,28,AC_MSKB3)//[28:28]
    #define CLAMP_S1P Fld(1,27,AC_MSKB3)//[27:27]
    #define CLAMP_S0P Fld(1,26,AC_MSKB3)//[26:26]
    #define IN_S2P Fld(1,25,AC_MSKB3)//[25:25]
    #define IN_S1P Fld(1,24,AC_MSKB3)//[24:24]
    #define IN_S0P Fld(1,23,AC_MSKB2)//[23:23]
    #define IN_OFFSET_1P Fld(11,12,AC_MSKW21)//[22:12]
    #define IN_OFFSET_1P_PIP Fld(11,12,AC_MSKW21)//[22:12]
    #define MAIN_EASY_BP3X3 Fld(1,11,AC_MSKB1)//[11:11]
    #define IN_OFFSET_0P Fld(11,0,AC_MSKW10)//[10:0]
    #define IN_OFFSET_0P_PIP Fld(11,0,AC_MSKW10)//[10:0]
#define TRANS_MAIN_01 (IO_PREPROC_BASE + 0x088)
#define TRANS_PIP_01 (IO_PREPROC_BASE + 0x288)
#define TRANS_MON_01 (IO_PREPROC_BASE + 0xC08)
    #define OUT_OFFSET_0P Fld(11,12,AC_MSKW21)//[22:12]
    #define OUT_OFFSET_0P_PIP Fld(11,12,AC_MSKW21)//[22:12]
    #define IN_OFFSET_2P Fld(11,0,AC_MSKW10)//[10:0]
    #define IN_OFFSET_2P_PIP Fld(11,0,AC_MSKW10)//[10:0]
#define TRANS_MAIN_02 (IO_PREPROC_BASE + 0x08C)
#define TRANS_PIP_02 (IO_PREPROC_BASE + 0x28C)
#define TRANS_MON_02 (IO_PREPROC_BASE + 0xC0C)
    #define OUT_OFFSET_2P Fld(11,12,AC_MSKW21)//[22:12]
    #define OUT_OFFSET_2P_PIP Fld(11,12,AC_MSKW21)//[22:12]
    #define OUT_OFFSET_1P Fld(11,0,AC_MSKW10)//[10:0]
    #define OUT_OFFSET_1P_PIP Fld(11,0,AC_MSKW10)//[10:0]
#define TRANS_MAIN_03 (IO_PREPROC_BASE + 0x090)
#define TRANS_PIP_03 (IO_PREPROC_BASE + 0x290)    
#define TRANS_MON_03 (IO_PREPROC_BASE + 0xC10)
    #define COEFF_01P Fld(12,12,AC_MSKW21)//[23:12]
    #define COEFF_00P Fld(12,0,AC_MSKW10)//[11:0]
#define TRANS_MAIN_04 (IO_PREPROC_BASE + 0x094)
#define TRANS_PIP_04 (IO_PREPROC_BASE + 0x294)
#define TRANS_MON_04 (IO_PREPROC_BASE + 0xC14)
    #define COEFF_10P Fld(12,12,AC_MSKW21)//[23:12]
    #define COEFF_02P Fld(12,0,AC_MSKW10)//[11:0]
#define TRANS_MAIN_05 (IO_PREPROC_BASE + 0x098)
#define TRANS_PIP_05 (IO_PREPROC_BASE + 0x298)    
#define TRANS_MON_05 (IO_PREPROC_BASE + 0xC18)
    #define COEFF_12P Fld(12,12,AC_MSKW21)//[23:12]
    #define COEFF_11P Fld(12,0,AC_MSKW10)//[11:0]
#define TRANS_MAIN_06 (IO_PREPROC_BASE + 0x09C)
#define TRANS_PIP_06 (IO_PREPROC_BASE + 0x29C)
#define TRANS_MON_06 (IO_PREPROC_BASE + 0xC1C)
    #define COEFF_21P Fld(12,12,AC_MSKW21)//[23:12]
    #define COEFF_20P Fld(12,0,AC_MSKW10)//[11:0]
#define TRANS_MAIN_07 (IO_PREPROC_BASE + 0x0A0)
#define TRANS_PIP_07 (IO_PREPROC_BASE + 0x2A0)
#define TRANS_MON_07 (IO_PREPROC_BASE + 0xC20)
    #define ERR_DFN Fld(1,31,AC_MSKB3)//[31:31]
    #define REG_INDEX Fld(5,20,AC_MSKW32)//[24:20]
    #define INPUT_SELP Fld(4,16,AC_MSKB2)//[19:16]
    #define BP_VSYNC Fld(1,15,AC_MSKB1)//[15:15]
    #define CONTROL_SEL Fld(3,12,AC_MSKB1)//[14:12]
    #define COEFF_22P Fld(12,0,AC_MSKW10)//[11:0]
#define TRANS_MAIN_08 (IO_PREPROC_BASE + 0x0A4)
#define TRANS_PIP_08 (IO_PREPROC_BASE + 0x2A4)
#define TRANS_MON_08 (IO_PREPROC_BASE + 0xC24)
    #define PRE_TRAN_MAIN_ATPG_CT Fld(1,31,AC_MSKB3)//[31:31]
    #define PRE_TRAN_MAIN_ATPG_OB Fld(1,30,AC_MSKB3)//[30:30]
    #define CONTROL_REG Fld(30,0,AC_MSKDW)//[29:0]
#define STA_3X3_MAIN_00 (IO_PREPROC_BASE + 0x080)
#define STA_3X3_PIP_00 (IO_PREPROC_BASE + 0x280)
#define STA_3X3_MON_00 (IO_PREPROC_BASE + 0xC00)
    #define STATUS_3X3 Fld(14,0,AC_MSKW10)//[13:0]
    
// Software register
#define SWRW_00 (IO_PREPROC_BASE + 0x580)   // PSCAN OSD debug index
#define SWRW_01 (IO_PREPROC_BASE + 0x584)   // Buffer Address
#define SWRW_02 (IO_PREPROC_BASE + 0x588)   // Buffer size
#define SWRW_03 (IO_PREPROC_BASE + 0x58C)   // Dump format
    #define DUMP_CTRL_HEIGHT Fld(12, 20, AC_MSKW32)  
    #define DUMP_CTRL_WIDTH  Fld(12, 8, AC_MSKW21)       
    #define DUMP_CTRL_FORMAT Fld(8, 0, AC_FULLB0) 
#define SWRW_04 (IO_PREPROC_BASE + 0x590)
    #define DUMP_CTRL_ENG_SEL Fld(6, 26, AC_MSKB3)  // Dump Engine
    #define DUMP_CTRL_STATE   Fld(2, 24, AC_MSKB3)  // Dump State
    #define DUMP_CTRL_SIZE    Fld(23, 0, AC_MSKDW)   // Dump size
#define SWRW_05 (IO_PREPROC_BASE + 0x594)
    #define DUMP_CTRL_SHRINK_W  Fld(16, 16, AC_FULLW32)
    #define DUMP_CTRL_SHRINK_H  Fld(16,  0, AC_FULLW10)
#define SWRW_06 (IO_PREPROC_BASE + 0x598)
    #define DUMP_CTRL_START_X   Fld(16, 16, AC_FULLW32)
    #define DUMP_CTRL_START_Y   Fld(16,  0, AC_FULLW10)     
#define SWRW_07 (IO_PREPROC_BASE + 0x59C)
    #define DUMP_REQ_WIDTH      Fld(16, 16, AC_FULLW32)  
    #define DUMP_REQ_HEIGHT     Fld(16,  0, AC_FULLW10)     

#define SWRW_08 (IO_PREPROC_BASE + 0x5A0)
    #define DUMP_FORCE_ALLOC_ADDR Fld(32,0,AC_FULLDW)//[31:0]
#define SWRW_09 (IO_PREPROC_BASE + 0x5A4)
    #define CONTINUOUS_DUMP_EN Fld(1,0,AC_MSKB0)//[0:0]
    #define CONTINUOUS_DUMP_PAUSE Fld(1,1,AC_MSKB0)//[1:1]
#define SWRW_0A (IO_PREPROC_BASE + 0x5A8)
#define SWRW_0B (IO_PREPROC_BASE + 0x5AC)
#define SWRW_0C (IO_PREPROC_BASE + 0x5B0)
#define SWRW_0D (IO_PREPROC_BASE + 0x5B4)
#define SWRW_0E (IO_PREPROC_BASE + 0x5B8)
#define SWRW_0F (IO_PREPROC_BASE + 0x5BC)

// Frequency detection.
#define PRE_DS_FIL_00 (IO_PREPROC_BASE + 0x800)
    #define H_FILTER_BAND0_COEF0 Fld(10,20,AC_MSKW32)//[29:20]
    #define H_FILTER_BAND0_COEF1 Fld(10,10,AC_MSKW21)//[19:10]
    #define H_FILTER_BAND0_COEF2 Fld(10,0,AC_MSKW10)//[9:0]
#define PRE_DS_FIL_01 (IO_PREPROC_BASE + 0x804)
    #define H_FILTER_BAND0_COEF3 Fld(10,20,AC_MSKW32)//[29:20]
    #define H_FILTER_BAND0_COEF4 Fld(10,10,AC_MSKW21)//[19:10]
    #define H_FILTER_BAND0_COEF5 Fld(10,0,AC_MSKW10)//[9:0]
#define PRE_DS_FIL_02 (IO_PREPROC_BASE + 0x808)
    #define H_FILTER_BAND0_COEF6 Fld(10,20,AC_MSKW32)//[29:20]
    #define H_FILTER_BAND0_COEF7 Fld(10,10,AC_MSKW21)//[19:10]
    #define H_FILTER_BAND0_COEF8 Fld(10,0,AC_MSKW10)//[9:0]
#define PRE_DS_FIL_03 (IO_PREPROC_BASE + 0x80C)
    #define H_FILTER_BAND0_COEF9 Fld(10,20,AC_MSKW32)//[29:20]
    #define H_FILTER_BAND0_COEF10 Fld(10,10,AC_MSKW21)//[19:10]
    #define H_FILTER_BAND0_COEF11 Fld(10,0,AC_MSKW10)//[9:0]
#define PRE_DS_FIL_04 (IO_PREPROC_BASE + 0x810)
    #define H_FILTER_BAND0_COEF12 Fld(10,20,AC_MSKW32)//[29:20]
    #define H_FILTER_BAND0_COEF13 Fld(10,10,AC_MSKW21)//[19:10]
    #define H_FILTER_BAND0_COEF14 Fld(10,0,AC_MSKW10)//[9:0]
#define PRE_DS_FIL_05 (IO_PREPROC_BASE + 0x814)
    #define H_FILTER_BAND0_COEF15 Fld(10,20,AC_MSKW32)//[29:20]
    #define H_FILTER_BAND0_COEF16 Fld(10,10,AC_MSKW21)//[19:10]
    #define H_FILTER_BAND0_COEF17 Fld(10,0,AC_MSKW10)//[9:0]
#define PRE_DS_FIL_06 (IO_PREPROC_BASE + 0x81C)
    #define H_FILTER_BAND0_COEF18 Fld(10,20,AC_MSKW32)//[29:20]
    #define H_FILTER_BAND0_COEF19 Fld(10,10,AC_MSKW21)//[19:10]
    #define H_FILTER_BAND0_COEF20 Fld(10,0,AC_MSKW10)//[9:0]
#define PRE_DS_FIL_07 (IO_PREPROC_BASE + 0x820)
    #define H_FILTER_BAND1_COEF0 Fld(8,24,AC_FULLB3)//[31:24]
    #define H_FILTER_BAND1_COEF1 Fld(8,16,AC_FULLB2)//[23:16]
    #define H_FILTER_BAND1_COEF2 Fld(8,8,AC_FULLB1)//[15:8]
    #define H_FILTER_BAND1_COEF3 Fld(8,0,AC_FULLB0)//[7:0]
#define PRE_DS_FIL_08 (IO_PREPROC_BASE + 0x824)
    #define H_FILTER_BAND1_COEF4 Fld(8,24,AC_FULLB3)//[31:24]
    #define H_FILTER_BAND1_COEF5 Fld(8,16,AC_FULLB2)//[23:16]
    #define H_FILTER_BAND1_COEF6 Fld(8,8,AC_FULLB1)//[15:8]
    #define H_FILTER_BAND1_COEF7 Fld(8,0,AC_FULLB0)//[7:0]
#define PRE_DS_FIL_09 (IO_PREPROC_BASE + 0x82C)
    #define H_FILTER_BAND1_COEF8 Fld(8,24,AC_FULLB3)//[31:24]
    #define H_FILTER_BAND1_COEF9 Fld(8,16,AC_FULLB2)//[23:16]
    #define H_FILTER_BAND1_COEF10 Fld(8,8,AC_FULLB1)//[15:8]
    #define H_FILTER_BAND1_COEF11 Fld(8,0,AC_FULLB0)//[7:0]
#define PRE_DS_FIL_0A (IO_PREPROC_BASE + 0x830)
    #define H_FILTER_BAND1_COEF12 Fld(8,16,AC_FULLB2)//[23:16]
    #define H_FILTER_BAND1_COEF13 Fld(8,8,AC_FULLB1)//[15:8]
    #define H_FILTER_BAND1_COEF14 Fld(8,0,AC_FULLB0)//[7:0]
#define PRE_DS_FIL_0B (IO_PREPROC_BASE + 0x834)
    #define H_FILTER_BAND2_COEF0 Fld(8,24,AC_FULLB3)//[31:24]
    #define H_FILTER_BAND2_COEF1 Fld(8,16,AC_FULLB2)//[23:16]
    #define H_FILTER_BAND2_COEF2 Fld(8,8,AC_FULLB1)//[15:8]
    #define H_FILTER_BAND2_COEF3 Fld(8,0,AC_FULLB0)//[7:0]
#define PRE_DS_FIL_0C (IO_PREPROC_BASE + 0x83C)
    #define H_FILTER_BAND2_COEF4 Fld(8,24,AC_FULLB3)//[31:24]
    #define H_FILTER_BAND2_COEF5 Fld(8,16,AC_FULLB2)//[23:16]
    #define H_FILTER_BAND2_COEF6 Fld(8,8,AC_FULLB1)//[15:8]
    #define H_FILTER_BAND2_COEF7 Fld(8,0,AC_FULLB0)//[7:0]
#define PRE_DS_FIL_0D (IO_PREPROC_BASE + 0x840)
    #define H_FILTER_BAND2_COEF8 Fld(8,24,AC_FULLB3)//[31:24]
    #define H_FILTER_BAND2_COEF9 Fld(8,16,AC_FULLB2)//[23:16]
    #define H_FILTER_BAND2_COEF10 Fld(8,8,AC_FULLB1)//[15:8]
    #define H_FILTER_BAND2_COEF11 Fld(8,0,AC_FULLB0)//[7:0]
#define PRE_DS_FIL_0E (IO_PREPROC_BASE + 0x844)
    #define H_FILTER_BAND2_COEF12 Fld(8,16,AC_FULLB2)//[23:16]
    #define H_FILTER_BAND2_COEF13 Fld(8,8,AC_FULLB1)//[15:8]
    #define H_FILTER_BAND2_COEF14 Fld(8,0,AC_FULLB0)//[7:0]
#define PRE_DS_FIL_0F (IO_PREPROC_BASE + 0x84C)
    #define H_FILTER_BAND3_COEF0 Fld(8,24,AC_FULLB3)//[31:24]
    #define H_FILTER_BAND3_COEF1 Fld(8,16,AC_FULLB2)//[23:16]
    #define H_FILTER_BAND3_COEF2 Fld(8,8,AC_FULLB1)//[15:8]
    #define H_FILTER_BAND3_COEF3 Fld(8,0,AC_FULLB0)//[7:0]
#define PRE_DS_FIL_10 (IO_PREPROC_BASE + 0x850)
    #define H_FILTER_BAND3_COEF4 Fld(8,24,AC_FULLB3)//[31:24]
    #define H_FILTER_BAND3_COEF5 Fld(8,16,AC_FULLB2)//[23:16]
    #define H_FILTER_BAND3_COEF6 Fld(8,8,AC_FULLB1)//[15:8]
    #define H_FILTER_BAND3_COEF7 Fld(8,0,AC_FULLB0)//[7:0]
#define PRE_DS_FIL_11 (IO_PREPROC_BASE + 0x854)
    #define H_FILTER_BAND3_COEF8 Fld(8,24,AC_FULLB3)//[31:24]
    #define H_FILTER_BAND3_COEF9 Fld(8,16,AC_FULLB2)//[23:16]
    #define H_FILTER_BAND3_COEF10 Fld(8,8,AC_FULLB1)//[15:8]
    #define H_FILTER_BAND3_COEF11 Fld(8,0,AC_FULLB0)//[7:0]
#define PRE_DS_FIL_12 (IO_PREPROC_BASE + 0x85C)
    #define H_FILTER_BAND3_COEF12 Fld(8,16,AC_FULLB2)//[23:16]
    #define H_FILTER_BAND3_COEF13 Fld(8,8,AC_FULLB1)//[15:8]
    #define H_FILTER_BAND3_COEF14 Fld(8,0,AC_FULLB0)//[7:0]
#define PRE_DS_FIL_13 (IO_PREPROC_BASE + 0x860)
    #define H_FILTER_WIDTH Fld(16,16,AC_FULLW32)//[31:16]
    #define H_FILTER_HEIGHT Fld(16,0,AC_FULLW10)//[15:0]
#define PRE_DS_FIL_14 (IO_PREPROC_BASE + 0x864)
    #define H_FILTER_H_START Fld(16,16,AC_FULLW32)//[31:16]
    #define H_FILTER_V_START Fld(16,0,AC_FULLW10)//[15:0]
#define PRE_DS_FIL_15 (IO_PREPROC_BASE + 0x86C)
    #define H_FILTER_H_SIZE Fld(16,16,AC_FULLW32)//[31:16]
    #define H_FILTER_V_SIZE Fld(16,0,AC_FULLW10)//[15:0]
#define PRE_DS_FIL_16 (IO_PREPROC_BASE + 0x870)
    #define H_FILTER_SWITCH_0 Fld(1,31,AC_MSKB3)//[31:31]
    #define H_FILTER_SWITCH_1 Fld(1,30,AC_MSKB3)//[30:30]
    #define H_FILTER_SWITCH_2 Fld(1,29,AC_MSKB3)//[29:29]
    #define H_FILTER_SWITCH_3 Fld(1,28,AC_MSKB3)//[28:28]
    #define BITSHIFT_A0 Fld(3,25,AC_MSKB3)//[27:25]
    #define BITSHIFT_B0 Fld(3,22,AC_MSKW32)//[24:22]
    #define BITSHIFT_A1 Fld(3,19,AC_MSKB2)//[21:19]
    #define BITSHIFT_B1 Fld(3,16,AC_MSKB2)//[18:16]
    #define BITSHIFT_A2 Fld(3,13,AC_MSKB1)//[15:13]
    #define BITSHIFT_B2 Fld(3,10,AC_MSKB1)//[12:10]
    #define BITSHIFT_A3 Fld(3,7,AC_MSKW10)//[9:7]
    #define BITSHIFT_B3 Fld(3,4,AC_MSKB0)//[6:4]
    #define H_FILTER_OUTPUT_MSB Fld(1,3,AC_MSKB0)//[3:3]
#define PRE_DS_FIL_17 (IO_PREPROC_BASE + 0x874)
    #define A0_HIST_0 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_18 (IO_PREPROC_BASE + 0x878)
    #define A0_HIST_1 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_19 (IO_PREPROC_BASE + 0x87C)
    #define A0_HIST_2 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_1A (IO_PREPROC_BASE + 0x880)
    #define A0_HIST_3 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_1B (IO_PREPROC_BASE + 0x884)
    #define A0_HIST_4 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_1C (IO_PREPROC_BASE + 0x888)
    #define A0_HIST_5 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_1D (IO_PREPROC_BASE + 0x88C)
    #define A0_HIST_6 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_1E (IO_PREPROC_BASE + 0x890)
    #define A0_HIST_7 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_1F (IO_PREPROC_BASE + 0x894)
    #define A0_HIST_8 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_20 (IO_PREPROC_BASE + 0x898)
    #define A0_HIST_9 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_21 (IO_PREPROC_BASE + 0x89C)
    #define A0_HIST_10 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_22 (IO_PREPROC_BASE + 0x8A0)
    #define A0_HIST_11 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_23 (IO_PREPROC_BASE + 0x8A4)
    #define A0_HIST_12 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_24 (IO_PREPROC_BASE + 0x8A8)
    #define A0_HIST_13 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_25 (IO_PREPROC_BASE + 0x8AC)
    #define A0_HIST_14 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_26 (IO_PREPROC_BASE + 0x8B0)
    #define A0_HIST_15 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_27 (IO_PREPROC_BASE + 0x8B4)
    #define B0_HIST_0 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_28 (IO_PREPROC_BASE + 0x8B8)
    #define B0_HIST_1 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_29 (IO_PREPROC_BASE + 0x8BC)
    #define B0_HIST_2 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_2A (IO_PREPROC_BASE + 0x8C0)
    #define B0_HIST_3 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_2B (IO_PREPROC_BASE + 0x8C4)
    #define B0_HIST_4 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_2C (IO_PREPROC_BASE + 0x8C8)
    #define B0_HIST_5 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_2D (IO_PREPROC_BASE + 0x8CC)
    #define B0_HIST_6 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_2E (IO_PREPROC_BASE + 0x8D0)
    #define B0_HIST_7 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_2F (IO_PREPROC_BASE + 0x8D4)
    #define B0_HIST_8 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_30 (IO_PREPROC_BASE + 0x8D8)
    #define B0_HIST_9 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_31 (IO_PREPROC_BASE + 0x8DC)
    #define B0_HIST_10 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_32 (IO_PREPROC_BASE + 0x8E0)
    #define B0_HIST_11 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_33 (IO_PREPROC_BASE + 0x8E4)
    #define B0_HIST_12 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_34 (IO_PREPROC_BASE + 0x8E8)
    #define B0_HIST_13 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_35 (IO_PREPROC_BASE + 0x8EC)
    #define B0_HIST_14 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_36 (IO_PREPROC_BASE + 0x8F0)
    #define B0_HIST_15 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_37 (IO_PREPROC_BASE + 0x8F4)
    #define A1_HIST_0 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_38 (IO_PREPROC_BASE + 0x8F8)
    #define A1_HIST_1 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_39 (IO_PREPROC_BASE + 0x8FC)
    #define A1_HIST_2 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_3A (IO_PREPROC_BASE + 0x900)
    #define A1_HIST_3 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_3B (IO_PREPROC_BASE + 0x904)
    #define A1_HIST_4 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_3C (IO_PREPROC_BASE + 0x908)
    #define A1_HIST_5 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_3D (IO_PREPROC_BASE + 0x90C)
    #define A1_HIST_6 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_3E (IO_PREPROC_BASE + 0x910)
    #define A1_HIST_7 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_3F (IO_PREPROC_BASE + 0x914)
    #define A1_HIST_8 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_40 (IO_PREPROC_BASE + 0x918)
    #define A1_HIST_9 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_41 (IO_PREPROC_BASE + 0x91C)
    #define A1_HIST_10 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_42 (IO_PREPROC_BASE + 0x920)
    #define A1_HIST_11 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_43 (IO_PREPROC_BASE + 0x924)
    #define A1_HIST_12 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_44 (IO_PREPROC_BASE + 0x928)
    #define A1_HIST_13 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_45 (IO_PREPROC_BASE + 0x92C)
    #define A1_HIST_14 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_46 (IO_PREPROC_BASE + 0x930)
    #define A1_HIST_15 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_47 (IO_PREPROC_BASE + 0x934)
    #define B1_HIST_0 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_48 (IO_PREPROC_BASE + 0x938)
    #define B1_HIST_1 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_49 (IO_PREPROC_BASE + 0x93C)
    #define B1_HIST_2 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_4A (IO_PREPROC_BASE + 0x940)
    #define B1_HIST_3 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_4B (IO_PREPROC_BASE + 0x944)
    #define B1_HIST_4 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_4C (IO_PREPROC_BASE + 0x948)
    #define B1_HIST_5 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_4D (IO_PREPROC_BASE + 0x94C)
    #define B1_HIST_6 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_4E (IO_PREPROC_BASE + 0x950)
    #define B1_HIST_7 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_4F (IO_PREPROC_BASE + 0x954)
    #define B1_HIST_8 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_50 (IO_PREPROC_BASE + 0x958)
    #define B1_HIST_9 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_51 (IO_PREPROC_BASE + 0x95C)
    #define B1_HIST_10 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_52 (IO_PREPROC_BASE + 0x960)
    #define B1_HIST_11 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_53 (IO_PREPROC_BASE + 0x964)
    #define B1_HIST_12 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_54 (IO_PREPROC_BASE + 0x968)
    #define B1_HIST_13 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_55 (IO_PREPROC_BASE + 0x96C)
    #define B1_HIST_14 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_56 (IO_PREPROC_BASE + 0x970)
    #define B1_HIST_15 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_57 (IO_PREPROC_BASE + 0x974)
    #define A2_HIST_0 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_58 (IO_PREPROC_BASE + 0x978)
    #define A2_HIST_1 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_59 (IO_PREPROC_BASE + 0x97C)
    #define A2_HIST_2 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_5A (IO_PREPROC_BASE + 0x980)
    #define A2_HIST_3 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_5B (IO_PREPROC_BASE + 0x984)
    #define A2_HIST_4 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_5C (IO_PREPROC_BASE + 0x988)
    #define A2_HIST_5 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_5D (IO_PREPROC_BASE + 0x98C)
    #define A2_HIST_6 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_5E (IO_PREPROC_BASE + 0x990)
    #define A2_HIST_7 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_5F (IO_PREPROC_BASE + 0x994)
    #define A2_HIST_8 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_60 (IO_PREPROC_BASE + 0x998)
    #define A2_HIST_9 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_61 (IO_PREPROC_BASE + 0x99C)
    #define A2_HIST_10 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_62 (IO_PREPROC_BASE + 0x9A0)
    #define A2_HIST_11 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_63 (IO_PREPROC_BASE + 0x9A4)
    #define A2_HIST_12 Fld(24,0,AC_MSKDW)//[23:0]

//Page PREDSMAIN_2
#define PRE_DS_FIL_64 (IO_PREPROC_BASE + 0x9A8)
    #define A2_HIST_13 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_65 (IO_PREPROC_BASE + 0x9AC)
    #define A2_HIST_14 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_66 (IO_PREPROC_BASE + 0x9B0)
    #define A2_HIST_15 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_67 (IO_PREPROC_BASE + 0x9B4)
    #define B2_HIST_0 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_68 (IO_PREPROC_BASE + 0x9B8)
    #define B2_HIST_1 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_69 (IO_PREPROC_BASE + 0x9BC)
    #define B2_HIST_2 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_6A (IO_PREPROC_BASE + 0x9C0)
    #define B2_HIST_3 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_6B (IO_PREPROC_BASE + 0x9C4)
    #define B2_HIST_4 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_6C (IO_PREPROC_BASE + 0x9C8)
    #define B2_HIST_5 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_6D (IO_PREPROC_BASE + 0x9CC)
    #define B2_HIST_6 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_6E (IO_PREPROC_BASE + 0x9D0)
    #define B2_HIST_7 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_6F (IO_PREPROC_BASE + 0x9D4)
    #define B2_HIST_8 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_70 (IO_PREPROC_BASE + 0x9D8)
    #define B2_HIST_9 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_71 (IO_PREPROC_BASE + 0x9DC)
    #define B2_HIST_10 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_72 (IO_PREPROC_BASE + 0x9E0)
    #define B2_HIST_11 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_73 (IO_PREPROC_BASE + 0x9E4)
    #define B2_HIST_12 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_74 (IO_PREPROC_BASE + 0x9E8)
    #define B2_HIST_13 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_75 (IO_PREPROC_BASE + 0x9EC)
    #define B2_HIST_14 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_76 (IO_PREPROC_BASE + 0x9F0)
    #define B2_HIST_15 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_77 (IO_PREPROC_BASE + 0x9F4)
    #define A3_HIST_0 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_78 (IO_PREPROC_BASE + 0x9F8)
    #define A3_HIST_1 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_79 (IO_PREPROC_BASE + 0x9FC)
    #define A3_HIST_2 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_7A (IO_PREPROC_BASE + 0xA00)
    #define A3_HIST_3 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_7B (IO_PREPROC_BASE + 0xA04)
    #define A3_HIST_4 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_7C (IO_PREPROC_BASE + 0xA08)
    #define A3_HIST_5 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_7D (IO_PREPROC_BASE + 0xA0C)
    #define A3_HIST_6 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_7E (IO_PREPROC_BASE + 0xA10)
    #define A3_HIST_7 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_7F (IO_PREPROC_BASE + 0xA14)
    #define A3_HIST_8 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_80 (IO_PREPROC_BASE + 0xA18)
    #define A3_HIST_9 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_81 (IO_PREPROC_BASE + 0xA1C)
    #define A3_HIST_10 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_82 (IO_PREPROC_BASE + 0xA20)
    #define A3_HIST_11 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_83 (IO_PREPROC_BASE + 0xA24)
    #define A3_HIST_12 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_84 (IO_PREPROC_BASE + 0xA28)
    #define A3_HIST_13 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_85 (IO_PREPROC_BASE + 0xA2C)
    #define A3_HIST_14 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_86 (IO_PREPROC_BASE + 0xA30)
    #define A3_HIST_15 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_87 (IO_PREPROC_BASE + 0xA34)
    #define B3_HIST_0 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_88 (IO_PREPROC_BASE + 0xA38)
    #define B3_HIST_1 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_89 (IO_PREPROC_BASE + 0xA3C)
    #define B3_HIST_2 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_8A (IO_PREPROC_BASE + 0xA40)
    #define B3_HIST_3 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_8B (IO_PREPROC_BASE + 0xA44)
    #define B3_HIST_4 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_8C (IO_PREPROC_BASE + 0xA48)
    #define B3_HIST_5 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_8D (IO_PREPROC_BASE + 0xA4C)
    #define B3_HIST_6 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_8E (IO_PREPROC_BASE + 0xA50)
    #define B3_HIST_7 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_8F (IO_PREPROC_BASE + 0xA54)
    #define B3_HIST_8 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_90 (IO_PREPROC_BASE + 0xA58)
    #define B3_HIST_9 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_91 (IO_PREPROC_BASE + 0xA5C)
    #define B3_HIST_10 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_92 (IO_PREPROC_BASE + 0xA60)
    #define B3_HIST_11 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_93 (IO_PREPROC_BASE + 0xA64)
    #define B3_HIST_12 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_94 (IO_PREPROC_BASE + 0xA68)
    #define B3_HIST_13 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_95 (IO_PREPROC_BASE + 0xA6C)
    #define B3_HIST_14 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_96 (IO_PREPROC_BASE + 0xA70)
    #define B3_HIST_15 Fld(24,0,AC_MSKDW)//[23:0]
#define PRE_DS_FIL_97 (IO_PREPROC_BASE + 0xA74)
    #define H_FILTER_BAND0_DIV Fld(4,28,AC_MSKB3)//[31:28]
    #define H_FILTER_BAND1_DIV Fld(4,24,AC_MSKB3)//[27:24]
    #define H_FILTER_BAND2_DIV Fld(4,20,AC_MSKB2)//[23:20]
    #define H_FILTER_BAND3_DIV Fld(4,16,AC_MSKB2)//[19:16]
    #define H_FILTER_VSYNC_INV Fld(1,15,AC_MSKB1)//[15:15]
    #define H_FILTER_X0_CNT_SEL Fld(1,14,AC_MSKB1)//[14:14]


//===============================================================================
//  5398 Color Related Register
//===============================================================================    
//Page COLOR_1
#define SCE_CFG_MAIN (IO_POSTCOLOR_BASE + 0x000)
    #define M_REG_RESET Fld(1,31,AC_MSKB3)//[31:31]
    #define M_DISP_RESET Fld(1,30,AC_MSKB3)//[30:30]
    #define COLOR_DBUF_EN Fld(1,29,AC_MSKB3)//[29:29]
    #define C_LUMA_HIST_IN_SEL Fld(1,28,AC_MSKB3)//[28:28]
    #define YCURVE_33_EN Fld(1,26,AC_MSKB3)//[26:26]
    #define C_PP_CM_DBG_SEL Fld(4,16,AC_MSKB2)//[19:16]
    #define COLOR_YHIST_TYPE Fld(2,24,AC_MSKB3)//[25:24]
    #define LCN_SAT_LIMIT Fld(1,14,AC_MSKB1)//[14:14]
    #define SEQ_SEL Fld(1,13,AC_MSKB1)//[13:13]
    #define ENG_SWAP Fld(1,11,AC_MSKB1)//[11:11]
    #define COLOR_YHIST_WGT_EN Fld(1,9,AC_MSKB1)//[9:9]
    #define LCMP_BYPASS Fld(1,8,AC_MSKB1)//[8:8]
    #define ALLBP Fld(1,7,AC_MSKB0)//[7:7]
    #define CCMP_BP Fld(1,6,AC_MSKB0)//[6:6]
    #define ADAP_LUMA_BP Fld(1,5,AC_MSKB0)//[5:5]
    #define HEBP Fld(1,4,AC_MSKB0)//[4:4]
    #define SEBP Fld(1,3,AC_MSKB0)//[3:3]
    #define YEBP Fld(1,2,AC_MSKB0)//[2:2]
    #define P2CBP Fld(1,1,AC_MSKB0)//[1:1]
    #define C2PBP Fld(1,0,AC_MSKB0)//[0:0]
#define PXL_CNT_MAIN (IO_POSTCOLOR_BASE + 0x004)
    #define H_CONT Fld(16,0,AC_FULLW10)//[15:0]
#define LINE_CNT_MAIN (IO_POSTCOLOR_BASE + 0x008)
    #define V_CONT Fld(16,16,AC_FULLW32)//[31:16]
    #define LINE_CONT Fld(16,0,AC_FULLW10)//[15:0]
#define WIN_X_MAIN (IO_POSTCOLOR_BASE + 0x00C)
    #define WIN_X_END Fld(16,16,AC_FULLW32)//[31:16]
    #define WIN_X_START Fld(16,0,AC_FULLW10)//[15:0]
#define WIN_Y_MAIN (IO_POSTCOLOR_BASE + 0x010)
    #define WIN_Y_END Fld(16,16,AC_FULLW32)//[31:16]
    #define WIN_Y_START Fld(16,0,AC_FULLW10)//[15:0]
#define CH_DLY_MAIN (IO_POSTCOLOR_BASE + 0x014)
    #define CR_DEL Fld(3,6,AC_MSKW10)//[8:6]
    #define CB_DEL Fld(3,3,AC_MSKB0)//[5:3]
    #define Y_DEL Fld(3,0,AC_MSKB0)//[2:0]
#define DBG_CFG_MAIN (IO_POSTCOLOR_BASE + 0x020)
    #define C_SHP_DSR_DLY_SEL Fld(4,28,AC_MSKB3)//[31:28]
    #define SRS_EN Fld(1,27,AC_MSKB3)//[27:27]
    #define YSH_PTG_MODE Fld(2,25,AC_MSKB3)//[26:25]
    #define CR_INK_MODE Fld(3,22,AC_MSKW32)//[24:22]
    #define CB_INK_MODE Fld(3,19,AC_MSKB2)//[21:19]
    #define Y_INK_MODE Fld(3,16,AC_MSKB2)//[18:16]
    #define W3_INK_EN Fld(1,13,AC_MSKB1)//[13:13]
    #define W2_INK_EN Fld(1,12,AC_MSKB1)//[12:12]
    #define W1_INK_EN Fld(1,11,AC_MSKB1)//[11:11]
    #define CR_REPLACE Fld(1,10,AC_MSKB1)//[10:10]
    #define CB_REPLACE Fld(1,9,AC_MSKB1)//[9:9]
    #define Y_REPLACE Fld(1,8,AC_MSKB1)//[8:8]
    #define SPLIT_SWAP Fld(1,4,AC_MSKB0)//[4:4]
    #define SPLIT_EN Fld(1,3,AC_MSKB0)//[3:3]
    #define SCE_CAP_EN Fld(1,2,AC_MSKB0)//[2:2]
    #define INK_EN Fld(1,0,AC_MSKB0)//[0:0]
/* Mustang Modified : Chroma Boost */
#define C_BOOST_MAIN (IO_POSTCOLOR_BASE + 0x024)
    #define NEW_CBOOST_LMT_U Fld(8,24,AC_FULLB3)//[31:24]
    #define NEW_CBOOST_LMT_L Fld(8,16,AC_FULLB2)//[23:16]
    #define NEW_CBOOST_EN Fld(1,13,AC_MSKB1)//[13:13]
    #define CBOOST_YOFFSET_SEL Fld(2,11,AC_MSKB1)//[12:11]
    #define C_BOOST_LUMA_THD Fld(3,8,AC_MSKB1)//[10:8]
    #define CBOOST_GAIN Fld(8,0,AC_FULLB0)//[7:0]
#define C_BOOST_MAIN_2 (IO_POSTCOLOR_BASE + 0x028)
    #define C_NEW_BOOST_LMT_U2 Fld(8,24,AC_FULLB3)//[31:24]
    #define C_NEW_BOOST_LMT_L2 Fld(8,16,AC_FULLB2)//[23:16]
    #define HUE_HIST_STH Fld(8,8,AC_FULLB1)//[15:8]
    #define CBOOST_YOFFSET Fld(8,0,AC_FULLB0)//[7:0]
#define LUMA_ADJ (IO_POSTCOLOR_BASE + 0x02C)
    #define Y_SLOPE_LMT Fld(8,8,AC_FULLB1)//[15:8]
    #define Y_LEV_ADJ Fld(8,0,AC_FULLB0)//[7:0]
#define G_PIC_ADJ_MAIN_1 (IO_POSTCOLOR_BASE + 0x030)
    #define BRIGHTNESS Fld(11,16,AC_MSKW32)//[26:16]
    #define CONTRAST Fld(10,0,AC_MSKW10)//[9:0]
#define G_PIC_ADJ_MAIN_2 (IO_POSTCOLOR_BASE + 0x034)
    #define HUE Fld(10,16,AC_MSKW32)//[25:16]
    #define SAT Fld(10,0,AC_MSKW10)//[9:0]
#define G_PIC_ADJ_MAIN_3 (IO_POSTCOLOR_BASE + 0x038)
    #define POST_HUE Fld(10,0,AC_MSKW10)//[9:0]
#define INK_DATA_MAIN (IO_POSTCOLOR_BASE + 0x040)
    #define INK_DATA_CB Fld(10,16,AC_MSKW32)//[25:16]
    #define INK_DATA_Y Fld(10,0,AC_MSKW10)//[9:0]
#define INK_DATA_MAIN_CR (IO_POSTCOLOR_BASE + 0x044)
    #define INK_DATA_CR Fld(10,0,AC_MSKW10)//[9:0]
#define Y_SLOPE_1_0_MAIN (IO_POSTCOLOR_BASE + 0x058)
    #define Y_SLOPE_1 Fld(8,16,AC_FULLB2)//[23:16]
    #define Y_SLOPE_0 Fld(8,0,AC_FULLB0)//[7:0]
#define Y_SLOPE_3_2_MAIN (IO_POSTCOLOR_BASE + 0x05C)
    #define Y_SLOPE_3 Fld(8,16,AC_FULLB2)//[23:16]
    #define Y_SLOPE_2 Fld(8,0,AC_FULLB0)//[7:0]
#define Y_SLOPE_5_4_MAIN (IO_POSTCOLOR_BASE + 0x060)
    #define Y_SLOPE_5 Fld(8,16,AC_FULLB2)//[23:16]
    #define Y_SLOPE_4 Fld(8,0,AC_FULLB0)//[7:0]
#define Y_SLOPE_7_6_MAIN (IO_POSTCOLOR_BASE + 0x064)
    #define Y_SLOPE_7 Fld(8,16,AC_FULLB2)//[23:16]
    #define Y_SLOPE_6 Fld(8,0,AC_FULLB0)//[7:0]
#define Y_SLOPE_9_8_MAIN (IO_POSTCOLOR_BASE + 0x068)
    #define Y_SLOPE_9 Fld(8,16,AC_FULLB2)//[23:16]
    #define Y_SLOPE_8 Fld(8,0,AC_FULLB0)//[7:0]
#define Y_SLOPE_11_10_MAIN (IO_POSTCOLOR_BASE + 0x06C)
    #define Y_SLOPE_11 Fld(8,16,AC_FULLB2)//[23:16]
    #define Y_SLOPE_10 Fld(8,0,AC_FULLB0)//[7:0]
#define Y_SLOPE_13_12_MAIN (IO_POSTCOLOR_BASE + 0x070)
    #define Y_SLOPE_13 Fld(8,16,AC_FULLB2)//[23:16]
    #define Y_SLOPE_12 Fld(8,0,AC_FULLB0)//[7:0]
#define Y_SLOPE_15_14_MAIN (IO_POSTCOLOR_BASE + 0x074)
    #define Y_SLOPE_15 Fld(8,16,AC_FULLB2)//[23:16]
    #define Y_SLOPE_14 Fld(8,0,AC_FULLB0)//[7:0]
#define LOCAL_SAT_1 (IO_POSTCOLOR_BASE + 0x078)
    #define SAT_CPU_SEL_SRAM_0 Fld(1,31,AC_MSKB3)//[31:31]
    #define R_SAT_CPURW_ACTIVE Fld(1,30,AC_MSKB3)//[30:30]
    #define SAT_TABLE_WAIT_VSYNC Fld(1,29,AC_MSKB3)//[29:29]
    #define R_SAT_FILL_TABLE_READY Fld(1,28,AC_MSKB3)//[28:28]
    #define SAT_READ_FINISH Fld(1,27,AC_MSKB3)//[27:27]
    #define SAT_R_READ Fld(1,26,AC_MSKB3)//[26:26]
    #define SAT_WRITE_FINISH Fld(1,25,AC_MSKB3)//[25:25]
    #define R_SAT_WRITE Fld(1,24,AC_MSKB3)//[24:24]
    #define R_SAT_FORCE_SRAM_CS_ON Fld(1,17,AC_MSKB2)//[17:17]
    #define R_SAT_VA_READ_LATEST_WDATA Fld(1,16,AC_MSKB2)//[16:16]
    #define R_SAT_RDATA_BYTE_EN_SEL Fld(2,14,AC_MSKB1)//[15:14]
    #define R_SAT_WDATA_BYTE_EN_SEL Fld(2,12,AC_MSKB1)//[13:12]
    #define R_SAT_RD_AUTO_INC_ADDR Fld(1,11,AC_MSKB1)//[11:11]
    #define R_SAT_WR_AUTO_INC_ADDR Fld(1,10,AC_MSKB1)//[10:10]
    #define R_SAT_PIO_MODE Fld(1,9,AC_MSKB1)//[9:9]
    #define R_SAT_FORCE_WR_NO_WAIT Fld(1,8,AC_MSKB1)//[8:8]
    #define R_SAT_MAX_WAIT_CYCLE Fld(8,0,AC_FULLB0)//[7:0]
#define LOCAL_SAT_2 (IO_POSTCOLOR_BASE + 0x07C)
    #define SAT_CPU_SRAM_ADDR Fld(5,16,AC_MSKB2)//[20:16]
    #define R_SAT_ADDR Fld(5,0,AC_MSKB0)//[4:0]
#define LOCAL_SAT_3 (IO_POSTCOLOR_BASE + 0x080)
    #define SAT_G2_W Fld(8,24,AC_FULLB3)//[31:24]
    #define SAT_G1_W Fld(8,16,AC_FULLB2)//[23:16]
    #define SAT_P2_W Fld(8,8,AC_FULLB1)//[15:8]
    #define SAT_P1_W Fld(8,0,AC_FULLB0)//[7:0]
#define LOCAL_SAT_4 (IO_POSTCOLOR_BASE + 0x084)
    #define SAT_G_Y128_W Fld(8,24,AC_FULLB3)//[31:24]
    #define SAT_G_Y64_W Fld(8,16,AC_FULLB2)//[23:16]
    #define SAT_G_Y0_W Fld(8,8,AC_FULLB1)//[15:8]
    #define SAT_G3_W Fld(8,0,AC_FULLB0)//[7:0]
#define LOCAL_SAT_5 (IO_POSTCOLOR_BASE + 0x088)
    #define LCMP_M11_W Fld(10,16,AC_MSKW32)//[25:16]
    #define SAT_G_Y256_W Fld(8,8,AC_FULLB1)//[15:8]
    #define SAT_G_Y192_W Fld(8,0,AC_FULLB0)//[7:0]
#define LOCAL_SAT_6 (IO_POSTCOLOR_BASE + 0x08C)
    #define LCMP_M21_W Fld(10,20,AC_MSKW32)//[29:20]
    #define LCMP_M13_W Fld(10,10,AC_MSKW21)//[19:10]
    #define LCMP_M12_W Fld(10,0,AC_MSKW10)//[9:0]
#define LOCAL_SAT_7 (IO_POSTCOLOR_BASE + 0x090)
    #define LCMP_M23_W Fld(10,10,AC_MSKW21)//[19:10]
    #define LCMP_M22_W Fld(10,0,AC_MSKW10)//[9:0]
#define LOCAL_SAT_8 (IO_POSTCOLOR_BASE + 0x094)
    #define SAT_G2_R Fld(8,24,AC_FULLB3)//[31:24]
    #define SAT_G1_R Fld(8,16,AC_FULLB2)//[23:16]
    #define SAT_P2_R Fld(8,8,AC_FULLB1)//[15:8]
    #define SAT_P1_R Fld(8,0,AC_FULLB0)//[7:0]
#define LOCAL_SAT_9 (IO_POSTCOLOR_BASE + 0x098)
    #define SAT_G_Y128_R Fld(8,24,AC_FULLB3)//[31:24]
    #define SAT_G_Y64_R Fld(8,16,AC_FULLB2)//[23:16]
    #define SAT_G_Y0_R Fld(8,8,AC_FULLB1)//[15:8]
    #define SAT_G3_R Fld(8,0,AC_FULLB0)//[7:0]
#define LOCAL_SAT_10 (IO_POSTCOLOR_BASE + 0x09C)
    #define LCMP_M11_R Fld(10,16,AC_MSKW32)//[25:16]
    #define SAT_G_Y256_R Fld(8,8,AC_FULLB1)//[15:8]
    #define SAT_G_Y192_R Fld(8,0,AC_FULLB0)//[7:0]
#define LOCAL_SAT_11 (IO_POSTCOLOR_BASE + 0x0A0)
    #define LCMP_M21_R Fld(10,20,AC_MSKW32)//[29:20]
    #define LCMP_M13_R Fld(10,10,AC_MSKW21)//[19:10]
    #define LCMP_M12_R Fld(10,0,AC_MSKW10)//[9:0]
#define LOCAL_SAT_12 (IO_POSTCOLOR_BASE + 0x0A4)
    #define LCMP_M23_R Fld(10,10,AC_MSKW21)//[19:10]
    #define LCMP_M22_R Fld(10,0,AC_MSKW10)//[9:0]
#define CCMP_GROUP_1 (IO_POSTCOLOR_BASE + 0x0A8)
    #define CCMP_3 Fld(8,24,AC_FULLB3)//[31:24]
    #define CCMP_2 Fld(8,16,AC_FULLB2)//[23:16]
    #define CCMP_1 Fld(8,8,AC_FULLB1)//[15:8]
    #define CCMP_0 Fld(8,0,AC_FULLB0)//[7:0]
#define CCMP_GROUP_2 (IO_POSTCOLOR_BASE + 0x0AC)
    #define CCMP_7 Fld(8,24,AC_FULLB3)//[31:24]
    #define CCMP_6 Fld(8,16,AC_FULLB2)//[23:16]
    #define CCMP_5 Fld(8,8,AC_FULLB1)//[15:8]
    #define CCMP_4 Fld(8,0,AC_FULLB0)//[7:0]
#define CCMP_GROUP_3 (IO_POSTCOLOR_BASE + 0x0B0)
    #define CCMP_8 Fld(8,0,AC_FULLB0)//[7:0]
#define TWO_D_WINDOW_1 (IO_POSTCOLOR_BASE + 0x0B4)
    #define W1_SAT_UPPER Fld(8,24,AC_FULLB3)//[31:24]
    #define W1_SAT_LOWER Fld(8,16,AC_FULLB2)//[23:16]
    #define W1_HUE_UPPER Fld(8,8,AC_FULLB1)//[15:8]
    #define W1_HUE_LOWER Fld(8,0,AC_FULLB0)//[7:0]
#define TWO_D_WINDOW_2 (IO_POSTCOLOR_BASE + 0x0B8)
    #define W2_SAT_UPPER Fld(8,24,AC_FULLB3)//[31:24]
    #define W2_SAT_LOWER Fld(8,16,AC_FULLB2)//[23:16]
    #define W2_HUE_UPPER Fld(8,8,AC_FULLB1)//[15:8]
    #define W2_HUE_LOWER Fld(8,0,AC_FULLB0)//[7:0]
#define TWO_D_WINDOW_3 (IO_POSTCOLOR_BASE + 0x0BC)
    #define W3_SAT_UPPER Fld(8,24,AC_FULLB3)//[31:24]
    #define W3_SAT_LOWER Fld(8,16,AC_FULLB2)//[23:16]
    #define W3_HUE_UPPER Fld(8,8,AC_FULLB1)//[15:8]
    #define W3_HUE_LOWER Fld(8,0,AC_FULLB0)//[7:0]
#define TWO_D_W1_RESULT (IO_POSTCOLOR_BASE + 0x0C0)
    #define W1_RESULT Fld(23,0,AC_MSKDW)//[22:0]
#define TWO_D_W2_RESULT (IO_POSTCOLOR_BASE + 0x0C4)
    #define W2_RESULT Fld(23,0,AC_MSKDW)//[22:0]
#define TWO_D_W3_RESULT (IO_POSTCOLOR_BASE + 0x0C8)
    #define W3_RESULT Fld(23,0,AC_MSKDW)//[22:0]
#define LUMA_SUM_MAIN (IO_POSTCOLOR_BASE + 0x0CC)
    #define SCE_LUMA_SUM Fld(32,0,AC_FULLDW)//[31:0]
#define LUMA_MIN_MAX_MAIN (IO_POSTCOLOR_BASE + 0x0D0)
    #define COLOR_INFO_3D_EN Fld(1,31,AC_MSKB3)//[31:31]
    #define COLOR_INFO_3D_EVEN Fld(1,30,AC_MSKB3)//[30:30]
    #define LUMA_SUM_SHIFT Fld(1,29,AC_MSKB3)//[29:29]
    #define SAT_SUM_SHIFT Fld(1,28,AC_MSKB3)//[28:28]
    #define COLOR_HIST_SHIFT Fld(1,27,AC_MSKB3)//[27:27]
    #define LUMA_MAX Fld(10,16,AC_MSKW32)//[25:16]
    #define LUMA_MIN Fld(10,0,AC_MSKW10)//[9:0]
#define SAT_SUM_MAIN (IO_POSTCOLOR_BASE + 0x0D4)
    #define SCE_SAT_SUM Fld(32,0,AC_FULLDW)//[31:0]
#define LOCAL_HUE_1 (IO_POSTCOLOR_BASE + 0x0D8)
    #define HUE_CPU_SEL_SRAM_0 Fld(1,31,AC_MSKB3)//[31:31]
    #define R_HUE_CPURW_ACTIVE Fld(1,30,AC_MSKB3)//[30:30]
    #define HUE_TABLE_WAIT_VSYNC Fld(1,29,AC_MSKB3)//[29:29]
    #define R_HUE_FILL_TABLE_READY Fld(1,28,AC_MSKB3)//[28:28]
    #define HUE_READ_FINISH Fld(1,27,AC_MSKB3)//[27:27]
    #define HUE_R_READ Fld(1,26,AC_MSKB3)//[26:26]
    #define HUE_WRITE_FINISH Fld(1,25,AC_MSKB3)//[25:25]
    #define R_HUE_WRITE Fld(1,24,AC_MSKB3)//[24:24]
    #define R_HUE_FORCE_SRAM_CS_ON Fld(1,17,AC_MSKB2)//[17:17]
    #define R_HUE_VA_READ_LATEST_WDATA Fld(1,16,AC_MSKB2)//[16:16]
    #define R_HUE_RDATA_BYTE_EN_SEL Fld(2,14,AC_MSKB1)//[15:14]
    #define R_HUE_WDATA_BYTE_EN_SEL Fld(2,12,AC_MSKB1)//[13:12]
    #define R_HUE_RD_AUTO_INC_ADDR Fld(1,11,AC_MSKB1)//[11:11]
    #define R_HUE_WR_AUTO_INC_ADDR Fld(1,10,AC_MSKB1)//[10:10]
    #define R_HUE_PIO_MODE Fld(1,9,AC_MSKB1)//[9:9]
    #define R_HUE_FORCE_WR_NO_WAIT Fld(1,8,AC_MSKB1)//[8:8]
    #define R_HUE_MAX_WAIT_CYCLE Fld(8,0,AC_FULLB0)//[7:0]
#define LOCAL_HUE_2 (IO_POSTCOLOR_BASE + 0x0DC)
    #define HUE_CPU_SRAM_ADDR Fld(5,16,AC_MSKB2)//[20:16]
    #define R_HUE_ADDR Fld(5,0,AC_MSKB0)//[4:0]
#define LOCAL_HUE_3 (IO_POSTCOLOR_BASE + 0x0E0)
    #define Y128_TO_HUE_W Fld(8,24,AC_FULLB3)//[31:24]
    #define Y64_TO_HUE_W Fld(8,16,AC_FULLB2)//[23:16]
    #define Y0_TO_HUE_W Fld(8,8,AC_FULLB1)//[15:8]
    #define HUE_TO_HUE_W Fld(8,0,AC_FULLB0)//[7:0]
#define LOCAL_HUE_4 (IO_POSTCOLOR_BASE + 0x0E4)
    #define S32_TO_HUE_W Fld(8,24,AC_FULLB3)//[31:24]
    #define S0_TO_HUE_W Fld(8,16,AC_FULLB2)//[23:16]
    #define Y256_TO_HUE_W Fld(8,8,AC_FULLB1)//[15:8]
    #define Y192_TO_HUE_W Fld(8,0,AC_FULLB0)//[7:0]
#define LOCAL_HUE_5 (IO_POSTCOLOR_BASE + 0x0E8)
    #define S128_TO_HUE_W Fld(8,16,AC_FULLB2)//[23:16]
    #define S96_TO_HUE_W Fld(8,8,AC_FULLB1)//[15:8]
    #define S64_TO_HUE_W Fld(8,0,AC_FULLB0)//[7:0]
#define LOCAL_HUE_6 (IO_POSTCOLOR_BASE + 0x0EC)
    #define Y128_TO_HUE_R Fld(8,24,AC_FULLB3)//[31:24]
    #define Y64_TO_HUE_R Fld(8,16,AC_FULLB2)//[23:16]
    #define Y0_TO_HUE_R Fld(8,8,AC_FULLB1)//[15:8]
    #define HUE_TO_HUE_R Fld(8,0,AC_FULLB0)//[7:0]
#define LOCAL_HUE_7 (IO_POSTCOLOR_BASE + 0x0F0)
    #define S32_TO_HUE_R Fld(8,24,AC_FULLB3)//[31:24]
    #define S0_TO_HUE_R Fld(8,16,AC_FULLB2)//[23:16]
    #define Y256_TO_HUE_R Fld(8,8,AC_FULLB1)//[15:8]
    #define Y192_TO_HUE_R Fld(8,0,AC_FULLB0)//[7:0]

//Page COLOR_2
#define LOCAL_HUE_8 (IO_POSTCOLOR_BASE + 0x0F4)
    #define S128_TO_HUE_R Fld(8,16,AC_FULLB2)//[23:16]
    #define S96_TO_HUE_R Fld(8,8,AC_FULLB1)//[15:8]
    #define S64_TO_HUE_R Fld(8,0,AC_FULLB0)//[7:0]
#define SAT_HIST_CFG_MAIN (IO_POSTCOLOR_BASE + 0x0F8)
    #define SAT_BOUND_4 Fld(8,24,AC_FULLB3)//[31:24]
    #define SAT_BOUND_3 Fld(8,16,AC_FULLB2)//[23:16]
    #define SAT_BOUND_2 Fld(8,8,AC_FULLB1)//[15:8]
    #define SAT_BOUND_1 Fld(8,0,AC_FULLB0)//[7:0]
#define SAT_HIST_CFG_MAIN_2 (IO_POSTCOLOR_BASE + 0x0FC)
    #define SAT_BOUND_7 Fld(8,16,AC_FULLB2)//[23:16]
    #define SAT_BOUND_6 Fld(8,8,AC_FULLB1)//[15:8]
    #define SAT_BOUND_5 Fld(8,0,AC_FULLB0)//[7:0]
#define SAT_HIST_X_CFG_MAIN (IO_POSTCOLOR_BASE + 0x100)
    #define SAT_WIN_X_END Fld(16,16,AC_FULLW32)//[31:16]
    #define SAT_WIN_X_START Fld(16,0,AC_FULLW10)//[15:0]
#define SAT_HIST_Y_CFG_MAIN (IO_POSTCOLOR_BASE + 0x104)
    #define SAT_WIN_Y_END Fld(16,16,AC_FULLW32)//[31:16]
    #define SAT_WIN_Y_START Fld(16,0,AC_FULLW10)//[15:0]
#define SAT_HIST_1_0_MAIN (IO_POSTCOLOR_BASE + 0x108)
    #define SAT_HIST_1 Fld(16,16,AC_FULLW32)//[31:16]
    #define SAT_HIST_0 Fld(16,0,AC_FULLW10)//[15:0]
#define SAT_HIST_3_2_MAIN (IO_POSTCOLOR_BASE + 0x10C)
    #define SAT_HIST_3 Fld(16,16,AC_FULLW32)//[31:16]
    #define SAT_HIST_2 Fld(16,0,AC_FULLW10)//[15:0]
#define SAT_HIST_5_4_MAIN (IO_POSTCOLOR_BASE + 0x110)
    #define SAT_HIST_5 Fld(16,16,AC_FULLW32)//[31:16]
    #define SAT_HIST_4 Fld(16,0,AC_FULLW10)//[15:0]
#define SAT_HIST_7_6_MAIN (IO_POSTCOLOR_BASE + 0x114)
    #define SAT_HIST_7 Fld(16,16,AC_FULLW32)//[31:16]
    #define SAT_HIST_6 Fld(16,0,AC_FULLW10)//[15:0]

#define BWS_2 (IO_POSTCOLOR_BASE + 0x11C)
    #define PPMCM_ATPG_CT Fld(1,27,AC_MSKB3)//[27:27]
    #define PPMCM_ATPG_OB Fld(1,26,AC_MSKB3)//[26:26]

#define HUE_HIST_CFG_MAIN (IO_POSTCOLOR_BASE + 0x120)
    #define HUE_BOUND_3 Fld(8,24,AC_FULLB3)//[31:24]
    #define HUE_BOUND_2 Fld(8,16,AC_FULLB2)//[23:16]
    #define HUE_BOUND_1 Fld(8,8,AC_FULLB1)//[15:8]
    #define HUE_BOUND_0 Fld(8,0,AC_FULLB0)//[7:0]
#define HUE_HIST_CFG_MAIN_1 (IO_POSTCOLOR_BASE + 0x124)
    #define HUE_BOUND_7 Fld(8,24,AC_FULLB3)//[31:24]
    #define HUE_BOUND_6 Fld(8,16,AC_FULLB2)//[23:16]
    #define HUE_BOUND_5 Fld(8,8,AC_FULLB1)//[15:8]
    #define HUE_BOUND_4 Fld(8,0,AC_FULLB0)//[7:0]
#define HUE_HIST_1_0_MAIN (IO_POSTCOLOR_BASE + 0x128)
    #define HUE_HIST_1 Fld(16,16,AC_FULLW32)//[31:16]
    #define HUE_HIST_0 Fld(16,0,AC_FULLW10)//[15:0]
#define HUE_HIST_3_2_MAIN (IO_POSTCOLOR_BASE + 0x12C)
    #define HUE_HIST_3 Fld(16,16,AC_FULLW32)//[31:16]
    #define HUE_HIST_2 Fld(16,0,AC_FULLW10)//[15:0]
#define HUE_HIST_5_4_MAIN (IO_POSTCOLOR_BASE + 0x130)
    #define HUE_HIST_5 Fld(16,16,AC_FULLW32)//[31:16]
    #define HUE_HIST_4 Fld(16,0,AC_FULLW10)//[15:0]
#define HUE_HIST_7_6_MAIN (IO_POSTCOLOR_BASE + 0x134)
    #define HUE_HIST_7 Fld(16,16,AC_FULLW32)//[31:16]
    #define HUE_HIST_6 Fld(16,0,AC_FULLW10)//[15:0]
#define BITPLUS_1 (IO_POSTCOLOR_BASE + 0x138)
    #define Y_BITPLUS_Q4 Fld(6,26,AC_MSKB3)//[31:26]
    #define Y_BITPLUS_Q3 Fld(6,20,AC_MSKW32)//[25:20]
    #define Y_BITPLUS_Q2 Fld(6,14,AC_MSKW21)//[19:14]
    #define Y_BITPLUS_Q1 Fld(6,8,AC_MSKB1)//[13:8]
    #define Y_BITPLUS_RANDOM_FIX Fld(1,6,AC_MSKB0)//[6:6]
    #define Y_BITPLUS_YRANGE Fld(6,0,AC_MSKB0)//[5:0]
#define BITPLUS_2 (IO_POSTCOLOR_BASE + 0x13C)
    #define Y_BITPLUS_INK_EN Fld(1,31,AC_MSKB3)//[31:31]
    #define Y_BITPLUS_EN Fld(1,30,AC_MSKB3)//[30:30]
    #define Y_BITPLUS_SDIFF_SHIFT Fld(3,27,AC_MSKB3)//[29:27]
    #define Y_BITPLUS_P3 Fld(9,18,AC_MSKW32)//[26:18]
    #define Y_BITPLUS_P2 Fld(9,9,AC_MSKW21)//[17:9]
    #define Y_BITPLUS_P1 Fld(9,0,AC_MSKW10)//[8:0]
#define BITPLUS_3 (IO_POSTCOLOR_BASE + 0x140)
    #define Y_BITPLUS_BYPASS Fld(1,31,AC_MSKB3)//[31:31]
    #define Y_BITPLUS_RANDOM_EN Fld(1,30,AC_MSKB3)//[30:30]
    #define Y_BITPLUS_SHIFT Fld(2,28,AC_MSKB3)//[29:28]
    #define Y_BITPLUS_G34 Fld(6,21,AC_MSKW32)//[26:21]
    #define Y_BITPLUS_G23 Fld(6,15,AC_MSKW21)//[20:15]
    #define Y_BITPLUS_G12 Fld(6,9,AC_MSKB1)//[14:9]
    #define Y_BITPLUS_P4 Fld(9,0,AC_MSKW10)//[8:0]
#define BITPLUS_4 (IO_POSTCOLOR_BASE + 0x144)
    #define S_BITPLUS_Q4 Fld(6,26,AC_MSKB3)//[31:26]
    #define S_BITPLUS_Q3 Fld(6,20,AC_MSKW32)//[25:20]
    #define S_BITPLUS_Q2 Fld(6,14,AC_MSKW21)//[19:14]
    #define S_BITPLUS_Q1 Fld(6,8,AC_MSKB1)//[13:8]
    #define S_BITPLUS_RANDOM_FIX Fld(1,6,AC_MSKB0)//[6:6]
    #define S_BITPLUS_SRANGE Fld(6,0,AC_MSKB0)//[5:0]
#define BITPLUS_5 (IO_POSTCOLOR_BASE + 0x148)
    #define S_BITPLUS_INK_EN Fld(1,31,AC_MSKB3)//[31:31]
    #define S_BITPLUS_EN Fld(1,30,AC_MSKB3)//[30:30]
    #define S_BITPLUS_SDIFF_SHIFT Fld(3,27,AC_MSKB3)//[29:27]
    #define S_BITPLUS_P3 Fld(9,18,AC_MSKW32)//[26:18]
    #define S_BITPLUS_P2 Fld(9,9,AC_MSKW21)//[17:9]
    #define S_BITPLUS_P1 Fld(9,0,AC_MSKW10)//[8:0]
#define BITPLUS_6 (IO_POSTCOLOR_BASE + 0x14C)
    #define S_BITPLUS_BYPASS Fld(1,31,AC_MSKB3)//[31:31]
    #define S_BITPLUS_RANDOM_EN Fld(1,30,AC_MSKB3)//[30:30]
    #define S_BITPLUS_SHIFT Fld(2,28,AC_MSKB3)//[29:28]
    #define S_BITPLUS_G34 Fld(6,21,AC_MSKW32)//[26:21]
    #define S_BITPLUS_G23 Fld(6,15,AC_MSKW21)//[20:15]
    #define S_BITPLUS_G12 Fld(6,9,AC_MSKB1)//[14:9]
    #define S_BITPLUS_P4 Fld(9,0,AC_MSKW10)//[8:0]
#define BITPLUS_7 (IO_POSTCOLOR_BASE + 0x150)
    #define S_BITPLUS_HRANGE Fld(6,0,AC_MSKB0)//[5:0]
//NEW add register in capy for YSH area counter Y bound
#define YSH_COLOR_AREA_CONFIG_3 (IO_POSTCOLOR_BASE + 0x188)
    #define YSH_COLOR_AREA_MIN_Y3 Fld(10,20,AC_MSKW32)//[29:20]
    #define YSH_COLOR_AREA_MAX_Y2 Fld(10,10,AC_MSKW21)//[19:10]
    #define YSH_COLOR_AREA_MIN_Y2 Fld(9,0,AC_MSKW10)//[9:0]
#define YSH_COLOR_AREA_CONFIG_4 (IO_POSTCOLOR_BASE + 0x18C)
    #define YSH_COLOR_AREA_MAX_Y3 Fld(10,0,AC_MSKW10)//[9:0]

#define Y_FTN_1_0_MAIN (IO_POSTCOLOR_BASE + 0x200)
    #define Y_FTN_1 Fld(12,16,AC_MSKW32)//[27:16]
    #define Y_FTN_0 Fld(12,0,AC_MSKW10)//[11:0]
#define Y_FTN_3_2_MAIN (IO_POSTCOLOR_BASE + 0x204)
    #define Y_FTN_3 Fld(12,16,AC_MSKW32)//[27:16]
    #define Y_FTN_2 Fld(12,0,AC_MSKW10)//[11:0]
#define Y_FTN_5_4_MAIN (IO_POSTCOLOR_BASE + 0x208)
    #define Y_FTN_5 Fld(12,16,AC_MSKW32)//[27:16]
    #define Y_FTN_4 Fld(12,0,AC_MSKW10)//[11:0]
#define Y_FTN_7_6_MAIN (IO_POSTCOLOR_BASE + 0x20C)
    #define Y_FTN_7 Fld(12,16,AC_MSKW32)//[27:16]
    #define Y_FTN_6 Fld(12,0,AC_MSKW10)//[11:0]
#define Y_FTN_9_8_MAIN (IO_POSTCOLOR_BASE + 0x210)
    #define Y_FTN_9 Fld(12,16,AC_MSKW32)//[27:16]
    #define Y_FTN_8 Fld(12,0,AC_MSKW10)//[11:0]
#define Y_FTN_11_10_MAIN (IO_POSTCOLOR_BASE + 0x214)
    #define Y_FTN_11 Fld(12,16,AC_MSKW32)//[27:16]
    #define Y_FTN_10 Fld(12,0,AC_MSKW10)//[11:0]
#define Y_FTN_13_12_MAIN (IO_POSTCOLOR_BASE + 0x218)
    #define Y_FTN_13 Fld(12,16,AC_MSKW32)//[27:16]
    #define Y_FTN_12 Fld(12,0,AC_MSKW10)//[11:0]
#define Y_FTN_15_14_MAIN (IO_POSTCOLOR_BASE + 0x21C)
    #define Y_FTN_15 Fld(12,16,AC_MSKW32)//[27:16]
    #define Y_FTN_14 Fld(12,0,AC_MSKW10)//[11:0]
#define Y_FTN_17_16_MAIN (IO_POSTCOLOR_BASE + 0x220)
    #define Y_FTN_17 Fld(12,16,AC_MSKW32)//[27:16]
    #define Y_FTN_16 Fld(12,0,AC_MSKW10)//[11:0]
#define Y_FTN_19_18_MAIN (IO_POSTCOLOR_BASE + 0x224)
    #define Y_FTN_19 Fld(12,16,AC_MSKW32)//[27:16]
    #define Y_FTN_18 Fld(12,0,AC_MSKW10)//[11:0]
#define Y_FTN_21_20_MAIN (IO_POSTCOLOR_BASE + 0x228)
    #define Y_FTN_21 Fld(12,16,AC_MSKW32)//[27:16]
    #define Y_FTN_20 Fld(12,0,AC_MSKW10)//[11:0]
#define Y_FTN_23_22_MAIN (IO_POSTCOLOR_BASE + 0x22C)
    #define Y_FTN_23 Fld(12,16,AC_MSKW32)//[27:16]
    #define Y_FTN_22 Fld(12,0,AC_MSKW10)//[11:0]
#define Y_FTN_25_24_MAIN (IO_POSTCOLOR_BASE + 0x230)
    #define Y_FTN_25 Fld(12,16,AC_MSKW32)//[27:16]
    #define Y_FTN_24 Fld(12,0,AC_MSKW10)//[11:0]
#define Y_FTN_27_26_MAIN (IO_POSTCOLOR_BASE + 0x234)
    #define Y_FTN_27 Fld(12,16,AC_MSKW32)//[27:16]
    #define Y_FTN_26 Fld(12,0,AC_MSKW10)//[11:0]
#define Y_FTN_29_28_MAIN (IO_POSTCOLOR_BASE + 0x238)
    #define Y_FTN_29 Fld(12,16,AC_MSKW32)//[27:16]
    #define Y_FTN_28 Fld(12,0,AC_MSKW10)//[11:0]
#define Y_FTN_31_30_MAIN (IO_POSTCOLOR_BASE + 0x23C)
    #define Y_FTN_31 Fld(12,16,AC_MSKW32)//[27:16]
    #define Y_FTN_30 Fld(12,0,AC_MSKW10)//[11:0]
#define Y_FTN_32_33_MAIN (IO_POSTCOLOR_BASE + 0x240)
    #define Y_FTN_33 Fld(12,16,AC_MSKW32)//[27:16]
    #define Y_FTN_32 Fld(12,0,AC_MSKW10)//[11:0]
#define Y_FTN_35_34_MAIN (IO_POSTCOLOR_BASE + 0x244)
    #define Y_FTN_35 Fld(12,16,AC_MSKW32)//[27:16]
    #define Y_FTN_34 Fld(12,0,AC_MSKW10)//[11:0]
#define Y_FTN_37_36_MAIN (IO_POSTCOLOR_BASE + 0x248)
    #define Y_FTN_37 Fld(12,16,AC_MSKW32)//[27:16]
    #define Y_FTN_36 Fld(12,0,AC_MSKW10)//[11:0]
#define Y_FTN_39_38_MAIN (IO_POSTCOLOR_BASE + 0x24C)
    #define Y_FTN_39 Fld(12,16,AC_MSKW32)//[27:16]
    #define Y_FTN_38 Fld(12,0,AC_MSKW10)//[11:0]
#define Y_FTN_41_40_MAIN (IO_POSTCOLOR_BASE + 0x250)
    #define Y_FTN_41 Fld(12,16,AC_MSKW32)//[27:16]
    #define Y_FTN_40 Fld(12,0,AC_MSKW10)//[11:0]
#define Y_FTN_43_42_MAIN (IO_POSTCOLOR_BASE + 0x254)
    #define Y_FTN_43 Fld(12,16,AC_MSKW32)//[27:16]
    #define Y_FTN_42 Fld(12,0,AC_MSKW10)//[11:0]
#define Y_FTN_45_44_MAIN (IO_POSTCOLOR_BASE + 0x258)
    #define Y_FTN_45 Fld(12,16,AC_MSKW32)//[27:16]
    #define Y_FTN_44 Fld(12,0,AC_MSKW10)//[11:0]
#define Y_FTN_47_46_MAIN (IO_POSTCOLOR_BASE + 0x25C)
    #define Y_FTN_47 Fld(12,16,AC_MSKW32)//[27:16]
    #define Y_FTN_46 Fld(12,0,AC_MSKW10)//[11:0]
#define Y_FTN_49_48_MAIN (IO_POSTCOLOR_BASE + 0x260)
    #define Y_FTN_49 Fld(12,16,AC_MSKW32)//[27:16]
    #define Y_FTN_48 Fld(12,0,AC_MSKW10)//[11:0]
#define Y_FTN_51_50_MAIN (IO_POSTCOLOR_BASE + 0x264)
    #define Y_FTN_51 Fld(12,16,AC_MSKW32)//[27:16]
    #define Y_FTN_50 Fld(12,0,AC_MSKW10)//[11:0]
#define Y_FTN_53_52_MAIN (IO_POSTCOLOR_BASE + 0x268)
    #define Y_FTN_53 Fld(12,16,AC_MSKW32)//[27:16]
    #define Y_FTN_52 Fld(12,0,AC_MSKW10)//[11:0]
#define Y_FTN_55_54_MAIN (IO_POSTCOLOR_BASE + 0x26C)
    #define Y_FTN_55 Fld(12,16,AC_MSKW32)//[27:16]
    #define Y_FTN_54 Fld(12,0,AC_MSKW10)//[11:0]
#define Y_FTN_57_56_MAIN (IO_POSTCOLOR_BASE + 0x270)
    #define Y_FTN_57 Fld(12,16,AC_MSKW32)//[27:16]
    #define Y_FTN_56 Fld(12,0,AC_MSKW10)//[11:0]
#define Y_FTN_59_58_MAIN (IO_POSTCOLOR_BASE + 0x274)
    #define Y_FTN_59 Fld(12,16,AC_MSKW32)//[27:16]
    #define Y_FTN_58 Fld(12,0,AC_MSKW10)//[11:0]
#define Y_FTN_61_60_MAIN (IO_POSTCOLOR_BASE + 0x278)
    #define Y_FTN_61 Fld(12,16,AC_MSKW32)//[27:16]
    #define Y_FTN_60 Fld(12,0,AC_MSKW10)//[11:0]
#define Y_FTN_63_62_MAIN (IO_POSTCOLOR_BASE + 0x27C)
    #define Y_FTN_63 Fld(12,16,AC_MSKW32)//[27:16]
    #define Y_FTN_62 Fld(12,0,AC_MSKW10)//[11:0]
#define Y_FTN_64_MAIN (IO_POSTCOLOR_BASE + 0x280)
    #define Y_FTN_64 Fld(12,0,AC_MSKW10)//[11:0]
#define Y_FTN2_1_0_MAIN (IO_POSTCOLOR_BASE + 0x284)
    #define Y_FTN2_1 Fld(12,16,AC_MSKW32)//[27:16]
    #define Y_FTN2_0 Fld(12,0,AC_MSKW10)//[11:0]
#define Y_FTN2_3_2_MAIN (IO_POSTCOLOR_BASE + 0x288)
    #define Y_FTN2_3 Fld(12,16,AC_MSKW32)//[27:16]
    #define Y_FTN2_2 Fld(12,0,AC_MSKW10)//[11:0]
#define Y_FTN2_5_4_MAIN (IO_POSTCOLOR_BASE + 0x28C)
    #define Y_FTN2_5 Fld(12,16,AC_MSKW32)//[27:16]
    #define Y_FTN2_4 Fld(12,0,AC_MSKW10)//[11:0]
#define Y_FTN2_7_6_MAIN (IO_POSTCOLOR_BASE + 0x290)
    #define Y_FTN2_7 Fld(12,16,AC_MSKW32)//[27:16]
    #define Y_FTN2_6 Fld(12,0,AC_MSKW10)//[11:0]
#define Y_FTN2_9_8_MAIN (IO_POSTCOLOR_BASE + 0x294)
    #define Y_FTN2_9 Fld(12,16,AC_MSKW32)//[27:16]
    #define Y_FTN2_8 Fld(12,0,AC_MSKW10)//[11:0]
#define Y_FTN2_11_10_MAIN (IO_POSTCOLOR_BASE + 0x298)
    #define Y_FTN2_11 Fld(12,16,AC_MSKW32)//[27:16]
    #define Y_FTN2_10 Fld(12,0,AC_MSKW10)//[11:0]
#define Y_FTN2_13_12_MAIN (IO_POSTCOLOR_BASE + 0x29C)
    #define Y_FTN2_13 Fld(12,16,AC_MSKW32)//[27:16]
    #define Y_FTN2_12 Fld(12,0,AC_MSKW10)//[11:0]
#define Y_FTN2_15_14_MAIN (IO_POSTCOLOR_BASE + 0x2A0)
    #define Y_FTN2_15 Fld(12,16,AC_MSKW32)//[27:16]
    #define Y_FTN2_14 Fld(12,0,AC_MSKW10)//[11:0]
#define Y_FTN2_17_16_MAIN (IO_POSTCOLOR_BASE + 0x2A4)
    #define Y_FTN2_17 Fld(12,16,AC_MSKW32)//[27:16]
    #define Y_FTN2_16 Fld(12,0,AC_MSKW10)//[11:0]
#define Y_FTN2_19_18_MAIN (IO_POSTCOLOR_BASE + 0x2A8)
    #define Y_FTN2_19 Fld(12,16,AC_MSKW32)//[27:16]
    #define Y_FTN2_18 Fld(12,0,AC_MSKW10)//[11:0]
#define Y_FTN2_21_20_MAIN (IO_POSTCOLOR_BASE + 0x2AC)
    #define Y_FTN2_21 Fld(12,16,AC_MSKW32)//[27:16]
    #define Y_FTN2_20 Fld(12,0,AC_MSKW10)//[11:0]
#define Y_FTN2_23_22_MAIN (IO_POSTCOLOR_BASE + 0x2B0)
    #define Y_FTN2_23 Fld(12,16,AC_MSKW32)//[27:16]
    #define Y_FTN2_22 Fld(12,0,AC_MSKW10)//[11:0]
#define Y_FTN2_25_24_MAIN (IO_POSTCOLOR_BASE + 0x2B4)
    #define Y_FTN2_25 Fld(12,16,AC_MSKW32)//[27:16]
    #define Y_FTN2_24 Fld(12,0,AC_MSKW10)//[11:0]
#define Y_FTN2_27_26_MAIN (IO_POSTCOLOR_BASE + 0x2B8)
    #define Y_FTN2_27 Fld(12,16,AC_MSKW32)//[27:16]
    #define Y_FTN2_26 Fld(12,0,AC_MSKW10)//[11:0]
#define Y_FTN2_29_28_MAIN (IO_POSTCOLOR_BASE + 0x2BC)
    #define Y_FTN2_29 Fld(12,16,AC_MSKW32)//[27:16]
    #define Y_FTN2_28 Fld(12,0,AC_MSKW10)//[11:0]
#define Y_FTN2_31_30_MAIN (IO_POSTCOLOR_BASE + 0x2C0)
    #define Y_FTN2_31 Fld(12,16,AC_MSKW32)//[27:16]
    #define Y_FTN2_30 Fld(12,0,AC_MSKW10)//[11:0]
#define Y_FTN2_33_32_MAIN (IO_POSTCOLOR_BASE + 0x2C4)
    #define Y_FTN2_33 Fld(12,16,AC_MSKW32)//[27:16]
    #define Y_FTN2_32 Fld(12,0,AC_MSKW10)//[11:0]
#define Y_FTN2_35_34_MAIN (IO_POSTCOLOR_BASE + 0x2C8)
    #define Y_FTN2_35 Fld(12,16,AC_MSKW32)//[27:16]
    #define Y_FTN2_34 Fld(12,0,AC_MSKW10)//[11:0]
#define Y_FTN2_37_36_MAIN (IO_POSTCOLOR_BASE + 0x2CC)
    #define Y_FTN2_37 Fld(12,16,AC_MSKW32)//[27:16]
    #define Y_FTN2_36 Fld(12,0,AC_MSKW10)//[11:0]
#define Y_FTN2_39_38_MAIN (IO_POSTCOLOR_BASE + 0x2D0)
    #define Y_FTN2_39 Fld(12,16,AC_MSKW32)//[27:16]
    #define Y_FTN2_38 Fld(12,0,AC_MSKW10)//[11:0]
#define Y_FTN2_41_40_MAIN (IO_POSTCOLOR_BASE + 0x2D4)
    #define Y_FTN2_41 Fld(12,16,AC_MSKW32)//[27:16]
    #define Y_FTN2_40 Fld(12,0,AC_MSKW10)//[11:0]
#define Y_FTN2_43_42_MAIN (IO_POSTCOLOR_BASE + 0x2D8)
    #define Y_FTN2_43 Fld(12,16,AC_MSKW32)//[27:16]
    #define Y_FTN2_42 Fld(12,0,AC_MSKW10)//[11:0]
#define Y_FTN2_45_44_MAIN (IO_POSTCOLOR_BASE + 0x2DC)
    #define Y_FTN2_45 Fld(12,16,AC_MSKW32)//[27:16]
    #define Y_FTN2_44 Fld(12,0,AC_MSKW10)//[11:0]
#define Y_FTN2_47_46_MAIN (IO_POSTCOLOR_BASE + 0x2E0)
    #define Y_FTN2_47 Fld(12,16,AC_MSKW32)//[27:16]
    #define Y_FTN2_46 Fld(12,0,AC_MSKW10)//[11:0]
#define Y_FTN2_49_48_MAIN (IO_POSTCOLOR_BASE + 0x2E4)
    #define Y_FTN2_49 Fld(12,16,AC_MSKW32)//[27:16]
    #define Y_FTN2_48 Fld(12,0,AC_MSKW10)//[11:0]
#define Y_FTN2_51_50_MAIN (IO_POSTCOLOR_BASE + 0x2E8)
    #define Y_FTN2_51 Fld(12,16,AC_MSKW32)//[27:16]
    #define Y_FTN2_50 Fld(12,0,AC_MSKW10)//[11:0]
#define Y_FTN2_53_52_MAIN (IO_POSTCOLOR_BASE + 0x2EC)
    #define Y_FTN2_53 Fld(12,16,AC_MSKW32)//[27:16]
    #define Y_FTN2_52 Fld(12,0,AC_MSKW10)//[11:0]
#define Y_FTN2_55_54_MAIN (IO_POSTCOLOR_BASE + 0x2F0)
    #define Y_FTN2_55 Fld(12,16,AC_MSKW32)//[27:16]
    #define Y_FTN2_54 Fld(12,0,AC_MSKW10)//[11:0]
#define Y_FTN2_57_56_MAIN (IO_POSTCOLOR_BASE + 0x2F4)
    #define Y_FTN2_57 Fld(12,16,AC_MSKW32)//[27:16]
    #define Y_FTN2_56 Fld(12,0,AC_MSKW10)//[11:0]
#define Y_FTN2_59_58_MAIN (IO_POSTCOLOR_BASE + 0x2F8)
    #define Y_FTN2_59 Fld(12,16,AC_MSKW32)//[27:16]
    #define Y_FTN2_58 Fld(12,0,AC_MSKW10)//[11:0]
#define Y_FTN2_61_60_MAIN (IO_POSTCOLOR_BASE + 0x2FC)
    #define Y_FTN2_61 Fld(12,16,AC_MSKW32)//[27:16]
    #define Y_FTN2_60 Fld(12,0,AC_MSKW10)//[11:0]
#define Y_FTN2_63_62_MAIN (IO_POSTCOLOR_BASE + 0x300)
    #define Y_FTN2_63 Fld(12,16,AC_MSKW32)//[27:16]
    #define Y_FTN2_62 Fld(12,0,AC_MSKW10)//[11:0]
#define Y_FTN2_64_MAIN (IO_POSTCOLOR_BASE + 0x304)
    #define Y_FTN2_64 Fld(12,0,AC_MSKW10)//[11:0]

#define Y_FTN2_SKIN_RANGE_1 (IO_POSTCOLOR_BASE + 0x308)
    #define Y_FTN2_BYPASS Fld(1,31,AC_MSKB3)//[31:31]
    #define Y_FTN2_INK_EN Fld(1,30,AC_MSKB3)//[30:30]
    #define Y_FTN2_YSLOPE Fld(4,20,AC_MSKB2)//[23:20]
    #define Y_FTN2_YMAX Fld(10,10,AC_MSKW21)//[19:10]
    #define Y_FTN2_YMIN Fld(10,0,AC_MSKW10)//[9:0]
#define Y_FTN2_SKIN_RANGE_2 (IO_POSTCOLOR_BASE + 0x30C)
    #define Y_FTN2_SSLOPE Fld(4,20,AC_MSKB2)//[23:20]
    #define Y_FTN2_SMAX Fld(10,10,AC_MSKW21)//[19:10]
    #define Y_FTN2_SMIN Fld(10,0,AC_MSKW10)//[9:0]
#define Y_FTN2_SKIN_RANGE_3 (IO_POSTCOLOR_BASE + 0x310)
    #define Y_FTN2_HSLOPE Fld(4,20,AC_MSKB2)//[23:20]
    #define Y_FTN2_HMAX Fld(10,10,AC_MSKW21)//[19:10]
    #define Y_FTN2_HMIN Fld(10,0,AC_MSKW10)//[9:0]
// Luma Histogram
#define LUMA_HIST_00 (IO_POSTCOLOR_BASE + 0x400)
    #define LUMA_HIST_PCNT_00 Fld(23,0,AC_MSKDW)//[22:0]
#define LUMA_HIST_01 (IO_POSTCOLOR_BASE + 0x404)
    #define LUMA_HIST_PCNT_01 Fld(23,0,AC_MSKDW)//[22:0]
#define LUMA_HIST_02 (IO_POSTCOLOR_BASE + 0x408)
    #define LUMA_HIST_PCNT_02 Fld(23,0,AC_MSKDW)//[22:0]
#define LUMA_HIST_03 (IO_POSTCOLOR_BASE + 0x40C)
    #define LUMA_HIST_PCNT_03 Fld(23,0,AC_MSKDW)//[22:0]
#define LUMA_HIST_04 (IO_POSTCOLOR_BASE + 0x410)
    #define LUMA_HIST_PCNT_04 Fld(23,0,AC_MSKDW)//[22:0]
#define LUMA_HIST_05 (IO_POSTCOLOR_BASE + 0x414)
    #define LUMA_HIST_PCNT_05 Fld(23,0,AC_MSKDW)//[22:0]
#define LUMA_HIST_06 (IO_POSTCOLOR_BASE + 0x418)
    #define LUMA_HIST_PCNT_06 Fld(23,0,AC_MSKDW)//[22:0]
#define LUMA_HIST_07 (IO_POSTCOLOR_BASE + 0x41C)
    #define LUMA_HIST_PCNT_07 Fld(23,0,AC_MSKDW)//[22:0]
#define LUMA_HIST_08 (IO_POSTCOLOR_BASE + 0x420)
    #define LUMA_HIST_PCNT_08 Fld(23,0,AC_MSKDW)//[22:0]
#define LUMA_HIST_09 (IO_POSTCOLOR_BASE + 0x424)
    #define LUMA_HIST_PCNT_09 Fld(23,0,AC_MSKDW)//[22:0]
#define LUMA_HIST_10 (IO_POSTCOLOR_BASE + 0x428)
    #define LUMA_HIST_PCNT_10 Fld(23,0,AC_MSKDW)//[22:0]
#define LUMA_HIST_11 (IO_POSTCOLOR_BASE + 0x42C)
    #define LUMA_HIST_PCNT_11 Fld(23,0,AC_MSKDW)//[22:0]
#define LUMA_HIST_12 (IO_POSTCOLOR_BASE + 0x430)
    #define LUMA_HIST_PCNT_12 Fld(23,0,AC_MSKDW)//[22:0]
#define LUMA_HIST_13 (IO_POSTCOLOR_BASE + 0x434)
    #define LUMA_HIST_PCNT_13 Fld(23,0,AC_MSKDW)//[22:0]
#define LUMA_HIST_14 (IO_POSTCOLOR_BASE + 0x438)
    #define LUMA_HIST_PCNT_14 Fld(23,0,AC_MSKDW)//[22:0]
#define LUMA_HIST_15 (IO_POSTCOLOR_BASE + 0x43C)
    #define LUMA_HIST_PCNT_15 Fld(23,0,AC_MSKDW)//[22:0]
#define LUMA_HIST_16 (IO_POSTCOLOR_BASE + 0x440)
    #define LUMA_HIST_PCNT_16 Fld(23,0,AC_MSKDW)//[22:0]
#define LUMA_HIST_17 (IO_POSTCOLOR_BASE + 0x444)
    #define LUMA_HIST_PCNT_17 Fld(23,0,AC_MSKDW)//[22:0]
#define LUMA_HIST_18 (IO_POSTCOLOR_BASE + 0x448)
    #define LUMA_HIST_PCNT_18 Fld(23,0,AC_MSKDW)//[22:0]
#define LUMA_HIST_19 (IO_POSTCOLOR_BASE + 0x44C)
    #define LUMA_HIST_PCNT_19 Fld(23,0,AC_MSKDW)//[22:0]
#define LUMA_HIST_20 (IO_POSTCOLOR_BASE + 0x450)
    #define LUMA_HIST_PCNT_20 Fld(23,0,AC_MSKDW)//[22:0]
#define LUMA_HIST_21 (IO_POSTCOLOR_BASE + 0x454)
    #define LUMA_HIST_PCNT_21 Fld(23,0,AC_MSKDW)//[22:0]
#define LUMA_HIST_22 (IO_POSTCOLOR_BASE + 0x458)
    #define LUMA_HIST_PCNT_22 Fld(23,0,AC_MSKDW)//[22:0]
#define LUMA_HIST_23 (IO_POSTCOLOR_BASE + 0x45C)
    #define LUMA_HIST_PCNT_23 Fld(23,0,AC_MSKDW)//[22:0]
#define LUMA_HIST_24 (IO_POSTCOLOR_BASE + 0x460)
    #define LUMA_HIST_PCNT_24 Fld(23,0,AC_MSKDW)//[22:0]
#define LUMA_HIST_25 (IO_POSTCOLOR_BASE + 0x464)
    #define LUMA_HIST_PCNT_25 Fld(23,0,AC_MSKDW)//[22:0]
#define LUMA_HIST_26 (IO_POSTCOLOR_BASE + 0x468)
    #define LUMA_HIST_PCNT_26 Fld(23,0,AC_MSKDW)//[22:0]
#define LUMA_HIST_27 (IO_POSTCOLOR_BASE + 0x46C)
    #define LUMA_HIST_PCNT_27 Fld(23,0,AC_MSKDW)//[22:0]
#define LUMA_HIST_28 (IO_POSTCOLOR_BASE + 0x470)
    #define LUMA_HIST_PCNT_28 Fld(23,0,AC_MSKDW)//[22:0]
#define LUMA_HIST_29 (IO_POSTCOLOR_BASE + 0x474)
    #define LUMA_HIST_PCNT_29 Fld(23,0,AC_MSKDW)//[22:0]
#define LUMA_HIST_30 (IO_POSTCOLOR_BASE + 0x478)
    #define LUMA_HIST_PCNT_30 Fld(23,0,AC_MSKDW)//[22:0]
#define LUMA_HIST_31 (IO_POSTCOLOR_BASE + 0x47C)
    #define LUMA_HIST_PCNT_31 Fld(23,0,AC_MSKDW)//[22:0]
#define LUMA_HIST_32 (IO_POSTCOLOR_BASE + 0x480)
    #define LUMA_HIST_PCNT_32 Fld(23,0,AC_MSKDW)//[22:0]
#define LUMA_HIST_33 (IO_POSTCOLOR_BASE + 0x484)
    #define LUMA_HIST_PCNT_33 Fld(23,0,AC_MSKDW)//[22:0]
#define LUMA_HIST_34 (IO_POSTCOLOR_BASE + 0x488)
    #define LUMA_HIST_PCNT_34 Fld(23,0,AC_MSKDW)//[22:0]
#define LUMA_HIST_35 (IO_POSTCOLOR_BASE + 0x48C)
    #define LUMA_HIST_PCNT_35 Fld(23,0,AC_MSKDW)//[22:0]
#define LUMA_HIST_36 (IO_POSTCOLOR_BASE + 0x490)
    #define LUMA_HIST_PCNT_36 Fld(23,0,AC_MSKDW)//[22:0]
#define LUMA_HIST_37 (IO_POSTCOLOR_BASE + 0x494)
    #define LUMA_HIST_PCNT_37 Fld(23,0,AC_MSKDW)//[22:0]
#define LUMA_HIST_38 (IO_POSTCOLOR_BASE + 0x498)
    #define LUMA_HIST_PCNT_38 Fld(23,0,AC_MSKDW)//[22:0]
#define LUMA_HIST_39 (IO_POSTCOLOR_BASE + 0x49C)
    #define LUMA_HIST_PCNT_39 Fld(23,0,AC_MSKDW)//[22:0]
#define LUMA_HIST_40 (IO_POSTCOLOR_BASE + 0x4A0)
    #define LUMA_HIST_PCNT_40 Fld(23,0,AC_MSKDW)//[22:0]
#define LUMA_HIST_41 (IO_POSTCOLOR_BASE + 0x4A4)
    #define LUMA_HIST_PCNT_41 Fld(23,0,AC_MSKDW)//[22:0]
#define LUMA_HIST_42 (IO_POSTCOLOR_BASE + 0x4A8)
    #define LUMA_HIST_PCNT_42 Fld(23,0,AC_MSKDW)//[22:0]
#define LUMA_HIST_43 (IO_POSTCOLOR_BASE + 0x4AC)
    #define LUMA_HIST_PCNT_43 Fld(23,0,AC_MSKDW)//[22:0]
#define LUMA_HIST_44 (IO_POSTCOLOR_BASE + 0x4B0)
    #define LUMA_HIST_PCNT_44 Fld(23,0,AC_MSKDW)//[22:0]
#define LUMA_HIST_45 (IO_POSTCOLOR_BASE + 0x4B4)
    #define LUMA_HIST_PCNT_45 Fld(23,0,AC_MSKDW)//[22:0]
#define LUMA_HIST_46 (IO_POSTCOLOR_BASE + 0x4B8)
    #define LUMA_HIST_PCNT_46 Fld(23,0,AC_MSKDW)//[22:0]
#define LUMA_HIST_47 (IO_POSTCOLOR_BASE + 0x4BC)
    #define LUMA_HIST_PCNT_47 Fld(23,0,AC_MSKDW)//[22:0]
#define LUMA_HIST_48 (IO_POSTCOLOR_BASE + 0x4C0)
    #define LUMA_HIST_PCNT_48 Fld(23,0,AC_MSKDW)//[22:0]
#define LUMA_HIST_49 (IO_POSTCOLOR_BASE + 0x4C4)
    #define LUMA_HIST_PCNT_49 Fld(23,0,AC_MSKDW)//[22:0]
#define LUMA_HIST_50 (IO_POSTCOLOR_BASE + 0x4C8)
    #define LUMA_HIST_PCNT_50 Fld(23,0,AC_MSKDW)//[22:0]
#define LUMA_HIST_51 (IO_POSTCOLOR_BASE + 0x4CC)
    #define LUMA_HIST_PCNT_51 Fld(23,0,AC_MSKDW)//[22:0]
#define LUMA_HIST_52 (IO_POSTCOLOR_BASE + 0x4D0)
    #define LUMA_HIST_PCNT_52 Fld(23,0,AC_MSKDW)//[22:0]
#define LUMA_HIST_53 (IO_POSTCOLOR_BASE + 0x4D4)
    #define LUMA_HIST_PCNT_53 Fld(23,0,AC_MSKDW)//[22:0]
#define LUMA_HIST_54 (IO_POSTCOLOR_BASE + 0x4D8)
    #define LUMA_HIST_PCNT_54 Fld(23,0,AC_MSKDW)//[22:0]
#define LUMA_HIST_55 (IO_POSTCOLOR_BASE + 0x4DC)
    #define LUMA_HIST_PCNT_55 Fld(23,0,AC_MSKDW)//[22:0]
#define LUMA_HIST_56 (IO_POSTCOLOR_BASE + 0x4E0)
    #define LUMA_HIST_PCNT_56 Fld(23,0,AC_MSKDW)//[22:0]
#define LUMA_HIST_57 (IO_POSTCOLOR_BASE + 0x4E4)
    #define LUMA_HIST_PCNT_57 Fld(23,0,AC_MSKDW)//[22:0]
#define LUMA_HIST_58 (IO_POSTCOLOR_BASE + 0x4E8)
    #define LUMA_HIST_PCNT_58 Fld(23,0,AC_MSKDW)//[22:0]
#define LUMA_HIST_59 (IO_POSTCOLOR_BASE + 0x4EC)
    #define LUMA_HIST_PCNT_59 Fld(23,0,AC_MSKDW)//[22:0]
#define LUMA_HIST_60 (IO_POSTCOLOR_BASE + 0x4F0)
    #define LUMA_HIST_PCNT_60 Fld(23,0,AC_MSKDW)//[22:0]
#define LUMA_HIST_61 (IO_POSTCOLOR_BASE + 0x4F4)
    #define LUMA_HIST_PCNT_61 Fld(23,0,AC_MSKDW)//[22:0]
#define LUMA_HIST_62 (IO_POSTCOLOR_BASE + 0x4F8)
    #define LUMA_HIST_PCNT_62 Fld(23,0,AC_MSKDW)//[22:0]
#define LUMA_HIST_63 (IO_POSTCOLOR_BASE + 0x4FC)
    #define LUMA_HIST_PCNT_63 Fld(23,0,AC_MSKDW)//[22:0]
#define LUMA_HIST_64 (IO_POSTCOLOR_BASE + 0x500)
    #define LUMA_HIST_PCNT_64 Fld(23,0,AC_MSKDW)//[22:0]
#define LUMA_HIST_65 (IO_POSTCOLOR_BASE + 0x504)
    #define LUMA_HIST_PCNT_65 Fld(23,0,AC_MSKDW)//[22:0]
#define LUMA_HIST_66 (IO_POSTCOLOR_BASE + 0x508)
    #define LUMA_HIST_PCNT_66 Fld(23,0,AC_MSKDW)//[22:0]
#define LUMA_HIST_67 (IO_POSTCOLOR_BASE + 0x50C)
    #define LUMA_HIST_PCNT_67 Fld(23,0,AC_MSKDW)//[22:0]
#define LUMA_HIST_68 (IO_POSTCOLOR_BASE + 0x510)
    #define LUMA_HIST_PCNT_68 Fld(23,0,AC_MSKDW)//[22:0]
#define LUMA_HIST_69 (IO_POSTCOLOR_BASE + 0x514)
    #define LUMA_HIST_PCNT_69 Fld(23,0,AC_MSKDW)//[22:0]
#define LUMA_HIST_70 (IO_POSTCOLOR_BASE + 0x518)
    #define LUMA_HIST_PCNT_70 Fld(23,0,AC_MSKDW)//[22:0]
#define LUMA_HIST_71 (IO_POSTCOLOR_BASE + 0x51C)
    #define LUMA_HIST_PCNT_71 Fld(23,0,AC_MSKDW)//[22:0]
#define LUMA_HIST_72 (IO_POSTCOLOR_BASE + 0x520)
    #define LUMA_HIST_PCNT_72 Fld(23,0,AC_MSKDW)//[22:0]
#define LUMA_HIST_73 (IO_POSTCOLOR_BASE + 0x524)
    #define LUMA_HIST_PCNT_73 Fld(23,0,AC_MSKDW)//[22:0]
#define LUMA_HIST_74 (IO_POSTCOLOR_BASE + 0x528)
    #define LUMA_HIST_PCNT_74 Fld(23,0,AC_MSKDW)//[22:0]
#define LUMA_HIST_75 (IO_POSTCOLOR_BASE + 0x52C)
    #define LUMA_HIST_PCNT_75 Fld(23,0,AC_MSKDW)//[22:0]
#define LUMA_HIST_76 (IO_POSTCOLOR_BASE + 0x530)
    #define LUMA_HIST_PCNT_76 Fld(23,0,AC_MSKDW)//[22:0]
#define LUMA_HIST_77 (IO_POSTCOLOR_BASE + 0x534)
    #define LUMA_HIST_PCNT_77 Fld(23,0,AC_MSKDW)//[22:0]
#define LUMA_HIST_78 (IO_POSTCOLOR_BASE + 0x538)
    #define LUMA_HIST_PCNT_78 Fld(23,0,AC_MSKDW)//[22:0]
#define LUMA_HIST_79 (IO_POSTCOLOR_BASE + 0x53C)
    #define LUMA_HIST_PCNT_79 Fld(23,0,AC_MSKDW)//[22:0]
#define LUMA_HIST_80 (IO_POSTCOLOR_BASE + 0x540)
    #define LUMA_HIST_PCNT_80 Fld(23,0,AC_MSKDW)//[22:0]
#define LUMA_HIST_81 (IO_POSTCOLOR_BASE + 0x544)
    #define LUMA_HIST_PCNT_81 Fld(23,0,AC_MSKDW)//[22:0]
#define LUMA_HIST_82 (IO_POSTCOLOR_BASE + 0x548)
    #define LUMA_HIST_PCNT_82 Fld(23,0,AC_MSKDW)//[22:0]
#define LUMA_HIST_83 (IO_POSTCOLOR_BASE + 0x54C)
    #define LUMA_HIST_PCNT_83 Fld(23,0,AC_MSKDW)//[22:0]
#define LUMA_HIST_84 (IO_POSTCOLOR_BASE + 0x550)
    #define LUMA_HIST_PCNT_84 Fld(23,0,AC_MSKDW)//[22:0]
#define LUMA_HIST_85 (IO_POSTCOLOR_BASE + 0x554)
    #define LUMA_HIST_PCNT_85 Fld(23,0,AC_MSKDW)//[22:0]
#define LUMA_HIST_86 (IO_POSTCOLOR_BASE + 0x558)
    #define LUMA_HIST_PCNT_86 Fld(23,0,AC_MSKDW)//[22:0]
#define LUMA_HIST_87 (IO_POSTCOLOR_BASE + 0x55C)
    #define LUMA_HIST_PCNT_87 Fld(23,0,AC_MSKDW)//[22:0]
#define LUMA_HIST_88 (IO_POSTCOLOR_BASE + 0x560)
    #define LUMA_HIST_PCNT_88 Fld(23,0,AC_MSKDW)//[22:0]
#define LUMA_HIST_89 (IO_POSTCOLOR_BASE + 0x564)
    #define LUMA_HIST_PCNT_89 Fld(23,0,AC_MSKDW)//[22:0]
#define LUMA_HIST_90 (IO_POSTCOLOR_BASE + 0x568)
    #define LUMA_HIST_PCNT_90 Fld(23,0,AC_MSKDW)//[22:0]
#define LUMA_HIST_91 (IO_POSTCOLOR_BASE + 0x56C)
    #define LUMA_HIST_PCNT_91 Fld(23,0,AC_MSKDW)//[22:0]
#define LUMA_HIST_92 (IO_POSTCOLOR_BASE + 0x570)
    #define LUMA_HIST_PCNT_92 Fld(23,0,AC_MSKDW)//[22:0]
#define LUMA_HIST_93 (IO_POSTCOLOR_BASE + 0x574)
    #define LUMA_HIST_PCNT_93 Fld(23,0,AC_MSKDW)//[22:0]
#define LUMA_HIST_94 (IO_POSTCOLOR_BASE + 0x578)
    #define LUMA_HIST_PCNT_94 Fld(23,0,AC_MSKDW)//[22:0]
#define LUMA_HIST_95 (IO_POSTCOLOR_BASE + 0x57C)
    #define LUMA_HIST_PCNT_95 Fld(23,0,AC_MSKDW)//[22:0]
#define LUMA_HIST_96 (IO_POSTCOLOR_BASE + 0x580)
    #define LUMA_HIST_PCNT_96 Fld(23,0,AC_MSKDW)//[22:0]
#define LUMA_HIST_97 (IO_POSTCOLOR_BASE + 0x584)
    #define LUMA_HIST_PCNT_97 Fld(23,0,AC_MSKDW)//[22:0]
#define LUMA_HIST_98 (IO_POSTCOLOR_BASE + 0x588)
    #define LUMA_HIST_PCNT_98 Fld(23,0,AC_MSKDW)//[22:0]
#define LUMA_HIST_99 (IO_POSTCOLOR_BASE + 0x58C)
    #define LUMA_HIST_PCNT_99 Fld(23,0,AC_MSKDW)//[22:0]
#define LUMA_HIST_100 (IO_POSTCOLOR_BASE + 0x590)
    #define LUMA_HIST_PCNT_100 Fld(23,0,AC_MSKDW)//[22:0]
#define LUMA_HIST_101 (IO_POSTCOLOR_BASE + 0x594)
    #define LUMA_HIST_PCNT_101 Fld(23,0,AC_MSKDW)//[22:0]
#define LUMA_HIST_102 (IO_POSTCOLOR_BASE + 0x598)
    #define LUMA_HIST_PCNT_102 Fld(23,0,AC_MSKDW)//[22:0]
#define LUMA_HIST_103 (IO_POSTCOLOR_BASE + 0x59C)
    #define LUMA_HIST_PCNT_103 Fld(23,0,AC_MSKDW)//[22:0]
#define LUMA_HIST_104 (IO_POSTCOLOR_BASE + 0x5A0)
    #define LUMA_HIST_PCNT_104 Fld(23,0,AC_MSKDW)//[22:0]
#define LUMA_HIST_105 (IO_POSTCOLOR_BASE + 0x5A4)
    #define LUMA_HIST_PCNT_105 Fld(23,0,AC_MSKDW)//[22:0]
#define LUMA_HIST_106 (IO_POSTCOLOR_BASE + 0x5A8)
    #define LUMA_HIST_PCNT_106 Fld(23,0,AC_MSKDW)//[22:0]
#define LUMA_HIST_107 (IO_POSTCOLOR_BASE + 0x5AC)
    #define LUMA_HIST_PCNT_107 Fld(23,0,AC_MSKDW)//[22:0]
#define LUMA_HIST_108 (IO_POSTCOLOR_BASE + 0x5B0)
    #define LUMA_HIST_PCNT_108 Fld(23,0,AC_MSKDW)//[22:0]
#define LUMA_HIST_109 (IO_POSTCOLOR_BASE + 0x5B4)
    #define LUMA_HIST_PCNT_109 Fld(23,0,AC_MSKDW)//[22:0]
#define LUMA_HIST_110 (IO_POSTCOLOR_BASE + 0x5B8)
    #define LUMA_HIST_PCNT_110 Fld(23,0,AC_MSKDW)//[22:0]
#define LUMA_HIST_111 (IO_POSTCOLOR_BASE + 0x5BC)
    #define LUMA_HIST_PCNT_111 Fld(23,0,AC_MSKDW)//[22:0]
#define LUMA_HIST_112 (IO_POSTCOLOR_BASE + 0x5C0)
    #define LUMA_HIST_PCNT_112 Fld(23,0,AC_MSKDW)//[22:0]
#define CRC_0 (IO_POSTCOLOR_BASE + 0x5C4)
    #define POST_CRC_SRC_SEL Fld(4,16,AC_MSKB2)//[19:16]
    #define CRC_STILL_CHECK_MAX Fld(8,8,AC_FULLB1)//[15:8]
    #define CRC_NON_STILL_CNT Fld(4,4,AC_MSKB0)//[7:4]
    #define CRC_STILL_CHECK_DONE Fld(1,3,AC_MSKB0)//[3:3]
    #define C_CRC_STILL_CHECK_TRIG Fld(1,2,AC_MSKB0)//[2:2]
    #define CRC_L_EN Fld(1,1,AC_MSKB0)//[1:1]
    #define CRC_R_EN Fld(1,0,AC_MSKB0)//[0:0]
#define CRC_1 (IO_POSTCOLOR_BASE + 0x5C8)
    #define CRC_CLIP_H_END Fld(13,16,AC_MSKW32)//[28:16]
    #define CRC_CLIP_H_START Fld(13,0,AC_MSKW10)//[12:0]
#define CRC_2 (IO_POSTCOLOR_BASE + 0x5CC)
    #define CRC_CLIP_V_END Fld(12,16,AC_MSKW32)//[27:16]
    #define CRC_CLIP_V_START Fld(12,0,AC_MSKW10)//[11:0]
#define CRC_3 (IO_POSTCOLOR_BASE + 0x5D0)
    #define CRC_Y_MASK Fld(10,20,AC_MSKW32)//[29:20]
    #define CRC_C_MASK Fld(10,10,AC_MSKW21)//[19:10]
    #define CRC_V_MASK Fld(10,0,AC_MSKW10)//[9:0]
#define CRC_4 (IO_POSTCOLOR_BASE + 0x5D4)
    #define CRC_RESULT Fld(32,0,AC_FULLDW)//[31:0]
#define LCOLORNOISE_1 (IO_POSTCOLOR_BASE + 0x5D8)
    #define LCN_BYPASS Fld(1,31,AC_MSKB3)//[31:31]
    #define LCN_INK_EN Fld(1,30,AC_MSKB3)//[30:30]
    #define LCN_SAT_SRC Fld(1,29,AC_MSKB3)//[29:29]
    #define LIRE_STH Fld(7,22,AC_MSKW32)//[28:22]
    #define LIRE_YTH Fld(8,14,AC_MSKW21)//[21:14]
    #define LIRE_SSLOPE Fld(7,7,AC_MSKW10)//[13:7]
    #define LIRE_YSLOPE Fld(7,0,AC_MSKB0)//[6:0]
#define LCOLORNOISE_2 (IO_POSTCOLOR_BASE + 0x5DC)
    #define LSAT_SSLOPE Fld(7,23,AC_MSKW32)//[29:23]
    #define LSAT_STH Fld(7,16,AC_MSKB2)//[22:16]
    #define LSAT_GAIN Fld(7,8,AC_MSKB1)//[14:8]
    #define LIRE_GAIN Fld(7,0,AC_MSKB0)//[6:0]
#define SAT_HIST_CFG_MAIN_3 (IO_POSTCOLOR_BASE + 0x5E0)
    #define COLOR_HIST_X_END Fld(16,16,AC_FULLW32)//[31:16]
    #define COLOR_HIST_X_START Fld(16,0,AC_FULLW10)//[15:0]
#define SAT_HIST_CFG_MAIN_4 (IO_POSTCOLOR_BASE + 0x5E4)
    #define COLOR_HIST_Y_END Fld(16,16,AC_FULLW32)//[31:16]
    #define COLOR_HIST_Y_START Fld(16,0,AC_FULLW10)//[15:0]
#define SAT_HIST_CFG_MAIN_5 (IO_POSTCOLOR_BASE + 0x5E8)
    #define TWO_DIM_WIN_INV Fld(1,30,AC_MSKB3)//[30:30]
    #define COLOR_HIST_WIN_INV Fld(1,29,AC_MSKB3)//[29:29]
    #define SAT_HIST_HMIN Fld(13,16,AC_MSKW32)//[28:16]
    #define SAT_HIST_HMAX Fld(13,0,AC_MSKW10)//[12:0]
#define SAT_HIST_CFG_MAIN_6 (IO_POSTCOLOR_BASE + 0x5EC)
    #define TWO_DIM_X_END Fld(16,16,AC_FULLW32)//[31:16]
    #define TWO_DIM_X_START Fld(16,0,AC_FULLW10)//[15:0]
#define SAT_HIST_CFG_MAIN_7 (IO_POSTCOLOR_BASE + 0x5F0)
    #define TWO_DIM_Y_END Fld(16,16,AC_FULLW32)//[31:16]
    #define TWO_DIM_Y_START Fld(16,0,AC_FULLW10)//[15:0]
#define COLOR_MAPPING_CONTROL (IO_POSTCOLOR_BASE + 0x628)
    #define CM_INK_CH Fld(2,12,AC_MSKB1)//[13:12]
    #define CM_INK_DELTA_MODE Fld(1,10,AC_MSKB1)//[10:10]
    #define CM_W3_INK_EN Fld(1,9,AC_MSKB1)//[9:9]
    #define CM_W3_WGT_EN Fld(1,8,AC_MSKB1)//[8:8]
    #define CM_W3_EN Fld(1,7,AC_MSKB0)//[7:7]
    #define CM_W2_INK_EN Fld(1,6,AC_MSKB0)//[6:6]
    #define CM_W2_WGT_EN Fld(1,5,AC_MSKB0)//[5:5]
    #define CM_W2_EN Fld(1,4,AC_MSKB0)//[4:4]
    #define CM_W1_INK_EN Fld(1,3,AC_MSKB0)//[3:3]
    #define CM_W1_WGT_EN Fld(1,2,AC_MSKB0)//[2:2]
    #define CM_W1_EN Fld(1,1,AC_MSKB0)//[1:1]
    #define CM_BYPASS Fld(1,0,AC_MSKB0)//[0:0]
#define COLOR_MAPPING_W1_HUE_0 (IO_POSTCOLOR_BASE + 0x62C)
    #define CM_H_W1_POINT0 Fld(10,20,AC_MSKW32)//[29:20]
    #define CM_H_W1_U Fld(10,10,AC_MSKW21)//[19:10]
    #define CM_H_W1_L Fld(10,0,AC_MSKW10)//[9:0]
#define COLOR_MAPPING_W1_HUE_1 (IO_POSTCOLOR_BASE + 0x630)
    #define CM_H_W1_POINT3 Fld(10,20,AC_MSKW32)//[29:20]
    #define CM_H_W1_POINT2 Fld(10,10,AC_MSKW21)//[19:10]
    #define CM_H_W1_POINT1 Fld(10,0,AC_MSKW10)//[9:0]
#define COLOR_MAPPING_W1_HUE_2 (IO_POSTCOLOR_BASE + 0x634)
    #define CM_H_W1_SLOPE1 Fld(8,20,AC_MSKW32)//[27:20]
    #define CM_H_W1_SLOPE0 Fld(8,10,AC_MSKW21)//[17:10]
    #define CM_H_W1_POINT4 Fld(10,0,AC_MSKW10)//[9:0]
#define COLOR_MAPPING_W1_HUE_3 (IO_POSTCOLOR_BASE + 0x638)
    #define CM_H_W1_SLOPE5 Fld(8,24,AC_FULLB3)//[31:24]
    #define CM_H_W1_SLOPE4 Fld(8,16,AC_FULLB2)//[23:16]
    #define CM_H_W1_SLOPE3 Fld(8,8,AC_FULLB1)//[15:8]
    #define CM_H_W1_SLOPE2 Fld(8,0,AC_FULLB0)//[7:0]
#define COLOR_MAPPING_W1_HUE_4 (IO_POSTCOLOR_BASE + 0x63C)
    #define CM_H_W1_WGT_USLOPE Fld(10,16,AC_MSKW32)//[25:16]
    #define CM_H_W1_WGT_LSLOPE Fld(10,0,AC_MSKW10)//[9:0]
#define COLOR_MAPPING_W1_LUMA_0 (IO_POSTCOLOR_BASE + 0x640)
    #define CM_Y_W1_POINT0 Fld(10,20,AC_MSKW32)//[29:20]
    #define CM_Y_W1_U Fld(10,10,AC_MSKW21)//[19:10]
    #define CM_Y_W1_L Fld(10,0,AC_MSKW10)//[9:0]
#define COLOR_MAPPING_W1_LUMA_1 (IO_POSTCOLOR_BASE + 0x644)
    #define CM_Y_W1_POINT3 Fld(10,20,AC_MSKW32)//[29:20]
    #define CM_Y_W1_POINT2 Fld(10,10,AC_MSKW21)//[19:10]
    #define CM_Y_W1_POINT1 Fld(10,0,AC_MSKW10)//[9:0]
#define COLOR_MAPPING_W1_LUMA_2 (IO_POSTCOLOR_BASE + 0x648)
    #define CM_Y_W1_SLOPE1 Fld(8,20,AC_MSKW32)//[27:20]
    #define CM_Y_W1_SLOPE0 Fld(8,10,AC_MSKW21)//[17:10]
    #define CM_Y_W1_POINT4 Fld(10,0,AC_MSKW10)//[9:0]
#define COLOR_MAPPING_W1_LUMA_3 (IO_POSTCOLOR_BASE + 0x64C)
    #define CM_Y_W1_SLOPE5 Fld(8,24,AC_FULLB3)//[31:24]
    #define CM_Y_W1_SLOPE4 Fld(8,16,AC_FULLB2)//[23:16]
    #define CM_Y_W1_SLOPE3 Fld(8,8,AC_FULLB1)//[15:8]
    #define CM_Y_W1_SLOPE2 Fld(8,0,AC_FULLB0)//[7:0]
#define COLOR_MAPPING_W1_LUMA_4 (IO_POSTCOLOR_BASE + 0x650)
    #define CM_Y_W1_WGT_USLOPE Fld(10,16,AC_MSKW32)//[25:16]
    #define CM_Y_W1_WGT_LSLOPE Fld(10,0,AC_MSKW10)//[9:0]
#define COLOR_MAPPING_W1_SAT_0 (IO_POSTCOLOR_BASE + 0x654)
    #define CM_S_W1_POINT0 Fld(10,20,AC_MSKW32)//[29:20]
    #define CM_S_W1_U Fld(10,10,AC_MSKW21)//[19:10]
    #define CM_S_W1_L Fld(10,0,AC_MSKW10)//[9:0]
#define COLOR_MAPPING_W1_SAT_1 (IO_POSTCOLOR_BASE + 0x658)
    #define CM_S_W1_POINT3 Fld(10,20,AC_MSKW32)//[29:20]
    #define CM_S_W1_POINT2 Fld(10,10,AC_MSKW21)//[19:10]
    #define CM_S_W1_POINT1 Fld(10,0,AC_MSKW10)//[9:0]
#define COLOR_MAPPING_W1_SAT_2 (IO_POSTCOLOR_BASE + 0x65C)
    #define CM_S_W1_SLOPE1 Fld(8,20,AC_MSKW32)//[27:20]
    #define CM_S_W1_SLOPE0 Fld(8,10,AC_MSKW21)//[17:10]
    #define CM_S_W1_POINT4 Fld(10,0,AC_MSKW10)//[9:0]
#define COLOR_MAPPING_W1_SAT_3 (IO_POSTCOLOR_BASE + 0x660)
    #define CM_S_W1_SLOPE5 Fld(8,24,AC_FULLB3)//[31:24]
    #define CM_S_W1_SLOPE4 Fld(8,16,AC_FULLB2)//[23:16]
    #define CM_S_W1_SLOPE3 Fld(8,8,AC_FULLB1)//[15:8]
    #define CM_S_W1_SLOPE2 Fld(8,0,AC_FULLB0)//[7:0]
#define COLOR_MAPPING_W1_SAT_4 (IO_POSTCOLOR_BASE + 0x664)
    #define CM_S_W1_WGT_USLOPE Fld(10,16,AC_MSKW32)//[25:16]
    #define CM_S_W1_WGT_LSLOPE Fld(10,0,AC_MSKW10)//[9:0]
#define COLOR_MAPPING_W2_HUE_0 (IO_POSTCOLOR_BASE + 0x668)
    #define CM_H_W2_POINT0 Fld(10,20,AC_MSKW32)//[29:20]
    #define CM_H_W2_U Fld(10,10,AC_MSKW21)//[19:10]
    #define CM_H_W2_L Fld(10,0,AC_MSKW10)//[9:0]
#define COLOR_MAPPING_W2_HUE_1 (IO_POSTCOLOR_BASE + 0x66C)
    #define CM_H_W2_POINT3 Fld(10,20,AC_MSKW32)//[29:20]
    #define CM_H_W2_POINT2 Fld(10,10,AC_MSKW21)//[19:10]
    #define CM_H_W2_POINT1 Fld(10,0,AC_MSKW10)//[9:0]
#define COLOR_MAPPING_W2_HUE_2 (IO_POSTCOLOR_BASE + 0x670)
    #define CM_H_W2_SLOPE1 Fld(8,20,AC_MSKW32)//[27:20]
    #define CM_H_W2_SLOPE0 Fld(8,10,AC_MSKW21)//[17:10]
    #define CM_H_W2_POINT4 Fld(10,0,AC_MSKW10)//[9:0]
#define COLOR_MAPPING_W2_HUE_3 (IO_POSTCOLOR_BASE + 0x674)
    #define CM_H_W2_SLOPE5 Fld(8,24,AC_FULLB3)//[31:24]
    #define CM_H_W2_SLOPE4 Fld(8,16,AC_FULLB2)//[23:16]
    #define CM_H_W2_SLOPE3 Fld(8,8,AC_FULLB1)//[15:8]
    #define CM_H_W2_SLOPE2 Fld(8,0,AC_FULLB0)//[7:0]
#define COLOR_MAPPING_W2_HUE_4 (IO_POSTCOLOR_BASE + 0x678)
    #define CM_H_W2_WGT_USLOPE Fld(10,16,AC_MSKW32)//[25:16]
    #define CM_H_W2_WGT_LSLOPE Fld(10,0,AC_MSKW10)//[9:0]
#define COLOR_MAPPING_W2_LUMA_0 (IO_POSTCOLOR_BASE + 0x67C)
    #define CM_Y_W2_POINT0 Fld(10,20,AC_MSKW32)//[29:20]
    #define CM_Y_W2_U Fld(10,10,AC_MSKW21)//[19:10]
    #define CM_Y_W2_L Fld(10,0,AC_MSKW10)//[9:0]
#define COLOR_MAPPING_W2_LUMA_1 (IO_POSTCOLOR_BASE + 0x680)
    #define CM_Y_W2_POINT3 Fld(10,20,AC_MSKW32)//[29:20]
    #define CM_Y_W2_POINT2 Fld(10,10,AC_MSKW21)//[19:10]
    #define CM_Y_W2_POINT1 Fld(10,0,AC_MSKW10)//[9:0]
#define COLOR_MAPPING_W2_LUMA_2 (IO_POSTCOLOR_BASE + 0x684)
    #define CM_Y_W2_SLOPE1 Fld(8,20,AC_MSKW32)//[27:20]
    #define CM_Y_W2_SLOPE0 Fld(8,10,AC_MSKW21)//[17:10]
    #define CM_Y_W2_POINT4 Fld(10,0,AC_MSKW10)//[9:0]
#define COLOR_MAPPING_W2_LUMA_3 (IO_POSTCOLOR_BASE + 0x688)
    #define CM_Y_W2_SLOPE5 Fld(8,24,AC_FULLB3)//[31:24]
    #define CM_Y_W2_SLOPE4 Fld(8,16,AC_FULLB2)//[23:16]
    #define CM_Y_W2_SLOPE3 Fld(8,8,AC_FULLB1)//[15:8]
    #define CM_Y_W2_SLOPE2 Fld(8,0,AC_FULLB0)//[7:0]
#define COLOR_MAPPING_W2_LUMA_4 (IO_POSTCOLOR_BASE + 0x68C)
    #define CM_Y_W2_WGT_USLOPE Fld(10,16,AC_MSKW32)//[25:16]
    #define CM_Y_W2_WGT_LSLOPE Fld(10,0,AC_MSKW10)//[9:0]
#define COLOR_MAPPING_W2_SAT_0 (IO_POSTCOLOR_BASE + 0x690)
    #define CM_S_W2_POINT0 Fld(10,20,AC_MSKW32)//[29:20]
    #define CM_S_W2_U Fld(10,10,AC_MSKW21)//[19:10]
    #define CM_S_W2_L Fld(10,0,AC_MSKW10)//[9:0]
#define COLOR_MAPPING_W2_SAT_1 (IO_POSTCOLOR_BASE + 0x694)
    #define CM_S_W2_POINT3 Fld(10,20,AC_MSKW32)//[29:20]
    #define CM_S_W2_POINT2 Fld(10,10,AC_MSKW21)//[19:10]
    #define CM_S_W2_POINT1 Fld(10,0,AC_MSKW10)//[9:0]
#define COLOR_MAPPING_W2_SAT_2 (IO_POSTCOLOR_BASE + 0x698)
    #define CM_S_W2_SLOPE1 Fld(8,20,AC_MSKW32)//[27:20]
    #define CM_S_W2_SLOPE0 Fld(8,10,AC_MSKW21)//[17:10]
    #define CM_S_W2_POINT4 Fld(10,0,AC_MSKW10)//[9:0]
#define COLOR_MAPPING_W2_SAT_3 (IO_POSTCOLOR_BASE + 0x69C)
    #define CM_S_W2_SLOPE5 Fld(8,24,AC_FULLB3)//[31:24]
    #define CM_S_W2_SLOPE4 Fld(8,16,AC_FULLB2)//[23:16]
    #define CM_S_W2_SLOPE3 Fld(8,8,AC_FULLB1)//[15:8]
    #define CM_S_W2_SLOPE2 Fld(8,0,AC_FULLB0)//[7:0]
#define COLOR_MAPPING_W2_SAT_4 (IO_POSTCOLOR_BASE + 0x6A0)
    #define CM_S_W2_WGT_USLOPE Fld(10,16,AC_MSKW32)//[25:16]
    #define CM_S_W2_WGT_LSLOPE Fld(10,0,AC_MSKW10)//[9:0]
#define COLOR_MAPPING_W3_HUE_0 (IO_POSTCOLOR_BASE + 0x6A4)
    #define CM_H_W3_POINT0 Fld(10,20,AC_MSKW32)//[29:20]
    #define CM_H_W3_U Fld(10,10,AC_MSKW21)//[19:10]
    #define CM_H_W3_L Fld(10,0,AC_MSKW10)//[9:0]
#define COLOR_MAPPING_W3_HUE_1 (IO_POSTCOLOR_BASE + 0x6A8)
    #define CM_H_W3_POINT3 Fld(10,20,AC_MSKW32)//[29:20]
    #define CM_H_W3_POINT2 Fld(10,10,AC_MSKW21)//[19:10]
    #define CM_H_W3_POINT1 Fld(10,0,AC_MSKW10)//[9:0]
#define COLOR_MAPPING_W3_HUE_2 (IO_POSTCOLOR_BASE + 0x6AC)
    #define CM_H_W3_SLOPE1 Fld(8,20,AC_MSKW32)//[27:20]
    #define CM_H_W3_SLOPE0 Fld(8,10,AC_MSKW21)//[17:10]
    #define CM_H_W3_POINT4 Fld(10,0,AC_MSKW10)//[9:0]
#define COLOR_MAPPING_W3_HUE_3 (IO_POSTCOLOR_BASE + 0x6B0)
    #define CM_H_W3_SLOPE5 Fld(8,24,AC_FULLB3)//[31:24]
    #define CM_H_W3_SLOPE4 Fld(8,16,AC_FULLB2)//[23:16]
    #define CM_H_W3_SLOPE3 Fld(8,8,AC_FULLB1)//[15:8]
    #define CM_H_W3_SLOPE2 Fld(8,0,AC_FULLB0)//[7:0]
#define COLOR_MAPPING_W3_HUE_4 (IO_POSTCOLOR_BASE + 0x6B4)
    #define CM_H_W3_WGT_USLOPE Fld(10,16,AC_MSKW32)//[25:16]
    #define CM_H_W3_WGT_LSLOPE Fld(10,0,AC_MSKW10)//[9:0]
#define COLOR_MAPPING_W3_LUMA_0 (IO_POSTCOLOR_BASE + 0x6B8)
    #define CM_Y_W3_POINT0 Fld(10,20,AC_MSKW32)//[29:20]
    #define CM_Y_W3_U Fld(10,10,AC_MSKW21)//[19:10]
    #define CM_Y_W3_L Fld(10,0,AC_MSKW10)//[9:0]
#define COLOR_MAPPING_W3_LUMA_1 (IO_POSTCOLOR_BASE + 0x6BC)
    #define CM_Y_W3_POINT3 Fld(10,20,AC_MSKW32)//[29:20]
    #define CM_Y_W3_POINT2 Fld(10,10,AC_MSKW21)//[19:10]
    #define CM_Y_W3_POINT1 Fld(10,0,AC_MSKW10)//[9:0]
#define COLOR_MAPPING_W3_LUMA_2 (IO_POSTCOLOR_BASE + 0x6C0)
    #define CM_Y_W3_SLOPE1 Fld(8,20,AC_MSKW32)//[27:20]
    #define CM_Y_W3_SLOPE0 Fld(8,10,AC_MSKW21)//[17:10]
    #define CM_Y_W3_POINT4 Fld(10,0,AC_MSKW10)//[9:0]
#define COLOR_MAPPING_W3_LUMA_3 (IO_POSTCOLOR_BASE + 0x6C4)
    #define CM_Y_W3_SLOPE5 Fld(8,24,AC_FULLB3)//[31:24]
    #define CM_Y_W3_SLOPE4 Fld(8,16,AC_FULLB2)//[23:16]
    #define CM_Y_W3_SLOPE3 Fld(8,8,AC_FULLB1)//[15:8]
    #define CM_Y_W3_SLOPE2 Fld(8,0,AC_FULLB0)//[7:0]
#define COLOR_MAPPING_W3_LUMA_4 (IO_POSTCOLOR_BASE + 0x6C8)
    #define CM_Y_W3_WGT_USLOPE Fld(10,16,AC_MSKW32)//[25:16]
    #define CM_Y_W3_WGT_LSLOPE Fld(10,0,AC_MSKW10)//[9:0]
#define COLOR_MAPPING_W3_SAT_0 (IO_POSTCOLOR_BASE + 0x6CC)
    #define CM_S_W3_POINT0 Fld(10,20,AC_MSKW32)//[29:20]
    #define CM_S_W3_U Fld(10,10,AC_MSKW21)//[19:10]
    #define CM_S_W3_L Fld(10,0,AC_MSKW10)//[9:0]
#define COLOR_MAPPING_W3_SAT_1 (IO_POSTCOLOR_BASE + 0x6D0)
    #define CM_S_W3_POINT3 Fld(10,20,AC_MSKW32)//[29:20]
    #define CM_S_W3_POINT2 Fld(10,10,AC_MSKW21)//[19:10]
    #define CM_S_W3_POINT1 Fld(10,0,AC_MSKW10)//[9:0]
#define COLOR_MAPPING_W3_SAT_2 (IO_POSTCOLOR_BASE + 0x6D4)
    #define CM_S_W3_SLOPE1 Fld(8,20,AC_MSKW32)//[27:20]
    #define CM_S_W3_SLOPE0 Fld(8,10,AC_MSKW21)//[17:10]
    #define CM_S_W3_POINT4 Fld(10,0,AC_MSKW10)//[9:0]
#define COLOR_MAPPING_W3_SAT_3 (IO_POSTCOLOR_BASE + 0x6D8)
    #define CM_S_W3_SLOPE5 Fld(8,24,AC_FULLB3)//[31:24]
    #define CM_S_W3_SLOPE4 Fld(8,16,AC_FULLB2)//[23:16]
    #define CM_S_W3_SLOPE3 Fld(8,8,AC_FULLB1)//[15:8]
    #define CM_S_W3_SLOPE2 Fld(8,0,AC_FULLB0)//[7:0]
#define COLOR_MAPPING_W3_SAT_4 (IO_POSTCOLOR_BASE + 0x6DC)
    #define CM_S_W3_WGT_USLOPE Fld(10,16,AC_MSKW32)//[25:16]
    #define CM_S_W3_WGT_LSLOPE Fld(10,0,AC_MSKW10)//[9:0]

#define COLOR_HDR_DITHER_0 (IO_POSTCOLOR_BASE + 0x6E0)
    #define REG_FPHASE_BIT Fld(3,29,AC_MSKB3)//[31:29]
    #define REG_FPHASE_SEL Fld(2,27,AC_MSKB3)//[28:27]
    #define REG_FPHASE_CTRL Fld(2,25,AC_MSKB3)//[26:25]
    #define FPHASE Fld(6,19,AC_MSKW32)//[24:19]
    #define REG_FPHASE_R Fld(1,18,AC_MSKB2)//[18:18]
    #define REG_FPHASE_EN Fld(1,17,AC_MSKB2)//[17:17]
    #define REG_SUB_B Fld(2,15,AC_MSKW21)//[16:15]
    #define REG_SUB_G Fld(2,13,AC_MSKB1)//[14:13]
    #define REG_SUB_R Fld(2,11,AC_MSKB1)//[12:11]
    #define REG_SUBPIX_EN Fld(1,10,AC_MSKB1)//[10:10]
    #define REG_TABLE_EN Fld(2,8,AC_MSKB1)//[9:8]
    #define DITHER_LFSR_EN Fld(1,6,AC_MSKB0)//[6:6]
    #define RDITHER_EN Fld(1,5,AC_MSKB0)//[5:5]
    #define EDITHER_EN Fld(1,4,AC_MSKB0)//[4:4]
    #define ROUND_EN Fld(1,3,AC_MSKB0)//[3:3]
    #define REG_LEFT_EN Fld(1,2,AC_MSKB0)//[2:2]
    #define REG_COLOR_HDR_BYPASS Fld(1,0,AC_MSKB0)//[0:0]
#define COLOR_HDR_DITHER_1 (IO_POSTCOLOR_BASE + 0x6E4)
    #define REG_INK_DATA_G Fld(12,16,AC_MSKW32)//[27:16]
    #define REG_INK_DATA_R Fld(12,0,AC_MSKW10)//[11:0]
#define COLOR_HDR_DITHER_2 (IO_POSTCOLOR_BASE + 0x6E8)
    #define REG_INK Fld(1,31,AC_MSKB3)//[31:31]
    #define LSB_OFF Fld(1,30,AC_MSKB3)//[30:30]
    #define DRMOD_B Fld(2,16,AC_MSKB2)//[17:16]
    #define DRMOD_G Fld(2,14,AC_MSKB1)//[15:14]
    #define DRMOD_R Fld(2,12,AC_MSKB1)//[13:12]
    #define REG_INK_DATA_B Fld(12,0,AC_MSKW10)//[11:0]
#define COLOR_HDR_DITHER_3 (IO_POSTCOLOR_BASE + 0x6EC)
    #define REG_H_ACTIVE Fld(16,0,AC_FULLW10)//[15:0]
#define C_BOOST_MAIN_3 (IO_POSTCOLOR_BASE + 0x6F0)
    #define C_CHROMA_BOOST_MODE_SEL Fld(1,16,AC_MSKB2)//[16:16]
    #define CBOOST_GAIN_2 Fld(8,8,AC_FULLB1)//[15:8]
    #define CBOOST_GAIN_1 Fld(8,0,AC_FULLB0)//[7:0]
#define CAPTURE_LUMA_0 (IO_POSTCOLOR_BASE + 0x6F4)
    #define C_LUMA_POS_Y Fld(12,20,AC_MSKW32)//[31:20]
    #define C_LUMA_POS_X Fld(12,0,AC_MSKW10)//[11:0]
#define CAPTURE_LUMA_1 (IO_POSTCOLOR_BASE + 0x6F8)
    #define STA_LUMA_DUMP_Y_FTN2 Fld(12,20,AC_MSKW32)//[31:20]
    #define STA_LUMA_DUMP_Y_FTN Fld(12,0,AC_MSKW10)//[11:0]

	//capy add skin luma hist
#define SKIN_LUMA_HIST_00 (IO_POSTCOLOR_BASE + 0x6FC)
    #define SKIN_LUMA_HIST_PCN_00 Fld(32,0,AC_FULLDW)//[31:0]
#define SKIN_LUMA_HIST_01 (IO_POSTCOLOR_BASE + 0x700)
    #define SKIN_LUMA_HIST_PCN_01 Fld(32,0,AC_FULLDW)//[31:0]
#define SKIN_LUMA_HIST_02 (IO_POSTCOLOR_BASE + 0x704)
    #define SKIN_LUMA_HIST_PCN_02 Fld(32,0,AC_FULLDW)//[31:0]
#define SKIN_LUMA_HIST_03 (IO_POSTCOLOR_BASE + 0x708)
    #define SKIN_LUMA_HIS_PCNT_03 Fld(32,0,AC_FULLDW)//[31:0]
#define SKIN_LUMA_HIST_04 (IO_POSTCOLOR_BASE + 0x70C)
    #define SKIN_LUMA_HIST_PCN_04 Fld(32,0,AC_FULLDW)//[31:0]
#define SKIN_LUMA_HIST_05 (IO_POSTCOLOR_BASE + 0x710)
    #define SKIN_LUMA_HIST_PCN_05 Fld(32,0,AC_FULLDW)//[31:0]
#define SKIN_LUMA_HIST_06 (IO_POSTCOLOR_BASE + 0x714)
    #define SKIN_LUMA_HIST_PCN_06 Fld(32,0,AC_FULLDW)//[31:0]
#define SKIN_LUMA_HIST_07 (IO_POSTCOLOR_BASE + 0x718)
    #define SKIN_LUMA_HIST_PCN_07 Fld(32,0,AC_FULLDW)//[31:0]
#define SKIN_LUMA_HIST_08 (IO_POSTCOLOR_BASE + 0x71C)
    #define SKIN_LUMA_HIST_PCN_08 Fld(32,0,AC_FULLDW)//[31:0]
#define SKIN_LUMA_HIST_09 (IO_POSTCOLOR_BASE + 0x720)
    #define SKIN_LUMA_HIST_PCN_09 Fld(32,0,AC_FULLDW)//[31:0]
#define SKIN_LUMA_HIST_10 (IO_POSTCOLOR_BASE + 0x724)
    #define SKIN_LUMA_HIST_PCN_10 Fld(32,0,AC_FULLDW)//[31:0]
#define SKIN_LUMA_HIST_11 (IO_POSTCOLOR_BASE + 0x728)
    #define SKIN_LUMA_HIST_PCN_11 Fld(32,0,AC_FULLDW)//[31:0]
#define SKIN_LUMA_HIST_12 (IO_POSTCOLOR_BASE + 0x72C)
    #define SKIN_LUMA_HIST_PCN_12 Fld(32,0,AC_FULLDW)//[31:0]
#define SKIN_LUMA_HIST_13 (IO_POSTCOLOR_BASE + 0x730)
    #define SKIN_LUMA_HIST_PCN_13 Fld(32,0,AC_FULLDW)//[31:0]
#define SKIN_LUMA_HIST_14 (IO_POSTCOLOR_BASE + 0x734)
    #define SKIN_LUMA_HIST_PCN_14 Fld(32,0,AC_FULLDW)//[31:0]
#define SKIN_LUMA_HIST_15 (IO_POSTCOLOR_BASE + 0x738)
    #define SKIN_LUMA_HIST_PCN_15 Fld(32,0,AC_FULLDW)//[31:0]
#define SKIN_LUMA_HIST_16 (IO_POSTCOLOR_BASE + 0x73C)
    #define SKIN_LUMA_HIST_PCN_16 Fld(32,0,AC_FULLDW)//[31:0]
#define SKIN_LUMA_HIST_17 (IO_POSTCOLOR_BASE + 0x740)
    #define SKIN_LUMA_HIST_PCN_17 Fld(32,0,AC_FULLDW)//[31:0]
#define SKIN_LUMA_HIST_18 (IO_POSTCOLOR_BASE + 0x744)
    #define SKIN_LUMA_HIST_PCN_18 Fld(32,0,AC_FULLDW)//[31:0]
#define SKIN_LUMA_HIST_19 (IO_POSTCOLOR_BASE + 0x748)
    #define SKIN_LUMA_HIST_PCN_19 Fld(32,0,AC_FULLDW)//[31:0]
#define SKIN_LUMA_HIST_20 (IO_POSTCOLOR_BASE + 0x74C)
    #define SKIN_LUMA_HIST_PCN_20 Fld(32,0,AC_FULLDW)//[31:0]
#define SKIN_LUMA_HIST_21 (IO_POSTCOLOR_BASE + 0x750)
    #define SKIN_LUMA_HIST_PCN_21 Fld(32,0,AC_FULLDW)//[31:0]
#define SKIN_LUMA_HIST_22 (IO_POSTCOLOR_BASE + 0x754)
    #define SKIN_LUMA_HIST_PCN_22 Fld(32,0,AC_FULLDW)//[31:0]
#define SKIN_LUMA_HIST_23 (IO_POSTCOLOR_BASE + 0x758)
    #define SKIN_LUMA_HIST_PCN_23 Fld(32,0,AC_FULLDW)//[31:0]
#define SKIN_LUMA_HIST_24 (IO_POSTCOLOR_BASE + 0x75C)
    #define SKIN_LUMA_HIST_PCN_24 Fld(32,0,AC_FULLDW)//[31:0]
#define SKIN_LUMA_HIST_25 (IO_POSTCOLOR_BASE + 0x760)
    #define SKIN_LUMA_HIST_PCN_25 Fld(32,0,AC_FULLDW)//[31:0]
#define SKIN_LUMA_HIST_26 (IO_POSTCOLOR_BASE + 0x764)
    #define SKIN_LUMA_HIST_PCN_26 Fld(32,0,AC_FULLDW)//[31:0]
#define SKIN_LUMA_HIST_27 (IO_POSTCOLOR_BASE + 0x768)
    #define SKIN_LUMA_HIST_PCN_27 Fld(32,0,AC_FULLDW)//[31:0]
#define SKIN_LUMA_HIST_28 (IO_POSTCOLOR_BASE + 0x76C)
    #define SKIN_LUMA_HIST_PCN_28 Fld(32,0,AC_FULLDW)//[31:0]
#define SKIN_LUMA_HIST_29 (IO_POSTCOLOR_BASE + 0x770)
    #define SKIN_LUMA_HIST_PCN_29 Fld(32,0,AC_FULLDW)//[31:0]
#define SKIN_LUMA_HIST_30 (IO_POSTCOLOR_BASE + 0x774)
    #define SKIN_LUMA_HIST_PCN_30 Fld(32,0,AC_FULLDW)//[31:0]
#define SKIN_LUMA_HIST_31 (IO_POSTCOLOR_BASE + 0x778)
    #define SKIN_LUMA_HIST_PCN_31 Fld(32,0,AC_FULLDW)//[31:0]
#define SKIN_LUMA_HIST_32 (IO_POSTCOLOR_BASE + 0x77C)
    #define SKIN_LUMA_HIST_PCN_32 Fld(32,0,AC_FULLDW)//[31:0]
#define SKIN_LUMA_CONTRAL_0 (IO_POSTCOLOR_BASE + 0x780)
    #define SKIN_LUMA_HIST_X_START Fld(16,16,AC_FULLW32)//[31:16]
    #define SKIN_LUMA_HIST_X_END Fld(16,0,AC_FULLW10)//[15:0]
#define SKIN_LUMA_CONTRAL_1 (IO_POSTCOLOR_BASE + 0x784)
    #define SKIN_LUMA_HIST_Y_START Fld(16,16,AC_FULLW32)//[31:16]
    #define SKIN_LUMA_HIST_Y_END Fld(16,0,AC_FULLW10)//[15:0]
#define SKIN_LUMA_CONTRAL_2 (IO_POSTCOLOR_BASE + 0x788)
    #define SKIN_LUMA_HIST_THRESHOLD Fld(9,0,AC_MSKW10)//[8:0]
	
	//capy add YSH 3D hist
#define YSH_3D_HIST_CTRL_0 (IO_POSTCOLOR_BASE + 0xB00)
    #define INT_YSH_3D_HIST_STA Fld(1,3,AC_MSKB0)//[3:3]
    #define INT_YSH_3D_HIST_CLR Fld(1,2,AC_MSKB0)//[2:2]
    #define INT_YSH_3D_HIST_EN Fld(1,1,AC_MSKB0)//[1:1]
    #define YSH_3D_HIST_CEN Fld(1,0,AC_MSKB0)//[0:0]
#define YSH_3D_HIST_CONFIG_0 (IO_POSTCOLOR_BASE + 0xB04)
    #define YSH_3D_S_INTERVAL_0 Fld(12,20,AC_MSKW32)//[31:20]
    #define YSH_3D_Y_INTERVAL_1 Fld(10,10,AC_MSKW21)//[19:10]
    #define YSH_3D_Y_INTERVAL_0 Fld(10,0,AC_MSKW10)//[9:0]
#define YSH_3D_HIST_CONFIG_1 (IO_POSTCOLOR_BASE + 0xB08)
    #define YSH_3D_S_INTERVAL_2 Fld(12,12,AC_MSKW21)//[23:12]
    #define YSH_3D_S_INTERVAL_1 Fld(12,0,AC_MSKW10)//[11:0]
#define YSH_3D_HIST_CONFIG_2 (IO_POSTCOLOR_BASE + 0xB0C)
    #define YSH_3D_S_INTERVAL_4 Fld(12,12,AC_MSKW21)//[23:12]
    #define YSH_3D_S_INTERVAL_3 Fld(12,0,AC_MSKW10)//[11:0]
#define YSH_3D_HIST_CONFIG_3 (IO_POSTCOLOR_BASE + 0xB10)
    #define YSH_3D_S_INTERVAL_6 Fld(12,12,AC_MSKW21)//[23:12]
    #define YSH_3D_S_INTERVAL_5 Fld(12,0,AC_MSKW10)//[11:0]
#define YSH_3D_HIST_CONFIG_4 (IO_POSTCOLOR_BASE + 0xB14)
    #define YSH_3D_H_INTERVAL_1 Fld(13,13,AC_MSKDW)//[25:13]
    #define YSH_3D_H_INTERVAL_0 Fld(13,0,AC_MSKW10)//[12:0]
#define YSH_3D_HIST_CONFIG_5 (IO_POSTCOLOR_BASE + 0xB18)
    #define YSH_3D_H_INTERVAL_3 Fld(13,13,AC_MSKDW)//[25:13]
    #define YSH_3D_H_INTERVAL_2 Fld(13,0,AC_MSKW10)//[12:0]
#define YSH_3D_HIST_CONFIG_6 (IO_POSTCOLOR_BASE + 0xB1C)
    #define YSH_3D_H_INTERVAL_5 Fld(13,13,AC_MSKDW)//[25:13]
    #define YSH_3D_H_INTERVAL_4 Fld(13,0,AC_MSKW10)//[12:0]
#define YSH_3D_HIST_CONFIG_7 (IO_POSTCOLOR_BASE + 0xB20)
    #define YSH_3D_H_INTERVAL_7 Fld(13,13,AC_MSKDW)//[25:13]
    #define YSH_3D_H_INTERVAL_6 Fld(13,0,AC_MSKW10)//[12:0]
#define YSH_3D_HIST_CONFIG_8 (IO_POSTCOLOR_BASE + 0xB24)
    #define YSH_3D_H_INTERVAL_9 Fld(13,13,AC_MSKDW)//[25:13]
    #define YSH_3D_H_INTERVAL_8 Fld(13,0,AC_MSKW10)//[12:0]
#define YSH_3D_HIST_CONFIG_9 (IO_POSTCOLOR_BASE + 0xB28)
    #define YSH_3D_NONLINEAR_NORM Fld(1,26,AC_MSKB3)//[26:26]
    #define YSH_3D_NORM_VARIANCE Fld(13,13,AC_MSKDW)//[25:13]
    #define YSH_3D_H_INTERVAL_10 Fld(13,0,AC_MSKW10)//[12:0]
#define YSH_3D_HIST_0 (IO_POSTCOLOR_BASE + 0xB2C)
    #define YSH_3D_HIST_BIN_0 Fld(32,0,AC_FULLDW)//[31:0]
#define YSH_3D_HIST_1 (IO_POSTCOLOR_BASE + 0xB30)
    #define YSH_3D_HIST_BIN_1 Fld(32,0,AC_FULLDW)//[31:0]
#define YSH_3D_HIST_2 (IO_POSTCOLOR_BASE + 0xB34)
    #define YSH_3D_HIST_BIN_2 Fld(32,0,AC_FULLDW)//[31:0]
#define YSH_3D_HIST_3 (IO_POSTCOLOR_BASE + 0xB38)
    #define YSH_3D_HIST_BIN_3 Fld(32,0,AC_FULLDW)//[31:0]
#define YSH_3D_HIST_4 (IO_POSTCOLOR_BASE + 0xB3C)
    #define YSH_3D_HIST_BIN_4 Fld(32,0,AC_FULLDW)//[31:0]
#define YSH_3D_HIST_5 (IO_POSTCOLOR_BASE + 0xB40)
    #define YSH_3D_HIST_BIN_5 Fld(32,0,AC_FULLDW)//[31:0]
#define YSH_3D_HIST_6 (IO_POSTCOLOR_BASE + 0xB44)
    #define YSH_3D_HIST_BIN_6 Fld(32,0,AC_FULLDW)//[31:0]
#define YSH_3D_HIST_7 (IO_POSTCOLOR_BASE + 0xB48)
    #define YSH_3D_HIST_BIN_7 Fld(32,0,AC_FULLDW)//[31:0]
#define YSH_3D_HIST_8 (IO_POSTCOLOR_BASE + 0xB4C)
    #define YSH_3D_HIST_BIN_8 Fld(32,0,AC_FULLDW)//[31:0]
#define YSH_3D_HIST_9 (IO_POSTCOLOR_BASE + 0xB50)
    #define YSH_3D_HIST_BIN_9 Fld(32,0,AC_FULLDW)//[31:0]
#define YSH_3D_HIST_10 (IO_POSTCOLOR_BASE + 0xB54)
    #define YSH_3D_HIST_BIN_10 Fld(32,0,AC_FULLDW)//[31:0]
#define YSH_3D_HIST_11 (IO_POSTCOLOR_BASE + 0xB58)
    #define YSH_3D_HIST_BIN_11 Fld(32,0,AC_FULLDW)//[31:0]
#define YSH_3D_HIST_12 (IO_POSTCOLOR_BASE + 0xB5C)
    #define YSH_3D_HIST_BIN_12 Fld(32,0,AC_FULLDW)//[31:0]
#define YSH_3D_HIST_13 (IO_POSTCOLOR_BASE + 0xB60)
    #define YSH_3D_HIST_BIN_13 Fld(32,0,AC_FULLDW)//[31:0]
#define YSH_3D_HIS_14 (IO_POSTCOLOR_BASE + 0xB64)
    #define YSH_3D_HIST_BIN_14 Fld(32,0,AC_FULLDW)//[31:0]
#define YSH_3D_HIST_15 (IO_POSTCOLOR_BASE + 0xB68)
    #define YSH_3D_HIST_BIN_15 Fld(32,0,AC_FULLDW)//[31:0]
#define YSH_3D_HIST_16 (IO_POSTCOLOR_BASE + 0xB6C)
    #define YSH_3D_HIST_BIN_16 Fld(32,0,AC_FULLDW)//[31:0]
#define YSH_3D_HIST_17 (IO_POSTCOLOR_BASE + 0xB70)
    #define YSH_3D_HIST_BIN_17 Fld(32,0,AC_FULLDW)//[31:0]
#define YSH_3D_HIST_18 (IO_POSTCOLOR_BASE + 0xB74)
    #define YSH_3D_HIST_BIN_18 Fld(32,0,AC_FULLDW)//[31:0]
#define YSH_3D_HIST_19 (IO_POSTCOLOR_BASE + 0xB78)
    #define YSH_3D_HIST_BIN_19 Fld(32,0,AC_FULLDW)//[31:0]
#define YSH_3D_HIST_20 (IO_POSTCOLOR_BASE + 0xB7C)
    #define YSH_3D_HIST_BIN_20 Fld(32,0,AC_FULLDW)//[31:0]
#define YSH_3D_HIST_21 (IO_POSTCOLOR_BASE + 0xB80)
    #define YSH_3D_HIST_BIN_21 Fld(32,0,AC_FULLDW)//[31:0]
#define YSH_3D_HIST_22 (IO_POSTCOLOR_BASE + 0xB84)
    #define YSH_3D_HIST_BIN_22 Fld(32,0,AC_FULLDW)//[31:0]
#define YSH_3D_HIST_23 (IO_POSTCOLOR_BASE + 0xB88)
    #define YSH_3D_HIST_BIN_23 Fld(32,0,AC_FULLDW)//[31:0]
#define YSH_3D_HIST_24 (IO_POSTCOLOR_BASE + 0xB8C)
    #define YSH_3D_HIST_BIN_24 Fld(32,0,AC_FULLDW)//[31:0]
#define YSH_3D_HIST_25 (IO_POSTCOLOR_BASE + 0xB90)
    #define YSH_3D_HIST_BIN_25 Fld(32,0,AC_FULLDW)//[31:0]
#define YSH_3D_HIST_26 (IO_POSTCOLOR_BASE + 0xB94)
    #define YSH_3D_HIST_BIN_26 Fld(32,0,AC_FULLDW)//[31:0]
#define YSH_3D_HIST_27 (IO_POSTCOLOR_BASE + 0xB98)
    #define YSH_3D_HIST_BIN_27 Fld(32,0,AC_FULLDW)//[31:0]
#define YSH_3D_HIST_28 (IO_POSTCOLOR_BASE + 0xB9C)
    #define YSH_3D_HIST_BIN_28 Fld(32,0,AC_FULLDW)//[31:0]
#define YSH_3D_HIST_29 (IO_POSTCOLOR_BASE + 0xBA0)
    #define YSH_3D_HIST_BIN_29 Fld(32,0,AC_FULLDW)//[31:0]
#define YSH_3D_HIST_30 (IO_POSTCOLOR_BASE + 0xBA4)
    #define YSH_3D_HIST_BIN_30 Fld(32,0,AC_FULLDW)//[31:0]
#define YSH_3D_HIST_31 (IO_POSTCOLOR_BASE + 0xBA8)
    #define YSH_3D_HIST_BIN_31 Fld(32,0,AC_FULLDW)//[31:0]
#define YSH_3D_HIST_32 (IO_POSTCOLOR_BASE + 0xBAC)
    #define YSH_3D_HIST_BIN_32 Fld(32,0,AC_FULLDW)//[31:0]

//Page POSTPROC_2_5
#define YSH_3D_HIST_33 (IO_POSTCOLOR_BASE + 0xBB0)
    #define YSH_3D_HIST_BIN_33 Fld(32,0,AC_FULLDW)//[31:0]
#define YSH_3D_HIST_34 (IO_POSTCOLOR_BASE + 0xBB4)
    #define YSH_3D_HIST_BIN_34 Fld(32,0,AC_FULLDW)//[31:0]
#define YSH_3D_HIST_35 (IO_POSTCOLOR_BASE + 0xBB8)
    #define YSH_3D_HIST_BIN_35 Fld(32,0,AC_FULLDW)//[31:0]
#define YSH_3D_HIST_36 (IO_POSTCOLOR_BASE + 0xBBC)
    #define YSH_3D_HIST_BIN_36 Fld(32,0,AC_FULLDW)//[31:0]
#define YSH_3D_HIST_37 (IO_POSTCOLOR_BASE + 0xBC0)
    #define YSH_3D_HIST_BIN_37 Fld(32,0,AC_FULLDW)//[31:0]
#define YSH_3D_HIST_38 (IO_POSTCOLOR_BASE + 0xBC4)
    #define YSH_3D_HIST_BIN_38 Fld(32,0,AC_FULLDW)//[31:0]
#define YSH_3D_HIST_39 (IO_POSTCOLOR_BASE + 0xBC8)
    #define YSH_3D_HIST_BIN_39 Fld(32,0,AC_FULLDW)//[31:0]
#define YSH_3D_HIST_40 (IO_POSTCOLOR_BASE + 0xBCC)
    #define YSH_3D_HIST_BIN_40 Fld(32,0,AC_FULLDW)//[31:0]
#define YSH_3D_HIST_41 (IO_POSTCOLOR_BASE + 0xBD0)
    #define YSH_3D_HIST_BIN_41 Fld(32,0,AC_FULLDW)//[31:0]
#define YSH_3D_HIST_42 (IO_POSTCOLOR_BASE + 0xBD4)
    #define YSH_3D_HIST_BIN_42 Fld(32,0,AC_FULLDW)//[31:0]
#define YSH_3D_HIST_43 (IO_POSTCOLOR_BASE + 0xBD8)
    #define YSH_3D_HIST_BIN_43 Fld(32,0,AC_FULLDW)//[31:0]
#define YSH_3D_HIST_44 (IO_POSTCOLOR_BASE + 0xBDC)
    #define YSH_3D_HIST_BIN_44 Fld(32,0,AC_FULLDW)//[31:0]
#define YSH_3D_HIST_45 (IO_POSTCOLOR_BASE + 0xBE0)
    #define YSH_3D_HIST_BIN_45 Fld(32,0,AC_FULLDW)//[31:0]
#define YSH_3D_HIST_46 (IO_POSTCOLOR_BASE + 0xBE4)
    #define YSH_3D_HIST_BIN_46 Fld(32,0,AC_FULLDW)//[31:0]
#define YSH_3D_HIST_47 (IO_POSTCOLOR_BASE + 0xBE8)
    #define YSH_3D_HIST_BIN_47 Fld(32,0,AC_FULLDW)//[31:0]
#define YSH_3D_HIST_48 (IO_POSTCOLOR_BASE + 0xBEC)
    #define YSH_3D_HIST_BIN_48 Fld(32,0,AC_FULLDW)//[31:0]
#define YSH_3D_HIST_49 (IO_POSTCOLOR_BASE + 0xBF0)
    #define YSH_3D_HIST_BIN_49 Fld(32,0,AC_FULLDW)//[31:0]
#define YSH_3D_HIST_50 (IO_POSTCOLOR_BASE + 0xBF4)
    #define YSH_3D_HIST_BIN_50 Fld(32,0,AC_FULLDW)//[31:0]
#define YSH_3D_HIST_51 (IO_POSTCOLOR_BASE + 0xBF8)
    #define YSH_3D_HIST_BIN_51 Fld(32,0,AC_FULLDW)//[31:0]
#define YSH_3D_HIST_52 (IO_POSTCOLOR_BASE + 0xBFC)
    #define YSH_3D_HIST_BIN_52 Fld(32,0,AC_FULLDW)//[31:0]
#define YSH_3D_HIST_53 (IO_POSTCOLOR_BASE + 0xC00)
    #define YSH_3D_HIST_BIN_53 Fld(32,0,AC_FULLDW)//[31:0]
#define YSH_3D_HIST_54 (IO_POSTCOLOR_BASE + 0xC04)
    #define YSH_3D_HIST_BIN_54 Fld(32,0,AC_FULLDW)//[31:0]
#define YSH_3D_HIST_55 (IO_POSTCOLOR_BASE + 0xC08)
    #define YSH_3D_HIST_BIN_55 Fld(32,0,AC_FULLDW)//[31:0]
#define YSH_3D_HIST_56 (IO_POSTCOLOR_BASE + 0xC0C)
    #define YSH_3D_HIST_BIN_56 Fld(32,0,AC_FULLDW)//[31:0]
#define YSH_3D_HIST_57 (IO_POSTCOLOR_BASE + 0xC10)
    #define YSH_3D_HIST_BIN_57 Fld(32,0,AC_FULLDW)//[31:0]
#define YSH_3D_HIST_58 (IO_POSTCOLOR_BASE + 0xC14)
    #define YSH_3D_HIST_BIN_58 Fld(32,0,AC_FULLDW)//[31:0]
#define YSH_3D_HIST_59 (IO_POSTCOLOR_BASE + 0xC18)
    #define YSH_3D_HIST_BIN_59 Fld(32,0,AC_FULLDW)//[31:0]
#define YSH_3D_HIST_60 (IO_POSTCOLOR_BASE + 0xC1C)
    #define YSH_3D_HIST_BIN_60 Fld(32,0,AC_FULLDW)//[31:0]
#define YSH_3D_HIST_61 (IO_POSTCOLOR_BASE + 0xC20)
    #define YSH_3D_HIST_BIN_61 Fld(32,0,AC_FULLDW)//[31:0]
#define YSH_3D_HIST_62 (IO_POSTCOLOR_BASE + 0xC24)
    #define YSH_3D_HIST_BIN_62 Fld(32,0,AC_FULLDW)//[31:0]
#define YSH_3D_HIST_63 (IO_POSTCOLOR_BASE + 0xC28)
    #define YSH_3D_HIST_BIN_63 Fld(32,0,AC_FULLDW)//[31:0]
#define YSH_3D_HIST_64 (IO_POSTCOLOR_BASE + 0xC2C)
    #define YSH_3D_HIST_BIN_64 Fld(32,0,AC_FULLDW)//[31:0]
#define YSH_3D_HIST_65 (IO_POSTCOLOR_BASE + 0xC30)
    #define YSH_3D_HIST_BIN_65 Fld(32,0,AC_FULLDW)//[31:0]
#define YSH_3D_HIST_66 (IO_POSTCOLOR_BASE + 0xC34)
    #define YSH_3D_HIST_BIN_66 Fld(32,0,AC_FULLDW)//[31:0]
#define YSH_3D_HIST_67 (IO_POSTCOLOR_BASE + 0xC38)
    #define YSH_3D_HIST_BIN_67 Fld(32,0,AC_FULLDW)//[31:0]
#define YSH_3D_HIST_68 (IO_POSTCOLOR_BASE + 0xC3C)
    #define YSH_3D_HIST_BIN_68 Fld(32,0,AC_FULLDW)//[31:0]
#define YSH_3D_HIST_69 (IO_POSTCOLOR_BASE + 0xC40)
    #define YSH_3D_HIST_BIN_69 Fld(32,0,AC_FULLDW)//[31:0]
#define YSH_3D_HIST_70 (IO_POSTCOLOR_BASE + 0xC44)
    #define YSH_3D_HIST_BIN_70 Fld(32,0,AC_FULLDW)//[31:0]
#define YSH_3D_HIST_71 (IO_POSTCOLOR_BASE + 0xC48)
    #define YSH_3D_HIST_BIN_71 Fld(32,0,AC_FULLDW)//[31:0]
#define YSH_COLOR_AREA_CONFIG_0 (IO_POSTCOLOR_BASE + 0xC4C)
    #define YSH_COLOR_AREA_MAX_Y Fld(10,11,AC_MSKW21)//[20:11]
    #define YSH_COLOR_AREA_MIN_Y Fld(10,1,AC_MSKW10)//[10:1]
    #define YSH_COLOR_AREA_CEN Fld(1,0,AC_MSKB0)//[0:0]
#define YSH_COLOR_AREA_CONFIG_1 (IO_POSTCOLOR_BASE + 0xC50)
    #define YSH_COLOR_AREA_MAX_S Fld(12,12,AC_MSKW21)//[23:12]
    #define YSH_COLOR_AREA_MIN_S Fld(12,0,AC_MSKW10)//[11:0]
#define YSH_COLOR_AREA_CONFIG_2 (IO_POSTCOLOR_BASE + 0xC54)
    #define YSH_COLOR_AREA_MAX_H Fld(13,13,AC_MSKDW)//[25:13]
    #define YSH_COLOR_AREA_MIN_H Fld(13,0,AC_MSKW10)//[12:0]
#define YSH_COLOR_AREA_COUNT_Y (IO_POSTCOLOR_BASE + 0xC58)
    #define YSH_COLOR_AREA_Y Fld(23,0,AC_MSKDW)//[22:0]
#define YSH_COLOR_AREA_S (IO_POSTCOLOR_BASE + 0xC5C)
    #define YSH_COLOR_AREA_COUNT_S Fld(23,0,AC_MSKDW)//[22:0]
#define YSH_COLOR_AREA_COUNT_H (IO_POSTCOLOR_BASE + 0xC60)
    #define YSH_COLOR_AREA_H Fld(23,0,AC_MSKDW)//[22:0]
// Timing detection
#define TIMING_DETECTION_0 (IO_POSTCOLOR_BASE + 0x018)
    #define COLOR_VTOTAL_CNT Fld(16,16,AC_FULLW32)//[31:16]
    #define COLOR_HTOTAL_CNT Fld(16,0,AC_FULLW10)//[15:0]
#define TIMING_DETECTION_1 (IO_POSTCOLOR_BASE + 0x01C)
    #define COLOR_VDE_CNT Fld(16,16,AC_FULLW32)//[31:16]
    #define COLOR_HDE_CNT Fld(16,0,AC_FULLW10)//[15:0]

#define POS_MAIN (IO_POSTCOLOR_BASE + 0x03C)
    #define SCE_POS_Y Fld(16,16,AC_FULLW32)//[31:16]
    #define SCE_POS_X Fld(16,0,AC_FULLW10)//[15:0]
#define CAP_IN_DATA_MAIN (IO_POSTCOLOR_BASE + 0x048)
    #define CAP_IN_CB Fld(10,16,AC_MSKW32)//[25:16]
    #define CAP_IN_Y Fld(10,0,AC_MSKW10)//[9:0]
#define CAP_IN_DATA_MAIN_CR (IO_POSTCOLOR_BASE + 0x04C)
    #define CAP_IN_CR Fld(10,0,AC_MSKW10)//[9:0]
#define CAP_OUT_DATA_MAIN (IO_POSTCOLOR_BASE + 0x050)
    #define CAP_OUT_CB Fld(14,16,AC_MSKW32)//[29:16]
    #define CAP_OUT_Y Fld(10,0,AC_MSKW10)//[9:0]
#define CAP_OUT_DATA_MAIN_CR (IO_POSTCOLOR_BASE + 0x054)
    #define CAP_OUT_CR Fld(14,0,AC_MSKW10)//[13:0]

#define LCDIM_LD2_CONTRAL (IO_LCDIM_BASE + 0xA74)
    #define LD2_CONTRAL_C_NEW_LD_RESERVE_0 Fld(14,18,AC_MSKW32)//[31:18]
    #define LD2_CONTRAL_C_EXTEND_VALUE_GAURDBAND Fld(11,7,AC_MSKDW)//[17:7]
    #define LD2_CONTRAL_C_LD_INPUT_PHASE_STATUS Fld(1,6,AC_MSKB0)//[6:6]
    #define LD2_CONTRAL_C_LD_REGISTER_WRITE_SYNC Fld(1,5,AC_MSKB0)//[5:5]
    #define LD2_CONTRAL_C_LD_INPUT_BIT_SELECTION Fld(1,4,AC_MSKB0)//[4:4]
    #define LD2_CONTRAL_C_LD_BIT_SELECTION Fld(1,3,AC_MSKB0)//[3:3]
    #define LD2_CONTRAL_C_LD_SELECTION Fld(1,2,AC_MSKB0)//[2:2]
    #define LD2_CONTRAL_C_LD_FRAME_MODE_SELECTION Fld(1,1,AC_MSKB0)//[1:1]
    #define LD2_CONTRAL_C_LD_RISC_READDATA_CHANNEL_SEL Fld(1,0,AC_MSKB0)//[0:0]
#define LCDIM_NEW_LD_CONTROL (IO_LCDIM_BASE + 0xA78)
    #define NEW_LD_CONTROL_C_NEW_LD_RESERVE_1 Fld(3,29,AC_MSKB3)//[31:29]
    #define NEW_LD_CONTROL_C_NEW_LD_LDM_DMA_VSYNC_SEL Fld(3,26,AC_MSKB3)//[28:26]
    #define NEW_LD_CONTROL_C_NEW_LD_SPI_MOSI_SEL Fld(1,25,AC_MSKB3)//[25:25]
    #define NEW_LD_CONTROL_C_NEW_LD_FO_N400_BYPASS Fld(1,24,AC_MSKB3)//[24:24]
    #define NEW_LD_CONTROL_C_NEW_LD_FDE_END Fld(12,12,AC_MSKW21)//[23:12]
    #define NEW_LD_CONTROL_C_NEW_LD_FDE_START Fld(12,0,AC_MSKW10)//[11:0]
#endif
